// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/lib-Buckets-PackedStringArray.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const BaseFuel_SeqComparison._default.lte: LayerType;

const StartFuel_SeqComparison._default.lte: LayerType;

const StartFuelAssert_SeqComparison._default.lte: LayerType;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const BaseFuel_Maps._default.MapRemove: LayerType;

const StartFuel_Maps._default.MapRemove: LayerType;

const StartFuelAssert_Maps._default.MapRemove: LayerType;

const BaseFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuelAssert_Maps._default.MapRemoveStrong: LayerType;

const BaseFuel_Maps._default.MapRemove1: LayerType;

const StartFuel_Maps._default.MapRemove1: LayerType;

const StartFuelAssert_Maps._default.MapRemove1: LayerType;

const BaseFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuelAssert_Maps._default.MapRemove1Strong: LayerType;

const BaseFuel_Maps._default.IMapRemove: LayerType;

const StartFuel_Maps._default.IMapRemove: LayerType;

const StartFuelAssert_Maps._default.IMapRemove: LayerType;

const BaseFuel_Maps._default.IMapRemove1: LayerType;

const StartFuel_Maps._default.IMapRemove1: LayerType;

const StartFuelAssert_Maps._default.IMapRemove1: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion: LayerType;

const BaseFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferA: LayerType;

const BaseFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferB: LayerType;

const BaseFuel_Maps._default.MapUnion: LayerType;

const StartFuel_Maps._default.MapUnion: LayerType;

const StartFuelAssert_Maps._default.MapUnion: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferA: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferB: LayerType;

const BaseFuel_Maps._default.IMapUnion: LayerType;

const StartFuel_Maps._default.IMapUnion: LayerType;

const StartFuelAssert_Maps._default.IMapUnion: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion3: LayerType;

const BaseFuel_Uint32_Order._default.ltedef: LayerType;

const StartFuel_Uint32_Order._default.ltedef: LayerType;

const StartFuelAssert_Uint32_Order._default.ltedef: LayerType;

const BaseFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Uint32_Order._default.NotMinimum: LayerType;

const StartFuel_Uint32_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Uint32_Order._default.NotMinimum: LayerType;

const BaseFuel_Uint32_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Uint32_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Uint32_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Uint32_Order._default.minimum: LayerType;

const StartFuel_Uint32_Order._default.minimum: LayerType;

const StartFuelAssert_Uint32_Order._default.minimum: LayerType;

const BaseFuel_Uint32_Order._default.minimumOpt: LayerType;

const StartFuel_Uint32_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Uint32_Order._default.minimumOpt: LayerType;

const BaseFuel_Uint32_Order._default.maximum: LayerType;

const StartFuel_Uint32_Order._default.maximum: LayerType;

const StartFuelAssert_Uint32_Order._default.maximum: LayerType;

const BaseFuel_Uint32_Order._default.maximumOpt: LayerType;

const StartFuel_Uint32_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Uint32_Order._default.maximumOpt: LayerType;

const BaseFuel_Uint32_Order._default.IsSorted: LayerType;

const StartFuel_Uint32_Order._default.IsSorted: LayerType;

const StartFuelAssert_Uint32_Order._default.IsSorted: LayerType;

const BaseFuel_Uint32_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Uint32_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Uint32_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Byte_Order._default.lte: LayerType;

const StartFuel_Byte_Order._default.lte: LayerType;

const StartFuelAssert_Byte_Order._default.lte: LayerType;

const BaseFuel_Byte_Order._default.ltedef: LayerType;

const StartFuel_Byte_Order._default.ltedef: LayerType;

const StartFuelAssert_Byte_Order._default.ltedef: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Byte_Order._default.minimum: LayerType;

const StartFuel_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Byte_Order._default.minimum: LayerType;

const BaseFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Byte_Order._default.maximum: LayerType;

const StartFuel_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Byte_Order._default.maximum: LayerType;

const BaseFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_PackedStringArray._default.psaSeq: LayerType;

const StartFuel_PackedStringArray._default.psaSeq: LayerType;

const StartFuelAssert_PackedStringArray._default.psaSeq: LayerType;

// Constructor function declaration
function #PackedStringArray.Psa.Psa(Seq Box, Seq Box) : DatatypeType;

const unique ##PackedStringArray.Psa.Psa: DtCtorId;

// Constructor identifier
axiom (forall a#14#0#0: Seq Box, a#14#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#14#0#0, a#14#1#0) } 
  DatatypeCtorId(#PackedStringArray.Psa.Psa(a#14#0#0, a#14#1#0))
     == ##PackedStringArray.Psa.Psa);

function PackedStringArray.Psa.Psa_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d) } 
  PackedStringArray.Psa.Psa_q(d)
     <==> DatatypeCtorId(d) == ##PackedStringArray.Psa.Psa);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d) } 
  PackedStringArray.Psa.Psa_q(d)
     ==> (exists a#15#0#0: Seq Box, a#15#1#0: Seq Box :: 
      d == #PackedStringArray.Psa.Psa(a#15#0#0, a#15#1#0)));

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

function Tclass.PackedStringArray.Psa() : Ty;

// Tclass.PackedStringArray.Psa Tag
axiom Tag(Tclass.PackedStringArray.Psa()) == Tagclass.PackedStringArray.Psa;

const unique Tagclass.PackedStringArray.Psa: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.Psa
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.Psa()) } 
  $IsBox(bx, Tclass.PackedStringArray.Psa())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PackedStringArray.Psa()));

// Constructor $Is
axiom (forall a#16#0#0: Seq Box, a#16#1#0: Seq Box :: 
  { $Is(#PackedStringArray.Psa.Psa(a#16#0#0, a#16#1#0), Tclass.PackedStringArray.Psa()) } 
  $Is(#PackedStringArray.Psa.Psa(a#16#0#0, a#16#1#0), Tclass.PackedStringArray.Psa())
     <==> $Is(a#16#0#0, TSeq(Tclass.NativeTypes.uint32()))
       && $Is(a#16#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#17#0#0: Seq Box, a#17#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#PackedStringArray.Psa.Psa(a#17#0#0, a#17#1#0), 
      Tclass.PackedStringArray.Psa(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PackedStringArray.Psa.Psa(a#17#0#0, a#17#1#0), 
        Tclass.PackedStringArray.Psa(), 
        $h)
       <==> $IsAlloc(a#17#0#0, TSeq(Tclass.NativeTypes.uint32()), $h)
         && $IsAlloc(a#17#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedStringArray.Psa.offsets(d), TSeq(Tclass.NativeTypes.uint32()), $h) } 
  $IsGoodHeap($h)
       && 
      PackedStringArray.Psa.Psa_q(d)
       && $IsAlloc(d, Tclass.PackedStringArray.Psa(), $h)
     ==> $IsAlloc(PackedStringArray.Psa.offsets(d), TSeq(Tclass.NativeTypes.uint32()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedStringArray.Psa.data(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      PackedStringArray.Psa.Psa_q(d)
       && $IsAlloc(d, Tclass.PackedStringArray.Psa(), $h)
     ==> $IsAlloc(PackedStringArray.Psa.data(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#18#0#0: Seq Box, a#18#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(Lit(a#18#0#0), Lit(a#18#1#0)) } 
  #PackedStringArray.Psa.Psa(Lit(a#18#0#0), Lit(a#18#1#0))
     == Lit(#PackedStringArray.Psa.Psa(a#18#0#0, a#18#1#0)));

function PackedStringArray.Psa.offsets(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#19#0#0: Seq Box, a#19#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#19#0#0, a#19#1#0) } 
  PackedStringArray.Psa.offsets(#PackedStringArray.Psa.Psa(a#19#0#0, a#19#1#0))
     == a#19#0#0);

// Inductive seq element rank
axiom (forall a#20#0#0: Seq Box, a#20#1#0: Seq Box, i: int :: 
  { Seq#Index(a#20#0#0, i), #PackedStringArray.Psa.Psa(a#20#0#0, a#20#1#0) } 
  0 <= i && i < Seq#Length(a#20#0#0)
     ==> DtRank($Unbox(Seq#Index(a#20#0#0, i)): DatatypeType)
       < DtRank(#PackedStringArray.Psa.Psa(a#20#0#0, a#20#1#0)));

// Inductive seq rank
axiom (forall a#21#0#0: Seq Box, a#21#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#21#0#0, a#21#1#0) } 
  Seq#Rank(a#21#0#0) < DtRank(#PackedStringArray.Psa.Psa(a#21#0#0, a#21#1#0)));

function PackedStringArray.Psa.data(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: Seq Box, a#22#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#22#0#0, a#22#1#0) } 
  PackedStringArray.Psa.data(#PackedStringArray.Psa.Psa(a#22#0#0, a#22#1#0))
     == a#22#1#0);

// Inductive seq element rank
axiom (forall a#23#0#0: Seq Box, a#23#1#0: Seq Box, i: int :: 
  { Seq#Index(a#23#1#0, i), #PackedStringArray.Psa.Psa(a#23#0#0, a#23#1#0) } 
  0 <= i && i < Seq#Length(a#23#1#0)
     ==> DtRank($Unbox(Seq#Index(a#23#1#0, i)): DatatypeType)
       < DtRank(#PackedStringArray.Psa.Psa(a#23#0#0, a#23#1#0)));

// Inductive seq rank
axiom (forall a#24#0#0: Seq Box, a#24#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#24#0#0, a#24#1#0) } 
  Seq#Rank(a#24#1#0) < DtRank(#PackedStringArray.Psa.Psa(a#24#0#0, a#24#1#0)));

// Depth-one case-split function
function $IsA#PackedStringArray.Psa(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PackedStringArray.Psa(d) } 
  $IsA#PackedStringArray.Psa(d) ==> PackedStringArray.Psa.Psa_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d), $Is(d, Tclass.PackedStringArray.Psa()) } 
  $Is(d, Tclass.PackedStringArray.Psa()) ==> PackedStringArray.Psa.Psa_q(d));

// Datatype extensional equality declaration
function PackedStringArray.Psa#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PackedStringArray.Psa.Psa
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedStringArray.Psa#Equal(a, b) } 
  true
     ==> (PackedStringArray.Psa#Equal(a, b)
       <==> Seq#Equal(PackedStringArray.Psa.offsets(a), PackedStringArray.Psa.offsets(b))
         && Seq#Equal(PackedStringArray.Psa.data(a), PackedStringArray.Psa.data(b))));

// Datatype extensionality axiom: PackedStringArray.Psa
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedStringArray.Psa#Equal(a, b) } 
  PackedStringArray.Psa#Equal(a, b) <==> a == b);

const unique class.PackedStringArray.Psa: ClassName;

const unique class.PackedStringArray.DynamicPsa?: ClassName;

function Tclass.PackedStringArray.DynamicPsa?() : Ty;

// Tclass.PackedStringArray.DynamicPsa? Tag
axiom Tag(Tclass.PackedStringArray.DynamicPsa?())
   == Tagclass.PackedStringArray.DynamicPsa?;

const unique Tagclass.PackedStringArray.DynamicPsa?: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.DynamicPsa?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.DynamicPsa?()) } 
  $IsBox(bx, Tclass.PackedStringArray.DynamicPsa?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.DynamicPsa?()));

// DynamicPsa: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArray.DynamicPsa?()) } 
  $Is($o, Tclass.PackedStringArray.DynamicPsa?())
     <==> $o == null || dtype($o) == Tclass.PackedStringArray.DynamicPsa?());

// DynamicPsa: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArray.DynamicPsa?(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArray.DynamicPsa?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(PackedStringArray.DynamicPsa.nstrings) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$nstrings)
     == PackedStringArray.DynamicPsa.nstrings
   && !$IsGhostField(PackedStringArray.DynamicPsa.nstrings);

const PackedStringArray.DynamicPsa.nstrings: Field int;

function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

// DynamicPsa.nstrings: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.nstrings) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.nstrings), Tclass.NativeTypes.uint64()));

// DynamicPsa.nstrings: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.nstrings) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.nstrings), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(PackedStringArray.DynamicPsa.offsets) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$offsets)
     == PackedStringArray.DynamicPsa.offsets
   && !$IsGhostField(PackedStringArray.DynamicPsa.offsets);

const PackedStringArray.DynamicPsa.offsets: Field ref;

// DynamicPsa.offsets: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.offsets) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.offsets), 
      Tclass._System.array(Tclass.NativeTypes.uint32())));

// DynamicPsa.offsets: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.offsets) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.offsets), 
      Tclass._System.array(Tclass.NativeTypes.uint32()), 
      $h));

axiom FDim(PackedStringArray.DynamicPsa.data) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$data)
     == PackedStringArray.DynamicPsa.data
   && !$IsGhostField(PackedStringArray.DynamicPsa.data);

const PackedStringArray.DynamicPsa.data: Field ref;

// DynamicPsa.data: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.data) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.data), 
      Tclass._System.array(Tclass.NativeTypes.byte())));

// DynamicPsa.data: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.data) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.data), 
      Tclass._System.array(Tclass.NativeTypes.byte()), 
      $h));

axiom FDim(PackedStringArray.DynamicPsa.Repr) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$Repr)
     == PackedStringArray.DynamicPsa.Repr
   && $IsGhostField(PackedStringArray.DynamicPsa.Repr);

const PackedStringArray.DynamicPsa.Repr: Field (Set Box);

// DynamicPsa.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.Repr), TSet(Tclass._System.object())));

// DynamicPsa.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.Repr), 
      TSet(Tclass._System.object()), 
      $h));

// function declaration for PackedStringArray.DynamicPsa.WF
function PackedStringArray.DynamicPsa.WF($heap: Heap, this: ref) : bool;

function PackedStringArray.DynamicPsa.WF#canCall($heap: Heap, this: ref) : bool;

function Tclass.PackedStringArray.DynamicPsa() : Ty;

// Tclass.PackedStringArray.DynamicPsa Tag
axiom Tag(Tclass.PackedStringArray.DynamicPsa())
   == Tagclass.PackedStringArray.DynamicPsa;

const unique Tagclass.PackedStringArray.DynamicPsa: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.DynamicPsa
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.DynamicPsa()) } 
  $IsBox(bx, Tclass.PackedStringArray.DynamicPsa())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.DynamicPsa()));

// frame axiom for PackedStringArray.DynamicPsa.WF
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.WF($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.WF($h0, this)
       == PackedStringArray.DynamicPsa.WF($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.WF
axiom 3 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.WF($Heap, this) } 
    PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         || (3 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
       ==> true);

function PackedStringArray.DynamicPsa.WF#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.WF
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.WF#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.WF#requires($Heap, this) == true);

// definition axiom for PackedStringArray.DynamicPsa.WF(revealed)
axiom 3 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.WF($Heap, this) } 
    PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         || (3 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
       ==> (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           ==> NativeTypes.__default.Uint64UpperBound#canCall())
         && (
          (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
           ==> Uint32__Order.__default.IsSorted#canCall(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings))))
         && PackedStringArray.DynamicPsa.WF($Heap, this)
           == (
            Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound()
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296)
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)))));

procedure CheckWellformed$$PackedStringArray.DynamicPsa.WF(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.WF(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var ##run#0: Seq Box;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;
  var b$reqreads#10: bool;
  var b$reqreads#11: bool;
  var b$reqreads#12: bool;
  var b$reqreads#13: bool;
  var b$reqreads#14: bool;
  var b$reqreads#15: bool;
  var b$reqreads#16: bool;
  var b$reqreads#17: bool;
  var b$reqreads#18: bool;
  var b$reqreads#19: bool;
  var b$reqreads#20: bool;
  var b$reqreads#21: bool;
  var b$reqreads#22: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;
    b$reqreads#10 := true;
    b$reqreads#11 := true;
    b$reqreads#12 := true;
    b$reqreads#13 := true;
    b$reqreads#14 := true;
    b$reqreads#15 := true;
    b$reqreads#16 := true;
    b$reqreads#17 := true;
    b$reqreads#18 := true;
    b$reqreads#19 := true;
    b$reqreads#20 := true;
    b$reqreads#21 := true;
    b$reqreads#22 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(738,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    b$reqreads#0 := $_Frame[this, PackedStringArray.DynamicPsa.Repr];
    assert b$reqreads#0;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
        b$reqreads#1 := $_Frame[this, PackedStringArray.DynamicPsa.Repr];
        b$reqreads#2 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
        b$reqreads#3 := $_Frame[this, PackedStringArray.DynamicPsa.data];
        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data)))))
        {
            b$reqreads#4 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
            b$reqreads#5 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume NativeTypes.__default.Uint64UpperBound#canCall();
        }

        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound())
        {
            b$reqreads#6 := $_Frame[this, PackedStringArray.DynamicPsa.data];
            assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
        }

        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296)
        {
            b$reqreads#7 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            b$reqreads#8 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        }

        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets)))
        {
            b$reqreads#9 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            newtype$check#0 := LitInt(4294967296);
            assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        }

        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296)
        {
            newtype$check#1 := LitInt(0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            b$reqreads#10 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            if (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
            {
                b$reqreads#11 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
                assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
                b$reqreads#12 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
                newtype$check#2 := LitInt(1);
                assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
                newtype$check#3 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
                assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
                assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
                   && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
                     < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
                b$reqreads#13 := $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1)];
            }
        }

        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               < 4294967296))
        {
            newtype$check#4 := LitInt(0);
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            b$reqreads#14 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            if (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
            {
                b$reqreads#15 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
                assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
                b$reqreads#16 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
                newtype$check#5 := LitInt(1);
                assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
                newtype$check#6 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
                assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
                assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
                   && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
                     < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
                b$reqreads#17 := $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1)];
                b$reqreads#18 := $_Frame[this, PackedStringArray.DynamicPsa.data];
                assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
            }
        }

        if (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               < 4294967296)
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))))
        {
            b$reqreads#19 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
            b$reqreads#20 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            b$reqreads#21 := (forall $i: int :: 
              { $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField($i)] } 
              0 <= $i && $i < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                 ==> $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField($i)]);
            ##run#0 := Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings));
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            b$reqreads#22 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Uint32__Order.__default.IsSorted#canCall(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        }

        assume PackedStringArray.DynamicPsa.WF($Heap, this)
           == (
            Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound()
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296)
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings))));
        assume (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
             ==> NativeTypes.__default.Uint64UpperBound#canCall())
           && (
            (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
             ==> Uint32__Order.__default.IsSorted#canCall(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings))));
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.DynamicPsa.WF($Heap, this), TBool);
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
        assert b$reqreads#10;
        assert b$reqreads#11;
        assert b$reqreads#12;
        assert b$reqreads#13;
        assert b$reqreads#14;
        assert b$reqreads#15;
        assert b$reqreads#16;
        assert b$reqreads#17;
        assert b$reqreads#18;
        assert b$reqreads#19;
        assert b$reqreads#20;
        assert b$reqreads#21;
        assert b$reqreads#22;
    }
}



// function declaration for PackedStringArray.DynamicPsa.toPsa
function PackedStringArray.DynamicPsa.toPsa($heap: Heap, this: ref) : DatatypeType;

function PackedStringArray.DynamicPsa.toPsa#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.toPsa
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.toPsa($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.toPsa($h0, this)
       == PackedStringArray.DynamicPsa.toPsa($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.toPsa
axiom 13 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.toPsa($Heap, this) } 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         || (13 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> $Is(PackedStringArray.DynamicPsa.toPsa($Heap, this), Tclass.PackedStringArray.Psa()));

function PackedStringArray.DynamicPsa.toPsa#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.toPsa
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.toPsa#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.toPsa#requires($Heap, this)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.toPsa(revealed)
axiom 13 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.toPsa($Heap, this) } 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         || (13 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> (LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> PackedStringArray.__default.EmptyPsa#canCall())
         && PackedStringArray.DynamicPsa.toPsa($Heap, this)
           == (if LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             then PackedStringArray.__default.EmptyPsa()
             else #PackedStringArray.Psa.Psa(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.data)), 
                $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int))));

procedure CheckWellformed$$PackedStringArray.DynamicPsa.toPsa(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.toPsa(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;
  var b$reqreads#10: bool;
  var b$reqreads#11: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;
    b$reqreads#10 := true;
    b$reqreads#11 := true;

    // AddWellformednessCheck for function toPsa
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(751,20): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, PackedStringArray.DynamicPsa.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.DynamicPsa.toPsa($Heap, this), Tclass.PackedStringArray.Psa());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        b$reqreads#2 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
        if (LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
        {
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.EmptyPsa#canCall();
            assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
            assume PackedStringArray.DynamicPsa.toPsa($Heap, this)
               == Lit(PackedStringArray.__default.EmptyPsa());
            assume PackedStringArray.__default.EmptyPsa#canCall();
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.DynamicPsa.toPsa($Heap, this), Tclass.PackedStringArray.Psa());
        }
        else
        {
            b$reqreads#4 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
            b$reqreads#5 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            b$reqreads#6 := (forall $i: int :: 
              { $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField($i)] } 
              0 <= $i && $i < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                 ==> $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField($i)]);
            b$reqreads#7 := $_Frame[this, PackedStringArray.DynamicPsa.data];
            assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
            b$reqreads#8 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
            b$reqreads#9 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            newtype$check#1 := LitInt(1);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            newtype$check#2 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
               && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
                 < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            b$reqreads#10 := $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1)];
            assert 0
                 <= $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               && $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
            b$reqreads#11 := (forall $i: int :: 
              { $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.data), IndexField($i)] } 
              0 <= $i
                   && $i
                     < $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 ==> $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.data), IndexField($i)]);
            assume PackedStringArray.DynamicPsa.toPsa($Heap, this)
               == #PackedStringArray.Psa.Psa(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                  read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
                Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.data)), 
                  $Unbox(read($Heap, 
                      read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                      IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int));
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.DynamicPsa.toPsa($Heap, this), Tclass.PackedStringArray.Psa());
        }

        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
        assert b$reqreads#10;
        assert b$reqreads#11;
    }
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.TotalLength(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
   returns (result#0: int where LitInt(0) <= result#0 && result#0 < 18446744073709551616);
  free requires 15 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.TotalLength(this: ref) returns (result#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;

    // AddMethodImpl: TotalLength, CheckWellformed$$PackedStringArray.DynamicPsa.TotalLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(761,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(763,21): post-state"} true;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#0))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#0))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assume result#0
       == PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this));
}



procedure Call$$PackedStringArray.DynamicPsa.TotalLength(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
   returns (result#0: int where LitInt(0) <= result#0 && result#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this));
  ensures result#0
     == PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.TotalLength(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
   returns (result#0: int where LitInt(0) <= result#0 && result#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 15 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this));
  ensures result#0
     == PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.TotalLength(this: ref) returns (result#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#0_0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

    // AddMethodImpl: TotalLength, Impl$$PackedStringArray.DynamicPsa.TotalLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(764,4): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(765,7)
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(766,16)
        assume true;
        newtype$check#0_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume true;
        result#0 := LitInt(0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(766,19)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(768,16)
        assume true;
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        newtype$check#1 := LitInt(1);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        newtype$check#3 := $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int;
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assume true;
        result#0 := $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(768,47)"} true;
    }
}



// function declaration for PackedStringArray.DynamicPsa.weight
function PackedStringArray.DynamicPsa.weight($heap: Heap, this: ref) : int;

function PackedStringArray.DynamicPsa.weight#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.weight
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.weight($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.weight($h0, this)
       == PackedStringArray.DynamicPsa.weight($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.weight
axiom 16 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.weight($Heap, this) } 
    PackedStringArray.DynamicPsa.weight#canCall($Heap, this)
         || (16 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> LitInt(0) <= PackedStringArray.DynamicPsa.weight($Heap, this)
         && PackedStringArray.DynamicPsa.weight($Heap, this) < 18446744073709551616);

function PackedStringArray.DynamicPsa.weight#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.weight
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.weight#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.weight#requires($Heap, this)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.weight(revealed)
axiom 16 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.weight($Heap, this) } 
    PackedStringArray.DynamicPsa.weight#canCall($Heap, this)
         || (16 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.weight($Heap, this)
         == Mul(LitInt(4), read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
           + (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
             then 0
             else $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int));

procedure CheckWellformed$$PackedStringArray.DynamicPsa.weight(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.weight(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;

    // AddWellformednessCheck for function weight
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(772,20): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, PackedStringArray.DynamicPsa.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume LitInt(0) <= PackedStringArray.DynamicPsa.weight($Heap, this)
           && PackedStringArray.DynamicPsa.weight($Heap, this) < 18446744073709551616;
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
        newtype$check#0 := LitInt(4);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        b$reqreads#2 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
        newtype$check#1 := Mul(LitInt(4), read($Heap, this, PackedStringArray.DynamicPsa.nstrings));
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        b$reqreads#3 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
        newtype$check#2 := LitInt(0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0))
        {
            newtype$check#3 := LitInt(0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        }
        else
        {
            b$reqreads#4 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
            b$reqreads#5 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            newtype$check#4 := LitInt(1);
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            newtype$check#5 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
            assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
            assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
               && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
                 < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            b$reqreads#6 := $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1)];
            newtype$check#6 := $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int;
            assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        }

        newtype$check#7 := Mul(LitInt(4), read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
           + (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
             then 0
             else $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int);
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
        assume PackedStringArray.DynamicPsa.weight($Heap, this)
           == Mul(LitInt(4), read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
             + (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
               then 0
               else $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int);
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.DynamicPsa.weight($Heap, this), Tclass.NativeTypes.uint64());
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
    }
}



// function declaration for PackedStringArray.DynamicPsa.canAppend
function PackedStringArray.DynamicPsa.canAppend($heap: Heap, this: ref, str#0: Seq Box) : bool;

function PackedStringArray.DynamicPsa.canAppend#canCall($heap: Heap, this: ref, str#0: Seq Box) : bool;

// frame axiom for PackedStringArray.DynamicPsa.canAppend
axiom (forall $h0: Heap, $h1: Heap, this: ref, str#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.canAppend($h1, this, str#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && (PackedStringArray.DynamicPsa.canAppend#canCall($h0, this, str#0)
         || $Is(str#0, TSeq(Tclass.NativeTypes.byte())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.canAppend($h0, this, str#0)
       == PackedStringArray.DynamicPsa.canAppend($h1, this, str#0));

// consequence axiom for PackedStringArray.DynamicPsa.canAppend
axiom 18 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
    { PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0) } 
    PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
         || (18 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> true);

function PackedStringArray.DynamicPsa.canAppend#requires(Heap, ref, Seq Box) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.canAppend
axiom (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
  { PackedStringArray.DynamicPsa.canAppend#requires($Heap, this, str#0) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
       && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.DynamicPsa.canAppend#requires($Heap, this, str#0)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.canAppend(revealed)
axiom 18 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
    { PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0) } 
    PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
         || (18 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         && PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         && (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
             && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         && PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
           == (
            PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
                 + Seq#Length(str#0)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))));

procedure CheckWellformed$$PackedStringArray.DynamicPsa.canAppend(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box where $Is(str#0, TSeq(Tclass.NativeTypes.byte())));
  free requires 18 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.canAppend(this: ref, str#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##psa#0: DatatypeType;
  var ##key#0: Seq Box;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;

    // AddWellformednessCheck for function canAppend
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(779,14): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, PackedStringArray.DynamicPsa.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
        ##key#0 := str#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
        if (PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0))
        {
            b$reqreads#4 := $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
            b$reqreads#5 := $_Frame[this, PackedStringArray.DynamicPsa.offsets];
            assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
            newtype$check#0 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        }

        if (PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets)))
        {
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                    read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.WF($Heap, this);
            b$reqreads#6 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
            ##psa#1 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#1))
               < NativeTypes.__default.Uint64UpperBound();
            assume Seq#Length(PackedStringArray.Psa.data(##psa#1))
               < NativeTypes.__default.Uint64UpperBound();
            b$reqreads#7 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this));
            newtype$check#1 := Seq#Length(str#0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            newtype$check#2 := PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
               + Seq#Length(str#0);
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            b$reqreads#8 := $_Frame[this, PackedStringArray.DynamicPsa.data];
            assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
            newtype$check#3 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        }

        assume PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
           == (
            PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
                 + Seq#Length(str#0)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
           && (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
               && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this)));
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0), TBool);
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
    }
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.CanAppendWORealloc(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: bool);
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.CanAppendWORealloc(this: ref, str#0: Seq Box) returns (result#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##key#0: Seq Box;

    // AddMethodImpl: CanAppendWORealloc, CheckWellformed$$PackedStringArray.DynamicPsa.CanAppendWORealloc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(788,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume Seq#Length(str#0) < 4294967296;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(791,21): post-state"} true;
    if (*)
    {
        assume result#0;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
        ##key#0 := str#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
        assume PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
    }
    else
    {
        assume result#0
           ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
    }
}



procedure Call$$PackedStringArray.DynamicPsa.CanAppendWORealloc(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: bool);
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires Seq#Length(str#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures result#0
     ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
       && PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
  free ensures result#0
     ==> PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       && 
      PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       && 
      Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         < 4294967296 - 1
       && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(str#0)
         < 4294967296;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.CanAppendWORealloc(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: bool, $_reverifyPost: bool);
  free requires 19 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires Seq#Length(str#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures result#0
     ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
       && PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
  ensures result#0
     ==> 
    PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         < 4294967296 - 1;
  ensures result#0
     ==> 
    PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(str#0)
         < 4294967296;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.CanAppendWORealloc(this: ref, str#0: Seq Box) returns (result#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var tl#0: int where LitInt(0) <= tl#0 && tl#0 < 18446744073709551616;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;

    // AddMethodImpl: CanAppendWORealloc, Impl$$PackedStringArray.DynamicPsa.CanAppendWORealloc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(792,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(793,28)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$PackedStringArray.DynamicPsa.TotalLength(this);
    // TrCallStmt: After ProcessCallStmt
    tl#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(793,29)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(794,14)
    assume true;
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    newtype$check#0 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets)))
    {
        newtype$check#1 := LitInt(4294967296);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := LitInt(1);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := LitInt(4294967296 - 1);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    }

    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296 - 1)
    {
        newtype$check#4 := Seq#Length(str#0);
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        newtype$check#5 := tl#0 + Seq#Length(str#0);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
        newtype$check#6 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    }

    assume true;
    result#0 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296 - 1
       && tl#0 + Seq#Length(str#0)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(797,56)"} true;
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 21 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.append(this: ref, str#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##str#0: Seq Box;
  var ##psa#0: DatatypeType;
  var ##key#0: Seq Box;

    // AddMethodImpl: append, CheckWellformed$$PackedStringArray.DynamicPsa.append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(800,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    ##str#0 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##str#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0);
    assume PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(803,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#0, ##key#0)
       ==> PackedStringArray.__default.psaCanAppend(##psa#0, ##key#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296 - 1;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#0, ##key#0)
       ==> PackedStringArray.__default.psaCanAppend(##psa#0, ##key#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) + Seq#Length(##key#0)
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppend(##psa#0, ##key#0);
    assume PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
}



procedure Call$$PackedStringArray.DynamicPsa.append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
           || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
             < 4294967296 - 1);
  requires PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
           || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
               + Seq#Length(str#0)
             < 4294967296);
  requires PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
           + Seq#Length(str#0)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
  free ensures true;
  ensures Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
    read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 21 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free requires PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     && 
    PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
     && 
    PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
         + Seq#Length(str#0)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
  free ensures true;
  ensures Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
    read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.append(this: ref, str#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var start#0: int where LitInt(0) <= start#0 && start#0 < 4294967296;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 4294967296;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var src##0: Seq Box;
  var srcIndex##0: int;
  var newtype$check#6: int;
  var dst##0: ref;
  var dstIndex##0: int;
  var newtype$check#7: int;
  var len##0: int;
  var newtype$check#8: int;
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var newtype$check#9: int;
  var newtype$check#10: int;

    // AddMethodImpl: append, Impl$$PackedStringArray.DynamicPsa.append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(807,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(808,25)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0))
    {
        newtype$check#1 := LitInt(0);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 4294967296;
    }
    else
    {
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        newtype$check#2 := LitInt(1);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    }

    assume true;
    start#0 := (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
       then 0
       else $Unbox(read($Heap, 
          read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
          IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(808,75)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(809,25)
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assume true;
    assert $_Frame[read($Heap, this, PackedStringArray.DynamicPsa.offsets), IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings))];
    newtype$check#4 := Seq#Length(str#0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 4294967296;
    newtype$check#5 := start#0 + Seq#Length(str#0);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 4294967296;
    assume true;
    $rhs#0 := start#0 + Seq#Length(str#0);
    $Heap := update($Heap, 
      read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
      IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
      $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(809,50)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(810,23)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##0 := str#0;
    newtype$check#6 := LitInt(0);
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##0 := read($Heap, this, PackedStringArray.DynamicPsa.data);
    newtype$check#7 := start#0;
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##0 := start#0;
    newtype$check#8 := Seq#Length(str#0);
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := Seq#Length(str#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$NativeArrays.__default.CopySeqIntoArray(Tclass.NativeTypes.byte(), src##0, srcIndex##0, dst##0, dstIndex##0, len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(810,70)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(811,16)
    assume true;
    assert $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
    newtype$check#9 := LitInt(1);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    newtype$check#10 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + 1;
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    assume true;
    $rhs#1 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + 1;
    $Heap := update($Heap, this, PackedStringArray.DynamicPsa.nstrings, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(811,30)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(812,35)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Uint32__Order.__default.reveal__IsSorted();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(812,36)"} true;
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.realloc__offsets(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    new_offsets_len#0: int
       where LitInt(0) <= new_offsets_len#0 && new_offsets_len#0 < 18446744073709551616);
  free requires 23 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.realloc__offsets(this: ref, new_offsets_len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: realloc_offsets, CheckWellformed$$PackedStringArray.DynamicPsa.realloc__offsets
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(815,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume read($Heap, this, PackedStringArray.DynamicPsa.nstrings) <= new_offsets_len#0;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(818,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assume read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null
       && !read(old($Heap), read($Heap, this, PackedStringArray.DynamicPsa.offsets), alloc);
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assume _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       == new_offsets_len#0;
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume read($Heap, this, PackedStringArray.DynamicPsa.data)
       == read(old($Heap), this, PackedStringArray.DynamicPsa.data);
}



procedure Call$$PackedStringArray.DynamicPsa.realloc__offsets(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    new_offsets_len#0: int
       where LitInt(0) <= new_offsets_len#0 && new_offsets_len#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires read($Heap, this, PackedStringArray.DynamicPsa.nstrings) <= new_offsets_len#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null
     && !read(old($Heap), read($Heap, this, PackedStringArray.DynamicPsa.offsets), alloc);
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == new_offsets_len#0;
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.data)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.data);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.realloc__offsets(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    new_offsets_len#0: int
       where LitInt(0) <= new_offsets_len#0 && new_offsets_len#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 23 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires read($Heap, this, PackedStringArray.DynamicPsa.nstrings) <= new_offsets_len#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null
     && !read(old($Heap), read($Heap, this, PackedStringArray.DynamicPsa.offsets), alloc);
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == new_offsets_len#0;
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.data)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.data);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.realloc__offsets(this: ref, new_offsets_len#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var new_offsets#0: ref
     where $Is(new_offsets#0, Tclass._System.array(Tclass.NativeTypes.uint32()))
       && $IsAlloc(new_offsets#0, Tclass._System.array(Tclass.NativeTypes.uint32()), $Heap);
  var $nw: ref;
  var src##0: ref;
  var srcIndex##0: int;
  var newtype$check#0: int;
  var dst##0: ref;
  var dstIndex##0: int;
  var newtype$check#1: int;
  var len##0: int;
  var $rhs#0: ref where $Is($rhs#0, Tclass._System.array(Tclass.NativeTypes.uint32()));
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));

    // AddMethodImpl: realloc_offsets, Impl$$PackedStringArray.DynamicPsa.realloc__offsets
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(824,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(825,23)
    assume true;
    assert 0 <= new_offsets_len#0;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.uint32());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == new_offsets_len#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    new_offsets#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(825,52)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(826,34)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##0 := read($Heap, this, PackedStringArray.DynamicPsa.offsets);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##0 := new_offsets#0;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$NativeArrays.__default.CopyArrayIntoDifferentArray(Tclass.NativeTypes.uint32(), src##0, srcIndex##0, dst##0, dstIndex##0, len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(826,71)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(827,15)
    assume true;
    assert $_Frame[this, PackedStringArray.DynamicPsa.offsets];
    assume true;
    $rhs#0 := new_offsets#0;
    $Heap := update($Heap, this, PackedStringArray.DynamicPsa.offsets, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(827,28)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(828,7)
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assert {:subsumption 0} 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert read(old($Heap), this, PackedStringArray.DynamicPsa.offsets) != null;
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} 0 <= read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
       && read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assume true;
    assert Seq#Equal(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
      Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
        read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(829,12)
    assume true;
    assert $_Frame[this, PackedStringArray.DynamicPsa.Repr];
    assume true;
    $rhs#1 := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
      $Box(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    $Heap := update($Heap, this, PackedStringArray.DynamicPsa.Repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(829,35)"} true;
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.realloc__data(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    new_data_len#0: int
       where LitInt(0) <= new_data_len#0 && new_data_len#0 < 18446744073709551616);
  free requires 24 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.realloc__data(this: ref, new_data_len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;

    // AddMethodImpl: realloc_data, CheckWellformed$$PackedStringArray.DynamicPsa.realloc__data
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(832,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    newtype$check#0 := LitInt(4294967296);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume new_data_len#0 < 4294967296;
    if (*)
    {
        newtype$check#1 := LitInt(0);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        assume 0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        newtype$check#2 := LitInt(1);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        newtype$check#4 := $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int;
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        assume $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= new_data_len#0;
    }
    else
    {
        assume 0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= new_data_len#0;
    }

    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(836,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume read($Heap, this, PackedStringArray.DynamicPsa.offsets)
       == read(old($Heap), this, PackedStringArray.DynamicPsa.offsets);
    assume read($Heap, this, PackedStringArray.DynamicPsa.data) != null
       && !read(old($Heap), read($Heap, this, PackedStringArray.DynamicPsa.data), alloc);
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    assume _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       == new_data_len#0;
}



procedure Call$$PackedStringArray.DynamicPsa.realloc__data(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    new_data_len#0: int
       where LitInt(0) <= new_data_len#0 && new_data_len#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires new_data_len#0 < 4294967296;
  requires 0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
     ==> $Unbox(read($Heap, 
          read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
          IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
       <= new_data_len#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.offsets)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.offsets);
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.data) != null
     && !read(old($Heap), read($Heap, this, PackedStringArray.DynamicPsa.data), alloc);
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == new_data_len#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.realloc__data(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    new_data_len#0: int
       where LitInt(0) <= new_data_len#0 && new_data_len#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 24 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires new_data_len#0 < 4294967296;
  requires 0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
     ==> $Unbox(read($Heap, 
          read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
          IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
       <= new_data_len#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.offsets)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.offsets);
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.data) != null
     && !read(old($Heap), read($Heap, this, PackedStringArray.DynamicPsa.data), alloc);
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == new_data_len#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.realloc__data(this: ref, new_data_len#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var data_len#0: int where LitInt(0) <= data_len#0 && data_len#0 < 4294967296;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var new_data#0: ref
     where $Is(new_data#0, Tclass._System.array(Tclass.NativeTypes.byte()))
       && $IsAlloc(new_data#0, Tclass._System.array(Tclass.NativeTypes.byte()), $Heap);
  var $nw: ref;
  var src##0: ref;
  var srcIndex##0: int;
  var newtype$check#9: int;
  var dst##0: ref;
  var dstIndex##0: int;
  var newtype$check#10: int;
  var len##0: int;
  var newtype$check#11: int;
  var $rhs#0: ref where $Is($rhs#0, Tclass._System.array(Tclass.NativeTypes.byte()));
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));

    // AddMethodImpl: realloc_data, Impl$$PackedStringArray.DynamicPsa.realloc__data
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(842,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(843,20)
    assume true;
    newtype$check#5 := LitInt(0);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    if (LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
    {
        newtype$check#6 := LitInt(0);
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 4294967296;
    }
    else
    {
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        newtype$check#7 := LitInt(1);
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
        newtype$check#8 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    }

    assume true;
    data_len#0 := (if LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       then 0
       else $Unbox(read($Heap, 
          read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
          IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(843,70)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(844,20)
    assume true;
    assert 0 <= new_data_len#0;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.byte());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == new_data_len#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    new_data#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(844,44)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(845,34)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##0 := read($Heap, this, PackedStringArray.DynamicPsa.data);
    newtype$check#9 := LitInt(0);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##0 := new_data#0;
    newtype$check#10 := LitInt(0);
    assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##0 := LitInt(0);
    newtype$check#11 := data_len#0;
    assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := data_len#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$NativeArrays.__default.CopyArrayIntoDifferentArray(Tclass.NativeTypes.byte(), src##0, srcIndex##0, dst##0, dstIndex##0, len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(845,75)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(846,12)
    assume true;
    assert $_Frame[this, PackedStringArray.DynamicPsa.data];
    assume true;
    $rhs#0 := new_data#0;
    $Heap := update($Heap, this, PackedStringArray.DynamicPsa.data, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(846,22)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(847,12)
    assume true;
    assert $_Frame[this, PackedStringArray.DynamicPsa.Repr];
    assume true;
    $rhs#1 := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
      $Box(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    $Heap := update($Heap, this, PackedStringArray.DynamicPsa.Repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(847,35)"} true;
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.realloc__to__accomodate(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 25 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.realloc__to__accomodate(this: ref, str#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##key#0: Seq Box;
  var ##str#0: Seq Box;

    // AddMethodImpl: realloc_to_accomodate, CheckWellformed$$PackedStringArray.DynamicPsa.realloc__to__accomodate
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(850,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
    assume PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(853,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    ##str#0 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##str#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0);
    assume PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0);
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
           && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$PackedStringArray.DynamicPsa.realloc__to__accomodate(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         < 4294967296 - 1;
  requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(str#0)
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0);
  free ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     && 
    PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
     && 
    PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
         + Seq#Length(str#0)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.realloc__to__accomodate(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 25 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     && 
    PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
       < 4294967296 - 1
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Seq#Length(str#0)
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0);
  ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
           || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
             < 4294967296 - 1);
  ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || (PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
           || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
               + Seq#Length(str#0)
             < 4294967296);
  ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
     ==> PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
       || PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
           + Seq#Length(str#0)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.realloc__to__accomodate(this: ref, str#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#0_0: int;
  var new_offsets_len##0_0_0: int;
  var newtype$check#0_0_0: int;
  var new_offsets_len##0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var data_len#0: int where LitInt(0) <= data_len#0 && data_len#0 < 4294967296;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##psa#1: DatatypeType;
  var new_len#0: int where LitInt(0) <= new_len#0 && new_len#0 < 18446744073709551616;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#1_0: int;
  var newtype$check#1_1: int;
  var newtype$check#1_2: int;
  var new_data_len##1_0_0: int;
  var newtype$check#1_0_0: int;
  var new_data_len##1_0: int;
  var newtype$check#1_3: int;
  var newtype$check#1_4: int;

    // AddMethodImpl: realloc_to_accomodate, Impl$$PackedStringArray.DynamicPsa.realloc__to__accomodate
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(858,4): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(859,7)
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    newtype$check#0 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       == _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets)))
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(860,9)
        newtype$check#0_0 := LitInt(2147483648);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume true;
        if (LitInt(2147483648) <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(861,26)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            newtype$check#0_0_0 := LitInt(4294967295);
            assert LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            new_offsets_len##0_0_0 := LitInt(4294967295);
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.DynamicPsa.realloc__offsets(this, new_offsets_len##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(861,38)"} true;
        }
        else
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(863,26)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            newtype$check#0_1 := LitInt(2);
            assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
            newtype$check#0_2 := Mul(LitInt(2), read($Heap, this, PackedStringArray.DynamicPsa.nstrings));
            assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
            newtype$check#0_3 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
            newtype$check#0_4 := Mul(LitInt(2), read($Heap, this, PackedStringArray.DynamicPsa.nstrings)) + 1;
            assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            new_offsets_len##0_0 := Mul(LitInt(2), read($Heap, this, PackedStringArray.DynamicPsa.nstrings)) + 1;
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.DynamicPsa.realloc__offsets(this, new_offsets_len##0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(863,41)"} true;
        }
    }
    else
    {
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(866,28)
    assume true;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0))
    {
        newtype$check#2 := LitInt(0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 4294967296;
    }
    else
    {
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        newtype$check#3 := LitInt(1);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    }

    assume true;
    data_len#0 := (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
       then 0
       else $Unbox(read($Heap, 
          read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
          IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(866,78)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(867,7)
    newtype$check#5 := data_len#0;
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#1 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
       && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert data_len#0
       == PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(868,27)
    assume true;
    newtype$check#6 := data_len#0;
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    newtype$check#7 := Seq#Length(str#0);
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    newtype$check#8 := data_len#0 + Seq#Length(str#0);
    assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    new_len#0 := data_len#0 + Seq#Length(str#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(868,65)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(869,7)
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    newtype$check#9 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    if (_System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < new_len#0)
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(870,9)
        newtype$check#1_0 := LitInt(4294967296);
        assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
        newtype$check#1_1 := LitInt(2);
        assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
        newtype$check#1_2 := Mul(LitInt(2), new_len#0);
        assert LitInt(0) <= newtype$check#1_2 && newtype$check#1_2 < 18446744073709551616;
        assume true;
        if (LitInt(4294967296) <= Mul(LitInt(2), new_len#0))
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(871,23)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            newtype$check#1_0_0 := LitInt(4294967295);
            assert LitInt(0) <= newtype$check#1_0_0 && newtype$check#1_0_0 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            new_data_len##1_0_0 := LitInt(4294967295);
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.DynamicPsa.realloc__data(this, new_data_len##1_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(871,35)"} true;
        }
        else
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(873,23)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            newtype$check#1_3 := LitInt(2);
            assert LitInt(0) <= newtype$check#1_3 && newtype$check#1_3 < 18446744073709551616;
            newtype$check#1_4 := Mul(LitInt(2), new_len#0);
            assert LitInt(0) <= newtype$check#1_4 && newtype$check#1_4 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            new_data_len##1_0 := Mul(LitInt(2), new_len#0);
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.DynamicPsa.realloc__data(this, new_data_len##1_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(873,33)"} true;
        }
    }
    else
    {
    }
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.Append(this: ref, str#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##key#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##key#1: Seq Box;

    // AddMethodImpl: Append, CheckWellformed$$PackedStringArray.DynamicPsa.Append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(878,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
    assume PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(881,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    ##psa#1 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#1 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#1, ##key#1)
       ==> PackedStringArray.__default.psaCanAppend(##psa#1, ##key#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296 - 1;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#1, ##key#1)
       ==> PackedStringArray.__default.psaCanAppend(##psa#1, ##key#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) + Seq#Length(##key#1)
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppend(##psa#1, ##key#1);
    assume PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
           && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$PackedStringArray.DynamicPsa.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         < 4294967296 - 1;
  requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(str#0)
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.Append(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 26 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free requires PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     && 
    PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
       < 4294967296 - 1
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Seq#Length(str#0)
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppend(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), str#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.Append(this: ref, str#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var str##0: Seq Box;
  var str##1: Seq Box;

    // AddMethodImpl: Append, Impl$$PackedStringArray.DynamicPsa.Append
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(885,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(886,28)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assume true;
    // ProcessCallStmt: CheckSubrange
    str##0 := str#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.DynamicPsa.realloc__to__accomodate(this, str##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(886,32)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(887,13)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assume true;
    // ProcessCallStmt: CheckSubrange
    str##1 := str#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.DynamicPsa.append(this, str##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(887,17)"} true;
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.appendSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 32 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.appendSeq(this: ref, strs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##strs#1: Seq Box;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##strs#2: Seq Box;

    // AddMethodImpl: appendSeq, CheckWellformed$$PackedStringArray.DynamicPsa.appendSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(890,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assume read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#1 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#1 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) + Seq#Length(##strs#1)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#1))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1);
    assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    ##psa#2 := PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    assume PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == this
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(895,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    ##psa#3 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#2 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) + Seq#Length(##strs#2)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#2))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2);
    assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
}



procedure Call$$PackedStringArray.DynamicPsa.appendSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(strs#0)
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs#0))
         < 4294967296;
  requires read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0)
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
  free ensures true;
  ensures Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
    read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.appendSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 32 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Seq#Length(strs#0)
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
       < 4294967296;
  requires read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0)
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
  free ensures true;
  ensures Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
    read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.appendSeq(this: ref, strs#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var psa##0: DatatypeType;
  var strs1##0: Seq Box;
  var strs2##0: Seq Box;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var newtype$check#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#4: DatatypeType;
  var ##strs#3: Seq Box;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $decr$loop#00: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var str##0_0: Seq Box;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;

    // AddMethodImpl: appendSeq, Impl$$PackedStringArray.DynamicPsa.appendSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(899,4): initial state"} true;
    $_reverifyPost := false;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(900,7)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#0;
        assume true;
        if (LitInt(0) <= i#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#0 && i#0 <= Seq#Length(strs#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(904,9)
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(strs#0, Seq#Append(Seq#Take(strs#0, i#0), Seq#Drop(strs#0, i#0)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(905,29)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        // ProcessCallStmt: CheckSubrange
        psa##0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs1##0 := Seq#Take(strs#0, i#0);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs2##0 := Seq#Drop(strs#0, i#0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaAppendSeqAdditive(psa##0, strs1##0, strs2##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(905,59)"} true;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
                 + Seq#Length(Seq#Take(strs#0, i#0))
               < 4294967296;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    Seq#Take(strs#0, i#0)))
               < 4294967296;
        assert PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, this), 
              Seq#Take(strs#0, i#0)))
           <= PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
        assume false;
    }
    else
    {
        assume (forall i#1: int :: 
          { Seq#Take(strs#0, i#1) } 
          LitInt(0) <= i#1 && i#1 <= Seq#Length(strs#0)
             ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#1))
               && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#1)))
                 <= PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(906,6)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(908,21)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    i#2 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(908,24)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(909,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(strs#0) - i#2;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#2 <= Seq#Length(strs#0);
      free invariant $w$loop#0 ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound();
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296;
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               < 4294967296);
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
      free invariant $w$loop#0
         ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           && 
          PackedStringArray.DynamicPsa.WF($Heap, this)
           && 
          Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               < 4294967296)
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
            Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
      free invariant $w$loop#0
         ==> $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
           && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
              Seq#Take(strs#0, i#2)))
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#2));
      invariant $w$loop#0
         ==> PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
          PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
            Seq#Take(strs#0, i#2)));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]
             || 
            $o == this
             || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(strs#0) - i#2 <= $decr_init$loop#00
         && (Seq#Length(strs#0) - i#2 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(909,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume i#2 <= Seq#Length(strs#0);
            assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
            assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
            assume PackedStringArray.DynamicPsa.WF($Heap, this);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                    read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
            assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read(old($Heap), 
                        read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read(old($Heap), 
                        read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
                    read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
            assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
            ##psa#4 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#3 := Seq#Take(strs#0, i#2);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#4));
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#4, ##strs#3)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#4, ##strs#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) + Seq#Length(##strs#3)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#4, ##strs#3)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#4, ##strs#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#4))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#3))
                   < 4294967296;
            assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#2));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
                Seq#Take(strs#0, i#2)));
            assume $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
               && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                  PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
                  Seq#Take(strs#0, i#2)))
               && 
              PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
               && 
              PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
               && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#2));
            assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
              PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
                Seq#Take(strs#0, i#2)));
            assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
            assume true;
            assume Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
            newtype$check#1 := Seq#Length(strs#0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#2 := Seq#Length(strs#0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assume true;
        if (Seq#Length(strs#0) <= i#2)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(strs#0) - i#2;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(915,9)
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#2 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(Seq#Take(strs#0, i#2 + 1), 
          Seq#Append(Seq#Take(strs#0, i#2), Seq#Build(Seq#Empty(): Seq Box, Seq#Index(strs#0, i#2))));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(916,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        str##0_0 := $Unbox(Seq#Index(strs#0, i#2)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.DynamicPsa.append(this, str##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(916,23)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(917,11)
        assume true;
        newtype$check#0_2 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        newtype$check#0_3 := i#2 + 1;
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume true;
        i#2 := i#2 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(917,18)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(909,7)
        assert 0 <= $decr$loop#00 || Seq#Length(strs#0) - i#2 == $decr$loop#00;
        assert Seq#Length(strs#0) - i#2 < $decr$loop#00;
        assume true;
        assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
        assume $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
           && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
              Seq#Take(strs#0, i#2)))
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#2));
        assume true;
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(919,7)
    assert {:subsumption 0} 0 <= Seq#Length(strs#0) && Seq#Length(strs#0) <= Seq#Length(strs#0);
    assume true;
    assert Seq#Equal(Seq#Take(strs#0, Seq#Length(strs#0)), strs#0);
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 34 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq(this: ref, strs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##strs#1: Seq Box;
  var ##psa#2: DatatypeType;

    // AddMethodImpl: realloc_to_accomodate_seq, CheckWellformed$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(922,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(925,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assume read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#1 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#1 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) + Seq#Length(##strs#1)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#1))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1);
    assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    ##psa#2 := PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    assume PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
           && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(strs#0)
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs#0))
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0)
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  free ensures PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
  ensures PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 34 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Seq#Length(strs#0)
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa(old($Heap), this))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0)
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  free ensures PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
  ensures PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq(this: ref, strs#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var psa##0: DatatypeType;
  var strs1##0: Seq Box;
  var strs2##0: Seq Box;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var new_offsets_len##0_0: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var total_len#0: int
     where LitInt(0) <= total_len#0 && total_len#0 < 18446744073709551616;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var newtype$check#9: int;
  var $PreLoopHeap$loop#0: Heap;
  var $Frame$loop#0: <beta>[ref,Field beta]bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#3: DatatypeType;
  var ##strs#2: Seq Box;
  var ##psa#4: DatatypeType;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var $decr$loop#00: int;
  var newtype$check#1_0: int;
  var newtype$check#1_1: int;
  var ##run#1_0: Seq Box;
  var psa##1_0: DatatypeType;
  var ##psa#1_0: DatatypeType;
  var ##strs#1_0: Seq Box;
  var key##1_0: Seq Box;
  var newtype$check#1_2: int;
  var newtype$check#1_3: int;
  var newtype$check#1_4: int;
  var newtype$check#1_5: int;
  var newtype$check#12: int;
  var new_data_len##2_0: int;

    // AddMethodImpl: realloc_to_accomodate_seq, Impl$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(931,4): initial state"} true;
    $_reverifyPost := false;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(932,7)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#0;
        assume true;
        if (LitInt(0) <= i#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#0 && i#0 <= Seq#Length(strs#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(936,9)
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(strs#0, Seq#Append(Seq#Take(strs#0, i#0), Seq#Drop(strs#0, i#0)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(937,29)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        // ProcessCallStmt: CheckSubrange
        psa##0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs1##0 := Seq#Take(strs#0, i#0);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs2##0 := Seq#Drop(strs#0, i#0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaAppendSeqAdditive(psa##0, strs1##0, strs2##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(937,59)"} true;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
                 + Seq#Length(Seq#Take(strs#0, i#0))
               < 4294967296;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    Seq#Take(strs#0, i#0)))
               < 4294967296;
        assert PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, this), 
              Seq#Take(strs#0, i#0)))
           <= PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
        assume false;
    }
    else
    {
        assume (forall i#1: int :: 
          { Seq#Take(strs#0, i#1) } 
          LitInt(0) <= i#1 && i#1 <= Seq#Length(strs#0)
             ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#1))
               && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#1)))
                 <= PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(938,6)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(940,7)
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    newtype$check#0 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := Seq#Length(strs#0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    if (_System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(941,24)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        newtype$check#0_0 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := Seq#Length(strs#0);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        newtype$check#0_2 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0);
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        new_offsets_len##0_0 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) + Seq#Length(strs#0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.DynamicPsa.realloc__offsets(this, new_offsets_len##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(941,62)"} true;
    }
    else
    {
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(944,29)
    assume true;
    newtype$check#4 := LitInt(0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    if (read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0))
    {
        newtype$check#5 := LitInt(0);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    }
    else
    {
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        newtype$check#6 := LitInt(1);
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        newtype$check#7 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        newtype$check#8 := $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int;
        assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    }

    assume true;
    total_len#0 := (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
       then 0
       else $Unbox(read($Heap, 
          read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
          IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(944,89)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(945,21)
    assume true;
    newtype$check#9 := LitInt(0);
    assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    i#2 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(945,24)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(946,7)
    // Assume Fuel Constant
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    $Frame$loop#0 := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(strs#0) - i#2;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#2 <= Seq#Length(strs#0);
      free invariant $w$loop#0
         ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2))
           && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
      invariant $w$loop#0
         ==> total_len#0
           == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
              PackedStringArray.DynamicPsa.toPsa($Heap, this), 
              Seq#Take(strs#0, i#2)));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]
             || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f)
             || $Frame$loop#0[$o, $f]);
      free invariant Seq#Length(strs#0) - i#2 <= $decr_init$loop#00
         && (Seq#Length(strs#0) - i#2 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(946,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume i#2 <= Seq#Length(strs#0);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                    read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
            assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
            ##psa#3 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#2 := Seq#Take(strs#0, i#2);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) + Seq#Length(##strs#2)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#2))
                   < 4294967296;
            assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
            ##psa#4 := PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#4))
               < NativeTypes.__default.Uint64UpperBound();
            assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
               && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2))
               && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
            assume total_len#0
               == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
            newtype$check#10 := Seq#Length(strs#0);
            assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#11 := Seq#Length(strs#0);
        assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
        assume true;
        if (Seq#Length(strs#0) <= i#2)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(strs#0) - i#2;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(951,9)
        assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        newtype$check#1_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
        newtype$check#1_1 := i#2 + 1;
        assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        ##run#1_0 := Seq#Take(strs#0, i#2 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#1_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} Seq#Length(##run#1_0) > 0;
        assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(strs#0, i#2 + 1));
        assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(strs#0, i#2 + 1));
        assert Seq#Equal(Seq#Take(strs#0, i#2), 
          Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Seq#Take(strs#0, i#2 + 1)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(952,29)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assert 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        ##psa#1_0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#1_0 := Seq#Take(strs#0, i#2);
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#1_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
           ==> PackedStringArray.__default.WF(##psa#1_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1_0));
        assume PackedStringArray.__default.WF(##psa#1_0);
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1_0, ##strs#1_0)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1_0, ##strs#1_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) + Seq#Length(##strs#1_0)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1_0, ##strs#1_0)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1_0, ##strs#1_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1_0))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    ##strs#1_0))
               < 4294967296;
        assume PackedStringArray.__default.psaCanAppendSeq(##psa#1_0, ##strs#1_0);
        assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
        // ProcessCallStmt: CheckSubrange
        psa##1_0 := PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##1_0 := $Unbox(Seq#Index(strs#0, i#2)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $Frame$loop#0[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaAppendTotalLength(psa##1_0, key##1_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(952,71)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(953,19)
        assume true;
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        newtype$check#1_2 := Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box);
        assert LitInt(0) <= newtype$check#1_2 && newtype$check#1_2 < 18446744073709551616;
        newtype$check#1_3 := total_len#0 + Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box);
        assert LitInt(0) <= newtype$check#1_3 && newtype$check#1_3 < 18446744073709551616;
        assume true;
        total_len#0 := total_len#0 + Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(953,52)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(954,11)
        assume true;
        newtype$check#1_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_4 && newtype$check#1_4 < 18446744073709551616;
        newtype$check#1_5 := i#2 + 1;
        assert LitInt(0) <= newtype$check#1_5 && newtype$check#1_5 < 18446744073709551616;
        assume true;
        i#2 := i#2 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(954,18)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(946,7)
        assert 0 <= $decr$loop#00 || Seq#Length(strs#0) - i#2 == $decr$loop#00;
        assert Seq#Length(strs#0) - i#2 < $decr$loop#00;
        assume true;
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2))
           && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(956,7)
    assert {:subsumption 0} 0 <= Seq#Length(strs#0) && Seq#Length(strs#0) <= Seq#Length(strs#0);
    assume true;
    assert Seq#Equal(strs#0, Seq#Take(strs#0, Seq#Length(strs#0)));
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(957,7)
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    newtype$check#12 := _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
    assume true;
    if (_System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < total_len#0)
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(958,21)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assume true;
        // ProcessCallStmt: CheckSubrange
        new_data_len##2_0 := total_len#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.DynamicPsa.realloc__data(this, new_data_len##2_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(958,31)"} true;
    }
    else
    {
    }
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.AppendSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 36 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.AppendSeq(this: ref, strs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##strs#1: Seq Box;

    // AddMethodImpl: AppendSeq, CheckWellformed$$PackedStringArray.DynamicPsa.AppendSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(962,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == this
           || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(965,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    ##psa#1 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#1 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) + Seq#Length(##strs#1)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#1))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1);
    assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
           && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$PackedStringArray.DynamicPsa.AppendSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Seq#Length(strs#0)
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs#0))
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.AppendSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 36 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Seq#Length(strs#0)
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa(old($Heap), this), strs#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         && !read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.AppendSeq(this: ref, strs#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var strs##0: Seq Box;
  var new_Repr#0: Set Box
     where $Is(new_Repr#0, TSet(Tclass._System.object()))
       && $IsAlloc(new_Repr#0, TSet(Tclass._System.object()), $Heap);
  var new_offsets#0: ref
     where $Is(new_offsets#0, Tclass._System.array(Tclass.NativeTypes.uint32()))
       && $IsAlloc(new_offsets#0, Tclass._System.array(Tclass.NativeTypes.uint32()), $Heap);
  var new_data#0: ref
     where $Is(new_data#0, Tclass._System.array(Tclass.NativeTypes.byte()))
       && $IsAlloc(new_data#0, Tclass._System.array(Tclass.NativeTypes.byte()), $Heap);
  var ##psa#2: DatatypeType;
  var ##strs#2: Seq Box;
  var ##psa#3: DatatypeType;
  var i#0: int;
  var psa##0: DatatypeType;
  var strs1##0: Seq Box;
  var strs2##0: Seq Box;
  var i#2: int;
  var psa##1: DatatypeType;
  var strs1##1: Seq Box;
  var strs2##1: Seq Box;
  var psa##2: DatatypeType;
  var ##psa#4: DatatypeType;
  var ##strs#3: Seq Box;
  var str##0: Seq Box;
  var psa##3: DatatypeType;
  var strs1##2: Seq Box;
  var strs2##2: Seq Box;
  var i#4: int where LitInt(0) <= i#4 && i#4 < 18446744073709551616;
  var newtype$check#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#5: DatatypeType;
  var ##strs#4: Seq Box;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $decr$loop#00: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var str##0_0: Seq Box;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;

    // AddMethodImpl: AppendSeq, Impl$$PackedStringArray.DynamicPsa.AppendSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(969,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(970,32)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assume true;
    // ProcessCallStmt: CheckSubrange
    strs##0 := strs#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.DynamicPsa.realloc__to__accomodate__seq(this, strs##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(970,37)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(971,26)
    assume true;
    assume true;
    new_Repr#0 := read($Heap, this, PackedStringArray.DynamicPsa.Repr);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(971,32)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(972,29)
    assume true;
    assume true;
    new_offsets#0 := read($Heap, this, PackedStringArray.DynamicPsa.offsets);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(972,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(973,26)
    assume true;
    assume true;
    new_data#0 := read($Heap, this, PackedStringArray.DynamicPsa.data);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(973,32)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(975,7)
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##psa#2 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#2 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#2, ##strs#2)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#2, ##strs#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) + Seq#Length(##strs#2)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#2, ##strs#2)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#2, ##strs#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#2))
           < 4294967296;
    assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    ##psa#3 := PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#3))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    assert {:subsumption 0} read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
       && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0)
       && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0));
    assert {:subsumption 0} PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    assume PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), strs#0))
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(977,7)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#0;
        assume true;
        if (LitInt(0) <= i#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#0 && i#0 <= Seq#Length(strs#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(980,9)
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(strs#0, Seq#Append(Seq#Take(strs#0, i#0), Seq#Drop(strs#0, i#0)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(981,32)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        // ProcessCallStmt: CheckSubrange
        psa##0 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs1##0 := Seq#Take(strs#0, i#0);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs2##0 := Seq#Drop(strs#0, i#0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa##0, strs1##0, strs2##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(981,62)"} true;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
             || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
                 + Seq#Length(Seq#Take(strs#0, i#0))
               < 4294967296;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#0))
             || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    Seq#Take(strs#0, i#0)))
               < 4294967296;
        assume false;
    }
    else
    {
        assume (forall i#1: int :: 
          { Seq#Take(strs#0, i#1) } 
          LitInt(0) <= i#1 && i#1 <= Seq#Length(strs#0)
             ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#1)));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(982,6)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(984,7)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#2;
        assume true;
        if (LitInt(0) <= i#2)
        {
        }

        assume true;
        assume LitInt(0) <= i#2 && i#2 < Seq#Length(strs#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(988,9)
        assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(Seq#Take(strs#0, i#2 + 1), 
          Seq#Append(Seq#Take(strs#0, i#2), Seq#Build(Seq#Empty(): Seq Box, Seq#Index(strs#0, i#2))));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(989,32)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        // ProcessCallStmt: CheckSubrange
        psa##1 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        assert 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs1##1 := Seq#Take(strs#0, i#2);
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs2##1 := Seq#Build(Seq#Empty(): Seq Box, Seq#Index(strs#0, i#2));
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa##1, strs1##1, strs2##1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(989,62)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(990,24)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assert 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        ##psa#4 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#3 := Seq#Take(strs#0, i#2);
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#4));
        assume PackedStringArray.__default.WF(##psa#4);
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#4, ##strs#3)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#4, ##strs#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) + Seq#Length(##strs#3)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#4, ##strs#3)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#4, ##strs#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    ##strs#3))
               < 4294967296;
        assume PackedStringArray.__default.psaCanAppendSeq(##psa#4, ##strs#3);
        assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
        // ProcessCallStmt: CheckSubrange
        psa##2 := PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2));
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        str##0 := $Unbox(Seq#Index(strs#0, i#2)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaCanAppendOne(psa##2, str##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(990,66)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(991,9)
        assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(strs#0, Seq#Append(Seq#Take(strs#0, i#2 + 1), Seq#Drop(strs#0, i#2 + 1)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(992,29)
        // TrCallStmt: Before ProcessCallStmt
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound();
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296);
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
        assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           ==> PackedStringArray.DynamicPsa.WF($Heap, this)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
        assume PackedStringArray.DynamicPsa.WF($Heap, this);
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
        assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
        // ProcessCallStmt: CheckSubrange
        psa##3 := PackedStringArray.DynamicPsa.toPsa($Heap, this);
        assert 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs1##2 := Seq#Take(strs#0, i#2 + 1);
        assert 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs2##2 := Seq#Drop(strs#0, i#2 + 1);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaAppendSeqAdditive(psa##3, strs1##2, strs2##2);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(992,63)"} true;
        assert PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)), 
            $Unbox(Seq#Index(strs#0, i#2)): Seq Box)
           ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)), 
              $Unbox(Seq#Index(strs#0, i#2)): Seq Box)
             || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
                    PackedStringArray.DynamicPsa.toPsa($Heap, this), 
                    Seq#Take(strs#0, i#2))))
               < 4294967296 - 1;
        assert PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)), 
            $Unbox(Seq#Index(strs#0, i#2)): Seq Box)
           ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#2)), 
              $Unbox(Seq#Index(strs#0, i#2)): Seq Box)
             || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
                      PackedStringArray.DynamicPsa.toPsa($Heap, this), 
                      Seq#Take(strs#0, i#2))))
                 + Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box)
               < 4294967296;
        assert PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
                PackedStringArray.DynamicPsa.toPsa($Heap, this), 
                Seq#Take(strs#0, i#2)))
             + Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data));
        assume false;
    }
    else
    {
        assume (forall i#3: int :: 
          { $Unbox(Seq#Index(strs#0, i#3)): Seq Box } { Seq#Take(strs#0, i#3) } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(strs#0)
             ==> PackedStringArray.__default.psaCanAppend(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#3)), 
                $Unbox(Seq#Index(strs#0, i#3)): Seq Box)
               && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), PackedStringArray.DynamicPsa.toPsa($Heap, this), Seq#Take(strs#0, i#3)))
                   + Seq#Length($Unbox(Seq#Index(strs#0, i#3)): Seq Box)
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(993,6)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(995,21)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    i#4 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(995,24)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(996,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(strs#0) - i#4;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#4 <= Seq#Length(strs#0);
      free invariant $w$loop#0 ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound();
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296;
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               < 4294967296);
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
      invariant $w$loop#0
         ==> 
        PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         ==> PackedStringArray.DynamicPsa.WF($Heap, this)
           || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
            Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
      free invariant $w$loop#0
         ==> PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
           && 
          PackedStringArray.DynamicPsa.WF($Heap, this)
           && 
          Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             < NativeTypes.__default.Uint64UpperBound()
           && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
             < 4294967296
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               < 4294967296)
           && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             ==> $Unbox(read($Heap, 
                  read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                  IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
            Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
      free invariant $w$loop#0
         ==> $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
           && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
              Seq#Take(strs#0, i#4)))
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#4));
      invariant $w$loop#0
         ==> PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
          PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
            PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
            Seq#Take(strs#0, i#4)));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), new_Repr#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> read($Heap, this, PackedStringArray.DynamicPsa.offsets) == new_offsets#0;
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> read($Heap, this, PackedStringArray.DynamicPsa.data) == new_data#0;
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]
             || 
            $o == this
             || read(old($Heap), this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(strs#0) - i#4 <= $decr_init$loop#00
         && (Seq#Length(strs#0) - i#4 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(996,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume i#4 <= Seq#Length(strs#0);
            assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
            assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
            assume PackedStringArray.DynamicPsa.WF($Heap, this);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read($Heap, 
                        read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
               ==> PackedStringArray.DynamicPsa.WF($Heap, this)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                    read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
            assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
                    $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
                   < NativeTypes.__default.Uint64UpperBound();
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
                   <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read(old($Heap), 
                        read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     < 4294967296);
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
                   ==> $Unbox(read(old($Heap), 
                        read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                        IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                     <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
            assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
               ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
                    read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
            assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
            assert {:subsumption 0} 0 <= i#4 && i#4 <= Seq#Length(strs#0);
            ##psa#5 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#4 := Seq#Take(strs#0, i#4);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#4, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#5));
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#5, ##strs#4)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#5, ##strs#4)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) + Seq#Length(##strs#4)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#5, ##strs#4)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#5, ##strs#4)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#5))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#4))
                   < 4294967296;
            assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#4));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
                Seq#Take(strs#0, i#4)));
            assume $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
               && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                  PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
                  Seq#Take(strs#0, i#4)))
               && 
              PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
               && 
              PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
               && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#4));
            assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
              PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
                Seq#Take(strs#0, i#4)));
            assume true;
            assume Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), new_Repr#0);
            assume true;
            assume read($Heap, this, PackedStringArray.DynamicPsa.offsets) == new_offsets#0;
            assume true;
            assume read($Heap, this, PackedStringArray.DynamicPsa.data) == new_data#0;
            newtype$check#1 := Seq#Length(strs#0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#2 := Seq#Length(strs#0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assume true;
        if (Seq#Length(strs#0) <= i#4)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(strs#0) - i#4;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1004,9)
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#4 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#4 + 1 && i#4 + 1 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#4 && i#4 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#4 && i#4 < Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(Seq#Take(strs#0, i#4 + 1), 
          Seq#Append(Seq#Take(strs#0, i#4), Seq#Build(Seq#Empty(): Seq Box, Seq#Index(strs#0, i#4))));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1005,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert 0 <= i#4 && i#4 < Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        str##0_0 := $Unbox(Seq#Index(strs#0, i#4)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.DynamicPsa.append(this, str##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1005,23)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1006,11)
        assume true;
        newtype$check#0_2 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        newtype$check#0_3 := i#4 + 1;
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume true;
        i#4 := i#4 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1006,18)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(996,7)
        assert 0 <= $decr$loop#00 || Seq#Length(strs#0) - i#4 == $decr$loop#00;
        assert Seq#Length(strs#0) - i#4 < $decr$loop#00;
        assume true;
        assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
        assume $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
           && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              PackedStringArray.DynamicPsa.toPsa(old($Heap), this), 
              Seq#Take(strs#0, i#4)))
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
           && 
          PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
           && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), Seq#Take(strs#0, i#4));
        assume true;
        assume true;
        assume true;
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1008,7)
    assert {:subsumption 0} 0 <= Seq#Length(strs#0) && Seq#Length(strs#0) <= Seq#Length(strs#0);
    assume true;
    assert Seq#Equal(Seq#Take(strs#0, Seq#Length(strs#0)), strs#0);
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.Prefix(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    newlen#0: int where LitInt(0) <= newlen#0 && newlen#0 < 18446744073709551616);
  free requires 44 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.Prefix(this: ref, newlen#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var ##psa#0: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;

    // AddMethodImpl: Prefix, CheckWellformed$$PackedStringArray.DynamicPsa.Prefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1011,11): initial state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume newlen#0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1014,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Set#Equal(read(old($Heap), this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read(old($Heap), this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || (0 < read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read(old($Heap), 
                read(old($Heap), this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read(old($Heap), this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall(old($Heap), this)
       ==> PackedStringArray.DynamicPsa.WF(old($Heap), this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray(old($Heap), read(old($Heap), this, PackedStringArray.DynamicPsa.offsets)), 
            read(old($Heap), this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF(old($Heap), this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa(old($Heap), this));
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    ##psa#0 := PackedStringArray.DynamicPsa.toPsa(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#0 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
    ##to#0 := newlen#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assert {:subsumption 0} LitInt(0) <= ##from#0;
    assert {:subsumption 0} ##from#0 <= ##to#0;
    assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#0);
    assume LitInt(0) <= ##from#0
       && ##from#0 <= ##to#0
       && ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#0);
    assume PackedStringArray.__default.psaSubSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeq(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.psaSubSeq(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0));
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume read($Heap, this, PackedStringArray.DynamicPsa.offsets)
       == read(old($Heap), this, PackedStringArray.DynamicPsa.offsets);
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume read($Heap, this, PackedStringArray.DynamicPsa.data)
       == read(old($Heap), this, PackedStringArray.DynamicPsa.data);
    assert $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), old($Heap));
    assume Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
}



procedure Call$$PackedStringArray.DynamicPsa.Prefix(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    newlen#0: int where LitInt(0) <= newlen#0 && newlen#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires newlen#0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaSubSeq(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaSubSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaSubSeq(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.offsets)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.offsets);
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.data)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.data);
  free ensures true;
  ensures Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
    read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.Prefix(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    newlen#0: int where LitInt(0) <= newlen#0 && newlen#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 44 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  requires newlen#0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaSubSeq(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall(old($Heap), this)
     && PackedStringArray.__default.psaSubSeq#canCall(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaSubSeq(PackedStringArray.DynamicPsa.toPsa(old($Heap), this), LitInt(0), newlen#0));
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.offsets)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.offsets);
  free ensures true;
  ensures read($Heap, this, PackedStringArray.DynamicPsa.data)
     == read(old($Heap), this, PackedStringArray.DynamicPsa.data);
  free ensures true;
  ensures Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
    read(old($Heap), this, PackedStringArray.DynamicPsa.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.Prefix(this: ref, newlen#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var run##0: Seq Box;
  var i##0: int;
  var j##0: int;
  var newtype$check#1: int;
  var run##0_0: Seq Box;
  var i##0_0: int;
  var j##0_0: int;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;

    // AddMethodImpl: Prefix, Impl$$PackedStringArray.DynamicPsa.Prefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == this);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1020,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1021,37)
    // TrCallStmt: Before ProcessCallStmt
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
      read($Heap, this, PackedStringArray.DynamicPsa.nstrings));
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    j##0 := newlen#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Uint32__Order.__default.SortedSubsequence(run##0, i##0, j##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1021,75)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1022,7)
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assert {:subsumption 0} 0 <= newlen#0
       && newlen#0
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assert {:subsumption 0} 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} 0 <= newlen#0
       && newlen#0
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume true;
    assert Seq#Equal(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        newlen#0), 
      Seq#Take(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
        newlen#0));
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1023,7)
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    if (0 < newlen#0)
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1024,40)
        // TrCallStmt: Before ProcessCallStmt
        assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
        assert 0 <= read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
        assume true;
        // ProcessCallStmt: CheckSubrange
        run##0_0 := Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings));
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##0_0 := newlen#0 - 1;
        assume true;
        // ProcessCallStmt: CheckSubrange
        j##0_0 := read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$Uint32__Order.__default.IsSortedImpliesLte(run##0_0, i##0_0, j##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1024,100)"} true;
    }
    else
    {
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1026,16)
    assume true;
    assert $_Frame[this, PackedStringArray.DynamicPsa.nstrings];
    assume true;
    $rhs#0 := newlen#0;
    $Heap := update($Heap, this, PackedStringArray.DynamicPsa.nstrings, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1026,24)"} true;
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.PreSized(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    num_strings#0: int
       where LitInt(0) <= num_strings#0 && num_strings#0 < 4294967296, 
    total_len#0: int where LitInt(0) <= total_len#0 && total_len#0 < 4294967296);
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.PreSized(this: ref, num_strings#0: int, total_len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: PreSized, CheckWellformed$$PackedStringArray.DynamicPsa.PreSized
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1029,16): initial state"} true;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1030,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assume _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       == num_strings#0;
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    assume _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       == total_len#0;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.EmptyPsa());
    assume (forall $o: ref :: 
      { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
      read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$PackedStringArray.DynamicPsa.PreSized(num_strings#0: int
       where LitInt(0) <= num_strings#0 && num_strings#0 < 4294967296, 
    total_len#0: int where LitInt(0) <= total_len#0 && total_len#0 < 4294967296)
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == num_strings#0;
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == total_len#0;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(Lit(PackedStringArray.__default.EmptyPsa()))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.EmptyPsa#canCall();
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.EmptyPsa());
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.PreSized(num_strings#0: int
       where LitInt(0) <= num_strings#0 && num_strings#0 < 4294967296, 
    total_len#0: int where LitInt(0) <= total_len#0 && total_len#0 < 4294967296)
   returns (this: ref where this != null && $Is(this, Tclass.PackedStringArray.DynamicPsa()), 
    $_reverifyPost: bool);
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == num_strings#0;
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == total_len#0;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(Lit(PackedStringArray.__default.EmptyPsa()))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.EmptyPsa#canCall();
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.EmptyPsa());
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.PreSized(num_strings#0: int, total_len#0: int) returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.nstrings: int;
  var this.offsets: ref;
  var this.data: ref;
  var this.Repr: Set Box;
  var newtype$check#0: int;
  var $nw: ref;

    // AddMethodImpl: PreSized, Impl$$PackedStringArray.DynamicPsa.PreSized
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1035,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1035,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1036,16)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    this.nstrings := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1036,19)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1037,15)
    assume true;
    assert 0 <= num_strings#0;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.uint32());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == num_strings#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    this.offsets := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1037,40)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1038,12)
    assume true;
    assert 0 <= total_len#0;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.byte());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == total_len#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    this.data := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1038,33)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1039,12)
    assume true;
    assume true;
    this.Repr := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), $Box(this.offsets)), 
      $Box(this.data));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1039,35)"} true;
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1035,5)
    assume !read($Heap, this, alloc);
    assume read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == this.nstrings;
    assume read($Heap, this, PackedStringArray.DynamicPsa.offsets) == this.offsets;
    assume read($Heap, this, PackedStringArray.DynamicPsa.data) == this.data;
    assume read($Heap, this, PackedStringArray.DynamicPsa.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1035,5)
}



procedure CheckWellformed$$PackedStringArray.DynamicPsa.FromSeq(this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap), 
    strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 48 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.DynamicPsa.FromSeq(this: ref, strs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var ##strs#1: Seq Box;
  var ##psa#1: DatatypeType;
  var ##strs#2: Seq Box;

    // AddMethodImpl: FromSeq, CheckWellformed$$PackedStringArray.DynamicPsa.FromSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1042,16): initial state"} true;
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#0 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1044,16): post-state"} true;
    assume PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assert read($Heap, this, PackedStringArray.DynamicPsa.offsets) != null;
    assume _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       == Seq#Length(strs#0);
    assert read($Heap, this, PackedStringArray.DynamicPsa.data) != null;
    ##strs#1 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#1)
         || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
             + Seq#Length(##strs#1)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#1)
         || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#1))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#1);
    assume PackedStringArray.__default.psaFromSeq#canCall(strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaFromSeq(strs#0));
    ##psa#1 := PackedStringArray.__default.psaFromSeq(strs#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaFromSeq(strs#0));
    assume _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaFromSeq(strs#0));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
       ==> PackedStringArray.DynamicPsa.WF($Heap, this)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, this);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, this));
    ##strs#2 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#2)
       ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#2)
         || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
             + Seq#Length(##strs#2)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#2)
       ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#2)
         || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#2))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), ##strs#2);
    assume PackedStringArray.__default.psaFromSeq#canCall(strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaFromSeq(strs#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
      PackedStringArray.__default.psaFromSeq(strs#0));
    assume (forall $o: ref :: 
      { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
      read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$PackedStringArray.DynamicPsa.FromSeq(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.PackedStringArray.DynamicPsa())
         && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
       || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Seq#Length(strs#0)
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
       || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs#0))
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     && 
    PackedStringArray.DynamicPsa.WF($Heap, this)
     && 
    Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
        $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
       < NativeTypes.__default.Uint64UpperBound()
     && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
       < 4294967296
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         < 4294967296)
     && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
       ==> $Unbox(read($Heap, 
            read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
            IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
        read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == Seq#Length(strs#0);
  free ensures PackedStringArray.__default.psaFromSeq#canCall(strs#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaFromSeq(strs#0));
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaFromSeq(strs#0));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaFromSeq(strs#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.psaFromSeq#canCall(strs#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaFromSeq(strs#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.DynamicPsa.FromSeq(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (this: ref where this != null && $Is(this, Tclass.PackedStringArray.DynamicPsa()), 
    $_reverifyPost: bool);
  free requires 48 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && 
    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Seq#Length(strs#0)
       < 4294967296
     && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
          $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
         < NativeTypes.__default.Uint64UpperBound();
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
         < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           < 4294967296);
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
         ==> $Unbox(read($Heap, 
              read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
              IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
           <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)));
  ensures PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
     ==> PackedStringArray.DynamicPsa.WF($Heap, this)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
          read($Heap, this, PackedStringArray.DynamicPsa.nstrings)));
  free ensures true;
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
     == Seq#Length(strs#0);
  free ensures PackedStringArray.__default.psaFromSeq#canCall(strs#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaFromSeq(strs#0));
  ensures _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
     == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaFromSeq(strs#0));
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.DynamicPsa.toPsa($Heap, this))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaFromSeq(strs#0))
     && 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
     && PackedStringArray.__default.psaFromSeq#canCall(strs#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.DynamicPsa.toPsa($Heap, this), 
    PackedStringArray.__default.psaFromSeq(strs#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)] } 
    read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.DynamicPsa.FromSeq(strs#0: Seq Box) returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.nstrings: int;
  var this.offsets: ref;
  var this.data: ref;
  var this.Repr: Set Box;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var $nw: ref;
  var total_len#0: int
     where LitInt(0) <= total_len#0 && total_len#0 < 18446744073709551616;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var strs##0: Seq Box;
  var strs##1: Seq Box;

    // AddMethodImpl: FromSeq, Impl$$PackedStringArray.DynamicPsa.FromSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1049,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1049,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1050,16)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    this.nstrings := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1050,19)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1051,15)
    assume true;
    newtype$check#1 := Seq#Length(strs#0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assert 0 <= Seq#Length(strs#0);
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.uint32());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == Seq#Length(strs#0);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    this.offsets := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1051,45)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1052,41)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    strs##0 := strs#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$PackedStringArray.__default.psaSeqTotalLength(strs##0);
    // TrCallStmt: After ProcessCallStmt
    total_len#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1052,46)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1053,12)
    assume true;
    assert 0 <= total_len#0;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.byte());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == total_len#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    this.data := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1053,33)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1054,12)
    assume true;
    assume true;
    this.Repr := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), $Box(this.offsets)), 
      $Box(this.data));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1054,35)"} true;
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1049,5)
    assume !read($Heap, this, alloc);
    assume read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == this.nstrings;
    assume read($Heap, this, PackedStringArray.DynamicPsa.offsets) == this.offsets;
    assume read($Heap, this, PackedStringArray.DynamicPsa.data) == this.data;
    assume read($Heap, this, PackedStringArray.DynamicPsa.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1049,5)
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1056,16)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assume true;
    // ProcessCallStmt: CheckSubrange
    strs##1 := strs#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this || read($Heap, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.DynamicPsa.appendSeq(this, strs##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1056,21)"} true;
}



// PackedStringArray.DynamicPsa: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.PackedStringArray.DynamicPsa()) } 
  $Is(c#0, Tclass.PackedStringArray.DynamicPsa())
     <==> $Is(c#0, Tclass.PackedStringArray.DynamicPsa?()) && c#0 != null);

// PackedStringArray.DynamicPsa: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa(), $h) } 
  $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa(), $h)
     <==> $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa?(), $h));

const unique class.PackedStringArray.__default: ClassName;

function Tclass.PackedStringArray.__default() : Ty;

// Tclass.PackedStringArray.__default Tag
axiom Tag(Tclass.PackedStringArray.__default())
   == Tagclass.PackedStringArray.__default;

const unique Tagclass.PackedStringArray.__default: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.__default()) } 
  $IsBox(bx, Tclass.PackedStringArray.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArray.__default()) } 
  $Is($o, Tclass.PackedStringArray.__default())
     <==> $o == null || dtype($o) == Tclass.PackedStringArray.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArray.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArray.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedStringArray._default.WF
function PackedStringArray.__default.WF(psa#0: DatatypeType) : bool;

function PackedStringArray.__default.WF#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.WF
axiom 4 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.WF(psa#0) } 
    PackedStringArray.__default.WF#canCall(psa#0)
         || (4 != $FunctionContextHeight && $Is(psa#0, Tclass.PackedStringArray.Psa()))
       ==> true);

function PackedStringArray.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.WF
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.WF#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.WF#requires(psa#0) == true);

// definition axiom for PackedStringArray.__default.WF(revealed)
axiom 4 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.WF(psa#0) } 
    PackedStringArray.__default.WF#canCall(psa#0)
         || (4 != $FunctionContextHeight && $Is(psa#0, Tclass.PackedStringArray.Psa()))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(psa#0)))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(psa#0))
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> PackedStringArray.Psa.Psa_q(psa#0)
                 && 
                PackedStringArray.Psa.Psa_q(psa#0)
                 && PackedStringArray.Psa.Psa_q(psa#0)))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> PackedStringArray.Psa.Psa_q(psa#0)
                 && 
                PackedStringArray.Psa.Psa_q(psa#0)
                 && PackedStringArray.Psa.Psa_q(psa#0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && Uint32__Order.__default.IsSorted#canCall(PackedStringArray.Psa.offsets(psa#0)))
         && PackedStringArray.__default.WF(psa#0)
           == (
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.WF for all literals(revealed)
axiom 4 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.WF(Lit(psa#0)) } 
    PackedStringArray.__default.WF#canCall(Lit(psa#0))
         || (4 != $FunctionContextHeight && $Is(psa#0, Tclass.PackedStringArray.Psa()))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) == LitInt(0))
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && 
                PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && PackedStringArray.Psa.Psa_q(Lit(psa#0))))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && 
                PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && PackedStringArray.Psa.Psa_q(Lit(psa#0)))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 == $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), 
                    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)): int)
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && Uint32__Order.__default.IsSorted#canCall(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedStringArray.__default.WF(Lit(psa#0))
           == (
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) < 4294967296
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) == LitInt(0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 == $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), 
                    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

procedure CheckWellformed$$PackedStringArray.__default.WF(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.WF(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##run#0: Seq Box;
  var b$reqreads#0: bool;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function WF
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(20,12): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296)
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
        }

        if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
           && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296)
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
            if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0))
            {
                assume PackedStringArray.Psa.Psa_q(psa#0);
            }
        }

        if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
           && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
           && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0)))
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
            if (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
            {
                assume PackedStringArray.Psa.Psa_q(psa#0);
                assume PackedStringArray.Psa.Psa_q(psa#0);
                assume PackedStringArray.Psa.Psa_q(psa#0);
                assert 0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1
                   && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1
                     < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
            }
        }

        if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
           && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
           && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
             ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
           && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                  Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int))
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
            ##run#0 := PackedStringArray.Psa.offsets(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Uint32__Order.__default.IsSorted#canCall(PackedStringArray.Psa.offsets(psa#0));
        }

        assume PackedStringArray.__default.WF(psa#0)
           == (
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0)));
        assume PackedStringArray.Psa.Psa_q(psa#0)
           && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
             ==> PackedStringArray.Psa.Psa_q(psa#0))
           && (PackedStringArray.Psa.Psa_q(psa#0)
               && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
             ==> PackedStringArray.Psa.Psa_q(psa#0)
               && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
                 ==> PackedStringArray.Psa.Psa_q(psa#0)))
           && (PackedStringArray.Psa.Psa_q(psa#0)
               && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
                 ==> PackedStringArray.Psa.Psa_q(psa#0))
               && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
                 ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
             ==> PackedStringArray.Psa.Psa_q(psa#0)
               && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
                 ==> PackedStringArray.Psa.Psa_q(psa#0)
                   && 
                  PackedStringArray.Psa.Psa_q(psa#0)
                   && PackedStringArray.Psa.Psa_q(psa#0)))
           && (PackedStringArray.Psa.Psa_q(psa#0)
               && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
                 ==> PackedStringArray.Psa.Psa_q(psa#0)
                   && 
                  PackedStringArray.Psa.Psa_q(psa#0)
                   && PackedStringArray.Psa.Psa_q(psa#0))
               && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
                 ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                   == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                      Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
             ==> PackedStringArray.Psa.Psa_q(psa#0)
               && Uint32__Order.__default.IsSorted#canCall(PackedStringArray.Psa.offsets(psa#0)));
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.WF(psa#0), TBool);
        assert b$reqreads#0;
    }
}



// function declaration for PackedStringArray._default.psaNumStrings
function PackedStringArray.__default.psaNumStrings(psa#0: DatatypeType) : int;

function PackedStringArray.__default.psaNumStrings#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaNumStrings
axiom 37 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaNumStrings(psa#0) } 
    PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         || (37 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> LitInt(0) <= PackedStringArray.__default.psaNumStrings(psa#0)
         && PackedStringArray.__default.psaNumStrings(psa#0) < 18446744073709551616);

function PackedStringArray.__default.psaNumStrings#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaNumStrings
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaNumStrings#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaNumStrings#requires(psa#0)
       == (Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         < NativeTypes.__default.Uint64UpperBound()));

// definition axiom for PackedStringArray.__default.psaNumStrings(revealed)
axiom 37 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaNumStrings(psa#0) } 
    PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         || (37 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaNumStrings(psa#0)
           == Seq#Length(PackedStringArray.Psa.offsets(psa#0)));

// definition axiom for PackedStringArray.__default.psaNumStrings for all literals(revealed)
axiom 37 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaNumStrings(Lit(psa#0)) } 
    PackedStringArray.__default.psaNumStrings#canCall(Lit(psa#0))
         || (37 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaNumStrings(Lit(psa#0))
           == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))));

procedure CheckWellformed$$PackedStringArray.__default.psaNumStrings(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaNumStrings(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var newtype$check#0: int;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function psaNumStrings
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(30,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume PackedStringArray.Psa.Psa_q(psa#0);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       < NativeTypes.__default.Uint64UpperBound();
    assert b$reqreads#0;
    if (*)
    {
        assume LitInt(0) <= PackedStringArray.__default.psaNumStrings(psa#0)
           && PackedStringArray.__default.psaNumStrings(psa#0) < 18446744073709551616;
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0));
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume PackedStringArray.__default.psaNumStrings(psa#0)
           == Seq#Length(PackedStringArray.Psa.offsets(psa#0));
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaNumStrings(psa#0), Tclass.NativeTypes.uint64());
    }
}



// function declaration for PackedStringArray._default.psaTotalLength
function PackedStringArray.__default.psaTotalLength(psa#0: DatatypeType) : int;

function PackedStringArray.__default.psaTotalLength#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaTotalLength
axiom 14 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaTotalLength(psa#0) } 
    PackedStringArray.__default.psaTotalLength#canCall(psa#0)
         || (14 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.data(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> LitInt(0) <= PackedStringArray.__default.psaTotalLength(psa#0)
         && PackedStringArray.__default.psaTotalLength(psa#0) < 18446744073709551616);

function PackedStringArray.__default.psaTotalLength#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaTotalLength
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaTotalLength#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaTotalLength#requires(psa#0)
       == (Seq#Length(PackedStringArray.Psa.data(psa#0))
         < NativeTypes.__default.Uint64UpperBound()));

// definition axiom for PackedStringArray.__default.psaTotalLength(revealed)
axiom 14 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaTotalLength(psa#0) } 
    PackedStringArray.__default.psaTotalLength#canCall(psa#0)
         || (14 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.data(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaTotalLength(psa#0)
           == Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.psaTotalLength for all literals(revealed)
axiom 14 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaTotalLength(Lit(psa#0)) } 
    PackedStringArray.__default.psaTotalLength#canCall(Lit(psa#0))
         || (14 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaTotalLength(Lit(psa#0))
           == Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

procedure CheckWellformed$$PackedStringArray.__default.psaTotalLength(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaTotalLength(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var newtype$check#0: int;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function psaTotalLength
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(36,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume PackedStringArray.Psa.Psa_q(psa#0);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(PackedStringArray.Psa.data(psa#0))
       < NativeTypes.__default.Uint64UpperBound();
    assert b$reqreads#0;
    if (*)
    {
        assume LitInt(0) <= PackedStringArray.__default.psaTotalLength(psa#0)
           && PackedStringArray.__default.psaTotalLength(psa#0) < 18446744073709551616;
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#0 := Seq#Length(PackedStringArray.Psa.data(psa#0));
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume PackedStringArray.__default.psaTotalLength(psa#0)
           == Seq#Length(PackedStringArray.Psa.data(psa#0));
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaTotalLength(psa#0), Tclass.NativeTypes.uint64());
    }
}



// function declaration for PackedStringArray._default.psaStart
function PackedStringArray.__default.psaStart(psa#0: DatatypeType, i#0: int) : int;

function PackedStringArray.__default.psaStart#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaStart
axiom 7 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaStart(psa#0, i#0) } 
    PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         || (7 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
         && PackedStringArray.__default.psaStart(psa#0, i#0)
           <= Seq#Length(PackedStringArray.Psa.data(psa#0))
         && 
        LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
         && PackedStringArray.__default.psaStart(psa#0, i#0) < 4294967296);

function PackedStringArray.__default.psaStart#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaStart
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaStart#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaStart#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaStart(revealed)
axiom 7 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaStart(psa#0, i#0) } 
    PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         || (7 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0) ==> PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaStart(psa#0, i#0)
           == (if i#0 == LitInt(0)
             then 0
             else $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0 - 1)): int));

// definition axiom for PackedStringArray.__default.psaStart for all literals(revealed)
axiom 7 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(i#0))
         || (7 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0) ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then 0
             else $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(i#0 - 1))): int));

procedure CheckWellformed$$PackedStringArray.__default.psaStart(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616)
   returns (start#0: int where LitInt(0) <= start#0 && start#0 < 4294967296);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures LitInt(0) <= start#0;
  ensures start#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));



implementation CheckWellformed$$PackedStringArray.__default.psaStart(psa#0: DatatypeType, i#0: int) returns (start#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var run##0: Seq Box;
  var i##0: int;
  var j##0: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function psaStart
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(42,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    if (LitInt(0) <= i#0)
    {
        assume PackedStringArray.Psa.Psa_q(psa#0);
    }

    assume LitInt(0) <= i#0 && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
    assert b$reqreads#0;
    if (*)
    {
        assume LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
           && PackedStringArray.__default.psaStart(psa#0, i#0) < 4294967296;
        if (LitInt(0) <= start#0)
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
        }

        assume LitInt(0) <= start#0 && start#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        if (i#0 == LitInt(0))
        {
            newtype$check#1 := LitInt(0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 4294967296;
            assume PackedStringArray.__default.psaStart(psa#0, i#0) == LitInt(0);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaStart(psa#0, i#0), Tclass.NativeTypes.uint32());
        }
        else
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(48,38)
            // TrCallStmt: Before ProcessCallStmt
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assume PackedStringArray.Psa.Psa_q(psa#0);
            // ProcessCallStmt: CheckSubrange
            run##0 := PackedStringArray.Psa.offsets(psa#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##0 := i#0 - 1;
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assume PackedStringArray.Psa.Psa_q(psa#0);
            // ProcessCallStmt: CheckSubrange
            j##0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1;
            // ProcessCallStmt: Make the call
            call Call$$Uint32__Order.__default.IsSortedImpliesLte(run##0, i##0, j##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(48,83)"} true;
            assume PackedStringArray.Psa.Psa_q(psa#0);
            newtype$check#2 := LitInt(1);
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            newtype$check#3 := i#0 - 1;
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            assert 0 <= i#0 - 1 && i#0 - 1 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
            assume PackedStringArray.__default.psaStart(psa#0, i#0)
               == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0 - 1)): int;
            assume PackedStringArray.Psa.Psa_q(psa#0);
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaStart(psa#0, i#0), Tclass.NativeTypes.uint32());
        }

        assume PackedStringArray.__default.psaStart(psa#0, i#0) == start#0;
    }
}



// function declaration for PackedStringArray._default.psaEnd
function PackedStringArray.__default.psaEnd(psa#0: DatatypeType, i#0: int) : int;

function PackedStringArray.__default.psaEnd#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaEnd
axiom 8 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaEnd(psa#0, i#0) } 
    PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         || (8 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.__default.psaStart(psa#0, i#0)
           <= PackedStringArray.__default.psaEnd(psa#0, i#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0)
           <= Seq#Length(PackedStringArray.Psa.data(psa#0))
         && 
        LitInt(0) <= PackedStringArray.__default.psaEnd(psa#0, i#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0) < 4294967296);

function PackedStringArray.__default.psaEnd#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaEnd
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaEnd#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaEnd#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaEnd(revealed)
axiom 8 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaEnd(psa#0, i#0) } 
    PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         || (8 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0)
           == (var _v0#0 := (if i#0 > 0 then false else false); 
            $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0)): int));

// definition axiom for PackedStringArray.__default.psaEnd for all literals(revealed)
axiom 8 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(i#0))
         || (8 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0))
           == (var _v0#1 := (if i#0 > 0 then false else false); 
            $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(i#0))): int));

procedure CheckWellformed$$PackedStringArray.__default.psaEnd(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616)
   returns (end#0: int where LitInt(0) <= end#0 && end#0 < 4294967296);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.psaStart(psa#0, i#0) <= end#0;
  ensures end#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));



implementation CheckWellformed$$PackedStringArray.__default.psaEnd(psa#0: DatatypeType, i#0: int) returns (end#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var _v0#2: bool;
  var let#0#0#0: bool;
  var newtype$check#0: int;
  var run##0: Seq Box;
  var i##0: int;
  var j##0: int;
  var run##1: Seq Box;
  var i##1: int;
  var j##1: int;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function psaEnd
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(63,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    if (LitInt(0) <= i#0)
    {
        assume PackedStringArray.Psa.Psa_q(psa#0);
    }

    assume LitInt(0) <= i#0 && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
    assert b$reqreads#0;
    if (*)
    {
        assume LitInt(0) <= PackedStringArray.__default.psaEnd(psa#0, i#0)
           && PackedStringArray.__default.psaEnd(psa#0, i#0) < 4294967296;
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.psaStart#canCall(psa#0, i#0);
        if (PackedStringArray.__default.psaStart(psa#0, i#0) <= end#0)
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
        }

        assume PackedStringArray.__default.psaStart(psa#0, i#0) <= end#0
           && end#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        havoc _v0#2;
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        if (i#0 > 0)
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(69,38)
            // TrCallStmt: Before ProcessCallStmt
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assume PackedStringArray.Psa.Psa_q(psa#0);
            // ProcessCallStmt: CheckSubrange
            run##0 := PackedStringArray.Psa.offsets(psa#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##0 := i#0 - 1;
            assume true;
            // ProcessCallStmt: CheckSubrange
            j##0 := i#0;
            // ProcessCallStmt: Make the call
            call Call$$Uint32__Order.__default.IsSortedImpliesLte(run##0, i##0, j##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(69,74)"} true;
            assume let#0#0#0 == Lit(false);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#0#0#0, TBool);
        }
        else
        {
            assume let#0#0#0 == Lit(false);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#0#0#0, TBool);
        }

        assume _v0#2 == let#0#0#0;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(71,36)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // ProcessCallStmt: CheckSubrange
        run##1 := PackedStringArray.Psa.offsets(psa#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##1 := i#0;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // ProcessCallStmt: CheckSubrange
        j##1 := Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1;
        // ProcessCallStmt: Make the call
        call Call$$Uint32__Order.__default.IsSortedImpliesLte(run##1, i##1, j##1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(71,77)"} true;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assert 0 <= i#0 && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
        assume PackedStringArray.__default.psaEnd(psa#0, i#0)
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0)): int;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaEnd(psa#0, i#0), Tclass.NativeTypes.uint32());
        assume PackedStringArray.__default.psaEnd(psa#0, i#0) == end#0;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.psaStartLtePsaEnd(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    j#0: int where LitInt(0) <= j#0 && j#0 < 18446744073709551616);
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaStartLtePsaEnd(psa#0: DatatypeType, i#0: int, j#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var ##psa#2: DatatypeType;
  var ##i#1: int;

    // AddMethodImpl: psaStartLtePsaEnd, CheckWellformed$$PackedStringArray.__default.psaStartLtePsaEnd
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(76,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    if (LitInt(0) <= i#0)
    {
    }

    if (LitInt(0) <= i#0 && i#0 <= j#0)
    {
        assume PackedStringArray.Psa.Psa_q(psa#0);
    }

    assume LitInt(0) <= i#0
       && i#0 <= j#0
       && j#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(79,29): post-state"} true;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##i#0 := i#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
    assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.psaStart#canCall(psa#0, i#0);
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##i#1 := j#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assert {:subsumption 0} LitInt(0) <= ##i#1;
    assert {:subsumption 0} ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
    assume LitInt(0) <= ##i#1 && ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.psaEnd#canCall(psa#0, j#0);
    assume PackedStringArray.__default.psaStart(psa#0, i#0)
       <= PackedStringArray.__default.psaEnd(psa#0, j#0);
}



procedure Call$$PackedStringArray.__default.psaStartLtePsaEnd(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    j#0: int where LitInt(0) <= j#0 && j#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
     && PackedStringArray.__default.psaEnd#canCall(psa#0, j#0);
  ensures PackedStringArray.__default.psaStart(psa#0, i#0)
     <= PackedStringArray.__default.psaEnd(psa#0, j#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.psaStartLtePsaEnd(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    j#0: int where LitInt(0) <= j#0 && j#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 38 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
     && PackedStringArray.__default.psaEnd#canCall(psa#0, j#0);
  ensures PackedStringArray.__default.psaStart(psa#0, i#0)
     <= PackedStringArray.__default.psaEnd(psa#0, j#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.psaStartLtePsaEnd(psa#0: DatatypeType, i#0: int, j#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var run##0: Seq Box;
  var i##0: int;
  var j##0: int;

    // AddMethodImpl: psaStartLtePsaEnd, Impl$$PackedStringArray.__default.psaStartLtePsaEnd
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(80,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(81,5)
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    if (i#0 == LitInt(0))
    {
    }
    else
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(83,38)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // ProcessCallStmt: CheckSubrange
        run##0 := PackedStringArray.Psa.offsets(psa#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##0 := i#0 - 1;
        assume true;
        // ProcessCallStmt: CheckSubrange
        j##0 := j#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$Uint32__Order.__default.IsSortedImpliesLte(run##0, i##0, j##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(83,74)"} true;
    }
}



// function declaration for PackedStringArray._default.psaElement
function PackedStringArray.__default.psaElement(psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedStringArray.__default.psaElement#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaElement
axiom 9 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaElement(psa#0, i#0) } 
    PackedStringArray.__default.psaElement#canCall(psa#0, i#0)
         || (9 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> $Is(PackedStringArray.__default.psaElement(psa#0, i#0), 
        TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.psaElement#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaElement
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaElement#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaElement#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaElement(revealed)
axiom 9 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaElement(psa#0, i#0) } 
    PackedStringArray.__default.psaElement#canCall(psa#0, i#0)
         || (9 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         && PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         && PackedStringArray.__default.psaElement(psa#0, i#0)
           == Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), 
              PackedStringArray.__default.psaEnd(psa#0, i#0)), 
            PackedStringArray.__default.psaStart(psa#0, i#0)));

// definition axiom for PackedStringArray.__default.psaElement for all literals(revealed)
axiom 9 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0))
         || (9 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(i#0))
         && PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(i#0))
         && PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0))
           == Lit(Seq#Drop(Seq#Take(Lit(PackedStringArray.Psa.data(Lit(psa#0))), 
                LitInt(PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0)))), 
              LitInt(PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0))))));

procedure CheckWellformed$$PackedStringArray.__default.psaElement(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaElement(psa#0: DatatypeType, i#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var ##psa#2: DatatypeType;
  var ##i#1: int;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function psaElement
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(87,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    if (LitInt(0) <= i#0)
    {
        assume PackedStringArray.Psa.Psa_q(psa#0);
    }

    assume LitInt(0) <= i#0 && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0));
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaElement(psa#0, i#0), 
          TSeq(Tclass.NativeTypes.byte()));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaStart#canCall(psa#0, i#0);
        assert 0 <= PackedStringArray.__default.psaStart(psa#0, i#0)
           && PackedStringArray.__default.psaStart(psa#0, i#0)
             <= Seq#Length(PackedStringArray.Psa.data(psa#0));
        ##psa#2 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#1 := i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assert {:subsumption 0} LitInt(0) <= ##i#1;
        assert {:subsumption 0} ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
        assume LitInt(0) <= ##i#1 && ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaEnd#canCall(psa#0, i#0);
        assert PackedStringArray.__default.psaStart(psa#0, i#0)
             <= PackedStringArray.__default.psaEnd(psa#0, i#0)
           && PackedStringArray.__default.psaEnd(psa#0, i#0)
             <= Seq#Length(PackedStringArray.Psa.data(psa#0));
        assume PackedStringArray.__default.psaElement(psa#0, i#0)
           == Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), 
              PackedStringArray.__default.psaEnd(psa#0, i#0)), 
            PackedStringArray.__default.psaStart(psa#0, i#0));
        assume PackedStringArray.Psa.Psa_q(psa#0)
           && PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
           && PackedStringArray.__default.psaEnd#canCall(psa#0, i#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaElement(psa#0, i#0), 
          TSeq(Tclass.NativeTypes.byte()));
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



// function declaration for PackedStringArray._default.psaSeq
function PackedStringArray.__default.psaSeq($ly: LayerType, psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedStringArray.__default.psaSeq#canCall(psa#0: DatatypeType, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0) } 
  PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0)
     == PackedStringArray.__default.psaSeq($ly, psa#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq(AsFuelBottom($ly), psa#0, i#0) } 
  PackedStringArray.__default.psaSeq($ly, psa#0, i#0)
     == PackedStringArray.__default.psaSeq($LZ, psa#0, i#0));

// consequence axiom for PackedStringArray.__default.psaSeq
axiom 10 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaSeq($ly, psa#0, i#0) } 
    PackedStringArray.__default.psaSeq#canCall(psa#0, i#0)
         || (10 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> Seq#Length(PackedStringArray.__default.psaSeq($ly, psa#0, i#0)) == i#0
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), j#0)): Seq Box } 
          LitInt(0) <= j#0 && j#0 < i#0
             ==> Seq#Equal($Unbox(Seq#Index(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), j#0)): Seq Box, 
              PackedStringArray.__default.psaElement(psa#0, j#0)))
         && $Is(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function PackedStringArray.__default.psaSeq#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSeq
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq#requires($ly, psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaSeq#requires($ly, psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaSeq(revealed)
axiom 10 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0) } 
    PackedStringArray.__default.psaSeq#canCall(psa#0, i#0)
         || (10 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0)
           ==> PackedStringArray.__default.psaSeq#canCall(psa#0, i#0 - 1)
             && PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1))
         && PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.psaSeq($ly, psa#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(PackedStringArray.__default.psaElement(psa#0, i#0 - 1))))));

// definition axiom for PackedStringArray.__default.psaSeq for all literals(revealed)
axiom 10 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), LitInt(i#0))
         || (10 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0)
           ==> PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0 - 1)))
         && PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1))))))));

procedure {:opaque} CheckWellformed$$PackedStringArray.__default.psaSeq(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), i#0: int)
   returns (res#0: Seq Box where $Is(res#0, TSeq(TSeq(Tclass.NativeTypes.byte()))));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures Seq#Length(res#0) == i#0;
  ensures (forall j#1: int :: 
    { $Unbox(Seq#Index(res#0, j#1)): Seq Box } 
    LitInt(0) <= j#1 && j#1 < i#0
       ==> Seq#Equal($Unbox(Seq#Index(res#0, j#1)): Seq Box, 
        PackedStringArray.__default.psaElement(psa#0, j#1)));



implementation {:opaque} CheckWellformed$$PackedStringArray.__default.psaSeq(psa#0: DatatypeType, i#0: int) returns (res#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var j#2: int;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var ##psa#2: DatatypeType;
  var ##i#1: int;
  var newtype$check#1: int;
  var ##psa#3: DatatypeType;
  var ##i#2: int;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function psaSeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(94,21): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    if (LitInt(0) <= i#0)
    {
        assume PackedStringArray.Psa.Psa_q(psa#0);
    }

    assume LitInt(0) <= i#0 && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0));
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte())));
        assume Seq#Length(res#0) == i#0;
        havoc j#2;
        if (*)
        {
            assume LitInt(0) <= j#2;
            assume j#2 < i#0;
            assert 0 <= j#2 && j#2 < Seq#Length(res#0);
            newtype$check#0 := j#2;
            assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
            ##psa#1 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#0 := j#2;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
               ==> PackedStringArray.__default.WF(##psa#1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#1));
            assume PackedStringArray.__default.WF(##psa#1);
            assert {:subsumption 0} LitInt(0) <= ##i#0;
            assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
            assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
            assume PackedStringArray.__default.psaElement#canCall(psa#0, j#2);
            assume Seq#Equal($Unbox(Seq#Index(res#0, j#2)): Seq Box, 
              PackedStringArray.__default.psaElement(psa#0, j#2));
        }
        else
        {
            assume LitInt(0) <= j#2 && j#2 < i#0
               ==> Seq#Equal($Unbox(Seq#Index(res#0, j#2)): Seq Box, 
                PackedStringArray.__default.psaElement(psa#0, j#2));
        }

        assume (forall j#1: int :: 
          { $Unbox(Seq#Index(res#0, j#1)): Seq Box } 
          LitInt(0) <= j#1 && j#1 < i#0
             ==> Seq#Equal($Unbox(Seq#Index(res#0, j#1)): Seq Box, 
              PackedStringArray.__default.psaElement(psa#0, j#1)));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (i#0 == LitInt(0))
        {
            assume PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0)
               == Lit(Seq#Empty(): Seq Box);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0), 
              TSeq(TSeq(Tclass.NativeTypes.byte())));
        }
        else
        {
            ##psa#2 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#1 := i#0 - 1;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#1, TInt, $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#2));
            assume PackedStringArray.__default.WF(##psa#2);
            assert {:subsumption 0} LitInt(0) <= ##i#1;
            assert {:subsumption 0} ##i#1 <= Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
            assume LitInt(0) <= ##i#1
               && ##i#1 <= Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= i#0 || DtRank(##psa#2) < DtRank(psa#0) || ##i#1 == i#0;
            assert DtRank(##psa#2) < DtRank(psa#0)
               || (DtRank(##psa#2) == DtRank(psa#0) && ##i#1 < i#0);
            assume PackedStringArray.__default.psaSeq#canCall(psa#0, i#0 - 1);
            newtype$check#1 := i#0 - 1;
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            ##psa#3 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#2 := i#0 - 1;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#2, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assume PackedStringArray.__default.WF(##psa#3);
            assert {:subsumption 0} LitInt(0) <= ##i#2;
            assert {:subsumption 0} ##i#2 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3));
            assume LitInt(0) <= ##i#2 && ##i#2 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3));
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1);
            assume PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0)
               == Seq#Append(PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0 - 1), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(PackedStringArray.__default.psaElement(psa#0, i#0 - 1))));
            assume PackedStringArray.__default.psaSeq#canCall(psa#0, i#0 - 1)
               && PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1);
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0), 
              TSeq(TSeq(Tclass.NativeTypes.byte())));
        }

        assume PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0)
           == res#0;
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



// function declaration for PackedStringArray._default.I
function PackedStringArray.__default.I(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.I#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.I
axiom 11 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.I(psa#0) } 
    PackedStringArray.__default.I#canCall(psa#0)
         || (11 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> $Is(PackedStringArray.__default.I(psa#0), TSeq(TSeq(Tclass.NativeTypes.byte()))));

function PackedStringArray.__default.I#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.I
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.I#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.I#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.I(revealed)
axiom 11 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.I(psa#0) } 
    PackedStringArray.__default.I#canCall(psa#0)
         || (11 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaSeq#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
         && PackedStringArray.__default.I(psa#0)
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            psa#0, 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.I for all literals(revealed)
axiom 11 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.I(Lit(psa#0)) } 
    PackedStringArray.__default.I#canCall(Lit(psa#0))
         || (11 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedStringArray.__default.I(Lit(psa#0))
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            Lit(psa#0), 
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

procedure CheckWellformed$$PackedStringArray.__default.I(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.I(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function I
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(103,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(PackedStringArray.__default.I(psa#0), TSeq(TSeq(Tclass.NativeTypes.byte())));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0));
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, TInt, $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 <= Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        assume LitInt(0) <= ##i#0
           && ##i#0 <= Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaSeq#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)));
        assume PackedStringArray.__default.I(psa#0)
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            psa#0, 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)));
        assume PackedStringArray.Psa.Psa_q(psa#0)
           && PackedStringArray.__default.psaSeq#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)));
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.I(psa#0), TSeq(TSeq(Tclass.NativeTypes.byte())));
        assert b$reqreads#1;
    }
}



// function declaration for PackedStringArray._default.EmptyPsa
function PackedStringArray.__default.EmptyPsa() : DatatypeType;

function PackedStringArray.__default.EmptyPsa#canCall() : bool;

// consequence axiom for PackedStringArray.__default.EmptyPsa
axiom 12 <= $FunctionContextHeight
   ==> 
  PackedStringArray.__default.EmptyPsa#canCall() || 12 != $FunctionContextHeight
   ==> PackedStringArray.__default.WF(PackedStringArray.__default.EmptyPsa())
     && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.EmptyPsa()), 
      Seq#Empty(): Seq Box)
     && $Is(PackedStringArray.__default.EmptyPsa(), Tclass.PackedStringArray.Psa());

function PackedStringArray.__default.EmptyPsa#requires() : bool;

// #requires axiom for PackedStringArray.__default.EmptyPsa
axiom PackedStringArray.__default.EmptyPsa#requires() == true;

// definition axiom for PackedStringArray.__default.EmptyPsa(revealed)
axiom 12 <= $FunctionContextHeight
   ==> 
  PackedStringArray.__default.EmptyPsa#canCall() || 12 != $FunctionContextHeight
   ==> PackedStringArray.__default.EmptyPsa()
     == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));

// definition axiom for PackedStringArray.__default.EmptyPsa for all literals(revealed)
axiom 12 <= $FunctionContextHeight
   ==> 
  PackedStringArray.__default.EmptyPsa#canCall() || 12 != $FunctionContextHeight
   ==> PackedStringArray.__default.EmptyPsa()
     == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));

procedure CheckWellformed$$PackedStringArray.__default.EmptyPsa()
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 12 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), Seq#Empty(): Seq Box);



implementation CheckWellformed$$PackedStringArray.__default.EmptyPsa() returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##run#0: Seq Box;


    // AddWellformednessCheck for function EmptyPsa
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(109,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    if (*)
    {
        assume $Is(PackedStringArray.__default.EmptyPsa(), Tclass.PackedStringArray.Psa());
        ##psa#0 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
        assume PackedStringArray.__default.WF#canCall(result#0);
        assume PackedStringArray.__default.WF(result#0);
        ##psa#1 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assume PackedStringArray.__default.I#canCall(result#0);
        assume Seq#Equal(PackedStringArray.__default.I(result#0), Seq#Empty(): Seq Box);
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(113,5)
        ##run#0 := Lit(Seq#Empty(): Seq Box);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
        assume Uint32__Order.__default.IsSorted#canCall(Lit(Seq#Empty(): Seq Box));
        assume Uint32__Order.__default.IsSorted#canCall(Lit(Seq#Empty(): Seq Box));
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(113,5)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(113,71)
            // TrCallStmt: Before ProcessCallStmt
            // ProcessCallStmt: Make the call
            call Call$$Uint32__Order.__default.reveal__IsSorted();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(113,72)"} true;
            assert {:subsumption 0} Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, Lit(Seq#Empty(): Seq Box));
            assume false;
        }

        assume Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, Lit(Seq#Empty(): Seq Box));
        assume PackedStringArray.__default.EmptyPsa()
           == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.EmptyPsa(), Tclass.PackedStringArray.Psa());
        assume PackedStringArray.__default.EmptyPsa() == result#0;
    }
}



// function declaration for PackedStringArray._default.SizeOfPsa
function PackedStringArray.__default.SizeOfPsa(psa#0: DatatypeType) : int;

function PackedStringArray.__default.SizeOfPsa#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.SizeOfPsa
axiom 49 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsa(psa#0) } 
    PackedStringArray.__default.SizeOfPsa#canCall(psa#0)
         || (49 != $FunctionContextHeight && $Is(psa#0, Tclass.PackedStringArray.Psa()))
       ==> true);

function PackedStringArray.__default.SizeOfPsa#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.SizeOfPsa
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.SizeOfPsa#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.SizeOfPsa#requires(psa#0) == true);

// definition axiom for PackedStringArray.__default.SizeOfPsa(revealed)
axiom 49 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsa(psa#0) } 
    PackedStringArray.__default.SizeOfPsa#canCall(psa#0)
         || (49 != $FunctionContextHeight && $Is(psa#0, Tclass.PackedStringArray.Psa()))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.SizeOfPsa(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.SizeOfPsa for all literals(revealed)
axiom 49 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.SizeOfPsa(Lit(psa#0)) } 
    PackedStringArray.__default.SizeOfPsa#canCall(Lit(psa#0))
         || (49 != $FunctionContextHeight && $Is(psa#0, Tclass.PackedStringArray.Psa()))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.SizeOfPsa(Lit(psa#0))
           == 4
             + Mul(LitInt(4), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

procedure CheckWellformed$$PackedStringArray.__default.SizeOfPsa(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for PackedStringArray._default.SizeOfPsaUint64
function PackedStringArray.__default.SizeOfPsaUint64(psa#0: DatatypeType) : int;

function PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.SizeOfPsaUint64
axiom 50 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsaUint64(psa#0) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0)
         || (50 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> LitInt(0) <= PackedStringArray.__default.SizeOfPsaUint64(psa#0)
         && PackedStringArray.__default.SizeOfPsaUint64(psa#0) < 18446744073709551616);

function PackedStringArray.__default.SizeOfPsaUint64#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.SizeOfPsaUint64
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.SizeOfPsaUint64#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.SizeOfPsaUint64#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.SizeOfPsaUint64(revealed)
axiom 50 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsaUint64(psa#0) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0)
         || (50 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.SizeOfPsaUint64(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.SizeOfPsaUint64 for all literals(revealed)
axiom 50 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.SizeOfPsaUint64(Lit(psa#0)) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(psa#0))
         || (50 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.SizeOfPsaUint64(Lit(psa#0))
           == 4
             + Mul(LitInt(4), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

procedure CheckWellformed$$PackedStringArray.__default.SizeOfPsaUint64(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 50 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.SizeOfPsaUint64(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function SizeOfPsaUint64
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(122,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    assert b$reqreads#0;
    if (*)
    {
        assume LitInt(0) <= PackedStringArray.__default.SizeOfPsaUint64(psa#0)
           && PackedStringArray.__default.SizeOfPsaUint64(psa#0) < 18446744073709551616;
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        newtype$check#0 := LitInt(4);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        newtype$check#1 := LitInt(4);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#2 := Seq#Length(PackedStringArray.Psa.offsets(psa#0));
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)));
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := 4 + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)));
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#5 := Seq#Length(PackedStringArray.Psa.data(psa#0));
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        newtype$check#6 := 4
           + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
           + Seq#Length(PackedStringArray.Psa.data(psa#0));
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        assume PackedStringArray.__default.SizeOfPsaUint64(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0));
        assume PackedStringArray.Psa.Psa_q(psa#0) && PackedStringArray.Psa.Psa_q(psa#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.SizeOfPsaUint64(psa#0), Tclass.NativeTypes.uint64());
    }
}



procedure CheckWellformed$$PackedStringArray.__default.CheckIsSorted(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.uint32()), $Heap))
   returns (b#0: bool);
  free requires 51 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedStringArray.__default.CheckIsSorted(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.uint32()), $Heap))
   returns (b#0: bool);
  // user-defined preconditions
  requires Seq#Length(s#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Uint32__Order.__default.IsSorted#canCall(s#0);
  ensures b#0
     == Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, s#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.CheckIsSorted(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(s#0, TSeq(Tclass.NativeTypes.uint32()), $Heap))
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 51 == $FunctionContextHeight;
  // user-defined preconditions
  requires Seq#Length(s#0) < 18446744073709551616;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Uint32__Order.__default.IsSorted#canCall(s#0);
  ensures b#0
     == Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, s#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.CheckIsSorted(s#0: Seq Box) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616;
  var newtype$check#0: int;
  var ##run#0_0: Seq Box;
  var ##run#1_0: Seq Box;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##run#1: Seq Box;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $decr$loop#00: int;
  var newtype$check#2_0: int;
  var newtype$check#2_1: int;
  var ##run#2_0_0: Seq Box;
  var run##2_0: Seq Box;
  var key##2_0: int;
  var newtype$check#2_2: int;
  var newtype$check#2_3: int;
  var newtype$check#2_4: int;
  var newtype$check#2_5: int;

    // AddMethodImpl: CheckIsSorted, Impl$$PackedStringArray.__default.CheckIsSorted
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(131,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(132,19)
    assume true;
    newtype$check#0 := LitInt(1);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    i#0 := LitInt(1);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(132,22)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(133,5)
    assume true;
    if (Seq#Length(s#0) < 2)
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(134,7)
        ##run#0_0 := s#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0_0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
        assume Uint32__Order.__default.IsSorted#canCall(s#0);
        assume Uint32__Order.__default.IsSorted#canCall(s#0);
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(134,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(134,72)
            // TrCallStmt: Before ProcessCallStmt
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Uint32__Order.__default.reveal__IsSorted();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(134,73)"} true;
            assert {:subsumption 0} Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, s#0);
            assume false;
        }

        assume Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, s#0);
        // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(135,7)
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(135,7)
        assume true;
        assume true;
        b#0 := Lit(true);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(135,17)"} true;
        return;
    }
    else
    {
    }

    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(137,5)
    assume true;
    if (0 < Seq#Length(s#0))
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(138,7)
        assert {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
        ##run#1_0 := Seq#Take(s#0, LitInt(1));
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#1_0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
        assume Uint32__Order.__default.IsSorted#canCall(Seq#Take(s#0, LitInt(1)));
        assume Uint32__Order.__default.IsSorted#canCall(Seq#Take(s#0, LitInt(1)));
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(138,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(138,77)
            // TrCallStmt: Before ProcessCallStmt
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Uint32__Order.__default.reveal__IsSorted();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(138,78)"} true;
            assert {:subsumption 0} Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, Seq#Take(s#0, LitInt(1)));
            assume false;
        }

        assume Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, Seq#Take(s#0, LitInt(1)));
    }
    else
    {
    }

    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(140,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(s#0) - i#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#0 <= Seq#Length(s#0);
      free invariant $w$loop#0 ==> Uint32__Order.__default.IsSorted#canCall(Seq#Take(s#0, i#0));
      invariant $w$loop#0
         ==> Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, Seq#Take(s#0, i#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(s#0) - i#0 <= $decr_init$loop#00
         && (Seq#Length(s#0) - i#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(140,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume i#0 <= Seq#Length(s#0);
            assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
            ##run#1 := Seq#Take(s#0, i#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            assume Uint32__Order.__default.IsSorted#canCall(Seq#Take(s#0, i#0));
            assume Uint32__Order.__default.IsSorted#canCall(Seq#Take(s#0, i#0));
            assume Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Seq#Take(s#0, i#0));
            newtype$check#1 := Seq#Length(s#0);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#2 := Seq#Length(s#0);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assume true;
        if (Seq#Length(s#0) <= i#0)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(s#0) - i#0;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(144,7)
        newtype$check#2_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#2_0 && newtype$check#2_0 < 18446744073709551616;
        newtype$check#2_1 := i#0 - 1;
        assert LitInt(0) <= newtype$check#2_1 && newtype$check#2_1 < 18446744073709551616;
        assert 0 <= i#0 - 1 && i#0 - 1 < Seq#Length(s#0);
        assert 0 <= i#0 && i#0 < Seq#Length(s#0);
        assume true;
        if ($Unbox(Seq#Index(s#0, i#0 - 1)): int > $Unbox(Seq#Index(s#0, i#0)): int)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(145,9)
            ##run#2_0_0 := s#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#2_0_0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            assume Uint32__Order.__default.IsSorted#canCall(s#0);
            assume Uint32__Order.__default.IsSorted#canCall(s#0);
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(145,9)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(145,75)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Uint32__Order.__default.reveal__IsSorted();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(145,76)"} true;
                assert {:subsumption 0} !Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, s#0);
                assume false;
            }

            assume !Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, s#0);
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(146,9)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(146,9)
            assume true;
            assume true;
            b#0 := Lit(false);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(146,20)"} true;
            return;
        }
        else
        {
        }

        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(148,33)
        // TrCallStmt: Before ProcessCallStmt
        assert 0 <= i#0 && i#0 <= Seq#Length(s#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        run##2_0 := Seq#Take(s#0, i#0);
        assert 0 <= i#0 && i#0 < Seq#Length(s#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##2_0 := $Unbox(Seq#Index(s#0, i#0)): int;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$Uint32__Order.__default.SortedAugment(run##2_0, key##2_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(148,46)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(149,7)
        newtype$check#2_2 := LitInt(1);
        assert LitInt(0) <= newtype$check#2_2 && newtype$check#2_2 < 18446744073709551616;
        newtype$check#2_3 := i#0 + 1;
        assert LitInt(0) <= newtype$check#2_3 && newtype$check#2_3 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(s#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(s#0);
        assume true;
        assert Seq#Equal(Seq#Take(s#0, i#0 + 1), 
          Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, Seq#Index(s#0, i#0))));
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(150,9)
        assume true;
        newtype$check#2_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#2_4 && newtype$check#2_4 < 18446744073709551616;
        newtype$check#2_5 := i#0 + 1;
        assert LitInt(0) <= newtype$check#2_5 && newtype$check#2_5 < 18446744073709551616;
        assume true;
        i#0 := i#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(150,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(140,5)
        assert 0 <= $decr$loop#00 || Seq#Length(s#0) - i#0 == $decr$loop#00;
        assert Seq#Length(s#0) - i#0 < $decr$loop#00;
        assume true;
        assume Uint32__Order.__default.IsSorted#canCall(Seq#Take(s#0, i#0));
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(152,5)
    assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume true;
    assert Seq#Equal(s#0, Seq#Take(s#0, i#0));
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(153,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(153,5)
    assume true;
    assume true;
    b#0 := Lit(true);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(153,15)"} true;
    return;
}



// function declaration for PackedStringArray._default.FirstElement
function PackedStringArray.__default.FirstElement(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.FirstElement#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.FirstElement
axiom 52 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.FirstElement(psa#0) } 
    PackedStringArray.__default.FirstElement#canCall(psa#0)
         || (52 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> $Is(PackedStringArray.__default.FirstElement(psa#0), TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.FirstElement#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.FirstElement
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.FirstElement#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.FirstElement#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0));

// definition axiom for PackedStringArray.__default.FirstElement(revealed)
axiom 52 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.FirstElement(psa#0) } 
    PackedStringArray.__default.FirstElement#canCall(psa#0)
         || (52 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> PackedStringArray.__default.psaElement#canCall(psa#0, LitInt(0))
         && PackedStringArray.__default.FirstElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, LitInt(0)));

// definition axiom for PackedStringArray.__default.FirstElement for all literals(revealed)
axiom 52 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.FirstElement(Lit(psa#0)) } 
    PackedStringArray.__default.FirstElement#canCall(Lit(psa#0))
         || (52 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) > 0)
       ==> PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(0))
         && PackedStringArray.__default.FirstElement(Lit(psa#0))
           == Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(0))));

procedure CheckWellformed$$PackedStringArray.__default.FirstElement(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 52 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.FirstElement(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function FirstElement
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(156,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    assume PackedStringArray.Psa.Psa_q(psa#0);
    assume Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0;
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(PackedStringArray.__default.FirstElement(psa#0), TSeq(Tclass.NativeTypes.byte()));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := LitInt(0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, LitInt(0));
        assume PackedStringArray.__default.FirstElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, LitInt(0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, LitInt(0));
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.FirstElement(psa#0), TSeq(Tclass.NativeTypes.byte()));
        assert b$reqreads#1;
    }
}



// function declaration for PackedStringArray._default.LastElement
function PackedStringArray.__default.LastElement(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.LastElement#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.LastElement
axiom 53 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.LastElement(psa#0) } 
    PackedStringArray.__default.LastElement#canCall(psa#0)
         || (53 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> $Is(PackedStringArray.__default.LastElement(psa#0), TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.LastElement#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.LastElement
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.LastElement#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.LastElement#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0));

// definition axiom for PackedStringArray.__default.LastElement(revealed)
axiom 53 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.LastElement(psa#0) } 
    PackedStringArray.__default.LastElement#canCall(psa#0)
         || (53 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaElement#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)
         && PackedStringArray.__default.LastElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1));

// definition axiom for PackedStringArray.__default.LastElement for all literals(revealed)
axiom 53 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.LastElement(Lit(psa#0)) } 
    PackedStringArray.__default.LastElement#canCall(Lit(psa#0))
         || (53 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) > 0)
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)
         && PackedStringArray.__default.LastElement(Lit(psa#0))
           == PackedStringArray.__default.psaElement(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1));

procedure CheckWellformed$$PackedStringArray.__default.LastElement(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()));
  free requires 53 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.LastElement(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##psa#1: DatatypeType;
  var ##i#0: int;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function LastElement
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(163,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    assume PackedStringArray.Psa.Psa_q(psa#0);
    assume Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0;
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(PackedStringArray.__default.LastElement(psa#0), TSeq(Tclass.NativeTypes.byte()));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0));
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        newtype$check#1 := LitInt(1);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1;
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1));
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1);
        assume PackedStringArray.__default.LastElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1);
        assume PackedStringArray.Psa.Psa_q(psa#0)
           && PackedStringArray.__default.psaElement#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.LastElement(psa#0), TSeq(Tclass.NativeTypes.byte()));
        assert b$reqreads#1;
    }
}



// function declaration for PackedStringArray._default.subtractConstant
function PackedStringArray.__default.subtractConstant($ly: LayerType, nums#0: Seq Box, subtrahend#0: int) : Seq Box;

function PackedStringArray.__default.subtractConstant#canCall(nums#0: Seq Box, subtrahend#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0) } 
  PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0)
     == PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant(AsFuelBottom($ly), nums#0, subtrahend#0) } 
  PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0)
     == PackedStringArray.__default.subtractConstant($LZ, nums#0, subtrahend#0));

// consequence axiom for PackedStringArray.__default.subtractConstant
axiom 39 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    { PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0) } 
    PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0)
         || (39 != $FunctionContextHeight
           && 
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(nums#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(nums#0)
               ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#0)): int))
       ==> Seq#Length(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0))
           == Seq#Length(nums#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(nums#0, i#1)): int } 
            { $Unbox(Seq#Index(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1
                 < Seq#Length(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0))
             ==> $Unbox(Seq#Index(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), i#1)): int
               == $Unbox(Seq#Index(nums#0, i#1)): int - subtrahend#0)
         && $Is(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function PackedStringArray.__default.subtractConstant#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for PackedStringArray.__default.subtractConstant
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant#requires($ly, nums#0, subtrahend#0) } 
  $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= subtrahend#0
       && subtrahend#0 < 4294967296
     ==> PackedStringArray.__default.subtractConstant#requires($ly, nums#0, subtrahend#0)
       == (forall i#2: int :: 
        { $Unbox(Seq#Index(nums#0, i#2)): int } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(nums#0)
           ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#2)): int));

// definition axiom for PackedStringArray.__default.subtractConstant(revealed)
axiom 39 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    { PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0) } 
    PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0)
         || (39 != $FunctionContextHeight
           && 
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(nums#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(nums#0)
               ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#2)): int))
       ==> (Seq#Length(nums#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), nums#0)
             && PackedStringArray.__default.subtractConstant#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), subtrahend#0)
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), nums#0))
         && PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0)
           == (if Seq#Length(nums#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.subtractConstant($ly, 
                Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), 
                subtrahend#0), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), nums#0)): int
                     - subtrahend#0)))));

// definition axiom for PackedStringArray.__default.subtractConstant for all literals(revealed)
axiom 39 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    {:weight 3} { PackedStringArray.__default.subtractConstant($LS($ly), Lit(nums#0), LitInt(subtrahend#0)) } 
    PackedStringArray.__default.subtractConstant#canCall(Lit(nums#0), LitInt(subtrahend#0))
         || (39 != $FunctionContextHeight
           && 
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(nums#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(nums#0))
               ==> LitInt(subtrahend#0) <= $Unbox(Seq#Index(Lit(nums#0), i#3)): int))
       ==> (Seq#Length(Lit(nums#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(nums#0))
             && PackedStringArray.__default.subtractConstant#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(nums#0))), 
              LitInt(subtrahend#0))
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(nums#0)))
         && PackedStringArray.__default.subtractConstant($LS($ly), Lit(nums#0), LitInt(subtrahend#0))
           == (if Seq#Length(Lit(nums#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.subtractConstant($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(nums#0))), 
                LitInt(subtrahend#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(nums#0))): int
                       - subtrahend#0))))));

procedure CheckWellformed$$PackedStringArray.__default.subtractConstant(nums#0: Seq Box where $Is(nums#0, TSeq(Tclass.NativeTypes.uint32())), 
    subtrahend#0: int where LitInt(0) <= subtrahend#0 && subtrahend#0 < 4294967296)
   returns (result#0: Seq Box where $Is(result#0, TSeq(Tclass.NativeTypes.uint32())));
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures Seq#Length(result#0) == Seq#Length(nums#0);
  ensures (forall i#4: int :: 
    { $Unbox(Seq#Index(nums#0, i#4)): int } 
      { $Unbox(Seq#Index(result#0, i#4)): int } 
    true
       ==> 
      LitInt(0) <= i#4 && i#4 < Seq#Length(result#0)
       ==> $Unbox(Seq#Index(result#0, i#4)): int
         == $Unbox(Seq#Index(nums#0, i#4)): int - subtrahend#0);



implementation CheckWellformed$$PackedStringArray.__default.subtractConstant(nums#0: Seq Box, subtrahend#0: int) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#5: int;
  var i#7: int;
  var newtype$check#0: int;
  var ##run#0: Seq Box;
  var ##nums#0: Seq Box;
  var ##subtrahend#0: int;
  var ##run#1: Seq Box;
  var newtype$check#1: int;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function subtractConstant
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(170,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    havoc i#5;
    if (*)
    {
        assume LitInt(0) <= i#5;
        assume i#5 < Seq#Length(nums#0);
        assert 0 <= i#5 && i#5 < Seq#Length(nums#0);
        assume subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#5)): int;
    }
    else
    {
        assume LitInt(0) <= i#5 && i#5 < Seq#Length(nums#0)
           ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#5)): int;
    }

    assume (forall i#6: int :: 
      { $Unbox(Seq#Index(nums#0, i#6)): int } 
      true
         ==> 
        LitInt(0) <= i#6 && i#6 < Seq#Length(nums#0)
         ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#6)): int);
    if (*)
    {
        assume $Is(PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0), 
          TSeq(Tclass.NativeTypes.uint32()));
        assume Seq#Length(result#0) == Seq#Length(nums#0);
        havoc i#7;
        if (*)
        {
            assume LitInt(0) <= i#7;
            assume i#7 < Seq#Length(result#0);
            assert 0 <= i#7 && i#7 < Seq#Length(result#0);
            assert 0 <= i#7 && i#7 < Seq#Length(nums#0);
            newtype$check#0 := $Unbox(Seq#Index(nums#0, i#7)): int - subtrahend#0;
            assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 4294967296;
            assume $Unbox(Seq#Index(result#0, i#7)): int
               == $Unbox(Seq#Index(nums#0, i#7)): int - subtrahend#0;
        }
        else
        {
            assume LitInt(0) <= i#7 && i#7 < Seq#Length(result#0)
               ==> $Unbox(Seq#Index(result#0, i#7)): int
                 == $Unbox(Seq#Index(nums#0, i#7)): int - subtrahend#0;
        }

        assume (forall i#4: int :: 
          { $Unbox(Seq#Index(nums#0, i#4)): int } 
            { $Unbox(Seq#Index(result#0, i#4)): int } 
          true
             ==> 
            LitInt(0) <= i#4 && i#4 < Seq#Length(result#0)
             ==> $Unbox(Seq#Index(result#0, i#4)): int
               == $Unbox(Seq#Index(nums#0, i#4)): int - subtrahend#0);
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (Seq#Length(nums#0) == LitInt(0))
        {
            assume PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0)
               == Lit(Seq#Empty(): Seq Box);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0), 
              TSeq(Tclass.NativeTypes.uint32()));
        }
        else
        {
            ##run#0 := nums#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Seq#Length(##run#0) > 0;
            b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), nums#0);
            ##nums#0 := Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##nums#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            ##subtrahend#0 := subtrahend#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##subtrahend#0, Tclass.NativeTypes.uint32(), $Heap);
            assert {:subsumption 0} (forall i#8: int :: 
              { $Unbox(Seq#Index(##nums#0, i#8)): int } 
              true
                 ==> 
                LitInt(0) <= i#8 && i#8 < Seq#Length(##nums#0)
                 ==> ##subtrahend#0 <= $Unbox(Seq#Index(##nums#0, i#8)): int);
            assume (forall i#8: int :: 
              { $Unbox(Seq#Index(##nums#0, i#8)): int } 
              true
                 ==> 
                LitInt(0) <= i#8 && i#8 < Seq#Length(##nums#0)
                 ==> ##subtrahend#0 <= $Unbox(Seq#Index(##nums#0, i#8)): int);
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= subtrahend#0
               || Seq#Rank(##nums#0) < Seq#Rank(nums#0)
               || ##subtrahend#0 == subtrahend#0;
            assert Seq#Rank(##nums#0) < Seq#Rank(nums#0)
               || (Seq#Rank(##nums#0) == Seq#Rank(nums#0) && ##subtrahend#0 < subtrahend#0);
            assume PackedStringArray.__default.subtractConstant#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), subtrahend#0);
            ##run#1 := nums#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Seq#Length(##run#1) > 0;
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), nums#0);
            newtype$check#1 := $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), nums#0)): int
               - subtrahend#0;
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 4294967296;
            assume PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0)
               == Seq#Append(PackedStringArray.__default.subtractConstant($LS($LZ), 
                  Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), 
                  subtrahend#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), nums#0)): int
                       - subtrahend#0)));
            assume Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), nums#0)
               && PackedStringArray.__default.subtractConstant#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), subtrahend#0)
               && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), nums#0);
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0), 
              TSeq(Tclass.NativeTypes.uint32()));
        }

        assume PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0)
           == result#0;
        assert b$reqreads#0;
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.SubtractConstant(nums#0: Seq Box
       where $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(nums#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    subtrahend#0: int where LitInt(0) <= subtrahend#0 && subtrahend#0 < 4294967296)
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.uint32()), $Heap));
  free requires 54 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.SubtractConstant(nums#0: Seq Box, subtrahend#0: int) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var ##nums#0: Seq Box;
  var ##subtrahend#0: int;

    // AddMethodImpl: SubtractConstant, CheckWellformed$$PackedStringArray.__default.SubtractConstant
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(181,9): initial state"} true;
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(nums#0);
        assert 0 <= i#0 && i#0 < Seq#Length(nums#0);
        assume subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#0)): int;
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(nums#0)
           ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#0)): int;
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(nums#0, i#1)): int } 
      true
         ==> 
        LitInt(0) <= i#1 && i#1 < Seq#Length(nums#0)
         ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#1)): int);
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(nums#0) < NativeTypes.__default.Uint64UpperBound();
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(184,19): post-state"} true;
    ##nums#0 := nums#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##nums#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
    ##subtrahend#0 := subtrahend#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##subtrahend#0, Tclass.NativeTypes.uint32(), $Heap);
    assert {:subsumption 0} (forall i#2: int :: 
      { $Unbox(Seq#Index(##nums#0, i#2)): int } 
      true
         ==> 
        LitInt(0) <= i#2 && i#2 < Seq#Length(##nums#0)
         ==> ##subtrahend#0 <= $Unbox(Seq#Index(##nums#0, i#2)): int);
    assume (forall i#2: int :: 
      { $Unbox(Seq#Index(##nums#0, i#2)): int } 
      true
         ==> 
        LitInt(0) <= i#2 && i#2 < Seq#Length(##nums#0)
         ==> ##subtrahend#0 <= $Unbox(Seq#Index(##nums#0, i#2)): int);
    assume PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0);
    assume Seq#Equal(result#0, 
      PackedStringArray.__default.subtractConstant($LS($LZ), nums#0, subtrahend#0));
}



procedure Call$$PackedStringArray.__default.SubtractConstant(nums#0: Seq Box
       where $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(nums#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    subtrahend#0: int where LitInt(0) <= subtrahend#0 && subtrahend#0 < 4294967296)
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.uint32()), $Heap));
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(nums#0, i#1)): int } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < Seq#Length(nums#0)
       ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#1)): int);
  requires Seq#Length(nums#0) < NativeTypes.__default.Uint64UpperBound();
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0);
  ensures Seq#Equal(result#0, 
    PackedStringArray.__default.subtractConstant($LS($LS($LZ)), nums#0, subtrahend#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.SubtractConstant(nums#0: Seq Box
       where $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(nums#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    subtrahend#0: int where LitInt(0) <= subtrahend#0 && subtrahend#0 < 4294967296)
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    $_reverifyPost: bool);
  free requires 54 == $FunctionContextHeight;
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(nums#0, i#1)): int } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < Seq#Length(nums#0)
       ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#1)): int);
  requires Seq#Length(nums#0) < NativeTypes.__default.Uint64UpperBound();
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0);
  ensures Seq#Equal(result#0, 
    PackedStringArray.__default.subtractConstant($LS($LS($LZ)), nums#0, subtrahend#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.SubtractConstant(nums#0: Seq Box, subtrahend#0: int)
   returns (result#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var arr#0: ref
     where $Is(arr#0, Tclass._System.array?(Tclass.NativeTypes.uint32()))
       && $IsAlloc(arr#0, Tclass._System.array?(Tclass.NativeTypes.uint32()), $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass._System.array(Tclass.NativeTypes.uint32()))
       && $IsAlloc($rhs##0, Tclass._System.array(Tclass.NativeTypes.uint32()), $Heap);
  var n##0: int;
  var newtype$check#0: int;
  var t##0: Box;
  var newtype$check#1: int;
  var i#3: int where LitInt(0) <= i#3 && i#3 < 18446744073709551616;
  var newtype$check#2: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#3: int;
  var j#0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var $decr$loop#00: int;
  var $rhs#0_0: int where LitInt(0) <= $rhs#0_0 && $rhs#0_0 < 4294967296;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;

    // AddMethodImpl: SubtractConstant, Impl$$PackedStringArray.__default.SubtractConstant
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(185,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(186,28)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type array?<uint32>
    // TrCallStmt: Before ProcessCallStmt
    newtype$check#0 := Seq#Length(nums#0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    n##0 := Seq#Length(nums#0);
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 4294967296;
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##0 := $Box(LitInt(0));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$NativeArrays.__default.newArrayFill(Tclass.NativeTypes.uint32(), n##0, t##0);
    // TrCallStmt: After ProcessCallStmt
    arr#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(186,48)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(187,19)
    assume true;
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    i#3 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(187,22)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(188,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(nums#0) - i#3;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#3 <= Seq#Length(nums#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(nums#0, j#1)): int } 
            { $Unbox(read($Heap, arr#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            j#1 < i#3
             ==> $Unbox(read($Heap, arr#0, IndexField(j#1))): int
               == $Unbox(Seq#Index(nums#0, j#1)): int - subtrahend#0);
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(nums#0) - i#3 <= $decr_init$loop#00
         && (Seq#Length(nums#0) - i#3 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(188,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#3 := Seq#Length(nums#0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            assume true;
            assume i#3 <= Seq#Length(nums#0);
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
            // Begin Comprehension WF check
            if (j#0 < i#3)
            {
                assert arr#0 != null;
                assert {:subsumption 0} 0 <= j#0 && j#0 < _System.array.Length(arr#0);
                assert {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(nums#0);
                newtype$check#4 := $Unbox(Seq#Index(nums#0, j#0)): int - subtrahend#0;
                assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 4294967296;
            }

            // End Comprehension WF check
            assume true;
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(nums#0, j#1)): int } 
                { $Unbox(read($Heap, arr#0, IndexField(j#1))): int } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616
                 ==> 
                j#1 < i#3
                 ==> $Unbox(read($Heap, arr#0, IndexField(j#1))): int
                   == $Unbox(Seq#Index(nums#0, j#1)): int - subtrahend#0);
            newtype$check#5 := Seq#Length(nums#0);
            assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#6 := Seq#Length(nums#0);
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        assume true;
        if (Seq#Length(nums#0) <= i#3)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(nums#0) - i#3;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(192,14)
        assert arr#0 != null;
        assert 0 <= i#3 && i#3 < _System.array.Length(arr#0);
        assume true;
        assert $_Frame[arr#0, IndexField(i#3)];
        assert 0 <= i#3 && i#3 < Seq#Length(nums#0);
        newtype$check#0_0 := $Unbox(Seq#Index(nums#0, i#3)): int - subtrahend#0;
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 4294967296;
        assume true;
        $rhs#0_0 := $Unbox(Seq#Index(nums#0, i#3)): int - subtrahend#0;
        $Heap := update($Heap, arr#0, IndexField(i#3), $Box($rhs#0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(192,36)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(193,9)
        assume true;
        newtype$check#0_1 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        newtype$check#0_2 := i#3 + 1;
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        i#3 := i#3 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(193,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(188,5)
        assert 0 <= $decr$loop#00 || Seq#Length(nums#0) - i#3 == $decr$loop#00;
        assert Seq#Length(nums#0) - i#3 < $decr$loop#00;
        assume true;
        assume true;
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(195,12)
    assume true;
    assert arr#0 != null;
    assume true;
    result#0 := Seq#FromArray($Heap, arr#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(195,21)"} true;
}



// function declaration for PackedStringArray._default.subOffsets
function PackedStringArray.__default.subOffsets(offsets#0: Seq Box, from#0: int, to#0: int) : Seq Box;

function PackedStringArray.__default.subOffsets#canCall(offsets#0: Seq Box, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.subOffsets
axiom 40 <= $FunctionContextHeight
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    { PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) } 
    PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0)
         || (40 != $FunctionContextHeight
           && 
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(offsets#0))
       ==> $Is(PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0), 
        TSeq(Tclass.NativeTypes.uint32())));

function PackedStringArray.__default.subOffsets#requires(Seq Box, int, int) : bool;

// #requires axiom for PackedStringArray.__default.subOffsets
axiom (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
  { PackedStringArray.__default.subOffsets#requires(offsets#0, from#0, to#0) } 
  $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.subOffsets#requires(offsets#0, from#0, to#0)
       == (Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= Seq#Length(offsets#0)));

// definition axiom for PackedStringArray.__default.subOffsets(revealed)
axiom 40 <= $FunctionContextHeight
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    { PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) } 
    PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0)
         || (40 != $FunctionContextHeight
           && 
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(offsets#0))
       ==> (var suboffsets#0 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0); 
          from#0 != LitInt(0)
             ==> PackedStringArray.__default.subtractConstant#canCall(suboffsets#0, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int))
         && PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0)
           == (var suboffsets#0 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0); 
            (if from#0 == LitInt(0)
               then suboffsets#0
               else PackedStringArray.__default.subtractConstant($LS($LZ), suboffsets#0, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int))));

// definition axiom for PackedStringArray.__default.subOffsets for all literals(revealed)
axiom 40 <= $FunctionContextHeight
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.subOffsets(Lit(offsets#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.subOffsets#canCall(Lit(offsets#0), LitInt(from#0), LitInt(to#0))
         || (40 != $FunctionContextHeight
           && 
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(offsets#0))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= Seq#Length(Lit(offsets#0)))
       ==> (var suboffsets#1 := Lit(Seq#Drop(Seq#Take(Lit(offsets#0), LitInt(to#0)), LitInt(from#0))); 
          LitInt(from#0) != LitInt(0)
             ==> PackedStringArray.__default.subtractConstant#canCall(suboffsets#1, $Unbox(Seq#Index(Lit(offsets#0), LitInt(from#0 - 1))): int))
         && PackedStringArray.__default.subOffsets(Lit(offsets#0), LitInt(from#0), LitInt(to#0))
           == (var suboffsets#1 := Lit(Seq#Drop(Seq#Take(Lit(offsets#0), LitInt(to#0)), LitInt(from#0))); 
            (if LitInt(from#0) == LitInt(0)
               then suboffsets#1
               else PackedStringArray.__default.subtractConstant($LS($LZ), 
                suboffsets#1, 
                $Unbox(Seq#Index(Lit(offsets#0), LitInt(from#0 - 1))): int))));

procedure CheckWellformed$$PackedStringArray.__default.subOffsets(offsets#0: Seq Box where $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32())), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: Seq Box where $Is(result#0, TSeq(Tclass.NativeTypes.uint32())));
  free requires 40 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.subOffsets(offsets#0: Seq Box, from#0: int, to#0: int) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##run#0: Seq Box;
  var b$reqreads#0: bool;
  var suboffsets#2: Seq Box;
  var let#0#0#0: Seq Box;
  var newtype$check#0: int;
  var i#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##nums#0: Seq Box;
  var ##subtrahend#0: int;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function subOffsets
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(198,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##run#0 := offsets#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume Uint32__Order.__default.IsSorted#canCall(offsets#0);
    assume Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0);
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 <= to#0)
    {
    }

    assume LitInt(0) <= from#0 && from#0 <= to#0 && to#0 <= Seq#Length(offsets#0);
    assert b$reqreads#0;
    if (*)
    {
        assume $Is(PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0), 
          TSeq(Tclass.NativeTypes.uint32()));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        havoc suboffsets#2;
        assume $Is(suboffsets#2, TSeq(Tclass.NativeTypes.uint32()));
        assert 0 <= from#0 && from#0 <= Seq#Length(offsets#0);
        assert from#0 <= to#0 && to#0 <= Seq#Length(offsets#0);
        assume let#0#0#0 == Seq#Drop(Seq#Take(offsets#0, to#0), from#0);
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(let#0#0#0, TSeq(Tclass.NativeTypes.uint32()));
        assume suboffsets#2 == let#0#0#0;
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        if (from#0 == LitInt(0))
        {
            assume PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) == suboffsets#2;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0), 
              TSeq(Tclass.NativeTypes.uint32()));
        }
        else
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(206,7)
            havoc i#0;
            // Begin Comprehension WF check
            if (LitInt(0) <= i#0)
            {
            }

            if (LitInt(0) <= i#0 && i#0 < Seq#Length(suboffsets#2))
            {
                newtype$check#1 := LitInt(1);
                assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
                newtype$check#2 := from#0 - 1;
                assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
                assert {:subsumption 0} 0 <= from#0 - 1 && from#0 - 1 < Seq#Length(offsets#0);
                assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(suboffsets#2);
            }

            // End Comprehension WF check
            assume true;
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(206,7)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(206,118)
                // TrCallStmt: Before ProcessCallStmt
                // ProcessCallStmt: Make the call
                call Call$$Uint32__Order.__default.reveal__IsSorted();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(206,119)"} true;
                assert (forall i#1: int :: 
                  { $Unbox(Seq#Index(suboffsets#2, i#1)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#1 && i#1 < Seq#Length(suboffsets#2)
                     ==> $Unbox(Seq#Index(offsets#0, from#0 - 1)): int
                       <= $Unbox(Seq#Index(suboffsets#2, i#1)): int);
                assume false;
            }

            assume (forall i#1: int :: 
              { $Unbox(Seq#Index(suboffsets#2, i#1)): int } 
              true
                 ==> 
                LitInt(0) <= i#1 && i#1 < Seq#Length(suboffsets#2)
                 ==> $Unbox(Seq#Index(offsets#0, from#0 - 1)): int
                   <= $Unbox(Seq#Index(suboffsets#2, i#1)): int);
            newtype$check#3 := LitInt(1);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            newtype$check#4 := from#0 - 1;
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            assert 0 <= from#0 - 1 && from#0 - 1 < Seq#Length(offsets#0);
            ##nums#0 := suboffsets#2;
            // assume allocatedness for argument to function
            assume $IsAlloc(##nums#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            ##subtrahend#0 := $Unbox(Seq#Index(offsets#0, from#0 - 1)): int;
            // assume allocatedness for argument to function
            assume $IsAlloc(##subtrahend#0, Tclass.NativeTypes.uint32(), $Heap);
            assert {:subsumption 0} (forall i#2: int :: 
              { $Unbox(Seq#Index(##nums#0, i#2)): int } 
              true
                 ==> 
                LitInt(0) <= i#2 && i#2 < Seq#Length(##nums#0)
                 ==> ##subtrahend#0 <= $Unbox(Seq#Index(##nums#0, i#2)): int);
            assume (forall i#2: int :: 
              { $Unbox(Seq#Index(##nums#0, i#2)): int } 
              true
                 ==> 
                LitInt(0) <= i#2 && i#2 < Seq#Length(##nums#0)
                 ==> ##subtrahend#0 <= $Unbox(Seq#Index(##nums#0, i#2)): int);
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.subtractConstant#canCall(suboffsets#2, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int);
            assume PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0)
               == PackedStringArray.__default.subtractConstant($LS($LZ), suboffsets#2, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int);
            assume PackedStringArray.__default.subtractConstant#canCall(suboffsets#2, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int);
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0), 
              TSeq(Tclass.NativeTypes.uint32()));
        }

        assume PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) == result#0;
        assert b$reqreads#1;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.SubOffsets(offsets#0: Seq Box
       where $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(offsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.uint32()), $Heap));
  free requires 55 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.SubOffsets(offsets#0: Seq Box, from#0: int, to#0: int) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##run#0: Seq Box;
  var ##offsets#0: Seq Box;
  var ##from#0: int;
  var ##to#0: int;

    // AddMethodImpl: SubOffsets, CheckWellformed$$PackedStringArray.__default.SubOffsets
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(210,9): initial state"} true;
    ##run#0 := offsets#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
    assume Uint32__Order.__default.IsSorted#canCall(offsets#0);
    assume Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0);
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 <= to#0)
    {
    }

    assume LitInt(0) <= from#0 && from#0 <= to#0 && to#0 <= Seq#Length(offsets#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(213,19): post-state"} true;
    ##offsets#0 := offsets#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##offsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
    ##from#0 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
    ##to#0 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, ##offsets#0);
    assume Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, ##offsets#0);
    assert {:subsumption 0} LitInt(0) <= ##from#0;
    assert {:subsumption 0} ##from#0 <= ##to#0;
    assert {:subsumption 0} ##to#0 <= Seq#Length(##offsets#0);
    assume LitInt(0) <= ##from#0 && ##from#0 <= ##to#0 && ##to#0 <= Seq#Length(##offsets#0);
    assume PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0);
    assume Seq#Equal(result#0, PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0));
}



procedure Call$$PackedStringArray.__default.SubOffsets(offsets#0: Seq Box
       where $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(offsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.uint32()), $Heap));
  // user-defined preconditions
  requires Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, offsets#0);
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= Seq#Length(offsets#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0);
  ensures Seq#Equal(result#0, PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.SubOffsets(offsets#0: Seq Box
       where $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(offsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    $_reverifyPost: bool);
  free requires 55 == $FunctionContextHeight;
  // user-defined preconditions
  requires Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, offsets#0);
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= Seq#Length(offsets#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0);
  ensures Seq#Equal(result#0, PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.SubOffsets(offsets#0: Seq Box, from#0: int, to#0: int)
   returns (result#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var suboffsets#0: Seq Box
     where $Is(suboffsets#0, TSeq(Tclass.NativeTypes.uint32()))
       && $IsAlloc(suboffsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
  var newtype$check#0: int;
  var i#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.uint32()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
  var nums##0: Seq Box;
  var subtrahend##0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;

    // AddMethodImpl: SubOffsets, Impl$$PackedStringArray.__default.SubOffsets
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(214,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(215,20)
    assume true;
    assert 0 <= from#0 && from#0 <= Seq#Length(offsets#0);
    assert from#0 <= to#0 && to#0 <= Seq#Length(offsets#0);
    assume true;
    suboffsets#0 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(215,39)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(216,5)
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    if (from#0 == LitInt(0))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(217,14)
        assume true;
        assume true;
        result#0 := suboffsets#0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(217,26)"} true;
    }
    else
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(219,7)
        havoc i#0;
        // Begin Comprehension WF check
        if (LitInt(0) <= i#0)
        {
        }

        if (LitInt(0) <= i#0 && i#0 < Seq#Length(suboffsets#0))
        {
            newtype$check#1 := LitInt(1);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            newtype$check#2 := from#0 - 1;
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            assert {:subsumption 0} 0 <= from#0 - 1 && from#0 - 1 < Seq#Length(offsets#0);
            assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(suboffsets#0);
        }

        // End Comprehension WF check
        assume true;
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(219,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(219,118)
            // TrCallStmt: Before ProcessCallStmt
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Uint32__Order.__default.reveal__IsSorted();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(219,119)"} true;
            assert (forall i#1: int :: 
              { $Unbox(Seq#Index(suboffsets#0, i#1)): int } 
              true
                 ==> 
                LitInt(0) <= i#1 && i#1 < Seq#Length(suboffsets#0)
                 ==> $Unbox(Seq#Index(offsets#0, from#0 - 1)): int
                   <= $Unbox(Seq#Index(suboffsets#0, i#1)): int);
            assume false;
        }

        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(suboffsets#0, i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(suboffsets#0)
             ==> $Unbox(Seq#Index(offsets#0, from#0 - 1)): int
               <= $Unbox(Seq#Index(suboffsets#0, i#1)): int);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(220,33)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type seq<uint32>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        nums##0 := suboffsets#0;
        newtype$check#3 := LitInt(1);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := from#0 - 1;
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        assert 0 <= from#0 - 1 && from#0 - 1 < Seq#Length(offsets#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        subtrahend##0 := $Unbox(Seq#Index(offsets#0, from#0 - 1)): int;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$PackedStringArray.__default.SubtractConstant(nums##0, subtrahend##0);
        // TrCallStmt: After ProcessCallStmt
        result#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(220,61)"} true;
    }
}



// function declaration for PackedStringArray._default.psaSubSeqInternal
function PackedStringArray.__default.psaSubSeqInternal(psa#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaSubSeqInternal
axiom 41 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         || (41 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> $Is(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0), 
        Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaSubSeqInternal#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSubSeqInternal
axiom (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedStringArray.__default.psaSubSeqInternal#requires(psa#0, from#0, to#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaSubSeqInternal#requires(psa#0, from#0, to#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaSubSeqInternal(revealed)
axiom 41 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         || (41 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> (from#0 == to#0 ==> PackedStringArray.__default.EmptyPsa#canCall())
         && (from#0 != to#0
           ==> PackedStringArray.__default.psaStart#canCall(psa#0, from#0)
             && 
            PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1)
             && 
            PackedStringArray.Psa.Psa_q(psa#0)
             && PackedStringArray.__default.subOffsets#canCall(PackedStringArray.Psa.offsets(psa#0), from#0, to#0)
             && PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)
           == (if from#0 == to#0
             then PackedStringArray.__default.EmptyPsa()
             else (var dataStart#0 := PackedStringArray.__default.psaStart(psa#0, from#0); 
              (var dataEnd#0 := PackedStringArray.__default.psaEnd(psa#0, to#0 - 1); 
                #PackedStringArray.Psa.Psa(PackedStringArray.__default.subOffsets(PackedStringArray.Psa.offsets(psa#0), from#0, to#0), 
                  Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0))))));

// definition axiom for PackedStringArray.__default.psaSubSeqInternal for all literals(revealed)
axiom 41 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         || (41 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> (LitInt(from#0) == LitInt(to#0)
           ==> PackedStringArray.__default.EmptyPsa#canCall())
         && (LitInt(from#0) != LitInt(to#0)
           ==> PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(from#0))
             && 
            PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(to#0 - 1))
             && 
            PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && PackedStringArray.__default.subOffsets#canCall(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(from#0), LitInt(to#0))
             && PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0))
           == (if LitInt(from#0) == LitInt(to#0)
             then PackedStringArray.__default.EmptyPsa()
             else (var dataStart#1 := LitInt(PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(from#0))); 
              (var dataEnd#1 := LitInt(PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(to#0 - 1))); 
                Lit(#PackedStringArray.Psa.Psa(Lit(PackedStringArray.__default.subOffsets(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(from#0), LitInt(to#0))), 
                    Lit(Seq#Drop(Seq#Take(Lit(PackedStringArray.Psa.data(Lit(psa#0))), dataEnd#1), dataStart#1))))))));

procedure CheckWellformed$$PackedStringArray.__default.psaSubSeqInternal(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 41 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaSubSeqInternal(psa#0: DatatypeType, from#0: int, to#0: int) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var dataStart#2: int;
  var let#0#0#0: int;
  var ##psa#2: DatatypeType;
  var ##i#0: int;
  var dataEnd#2: int;
  var let#1#0#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##psa#3: DatatypeType;
  var ##i#1: int;
  var psa##0: DatatypeType;
  var i##0: int;
  var j##0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##offsets#0: Seq Box;
  var ##from#0: int;
  var ##to#0: int;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;

    // AddWellformednessCheck for function psaSubSeqInternal
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(224,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 <= to#0)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    }

    assume LitInt(0) <= from#0
       && from#0 <= to#0
       && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
    assert b$reqreads#0;
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0), 
          Tclass.PackedStringArray.Psa());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (from#0 == to#0)
        {
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.EmptyPsa#canCall();
            assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
            assume PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)
               == Lit(PackedStringArray.__default.EmptyPsa());
            assume PackedStringArray.__default.EmptyPsa#canCall();
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0), 
              Tclass.PackedStringArray.Psa());
        }
        else
        {
            havoc dataStart#2;
            assume LitInt(0) <= dataStart#2 && dataStart#2 < 4294967296;
            ##psa#2 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#0 := from#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
               ==> PackedStringArray.__default.WF(##psa#2)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#2));
            assume PackedStringArray.__default.WF(##psa#2);
            assert {:subsumption 0} LitInt(0) <= ##i#0;
            assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
            assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2));
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.psaStart#canCall(psa#0, from#0);
            assume let#0#0#0 == PackedStringArray.__default.psaStart(psa#0, from#0);
            assume PackedStringArray.__default.psaStart#canCall(psa#0, from#0);
            // CheckWellformedWithResult: any expression
            assume $Is(let#0#0#0, Tclass.NativeTypes.uint32());
            assume dataStart#2 == let#0#0#0;
            havoc dataEnd#2;
            assume LitInt(0) <= dataEnd#2 && dataEnd#2 < 4294967296;
            newtype$check#1 := LitInt(1);
            assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
            newtype$check#2 := to#0 - 1;
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            ##psa#3 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#1 := to#0 - 1;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assume PackedStringArray.__default.WF(##psa#3);
            assert {:subsumption 0} LitInt(0) <= ##i#1;
            assert {:subsumption 0} ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3));
            assume LitInt(0) <= ##i#1 && ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3));
            b$reqreads#4 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1);
            assume let#1#0#0 == PackedStringArray.__default.psaEnd(psa#0, to#0 - 1);
            assume PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1);
            // CheckWellformedWithResult: any expression
            assume $Is(let#1#0#0, Tclass.NativeTypes.uint32());
            assume dataEnd#2 == let#1#0#0;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(233,24)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            psa##0 := psa#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##0 := from#0;
            newtype$check#3 := LitInt(1);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            newtype$check#4 := to#0 - 1;
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            j##0 := to#0 - 1;
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.__default.psaStartLtePsaEnd(psa##0, i##0, j##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(233,40)"} true;
            assume PackedStringArray.Psa.Psa_q(psa#0);
            ##offsets#0 := PackedStringArray.Psa.offsets(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##offsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
            ##from#0 := from#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
            ##to#0 := to#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, ##offsets#0);
            assume Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, ##offsets#0);
            assert {:subsumption 0} LitInt(0) <= ##from#0;
            assert {:subsumption 0} ##from#0 <= ##to#0;
            assert {:subsumption 0} ##to#0 <= Seq#Length(##offsets#0);
            assume LitInt(0) <= ##from#0 && ##from#0 <= ##to#0 && ##to#0 <= Seq#Length(##offsets#0);
            b$reqreads#5 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.subOffsets#canCall(PackedStringArray.Psa.offsets(psa#0), from#0, to#0);
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assert 0 <= dataStart#2 && dataStart#2 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert dataStart#2 <= dataEnd#2
               && dataEnd#2 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assume PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)
               == #PackedStringArray.Psa.Psa(PackedStringArray.__default.subOffsets(PackedStringArray.Psa.offsets(psa#0), from#0, to#0), 
                Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#2), dataStart#2));
            assume PackedStringArray.Psa.Psa_q(psa#0)
               && PackedStringArray.__default.subOffsets#canCall(PackedStringArray.Psa.offsets(psa#0), from#0, to#0)
               && PackedStringArray.Psa.Psa_q(psa#0);
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0), 
              Tclass.PackedStringArray.Psa());
        }

        assume PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) == result#0;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.WFpsaSubSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616);
  free requires 42 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.WFpsaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;
  var ##from#1: int;
  var ##to#1: int;
  var ##psa#5: DatatypeType;
  var ##psa#6: DatatypeType;

    // AddMethodImpl: WFpsaSubSeq, CheckWellformed$$PackedStringArray.__default.WFpsaSubSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(237,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 <= to#0)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    }

    assume LitInt(0) <= from#0
       && from#0 <= to#0
       && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(240,14): post-state"} true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#0 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
    ##to#0 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assert {:subsumption 0} LitInt(0) <= ##from#0;
    assert {:subsumption 0} ##from#0 <= ##to#0;
    assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#2);
    assume LitInt(0) <= ##from#0
       && ##from#0 <= ##to#0
       && ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#2);
    assume PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
    ##psa#3 := PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
    assume PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#1 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#1, Tclass.NativeTypes.uint64(), $Heap);
    ##to#1 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assert {:subsumption 0} LitInt(0) <= ##from#1;
    assert {:subsumption 0} ##from#1 <= ##to#1;
    assert {:subsumption 0} ##to#1 <= PackedStringArray.__default.psaNumStrings(##psa#4);
    assume LitInt(0) <= ##from#1
       && ##from#1 <= ##to#1
       && ##to#1 <= PackedStringArray.__default.psaNumStrings(##psa#4);
    assume PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
    ##psa#5 := PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assume PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
    ##psa#6 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assert 0 <= from#0 && from#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assert from#0 <= to#0 && to#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assume Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)), 
      Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
}



procedure Call$$PackedStringArray.__default.WFpsaSubSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
  free ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     && 
    PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
       < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
         == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
         == LitInt(0))
     && (0
         < Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
       ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)), 
            Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
               - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)));
  free ensures PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)), 
    Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.WFpsaSubSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 42 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
         < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
         < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
       || (Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
           == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
           == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
       || (0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
         ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)), 
              Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)))
                 - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)));
  free ensures PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)), 
    Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.WFpsaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var subpsa#0: DatatypeType
     where $Is(subpsa#0, Tclass.PackedStringArray.Psa())
       && $IsAlloc(subpsa#0, Tclass.PackedStringArray.Psa(), $Heap);
  var ##psa#7: DatatypeType;
  var ##from#2: int;
  var ##to#2: int;
  var ##psa#8: DatatypeType;
  var isubpsa#0: Seq Box
     where $Is(isubpsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(isubpsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#9: DatatypeType;
  var ipsasub#0: Seq Box
     where $Is(ipsasub#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(ipsasub#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#10: DatatypeType;
  var i#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var dataStart#0: int where LitInt(0) <= dataStart#0 && dataStart#0 < 4294967296;
  var ##psa#11: DatatypeType;
  var ##i#0: int;
  var dataEnd#0: int where LitInt(0) <= dataEnd#0 && dataEnd#0 < 4294967296;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##psa#12: DatatypeType;
  var ##i#1: int;
  var subStart#0: int where LitInt(0) <= subStart#0 && subStart#0 < 4294967296;
  var ##psa#13: DatatypeType;
  var ##i#2: int;
  var subEnd#0: int where LitInt(0) <= subEnd#0 && subEnd#0 < 4294967296;
  var ##psa#14: DatatypeType;
  var ##i#3: int;
  var j#0: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;

    // AddMethodImpl: WFpsaSubSeq, Impl$$PackedStringArray.__default.WFpsaSubSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(242,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(243,16)
    assume true;
    ##psa#7 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#2 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#2, Tclass.NativeTypes.uint64(), $Heap);
    ##to#2 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#2, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#7));
    assume PackedStringArray.__default.WF(##psa#7);
    assert {:subsumption 0} LitInt(0) <= ##from#2;
    assert {:subsumption 0} ##from#2 <= ##to#2;
    assert {:subsumption 0} ##to#2 <= PackedStringArray.__default.psaNumStrings(##psa#7);
    assume LitInt(0) <= ##from#2
       && ##from#2 <= ##to#2
       && ##to#2 <= PackedStringArray.__default.psaNumStrings(##psa#7);
    assume PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
    assume PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0);
    subpsa#0 := PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(243,50)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(244,5)
    ##psa#8 := subpsa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(subpsa#0);
    assume PackedStringArray.__default.WF#canCall(subpsa#0);
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(244,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(244,56)
        // TrCallStmt: Before ProcessCallStmt
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$Uint32__Order.__default.reveal__IsSorted();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(244,57)"} true;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(subpsa#0)
           ==> PackedStringArray.__default.WF(subpsa#0)
             || Seq#Length(PackedStringArray.Psa.offsets(subpsa#0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(subpsa#0)
           ==> PackedStringArray.__default.WF(subpsa#0)
             || Seq#Length(PackedStringArray.Psa.data(subpsa#0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(subpsa#0)
           ==> PackedStringArray.__default.WF(subpsa#0)
             || (Seq#Length(PackedStringArray.Psa.offsets(subpsa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(subpsa#0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(subpsa#0)
           ==> PackedStringArray.__default.WF(subpsa#0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(subpsa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(subpsa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(subpsa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(subpsa#0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(subpsa#0)
           ==> PackedStringArray.__default.WF(subpsa#0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(subpsa#0));
        assume false;
    }

    assume PackedStringArray.__default.WF(subpsa#0);
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(245,17)
    assume true;
    ##psa#9 := subpsa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#9));
    assume PackedStringArray.__default.WF(##psa#9);
    assume PackedStringArray.__default.I#canCall(subpsa#0);
    assume PackedStringArray.__default.I#canCall(subpsa#0);
    isubpsa#0 := PackedStringArray.__default.I(subpsa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(245,28)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(246,17)
    assume true;
    ##psa#10 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#10, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.data(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#10))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#10), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#10));
    assume PackedStringArray.__default.WF(##psa#10);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assert 0 <= from#0 && from#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assert from#0 <= to#0 && to#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assume PackedStringArray.__default.I#canCall(psa#0);
    ipsasub#0 := Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(246,35)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(247,5)
    assume true;
    assert Seq#Length(isubpsa#0) == Seq#Length(ipsasub#0);
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(248,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#0;
        assume LitInt(0) <= i#0 && i#0 < 18446744073709551616;
        newtype$check#1 := LitInt(0);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        if (LitInt(0) <= i#0)
        {
            newtype$check#2 := Seq#Length(isubpsa#0);
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        }

        assume true;
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(isubpsa#0);
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(251,21)
        assume true;
        ##psa#11 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#11, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := from#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
           ==> PackedStringArray.__default.WF(##psa#11)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
           ==> PackedStringArray.__default.WF(##psa#11)
             || Seq#Length(PackedStringArray.Psa.data(##psa#11)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
           ==> PackedStringArray.__default.WF(##psa#11)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#11)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
           ==> PackedStringArray.__default.WF(##psa#11)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#11))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#11), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
           ==> PackedStringArray.__default.WF(##psa#11)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#11));
        assume PackedStringArray.__default.WF(##psa#11);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11));
        assume LitInt(0) <= ##i#0
           && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11));
        assume PackedStringArray.__default.psaStart#canCall(psa#0, from#0);
        assume PackedStringArray.__default.psaStart#canCall(psa#0, from#0);
        dataStart#0 := PackedStringArray.__default.psaStart(psa#0, from#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(251,42)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(252,19)
        assume true;
        newtype$check#3 := LitInt(1);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := to#0 - 1;
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        ##psa#12 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#12, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#1 := to#0 - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
           ==> PackedStringArray.__default.WF(##psa#12)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
           ==> PackedStringArray.__default.WF(##psa#12)
             || Seq#Length(PackedStringArray.Psa.data(##psa#12)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
           ==> PackedStringArray.__default.WF(##psa#12)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#12)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
           ==> PackedStringArray.__default.WF(##psa#12)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#12))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#12))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#12), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#12)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#12)
           ==> PackedStringArray.__default.WF(##psa#12)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#12));
        assume PackedStringArray.__default.WF(##psa#12);
        assert {:subsumption 0} LitInt(0) <= ##i#1;
        assert {:subsumption 0} ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#12));
        assume LitInt(0) <= ##i#1
           && ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#12));
        assume PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1);
        assume PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1);
        dataEnd#0 := PackedStringArray.__default.psaEnd(psa#0, to#0 - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(252,38)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(253,20)
        assume true;
        ##psa#13 := subpsa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#13, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#2 := i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#2, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
           ==> PackedStringArray.__default.WF(##psa#13)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
           ==> PackedStringArray.__default.WF(##psa#13)
             || Seq#Length(PackedStringArray.Psa.data(##psa#13)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
           ==> PackedStringArray.__default.WF(##psa#13)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#13)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
           ==> PackedStringArray.__default.WF(##psa#13)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#13))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#13))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#13), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#13)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#13)
           ==> PackedStringArray.__default.WF(##psa#13)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#13));
        assume PackedStringArray.__default.WF(##psa#13);
        assert {:subsumption 0} LitInt(0) <= ##i#2;
        assert {:subsumption 0} ##i#2 < Seq#Length(PackedStringArray.Psa.offsets(##psa#13));
        assume LitInt(0) <= ##i#2
           && ##i#2 < Seq#Length(PackedStringArray.Psa.offsets(##psa#13));
        assume PackedStringArray.__default.psaStart#canCall(subpsa#0, i#0);
        assume PackedStringArray.__default.psaStart#canCall(subpsa#0, i#0);
        subStart#0 := PackedStringArray.__default.psaStart(subpsa#0, i#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(253,41)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(254,18)
        assume true;
        ##psa#14 := subpsa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#14, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#3 := i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#3, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
           ==> PackedStringArray.__default.WF(##psa#14)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
           ==> PackedStringArray.__default.WF(##psa#14)
             || Seq#Length(PackedStringArray.Psa.data(##psa#14)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
           ==> PackedStringArray.__default.WF(##psa#14)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#14)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
           ==> PackedStringArray.__default.WF(##psa#14)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#14))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#14))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#14), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#14)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#14)
           ==> PackedStringArray.__default.WF(##psa#14)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#14));
        assume PackedStringArray.__default.WF(##psa#14);
        assert {:subsumption 0} LitInt(0) <= ##i#3;
        assert {:subsumption 0} ##i#3 < Seq#Length(PackedStringArray.Psa.offsets(##psa#14));
        assume LitInt(0) <= ##i#3
           && ##i#3 < Seq#Length(PackedStringArray.Psa.offsets(##psa#14));
        assume PackedStringArray.__default.psaEnd#canCall(subpsa#0, i#0);
        assume PackedStringArray.__default.psaEnd#canCall(subpsa#0, i#0);
        subEnd#0 := PackedStringArray.__default.psaEnd(subpsa#0, i#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(254,37)"} true;
        // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(256,7)
        if (*)
        {
            // Assume Fuel Constant
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 4294967296;
            newtype$check#5 := LitInt(0);
            assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 4294967296;
            if (LitInt(0) <= j#0)
            {
                newtype$check#6 := subEnd#0 - subStart#0;
                assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 4294967296;
            }

            assume true;
            assume LitInt(0) <= j#0 && j#0 < subEnd#0 - subStart#0;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(262,9)
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assert {:subsumption 0} 0 <= dataStart#0 && dataStart#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert {:subsumption 0} dataStart#0 <= dataEnd#0
               && dataEnd#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert {:subsumption 0} 0 <= subStart#0
               && subStart#0
                 <= Seq#Length(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0));
            assert {:subsumption 0} subStart#0 <= subEnd#0
               && subEnd#0
                 <= Seq#Length(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0));
            assert {:subsumption 0} 0 <= j#0
               && j#0
                 < Seq#Length(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                      subEnd#0), 
                    subStart#0));
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assert {:subsumption 0} 0 <= dataStart#0 && dataStart#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert {:subsumption 0} dataStart#0 <= dataEnd#0
               && dataEnd#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            newtype$check#7 := subStart#0 + j#0;
            assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 4294967296;
            assert {:subsumption 0} 0 <= subStart#0 + j#0
               && subStart#0 + j#0
                 < Seq#Length(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0));
            assume PackedStringArray.Psa.Psa_q(psa#0) && PackedStringArray.Psa.Psa_q(psa#0);
            assert $Unbox(Seq#Index(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                      subEnd#0), 
                    subStart#0), 
                  j#0)): int
               == $Unbox(Seq#Index(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                  subStart#0 + j#0)): int;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(263,9)
            assume PackedStringArray.Psa.Psa_q(psa#0);
            assert {:subsumption 0} 0 <= dataStart#0 && dataStart#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert {:subsumption 0} dataStart#0 <= dataEnd#0
               && dataEnd#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert {:subsumption 0} 0 <= subStart#0
               && subStart#0
                 <= Seq#Length(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0));
            assert {:subsumption 0} subStart#0 <= subEnd#0
               && subEnd#0
                 <= Seq#Length(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0));
            assert {:subsumption 0} 0 <= j#0
               && j#0
                 < Seq#Length(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                      subEnd#0), 
                    subStart#0));
            assume PackedStringArray.Psa.Psa_q(psa#0);
            newtype$check#8 := dataStart#0 + subStart#0;
            assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 4294967296;
            newtype$check#9 := dataStart#0 + subStart#0 + j#0;
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 4294967296;
            assert {:subsumption 0} 0 <= dataStart#0 + subStart#0 + j#0
               && dataStart#0 + subStart#0 + j#0 < Seq#Length(PackedStringArray.Psa.data(psa#0));
            assume PackedStringArray.Psa.Psa_q(psa#0) && PackedStringArray.Psa.Psa_q(psa#0);
            assert $Unbox(Seq#Index(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                      subEnd#0), 
                    subStart#0), 
                  j#0)): int
               == $Unbox(Seq#Index(PackedStringArray.Psa.data(psa#0), dataStart#0 + subStart#0 + j#0)): int;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(264,9)
            assume PackedStringArray.Psa.Psa_q(psa#0);
            newtype$check#10 := dataStart#0 + subStart#0;
            assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 4294967296;
            assert {:subsumption 0} 0 <= dataStart#0 + subStart#0
               && dataStart#0 + subStart#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            newtype$check#11 := dataStart#0 + subEnd#0;
            assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 4294967296;
            assert {:subsumption 0} dataStart#0 + subStart#0 <= dataStart#0 + subEnd#0
               && dataStart#0 + subEnd#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
            assert {:subsumption 0} 0 <= j#0
               && j#0
                 < Seq#Length(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataStart#0 + subEnd#0), 
                    dataStart#0 + subStart#0));
            assume PackedStringArray.Psa.Psa_q(psa#0);
            newtype$check#12 := dataStart#0 + subStart#0;
            assert LitInt(0) <= newtype$check#12 && newtype$check#12 < 4294967296;
            newtype$check#13 := dataStart#0 + subStart#0 + j#0;
            assert LitInt(0) <= newtype$check#13 && newtype$check#13 < 4294967296;
            assert {:subsumption 0} 0 <= dataStart#0 + subStart#0 + j#0
               && dataStart#0 + subStart#0 + j#0 < Seq#Length(PackedStringArray.Psa.data(psa#0));
            assume PackedStringArray.Psa.Psa_q(psa#0) && PackedStringArray.Psa.Psa_q(psa#0);
            assert $Unbox(Seq#Index(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataStart#0 + subEnd#0), 
                    dataStart#0 + subStart#0), 
                  j#0)): int
               == $Unbox(Seq#Index(PackedStringArray.Psa.data(psa#0), dataStart#0 + subStart#0 + j#0)): int;
            assert $Unbox(Seq#Index(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                      subEnd#0), 
                    subStart#0), 
                  j#0)): int
               == $Unbox(Seq#Index(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataStart#0 + subEnd#0), 
                    dataStart#0 + subStart#0), 
                  j#0)): int;
            assume false;
        }
        else
        {
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                        subEnd#0), 
                      subStart#0), 
                    j#1)): int } 
              LitInt(0) <= j#1
                   && j#1 < 4294967296
                   && 
                  LitInt(0) <= j#1
                   && j#1 < subEnd#0 - subStart#0
                 ==> $Unbox(Seq#Index(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0), 
                          subEnd#0), 
                        subStart#0), 
                      j#1)): int
                   == $Unbox(Seq#Index(Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataStart#0 + subEnd#0), 
                        dataStart#0 + subStart#0), 
                      j#1)): int);
        }

        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(265,6)"} true;
        assert Seq#Equal($Unbox(Seq#Index(isubpsa#0, i#0)): Seq Box, 
          $Unbox(Seq#Index(ipsasub#0, i#0)): Seq Box);
        assume false;
    }
    else
    {
        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsasub#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(isubpsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1
               && i#1 < 18446744073709551616
               && 
              LitInt(0) <= i#1
               && i#1 < Seq#Length(isubpsa#0)
             ==> Seq#Equal($Unbox(Seq#Index(isubpsa#0, i#1)): Seq Box, 
              $Unbox(Seq#Index(ipsasub#0, i#1)): Seq Box));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(266,4)"} true;
}



// function declaration for PackedStringArray._default.psaSubSeq
function PackedStringArray.__default.psaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedStringArray.__default.psaSubSeq#canCall(psa#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaSubSeq
axiom 43 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
         || (43 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
          Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0))
         && $Is(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaSubSeq#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSubSeq
axiom (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedStringArray.__default.psaSubSeq#requires(psa#0, from#0, to#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaSubSeq#requires(psa#0, from#0, to#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaSubSeq(revealed)
axiom 43 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
         || (43 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         && PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)
           == PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));

// definition axiom for PackedStringArray.__default.psaSubSeq for all literals(revealed)
axiom 43 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSubSeq(Lit(psa#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.psaSubSeq#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         || (43 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> PackedStringArray.__default.psaSubSeqInternal#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         && PackedStringArray.__default.psaSubSeq(Lit(psa#0), LitInt(from#0), LitInt(to#0))
           == Lit(PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0))));

procedure CheckWellformed$$PackedStringArray.__default.psaSubSeq(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 43 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));



implementation CheckWellformed$$PackedStringArray.__default.psaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;
  var psa##0: DatatypeType;
  var from##0: int;
  var to##0: int;
  var ##psa#5: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function psaSubSeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(269,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 <= to#0)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    }

    assume LitInt(0) <= from#0
       && from#0 <= to#0
       && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
    assert b$reqreads#0;
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0), 
          Tclass.PackedStringArray.Psa());
        ##psa#2 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assume PackedStringArray.__default.WF#canCall(result#0);
        assume PackedStringArray.__default.WF(result#0);
        ##psa#3 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assume PackedStringArray.__default.I#canCall(result#0);
        ##psa#4 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#4));
        assume PackedStringArray.__default.WF(##psa#4);
        assume PackedStringArray.__default.I#canCall(psa#0);
        assert 0 <= from#0 && from#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
        assert from#0 <= to#0 && to#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
        assume Seq#Equal(PackedStringArray.__default.I(result#0), 
          Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(275,16)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa##0 := psa#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        from##0 := from#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        to##0 := to#0;
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.WFpsaSubSeq(psa##0, from##0, to##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(275,30)"} true;
        ##psa#5 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
        ##from#0 := from#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
        ##to#0 := to#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#5));
        assume PackedStringArray.__default.WF(##psa#5);
        assert {:subsumption 0} LitInt(0) <= ##from#0;
        assert {:subsumption 0} ##from#0 <= ##to#0;
        assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#5);
        assume LitInt(0) <= ##from#0
           && ##from#0 <= ##to#0
           && ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#5);
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));
        assume PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)
           == PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0);
        assume PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0), 
          Tclass.PackedStringArray.Psa());
        assume PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) == result#0;
        assert b$reqreads#2;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.PsaSubSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap));
  free requires 56 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.PsaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;
  var ##psa#3: DatatypeType;
  var ##from#1: int;
  var ##to#1: int;
  var ##psa#4: DatatypeType;
  var ##psa#5: DatatypeType;
  var ##from#2: int;
  var ##to#2: int;
  var ##psa#6: DatatypeType;
  var ##psa#7: DatatypeType;

    // AddMethodImpl: PsaSubSeq, CheckWellformed$$PackedStringArray.__default.PsaSubSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(279,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 <= to#0)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    }

    assume LitInt(0) <= from#0
       && from#0 <= to#0
       && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(282,19): post-state"} true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#0 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
    ##to#0 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assert {:subsumption 0} LitInt(0) <= ##from#0;
    assert {:subsumption 0} ##from#0 <= ##to#0;
    assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#2);
    assume LitInt(0) <= ##from#0
       && ##from#0 <= ##to#0
       && ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#2);
    assume PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    assume PackedStringArray.Psa#Equal(result#0, PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    ##psa#3 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#1 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#1, Tclass.NativeTypes.uint64(), $Heap);
    ##to#1 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assert {:subsumption 0} LitInt(0) <= ##from#1;
    assert {:subsumption 0} ##from#1 <= ##to#1;
    assert {:subsumption 0} ##to#1 <= PackedStringArray.__default.psaNumStrings(##psa#3);
    assume LitInt(0) <= ##from#1
       && ##from#1 <= ##to#1
       && ##to#1 <= PackedStringArray.__default.psaNumStrings(##psa#3);
    assume PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    ##psa#4 := PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    assume PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    ##psa#5 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    ##from#2 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#2, Tclass.NativeTypes.uint64(), $Heap);
    ##to#2 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#2, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assert {:subsumption 0} LitInt(0) <= ##from#2;
    assert {:subsumption 0} ##from#2 <= ##to#2;
    assert {:subsumption 0} ##to#2 <= PackedStringArray.__default.psaNumStrings(##psa#5);
    assume LitInt(0) <= ##from#2
       && ##from#2 <= ##to#2
       && ##to#2 <= PackedStringArray.__default.psaNumStrings(##psa#5);
    assume PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    ##psa#6 := PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
    ##psa#7 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#7));
    assume PackedStringArray.__default.WF(##psa#7);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assert 0 <= from#0 && from#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assert from#0 <= to#0 && to#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assume Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
      Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
}



procedure Call$$PackedStringArray.__default.PsaSubSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#PackedStringArray.Psa(result#0)
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     && PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0);
  ensures PackedStringArray.Psa#Equal(result#0, PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
  free ensures PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
  free ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     && 
    PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
       < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
         == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
         == LitInt(0))
     && (0
         < Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
       ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
            Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
               - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)));
  free ensures PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
    Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.PsaSubSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap), 
    $_reverifyPost: bool);
  free requires 56 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#PackedStringArray.Psa(result#0)
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     && PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0);
  ensures PackedStringArray.Psa#Equal(result#0, PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
  free ensures PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0));
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
         < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
         < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
       || (Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
           == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
           == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
       || (0
           < Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
         ==> Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
              Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)))
                 - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)));
  free ensures PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
    Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.PsaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var dataStart#0: int where LitInt(0) <= dataStart#0 && dataStart#0 < 4294967296;
  var ##psa#8: DatatypeType;
  var ##i#0: int;
  var dataEnd#0: int where LitInt(0) <= dataEnd#0 && dataEnd#0 < 4294967296;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##psa#9: DatatypeType;
  var ##i#1: int;
  var psa##0: DatatypeType;
  var i##0: int;
  var j##0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newoffsets#0: Seq Box
     where $Is(newoffsets#0, TSeq(Tclass.NativeTypes.uint32()))
       && $IsAlloc(newoffsets#0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.uint32()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.uint32()), $Heap);
  var offsets##0: Seq Box;
  var from##0: int;
  var to##0: int;
  var psa##1: DatatypeType;
  var from##1: int;
  var to##1: int;

    // AddMethodImpl: PsaSubSeq, Impl$$PackedStringArray.__default.PsaSubSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(285,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(286,5)
    assume true;
    if (from#0 == to#0)
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(287,14)
        assume true;
        assume PackedStringArray.__default.EmptyPsa#canCall();
        assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
        assume PackedStringArray.__default.EmptyPsa#canCall();
        result#0 := Lit(PackedStringArray.__default.EmptyPsa());
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(287,26)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(289,21)
        assume true;
        ##psa#8 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0 := from#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#8));
        assume PackedStringArray.__default.WF(##psa#8);
        assert {:subsumption 0} LitInt(0) <= ##i#0;
        assert {:subsumption 0} ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8));
        assume LitInt(0) <= ##i#0 && ##i#0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8));
        assume PackedStringArray.__default.psaStart#canCall(psa#0, from#0);
        assume PackedStringArray.__default.psaStart#canCall(psa#0, from#0);
        dataStart#0 := PackedStringArray.__default.psaStart(psa#0, from#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(289,42)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(290,19)
        assume true;
        newtype$check#1 := LitInt(1);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := to#0 - 1;
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        ##psa#9 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#1 := to#0 - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#1, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
           ==> PackedStringArray.__default.WF(##psa#9)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
           ==> PackedStringArray.__default.WF(##psa#9)
             || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
           ==> PackedStringArray.__default.WF(##psa#9)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
           ==> PackedStringArray.__default.WF(##psa#9)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
           ==> PackedStringArray.__default.WF(##psa#9)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#9));
        assume PackedStringArray.__default.WF(##psa#9);
        assert {:subsumption 0} LitInt(0) <= ##i#1;
        assert {:subsumption 0} ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9));
        assume LitInt(0) <= ##i#1 && ##i#1 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9));
        assume PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1);
        assume PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1);
        dataEnd#0 := PackedStringArray.__default.psaEnd(psa#0, to#0 - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(290,38)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(291,24)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa##0 := psa#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##0 := from#0;
        newtype$check#3 := LitInt(1);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        newtype$check#4 := to#0 - 1;
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        j##0 := to#0 - 1;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaStartLtePsaEnd(psa##0, i##0, j##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(291,40)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(292,35)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type seq<uint32>
        // TrCallStmt: Before ProcessCallStmt
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // ProcessCallStmt: CheckSubrange
        offsets##0 := PackedStringArray.Psa.offsets(psa#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        from##0 := from#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        to##0 := to#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$PackedStringArray.__default.SubOffsets(offsets##0, from##0, to##0);
        // TrCallStmt: After ProcessCallStmt
        newoffsets#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(292,57)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(293,14)
        assume true;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assert 0 <= dataStart#0 && dataStart#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
        assert dataStart#0 <= dataEnd#0
           && dataEnd#0 <= Seq#Length(PackedStringArray.Psa.data(psa#0));
        assume PackedStringArray.Psa.Psa_q(psa#0);
        result#0 := #PackedStringArray.Psa.Psa(newoffsets#0, 
          Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(293,61)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(294,18)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa##1 := psa#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        from##1 := from#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        to##1 := to#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.WFpsaSubSeq(psa##1, from##1, to##1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(294,32)"} true;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.PsaPrefix(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap));
  free requires 57 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.PsaPrefix(psa#0: DatatypeType, to#0: int) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;

    // AddMethodImpl: PsaPrefix, CheckWellformed$$PackedStringArray.__default.PsaPrefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(298,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= to#0)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    }

    assume LitInt(0) <= to#0 && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(301,14): post-state"} true;
    ##psa#2 := result#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(result#0);
    assume PackedStringArray.__default.WF(result#0);
    ##psa#3 := result#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(result#0);
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assert 0 <= to#0 && to#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assume Seq#Equal(PackedStringArray.__default.I(result#0), 
      Seq#Take(PackedStringArray.__default.I(psa#0), to#0));
}



procedure Call$$PackedStringArray.__default.PsaPrefix(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.WF#canCall(result#0);
  free ensures PackedStringArray.__default.WF#canCall(result#0)
     && 
    PackedStringArray.__default.WF(result#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
       ==> Seq#Length(PackedStringArray.Psa.data(result#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
            Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      PackedStringArray.Psa.offsets(result#0));
  free ensures PackedStringArray.__default.I#canCall(result#0)
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Seq#Take(PackedStringArray.__default.I(psa#0), to#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.PsaPrefix(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap), 
    $_reverifyPost: bool);
  free requires 57 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= to#0;
  requires to#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.WF#canCall(result#0);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  free ensures PackedStringArray.__default.I#canCall(result#0)
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Seq#Take(PackedStringArray.__default.I(psa#0), to#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.PsaPrefix(psa#0: DatatypeType, to#0: int)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.PackedStringArray.Psa())
       && $IsAlloc($rhs##0, Tclass.PackedStringArray.Psa(), $Heap);
  var psa##0: DatatypeType;
  var from##0: int;
  var newtype$check#1: int;
  var to##0: int;

    // AddMethodImpl: PsaPrefix, Impl$$PackedStringArray.__default.PsaPrefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(303,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(304,24)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Psa
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    psa##0 := psa#0;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    to##0 := to#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$PackedStringArray.__default.PsaSubSeq(psa##0, from##0, to##0);
    // TrCallStmt: After ProcessCallStmt
    result#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(304,35)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.PsaSuffix(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap));
  free requires 58 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.PsaSuffix(psa#0: DatatypeType, from#0: int) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;

    // AddMethodImpl: PsaSuffix, CheckWellformed$$PackedStringArray.__default.PsaSuffix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(307,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= from#0)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    }

    assume LitInt(0) <= from#0
       && from#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(310,14): post-state"} true;
    ##psa#2 := result#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(result#0);
    assume PackedStringArray.__default.WF(result#0);
    ##psa#3 := result#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(result#0);
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assert 0 <= from#0 && from#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    assume Seq#Equal(PackedStringArray.__default.I(result#0), 
      Seq#Drop(PackedStringArray.__default.I(psa#0), from#0));
}



procedure Call$$PackedStringArray.__default.PsaSuffix(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= from#0;
  requires from#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.WF#canCall(result#0);
  free ensures PackedStringArray.__default.WF#canCall(result#0)
     && 
    PackedStringArray.__default.WF(result#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
       ==> Seq#Length(PackedStringArray.Psa.data(result#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
            Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
      PackedStringArray.Psa.offsets(result#0));
  free ensures PackedStringArray.__default.I#canCall(result#0)
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Seq#Drop(PackedStringArray.__default.I(psa#0), from#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.PsaSuffix(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616)
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(result#0, Tclass.PackedStringArray.Psa(), $Heap), 
    $_reverifyPost: bool);
  free requires 58 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires LitInt(0) <= from#0;
  requires from#0 <= PackedStringArray.__default.psaNumStrings(psa#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.WF#canCall(result#0);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  free ensures PackedStringArray.__default.I#canCall(result#0)
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Seq#Drop(PackedStringArray.__default.I(psa#0), from#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.PsaSuffix(psa#0: DatatypeType, from#0: int)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.PackedStringArray.Psa())
       && $IsAlloc($rhs##0, Tclass.PackedStringArray.Psa(), $Heap);
  var psa##0: DatatypeType;
  var from##0: int;
  var to##0: int;
  var ##psa#5: DatatypeType;

    // AddMethodImpl: PsaSuffix, Impl$$PackedStringArray.__default.PsaSuffix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(312,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(313,24)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Psa
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    psa##0 := psa#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from##0 := from#0;
    ##psa#5 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    // ProcessCallStmt: CheckSubrange
    to##0 := PackedStringArray.__default.psaNumStrings(psa#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$PackedStringArray.__default.PsaSubSeq(psa##0, from##0, to##0);
    // TrCallStmt: After ProcessCallStmt
    result#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(313,54)"} true;
}



// function declaration for PackedStringArray._default.psaDropLast
function PackedStringArray.__default.psaDropLast(psa#0: DatatypeType) : DatatypeType;

function PackedStringArray.__default.psaDropLast#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaDropLast
axiom 59 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaDropLast(psa#0) } 
    PackedStringArray.__default.psaDropLast#canCall(psa#0)
         || (59 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 0 < PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaDropLast(psa#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaDropLast(psa#0)), 
          Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa#0)))
         && $Is(PackedStringArray.__default.psaDropLast(psa#0), Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaDropLast#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaDropLast
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaDropLast#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaDropLast#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 0 < PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaDropLast(revealed)
axiom 59 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaDropLast(psa#0) } 
    PackedStringArray.__default.psaDropLast#canCall(psa#0)
         || (59 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 0 < PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         && PackedStringArray.__default.psaSubSeq#canCall(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1)
         && PackedStringArray.__default.psaDropLast(psa#0)
           == PackedStringArray.__default.psaSubSeq(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1));

// definition axiom for PackedStringArray.__default.psaDropLast for all literals(revealed)
axiom 59 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaDropLast(Lit(psa#0)) } 
    PackedStringArray.__default.psaDropLast#canCall(Lit(psa#0))
         || (59 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(0 < PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> PackedStringArray.__default.psaNumStrings#canCall(Lit(psa#0))
         && PackedStringArray.__default.psaSubSeq#canCall(Lit(psa#0), 
          LitInt(0), 
          LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0)) - 1))
         && PackedStringArray.__default.psaDropLast(Lit(psa#0))
           == Lit(PackedStringArray.__default.psaSubSeq(Lit(psa#0), 
              LitInt(0), 
              LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0)) - 1))));

procedure CheckWellformed$$PackedStringArray.__default.psaDropLast(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()))
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 59 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa#0)));



implementation CheckWellformed$$PackedStringArray.__default.psaDropLast(psa#0: DatatypeType) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var newtype$check#0: int;
  var ##psa#1: DatatypeType;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;
  var ##run#0: Seq Box;
  var psa##0: DatatypeType;
  var from##0: int;
  var newtype$check#1: int;
  var to##0: int;
  var ##psa#5: DatatypeType;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##psa#6: DatatypeType;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var ##psa#7: DatatypeType;
  var ##from#0: int;
  var ##to#0: int;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;

    // AddWellformednessCheck for function psaDropLast
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(316,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    assume 0 < PackedStringArray.__default.psaNumStrings(psa#0);
    assert b$reqreads#0;
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaDropLast(psa#0), Tclass.PackedStringArray.Psa());
        ##psa#2 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assume PackedStringArray.__default.WF#canCall(result#0);
        assume PackedStringArray.__default.WF(result#0);
        ##psa#3 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assume PackedStringArray.__default.I#canCall(result#0);
        ##psa#4 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#4));
        assume PackedStringArray.__default.WF(##psa#4);
        assume PackedStringArray.__default.I#canCall(psa#0);
        ##run#0 := PackedStringArray.__default.I(psa#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} Seq#Length(##run#0) > 0;
        assume Seq#Length(##run#0) > 0;
        assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa#0));
        assume Seq#Equal(PackedStringArray.__default.I(result#0), 
          Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa#0)));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(322,16)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa##0 := psa#0;
        newtype$check#1 := LitInt(0);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        from##0 := LitInt(0);
        ##psa#5 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
        newtype$check#2 := LitInt(1);
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := PackedStringArray.__default.psaNumStrings(psa#0) - 1;
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
        // ProcessCallStmt: CheckSubrange
        to##0 := PackedStringArray.__default.psaNumStrings(psa#0) - 1;
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.WFpsaSubSeq(psa##0, from##0, to##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(322,45)"} true;
        newtype$check#4 := LitInt(0);
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        ##psa#6 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           < NativeTypes.__default.Uint64UpperBound();
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
        newtype$check#5 := LitInt(1);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        newtype$check#6 := PackedStringArray.__default.psaNumStrings(psa#0) - 1;
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        ##psa#7 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
        ##from#0 := LitInt(0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##from#0, Tclass.NativeTypes.uint64(), $Heap);
        ##to#0 := PackedStringArray.__default.psaNumStrings(psa#0) - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##to#0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#7));
        assume PackedStringArray.__default.WF(##psa#7);
        assert {:subsumption 0} LitInt(0) <= ##from#0;
        assert {:subsumption 0} ##from#0 <= ##to#0;
        assert {:subsumption 0} ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#7);
        assume LitInt(0) <= ##from#0
           && ##from#0 <= ##to#0
           && ##to#0 <= PackedStringArray.__default.psaNumStrings(##psa#7);
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaSubSeq#canCall(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaSubSeq(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1));
        assume PackedStringArray.__default.psaDropLast(psa#0)
           == PackedStringArray.__default.psaSubSeq(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1);
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0)
           && PackedStringArray.__default.psaSubSeq#canCall(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaDropLast(psa#0), Tclass.PackedStringArray.Psa());
        assume PackedStringArray.__default.psaDropLast(psa#0) == result#0;
        assert b$reqreads#2;
        assert b$reqreads#3;
    }
}



// function declaration for PackedStringArray._default.psaCanAppend
function PackedStringArray.__default.psaCanAppend(psa#0: DatatypeType, key#0: Seq Box) : bool;

function PackedStringArray.__default.psaCanAppend#canCall(psa#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaCanAppend
axiom 17 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
         || (17 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function PackedStringArray.__default.psaCanAppend#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaCanAppend
axiom (forall psa#0: DatatypeType, key#0: Seq Box :: 
  { PackedStringArray.__default.psaCanAppend#requires(psa#0, key#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.__default.psaCanAppend#requires(psa#0, key#0) == true);

// definition axiom for PackedStringArray.__default.psaCanAppend(revealed)
axiom 17 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
         || (17 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
           ==> PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaCanAppend(psa#0, key#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppend for all literals(revealed)
axiom 17 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0)) } 
    PackedStringArray.__default.psaCanAppend#canCall(Lit(psa#0), Lit(key#0))
         || (17 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296 - 1
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0))
           == (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296 - 1
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) + Seq#Length(Lit(key#0))
               < 4294967296));

procedure CheckWellformed$$PackedStringArray.__default.psaCanAppend(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    key#0: Seq Box where $Is(key#0, TSeq(Tclass.NativeTypes.byte())));
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure CheckWellformed$$PackedStringArray.__default.PsaCanAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: bool);
  free requires 60 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$PackedStringArray.__default.PsaCanAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: bool);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.PsaCanAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: bool, $_reverifyPost: bool);
  free requires 60 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.PsaCanAppend(psa#0: DatatypeType, key#0: Seq Box)
   returns (result#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;

    // AddMethodImpl: PsaCanAppend, Impl$$PackedStringArray.__default.PsaCanAppend
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(335,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(336,12)
    assume true;
    assume PackedStringArray.Psa.Psa_q(psa#0);
    newtype$check#0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0));
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := LitInt(4294967296);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := LitInt(1);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := LitInt(4294967296 - 1);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1)
    {
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#4 := Seq#Length(PackedStringArray.Psa.data(psa#0));
        assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        newtype$check#5 := Seq#Length(key#0);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        newtype$check#6 := Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0);
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        newtype$check#7 := LitInt(4294967296);
        assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    }

    assume PackedStringArray.Psa.Psa_q(psa#0)
       && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
         ==> PackedStringArray.Psa.Psa_q(psa#0));
    result#0 := Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
       && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(338,63)"} true;
}



// function declaration for PackedStringArray._default.psaAppend
function PackedStringArray.__default.psaAppend(psa#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaAppend#canCall(psa#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaAppend
axiom 20 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
         || (20 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppend(psa#0, key#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaAppend(psa#0, key#0))
         && $Is(PackedStringArray.__default.psaAppend(psa#0, key#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaAppend#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaAppend
axiom (forall psa#0: DatatypeType, key#0: Seq Box :: 
  { PackedStringArray.__default.psaAppend#requires(psa#0, key#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.__default.psaAppend#requires(psa#0, key#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedStringArray.__default.psaCanAppend(psa#0, key#0)));

// definition axiom for PackedStringArray.__default.psaAppend(revealed)
axiom 20 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
         || (20 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppend(psa#0, key#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaAppend(psa#0, key#0)
           == (var newdata#0 := Seq#Append(PackedStringArray.Psa.data(psa#0), key#0); 
            #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(psa#0), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#0)))), 
              newdata#0)));

// definition axiom for PackedStringArray.__default.psaAppend for all literals(revealed)
axiom 20 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppend(Lit(psa#0), Lit(key#0)) } 
    PackedStringArray.__default.psaAppend#canCall(Lit(psa#0), Lit(key#0))
         || (20 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaAppend(Lit(psa#0), Lit(key#0))
           == (var newdata#1 := Seq#Append(PackedStringArray.Psa.data(Lit(psa#0)), key#0); 
            #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(Lit(psa#0)), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#1)))), 
              newdata#1)));

procedure CheckWellformed$$PackedStringArray.__default.psaAppend(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    key#0: Seq Box where $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 20 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));



implementation CheckWellformed$$PackedStringArray.__default.psaAppend(psa#0: DatatypeType, key#0: Seq Box) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##key#0: Seq Box;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##psa#2: DatatypeType;
  var newdata#2: Seq Box;
  var let#0#0#0: Seq Box;
  var run##0: Seq Box;
  var key##0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function psaAppend
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(341,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0);
    assume PackedStringArray.__default.psaCanAppend(psa#0, key#0);
    assert b$reqreads#0;
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaAppend(psa#0, key#0), 
          Tclass.PackedStringArray.Psa());
        ##psa#2 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assume PackedStringArray.__default.WF#canCall(result#0);
        assume PackedStringArray.__default.WF(result#0);
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        havoc newdata#2;
        assume $Is(newdata#2, TSeq(Tclass.NativeTypes.byte()));
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assume let#0#0#0 == Seq#Append(PackedStringArray.Psa.data(psa#0), key#0);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // CheckWellformedWithResult: any expression
        assume $Is(let#0#0#0, TSeq(Tclass.NativeTypes.byte()));
        assume newdata#2 == let#0#0#0;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(347,31)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedStringArray.Psa.Psa_q(psa#0);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // ProcessCallStmt: CheckSubrange
        run##0 := PackedStringArray.Psa.offsets(psa#0);
        newtype$check#0 := Seq#Length(newdata#2);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 4294967296;
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0 := Seq#Length(newdata#2);
        // ProcessCallStmt: Make the call
        call Call$$Uint32__Order.__default.SortedAugment(run##0, key##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(347,64)"} true;
        assume PackedStringArray.Psa.Psa_q(psa#0);
        newtype$check#1 := Seq#Length(newdata#2);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 4294967296;
        assume PackedStringArray.__default.psaAppend(psa#0, key#0)
           == #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#2)))), 
            newdata#2);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaAppend(psa#0, key#0), 
          Tclass.PackedStringArray.Psa());
        assume PackedStringArray.__default.psaAppend(psa#0, key#0) == result#0;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 28 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType, key#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##key#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##key#1: Seq Box;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;

    // AddMethodImpl: psaAppendIAppend, CheckWellformed$$PackedStringArray.__default.psaAppendIAppend
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(351,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0);
    assume PackedStringArray.__default.psaCanAppend(psa#0, key#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(354,35): post-state"} true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#1 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#2, ##key#1)
       ==> PackedStringArray.__default.psaCanAppend(##psa#2, ##key#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296 - 1;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#2, ##key#1)
       ==> PackedStringArray.__default.psaCanAppend(##psa#2, ##key#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) + Seq#Length(##key#1)
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppend(##psa#2, ##key#1);
    assume PackedStringArray.__default.psaAppend#canCall(psa#0, key#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppend(psa#0, key#0));
    ##psa#3 := PackedStringArray.__default.psaAppend(psa#0, key#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0));
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppend(psa#0, key#0)), 
      Seq#Append(PackedStringArray.__default.I(psa#0), 
        Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
}



procedure Call$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, key#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1;
  requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, key#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppend(psa#0, key#0)), 
    Seq#Append(PackedStringArray.__default.I(psa#0), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 28 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  free requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     && 
    PackedStringArray.__default.psaCanAppend(psa#0, key#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
     && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0))
     && PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppend(psa#0, key#0)), 
    Seq#Append(PackedStringArray.__default.I(psa#0), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.psaAppendIAppend(psa#0: DatatypeType, key#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ipsaa#0: Seq Box
     where $Is(ipsaa#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(ipsaa#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#5: DatatypeType;
  var ##key#2: Seq Box;
  var ##psa#6: DatatypeType;
  var aipsa#0: Seq Box
     where $Is(aipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(aipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#7: DatatypeType;
  var i#0: int;

    // AddMethodImpl: psaAppendIAppend, Impl$$PackedStringArray.__default.psaAppendIAppend
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(355,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(356,15)
    assume true;
    ##psa#5 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#2 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#2, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#5, ##key#2)
       ==> PackedStringArray.__default.psaCanAppend(##psa#5, ##key#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296 - 1;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#5, ##key#2)
       ==> PackedStringArray.__default.psaCanAppend(##psa#5, ##key#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) + Seq#Length(##key#2)
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppend(##psa#5, ##key#2);
    assume PackedStringArray.__default.psaAppend#canCall(psa#0, key#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppend(psa#0, key#0));
    ##psa#6 := PackedStringArray.__default.psaAppend(psa#0, key#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0));
    assume PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
       && PackedStringArray.__default.I#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0));
    ipsaa#0 := PackedStringArray.__default.I(PackedStringArray.__default.psaAppend(psa#0, key#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(356,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(357,15)
    assume true;
    ##psa#7 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
       ==> PackedStringArray.__default.WF(##psa#7)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#7));
    assume PackedStringArray.__default.WF(##psa#7);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    aipsa#0 := Seq#Append(PackedStringArray.__default.I(psa#0), 
      Seq#Build(Seq#Empty(): Seq Box, $Box(key#0)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(357,31)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(358,5)
    assume true;
    assert Seq#Length(ipsaa#0) == Seq#Length(aipsa#0);
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(359,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#0;
        assume true;
        if (LitInt(0) <= i#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(ipsaa#0);
        assert Seq#Equal($Unbox(Seq#Index(ipsaa#0, i#0)): Seq Box, 
          $Unbox(Seq#Index(aipsa#0, i#0)): Seq Box);
        assume false;
    }
    else
    {
        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(aipsa#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(ipsaa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(ipsaa#0)
             ==> Seq#Equal($Unbox(Seq#Index(ipsaa#0, i#1)): Seq Box, 
              $Unbox(Seq#Index(aipsa#0, i#1)): Seq Box));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(362,4)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.psaAppendTotalLength(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaAppendTotalLength(psa#0: DatatypeType, key#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##key#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##key#1: Seq Box;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;

    // AddMethodImpl: psaAppendTotalLength, CheckWellformed$$PackedStringArray.__default.psaAppendTotalLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(365,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0);
    assume PackedStringArray.__default.psaCanAppend(psa#0, key#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(368,55): post-state"} true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#1 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#2, ##key#1)
       ==> PackedStringArray.__default.psaCanAppend(##psa#2, ##key#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296 - 1;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#2, ##key#1)
       ==> PackedStringArray.__default.psaCanAppend(##psa#2, ##key#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) + Seq#Length(##key#1)
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppend(##psa#2, ##key#1);
    assume PackedStringArray.__default.psaAppend#canCall(psa#0, key#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppend(psa#0, key#0));
    ##psa#3 := PackedStringArray.__default.psaAppend(psa#0, key#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#3))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#3))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0));
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#4))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#4))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(psa#0);
    assume PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppend(psa#0, key#0))
       == PackedStringArray.__default.psaTotalLength(psa#0) + Seq#Length(key#0);
}



procedure Call$$PackedStringArray.__default.psaAppendTotalLength(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, key#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1;
  requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, key#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0))
     && PackedStringArray.__default.psaTotalLength#canCall(psa#0);
  ensures PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppend(psa#0, key#0))
     == PackedStringArray.__default.psaTotalLength(psa#0) + Seq#Length(key#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.psaAppendTotalLength(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 33 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  free requires PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
     && 
    PackedStringArray.__default.psaCanAppend(psa#0, key#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppend(psa#0, key#0))
     && PackedStringArray.__default.psaTotalLength#canCall(psa#0);
  ensures PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppend(psa#0, key#0))
     == PackedStringArray.__default.psaTotalLength(psa#0) + Seq#Length(key#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.psaAppendTotalLength(psa#0: DatatypeType, key#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: psaAppendTotalLength, Impl$$PackedStringArray.__default.psaAppendTotalLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(369,2): initial state"} true;
    $_reverifyPost := false;
}



// function declaration for PackedStringArray._default.psaCanAppendSeq
function PackedStringArray.__default.psaCanAppendSeq(psa#0: DatatypeType, strs#0: Seq Box) : bool;

function PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0: DatatypeType, strs#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaCanAppendSeq
axiom 27 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0)
         || (27 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> true);

function PackedStringArray.__default.psaCanAppendSeq#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaCanAppendSeq
axiom (forall psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaCanAppendSeq#requires(psa#0, strs#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaCanAppendSeq#requires(psa#0, strs#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq(revealed)
axiom 27 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0)
         || (27 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0)))
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
               < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq for decreasing-related literals(revealed)
axiom 27 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0)) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Lit(strs#0))
         || (27 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(Lit(strs#0))
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), Lit(strs#0))
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Lit(strs#0))))
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0))
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(Lit(strs#0))
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuel_Sequences._default.FlattenShape, 
                    Lit(strs#0)))
               < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq for all literals(revealed)
axiom 27 <= $FunctionContextHeight
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0)) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(psa#0), Lit(strs#0))
         || (27 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               + Seq#Length(Lit(strs#0))
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), Lit(strs#0))
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Lit(strs#0))))
         && PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0))
           == (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
                 + Seq#Length(Lit(strs#0))
               < 4294967296
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuel_Sequences._default.FlattenShape, 
                    Lit(strs#0)))
               < 4294967296));

procedure CheckWellformed$$PackedStringArray.__default.psaCanAppendSeq(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    strs#0: Seq Box where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte()))));
  free requires 27 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaCanAppendSeq(psa#0: DatatypeType, strs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##seqs#0: Seq Box;
  var ##shape#0: Seq Box;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;

    // AddWellformednessCheck for function psaCanAppendSeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(372,12): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    assert b$reqreads#0;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        assume PackedStringArray.Psa.Psa_q(psa#0);
        if (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
           < 4294967296)
        {
            assume PackedStringArray.Psa.Psa_q(psa#0);
            ##seqs#0 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##seqs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0);
            ##shape#0 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##shape#0, TSeq(Tclass._System.nat()), $Heap);
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
        }

        assume PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
               < 4294967296);
        assume PackedStringArray.Psa.Psa_q(psa#0)
           && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
               < 4294967296
             ==> PackedStringArray.Psa.Psa_q(psa#0)
               && 
              Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0)
               && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0)));
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0), TBool);
        assert b$reqreads#1;
        assert b$reqreads#2;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.psaCanAppendOne(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 35 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaCanAppendOne(psa#0: DatatypeType, str#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##key#0: Seq Box;

    // AddMethodImpl: psaCanAppendOne, CheckWellformed$$PackedStringArray.__default.psaCanAppendOne
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(380,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := Seq#Build(Seq#Empty(): Seq Box, $Box(str#0));
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)));
    assume PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)));
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(383,24): post-state"} true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##key#0 := str#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume PackedStringArray.__default.psaCanAppend#canCall(psa#0, str#0);
    assume PackedStringArray.__default.psaCanAppend(psa#0, str#0);
}



procedure Call$$PackedStringArray.__default.psaCanAppendOne(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
     ==> PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0))
           + Seq#Length(Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
     ==> PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
       || Seq#Length(PackedStringArray.Psa.data(psa#0))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              Seq#Build(Seq#Empty(): Seq Box, $Box(str#0))))
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaCanAppend#canCall(psa#0, str#0);
  free ensures PackedStringArray.__default.psaCanAppend#canCall(psa#0, str#0)
     && 
    PackedStringArray.__default.psaCanAppend(psa#0, str#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(str#0) < 4294967296;
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.psaCanAppendOne(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    str#0: Seq Box
       where $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(str#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 35 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
     && 
    PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         + Seq#Length(Seq#Build(Seq#Empty(): Seq Box, $Box(str#0)))
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
            StartFuel_Sequences._default.FlattenShape, 
            Seq#Build(Seq#Empty(): Seq Box, $Box(str#0))))
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaCanAppend#canCall(psa#0, str#0);
  ensures PackedStringArray.__default.psaCanAppend#canCall(psa#0, str#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, str#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1;
  ensures PackedStringArray.__default.psaCanAppend#canCall(psa#0, str#0)
     ==> PackedStringArray.__default.psaCanAppend(psa#0, str#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(str#0) < 4294967296;
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.psaCanAppendOne(psa#0: DatatypeType, str#0: Seq Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: psaCanAppendOne, Impl$$PackedStringArray.__default.psaCanAppendOne
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(384,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(385,24)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sequences.__default.reveal__FlattenShape();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(385,25)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(386,25)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sequences.__default.reveal__FlattenLength();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(386,26)"} true;
}



// function declaration for PackedStringArray._default.psaAppendSeq
function PackedStringArray.__default.psaAppendSeq($ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaAppendSeq#canCall(psa#0: DatatypeType, strs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0) } 
  PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0)
     == PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq(AsFuelBottom($ly), psa#0, strs#0) } 
  PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0)
     == PackedStringArray.__default.psaAppendSeq($LZ, psa#0, strs#0));

// consequence axiom for PackedStringArray.__default.psaAppendSeq
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs#0)
         || (29 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0)), 
          Seq#Append(PackedStringArray.__default.I(psa#0), strs#0))
         && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0))
           == PackedStringArray.__default.psaTotalLength(psa#0)
             + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
         && $Is(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaAppendSeq#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaAppendSeq
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq#requires($ly, psa#0, strs#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaAppendSeq#requires($ly, psa#0, strs#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)));

// definition axiom for PackedStringArray.__default.psaAppendSeq(revealed)
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs#0)
         || (29 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0))
       ==> (Seq#Length(strs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
             && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
             && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($ly, 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0)
           == (if Seq#Length(strs#0) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($ly, 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box)));

// definition axiom for PackedStringArray.__default.psaAppendSeq for decreasing-related literals(revealed)
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, Lit(strs#0)) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Lit(strs#0))
         || (29 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0)))
       ==> (Seq#Length(Lit(strs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, 
              Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                psa#0, 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0)))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box)))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, Lit(strs#0))
           == (if Seq#Length(Lit(strs#0)) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                psa#0, 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0)))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box))));

// definition axiom for PackedStringArray.__default.psaAppendSeq for all literals(revealed)
axiom 29 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppendSeq($LS($ly), Lit(psa#0), Lit(strs#0)) } 
    PackedStringArray.__default.psaAppendSeq#canCall(Lit(psa#0), Lit(strs#0))
         || (29 != $FunctionContextHeight
           && 
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0))))
       ==> (Seq#Length(Lit(strs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppendSeq#canCall(Lit(psa#0), 
              Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppend#canCall(Lit(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                  Lit(psa#0), 
                  Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box)))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), Lit(psa#0), Lit(strs#0))
           == (if Seq#Length(Lit(strs#0)) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(Lit(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                  Lit(psa#0), 
                  Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box))));

procedure CheckWellformed$$PackedStringArray.__default.psaAppendSeq(psa#0: DatatypeType where $Is(psa#0, Tclass.PackedStringArray.Psa()), 
    strs#0: Seq Box where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 29 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), 
    Seq#Append(PackedStringArray.__default.I(psa#0), strs#0));
  ensures PackedStringArray.__default.psaTotalLength(result#0)
     == PackedStringArray.__default.psaTotalLength(psa#0)
       + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
        Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
          StartFuelAssert_Sequences._default.FlattenShape, 
          strs#0));



implementation CheckWellformed$$PackedStringArray.__default.psaAppendSeq(psa#0: DatatypeType, strs#0: Seq Box) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##strs#0: Seq Box;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##psa#4: DatatypeType;
  var ##psa#5: DatatypeType;
  var ##psa#6: DatatypeType;
  var ##seqs#0: Seq Box;
  var ##shape#0: Seq Box;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##run#0: Seq Box;
  var ##run#1: Seq Box;
  var seqs1##0: Seq Box;
  var ##run#2: Seq Box;
  var seqs2##0: Seq Box;
  var ##run#3: Seq Box;
  var shape1##0: Seq Box;
  var ##run#4: Seq Box;
  var ##seqs#1: Seq Box;
  var shape2##0: Seq Box;
  var ##run#5: Seq Box;
  var ##seqs#2: Seq Box;
  var ##run#6: Seq Box;
  var ##seqs#3: Seq Box;
  var ##shape#1: Seq Box;
  var ##seqs#4: Seq Box;
  var ##shape#2: Seq Box;
  var ##run#7: Seq Box;
  var ##run#8: Seq Box;
  var ##seqs#5: Seq Box;
  var ##shape#3: Seq Box;
  var psa##0: DatatypeType;
  var ##run#9: Seq Box;
  var ##psa#7: DatatypeType;
  var ##strs#1: Seq Box;
  var key##0: Seq Box;
  var ##run#10: Seq Box;
  var ##run#11: Seq Box;
  var ##psa#8: DatatypeType;
  var ##strs#2: Seq Box;
  var ##run#12: Seq Box;
  var ##psa#9: DatatypeType;
  var ##key#0: Seq Box;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;

    // AddWellformednessCheck for function psaAppendSeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(389,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0);
    assert b$reqreads#0;
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs#0), 
          Tclass.PackedStringArray.Psa());
        ##psa#2 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assume PackedStringArray.__default.WF#canCall(result#0);
        assume PackedStringArray.__default.WF(result#0);
        ##psa#3 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assume PackedStringArray.__default.I#canCall(result#0);
        ##psa#4 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#4));
        assume PackedStringArray.__default.WF(##psa#4);
        assume PackedStringArray.__default.I#canCall(psa#0);
        assume Seq#Equal(PackedStringArray.__default.I(result#0), 
          Seq#Append(PackedStringArray.__default.I(psa#0), strs#0));
        ##psa#5 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#5))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.data(##psa#5))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaTotalLength#canCall(result#0);
        ##psa#6 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#6))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.data(##psa#6))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaTotalLength#canCall(psa#0);
        ##seqs#0 := strs#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##seqs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0);
        ##shape#0 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##shape#0, TSeq(Tclass._System.nat()), $Heap);
        assume Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
        newtype$check#0 := Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        newtype$check#1 := PackedStringArray.__default.psaTotalLength(psa#0)
           + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        assume PackedStringArray.__default.psaTotalLength(result#0)
           == PackedStringArray.__default.psaTotalLength(psa#0)
             + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        if (Seq#Length(strs#0) == LitInt(0))
        {
            assume PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs#0) == psa#0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs#0), 
              Tclass.PackedStringArray.Psa());
        }
        else
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(400,7)
            ##run#0 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##run#1 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            assert Seq#Equal(strs#0, 
              Seq#Append(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0))));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(401,27)
            // TrCallStmt: Before ProcessCallStmt
            ##run#2 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#2) > 0;
            assume Seq#Length(##run#2) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // ProcessCallStmt: CheckSubrange
            seqs1##0 := Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##run#3 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#3) > 0;
            assume Seq#Length(##run#3) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // ProcessCallStmt: CheckSubrange
            seqs2##0 := Seq#Build(Seq#Empty(): Seq Box, 
              Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // ProcessCallStmt: Make the call
            call Call$$Sequences.__default.FlattenShapeAdditive(Tclass.NativeTypes.byte(), seqs1##0, seqs2##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(401,56)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(402,28)
            // TrCallStmt: Before ProcessCallStmt
            ##run#4 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#4, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#4) > 0;
            assume Seq#Length(##run#4) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##seqs#1 := Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##seqs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
              Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // ProcessCallStmt: CheckSubrange
            shape1##0 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuel_Sequences._default.FlattenShape, 
              Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            ##run#5 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#5, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#5) > 0;
            assume Seq#Length(##run#5) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##seqs#2 := Seq#Build(Seq#Empty(): Seq Box, 
              Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##seqs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
              Seq#Build(Seq#Empty(): Seq Box, 
                Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            // ProcessCallStmt: CheckSubrange
            shape2##0 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuel_Sequences._default.FlattenShape, 
              Seq#Build(Seq#Empty(): Seq Box, 
                Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            // ProcessCallStmt: Make the call
            call Call$$Sequences.__default.FlattenLengthAdditive(shape1##0, shape2##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(402,85)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(403,7)
            ##run#6 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#6, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#6) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##seqs#3 := Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##seqs#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
              Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            ##shape#1 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuel_Sequences._default.FlattenShape, 
              Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##shape#1, TSeq(Tclass._System.nat()), $Heap);
            assume Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            ##seqs#4 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##seqs#4, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0);
            ##shape#2 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##shape#2, TSeq(Tclass._System.nat()), $Heap);
            assume Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0))
               && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                  StartFuel_Sequences._default.FlattenShape, 
                  Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)))
               && 
              Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0)
               && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
            assert {:subsumption 0} Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                  StartFuelAssert_Sequences._default.FlattenShape, 
                  Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)))
               <= Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                  StartFuelAssert_Sequences._default.FlattenShape, 
                  strs#0));
            assume Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                  StartFuelAssert_Sequences._default.FlattenShape, 
                  Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)))
               <= Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0));
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(404,7)
            ##run#7 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#7, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#7) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##run#8 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#8, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#8) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##seqs#5 := Seq#Build(Seq#Empty(): Seq Box, 
              Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##seqs#5, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
              Seq#Build(Seq#Empty(): Seq Box, 
                Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            ##shape#3 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuel_Sequences._default.FlattenShape, 
              Seq#Build(Seq#Empty(): Seq Box, 
                Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            // assume allocatedness for argument to function
            assume $IsAlloc(##shape#3, TSeq(Tclass._System.nat()), $Heap);
            assume Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0))));
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && 
              Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)))
               && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                  StartFuel_Sequences._default.FlattenShape, 
                  Seq#Build(Seq#Empty(): Seq Box, 
                    Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0))));
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(404,7)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(405,28)
                // TrCallStmt: Before ProcessCallStmt
                // ProcessCallStmt: Make the call
                call Call$$Sequences.__default.reveal__FlattenShape();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(405,29)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(406,29)
                // TrCallStmt: Before ProcessCallStmt
                // ProcessCallStmt: Make the call
                call Call$$Sequences.__default.reveal__FlattenLength();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(406,30)"} true;
                assert {:subsumption 0} Seq#Length($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box)
                   == Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                    Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                      StartFuelAssert_Sequences._default.FlattenShape, 
                      Seq#Build(Seq#Empty(): Seq Box, 
                        Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0))));
                assume false;
            }

            assume Seq#Length($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box)
               == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                  StartFuelAssert_Sequences._default.FlattenShape, 
                  Seq#Build(Seq#Empty(): Seq Box, 
                    Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0))));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(408,23)
            // TrCallStmt: Before ProcessCallStmt
            ##run#9 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#9, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#9) > 0;
            assume Seq#Length(##run#9) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##psa#7 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#1 := Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#7));
            assume PackedStringArray.__default.WF(##psa#7);
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#7, ##strs#1)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#7, ##strs#1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) + Seq#Length(##strs#1)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#7, ##strs#1)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#7, ##strs#1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#7))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#1))
                   < 4294967296;
            assume PackedStringArray.__default.psaCanAppendSeq(##psa#7, ##strs#1);
            assert 0 <= Seq#Length(strs#0) || Seq#Length(##strs#1) == Seq#Length(strs#0);
            assert 0 <= LitInt(1)
               || Seq#Length(##strs#1) < Seq#Length(strs#0)
               || LitInt(1) == LitInt(1);
            assert Seq#Length(##strs#1) < Seq#Length(strs#0)
               || (Seq#Length(##strs#1) == Seq#Length(strs#0) && LitInt(1) < LitInt(1));
            assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // ProcessCallStmt: CheckSubrange
            psa##0 := PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              psa#0, 
              Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            ##run#10 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#10, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#10) > 0;
            assume Seq#Length(##run#10) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // ProcessCallStmt: CheckSubrange
            key##0 := $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box;
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.__default.psaAppendIAppend(psa##0, key##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(408,69)"} true;
            ##run#11 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#11, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#11) > 0;
            assume Seq#Length(##run#11) > 0;
            b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##psa#8 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#2 := Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#8));
            assume PackedStringArray.__default.WF(##psa#8);
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#8, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#8, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) + Seq#Length(##strs#2)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#8, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#8, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#8))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#2))
                   < 4294967296;
            assume PackedStringArray.__default.psaCanAppendSeq(##psa#8, ##strs#2);
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= Seq#Length(strs#0) || Seq#Length(##strs#2) == Seq#Length(strs#0);
            assert 0 <= LitInt(1)
               || Seq#Length(##strs#2) < Seq#Length(strs#0)
               || LitInt(1) == LitInt(1);
            assert Seq#Length(##strs#2) < Seq#Length(strs#0)
               || (Seq#Length(##strs#2) == Seq#Length(strs#0) && LitInt(1) < LitInt(1));
            assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)));
            ##run#12 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#12, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#12) > 0;
            assume Seq#Length(##run#12) > 0;
            b$reqreads#4 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            ##psa#9 := PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              psa#0, 
              Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
            ##key#0 := $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#9));
            assume PackedStringArray.__default.WF(##psa#9);
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#9, ##key#0)
               ==> PackedStringArray.__default.psaCanAppend(##psa#9, ##key#0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296 - 1;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppend#canCall(##psa#9, ##key#0)
               ==> PackedStringArray.__default.psaCanAppend(##psa#9, ##key#0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#9)) + Seq#Length(##key#0)
                   < 4294967296;
            assume PackedStringArray.__default.psaCanAppend(##psa#9, ##key#0);
            b$reqreads#5 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                  psa#0, 
                  Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
                $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box));
            assume PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs#0)
               == PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                  psa#0, 
                  Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
                $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0))
               && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
               && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
                  psa#0, 
                  Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
                $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box);
            // CheckWellformedWithResult: any expression
            assume $Is(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs#0), 
              Tclass.PackedStringArray.Psa());
        }

        assume PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs#0) == result#0;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
    }
}



procedure {:_induction psa#0, strs1#0} CheckWellformed$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    strs1#0: Seq Box
       where $Is(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    strs2#0: Seq Box
       where $Is(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 30 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation {:_induction psa#0, strs1#0} CheckWellformed$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa#0: DatatypeType, strs1#0: Seq Box, strs2#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##strs#1: Seq Box;
  var ##psa#3: DatatypeType;
  var ##strs#2: Seq Box;
  var ##psa#4: DatatypeType;
  var ##strs#3: Seq Box;

    // AddMethodImpl: psaCanAppendSeqAdditive, CheckWellformed$$PackedStringArray.__default.psaCanAppendSeqAdditive
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(412,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(414,48): post-state"} true;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := Seq#Append(strs1#0, strs2#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0));
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#1 := strs1#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0);
    if (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0))
    {
        ##psa#3 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#2 := strs1#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) + Seq#Length(##strs#2)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    ##strs#2))
               < 4294967296;
        assume PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2);
        assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0));
        ##psa#4 := PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#3 := strs2#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#4));
        assume PackedStringArray.__default.WF(##psa#4);
        assume PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
    }

    assume PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
       <==> PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
         && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
}



procedure {:_induction psa#0, strs1#0} Call$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    strs1#0: Seq Box
       where $Is(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    strs2#0: Seq Box
       where $Is(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
     && (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       ==> PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0)
         && PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0));
  ensures PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
     <==> PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0), strs2#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction psa#0, strs1#0} Impl$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    strs1#0: Seq Box
       where $Is(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    strs2#0: Seq Box
       where $Is(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 30 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
     && (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       ==> PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0)
         && PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0));
  ensures PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
     <==> PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0), strs2#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction psa#0, strs1#0} Impl$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa#0: DatatypeType, strs1#0: Seq Box, strs2#0: Seq Box)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var seqs1##0: Seq Box;
  var seqs2##0: Seq Box;
  var shape1##0: Seq Box;
  var ##seqs#0: Seq Box;
  var shape2##0: Seq Box;
  var ##seqs#1: Seq Box;

    // AddMethodImpl: psaCanAppendSeqAdditive, Impl$$PackedStringArray.__default.psaCanAppendSeqAdditive
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(416,2): initial state"} true;
    assume $IsA#PackedStringArray.Psa(psa#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#psa0#0: DatatypeType, $ih#strs10#0: Seq Box :: 
      $Is($ih#psa0#0, Tclass.PackedStringArray.Psa())
           && $Is($ih#strs10#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF($ih#psa0#0)
           && (DtRank($ih#psa0#0) < DtRank(psa#0)
             || (DtRank($ih#psa0#0) == DtRank(psa#0)
               && (Seq#Rank($ih#strs10#0) < Seq#Rank(strs1#0)
                 || (Seq#Rank($ih#strs10#0) == Seq#Rank(strs1#0)
                   && Seq#Rank(strs2#0) < Seq#Rank(strs2#0)))))
         ==> (PackedStringArray.__default.psaCanAppendSeq($ih#psa0#0, Seq#Append($ih#strs10#0, strs2#0))
           <==> PackedStringArray.__default.psaCanAppendSeq($ih#psa0#0, $ih#strs10#0)
             && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), $ih#psa0#0, $ih#strs10#0), 
              strs2#0)));
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(417,25)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    seqs1##0 := strs1#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    seqs2##0 := strs2#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sequences.__default.FlattenShapeAdditive(Tclass.NativeTypes.byte(), seqs1##0, seqs2##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(417,38)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(418,26)
    // TrCallStmt: Before ProcessCallStmt
    ##seqs#0 := strs1#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##seqs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs1#0);
    assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs1#0);
    // ProcessCallStmt: CheckSubrange
    shape1##0 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs1#0);
    ##seqs#1 := strs2#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##seqs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs2#0);
    assume Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs2#0);
    // ProcessCallStmt: CheckSubrange
    shape2##0 := Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs2#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sequences.__default.FlattenLengthAdditive(shape1##0, shape2##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(418,67)"} true;
}



procedure {:_induction psa#0, strs1#0, strs2#0} CheckWellformed$$PackedStringArray.__default.psaAppendSeqAdditive(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    strs1#0: Seq Box
       where $Is(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    strs2#0: Seq Box
       where $Is(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 31 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation {:_induction psa#0, strs1#0, strs2#0} CheckWellformed$$PackedStringArray.__default.psaAppendSeqAdditive(psa#0: DatatypeType, strs1#0: Seq Box, strs2#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##strs#1: Seq Box;
  var ##psa#3: DatatypeType;
  var ##strs#2: Seq Box;
  var ##psa#4: DatatypeType;
  var ##strs#3: Seq Box;
  var ##psa#5: DatatypeType;
  var ##strs#4: Seq Box;
  var ##psa#6: DatatypeType;
  var ##strs#5: Seq Box;
  var ##psa#7: DatatypeType;
  var ##strs#6: Seq Box;
  var ##psa#8: DatatypeType;
  var ##strs#7: Seq Box;
  var ##psa#9: DatatypeType;
  var ##strs#8: Seq Box;
  var ##psa#10: DatatypeType;
  var ##strs#9: Seq Box;
  var ##psa#11: DatatypeType;
  var ##strs#10: Seq Box;

    // AddMethodImpl: psaAppendSeqAdditive, CheckWellformed$$PackedStringArray.__default.psaAppendSeqAdditive
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(453,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    if (*)
    {
        ##psa#1 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#0 := Seq#Append(strs1#0, strs2#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
           ==> PackedStringArray.__default.WF(##psa#1)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#1));
        assume PackedStringArray.__default.WF(##psa#1);
        assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0));
        assume PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0));
    }
    else
    {
        assume !PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0));
        ##psa#2 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#1 := strs1#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0);
        if (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0))
        {
            ##psa#3 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#2 := strs1#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assume PackedStringArray.__default.WF(##psa#3);
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) + Seq#Length(##strs#2)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#2))
                   < 4294967296;
            assume PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2);
            assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0));
            ##psa#4 := PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#3 := strs2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
               ==> PackedStringArray.__default.WF(##psa#4)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#4));
            assume PackedStringArray.__default.WF(##psa#4);
            assume PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
        }

        assume PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
           && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
    }

    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(457,48): post-state"} true;
    ##psa#5 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#4 := Seq#Append(strs1#0, strs2#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#4, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0));
    assume PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0));
    ##psa#6 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#5 := strs1#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#5, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0);
    if (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0))
    {
        ##psa#7 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#6 := strs1#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#6, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
           ==> PackedStringArray.__default.WF(##psa#7)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#7));
        assume PackedStringArray.__default.WF(##psa#7);
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#7, ##strs#6)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#7, ##strs#6)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) + Seq#Length(##strs#6)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#7, ##strs#6)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#7, ##strs#6)
             || Seq#Length(PackedStringArray.Psa.data(##psa#7))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    ##strs#6))
               < 4294967296;
        assume PackedStringArray.__default.psaCanAppendSeq(##psa#7, ##strs#6);
        assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0));
        ##psa#8 := PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#7 := strs2#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#7, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
           ==> PackedStringArray.__default.WF(##psa#8)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#8));
        assume PackedStringArray.__default.WF(##psa#8);
        assume PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
    }

    assume PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
    ##psa#9 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#8 := Seq#Append(strs1#0, strs2#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#8, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
       ==> PackedStringArray.__default.WF(##psa#9)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#9));
    assume PackedStringArray.__default.WF(##psa#9);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#9, ##strs#8)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#9, ##strs#8)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) + Seq#Length(##strs#8)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#9, ##strs#8)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#9, ##strs#8)
         || Seq#Length(PackedStringArray.Psa.data(##psa#9))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#8))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#9, ##strs#8);
    assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0));
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, Seq#Append(strs1#0, strs2#0)));
    ##psa#10 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#10, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#9 := strs1#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#9, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Seq#Length(PackedStringArray.Psa.data(##psa#10)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#10))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#10))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#10), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
       ==> PackedStringArray.__default.WF(##psa#10)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#10));
    assume PackedStringArray.__default.WF(##psa#10);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#10, ##strs#9)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#10, ##strs#9)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) + Seq#Length(##strs#9)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#10, ##strs#9)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#10, ##strs#9)
         || Seq#Length(PackedStringArray.Psa.data(##psa#10))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#9))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#10, ##strs#9);
    assume PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0));
    ##psa#11 := PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#11, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#10 := strs2#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#10, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Seq#Length(PackedStringArray.Psa.data(##psa#11)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#11)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#11))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#11), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
       ==> PackedStringArray.__default.WF(##psa#11)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#11));
    assume PackedStringArray.__default.WF(##psa#11);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#11, ##strs#10)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#11, ##strs#10)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) + Seq#Length(##strs#10)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#11, ##strs#10)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#11, ##strs#10)
         || Seq#Length(PackedStringArray.Psa.data(##psa#11))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#10))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#11, ##strs#10);
    assume PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), 
        strs2#0));
    assume PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, Seq#Append(strs1#0, strs2#0)), 
      PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), 
        strs2#0));
}



procedure {:_induction psa#0, strs1#0, strs2#0} Call$$PackedStringArray.__default.psaAppendSeqAdditive(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    strs1#0: Seq Box
       where $Is(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    strs2#0: Seq Box
       where $Is(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
     || (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0), strs2#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && (PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
       ==> PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
         && (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
           ==> PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0)
             && PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)));
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && 
    PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         + Seq#Length(Seq#Append(strs1#0, strs2#0))
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
            StartFuel_Sequences._default.FlattenShape, 
            Seq#Append(strs1#0, strs2#0)))
       < 4294967296;
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs1#0)
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs1#0))
       < 4294967296;
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0)))
         + Seq#Length(strs2#0)
       < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0)))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs2#0))
       < 4294967296;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, Seq#Append(strs1#0, strs2#0)))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), 
        strs2#0))
     && 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, Seq#Append(strs1#0, strs2#0)), 
    PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
      PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0), 
      strs2#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction psa#0, strs1#0, strs2#0} Impl$$PackedStringArray.__default.psaAppendSeqAdditive(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    strs1#0: Seq Box
       where $Is(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs1#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    strs2#0: Seq Box
       where $Is(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs2#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns ($_reverifyPost: bool);
  free requires 31 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
     || (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0), strs2#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && (PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
       ==> PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
         && (PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
           ==> PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0)
             && PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)));
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     ==> PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0))
           + Seq#Length(Seq#Append(strs1#0, strs2#0))
         < 4294967296;
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     ==> PackedStringArray.__default.psaCanAppendSeq(psa#0, Seq#Append(strs1#0, strs2#0))
       || Seq#Length(PackedStringArray.Psa.data(psa#0))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              Seq#Append(strs1#0, strs2#0)))
         < 4294967296;
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs1#0)
         < 4294967296;
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs1#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(psa#0, strs1#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs1#0))
         < 4294967296;
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)
       || Seq#Length(PackedStringArray.Psa.offsets(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0)))
           + Seq#Length(strs2#0)
         < 4294967296;
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0)
       || Seq#Length(PackedStringArray.Psa.data(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0)))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs2#0))
         < 4294967296;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, Seq#Append(strs1#0, strs2#0)))
     && $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), 
        strs2#0))
     && 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Seq#Append(strs1#0, strs2#0))
     && 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs1#0)
     && PackedStringArray.__default.psaAppendSeq#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), psa#0, strs1#0), strs2#0);
  ensures PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, Seq#Append(strs1#0, strs2#0)), 
    PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
      PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), psa#0, strs1#0), 
      strs2#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction psa#0, strs1#0, strs2#0} Impl$$PackedStringArray.__default.psaAppendSeqAdditive(psa#0: DatatypeType, strs1#0: Seq Box, strs2#0: Seq Box)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var psa##0: DatatypeType;
  var strs1##0: Seq Box;
  var strs2##0: Seq Box;
  var ##run#0: Seq Box;
  var ##run#1: Seq Box;
  var psa##1: DatatypeType;
  var strs1##1: Seq Box;
  var ##run#2: Seq Box;
  var strs2##1: Seq Box;
  var ##run#3: Seq Box;

    // AddMethodImpl: psaAppendSeqAdditive, Impl$$PackedStringArray.__default.psaAppendSeqAdditive
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(460,2): initial state"} true;
    assume $IsA#PackedStringArray.Psa(psa#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#psa0#0: DatatypeType, $ih#strs10#0: Seq Box, $ih#strs20#0: Seq Box :: 
      $Is($ih#psa0#0, Tclass.PackedStringArray.Psa())
           && $Is($ih#strs10#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is($ih#strs20#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF($ih#psa0#0)
           && (PackedStringArray.__default.psaCanAppendSeq($ih#psa0#0, Seq#Append($ih#strs10#0, $ih#strs20#0))
             || (PackedStringArray.__default.psaCanAppendSeq($ih#psa0#0, $ih#strs10#0)
               && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), $ih#psa0#0, $ih#strs10#0), 
                $ih#strs20#0)))
           && (DtRank($ih#psa0#0) < DtRank(psa#0)
             || (DtRank($ih#psa0#0) == DtRank(psa#0)
               && (Seq#Rank($ih#strs10#0) < Seq#Rank(strs1#0)
                 || (Seq#Rank($ih#strs10#0) == Seq#Rank(strs1#0)
                   && Seq#Rank($ih#strs20#0) < Seq#Rank(strs2#0)))))
         ==> PackedStringArray.__default.psaCanAppendSeq($ih#psa0#0, Seq#Append($ih#strs10#0, $ih#strs20#0))
           && 
          PackedStringArray.__default.psaCanAppendSeq($ih#psa0#0, $ih#strs10#0)
           && PackedStringArray.__default.psaCanAppendSeq(PackedStringArray.__default.psaAppendSeq($LS($LZ), $ih#psa0#0, $ih#strs10#0), 
            $ih#strs20#0)
           && PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LZ), $ih#psa0#0, Seq#Append($ih#strs10#0, $ih#strs20#0)), 
            PackedStringArray.__default.psaAppendSeq($LS($LZ), 
              PackedStringArray.__default.psaAppendSeq($LS($LZ), $ih#psa0#0, $ih#strs10#0), 
              $ih#strs20#0)));
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(461,28)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    psa##0 := psa#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    strs1##0 := strs1#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    strs2##0 := strs2#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa##0, strs1##0, strs2##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(461,46)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(462,5)
    assume true;
    if (Seq#Length(strs2#0) == LitInt(0))
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(463,7)
        assume true;
        assert Seq#Equal(Seq#Append(strs1#0, strs2#0), strs1#0);
    }
    else
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(464,12)
        assume true;
        if (Seq#Length(strs2#0) == LitInt(1))
        {
        }
        else
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(466,7)
            ##run#0 := strs2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            ##run#1 := strs2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0)
               && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            assert Seq#Equal(Seq#Append(Seq#Append(strs1#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs2#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs2#0))), 
              Seq#Append(strs1#0, strs2#0));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(467,30)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            psa##1 := psa#0;
            ##run#2 := strs2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#2) > 0;
            assume Seq#Length(##run#2) > 0;
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            // ProcessCallStmt: CheckSubrange
            strs1##1 := Seq#Append(strs1#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs2#0));
            ##run#3 := strs2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#3) > 0;
            assume Seq#Length(##run#3) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs2#0);
            // ProcessCallStmt: CheckSubrange
            strs2##1 := Seq#Build(Seq#Empty(): Seq Box, 
              Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs2#0));
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.__default.psaCanAppendSeqAdditive(psa##1, strs1##1, strs2##1);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(467,74)"} true;
        }
    }
}



// function declaration for PackedStringArray._default.psaFromSeq
function PackedStringArray.__default.psaFromSeq(strs#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaFromSeq#canCall(strs#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaFromSeq
axiom 46 <= $FunctionContextHeight
   ==> (forall strs#0: Seq Box :: 
    { PackedStringArray.__default.psaFromSeq(strs#0) } 
    PackedStringArray.__default.psaFromSeq#canCall(strs#0)
         || (46 != $FunctionContextHeight
           && 
          $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaFromSeq(strs#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaFromSeq(strs#0)), 
          strs#0)
         && $Is(PackedStringArray.__default.psaFromSeq(strs#0), Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaFromSeq#requires(Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaFromSeq
axiom (forall strs#0: Seq Box :: 
  { PackedStringArray.__default.psaFromSeq#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaFromSeq#requires(strs#0)
       == PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0));

// definition axiom for PackedStringArray.__default.psaFromSeq(revealed)
axiom 46 <= $FunctionContextHeight
   ==> (forall strs#0: Seq Box :: 
    { PackedStringArray.__default.psaFromSeq(strs#0) } 
    PackedStringArray.__default.psaFromSeq#canCall(strs#0)
         || (46 != $FunctionContextHeight
           && 
          $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0))
       ==> PackedStringArray.__default.EmptyPsa#canCall()
         && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
         && PackedStringArray.__default.psaFromSeq(strs#0)
           == PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));

// definition axiom for PackedStringArray.__default.psaFromSeq for all literals(revealed)
axiom 46 <= $FunctionContextHeight
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaFromSeq(Lit(strs#0)) } 
    PackedStringArray.__default.psaFromSeq#canCall(Lit(strs#0))
         || (46 != $FunctionContextHeight
           && 
          $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && Lit(PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))))
       ==> PackedStringArray.__default.EmptyPsa#canCall()
         && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))
         && PackedStringArray.__default.psaFromSeq(Lit(strs#0))
           == Lit(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))));

procedure CheckWellformed$$PackedStringArray.__default.psaFromSeq(strs#0: Seq Box where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte()))))
   returns (result#0: DatatypeType where $Is(result#0, Tclass.PackedStringArray.Psa()));
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.offsets(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Seq#Length(PackedStringArray.Psa.data(result#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(result#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(result#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(result#0))
         ==> Seq#Length(PackedStringArray.Psa.data(result#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(result#0), 
              Seq#Length(PackedStringArray.Psa.offsets(result#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(result#0)
     ==> PackedStringArray.__default.WF(result#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(result#0));
  ensures Seq#Equal(PackedStringArray.__default.I(result#0), strs#0);



implementation CheckWellformed$$PackedStringArray.__default.psaFromSeq(strs#0: Seq Box) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##strs#1: Seq Box;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;

    // AddWellformednessCheck for function psaFromSeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(471,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#0 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    assert b$reqreads#0;
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(PackedStringArray.__default.psaFromSeq(strs#0), Tclass.PackedStringArray.Psa());
        ##psa#1 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
        assume PackedStringArray.__default.WF#canCall(result#0);
        assume PackedStringArray.__default.WF(result#0);
        ##psa#2 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assume PackedStringArray.__default.I#canCall(result#0);
        assume Seq#Equal(PackedStringArray.__default.I(result#0), strs#0);
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.EmptyPsa#canCall();
        assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
        ##psa#3 := Lit(PackedStringArray.__default.EmptyPsa());
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#1 := strs#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#1)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#1)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) + Seq#Length(##strs#1)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#1)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#1)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    ##strs#1))
               < 4294967296;
        assume PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#1);
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
        assume PackedStringArray.__default.psaFromSeq(strs#0)
           == PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
        assume PackedStringArray.__default.EmptyPsa#canCall()
           && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
        // CheckWellformedWithResult: any expression
        assume $Is(PackedStringArray.__default.psaFromSeq(strs#0), Tclass.PackedStringArray.Psa());
        assume PackedStringArray.__default.psaFromSeq(strs#0) == result#0;
        assert b$reqreads#2;
        assert b$reqreads#3;
    }
}



procedure CheckWellformed$$PackedStringArray.__default.psaCanAppendI(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0));
  free requires 61 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaCanAppendI(psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#4: DatatypeType;
  var ##psa#5: DatatypeType;
  var ##strs#1: Seq Box;

    // AddMethodImpl: psaCanAppendI, CheckWellformed$$PackedStringArray.__default.psaCanAppendI
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(479,8): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(481,27): post-state"} true;
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##psa#3 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##psa#5 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#1 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
       ==> PackedStringArray.__default.WF(##psa#5)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#5));
    assume PackedStringArray.__default.WF(##psa#5);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#5, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#5, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) + Seq#Length(##strs#1)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#5, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#5, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#5))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#1))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#5, ##strs#1);
    assume PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        Lit(PackedStringArray.__default.EmptyPsa()), 
        PackedStringArray.__default.I(psa#0)));
    assume PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        Lit(PackedStringArray.__default.EmptyPsa()), 
        PackedStringArray.__default.I(psa#0)), 
      psa#0);
}



procedure Call$$PackedStringArray.__default.psaCanAppendI(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.I#canCall(psa#0)
     && PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
  free ensures PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0))
     && 
    PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0))
     && 
    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Seq#Length(PackedStringArray.__default.I(psa#0))
       < 4294967296
     && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
            StartFuel_Sequences._default.FlattenShape, 
            PackedStringArray.__default.I(psa#0)))
       < 4294967296;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        Lit(PackedStringArray.__default.EmptyPsa()), 
        PackedStringArray.__default.I(psa#0)))
     && $IsA#PackedStringArray.Psa(psa#0)
     && 
    PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.I#canCall(psa#0)
     && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
  ensures PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
      Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0)), 
    psa#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.psaCanAppendI(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0))
   returns ($_reverifyPost: bool);
  free requires 61 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.I#canCall(psa#0)
     && PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0))
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
        PackedStringArray.__default.I(psa#0))
       || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Seq#Length(PackedStringArray.__default.I(psa#0))
         < 4294967296;
  ensures PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0))
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
        PackedStringArray.__default.I(psa#0))
       || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              PackedStringArray.__default.I(psa#0)))
         < 4294967296;
  free ensures $IsA#PackedStringArray.Psa(PackedStringArray.__default.psaAppendSeq($LS($LZ), 
        Lit(PackedStringArray.__default.EmptyPsa()), 
        PackedStringArray.__default.I(psa#0)))
     && $IsA#PackedStringArray.Psa(psa#0)
     && 
    PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.I#canCall(psa#0)
     && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0));
  ensures PackedStringArray.Psa#Equal(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
      Lit(PackedStringArray.__default.EmptyPsa()), 
      PackedStringArray.__default.I(psa#0)), 
    psa#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.psaCanAppendI(psa#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var strs#0: Seq Box
     where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#6: DatatypeType;
  var ##psa#7: DatatypeType;
  var newtype$check#0: int;
  var ##psa#8: DatatypeType;
  var newtype$check#1: int;
  var ##psa#1_0: DatatypeType;
  var ##psa#1_1: DatatypeType;
  var ##strs#1_0: Seq Box;
  var prepsa#0: DatatypeType
     where $Is(prepsa#0, Tclass.PackedStringArray.Psa())
       && $IsAlloc(prepsa#0, Tclass.PackedStringArray.Psa(), $Heap);
  var ##psa#9: DatatypeType;
  var prestrs#0: Seq Box
     where $Is(prestrs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(prestrs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#10: DatatypeType;
  var last#0: Seq Box
     where $Is(last#0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(last#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var ##run#0: Seq Box;
  var psa##0: DatatypeType;
  var ##psa#11: DatatypeType;
  var ##strs#2: Seq Box;

    // AddMethodImpl: psaCanAppendI, Impl$$PackedStringArray.__default.psaCanAppendI
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(484,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(485,14)
    assume true;
    ##psa#6 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    strs#0 := PackedStringArray.__default.I(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(485,22)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(486,5)
    ##psa#7 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    if (PackedStringArray.__default.psaNumStrings(psa#0) == LitInt(0))
    {
    }
    else
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(487,12)
        ##psa#8 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
           < NativeTypes.__default.Uint64UpperBound();
        assume Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
           < NativeTypes.__default.Uint64UpperBound();
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
        newtype$check#1 := LitInt(1);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
        if (PackedStringArray.__default.psaNumStrings(psa#0) == LitInt(1))
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(488,7)
            assume PackedStringArray.__default.EmptyPsa#canCall();
            assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
            ##psa#1_0 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#1_0, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
               ==> PackedStringArray.__default.WF(##psa#1_0)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
               ==> PackedStringArray.__default.WF(##psa#1_0)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#1_0)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
               ==> PackedStringArray.__default.WF(##psa#1_0)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
               ==> PackedStringArray.__default.WF(##psa#1_0)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_0))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_0), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#1_0)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_0)
               ==> PackedStringArray.__default.WF(##psa#1_0)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#1_0));
            assume PackedStringArray.__default.I#canCall(psa#0);
            ##psa#1_1 := Lit(PackedStringArray.__default.EmptyPsa());
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#1_1, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#1_0 := PackedStringArray.__default.I(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#1_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1)
               ==> PackedStringArray.__default.WF(##psa#1_1)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1)
               ==> PackedStringArray.__default.WF(##psa#1_1)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#1_1)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1)
               ==> PackedStringArray.__default.WF(##psa#1_1)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_1)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1)
               ==> PackedStringArray.__default.WF(##psa#1_1)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#1_1))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1_1), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#1_1)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1_1)
               ==> PackedStringArray.__default.WF(##psa#1_1)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#1_1));
            assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
              PackedStringArray.__default.I(psa#0));
            assume PackedStringArray.__default.EmptyPsa#canCall()
               && PackedStringArray.__default.I#canCall(psa#0)
               && PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
                PackedStringArray.__default.I(psa#0));
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(488,7)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(489,28)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Sequences.__default.reveal__FlattenShape();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(489,29)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(490,29)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Sequences.__default.reveal__FlattenLength();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(490,30)"} true;
                assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
                    PackedStringArray.__default.I(psa#0))
                   ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
                      PackedStringArray.__default.I(psa#0))
                     || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
                         + Seq#Length(PackedStringArray.__default.I(psa#0))
                       < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), 
                    PackedStringArray.__default.I(psa#0))
                   ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
                      PackedStringArray.__default.I(psa#0))
                     || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
                         + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                            StartFuelAssert_Sequences._default.FlattenShape, 
                            PackedStringArray.__default.I(psa#0)))
                       < 4294967296;
                assume false;
            }

            assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), 
              PackedStringArray.__default.I(psa#0));
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(493,18)
            assume true;
            ##psa#9 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#9, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#9)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#9)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#9))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#9))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#9), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#9)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#9)
               ==> PackedStringArray.__default.WF(##psa#9)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#9));
            assume PackedStringArray.__default.WF(##psa#9);
            assert {:subsumption 0} 0 < PackedStringArray.__default.psaNumStrings(##psa#9);
            assume 0 < PackedStringArray.__default.psaNumStrings(##psa#9);
            assume PackedStringArray.__default.psaDropLast#canCall(psa#0);
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaDropLast(psa#0));
            assume PackedStringArray.__default.psaDropLast#canCall(psa#0);
            prepsa#0 := PackedStringArray.__default.psaDropLast(psa#0);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(493,36)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(494,19)
            assume true;
            ##psa#10 := prepsa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#10, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
               ==> PackedStringArray.__default.WF(##psa#10)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
               ==> PackedStringArray.__default.WF(##psa#10)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#10)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
               ==> PackedStringArray.__default.WF(##psa#10)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#10)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
               ==> PackedStringArray.__default.WF(##psa#10)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#10))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#10))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#10), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#10)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#10)
               ==> PackedStringArray.__default.WF(##psa#10)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#10));
            assume PackedStringArray.__default.WF(##psa#10);
            assume PackedStringArray.__default.I#canCall(prepsa#0);
            assume PackedStringArray.__default.I#canCall(prepsa#0);
            prestrs#0 := PackedStringArray.__default.I(prepsa#0);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(494,30)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(495,16)
            assume true;
            ##run#0 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Seq#Length(##run#0) > 0;
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0);
            last#0 := $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(495,28)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(496,7)
            assume true;
            assert Seq#Equal(strs#0, Seq#Append(prestrs#0, Seq#Build(Seq#Empty(): Seq Box, $Box(last#0))));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(497,20)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            psa##0 := prepsa#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assert 0 <= PackedStringArray.__default.psaNumStrings(psa#0)
               || PackedStringArray.__default.psaNumStrings(psa##0)
                 == PackedStringArray.__default.psaNumStrings(psa#0);
            assert PackedStringArray.__default.psaNumStrings(psa##0)
               < PackedStringArray.__default.psaNumStrings(psa#0);
            // ProcessCallStmt: Make the call
            call Call$$PackedStringArray.__default.psaCanAppendI(psa##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(497,27)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(498,7)
            assume PackedStringArray.__default.EmptyPsa#canCall();
            assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
            ##psa#11 := Lit(PackedStringArray.__default.EmptyPsa());
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#11, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#2 := strs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
               ==> PackedStringArray.__default.WF(##psa#11)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
               ==> PackedStringArray.__default.WF(##psa#11)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#11)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
               ==> PackedStringArray.__default.WF(##psa#11)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#11)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
               ==> PackedStringArray.__default.WF(##psa#11)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#11))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#11))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#11), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#11)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#11)
               ==> PackedStringArray.__default.WF(##psa#11)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#11));
            assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
            assume PackedStringArray.__default.EmptyPsa#canCall()
               && PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
            if (*)
            {
                // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(498,7)
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(499,28)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Sequences.__default.reveal__FlattenShape();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(499,29)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(500,29)
                // TrCallStmt: Before ProcessCallStmt
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Sequences.__default.reveal__FlattenLength();
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(500,30)"} true;
                assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
                   ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
                     || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
                         + Seq#Length(strs#0)
                       < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
                   ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
                     || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
                         + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                            StartFuelAssert_Sequences._default.FlattenShape, 
                            strs#0))
                       < 4294967296;
                assume false;
            }

            assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
        }
    }
}



procedure CheckWellformed$$PackedStringArray.__default.psaSeqTotalLength(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 47 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.psaSeqTotalLength(strs#0: Seq Box) returns (len#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##strs#1: Seq Box;
  var ##psa#2: DatatypeType;

    // AddMethodImpl: psaSeqTotalLength, CheckWellformed$$PackedStringArray.__default.psaSeqTotalLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(505,9): initial state"} true;
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#0 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc len#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(507,16): post-state"} true;
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#1 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#1 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) + Seq#Length(##strs#1)
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#1, ##strs#1)
       ==> PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1))
             + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuelAssert_Sequences._default.FlattenShape, 
                ##strs#1))
           < 4294967296;
    assume PackedStringArray.__default.psaCanAppendSeq(##psa#1, ##strs#1);
    assume PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
    ##psa#2 := PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.data(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
    assume len#0
       == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
}



procedure Call$$PackedStringArray.__default.psaSeqTotalLength(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
       || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Seq#Length(strs#0)
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
       || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs#0))
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
  ensures len#0
     == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.psaSeqTotalLength(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 47 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && 
    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Seq#Length(strs#0)
       < 4294967296
     && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
  ensures len#0
     == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.psaSeqTotalLength(strs#0: Seq Box) returns (len#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#0: int;
  var psa##0: DatatypeType;
  var strs1##0: Seq Box;
  var strs2##0: Seq Box;
  var curlen#0: int where LitInt(0) <= curlen#0 && curlen#0 < 18446744073709551616;
  var newtype$check#0: int;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var newtype$check#1: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#3: DatatypeType;
  var ##strs#2: Seq Box;
  var ##psa#4: DatatypeType;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var $decr$loop#00: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var ##run#0_0: Seq Box;
  var psa##0_0: DatatypeType;
  var ##psa#0_0: DatatypeType;
  var ##strs#0_0: Seq Box;
  var key##0_0: Seq Box;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var newtype$check#0_5: int;

    // AddMethodImpl: psaSeqTotalLength, Impl$$PackedStringArray.__default.psaSeqTotalLength
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(508,2): initial state"} true;
    $_reverifyPost := false;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(509,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#0;
        assume true;
        if (LitInt(0) <= i#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#0 && i#0 <= Seq#Length(strs#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(513,9)
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        assert Seq#Equal(strs#0, Seq#Append(Seq#Take(strs#0, i#0), Seq#Drop(strs#0, i#0)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(514,29)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedStringArray.__default.EmptyPsa#canCall();
        assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
        assume PackedStringArray.__default.EmptyPsa#canCall();
        // ProcessCallStmt: CheckSubrange
        psa##0 := Lit(PackedStringArray.__default.EmptyPsa());
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs1##0 := Seq#Take(strs#0, i#0);
        assert 0 <= i#0 && i#0 <= Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        strs2##0 := Seq#Drop(strs#0, i#0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaAppendSeqAdditive(psa##0, strs1##0, strs2##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(514,62)"} true;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#0))
             || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
                 + Seq#Length(Seq#Take(strs#0, i#0))
               < 4294967296;
        assert PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#0))
           ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#0))
             || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    Seq#Take(strs#0, i#0)))
               < 4294967296;
        assert PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
              Lit(PackedStringArray.__default.EmptyPsa()), 
              Seq#Take(strs#0, i#0)))
           <= PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));
        assume false;
    }
    else
    {
        assume (forall i#1: int :: 
          { Seq#Take(strs#0, i#1) } 
          LitInt(0) <= i#1 && i#1 <= Seq#Length(strs#0)
             ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#1))
               && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#1)))
                 <= PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0)));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(515,4)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(517,24)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    curlen#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(517,27)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(518,19)
    assume true;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    i#2 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(518,22)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(519,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(strs#0) - i#2;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#2 <= Seq#Length(strs#0);
      free invariant $w$loop#0
         ==> PackedStringArray.__default.EmptyPsa#canCall()
           && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2))
           && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
      invariant $w$loop#0
         ==> curlen#0
           == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LS($LZ)), 
              Lit(PackedStringArray.__default.EmptyPsa()), 
              Seq#Take(strs#0, i#2)));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(strs#0) - i#2 <= $decr_init$loop#00
         && (Seq#Length(strs#0) - i#2 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(519,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume i#2 <= Seq#Length(strs#0);
            assume PackedStringArray.__default.EmptyPsa#canCall();
            assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
            assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
            ##psa#3 := Lit(PackedStringArray.__default.EmptyPsa());
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            ##strs#2 := Seq#Take(strs#0, i#2);
            // assume allocatedness for argument to function
            assume $IsAlloc(##strs#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) + Seq#Length(##strs#2)
                   < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#3, ##strs#2)
               ==> PackedStringArray.__default.psaCanAppendSeq(##psa#3, ##strs#2)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                      Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                        StartFuelAssert_Sequences._default.FlattenShape, 
                        ##strs#2))
                   < 4294967296;
            assume PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2));
            assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
            ##psa#4 := PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2));
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.data(##psa#4))
               < NativeTypes.__default.Uint64UpperBound();
            assume PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
            assume PackedStringArray.__default.EmptyPsa#canCall()
               && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2))
               && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
            assume curlen#0
               == PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
            newtype$check#2 := Seq#Length(strs#0);
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#3 := Seq#Length(strs#0);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assume true;
        if (Seq#Length(strs#0) <= i#2)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(strs#0) - i#2;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(523,7)
        assert {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#2 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#2 + 1 && i#2 + 1 <= Seq#Length(strs#0);
        ##run#0_0 := Seq#Take(strs#0, i#2 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} Seq#Length(##run#0_0) > 0;
        assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(strs#0, i#2 + 1));
        assume Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Seq#Take(strs#0, i#2 + 1));
        assert Seq#Equal(Seq#Take(strs#0, i#2), 
          Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Seq#Take(strs#0, i#2 + 1)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(524,27)
        // TrCallStmt: Before ProcessCallStmt
        assume PackedStringArray.__default.EmptyPsa#canCall();
        assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
        assert 0 <= i#2 && i#2 <= Seq#Length(strs#0);
        ##psa#0_0 := Lit(PackedStringArray.__default.EmptyPsa());
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##strs#0_0 := Seq#Take(strs#0, i#2);
        // assume allocatedness for argument to function
        assume $IsAlloc(##strs#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#0_0, ##strs#0_0)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#0_0, ##strs#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) + Seq#Length(##strs#0_0)
               < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.psaCanAppendSeq#canCall(##psa#0_0, ##strs#0_0)
           ==> PackedStringArray.__default.psaCanAppendSeq(##psa#0_0, ##strs#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuelAssert_Sequences._default.FlattenShape, 
                    ##strs#0_0))
               < 4294967296;
        assume PackedStringArray.__default.psaCanAppendSeq(##psa#0_0, ##strs#0_0);
        assume PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2));
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
        assume PackedStringArray.__default.EmptyPsa#canCall()
           && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2));
        // ProcessCallStmt: CheckSubrange
        psa##0_0 := PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2));
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0_0 := $Unbox(Seq#Index(strs#0, i#2)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.psaAppendTotalLength(psa##0_0, key##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(524,72)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(525,14)
        assume true;
        assert 0 <= i#2 && i#2 < Seq#Length(strs#0);
        newtype$check#0_2 := Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box);
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        newtype$check#0_3 := curlen#0 + Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume true;
        curlen#0 := curlen#0 + Seq#Length($Unbox(Seq#Index(strs#0, i#2)): Seq Box);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(525,44)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(526,9)
        assume true;
        newtype$check#0_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        newtype$check#0_5 := i#2 + 1;
        assert LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        assume true;
        i#2 := i#2 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(526,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(519,5)
        assert 0 <= $decr$loop#00 || Seq#Length(strs#0) - i#2 == $decr$loop#00;
        assert Seq#Length(strs#0) - i#2 < $decr$loop#00;
        assume true;
        assume PackedStringArray.__default.EmptyPsa#canCall()
           && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2))
           && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Seq#Take(strs#0, i#2)));
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(528,5)
    assert {:subsumption 0} 0 <= Seq#Length(strs#0) && Seq#Length(strs#0) <= Seq#Length(strs#0);
    assume true;
    assert Seq#Equal(strs#0, Seq#Take(strs#0, Seq#Length(strs#0)));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(529,9)
    assume true;
    assume true;
    len#0 := curlen#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(529,17)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.LargestLte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: int
       where LitInt(0 - 9223372036854775808) <= result#0 && result#0 < 9223372036854775808);
  free requires 63 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.LargestLte(psa#0: DatatypeType, key#0: Seq Box) returns (result#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##run#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##run#1: Seq Box;
  var ##needle#0: Seq Box;

    // AddMethodImpl: LargestLte, CheckWellformed$$PackedStringArray.__default.LargestLte
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(532,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##run#0 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Lexicographic__Byte__Order.__default.IsSorted#canCall(PackedStringArray.__default.I(psa#0));
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, 
      PackedStringArray.__default.I(psa#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(535,26): post-state"} true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##run#1 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##needle#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
    assume Lexicographic__Byte__Order.__default.LargestLte#canCall(PackedStringArray.__default.I(psa#0), key#0);
    assume result#0
       == Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), PackedStringArray.__default.I(psa#0), key#0);
}



procedure Call$$PackedStringArray.__default.LargestLte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: int
       where LitInt(0 - 9223372036854775808) <= result#0 && result#0 < 9223372036854775808);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.LargestLte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures result#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.LargestLte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: int
       where LitInt(0 - 9223372036854775808) <= result#0 && result#0 < 9223372036854775808, 
    $_reverifyPost: bool);
  free requires 63 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.LargestLte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures result#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.LargestLte(psa#0: DatatypeType, key#0: Seq Box)
   returns (result#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ipsa#0: Seq Box
     where $Is(ipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(ipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#3: DatatypeType;
  var lo#0: int
     where LitInt(0 - 9223372036854775808) <= lo#0 && lo#0 < 9223372036854775808;
  var newtype$check#0: int;
  var hi#0: int
     where LitInt(0 - 9223372036854775808) <= hi#0 && hi#0 < 9223372036854775808;
  var ##psa#4: DatatypeType;
  var newtype$check#1: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var j#0: int;
  var newtype$check#2: int;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;
  var j#2: int;
  var newtype$check#3: int;
  var ##a#1: Seq Box;
  var ##b#1: Seq Box;
  var $decr$loop#00: int;
  var mid#0_0: int
     where LitInt(0 - 9223372036854775808) <= mid#0_0 && mid#0_0 < 9223372036854775808;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var t#0_0: int where LitInt(0 - 2147483648) <= t#0_0 && t#0_0 < 2147483648;
  var $rhs##0_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_0 && $rhs##0_0 < 2147483648;
  var a##0_0: Seq Box;
  var newtype$check#0_3: int;
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var b##0_0: Seq Box;
  var newtype$check#0_4: int;
  var j#0_0_0: int;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var newtype$check#0_0_2: int;
  var run##0_0_0: Seq Box;
  var i##0_0_0: int;
  var j##0_0_0: int;
  var newtype$check#0_0_3: int;
  var newtype$check#0_0_4: int;
  var j#0_0: int;
  var newtype$check#0_5: int;
  var run##0_0: Seq Box;
  var i##0_0: int;
  var j##0_0: int;
  var run##0: Seq Box;
  var needle##0: Seq Box;
  var pos##0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;

    // AddMethodImpl: LargestLte, Impl$$PackedStringArray.__default.LargestLte
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(536,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(537,20)
    assume true;
    ##psa#3 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ipsa#0 := PackedStringArray.__default.I(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(537,28)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(538,19)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0 - 9223372036854775808) <= newtype$check#0
       && newtype$check#0 < 9223372036854775808;
    assume true;
    lo#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(538,22)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(539,19)
    assume true;
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    newtype$check#1 := PackedStringArray.__default.psaNumStrings(psa#0);
    assert LitInt(0 - 9223372036854775808) <= newtype$check#1
       && newtype$check#1 < 9223372036854775808;
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    hi#0 := PackedStringArray.__default.psaNumStrings(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(539,48)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(541,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := hi#0 - lo#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= lo#0;
      invariant $w$loop#0 ==> lo#0 <= hi#0;
      invariant $w$loop#0 ==> hi#0 <= Seq#Length(ipsa#0);
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, j#1)): Seq Box } 
          LitInt(0 - 9223372036854775808) <= j#1 && j#1 < 9223372036854775808
             ==> 
            LitInt(0) <= j#1 && j#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#1)): Seq Box, key#0));
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, j#1)): Seq Box } 
          LitInt(0 - 9223372036854775808) <= j#1
               && j#1 < 9223372036854775808
               && 
              LitInt(0) <= j#1
               && j#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#1)): Seq Box, key#0));
      free invariant $w$loop#0
         ==> (forall j#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box } 
          LitInt(0 - 9223372036854775808) <= j#3 && j#3 < 9223372036854775808
             ==> 
            hi#0 <= j#3 && j#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box));
      invariant $w$loop#0
         ==> (forall j#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box } 
          LitInt(0 - 9223372036854775808) <= j#3
               && j#3 < 9223372036854775808
               && 
              hi#0 <= j#3
               && j#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant hi#0 - lo#0 <= $decr_init$loop#00
         && (hi#0 - lo#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(541,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= lo#0)
            {
            }

            if (LitInt(0) <= lo#0 && lo#0 <= hi#0)
            {
            }

            assume true;
            assume LitInt(0) <= lo#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(ipsa#0);
            havoc j#0;
            assume LitInt(0 - 9223372036854775808) <= j#0 && j#0 < 9223372036854775808;
            // Begin Comprehension WF check
            newtype$check#2 := LitInt(0);
            assert LitInt(0 - 9223372036854775808) <= newtype$check#2
               && newtype$check#2 < 9223372036854775808;
            if (LitInt(0) <= j#0)
            {
            }

            if (LitInt(0) <= j#0 && j#0 < lo#0)
            {
                assert {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(ipsa#0);
                ##a#0 := $Unbox(Seq#Index(ipsa#0, j#0)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#0 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#0)): Seq Box, key#0);
            }

            // End Comprehension WF check
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(ipsa#0, j#1)): Seq Box } 
              LitInt(0 - 9223372036854775808) <= j#1 && j#1 < 9223372036854775808
                 ==> 
                LitInt(0) <= j#1 && j#1 < lo#0
                 ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#1)): Seq Box, key#0));
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(ipsa#0, j#1)): Seq Box } 
              LitInt(0 - 9223372036854775808) <= j#1
                   && j#1 < 9223372036854775808
                   && 
                  LitInt(0) <= j#1
                   && j#1 < lo#0
                 ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#1)): Seq Box, key#0));
            havoc j#2;
            assume LitInt(0 - 9223372036854775808) <= j#2 && j#2 < 9223372036854775808;
            // Begin Comprehension WF check
            if (hi#0 <= j#2)
            {
                newtype$check#3 := Seq#Length(ipsa#0);
                assert LitInt(0 - 9223372036854775808) <= newtype$check#3
                   && newtype$check#3 < 9223372036854775808;
            }

            if (hi#0 <= j#2 && j#2 < Seq#Length(ipsa#0))
            {
                assert {:subsumption 0} 0 <= j#2 && j#2 < Seq#Length(ipsa#0);
                ##a#1 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#1 := $Unbox(Seq#Index(ipsa#0, j#2)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#2)): Seq Box);
            }

            // End Comprehension WF check
            assume (forall j#3: int :: 
              { $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box } 
              LitInt(0 - 9223372036854775808) <= j#3 && j#3 < 9223372036854775808
                 ==> 
                hi#0 <= j#3 && j#3 < Seq#Length(ipsa#0)
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box));
            assume (forall j#3: int :: 
              { $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box } 
              LitInt(0 - 9223372036854775808) <= j#3
                   && j#3 < 9223372036854775808
                   && 
                  hi#0 <= j#3
                   && j#3 < Seq#Length(ipsa#0)
                 ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box));
            assume true;
            assume false;
        }

        assume true;
        if (hi#0 <= lo#0)
        {
            break;
        }

        $decr$loop#00 := hi#0 - lo#0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(546,22)
        assume true;
        newtype$check#0_0 := lo#0 + hi#0;
        assert LitInt(0 - 9223372036854775808) <= newtype$check#0_0
           && newtype$check#0_0 < 9223372036854775808;
        newtype$check#0_1 := LitInt(2);
        assert LitInt(0 - 9223372036854775808) <= newtype$check#0_1
           && newtype$check#0_1 < 9223372036854775808;
        assert LitInt(2) != 0;
        newtype$check#0_2 := Div(lo#0 + hi#0, LitInt(2));
        assert LitInt(0 - 9223372036854775808) <= newtype$check#0_2
           && newtype$check#0_2 < 9223372036854775808;
        assume true;
        mid#0_0 := Div(lo#0 + hi#0, LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(546,37)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(547,32)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type int32
        // TrCallStmt: Before ProcessCallStmt
        newtype$check#0_3 := mid#0_0;
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        ##psa#0_0 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0_0 := mid#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0);
        // ProcessCallStmt: CheckSubrange
        a##0_0 := PackedStringArray.__default.psaElement(psa#0, mid#0_0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        b##0_0 := key#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        t#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(547,68)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(548,7)
        newtype$check#0_4 := LitInt(0);
        assert LitInt(0 - 2147483648) <= newtype$check#0_4 && newtype$check#0_4 < 2147483648;
        assume true;
        if (t#0_0 <= LitInt(0))
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(549,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc j#0_0_0;
                assume LitInt(0 - 9223372036854775808) <= j#0_0_0 && j#0_0_0 < 9223372036854775808;
                newtype$check#0_0_0 := LitInt(0);
                assert LitInt(0 - 9223372036854775808) <= newtype$check#0_0_0
                   && newtype$check#0_0_0 < 9223372036854775808;
                if (LitInt(0) <= j#0_0_0)
                {
                    newtype$check#0_0_1 := LitInt(1);
                    assert LitInt(0 - 9223372036854775808) <= newtype$check#0_0_1
                       && newtype$check#0_0_1 < 9223372036854775808;
                    newtype$check#0_0_2 := mid#0_0 + 1;
                    assert LitInt(0 - 9223372036854775808) <= newtype$check#0_0_2
                       && newtype$check#0_0_2 < 9223372036854775808;
                }

                assume true;
                assume LitInt(0) <= j#0_0_0 && j#0_0_0 < mid#0_0 + 1;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(552,38)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                run##0_0_0 := ipsa#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##0_0_0 := j#0_0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                j##0_0_0 := mid#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run##0_0_0, i##0_0_0, j##0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(552,65)"} true;
                assert Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                   ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                     || (Lit(true)
                       ==> 
                      Lit(true)
                       ==> 
                      Lit(true)
                       ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                        $Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, 
                        key#0));
                assume false;
            }
            else
            {
                assume (forall j#0_0_1: int :: 
                  { $Unbox(Seq#Index(ipsa#0, j#0_0_1)): Seq Box } 
                  LitInt(0 - 9223372036854775808) <= j#0_0_1
                       && j#0_0_1 < 9223372036854775808
                       && 
                      LitInt(0) <= j#0_0_1
                       && j#0_0_1 < mid#0_0 + 1
                     ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#0_0_1)): Seq Box, key#0));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(553,8)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(554,12)
            assume true;
            newtype$check#0_0_3 := LitInt(1);
            assert LitInt(0 - 9223372036854775808) <= newtype$check#0_0_3
               && newtype$check#0_0_3 < 9223372036854775808;
            newtype$check#0_0_4 := mid#0_0 + 1;
            assert LitInt(0 - 9223372036854775808) <= newtype$check#0_0_4
               && newtype$check#0_0_4 < 9223372036854775808;
            assume true;
            lo#0 := mid#0_0 + 1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(554,21)"} true;
        }
        else
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(556,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc j#0_0;
                assume LitInt(0 - 9223372036854775808) <= j#0_0 && j#0_0 < 9223372036854775808;
                if (mid#0_0 <= j#0_0)
                {
                    newtype$check#0_5 := Seq#Length(ipsa#0);
                    assert LitInt(0 - 9223372036854775808) <= newtype$check#0_5
                       && newtype$check#0_5 < 9223372036854775808;
                }

                assume true;
                assume mid#0_0 <= j#0_0 && j#0_0 < Seq#Length(ipsa#0);
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(559,38)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                run##0_0 := ipsa#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##0_0 := mid#0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                j##0_0 := j#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run##0_0, i##0_0, j##0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(559,65)"} true;
                assert Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                     || (Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                       ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                         || (Lit(true)
                           ==> 
                          Lit(true)
                           ==> 
                          Lit(true)
                           ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                            key#0, 
                            $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)));
                assert Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                     || !Seq#Equal(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box);
                assume false;
            }
            else
            {
                assume (forall j#0_1: int :: 
                  { $Unbox(Seq#Index(ipsa#0, j#0_1)): Seq Box } 
                  LitInt(0 - 9223372036854775808) <= j#0_1
                       && j#0_1 < 9223372036854775808
                       && 
                      mid#0_0 <= j#0_1
                       && j#0_1 < Seq#Length(ipsa#0)
                     ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#0_1)): Seq Box));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(560,8)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(561,12)
            assume true;
            assume true;
            hi#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(561,17)"} true;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(541,5)
        assert 0 <= $decr$loop#00 || hi#0 - lo#0 == $decr$loop#00;
        assert hi#0 - lo#0 < $decr$loop#00;
        assume true;
        assume (forall j#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, j#1)): Seq Box } 
          LitInt(0 - 9223372036854775808) <= j#1 && j#1 < 9223372036854775808
             ==> 
            LitInt(0) <= j#1 && j#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#1)): Seq Box, key#0));
        assume (forall j#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box } 
          LitInt(0 - 9223372036854775808) <= j#3 && j#3 < 9223372036854775808
             ==> 
            hi#0 <= j#3 && j#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#3)): Seq Box));
    }

    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(564,32)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := ipsa#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := key#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    pos##0 := hi#0 - 1;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Lexicographic__Byte__Order.__default.LargestLteIsUnique(run##0, needle##0, pos##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(564,57)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(565,12)
    assume true;
    newtype$check#4 := LitInt(1);
    assert LitInt(0 - 9223372036854775808) <= newtype$check#4
       && newtype$check#4 < 9223372036854775808;
    newtype$check#5 := hi#0 - 1;
    assert LitInt(0 - 9223372036854775808) <= newtype$check#5
       && newtype$check#5 < 9223372036854775808;
    assume true;
    result#0 := hi#0 - 1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(565,20)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  free requires 64 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##s#0: Seq Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: BinarySearchIndexOfFirstKeyGte, CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(568,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc idx#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(572,4): post-state"} true;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##s#0 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
    assume idx#0
       == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
        PackedStringArray.__default.I(psa#0), 
        key#0);
}



procedure Call$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
      PackedStringArray.__default.I(psa#0), 
      key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 64 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
      PackedStringArray.__default.I(psa#0), 
      key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var lo#0: int where LitInt(0) <= lo#0 && lo#0 < 18446744073709551616;
  var newtype$check#0: int;
  var hi#0: int where LitInt(0) <= hi#0 && hi#0 < 18446744073709551616;
  var ##psa#2: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#3: DatatypeType;
  var newtype$check#3: int;
  var ##psa#4: DatatypeType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;
  var ##psa#5: DatatypeType;
  var ##psa#6: DatatypeType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var ##a#1: Seq Box;
  var ##b#1: Seq Box;
  var ##psa#7: DatatypeType;
  var ##s#1: Seq Box;
  var ##key#1: Seq Box;
  var ##psa#8: DatatypeType;
  var ##s#2: Seq Box;
  var ##key#2: Seq Box;
  var ##lo#0: int;
  var ##hi#0: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var $decr$loop#00: int;
  var mid#0_0: int where LitInt(0) <= mid#0_0 && mid#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var c#0_0: int where LitInt(0 - 2147483648) <= c#0_0 && c#0_0 < 2147483648;
  var $rhs##0_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_0 && $rhs##0_0 < 2147483648;
  var a##0_0: Seq Box;
  var b##0_0: Seq Box;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var newtype$check#0_5: int;

    // AddMethodImpl: BinarySearchIndexOfFirstKeyGte, Impl$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGte
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(573,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(574,51)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Lexicographic__Byte__Order.__default.reveal__binarySearchIndexOfFirstKeyGte();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(574,52)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(575,20)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    lo#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(575,23)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(576,20)
    assume true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := PackedStringArray.__default.psaNumStrings(psa#0) + 1;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    hi#0 := PackedStringArray.__default.psaNumStrings(psa#0) + 1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(576,44)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(578,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := hi#0 - (lo#0 + 1);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> lo#0 < hi#0 ==> PackedStringArray.__default.I#canCall(psa#0);
      invariant $w$loop#0 ==> LitInt(0) <= lo#0;
      invariant $w$loop#0 ==> lo#0 < hi#0;
      invariant $w$loop#0 ==> hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0)) + 1;
      free invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0);
      invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> 
        Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
          key#0)
         ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           || (Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
              key#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                key#0)
               || (Lit(true)
                 ==> 
                Lit(true)
                 ==> 
                Lit(true)
                 ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                  $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                  key#0)));
      invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> 
        Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
          key#0)
         ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           || !Seq#Equal($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0);
      free invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           && 
          Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           && 
          Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           && !Seq#Equal($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0);
      free invariant $w$loop#0
         ==> PackedStringArray.__default.I#canCall(psa#0)
           && (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
             ==> PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
      invariant $w$loop#0
         ==> 
        hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
         ==> 
        Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
          $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
         ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           || (Lit(true)
             ==> 
            Lit(true)
             ==> 
            Lit(true)
             ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
              key#0, 
              $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
      free invariant $w$loop#0
         ==> 
        hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
         ==> Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           && 
          Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
            key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
      free invariant $w$loop#0
         ==> PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0)
           && 
          PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
      invariant $w$loop#0
         ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
            PackedStringArray.__default.I(psa#0), 
            key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant hi#0 - (lo#0 + 1) <= $decr_init$loop#00
         && (hi#0 - (lo#0 + 1) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(578,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= lo#0)
            {
            }

            if (LitInt(0) <= lo#0 && lo#0 < hi#0)
            {
                ##psa#3 := psa#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#3));
                assume PackedStringArray.__default.I#canCall(psa#0);
            }

            assume lo#0 < hi#0 ==> PackedStringArray.__default.I#canCall(psa#0);
            assume LitInt(0) <= lo#0
               && lo#0 < hi#0
               && hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0)) + 1;
            newtype$check#3 := LitInt(0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            if (lo#0 > 0)
            {
                ##psa#4 := psa#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#4));
                assume PackedStringArray.__default.I#canCall(psa#0);
                newtype$check#4 := LitInt(1);
                assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
                newtype$check#5 := lo#0 - 1;
                assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
                assert {:subsumption 0} 0 <= lo#0 - 1 && lo#0 - 1 < Seq#Length(PackedStringArray.__default.I(psa#0));
                ##a#0 := $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#0 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                  key#0);
            }

            assume lo#0 > 0
               ==> PackedStringArray.__default.I#canCall(psa#0)
                 && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                  key#0);
            assume lo#0 > 0
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                key#0);
            ##psa#5 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#5));
            assume PackedStringArray.__default.I#canCall(psa#0);
            if (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0)))
            {
                ##psa#6 := psa#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#6));
                assume PackedStringArray.__default.I#canCall(psa#0);
                newtype$check#6 := LitInt(1);
                assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
                newtype$check#7 := hi#0 - 1;
                assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
                assert {:subsumption 0} 0 <= hi#0 - 1 && hi#0 - 1 < Seq#Length(PackedStringArray.__default.I(psa#0));
                ##a#1 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#1 := $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
                  $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
            }

            assume PackedStringArray.__default.I#canCall(psa#0)
               && (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
                 ==> PackedStringArray.__default.I#canCall(psa#0)
                   && Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
                    $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
            assume hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
               ==> Lexicographic__Byte__Order.__default.lte(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
            ##psa#7 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#7));
            assume PackedStringArray.__default.I#canCall(psa#0);
            ##s#1 := PackedStringArray.__default.I(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            ##key#1 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
            ##psa#8 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#8));
            assume PackedStringArray.__default.I#canCall(psa#0);
            ##s#2 := PackedStringArray.__default.I(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            ##key#2 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#2, TSeq(Tclass.NativeTypes.byte()), $Heap);
            ##lo#0 := lo#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##lo#0, TInt, $Heap);
            ##hi#0 := hi#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##hi#0, TInt, $Heap);
            assert {:subsumption 0} LitInt(0) <= ##lo#0;
            assert {:subsumption 0} ##lo#0 < ##hi#0;
            assert {:subsumption 0} ##hi#0 <= Seq#Length(##s#2) + 1;
            assert {:subsumption 0} ##lo#0 > 0
               ==> 
              Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
                 || (Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
                   ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
                     || (Lit(true)
                       ==> 
                      Lit(true)
                       ==> 
                      Lit(true)
                       ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                        $Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, 
                        ##key#2)));
            assert {:subsumption 0} ##lo#0 > 0
               ==> 
              Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
                 || !Seq#Equal($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2);
            assert {:subsumption 0} ##hi#0 <= Seq#Length(##s#2)
               ==> 
              Lexicographic__Byte__Order.__default.lte#canCall(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
               ==> Lexicographic__Byte__Order.__default.lte(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
                 || (Lit(true)
                   ==> 
                  Lit(true)
                   ==> 
                  Lit(true)
                   ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                    ##key#2, 
                    $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box));
            assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
            assume PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0)
               && 
              PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
            assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte, 
                PackedStringArray.__default.I(psa#0), 
                key#0)
               == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
            newtype$check#8 := LitInt(1);
            assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
            newtype$check#9 := lo#0 + 1;
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#10 := LitInt(1);
        assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
        newtype$check#11 := lo#0 + 1;
        assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
        assume true;
        if (hi#0 <= lo#0 + 1)
        {
            break;
        }

        $decr$loop#00 := hi#0 - (lo#0 + 1);
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(585,15)
        assume true;
        newtype$check#0_0 := lo#0 + hi#0;
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := LitInt(2);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert LitInt(2) != 0;
        newtype$check#0_2 := Div(lo#0 + hi#0, LitInt(2));
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        mid#0_0 := Div(lo#0 + hi#0, LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(585,30)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(586,32)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type int32
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := key#0;
        newtype$check#0_3 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        newtype$check#0_4 := mid#0_0 - 1;
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        ##psa#0_0 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0_0 := mid#0_0 - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0 - 1);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0 - 1);
        // ProcessCallStmt: CheckSubrange
        b##0_0 := PackedStringArray.__default.psaElement(psa#0, mid#0_0 - 1);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        c#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(586,60)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(587,7)
        newtype$check#0_5 := LitInt(0);
        assert LitInt(0 - 2147483648) <= newtype$check#0_5 && newtype$check#0_5 < 2147483648;
        assume true;
        if (c#0_0 > 0)
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(588,12)
            assume true;
            assume true;
            lo#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(588,17)"} true;
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(590,12)
            assume true;
            assume true;
            hi#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(590,17)"} true;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(578,5)
        assert 0 <= $decr$loop#00 || hi#0 - (lo#0 + 1) == $decr$loop#00;
        assert hi#0 - (lo#0 + 1) < $decr$loop#00;
        assume lo#0 < hi#0 ==> PackedStringArray.__default.I#canCall(psa#0);
        assume lo#0 > 0
           ==> PackedStringArray.__default.I#canCall(psa#0)
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
              key#0);
        assume PackedStringArray.__default.I#canCall(psa#0)
           && (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
             ==> PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
        assume PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(PackedStringArray.__default.I(psa#0), key#0)
           && 
          PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
    }

    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(593,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(593,5)
    assume true;
    assume true;
    idx#0 := lo#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(593,13)"} true;
    return;
}



procedure CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  free requires 65 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##s#0: Seq Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: BinarySearchIndexOfFirstKeyGt, CheckWellformed$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(596,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc idx#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(600,4): post-state"} true;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##s#0 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
    assume idx#0
       == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt, 
        PackedStringArray.__default.I(psa#0), 
        key#0);
}



procedure Call$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt, 
      PackedStringArray.__default.I(psa#0), 
      key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 65 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt, 
      PackedStringArray.__default.I(psa#0), 
      key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var lo#0: int where LitInt(0) <= lo#0 && lo#0 < 18446744073709551616;
  var newtype$check#0: int;
  var hi#0: int where LitInt(0) <= hi#0 && hi#0 < 18446744073709551616;
  var ##psa#2: DatatypeType;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#3: DatatypeType;
  var newtype$check#3: int;
  var ##psa#4: DatatypeType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;
  var ##psa#5: DatatypeType;
  var ##psa#6: DatatypeType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var ##a#1: Seq Box;
  var ##b#1: Seq Box;
  var ##psa#7: DatatypeType;
  var ##s#1: Seq Box;
  var ##key#1: Seq Box;
  var ##psa#8: DatatypeType;
  var ##s#2: Seq Box;
  var ##key#2: Seq Box;
  var ##lo#0: int;
  var ##hi#0: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var $decr$loop#00: int;
  var mid#0_0: int where LitInt(0) <= mid#0_0 && mid#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var c#0_0: int where LitInt(0 - 2147483648) <= c#0_0 && c#0_0 < 2147483648;
  var $rhs##0_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_0 && $rhs##0_0 < 2147483648;
  var a##0_0: Seq Box;
  var b##0_0: Seq Box;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var newtype$check#0_5: int;

    // AddMethodImpl: BinarySearchIndexOfFirstKeyGt, Impl$$PackedStringArray.__default.BinarySearchIndexOfFirstKeyGt
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(601,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(602,50)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Lexicographic__Byte__Order.__default.reveal__binarySearchIndexOfFirstKeyGt();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(602,51)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(603,20)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    lo#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(603,23)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(604,20)
    assume true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := PackedStringArray.__default.psaNumStrings(psa#0) + 1;
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    hi#0 := PackedStringArray.__default.psaNumStrings(psa#0) + 1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(604,44)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(606,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := hi#0 - (lo#0 + 1);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> lo#0 < hi#0 ==> PackedStringArray.__default.I#canCall(psa#0);
      invariant $w$loop#0 ==> LitInt(0) <= lo#0;
      invariant $w$loop#0 ==> lo#0 < hi#0;
      invariant $w$loop#0 ==> hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0)) + 1;
      free invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0);
      invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> 
        Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
          key#0)
         ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           || (Lit(true)
             ==> 
            Lit(true)
             ==> 
            Lit(true)
             ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
              $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
              key#0));
      free invariant $w$loop#0
         ==> 
        lo#0 > 0
         ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           && 
          Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0)
           && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
            key#0);
      free invariant $w$loop#0
         ==> PackedStringArray.__default.I#canCall(psa#0)
           && (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
             ==> PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
      invariant $w$loop#0
         ==> 
        hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
         ==> 
        Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
          $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
         ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           || (Lexicographic__Byte__Order.__default.lte#canCall(key#0, 
              $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
               || (Lit(true)
                 ==> 
                Lit(true)
                 ==> 
                Lit(true)
                 ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                  key#0, 
                  $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)));
      invariant $w$loop#0
         ==> 
        hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
         ==> 
        Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
          $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
         ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           || !Seq#Equal(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
      free invariant $w$loop#0
         ==> 
        hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
         ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           && 
          Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           && 
          Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box)
           && !Seq#Equal(key#0, 
            $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
      free invariant $w$loop#0
         ==> PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0)
           && 
          PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
      invariant $w$loop#0
         ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt, 
            PackedStringArray.__default.I(psa#0), 
            key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant hi#0 - (lo#0 + 1) <= $decr_init$loop#00
         && (hi#0 - (lo#0 + 1) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(606,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= lo#0)
            {
            }

            if (LitInt(0) <= lo#0 && lo#0 < hi#0)
            {
                ##psa#3 := psa#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
                   ==> PackedStringArray.__default.WF(##psa#3)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#3));
                assume PackedStringArray.__default.I#canCall(psa#0);
            }

            assume lo#0 < hi#0 ==> PackedStringArray.__default.I#canCall(psa#0);
            assume LitInt(0) <= lo#0
               && lo#0 < hi#0
               && hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0)) + 1;
            newtype$check#3 := LitInt(0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            if (lo#0 > 0)
            {
                ##psa#4 := psa#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
                   ==> PackedStringArray.__default.WF(##psa#4)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#4));
                assume PackedStringArray.__default.I#canCall(psa#0);
                newtype$check#4 := LitInt(1);
                assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
                newtype$check#5 := lo#0 - 1;
                assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
                assert {:subsumption 0} 0 <= lo#0 - 1 && lo#0 - 1 < Seq#Length(PackedStringArray.__default.I(psa#0));
                ##a#0 := $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#0 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                  key#0);
            }

            assume lo#0 > 0
               ==> PackedStringArray.__default.I#canCall(psa#0)
                 && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                  key#0);
            assume lo#0 > 0
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
                key#0);
            ##psa#5 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
               ==> PackedStringArray.__default.WF(##psa#5)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#5));
            assume PackedStringArray.__default.I#canCall(psa#0);
            if (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0)))
            {
                ##psa#6 := psa#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
                   ==> PackedStringArray.__default.WF(##psa#6)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#6));
                assume PackedStringArray.__default.I#canCall(psa#0);
                newtype$check#6 := LitInt(1);
                assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
                newtype$check#7 := hi#0 - 1;
                assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
                assert {:subsumption 0} 0 <= hi#0 - 1 && hi#0 - 1 < Seq#Length(PackedStringArray.__default.I(psa#0));
                ##a#1 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#1 := $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                  $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
            }

            assume PackedStringArray.__default.I#canCall(psa#0)
               && (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
                 ==> PackedStringArray.__default.I#canCall(psa#0)
                   && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                    $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
            assume hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
               ==> Lexicographic__Byte__Order.__default.lt(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box);
            ##psa#7 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#7, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#7)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#7)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#7))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#7))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#7), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#7)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#7)
               ==> PackedStringArray.__default.WF(##psa#7)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#7));
            assume PackedStringArray.__default.I#canCall(psa#0);
            ##s#1 := PackedStringArray.__default.I(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            ##key#1 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
            assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
            ##psa#8 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#8, Tclass.PackedStringArray.Psa(), $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#8)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#8)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#8))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#8))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#8), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#8)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#8)
               ==> PackedStringArray.__default.WF(##psa#8)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#8));
            assume PackedStringArray.__default.I#canCall(psa#0);
            ##s#2 := PackedStringArray.__default.I(psa#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##s#2, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
            ##key#2 := key#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##key#2, TSeq(Tclass.NativeTypes.byte()), $Heap);
            ##lo#0 := lo#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##lo#0, TInt, $Heap);
            ##hi#0 := hi#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##hi#0, TInt, $Heap);
            assert {:subsumption 0} LitInt(0) <= ##lo#0;
            assert {:subsumption 0} ##lo#0 < ##hi#0;
            assert {:subsumption 0} ##hi#0 <= Seq#Length(##s#2) + 1;
            assert {:subsumption 0} ##lo#0 > 0
               ==> 
              Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, ##key#2)
                 || (Lit(true)
                   ==> 
                  Lit(true)
                   ==> 
                  Lit(true)
                   ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                    $Unbox(Seq#Index(##s#2, ##lo#0 - 1)): Seq Box, 
                    ##key#2));
            assert {:subsumption 0} ##hi#0 <= Seq#Length(##s#2)
               ==> 
              Lexicographic__Byte__Order.__default.lt#canCall(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
               ==> Lexicographic__Byte__Order.__default.lt(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
                 || (Lexicographic__Byte__Order.__default.lte#canCall(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lte(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
                     || (Lit(true)
                       ==> 
                      Lit(true)
                       ==> 
                      Lit(true)
                       ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                        ##key#2, 
                        $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)));
            assert {:subsumption 0} ##hi#0 <= Seq#Length(##s#2)
               ==> 
              Lexicographic__Byte__Order.__default.lt#canCall(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
               ==> Lexicographic__Byte__Order.__default.lt(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box)
                 || !Seq#Equal(##key#2, $Unbox(Seq#Index(##s#2, ##hi#0 - 1)): Seq Box);
            assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
            assume PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0)
               && 
              PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
            assume Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt, 
                PackedStringArray.__default.I(psa#0), 
                key#0)
               == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
            newtype$check#8 := LitInt(1);
            assert LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
            newtype$check#9 := lo#0 + 1;
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#10 := LitInt(1);
        assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
        newtype$check#11 := lo#0 + 1;
        assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
        assume true;
        if (hi#0 <= lo#0 + 1)
        {
            break;
        }

        $decr$loop#00 := hi#0 - (lo#0 + 1);
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(613,15)
        assume true;
        newtype$check#0_0 := lo#0 + hi#0;
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := LitInt(2);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert LitInt(2) != 0;
        newtype$check#0_2 := Div(lo#0 + hi#0, LitInt(2));
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        mid#0_0 := Div(lo#0 + hi#0, LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(613,30)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(614,32)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type int32
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := key#0;
        newtype$check#0_3 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        newtype$check#0_4 := mid#0_0 - 1;
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        ##psa#0_0 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0_0 := mid#0_0 - 1;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0 - 1);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0 - 1);
        // ProcessCallStmt: CheckSubrange
        b##0_0 := PackedStringArray.__default.psaElement(psa#0, mid#0_0 - 1);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        c#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(614,60)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(615,7)
        newtype$check#0_5 := LitInt(0);
        assert LitInt(0 - 2147483648) <= newtype$check#0_5 && newtype$check#0_5 < 2147483648;
        assume true;
        if (c#0_0 >= LitInt(0))
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(616,12)
            assume true;
            assume true;
            lo#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(616,17)"} true;
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(618,12)
            assume true;
            assume true;
            hi#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(618,17)"} true;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(606,5)
        assert 0 <= $decr$loop#00 || hi#0 - (lo#0 + 1) == $decr$loop#00;
        assert hi#0 - (lo#0 + 1) < $decr$loop#00;
        assume lo#0 < hi#0 ==> PackedStringArray.__default.I#canCall(psa#0);
        assume lo#0 > 0
           ==> PackedStringArray.__default.I#canCall(psa#0)
             && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), lo#0 - 1)): Seq Box, 
              key#0);
        assume PackedStringArray.__default.I#canCall(psa#0)
           && (hi#0 <= Seq#Length(PackedStringArray.__default.I(psa#0))
             ==> PackedStringArray.__default.I#canCall(psa#0)
               && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                $Unbox(Seq#Index(PackedStringArray.__default.I(psa#0), hi#0 - 1)): Seq Box));
        assume PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(PackedStringArray.__default.I(psa#0), key#0)
           && 
          PackedStringArray.__default.I#canCall(psa#0)
           && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(PackedStringArray.__default.I(psa#0), key#0, lo#0, hi#0);
    }

    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(621,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(621,5)
    assume true;
    assume true;
    idx#0 := lo#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(621,13)"} true;
    return;
}



procedure CheckWellformed$$PackedStringArray.__default.IndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  free requires 67 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.IndexOfFirstKeyGte(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##run#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##run#1: Seq Box;
  var ##needle#0: Seq Box;

    // AddMethodImpl: IndexOfFirstKeyGte, CheckWellformed$$PackedStringArray.__default.IndexOfFirstKeyGte
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(627,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##run#0 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Lexicographic__Byte__Order.__default.IsSorted#canCall(PackedStringArray.__default.I(psa#0));
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, 
      PackedStringArray.__default.I(psa#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc idx#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(630,14): post-state"} true;
    if (LitInt(0) <= idx#0)
    {
        ##psa#2 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assume PackedStringArray.__default.I#canCall(psa#0);
    }

    assume LitInt(0) <= idx#0 && idx#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    ##psa#3 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##run#1 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##needle#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
    assume Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
    assume idx#0
       == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), PackedStringArray.__default.I(psa#0), key#0);
}



procedure Call$$PackedStringArray.__default.IndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LitInt(0) <= idx#0 ==> PackedStringArray.__default.I#canCall(psa#0);
  ensures LitInt(0) <= idx#0;
  ensures idx#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.IndexOfFirstKeyGte(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 67 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LitInt(0) <= idx#0 ==> PackedStringArray.__default.I#canCall(psa#0);
  ensures LitInt(0) <= idx#0;
  ensures idx#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.IndexOfFirstKeyGte(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ipsa#0: Seq Box
     where $Is(ipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(ipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#4: DatatypeType;
  var lo#0: int where LitInt(0) <= lo#0 && lo#0 < 18446744073709551616;
  var newtype$check#0: int;
  var hi#0: int where LitInt(0) <= hi#0 && hi#0 < 18446744073709551616;
  var ##psa#5: DatatypeType;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var i#0: int;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;
  var i#2: int;
  var ##a#1: Seq Box;
  var ##b#1: Seq Box;
  var $decr$loop#00: int;
  var mid#0_0: int where LitInt(0) <= mid#0_0 && mid#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var c#0_0: int where LitInt(0 - 2147483648) <= c#0_0 && c#0_0 < 2147483648;
  var $rhs##0_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_0 && $rhs##0_0 < 2147483648;
  var a##0_0: Seq Box;
  var b##0_0: Seq Box;
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var newtype$check#0_3: int;
  var j#0_0_0: int;
  var newtype$check#0_0_0: int;
  var run##0_0_0: Seq Box;
  var i##0_0_0: int;
  var j##0_0_0: int;
  var newtype$check#0_0_1: int;
  var newtype$check#0_0_2: int;
  var j#0_0: int;
  var run##0_0: Seq Box;
  var i##0_0: int;
  var j##0_0: int;
  var run##0: Seq Box;
  var ##psa#6: DatatypeType;
  var needle##0: Seq Box;
  var idx##0: int;
  var newtype$check#1: int;

    // AddMethodImpl: IndexOfFirstKeyGte, Impl$$PackedStringArray.__default.IndexOfFirstKeyGte
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(632,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(633,20)
    assume true;
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ipsa#0 := PackedStringArray.__default.I(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(633,28)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(635,20)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    lo#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(635,23)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(636,20)
    assume true;
    ##psa#5 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    hi#0 := PackedStringArray.__default.psaNumStrings(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(636,40)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(638,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := hi#0 - lo#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= lo#0;
      invariant $w$loop#0 ==> lo#0 <= Seq#Length(ipsa#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= hi#0;
      invariant $w$loop#0 ==> hi#0 <= Seq#Length(ipsa#0);
      free invariant $w$loop#0
         ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
      invariant $w$loop#0
         ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
      free invariant $w$loop#0
         ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
          hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
      invariant $w$loop#0
         ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
          hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant hi#0 - lo#0 <= $decr_init$loop#00
         && (hi#0 - lo#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(638,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= lo#0)
            {
            }

            assume true;
            assume LitInt(0) <= lo#0 && lo#0 <= Seq#Length(ipsa#0);
            if (LitInt(0) <= hi#0)
            {
            }

            assume true;
            assume LitInt(0) <= hi#0 && hi#0 <= Seq#Length(ipsa#0);
            havoc i#0;
            // Begin Comprehension WF check
            if (LitInt(0) <= i#0)
            {
            }

            if (LitInt(0) <= i#0 && i#0 < lo#0)
            {
                assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(ipsa#0);
                ##a#0 := $Unbox(Seq#Index(ipsa#0, i#0)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#0 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(ipsa#0, i#0)): Seq Box, key#0);
            }

            // End Comprehension WF check
            assume (forall i#1: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
              LitInt(0) <= i#1 && i#1 < lo#0
                 ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
            assume (forall i#1: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
              LitInt(0) <= i#1 && i#1 < lo#0
                 ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
            havoc i#2;
            // Begin Comprehension WF check
            if (hi#0 <= i#2)
            {
            }

            if (hi#0 <= i#2 && i#2 < Seq#Length(ipsa#0))
            {
                assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(ipsa#0);
                ##a#1 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#1 := $Unbox(Seq#Index(ipsa#0, i#2)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#2)): Seq Box);
            }

            // End Comprehension WF check
            assume (forall i#3: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
              hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
            assume (forall i#3: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
              hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
                 ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
            assume true;
            assume false;
        }

        assume true;
        if (hi#0 <= lo#0)
        {
            break;
        }

        $decr$loop#00 := hi#0 - lo#0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(645,23)
        assume true;
        newtype$check#0_0 := lo#0 + hi#0;
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := LitInt(2);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert LitInt(2) != 0;
        newtype$check#0_2 := Div(lo#0 + hi#0, LitInt(2));
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        mid#0_0 := Div(lo#0 + hi#0, LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(645,38)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(646,32)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type int32
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := key#0;
        ##psa#0_0 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0_0 := mid#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0);
        // ProcessCallStmt: CheckSubrange
        b##0_0 := PackedStringArray.__default.psaElement(psa#0, mid#0_0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        c#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(646,58)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(647,7)
        newtype$check#0_3 := LitInt(0);
        assert LitInt(0 - 2147483648) <= newtype$check#0_3 && newtype$check#0_3 < 2147483648;
        assume true;
        if (c#0_0 > 0)
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(648,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc j#0_0_0;
                assume LitInt(0) <= j#0_0_0 && j#0_0_0 < 18446744073709551616;
                newtype$check#0_0_0 := LitInt(0);
                assert LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
                if (LitInt(0) <= j#0_0_0)
                {
                }

                assume true;
                assume LitInt(0) <= j#0_0_0 && j#0_0_0 < mid#0_0;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(651,38)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                run##0_0_0 := ipsa#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##0_0_0 := j#0_0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                j##0_0_0 := mid#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run##0_0_0, i##0_0_0, j##0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(651,65)"} true;
                assert Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                   ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                     || (Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                       ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                         || (Lit(true)
                           ==> 
                          Lit(true)
                           ==> 
                          Lit(true)
                           ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                            $Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, 
                            key#0)));
                assert Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                   ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                     || !Seq#Equal($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0);
                assume false;
            }
            else
            {
                assume (forall j#0_0_1: int :: 
                  { $Unbox(Seq#Index(ipsa#0, j#0_0_1)): Seq Box } 
                  LitInt(0) <= j#0_0_1
                       && j#0_0_1 < 18446744073709551616
                       && 
                      LitInt(0) <= j#0_0_1
                       && j#0_0_1 < mid#0_0
                     ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(ipsa#0, j#0_0_1)): Seq Box, key#0));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(652,8)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(653,12)
            assume true;
            newtype$check#0_0_1 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
            newtype$check#0_0_2 := mid#0_0 + 1;
            assert LitInt(0) <= newtype$check#0_0_2 && newtype$check#0_0_2 < 18446744073709551616;
            assume true;
            lo#0 := mid#0_0 + 1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(653,21)"} true;
        }
        else
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(655,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc j#0_0;
                assume true;
                if (mid#0_0 <= j#0_0)
                {
                }

                assume true;
                assume mid#0_0 <= j#0_0 && j#0_0 < Seq#Length(ipsa#0);
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(658,38)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                run##0_0 := ipsa#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##0_0 := mid#0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                j##0_0 := j#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run##0_0, i##0_0, j##0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(658,58)"} true;
                assert Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                     || (Lit(true)
                       ==> 
                      Lit(true)
                       ==> 
                      Lit(true)
                       ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                        key#0, 
                        $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box));
                assume false;
            }
            else
            {
                assume (forall j#0_1: int :: 
                  { $Unbox(Seq#Index(ipsa#0, j#0_1)): Seq Box } 
                  mid#0_0 <= j#0_1 && j#0_1 < Seq#Length(ipsa#0)
                     ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(ipsa#0, j#0_1)): Seq Box));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(659,8)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(660,12)
            assume true;
            assume true;
            hi#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(660,17)"} true;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(638,5)
        assert 0 <= $decr$loop#00 || hi#0 - lo#0 == $decr$loop#00;
        assert hi#0 - lo#0 < $decr$loop#00;
        assume true;
        assume true;
        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
        assume (forall i#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
          hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(664,9)
    assume true;
    assume true;
    idx#0 := lo#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(664,13)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(665,37)
    // TrCallStmt: Before ProcessCallStmt
    ##psa#6 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    // ProcessCallStmt: CheckSubrange
    run##0 := PackedStringArray.__default.I(psa#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := key#0;
    newtype$check#1 := idx#0;
    assert LitInt(0) <= newtype$check#1;
    assume true;
    // ProcessCallStmt: CheckSubrange
    idx##0 := idx#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Lexicographic__Byte__Order.__default.IndexOfFirstGteIsUnique(run##0, needle##0, idx##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(665,61)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.IndexOfFirstKeyGt(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  free requires 68 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.IndexOfFirstKeyGt(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##run#0: Seq Box;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;
  var ##run#1: Seq Box;
  var ##needle#0: Seq Box;

    // AddMethodImpl: IndexOfFirstKeyGt, CheckWellformed$$PackedStringArray.__default.IndexOfFirstKeyGt
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(668,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##run#0 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Lexicographic__Byte__Order.__default.IsSorted#canCall(PackedStringArray.__default.I(psa#0));
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, 
      PackedStringArray.__default.I(psa#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc idx#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(671,14): post-state"} true;
    if (LitInt(0) <= idx#0)
    {
        ##psa#2 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
           ==> PackedStringArray.__default.WF(##psa#2)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#2));
        assume PackedStringArray.__default.WF(##psa#2);
        assume PackedStringArray.__default.I#canCall(psa#0);
    }

    assume LitInt(0) <= idx#0 && idx#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
    ##psa#3 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ##run#1 := PackedStringArray.__default.I(psa#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##needle#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
    assume Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
    assume idx#0
       == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($LZ), PackedStringArray.__default.I(psa#0), key#0);
}



procedure Call$$PackedStringArray.__default.IndexOfFirstKeyGt(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616);
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LitInt(0) <= idx#0 ==> PackedStringArray.__default.I#canCall(psa#0);
  ensures LitInt(0) <= idx#0;
  ensures idx#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.IndexOfFirstKeyGt(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 68 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LitInt(0) <= idx#0 ==> PackedStringArray.__default.I#canCall(psa#0);
  ensures LitInt(0) <= idx#0;
  ensures idx#0 <= Seq#Length(PackedStringArray.__default.I(psa#0));
  free ensures PackedStringArray.__default.I#canCall(psa#0)
     && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(PackedStringArray.__default.I(psa#0), key#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($LS($LZ)), PackedStringArray.__default.I(psa#0), key#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.IndexOfFirstKeyGt(psa#0: DatatypeType, key#0: Seq Box) returns (idx#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ipsa#0: Seq Box
     where $Is(ipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(ipsa#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var ##psa#4: DatatypeType;
  var lo#0: int where LitInt(0) <= lo#0 && lo#0 < 18446744073709551616;
  var newtype$check#0: int;
  var hi#0: int where LitInt(0) <= hi#0 && hi#0 < 18446744073709551616;
  var ##psa#5: DatatypeType;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var i#0: int;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;
  var i#2: int;
  var ##a#1: Seq Box;
  var ##b#1: Seq Box;
  var $decr$loop#00: int;
  var mid#0_0: int where LitInt(0) <= mid#0_0 && mid#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var c#0_0: int where LitInt(0 - 2147483648) <= c#0_0 && c#0_0 < 2147483648;
  var $rhs##0_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_0 && $rhs##0_0 < 2147483648;
  var a##0_0: Seq Box;
  var b##0_0: Seq Box;
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var newtype$check#0_3: int;
  var j#0_0_0: int;
  var newtype$check#0_0_0: int;
  var run##0_0_0: Seq Box;
  var i##0_0_0: int;
  var j##0_0_0: int;
  var newtype$check#0_0_1: int;
  var newtype$check#0_0_2: int;
  var j#0_0: int;
  var run##0_0: Seq Box;
  var i##0_0: int;
  var j##0_0: int;
  var run##0: Seq Box;
  var ##psa#6: DatatypeType;
  var needle##0: Seq Box;
  var idx##0: int;
  var newtype$check#1: int;

    // AddMethodImpl: IndexOfFirstKeyGt, Impl$$PackedStringArray.__default.IndexOfFirstKeyGt
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(673,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(674,20)
    assume true;
    ##psa#4 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    ipsa#0 := PackedStringArray.__default.I(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(674,28)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(676,20)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    lo#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(676,23)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(677,20)
    assume true;
    ##psa#5 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    hi#0 := PackedStringArray.__default.psaNumStrings(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(677,40)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(679,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := hi#0 - lo#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= lo#0;
      invariant $w$loop#0 ==> lo#0 <= Seq#Length(ipsa#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= hi#0;
      invariant $w$loop#0 ==> hi#0 <= Seq#Length(ipsa#0);
      free invariant $w$loop#0
         ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
      invariant $w$loop#0
         ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
      free invariant $w$loop#0
         ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
          hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
      invariant $w$loop#0
         ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
          hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant hi#0 - lo#0 <= $decr_init$loop#00
         && (hi#0 - lo#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(679,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= lo#0)
            {
            }

            assume true;
            assume LitInt(0) <= lo#0 && lo#0 <= Seq#Length(ipsa#0);
            if (LitInt(0) <= hi#0)
            {
            }

            assume true;
            assume LitInt(0) <= hi#0 && hi#0 <= Seq#Length(ipsa#0);
            havoc i#0;
            // Begin Comprehension WF check
            if (LitInt(0) <= i#0)
            {
            }

            if (LitInt(0) <= i#0 && i#0 < lo#0)
            {
                assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(ipsa#0);
                ##a#0 := $Unbox(Seq#Index(ipsa#0, i#0)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#0 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, i#0)): Seq Box, key#0);
            }

            // End Comprehension WF check
            assume (forall i#1: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
              LitInt(0) <= i#1 && i#1 < lo#0
                 ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
            assume (forall i#1: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
              LitInt(0) <= i#1 && i#1 < lo#0
                 ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
            havoc i#2;
            // Begin Comprehension WF check
            if (hi#0 <= i#2)
            {
            }

            if (hi#0 <= i#2 && i#2 < Seq#Length(ipsa#0))
            {
                assert {:subsumption 0} 0 <= i#2 && i#2 < Seq#Length(ipsa#0);
                ##a#1 := key#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##a#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                ##b#1 := $Unbox(Seq#Index(ipsa#0, i#2)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##b#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assume Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#2)): Seq Box);
            }

            // End Comprehension WF check
            assume (forall i#3: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
              hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
            assume (forall i#3: int :: 
              { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
              hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
                 ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
            assume true;
            assume false;
        }

        assume true;
        if (hi#0 <= lo#0)
        {
            break;
        }

        $decr$loop#00 := hi#0 - lo#0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(686,23)
        assume true;
        newtype$check#0_0 := lo#0 + hi#0;
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := LitInt(2);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert LitInt(2) != 0;
        newtype$check#0_2 := Div(lo#0 + hi#0, LitInt(2));
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        mid#0_0 := Div(lo#0 + hi#0, LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(686,38)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(687,32)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type int32
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := key#0;
        ##psa#0_0 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0_0 := mid#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, mid#0_0);
        // ProcessCallStmt: CheckSubrange
        b##0_0 := PackedStringArray.__default.psaElement(psa#0, mid#0_0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        c#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(687,58)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(688,7)
        newtype$check#0_3 := LitInt(0);
        assert LitInt(0 - 2147483648) <= newtype$check#0_3 && newtype$check#0_3 < 2147483648;
        assume true;
        if (c#0_0 >= LitInt(0))
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(689,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc j#0_0_0;
                assume LitInt(0) <= j#0_0_0 && j#0_0_0 < 18446744073709551616;
                newtype$check#0_0_0 := LitInt(0);
                assert LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
                if (LitInt(0) <= j#0_0_0)
                {
                }

                assume true;
                assume LitInt(0) <= j#0_0_0 && j#0_0_0 < mid#0_0;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(692,38)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                run##0_0_0 := ipsa#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##0_0_0 := j#0_0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                j##0_0_0 := mid#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run##0_0_0, i##0_0_0, j##0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(692,65)"} true;
                assert Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                   ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, key#0)
                     || (Lit(true)
                       ==> 
                      Lit(true)
                       ==> 
                      Lit(true)
                       ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                        $Unbox(Seq#Index(ipsa#0, j#0_0_0)): Seq Box, 
                        key#0));
                assume false;
            }
            else
            {
                assume (forall j#0_0_1: int :: 
                  { $Unbox(Seq#Index(ipsa#0, j#0_0_1)): Seq Box } 
                  LitInt(0) <= j#0_0_1
                       && j#0_0_1 < 18446744073709551616
                       && 
                      LitInt(0) <= j#0_0_1
                       && j#0_0_1 < mid#0_0
                     ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(ipsa#0, j#0_0_1)): Seq Box, key#0));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(693,8)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(694,12)
            assume true;
            newtype$check#0_0_1 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
            newtype$check#0_0_2 := mid#0_0 + 1;
            assert LitInt(0) <= newtype$check#0_0_2 && newtype$check#0_0_2 < 18446744073709551616;
            assume true;
            lo#0 := mid#0_0 + 1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(694,21)"} true;
        }
        else
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(696,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc j#0_0;
                assume true;
                if (mid#0_0 <= j#0_0)
                {
                }

                assume true;
                assume mid#0_0 <= j#0_0 && j#0_0 < Seq#Length(ipsa#0);
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(699,38)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                run##0_0 := ipsa#0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                i##0_0 := mid#0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                j##0_0 := j#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run##0_0, i##0_0, j##0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(699,58)"} true;
                assert Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                     || (Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                       ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                         || (Lit(true)
                           ==> 
                          Lit(true)
                           ==> 
                          Lit(true)
                           ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                            key#0, 
                            $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)));
                assert Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box)
                     || !Seq#Equal(key#0, $Unbox(Seq#Index(ipsa#0, j#0_0)): Seq Box);
                assume false;
            }
            else
            {
                assume (forall j#0_1: int :: 
                  { $Unbox(Seq#Index(ipsa#0, j#0_1)): Seq Box } 
                  mid#0_0 <= j#0_1 && j#0_1 < Seq#Length(ipsa#0)
                     ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(ipsa#0, j#0_1)): Seq Box));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(700,8)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(701,12)
            assume true;
            assume true;
            hi#0 := mid#0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(701,17)"} true;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(679,5)
        assert 0 <= $decr$loop#00 || hi#0 - lo#0 == $decr$loop#00;
        assert hi#0 - lo#0 < $decr$loop#00;
        assume true;
        assume true;
        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < lo#0
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(ipsa#0, i#1)): Seq Box, key#0));
        assume (forall i#3: int :: 
          { $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box } 
          hi#0 <= i#3 && i#3 < Seq#Length(ipsa#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(ipsa#0, i#3)): Seq Box));
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(705,9)
    assume true;
    assume true;
    idx#0 := lo#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(705,13)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(706,36)
    // TrCallStmt: Before ProcessCallStmt
    ##psa#6 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
       ==> PackedStringArray.__default.WF(##psa#6)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#6));
    assume PackedStringArray.__default.WF(##psa#6);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume PackedStringArray.__default.I#canCall(psa#0);
    // ProcessCallStmt: CheckSubrange
    run##0 := PackedStringArray.__default.I(psa#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := key#0;
    newtype$check#1 := idx#0;
    assert LitInt(0) <= newtype$check#1;
    assume true;
    // ProcessCallStmt: CheckSubrange
    idx##0 := idx#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Lexicographic__Byte__Order.__default.IndexOfFirstGtIsUnique(run##0, needle##0, idx##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(706,60)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.PivotIndexes(keys#0: DatatypeType
       where $Is(keys#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(keys#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(keys#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (pivotIdxs#0: Seq Box
       where $Is(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  free requires 69 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.PivotIndexes(keys#0: DatatypeType, pivots#0: Seq Box) returns (pivotIdxs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##run#0: Seq Box;
  var ##psa#2: DatatypeType;
  var i#0: int;
  var newtype$check#0: int;
  var ##psa#3: DatatypeType;
  var ##run#1: Seq Box;
  var ##needle#0: Seq Box;
  var ##run#2: Seq Box;
  var newtype$check#1: int;
  var ##psa#4: DatatypeType;

    // AddMethodImpl: PivotIndexes, CheckWellformed$$PackedStringArray.__default.PivotIndexes
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(709,9): initial state"} true;
    ##psa#0 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(keys#0);
    assume PackedStringArray.__default.WF(keys#0);
    ##psa#1 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(keys#0);
    ##run#0 := PackedStringArray.__default.I(keys#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assume Lexicographic__Byte__Order.__default.IsSorted#canCall(PackedStringArray.__default.I(keys#0));
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, 
      PackedStringArray.__default.I(keys#0));
    ##psa#2 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.I#canCall(keys#0);
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(PackedStringArray.__default.I(keys#0))
       < NativeTypes.__default.Uint64UpperBound();
    assume NativeTypes.__default.Uint64UpperBound#canCall();
    assume Seq#Length(pivots#0) < NativeTypes.__default.Uint64UpperBound() - 1;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc pivotIdxs#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(714,24): post-state"} true;
    assume Seq#Length(pivotIdxs#0) == Seq#Length(pivots#0) + 1;
    havoc i#0;
    if (*)
    {
        assume LitInt(0) <= i#0;
        assume i#0 < Seq#Length(pivots#0);
        assert 0 <= i#0 && i#0 < Seq#Length(pivotIdxs#0);
        newtype$check#0 := $Unbox(Seq#Index(pivotIdxs#0, i#0)): int;
        assert LitInt(0) <= newtype$check#0;
        ##psa#3 := keys#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
           ==> PackedStringArray.__default.WF(##psa#3)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#3));
        assume PackedStringArray.__default.WF(##psa#3);
        assume PackedStringArray.__default.I#canCall(keys#0);
        assert 0 <= i#0 && i#0 < Seq#Length(pivots#0);
        ##run#1 := PackedStringArray.__default.I(keys#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#1, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        ##needle#0 := $Unbox(Seq#Index(pivots#0, i#0)): Seq Box;
        // assume allocatedness for argument to function
        assume $IsAlloc(##needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
        assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, ##run#1);
        assume Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, i#0)): Seq Box);
        assume $Unbox(Seq#Index(pivotIdxs#0, i#0)): int
           == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
            PackedStringArray.__default.I(keys#0), 
            $Unbox(Seq#Index(pivots#0, i#0)): Seq Box);
    }
    else
    {
        assume LitInt(0) <= i#0 && i#0 < Seq#Length(pivots#0)
           ==> $Unbox(Seq#Index(pivotIdxs#0, i#0)): int
             == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
              PackedStringArray.__default.I(keys#0), 
              $Unbox(Seq#Index(pivots#0, i#0)): Seq Box);
    }

    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
        { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
         ==> $Unbox(Seq#Index(pivotIdxs#0, i#1)): int
           == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
            PackedStringArray.__default.I(keys#0), 
            $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
    ##run#2 := pivotIdxs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#2, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    assert {:subsumption 0} Seq#Length(##run#2) > 0;
    assume Seq#Length(##run#2) > 0;
    assume Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), pivotIdxs#0);
    newtype$check#1 := $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), pivotIdxs#0)): int;
    assert LitInt(0) <= newtype$check#1;
    ##psa#4 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
       ==> PackedStringArray.__default.WF(##psa#4)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#4));
    assume PackedStringArray.__default.WF(##psa#4);
    assume PackedStringArray.__default.I#canCall(keys#0);
    assume $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), pivotIdxs#0)): int
       == Seq#Length(PackedStringArray.__default.I(keys#0));
}



procedure Call$$PackedStringArray.__default.PivotIndexes(keys#0: DatatypeType
       where $Is(keys#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(keys#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(keys#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (pivotIdxs#0: Seq Box
       where $Is(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || Seq#Length(PackedStringArray.Psa.offsets(keys#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || Seq#Length(PackedStringArray.Psa.data(keys#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(keys#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(keys#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(keys#0))
         ==> Seq#Length(PackedStringArray.Psa.data(keys#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(keys#0), 
              Seq#Length(PackedStringArray.Psa.offsets(keys#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(keys#0)
     ==> PackedStringArray.__default.WF(keys#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(keys#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(keys#0));
  requires Seq#Length(PackedStringArray.__default.I(keys#0))
     < NativeTypes.__default.Uint64UpperBound();
  requires Seq#Length(pivots#0) < NativeTypes.__default.Uint64UpperBound() - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Length(pivotIdxs#0) == Seq#Length(pivots#0) + 1;
  free ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> PackedStringArray.__default.I#canCall(keys#0)
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  free ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> $Unbox(Seq#Index(pivotIdxs#0, i#1)): int
         == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
          PackedStringArray.__default.I(keys#0), 
          $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  free ensures Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), pivotIdxs#0)
     && PackedStringArray.__default.I#canCall(keys#0);
  ensures $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), pivotIdxs#0)): int
     == Seq#Length(PackedStringArray.__default.I(keys#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.PivotIndexes(keys#0: DatatypeType
       where $Is(keys#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(keys#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(keys#0), 
    pivots#0: Seq Box
       where $Is(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (pivotIdxs#0: Seq Box
       where $Is(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(pivotIdxs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    $_reverifyPost: bool);
  free requires 69 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(keys#0)
     && 
    PackedStringArray.__default.WF(keys#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(keys#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(keys#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(keys#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(keys#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(keys#0))
       ==> Seq#Length(PackedStringArray.Psa.data(keys#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(keys#0), 
            Seq#Length(PackedStringArray.Psa.offsets(keys#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(keys#0));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    PackedStringArray.__default.I(keys#0));
  requires Seq#Length(PackedStringArray.__default.I(keys#0))
     < NativeTypes.__default.Uint64UpperBound();
  requires Seq#Length(pivots#0) < NativeTypes.__default.Uint64UpperBound() - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Seq#Length(pivotIdxs#0) == Seq#Length(pivots#0) + 1;
  free ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> PackedStringArray.__default.I#canCall(keys#0)
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  ensures (forall i#1: int :: 
    { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
      { $Unbox(Seq#Index(pivotIdxs#0, i#1)): int } 
    LitInt(0) <= i#1 && i#1 < Seq#Length(pivots#0)
       ==> $Unbox(Seq#Index(pivotIdxs#0, i#1)): int
         == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LS($LZ)), 
          PackedStringArray.__default.I(keys#0), 
          $Unbox(Seq#Index(pivots#0, i#1)): Seq Box));
  free ensures Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), pivotIdxs#0)
     && PackedStringArray.__default.I#canCall(keys#0);
  ensures $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), pivotIdxs#0)): int
     == Seq#Length(PackedStringArray.__default.I(keys#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.PivotIndexes(keys#0: DatatypeType, pivots#0: Seq Box)
   returns (pivotIdxs#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var results#0: ref
     where $Is(results#0, Tclass._System.array?(Tclass.NativeTypes.uint64()))
       && $IsAlloc(results#0, Tclass._System.array?(Tclass.NativeTypes.uint64()), $Heap);
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var $nw: ref;
  var i#2: int where LitInt(0) <= i#2 && i#2 < 18446744073709551616;
  var newtype$check#5: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#6: int;
  var j#0: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var ##psa#5: DatatypeType;
  var ##run#3: Seq Box;
  var ##needle#1: Seq Box;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var $decr$loop#00: int;
  var $obj0: ref;
  var $index0: Field Box;
  var $rhs##0_0: int where LitInt(0) <= $rhs##0_0 && $rhs##0_0 < 18446744073709551616;
  var psa##0_0: DatatypeType;
  var key##0_0: Seq Box;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#11: int;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var ##psa#6: DatatypeType;

    // AddMethodImpl: PivotIndexes, Impl$$PackedStringArray.__default.PivotIndexes
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(717,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(718,17)
    assume true;
    newtype$check#2 := Seq#Length(pivots#0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := LitInt(1);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := Seq#Length(pivots#0) + 1;
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assert 0 <= Seq#Length(pivots#0) + 1;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass._System.array?(Tclass.NativeTypes.uint64());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == Seq#Length(pivots#0) + 1;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    results#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(718,53)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(719,20)
    assume true;
    newtype$check#5 := LitInt(0);
    assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume true;
    i#2 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(719,23)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(720,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(pivots#0) - i#2;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#2 <= Seq#Length(pivots#0);
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < i#2
             ==> PackedStringArray.__default.I#canCall(keys#0)
               && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#2
             ==> $Unbox(read($Heap, results#0, IndexField(j#1))): int
               == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LS($LZ)), 
                PackedStringArray.__default.I(keys#0), 
                $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#2
             ==> $Unbox(read($Heap, results#0, IndexField(j#1))): int
               == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
                PackedStringArray.__default.I(keys#0), 
                $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(pivots#0) - i#2 <= $decr_init$loop#00
         && (Seq#Length(pivots#0) - i#2 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(720,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            newtype$check#6 := Seq#Length(pivots#0);
            assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
            assume true;
            assume i#2 <= Seq#Length(pivots#0);
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
            // Begin Comprehension WF check
            newtype$check#7 := LitInt(0);
            assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
            if (LitInt(0) <= j#0)
            {
            }

            if (LitInt(0) <= j#0 && j#0 < i#2)
            {
                assert results#0 != null;
                assert {:subsumption 0} 0 <= j#0 && j#0 < _System.array.Length(results#0);
                newtype$check#8 := $Unbox(read($Heap, results#0, IndexField(j#0))): int;
                assert LitInt(0) <= newtype$check#8;
                ##psa#5 := keys#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
                   ==> PackedStringArray.__default.WF(##psa#5)
                     || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
                   ==> PackedStringArray.__default.WF(##psa#5)
                     || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
                   ==> PackedStringArray.__default.WF(##psa#5)
                     || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
                   ==> PackedStringArray.__default.WF(##psa#5)
                     || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
                       ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
                         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                            Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
                assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
                   ==> PackedStringArray.__default.WF(##psa#5)
                     || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                      PackedStringArray.Psa.offsets(##psa#5));
                assume PackedStringArray.__default.I#canCall(keys#0);
                assert {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(pivots#0);
                ##run#3 := PackedStringArray.__default.I(keys#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##run#3, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
                ##needle#1 := $Unbox(Seq#Index(pivots#0, j#0)): Seq Box;
                // assume allocatedness for argument to function
                assume $IsAlloc(##needle#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
                assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#3);
                assume Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#0)): Seq Box);
            }

            // End Comprehension WF check
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
                { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616
                 ==> 
                LitInt(0) <= j#1 && j#1 < i#2
                 ==> PackedStringArray.__default.I#canCall(keys#0)
                   && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
            assume (forall j#1: int :: 
              { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
                { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#2
                 ==> $Unbox(read($Heap, results#0, IndexField(j#1))): int
                   == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
                    PackedStringArray.__default.I(keys#0), 
                    $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
            newtype$check#9 := Seq#Length(pivots#0);
            assert LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#10 := Seq#Length(pivots#0);
        assert LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
        assume true;
        if (Seq#Length(pivots#0) <= i#2)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(pivots#0) - i#2;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(724,39)
        assert results#0 != null;
        assert 0 <= i#2 && i#2 < _System.array.Length(results#0);
        assume true;
        $obj0 := results#0;
        $index0 := IndexField(i#2);
        assert $_Frame[$obj0, $index0];
        // TrCallStmt: Adding lhs Microsoft.Dafny.SeqSelectExpr with type uint64
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa##0_0 := keys#0;
        assert 0 <= i#2 && i#2 < Seq#Length(pivots#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0_0 := $Unbox(Seq#Index(pivots#0, i#2)): Seq Box;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$PackedStringArray.__default.IndexOfFirstKeyGte(psa##0_0, key##0_0);
        // TrCallStmt: After ProcessCallStmt
        $Heap := update($Heap, $obj0, $index0, $Box($rhs##0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(724,55)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(725,9)
        assume true;
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#2 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        i#2 := i#2 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(725,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(720,5)
        assert 0 <= $decr$loop#00 || Seq#Length(pivots#0) - i#2 == $decr$loop#00;
        assert Seq#Length(pivots#0) - i#2 < $decr$loop#00;
        assume true;
        assume (forall j#1: int :: 
          { $Unbox(Seq#Index(pivots#0, j#1)): Seq Box } 
            { $Unbox(read($Heap, results#0, IndexField(j#1))): int } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < i#2
             ==> PackedStringArray.__default.I#canCall(keys#0)
               && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(PackedStringArray.__default.I(keys#0), $Unbox(Seq#Index(pivots#0, j#1)): Seq Box));
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(728,33)
    assert results#0 != null;
    newtype$check#11 := Seq#Length(pivots#0);
    assert LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    assert 0 <= Seq#Length(pivots#0)
       && Seq#Length(pivots#0) < _System.array.Length(results#0);
    assume true;
    assert $_Frame[results#0, IndexField(Seq#Length(pivots#0))];
    ##psa#6 := keys#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(keys#0);
    assume PackedStringArray.__default.psaNumStrings#canCall(keys#0);
    $rhs#0 := PackedStringArray.__default.psaNumStrings(keys#0);
    $Heap := update($Heap, results#0, IndexField(Seq#Length(pivots#0)), $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(728,54)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(729,15)
    assume true;
    assert results#0 != null;
    assume true;
    pivotIdxs#0 := Seq#FromArray($Heap, results#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(729,28)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.FromSeq(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap));
  free requires 70 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.FromSeq(strs#0: Seq Box) returns (psa#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##strs#0: Seq Box;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;

    // AddMethodImpl: FromSeq, CheckWellformed$$PackedStringArray.__default.FromSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1060,9): initial state"} true;
    assume PackedStringArray.__default.EmptyPsa#canCall();
    assume PackedStringArray.Psa.Psa_q(Lit(PackedStringArray.__default.EmptyPsa()));
    ##psa#0 := Lit(PackedStringArray.__default.EmptyPsa());
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    ##strs#0 := strs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Seq#Length(PackedStringArray.Psa.data(##psa#0)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#0))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#0)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0)
       ==> PackedStringArray.__default.WF(##psa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#0));
    assume PackedStringArray.__default.WF(##psa#0);
    assume PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    assume PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc psa#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1062,14): post-state"} true;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume Seq#Equal(PackedStringArray.__default.I(psa#0), strs#0);
}



procedure Call$$PackedStringArray.__default.FromSeq(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
       || Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Seq#Length(strs#0)
         < 4294967296;
  requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     ==> PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
       || Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
           + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
              StartFuelAssert_Sequences._default.FlattenShape, 
              strs#0))
         < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.WF#canCall(psa#0);
  free ensures PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  free ensures PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(psa#0), strs#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.FromSeq(strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap))
   returns (psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap), 
    $_reverifyPost: bool);
  free requires 70 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && 
    PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
     && 
    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Seq#Length(strs#0)
       < 4294967296
     && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedStringArray.__default.EmptyPsa()))))
         + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
          Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
       < 4294967296;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.WF#canCall(psa#0);
  ensures PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  ensures PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  ensures PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  ensures PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  free ensures PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(PackedStringArray.__default.I(psa#0), strs#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.FromSeq(strs#0: Seq Box) returns (psa#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var dpsa#0: ref
     where $Is(dpsa#0, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(dpsa#0, Tclass.PackedStringArray.DynamicPsa(), $Heap);
  var $nw: ref;
  var strs##0: Seq Box;

    // AddMethodImpl: FromSeq, Impl$$PackedStringArray.__default.FromSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1064,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1065,14)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1065,32)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    strs##0 := strs#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$PackedStringArray.DynamicPsa.FromSeq(strs##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1065,44)"} true;
    dpsa#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1065,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1066,9)
    assume true;
    assert dpsa#0 != null;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || Set#Equal(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.Repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(dpsa#0)), 
              $Box(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.offsets))), 
            $Box(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.data))));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || _System.array.Length(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.offsets))
           < NativeTypes.__default.Uint64UpperBound();
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || _System.array.Length(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.data))
           < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings)
           <= _System.array.Length(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.offsets));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings) < 4294967296;
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || (0 < read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, dpsa#0, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             < 4294967296);
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || (0 < read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, dpsa#0, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, dpsa#0, PackedStringArray.DynamicPsa.data)));
    assert {:subsumption 0} PackedStringArray.DynamicPsa.WF#canCall($Heap, dpsa#0)
       ==> PackedStringArray.DynamicPsa.WF($Heap, dpsa#0)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          Seq#Take(Seq#FromArray($Heap, read($Heap, dpsa#0, PackedStringArray.DynamicPsa.offsets)), 
            read($Heap, dpsa#0, PackedStringArray.DynamicPsa.nstrings)));
    assume PackedStringArray.DynamicPsa.WF($Heap, dpsa#0);
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, dpsa#0);
    assume PackedStringArray.Psa.Psa_q(PackedStringArray.DynamicPsa.toPsa($Heap, dpsa#0));
    assume PackedStringArray.DynamicPsa.toPsa#canCall($Heap, dpsa#0);
    psa#0 := PackedStringArray.DynamicPsa.toPsa($Heap, dpsa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1066,23)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.ToSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0))
   returns (strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  free requires 71 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.ToSeq(psa#0: DatatypeType) returns (strs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;

    // AddMethodImpl: ToSeq, CheckWellformed$$PackedStringArray.__default.ToSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1069,9): initial state"} true;
    ##psa#0 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa#0);
    assume PackedStringArray.__default.WF(psa#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc strs#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1071,17): post-state"} true;
    ##psa#1 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Seq#Length(PackedStringArray.Psa.data(##psa#1)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#1))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#1))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#1), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#1)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#1)
       ==> PackedStringArray.__default.WF(##psa#1)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#1));
    assume PackedStringArray.__default.WF(##psa#1);
    assume PackedStringArray.__default.I#canCall(psa#0);
    assume Seq#Equal(strs#0, PackedStringArray.__default.I(psa#0));
}



procedure Call$$PackedStringArray.__default.ToSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0))
   returns (strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa#0)
     ==> PackedStringArray.__default.WF(psa#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(strs#0, PackedStringArray.__default.I(psa#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$PackedStringArray.__default.ToSeq(psa#0: DatatypeType
       where $Is(psa#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa#0))
   returns (strs#0: Seq Box
       where $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    $_reverifyPost: bool);
  free requires 71 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa#0)
     && 
    PackedStringArray.__default.WF(psa#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures PackedStringArray.__default.I#canCall(psa#0);
  ensures Seq#Equal(strs#0, PackedStringArray.__default.I(psa#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$PackedStringArray.__default.ToSeq(psa#0: DatatypeType) returns (strs#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var nstrings#0: int
     where LitInt(0) <= nstrings#0 && nstrings#0 < 18446744073709551616;
  var ##psa#2: DatatypeType;
  var astrs#0: ref
     where $Is(astrs#0, Tclass._System.array?(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(astrs#0, Tclass._System.array?(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var $nw: ref;
  var i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616;
  var newtype$check#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##psa#3: DatatypeType;
  var ##i#0: int;
  var $decr$loop#00: int;
  var $rhs#0_0: Seq Box where $Is($rhs#0_0, TSeq(Tclass.NativeTypes.byte()));
  var ##psa#0_0: DatatypeType;
  var ##i#0_0: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

    // AddMethodImpl: ToSeq, Impl$$PackedStringArray.__default.ToSeq
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1072,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1073,26)
    assume true;
    ##psa#2 := psa#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
       < NativeTypes.__default.Uint64UpperBound();
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    assume PackedStringArray.__default.psaNumStrings#canCall(psa#0);
    nstrings#0 := PackedStringArray.__default.psaNumStrings(psa#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1073,46)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1074,15)
    assume true;
    assert 0 <= nstrings#0;
    havoc $nw;
    assume $nw != null
       && dtype($nw) == Tclass._System.array?(TSeq(Tclass.NativeTypes.byte()));
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw) == nstrings#0;
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    astrs#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1074,40)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1076,19)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    i#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1076,22)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1077,5)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := nstrings#0 - i#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> i#0 <= nstrings#0;
      free invariant $w$loop#0 ==> PackedStringArray.__default.psaSeq#canCall(psa#0, i#0);
      invariant $w$loop#0
         ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, astrs#0), i#0), 
          PackedStringArray.__default.psaSeq(StartFuelAssert_PackedStringArray._default.psaSeq, psa#0, i#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant nstrings#0 - i#0 <= $decr_init$loop#00
         && (nstrings#0 - i#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1077,4): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume true;
            assume i#0 <= nstrings#0;
            assert astrs#0 != null;
            assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(astrs#0);
            ##psa#3 := psa#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
            ##i#0 := i#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##i#0, TInt, $Heap);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
                   ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
                     == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                        Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
            assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
               ==> PackedStringArray.__default.WF(##psa#3)
                 || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
                  PackedStringArray.Psa.offsets(##psa#3));
            assert {:subsumption 0} LitInt(0) <= ##i#0;
            assert {:subsumption 0} ##i#0 <= Seq#Length(PackedStringArray.Psa.offsets(##psa#3));
            assume PackedStringArray.__default.psaSeq#canCall(psa#0, i#0);
            assume PackedStringArray.__default.psaSeq#canCall(psa#0, i#0);
            assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, astrs#0), i#0), 
              PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, psa#0, i#0));
            assume true;
            assume false;
        }

        assume true;
        if (nstrings#0 <= i#0)
        {
            break;
        }

        $decr$loop#00 := nstrings#0 - i#0;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1081,16)
        assert astrs#0 != null;
        assert 0 <= i#0 && i#0 < _System.array.Length(astrs#0);
        assume true;
        assert $_Frame[astrs#0, IndexField(i#0)];
        ##psa#0_0 := psa#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#0_0, Tclass.PackedStringArray.Psa(), $Heap);
        ##i#0_0 := i#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#0_0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#0_0), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#0_0)
           ==> PackedStringArray.__default.WF(##psa#0_0)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.WF(##psa#0_0);
        assert {:subsumption 0} LitInt(0) <= ##i#0_0;
        assert {:subsumption 0} ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume LitInt(0) <= ##i#0_0
           && ##i#0_0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#0_0));
        assume PackedStringArray.__default.psaElement#canCall(psa#0, i#0);
        assume PackedStringArray.__default.psaElement#canCall(psa#0, i#0);
        $rhs#0_0 := PackedStringArray.__default.psaElement(psa#0, i#0);
        $Heap := update($Heap, astrs#0, IndexField(i#0), $Box($rhs#0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1081,36)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1082,9)
        assume true;
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := i#0 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        i#0 := i#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1082,16)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1077,5)
        assert 0 <= $decr$loop#00 || nstrings#0 - i#0 == $decr$loop#00;
        assert nstrings#0 - i#0 < $decr$loop#00;
        assume true;
        assume PackedStringArray.__default.psaSeq#canCall(psa#0, i#0);
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1084,10)
    assume true;
    assert astrs#0 != null;
    assume true;
    strs#0 := Seq#FromArray($Heap, astrs#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1084,21)"} true;
}



procedure CheckWellformed$$PackedStringArray.__default.UniqueRepr(psa1#0: DatatypeType
       where $Is(psa1#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa1#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa1#0), 
    psa2#0: DatatypeType
       where $Is(psa2#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa2#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa2#0));
  free requires 72 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$PackedStringArray.__default.UniqueRepr(psa1#0: DatatypeType, psa2#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##psa#0: DatatypeType;
  var ##psa#1: DatatypeType;
  var ##psa#2: DatatypeType;
  var ##psa#3: DatatypeType;

    // AddMethodImpl: UniqueRepr, CheckWellformed$$PackedStringArray.__default.UniqueRepr
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1087,8): initial state"} true;
    ##psa#0 := psa1#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#0, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa1#0);
    assume PackedStringArray.__default.WF(psa1#0);
    ##psa#1 := psa2#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#1, Tclass.PackedStringArray.Psa(), $Heap);
    assume PackedStringArray.__default.WF#canCall(psa2#0);
    assume PackedStringArray.__default.WF(psa2#0);
    ##psa#2 := psa1#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#2, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Seq#Length(PackedStringArray.Psa.data(##psa#2)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#2))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#2))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#2), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#2)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#2)
       ==> PackedStringArray.__default.WF(##psa#2)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#2));
    assume PackedStringArray.__default.WF(##psa#2);
    assume PackedStringArray.__default.I#canCall(psa1#0);
    ##psa#3 := psa2#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##psa#3, Tclass.PackedStringArray.Psa(), $Heap);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Seq#Length(PackedStringArray.Psa.data(##psa#3)) < 4294967296;
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) == LitInt(0)
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3)) == LitInt(0));
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#3))
           ==> Seq#Length(PackedStringArray.Psa.data(##psa#3))
             == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#3), 
                Seq#Length(PackedStringArray.Psa.offsets(##psa#3)) - 1)): int);
    assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#3)
       ==> PackedStringArray.__default.WF(##psa#3)
         || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
          PackedStringArray.Psa.offsets(##psa#3));
    assume PackedStringArray.__default.WF(##psa#3);
    assume PackedStringArray.__default.I#canCall(psa2#0);
    assume Seq#Equal(PackedStringArray.__default.I(psa1#0), PackedStringArray.__default.I(psa2#0));
    assume PackedStringArray.Psa.Psa_q(psa1#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1091,17): post-state"} true;
    assume PackedStringArray.Psa#Equal(psa1#0, psa2#0);
}



procedure Call$$PackedStringArray.__default.UniqueRepr(psa1#0: DatatypeType
       where $Is(psa1#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa1#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa1#0), 
    psa2#0: DatatypeType
       where $Is(psa2#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa2#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa2#0));
  // user-defined preconditions
  requires PackedStringArray.__default.WF#canCall(psa1#0)
     ==> PackedStringArray.__default.WF(psa1#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa1#0)
     ==> PackedStringArray.__default.WF(psa1#0)
       || Seq#Length(PackedStringArray.Psa.data(psa1#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa1#0)
     ==> PackedStringArray.__default.WF(psa1#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa1#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa1#0)
     ==> PackedStringArray.__default.WF(psa1#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa1#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa1#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa1#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa1#0)
     ==> PackedStringArray.__default.WF(psa1#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa1#0));
  requires PackedStringArray.__default.WF#canCall(psa2#0)
     ==> PackedStringArray.__default.WF(psa2#0)
       || Seq#Length(PackedStringArray.Psa.offsets(psa2#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa2#0)
     ==> PackedStringArray.__default.WF(psa2#0)
       || Seq#Length(PackedStringArray.Psa.data(psa2#0)) < 4294967296;
  requires PackedStringArray.__default.WF#canCall(psa2#0)
     ==> PackedStringArray.__default.WF(psa2#0)
       || (Seq#Length(PackedStringArray.Psa.offsets(psa2#0)) == LitInt(0)
         ==> Seq#Length(PackedStringArray.Psa.data(psa2#0)) == LitInt(0));
  requires PackedStringArray.__default.WF#canCall(psa2#0)
     ==> PackedStringArray.__default.WF(psa2#0)
       || (0 < Seq#Length(PackedStringArray.Psa.offsets(psa2#0))
         ==> Seq#Length(PackedStringArray.Psa.data(psa2#0))
           == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa2#0), 
              Seq#Length(PackedStringArray.Psa.offsets(psa2#0)) - 1)): int);
  requires PackedStringArray.__default.WF#canCall(psa2#0)
     ==> PackedStringArray.__default.WF(psa2#0)
       || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
        PackedStringArray.Psa.offsets(psa2#0));
  requires Seq#Equal(PackedStringArray.__default.I(psa1#0), PackedStringArray.__default.I(psa2#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#PackedStringArray.Psa(psa1#0) && $IsA#PackedStringArray.Psa(psa2#0);
  ensures PackedStringArray.Psa#Equal(psa1#0, psa2#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$PackedStringArray.__default.UniqueRepr(psa1#0: DatatypeType
       where $Is(psa1#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa1#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa1#0), 
    psa2#0: DatatypeType
       where $Is(psa2#0, Tclass.PackedStringArray.Psa())
         && $IsAlloc(psa2#0, Tclass.PackedStringArray.Psa(), $Heap)
         && $IsA#PackedStringArray.Psa(psa2#0))
   returns ($_reverifyPost: bool);
  free requires 72 == $FunctionContextHeight;
  // user-defined preconditions
  free requires PackedStringArray.__default.WF#canCall(psa1#0)
     && 
    PackedStringArray.__default.WF(psa1#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa1#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa1#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa1#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa1#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa1#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa1#0));
  free requires PackedStringArray.__default.WF#canCall(psa2#0)
     && 
    PackedStringArray.__default.WF(psa2#0)
     && 
    Seq#Length(PackedStringArray.Psa.offsets(psa2#0)) < 4294967296
     && Seq#Length(PackedStringArray.Psa.data(psa2#0)) < 4294967296
     && (Seq#Length(PackedStringArray.Psa.offsets(psa2#0)) == LitInt(0)
       ==> Seq#Length(PackedStringArray.Psa.data(psa2#0)) == LitInt(0))
     && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa2#0))
       ==> Seq#Length(PackedStringArray.Psa.data(psa2#0))
         == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa2#0), 
            Seq#Length(PackedStringArray.Psa.offsets(psa2#0)) - 1)): int)
     && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa2#0));
  requires Seq#Equal(PackedStringArray.__default.I(psa1#0), PackedStringArray.__default.I(psa2#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#PackedStringArray.Psa(psa1#0) && $IsA#PackedStringArray.Psa(psa2#0);
  ensures PackedStringArray.Psa#Equal(psa1#0, psa2#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$PackedStringArray.__default.UniqueRepr(psa1#0: DatatypeType, psa2#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var pre1#0: DatatypeType
     where $Is(pre1#0, Tclass.PackedStringArray.Psa())
       && $IsAlloc(pre1#0, Tclass.PackedStringArray.Psa(), $Heap);
  var ##psa#4: DatatypeType;
  var pre2#0: DatatypeType
     where $Is(pre2#0, Tclass.PackedStringArray.Psa())
       && $IsAlloc(pre2#0, Tclass.PackedStringArray.Psa(), $Heap);
  var ##psa#5: DatatypeType;
  var psa1##0: DatatypeType;
  var psa2##0: DatatypeType;
  var last#0: Seq Box
     where $Is(last#0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(last#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var ##psa#6: DatatypeType;
  var ##run#0: Seq Box;

    // AddMethodImpl: UniqueRepr, Impl$$PackedStringArray.__default.UniqueRepr
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1093,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1094,5)
    assume PackedStringArray.Psa.Psa_q(psa1#0);
    assume PackedStringArray.Psa.Psa_q(psa1#0);
    if (Seq#Length(PackedStringArray.Psa.offsets(psa1#0)) == LitInt(0))
    {
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1096,16)
        assume true;
        ##psa#4 := psa1#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#4, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Seq#Length(PackedStringArray.Psa.data(##psa#4)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#4))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#4))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#4), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#4)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#4)
           ==> PackedStringArray.__default.WF(##psa#4)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#4));
        assume PackedStringArray.__default.WF(##psa#4);
        assert {:subsumption 0} 0 < PackedStringArray.__default.psaNumStrings(##psa#4);
        assume 0 < PackedStringArray.__default.psaNumStrings(##psa#4);
        assume PackedStringArray.__default.psaDropLast#canCall(psa1#0);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaDropLast(psa1#0));
        assume PackedStringArray.__default.psaDropLast#canCall(psa1#0);
        pre1#0 := PackedStringArray.__default.psaDropLast(psa1#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1096,35)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1097,16)
        assume true;
        ##psa#5 := psa2#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#5, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || Seq#Length(PackedStringArray.Psa.data(##psa#5)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#5)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#5))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#5))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#5), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#5)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#5)
           ==> PackedStringArray.__default.WF(##psa#5)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#5));
        assume PackedStringArray.__default.WF(##psa#5);
        assert {:subsumption 0} 0 < PackedStringArray.__default.psaNumStrings(##psa#5);
        assume 0 < PackedStringArray.__default.psaNumStrings(##psa#5);
        assume PackedStringArray.__default.psaDropLast#canCall(psa2#0);
        assume PackedStringArray.Psa.Psa_q(PackedStringArray.__default.psaDropLast(psa2#0));
        assume PackedStringArray.__default.psaDropLast#canCall(psa2#0);
        pre2#0 := PackedStringArray.__default.psaDropLast(psa2#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1097,35)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1098,17)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa1##0 := pre1#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        psa2##0 := pre2#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= Seq#Length(PackedStringArray.Psa.offsets(psa1#0))
           || Seq#Length(PackedStringArray.Psa.offsets(psa1##0))
             == Seq#Length(PackedStringArray.Psa.offsets(psa1#0));
        assert Seq#Length(PackedStringArray.Psa.offsets(psa1##0))
           < Seq#Length(PackedStringArray.Psa.offsets(psa1#0));
        // ProcessCallStmt: Make the call
        call Call$$PackedStringArray.__default.UniqueRepr(psa1##0, psa2##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1098,28)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1099,16)
        assume true;
        ##psa#6 := psa1#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##psa#6, Tclass.PackedStringArray.Psa(), $Heap);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
           ==> PackedStringArray.__default.WF(##psa#6)
             || Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
           ==> PackedStringArray.__default.WF(##psa#6)
             || Seq#Length(PackedStringArray.Psa.data(##psa#6)) < 4294967296;
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
           ==> PackedStringArray.__default.WF(##psa#6)
             || (Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#6)) == LitInt(0));
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
           ==> PackedStringArray.__default.WF(##psa#6)
             || (0 < Seq#Length(PackedStringArray.Psa.offsets(##psa#6))
               ==> Seq#Length(PackedStringArray.Psa.data(##psa#6))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(##psa#6), 
                    Seq#Length(PackedStringArray.Psa.offsets(##psa#6)) - 1)): int);
        assert {:subsumption 0} PackedStringArray.__default.WF#canCall(##psa#6)
           ==> PackedStringArray.__default.WF(##psa#6)
             || Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
              PackedStringArray.Psa.offsets(##psa#6));
        assume PackedStringArray.__default.WF(##psa#6);
        assume PackedStringArray.__default.I#canCall(psa1#0);
        ##run#0 := PackedStringArray.__default.I(psa1#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assert {:subsumption 0} Seq#Length(##run#0) > 0;
        assume Seq#Length(##run#0) > 0;
        assume Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa1#0));
        assume PackedStringArray.__default.I#canCall(psa1#0)
           && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa1#0));
        last#0 := $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa1#0))): Seq Box;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1099,31)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/Buckets/PackedStringArray.i.dfy(1100,7)
        assume PackedStringArray.Psa.Psa_q(psa1#0);
        assume PackedStringArray.Psa.Psa_q(pre1#0);
        assume PackedStringArray.Psa.Psa_q(psa1#0) && PackedStringArray.Psa.Psa_q(pre1#0);
        assert Seq#Equal(PackedStringArray.Psa.data(psa1#0), 
          Seq#Append(PackedStringArray.Psa.data(pre1#0), last#0));
    }
}



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$PackedStringArray.__default.reveal__psaSeq();
  free requires 73 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_PackedStringArray._default.psaSeq0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$PackedStringArray.__default.reveal__psaSeq();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_PackedStringArray._default.psaSeq
     == $LS(MoreFuel_PackedStringArray._default.psaSeq0);
  free ensures StartFuelAssert_PackedStringArray._default.psaSeq
     == $LS($LS(MoreFuel_PackedStringArray._default.psaSeq0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_PackedStringArray._default.psaSeq0)
     == MoreFuel_PackedStringArray._default.psaSeq0;



function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: Box :: 
  { #Options.Option.Some(a#5#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#5#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#6#0#0: Box :: d == #Options.Option.Some(a#6#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#7#0#0: Box :: 
  { $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#7#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#8#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#8#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#9#0#0: Box :: 
  { #Options.Option.Some(Lit(a#9#0#0)) } 
  #Options.Option.Some(Lit(a#9#0#0)) == Lit(#Options.Option.Some(a#9#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#10#0#0: Box :: 
  { #Options.Option.Some(a#10#0#0) } 
  Options.Option.value(#Options.Option.Some(a#10#0#0)) == a#10#0#0);

// Inductive rank
axiom (forall a#11#0#0: Box :: 
  { #Options.Option.Some(a#11#0#0) } 
  BoxRank(a#11#0#0) < DtRank(#Options.Option.Some(a#11#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#1)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#1)): DatatypeType)));

const unique class.NativePackedInts.__default: ClassName;

function Tclass.NativePackedInts.__default() : Ty;

// Tclass.NativePackedInts.__default Tag
axiom Tag(Tclass.NativePackedInts.__default()) == Tagclass.NativePackedInts.__default;

const unique Tagclass.NativePackedInts.__default: TyTag;

// Box/unbox axiom for Tclass.NativePackedInts.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativePackedInts.__default()) } 
  $IsBox(bx, Tclass.NativePackedInts.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativePackedInts.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativePackedInts.__default()) } 
  $Is($o, Tclass.NativePackedInts.__default())
     <==> $o == null || dtype($o) == Tclass.NativePackedInts.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativePackedInts.__default(), $h) } 
  $IsAlloc($o, Tclass.NativePackedInts.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32
function NativePackedInts.__default.unpack__LittleEndian__Uint32($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) < 4294967296);

function NativePackedInts.__default.unpack__LittleEndian__Uint32#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(4)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64
function NativePackedInts.__default.unpack__LittleEndian__Uint64($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
           < 18446744073709551616);

function NativePackedInts.__default.unpack__LittleEndian__Uint64#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(8)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(7))): int, LitInt(72057594037927936)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), i#0) + 4), Mul(LitInt(4), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(4))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(4))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))))));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), i#0) + 8), Mul(LitInt(8), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(8))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(8))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))))));

const unique class.SeqComparison.__default: ClassName;

function Tclass.SeqComparison.__default() : Ty;

// Tclass.SeqComparison.__default Tag
axiom Tag(Tclass.SeqComparison.__default()) == Tagclass.SeqComparison.__default;

const unique Tagclass.SeqComparison.__default: TyTag;

// Box/unbox axiom for Tclass.SeqComparison.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SeqComparison.__default()) } 
  $IsBox(bx, Tclass.SeqComparison.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SeqComparison.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SeqComparison.__default()) } 
  $Is($o, Tclass.SeqComparison.__default())
     <==> $o == null || dtype($o) == Tclass.SeqComparison.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SeqComparison.__default(), $h) } 
  $IsAlloc($o, Tclass.SeqComparison.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for SeqComparison._default.lte
function SeqComparison.__default.lte($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
  SeqComparison.__default.lte($LS($ly), a#0, b#0)
     == SeqComparison.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  SeqComparison.__default.lte($ly, a#0, b#0)
     == SeqComparison.__default.lte($LZ, a#0, b#0));

// consequence axiom for SeqComparison.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($ly, a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lte
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lte#requires($ly, a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int <= $Unbox(Seq#Index(a#0, LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(a#0, LitInt(0))): int <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(a#0, LitInt(0))): int < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int < $Unbox(Seq#Index(a#0, LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($ly, Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0)
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(Lit(b#0)) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(Lit(b#0)) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))))));

// function declaration for SeqComparison._default.lt
function SeqComparison.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for SeqComparison.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lt#requires(a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && SeqComparison.__default.lt(a#0, b#0)
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0)
             && !Seq#Equal(a#0, b#0)));

// definition axiom for SeqComparison.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lt(Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && SeqComparison.__default.lt(Lit(a#0), Lit(b#0))
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

const unique class.NativeArrays.__default: ClassName;

function Tclass.NativeArrays.__default() : Ty;

// Tclass.NativeArrays.__default Tag
axiom Tag(Tclass.NativeArrays.__default()) == Tagclass.NativeArrays.__default;

const unique Tagclass.NativeArrays.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArrays.__default()) } 
  $IsBox(bx, Tclass.NativeArrays.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArrays.__default()) } 
  $Is($o, Tclass.NativeArrays.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArrays.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure {:extern "NativeArrays_Compile", "newArrayFill"} CheckWellformed$$NativeArrays.__default.newArrayFill(NativeArrays._default.newArrayFill$T: Ty, 
    n#0: int where LitInt(0) <= n#0 && n#0 < 18446744073709551616, 
    t#0: Box
       where $IsBox(t#0, NativeArrays._default.newArrayFill$T)
         && $IsAllocBox(t#0, NativeArrays._default.newArrayFill$T, $Heap))
   returns (ar#0: ref
       where $Is(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T))
         && $IsAlloc(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "newArrayFill"} Call$$NativeArrays.__default.newArrayFill(NativeArrays._default.newArrayFill$T: Ty, 
    n#0: int where LitInt(0) <= n#0 && n#0 < 18446744073709551616, 
    t#0: Box
       where $IsBox(t#0, NativeArrays._default.newArrayFill$T)
         && $IsAllocBox(t#0, NativeArrays._default.newArrayFill$T, $Heap))
   returns (ar#0: ref
       where $Is(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T))
         && $IsAlloc(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures _System.array.Length(ar#0) == n#0;
  free ensures true;
  ensures (forall i#0: int :: 
    { read($Heap, ar#0, IndexField(i#0)) } 
    LitInt(0) <= i#0 && i#0 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < n#0
       ==> read($Heap, ar#0, IndexField(i#0)) == t#0);
  free ensures true;
  ensures ar#0 != null && !read(old($Heap), ar#0, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:extern "NativeArrays_Compile", "CopySeqIntoArray"} CheckWellformed$$NativeArrays.__default.CopySeqIntoArray(NativeArrays._default.CopySeqIntoArray$A: Ty, 
    src#0: Seq Box
       where $Is(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "CopySeqIntoArray"} Call$$NativeArrays.__default.CopySeqIntoArray(NativeArrays._default.CopySeqIntoArray$A: Ty, 
    src#0: Seq Box
       where $Is(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires srcIndex#0 + len#0 <= Seq#Length(src#0);
  requires dstIndex#0 + len#0 <= _System.array.Length(dst#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall i#0: int :: 
    { Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0) } 
      { read($Heap, dst#0, IndexField(i#0)) } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 < _System.array.Length(dst#0)
       ==> read($Heap, dst#0, IndexField(i#0))
         == (if dstIndex#0 <= i#0 && i#0 < dstIndex#0 + len#0
           then Seq#Index(src#0, i#0 - dstIndex#0 + srcIndex#0)
           else Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0)));
  free ensures true;
  ensures (forall i#1: int :: 
    { Seq#Index(src#0, i#1) } 
    true
       ==> 
      srcIndex#0 <= i#1 && i#1 < srcIndex#0 + len#0
       ==> Seq#Index(src#0, i#1)
         == read($Heap, dst#0, IndexField(i#1 - srcIndex#0 + dstIndex#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == dst#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:extern "NativeArrays_Compile", "CopyArrayIntoDifferentArray"} CheckWellformed$$NativeArrays.__default.CopyArrayIntoDifferentArray(NativeArrays._default.CopyArrayIntoDifferentArray$A: Ty, 
    src#0: ref
       where $Is(src#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(src#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(dst#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "CopyArrayIntoDifferentArray"} Call$$NativeArrays.__default.CopyArrayIntoDifferentArray(NativeArrays._default.CopyArrayIntoDifferentArray$A: Ty, 
    src#0: ref
       where $Is(src#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(src#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A))
         && $IsAlloc(dst#0, 
          Tclass._System.array(NativeArrays._default.CopyArrayIntoDifferentArray$A), 
          $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires srcIndex#0 + len#0 <= _System.array.Length(src#0);
  requires dstIndex#0 + len#0 <= _System.array.Length(dst#0);
  requires src#0 != dst#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall i#0: int :: 
    { Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0) } 
      { read($Heap, dst#0, IndexField(i#0)) } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 < _System.array.Length(dst#0)
       ==> read($Heap, dst#0, IndexField(i#0))
         == (if dstIndex#0 <= i#0 && i#0 < dstIndex#0 + len#0
           then read(old($Heap), src#0, IndexField(i#0 - dstIndex#0 + srcIndex#0))
           else Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0)));
  free ensures true;
  ensures (forall i#1: int :: 
    { read(old($Heap), src#0, IndexField(i#1)) } 
    true
       ==> 
      srcIndex#0 <= i#1 && i#1 < srcIndex#0 + len#0
       ==> read(old($Heap), src#0, IndexField(i#1))
         == read($Heap, dst#0, IndexField(i#1 - srcIndex#0 + dstIndex#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == dst#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#0: int, j#0: int :: 
          { Seq#Index(a#0, j#0), Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#0
               && j#0 < Seq#Length(a#0)
               && i#0 != j#0
             ==> Seq#Index(a#0, i#0) != Seq#Index(a#0, j#0)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#1: int, j#1: int :: 
          { Seq#Index(a#0, j#1), Seq#Index(a#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#1
               && j#1 < Seq#Length(Lit(a#0))
               && i#1 != j#1
             ==> Seq#Index(Lit(a#0), i#1) != Seq#Index(Lit(a#0), j#1)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#0 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#0));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#1 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#1));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#2 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#2));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int == i#0)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#2)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#2)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x0#0: Box, _o0#0: ref :: 
            $IsBox(_x0#0, Sequences._default.Filter$E)
               && $Is(_o0#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x0#0)[$Box(_o0#0)]
               && $Box($o) == $Box(_o0#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#0))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#1) } 
          LitInt(0) <= i#1
             ==> 
            i#1
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#2: int :: 
        { Seq#Index(run#0, i#2) } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#2: int :: 
            { Seq#Index(run#0, i#2) } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1) } 
          pos#0 <= i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1)
               == Seq#Index(s#0, i#1 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 <= i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#1)
               == Seq#Index(s#0, i#1 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0))
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#1)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#1))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#0))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#1: int :: 
          { Seq#Index(c#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#1)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#1))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#0: int :: 
            { Seq#Index(run#0, j#0) } 
            i#0 <= j#0 && j#0 < Seq#Length(run#0) ==> Seq#Index(run#0, j#0) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#0) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#0)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#0: int :: 
          { Seq#Index(b#0, i#0) } 
            { Seq#Index(a#0, i#0) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#0)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#0), Seq#Index(b#0, i#0))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(z#0, i#0)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0)), 
              $Unbox(Seq#Index(z#0, i#0)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#0, b#0 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#1, b#1 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(seqs#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#0)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#0)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

procedure {:_induction seqs1#0, seqs2#0} CheckWellformed$$Sequences.__default.FlattenShapeAdditive(Sequences._default.FlattenShapeAdditive$A: Ty, 
    seqs1#0: Seq Box
       where $Is(seqs1#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)))
         && $IsAlloc(seqs1#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)), $Heap), 
    seqs2#0: Seq Box
       where $Is(seqs2#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)))
         && $IsAlloc(seqs2#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)), $Heap));
  free requires 63 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction seqs1#0, seqs2#0} Call$$Sequences.__default.FlattenShapeAdditive(Sequences._default.FlattenShapeAdditive$A: Ty, 
    seqs1#0: Seq Box
       where $Is(seqs1#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)))
         && $IsAlloc(seqs1#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)), $Heap), 
    seqs2#0: Seq Box
       where $Is(seqs2#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)))
         && $IsAlloc(seqs2#0, TSeq(TSeq(Sequences._default.FlattenShapeAdditive$A)), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShapeAdditive$A, Seq#Append(seqs1#0, seqs2#0))
     && 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShapeAdditive$A, seqs1#0)
     && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShapeAdditive$A, seqs2#0);
  ensures Seq#Equal(Sequences.__default.FlattenShape(Sequences._default.FlattenShapeAdditive$A, 
      StartFuelAssert_Sequences._default.FlattenShape, 
      Seq#Append(seqs1#0, seqs2#0)), 
    Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShapeAdditive$A, 
        StartFuelAssert_Sequences._default.FlattenShape, 
        seqs1#0), 
      Sequences.__default.FlattenShape(Sequences._default.FlattenShapeAdditive$A, 
        StartFuelAssert_Sequences._default.FlattenShape, 
        seqs2#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

procedure {:_induction shape1#0, shape2#0} CheckWellformed$$Sequences.__default.FlattenLengthAdditive(shape1#0: Seq Box
       where $Is(shape1#0, TSeq(Tclass._System.nat()))
         && $IsAlloc(shape1#0, TSeq(Tclass._System.nat()), $Heap), 
    shape2#0: Seq Box
       where $Is(shape2#0, TSeq(Tclass._System.nat()))
         && $IsAlloc(shape2#0, TSeq(Tclass._System.nat()), $Heap));
  free requires 23 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction shape1#0, shape2#0} Call$$Sequences.__default.FlattenLengthAdditive(shape1#0: Seq Box
       where $Is(shape1#0, TSeq(Tclass._System.nat()))
         && $IsAlloc(shape1#0, TSeq(Tclass._System.nat()), $Heap), 
    shape2#0: Seq Box
       where $Is(shape2#0, TSeq(Tclass._System.nat()))
         && $IsAlloc(shape2#0, TSeq(Tclass._System.nat()), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.FlattenLength#canCall(Seq#Append(shape1#0, shape2#0))
     && 
    Sequences.__default.FlattenLength#canCall(shape1#0)
     && Sequences.__default.FlattenLength#canCall(shape2#0);
  ensures Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, Seq#Append(shape1#0, shape2#0))
     == Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, shape1#0)
       + Sequences.__default.FlattenLength(StartFuelAssert_Sequences._default.FlattenLength, shape2#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape0: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape0)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape0)
           == MoreFuel_Sequences._default.FlattenShape0
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape1: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape1)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape1)
           == MoreFuel_Sequences._default.FlattenShape1
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength0: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength0)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength0)
           == MoreFuel_Sequences._default.FlattenLength0
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength1: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength1)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength1)
           == MoreFuel_Sequences._default.FlattenLength1
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Sequences.__default.reveal__FlattenShape();
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Sequences._default.FlattenShape2: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Sequences.__default.reveal__FlattenShape();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Sequences._default.FlattenShape
     == $LS(MoreFuel_Sequences._default.FlattenShape2);
  free ensures StartFuelAssert_Sequences._default.FlattenShape
     == $LS($LS(MoreFuel_Sequences._default.FlattenShape2));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Sequences._default.FlattenShape2)
     == MoreFuel_Sequences._default.FlattenShape2;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Sequences.__default.reveal__FlattenLength();
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Sequences._default.FlattenLength2: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Sequences.__default.reveal__FlattenLength();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Sequences._default.FlattenLength
     == $LS(MoreFuel_Sequences._default.FlattenLength2);
  free ensures StartFuelAssert_Sequences._default.FlattenLength
     == $LS($LS(MoreFuel_Sequences._default.FlattenLength2));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Sequences._default.FlattenLength2)
     == MoreFuel_Sequences._default.FlattenLength2;



const unique class.Maps.__default: ClassName;

function Tclass.Maps.__default() : Ty;

// Tclass.Maps.__default Tag
axiom Tag(Tclass.Maps.__default()) == Tagclass.Maps.__default;

const unique Tagclass.Maps.__default: TyTag;

// Box/unbox axiom for Tclass.Maps.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Maps.__default()) } 
  $IsBox(bx, Tclass.Maps.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Maps.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Maps.__default()) } 
  $Is($o, Tclass.Maps.__default())
     <==> $o == null || dtype($o) == Tclass.Maps.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Maps.__default(), $h) } 
  $IsAlloc($o, Tclass.Maps.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Maps._default.IMapsTo
function Maps.__default.IMapsTo(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsTo
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> true);

function Maps.__default.IMapsTo#requires(Ty, Ty, IMap Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsTo
axiom (forall Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
       && $IsBox(k#0, Maps._default.IMapsTo$K)
       && $IsBox(v#0, Maps._default.IMapsTo$V)
     ==> Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.IMapsTo(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.IMapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsTo
function Maps.__default.MapsTo(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsTo
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> true);

function Maps.__default.MapsTo#requires(Ty, Ty, Map Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.MapsTo
axiom (forall Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
       && $IsBox(k#0, Maps._default.MapsTo$K)
       && $IsBox(v#0, Maps._default.MapsTo$V)
     ==> Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.MapsTo(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsAgreeOnKey
function Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsAgreeOnKey
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> true);

function Maps.__default.MapsAgreeOnKey#requires(Ty, Ty, Map Box Box, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapsAgreeOnKey
axiom (forall Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K)
     ==> Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.MapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(m#0)[k#0] == Map#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[k#0] == Map#Elements(Lit(m'#0))[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[Lit(k#0)] == Map#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IMapsAgreeOnKey
function Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsAgreeOnKey
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> true);

function Maps.__default.IMapsAgreeOnKey#requires(Ty, Ty, IMap Box Box, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsAgreeOnKey
axiom (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K)
     ==> Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(m#0)[k#0] == IMap#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.IMapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
        Maps._default.IMapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(Lit(m#0))[Lit(k#0)] == IMap#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IsSubIMap
function Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

function Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubIMap
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> true);

function Maps.__default.IsSubIMap#requires(Ty, Ty, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IsSubIMap
axiom (forall Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box :: 
  { Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
  $Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
       && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
     ==> Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubIMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
              { IMap#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubIMap$K)
               ==> 
              IMap#Domain(sub#0)[key#0]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
           == (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
                { IMap#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubIMap$K)
                 ==> 
                IMap#Domain(sub#0)[key#0]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubIMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
              { IMap#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubIMap$K)
               ==> 
              Lit(IMap#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, 
                Maps._default.IsSubIMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
           == (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
                { IMap#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubIMap$K)
                 ==> 
                Lit(IMap#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, 
                  Maps._default.IsSubIMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.IsSubMap
function Maps.__default.IsSubMap(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

function Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubMap
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> true);

function Maps.__default.IsSubMap#requires(Ty, Ty, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.IsSubMap
axiom (forall Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box :: 
  { Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
  $Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
       && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
     ==> Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
              { Map#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubMap$K)
               ==> 
              Map#Domain(sub#0)[key#0]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
           == (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
                { Map#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubMap$K)
                 ==> 
                Map#Domain(sub#0)[key#0]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    {:weight 3} { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
              { Map#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubMap$K)
               ==> 
              Lit(Map#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, 
                Maps._default.IsSubMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
           == (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
                { Map#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubMap$K)
                 ==> 
                Lit(Map#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, 
                  Maps._default.IsSubMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.MapRemove
function Maps.__default.MapRemove(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
      Maps._default.MapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemove
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> (forall k#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0] } 
            { ks#0[k#0] } 
            { Map#Domain(m#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(m#0)[k#0] && !ks#0[k#0]
             ==> Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0])
         && (forall k#1: Box :: 
          { ks#0[k#1] } 
            { Map#Domain(m#0)[k#1] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapRemove$K)
             ==> (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> Map#Domain(m#0)[k#1])
               && (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> !ks#0[k#1]))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)));

function Maps.__default.MapRemove#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemove
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
       && $Is(ks#0, TSet(Maps._default.MapRemove$K))
     ==> Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRemove(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove$K) && Map#Domain(m#0)[$w#1] && !ks#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
        Maps._default.MapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, 
          Maps._default.MapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove$K)
                   && 
                  Map#Domain(m#0)[$w#3]
                   && !Lit(ks#0)[$w#3]), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#1));

// function declaration for Maps._default.MapRemoveStrong
function Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemoveStrong
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)), 
          Set#Difference(Map#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemoveStrong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V)));

function Maps.__default.MapRemoveStrong#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemoveStrong
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
       && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K))
     ==> Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
       == true);

const MoreFuel_Maps._default.MapRemove0: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        m#0, 
        ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove0)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove0))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove0)
           == MoreFuel_Maps._default.MapRemove0
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            m#0, 
            ks#0)
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            m#0, 
            ks#0));

const MoreFuel_Maps._default.MapRemove1: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove1)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove1))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove1)
           == MoreFuel_Maps._default.MapRemove1
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(ks#0))
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            Lit(m#0), 
            Lit(ks#0)));

// function declaration for Maps._default.MapRemove1
function Maps.__default.MapRemove1(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
      Maps._default.MapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.MapRemove1
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> (forall j#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { Map#Domain(m#0)[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(m#0)[j#0] && j#0 != k#0
             ==> Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0])
         && (forall j#1: Box :: 
          { Map#Domain(m#0)[j#1] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemove1$K)
             ==> (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> Map#Domain(m#0)[j#1])
               && (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> j#1 != k#0))
         && (forall j#2: Box :: 
          { Map#Elements(m#0)[j#2] } 
            { Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
          $IsBox(j#2, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
             ==> Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
               == Map#Elements(m#0)[j#2])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)))
           <= Set#Card(Map#Domain(m#0))
         && (Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0) - 1)
         && (!Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0))
         && $Is(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0), 
          TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)));

function Maps.__default.MapRemove1#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
       && $IsBox(k#0, Maps._default.MapRemove1$K)
     ==> Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.MapRemove1(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#1] && $w#1 != k#0), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0)
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#3] && $w#3 != k#0), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#1));

// definition axiom for Maps.__default.MapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
        Maps._default.MapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
          Maps._default.MapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == (var m'#2 := Map#Glue((lambda $w#5: Box :: 
                $IsBox($w#5, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#5] && $w#5 != k#0), 
              (lambda $w#5: Box :: Map#Elements(Lit(m#0))[$w#5]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#2));

// function declaration for Maps._default.MapRemove1Strong
function Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LZ, 
      m#0, 
      k#0));

// consequence axiom for Maps.__default.MapRemove1Strong
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0)), 
          Set#Difference(Map#Domain(m#0), Set#UnionOne(Set#Empty(): Set Box, k#0)))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1Strong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                  Maps._default.MapRemove1Strong$V, 
                  $ly, 
                  m#0, 
                  k#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $ly, 
            m#0, 
            k#0), 
          TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V)));

function Maps.__default.MapRemove1Strong#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1Strong
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
       && $IsBox(k#0, Maps._default.MapRemove1Strong$K)
     ==> Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0)
       == true);

const MoreFuel_Maps._default.MapRemove10: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove10)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove10))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove10)
           == MoreFuel_Maps._default.MapRemove10
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            m#0, 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            m#0, 
            k#0));

const MoreFuel_Maps._default.MapRemove11: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove11)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove11))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove11)
           == MoreFuel_Maps._default.MapRemove11
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            k#0));

const MoreFuel_Maps._default.MapRemove12: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove12)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove12))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove12)
           == MoreFuel_Maps._default.MapRemove12
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(k#0))
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            Lit(k#0)));

// function declaration for Maps._default.IMapRemove
function Maps.__default.IMapRemove(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
      Maps._default.IMapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.IMapRemove
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)), 
          ISet#Difference(IMap#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

function Maps.__default.IMapRemove#requires(Ty, Ty, LayerType, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRemove
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
       && $Is(ks#0, TISet(Maps._default.IMapRemove$K))
     ==> Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRemove(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && !ks#0[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// definition axiom for Maps.__default.IMapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
        Maps._default.IMapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
          Maps._default.IMapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && !Lit(ks#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// function declaration for Maps._default.IMapRemove1
function Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box)
   : IMap Box Box;

function Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
      Maps._default.IMapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.IMapRemove1
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)), 
          ISet#Difference(IMap#Domain(m#0), ISet#UnionOne(ISet#Empty(): ISet Box, k#0)))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove1$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

function Maps.__default.IMapRemove1#requires(Ty, Ty, LayerType, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapRemove1
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
       && $IsBox(k#0, Maps._default.IMapRemove1$K)
     ==> Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapRemove1(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && $w#0 != k#0), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// definition axiom for Maps.__default.IMapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
        Maps._default.IMapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
          Maps._default.IMapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && $w#1 != k#0), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// function declaration for Maps._default.MapRestrict
function Maps.__default.MapRestrict(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// consequence axiom for Maps.__default.MapRestrict
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> $Is(Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

function Maps.__default.MapRestrict#requires(Ty, Ty, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRestrict
axiom (forall Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
       && $Is(ks#0, TSet(Maps._default.MapRestrict$K))
     ==> Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapRestrict$K) && ks#0[$w#0] && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// definition axiom for Maps.__default.MapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// function declaration for Maps._default.MapIRestrict
function Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : Map Box Box;

function Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.MapIRestrict
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> $Is(Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

function Maps.__default.MapIRestrict#requires(Ty, Ty, Map Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.MapIRestrict
axiom (forall Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
       && $Is(ks#0, TISet(Maps._default.MapIRestrict$K))
     ==> Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapIRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#0]
               && ks#0[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#1]
               && ks#0[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#2]
               && Lit(ks#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(Lit(m#0))[$w#2]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// function declaration for Maps._default.IMapRestrict
function Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.IMapRestrict
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> $Is(Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0), 
        TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

function Maps.__default.IMapRestrict#requires(Ty, Ty, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRestrict
axiom (forall Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
       && $Is(ks#0, TISet(Maps._default.IMapRestrict$K))
     ==> Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRestrict(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRestrict$K)
               && 
              ks#0[$w#0]
               && IMap#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// definition axiom for Maps.__default.IMapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && IMap#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// function declaration for Maps._default.MapDisjointUnion
function Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapDisjointUnion
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
              Maps._default.MapDisjointUnion$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1])
         && $Is(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
            Maps._default.MapDisjointUnion$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

function Maps.__default.MapDisjointUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
     ==> Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)));

// definition axiom for Maps.__default.MapDisjointUnion(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// definition axiom for Maps.__default.MapDisjointUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// function declaration for Maps._default.MapUnionPreferA
function Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferA
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
              Maps._default.MapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapa#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapb#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
            Maps._default.MapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

function Maps.__default.MapUnionPreferA#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferA
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
     ==> Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferA$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// definition axiom for Maps.__default.MapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferA$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// function declaration for Maps._default.MapUnionPreferB
function Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferB
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
              Maps._default.MapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapb#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapa#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#1] && !Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
            Maps._default.MapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

function Maps.__default.MapUnionPreferB#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferB
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
     ==> Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferB$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapb#0)[$w#0]
               then Map#Elements(mapb#0)[$w#0]
               else Map#Elements(mapa#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// definition axiom for Maps.__default.MapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferB$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapb#0)[$w#1]
               then Map#Elements(Lit(mapb#0))[$w#1]
               else Map#Elements(Lit(mapa#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// function declaration for Maps._default.MapUnion
function Maps.__default.MapUnion(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
      Maps._default.MapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.MapUnion
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0] && !Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { Map#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(mapb#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || Map#Elements(mapa#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0), 
          TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)));

function Maps.__default.MapUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnion
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
     ==> Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnion(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.MapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
        Maps._default.MapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.IMapUnionPreferA
function Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferA
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
              Maps._default.IMapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapa#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapa#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapb#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapb#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#2] && !IMap#Domain(mapa#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapb#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
            Maps._default.IMapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

function Maps.__default.IMapUnionPreferA#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferA
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
     ==> Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferA$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapa#0)[$w#0]
               then IMap#Elements(mapa#0)[$w#0]
               else IMap#Elements(mapb#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// definition axiom for Maps.__default.IMapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferA$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapa#0)[$w#1]
               then IMap#Elements(Lit(mapa#0))[$w#1]
               else IMap#Elements(Lit(mapb#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// function declaration for Maps._default.IMapUnionPreferB
function Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferB
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
              Maps._default.IMapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapb#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapa#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#1] && !IMap#Domain(mapb#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && !IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
            Maps._default.IMapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

function Maps.__default.IMapUnionPreferB#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferB
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
     ==> Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferB$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapb#0)[$w#0]
               then IMap#Elements(mapb#0)[$w#0]
               else IMap#Elements(mapa#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// definition axiom for Maps.__default.IMapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferB$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapb#0)[$w#1]
               then IMap#Elements(Lit(mapb#0))[$w#1]
               else IMap#Elements(Lit(mapa#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// function declaration for Maps._default.IMapUnion
function Maps.__default.IMapUnion(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
      Maps._default.IMapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.IMapUnion
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { IMap#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#0] && !IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(mapa#0)[k#0]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { IMap#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(mapb#0)[k#1]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { IMap#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(mapb#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || IMap#Elements(mapa#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0), 
          TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)));

function Maps.__default.IMapUnion#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnion
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
       && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
     ==> Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnion(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.IMapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
        Maps._default.IMapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.MapDisjointUnion3
function Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LZ, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// consequence axiom for Maps.__default.MapDisjointUnion3
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              $ly, 
              mapa#0, 
              mapb#0, 
              mapc#0)), 
          Set#Union(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
         && (!Set#Equal(Map#Domain(mapa#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapb#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapc#0), Set#Empty(): Set Box)
           ==> !Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0)), 
            Set#Empty(): Set Box))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#2] } 
            { Map#Elements(mapc#0)[k#2] } 
            { Map#Domain(mapc#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapc#0)[k#2]
             ==> Map#Elements(mapc#0)[k#2]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#2])
         && 
        Map#Equal(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)))
         && Map#Equal(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapa#0, 
              mapb#0), 
            mapc#0))
         && $Is(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

function Maps.__default.MapDisjointUnion3#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion3
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  $Is(mapa#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapb#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapc#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
     ==> Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0)
       == (
        Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0))));

// definition axiom for Maps.__default.MapDisjointUnion3(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0, 
          mapc#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion3$U)
               && (
                Map#Domain(mapa#0)[$w#0]
                 || Map#Domain(mapb#0)[$w#0]
                 || Map#Domain(mapc#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else (if Map#Domain(mapb#0)[$w#0]
                 then Map#Elements(mapb#0)[$w#0]
                 else Map#Elements(mapc#0)[$w#0]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// definition axiom for Maps.__default.MapDisjointUnion3 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0), 
        Lit(mapc#0)) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Set#Union(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))), 
            Map#Domain(Lit(mapc#0))))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion3$U)
               && (
                Lit(Map#Domain(Lit(mapa#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapb#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapc#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else (if Map#Domain(mapb#0)[$w#1]
                 then Map#Elements(Lit(mapb#0))[$w#1]
                 else Map#Elements(Lit(mapc#0))[$w#1]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// function declaration for Maps._default.MapToImap
function Maps.__default.MapToImap(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : IMap Box Box;

function Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.MapToImap
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> $Is(Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0), 
        TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

function Maps.__default.MapToImap#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapToImap
axiom (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
  { Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
  $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
     ==> Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
       == true);

// definition axiom for Maps.__default.MapToImap(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// definition axiom for Maps.__default.MapToImap for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0)) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// function declaration for Maps._default.MapLookupOption
function Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapLookupOption
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> $Is(Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.MapLookupOption$V)));

function Maps.__default.MapLookupOption#requires(Ty, Ty, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapLookupOption
axiom (forall Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box :: 
  { Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
       && $IsBox(key#0, Maps._default.MapLookupOption$K)
     ==> Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.MapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

// function declaration for Maps._default.ImapLookupOption
function Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.ImapLookupOption
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> $Is(Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.ImapLookupOption$V)));

function Maps.__default.ImapLookupOption#requires(Ty, Ty, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.ImapLookupOption
axiom (forall Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box :: 
  { Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
       && $IsBox(key#0, Maps._default.ImapLookupOption$K)
     ==> Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.ImapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.ImapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
        Maps._default.ImapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

const unique class.Uint32__Order.__default: ClassName;

function Tclass.Uint32__Order.__default() : Ty;

// Tclass.Uint32__Order.__default Tag
axiom Tag(Tclass.Uint32__Order.__default()) == Tagclass.Uint32__Order.__default;

const unique Tagclass.Uint32__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Uint32__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Uint32__Order.__default()) } 
  $IsBox(bx, Tclass.Uint32__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Uint32__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Uint32__Order.__default()) } 
  $Is($o, Tclass.Uint32__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Uint32__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Uint32__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Uint32__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Uint32_Order._default.SomeElement
function Uint32__Order.__default.SomeElement() : int;

function Uint32__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Uint32__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Uint32__Order.__default.SomeElement()
     && Uint32__Order.__default.SomeElement() < 4294967296;

function Uint32__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Uint32__Order.__default.SomeElement
axiom Uint32__Order.__default.SomeElement#requires() == true;

// definition axiom for Uint32__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Uint32__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Uint32__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Uint32__Order.__default.SomeElement() == LitInt(0);

// function declaration for Uint32_Order._default.lte
function Uint32__Order.__default.lte(a#0: int, b#0: int) : bool;

function Uint32__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lte(a#0, b#0) } 
    Uint32__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
           || Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0))
         && (forall a#1: int, b#1: int, c#0: int :: 
          { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, c#0), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#1, c#0) } 
            { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#1, c#0), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, b#1) } 
          LitInt(0) <= a#1
               && a#1 < 4294967296
               && 
              LitInt(0) <= b#1
               && b#1 < 4294967296
               && 
              LitInt(0) <= c#0
               && c#0 < 4294967296
             ==> 
            Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, b#1)
               && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#1, c#0)
             ==> Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, c#0))
         && Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
           || Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0))
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
             && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#2: int, b#2: int, c#1: int :: 
          { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, c#1), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#2, c#1) } 
            { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#2, c#1), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, b#2) } 
          LitInt(0) <= a#2
               && a#2 < 4294967296
               && 
              LitInt(0) <= b#2
               && b#2 < 4294967296
               && 
              LitInt(0) <= c#1
               && c#1 < 4294967296
             ==> 
            Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, b#2)
               && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#2, c#1)
             ==> Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, c#1)));

function Uint32__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.lte#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Uint32_Order._default.ltedef0: LayerType;

// definition axiom for Uint32__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lte(a#0, b#0) } 
    Uint32__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Uint32_Order._default.ltedef
           == $LS(MoreFuel_Uint32_Order._default.ltedef0)
         && StartFuelAssert_Uint32_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint32_Order._default.ltedef0))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.ltedef0)
           == MoreFuel_Uint32_Order._default.ltedef0
         && Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0));

const MoreFuel_Uint32_Order._default.ltedef1: LayerType;

// definition axiom for Uint32__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Uint32_Order._default.ltedef
           == $LS(MoreFuel_Uint32_Order._default.ltedef1)
         && StartFuelAssert_Uint32_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint32_Order._default.ltedef1))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.ltedef1)
           == MoreFuel_Uint32_Order._default.ltedef1
         && Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Uint32_Order._default.ltedef
function Uint32__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Uint32__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Uint32__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Uint32__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Uint32__Order.__default.ltedef($ly, a#0, b#0)
     == Uint32__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Uint32__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint32__Order.__default.ltedef($ly, a#0, b#0) } 
    Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Uint32__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Uint32__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Uint32_Order._default.LargestLte
function Uint32__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
     == Uint32__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Uint32__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
         && Uint32__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Uint32__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Uint32__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Uint32__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted0: LayerType;

// definition axiom for Uint32__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint32__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted0)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted0)
           == MoreFuel_Uint32_Order._default.IsSorted0
         && Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint32_Order._default.IsSorted1: LayerType;

// definition axiom for Uint32__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint32__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint32__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted1)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted1)
           == MoreFuel_Uint32_Order._default.IsSorted1
         && Uint32__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint32__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint32_Order._default.LargestLt
function Uint32__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
     == Uint32__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Uint32__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
         && Uint32__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Uint32__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Uint32__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Uint32__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Uint32__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted2: LayerType;

// definition axiom for Uint32__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint32__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted2)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted2)
           == MoreFuel_Uint32_Order._default.IsSorted2
         && Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Uint32__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint32_Order._default.IsSorted3: LayerType;

// definition axiom for Uint32__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint32__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint32__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted3)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted3)
           == MoreFuel_Uint32_Order._default.IsSorted3
         && Uint32__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint32__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint32_Order._default.IndexOfFirstGte
function Uint32__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Uint32__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted4: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), run#0)
             && Uint32__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
              needle#0)
             && (!Uint32__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), run#0)
                 && Uint32__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted4)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted4)
           == MoreFuel_Uint32_Order._default.IsSorted4
         && Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint32__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0))));

const MoreFuel_Uint32_Order._default.IsSorted5: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
             && Uint32__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint32__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
                 && Uint32__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted5)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted5)
           == MoreFuel_Uint32_Order._default.IsSorted5
         && Uint32__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint32__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGteIter
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint32__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGte
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint32_Order._default.IndexOfFirstGt
function Uint32__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Uint32__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted6: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), run#0)
             && Uint32__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
              needle#0)
             && (!Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), run#0)
                 && Uint32__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted6)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted6)
           == MoreFuel_Uint32_Order._default.IsSorted6
         && Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint32__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0))));

const MoreFuel_Uint32_Order._default.IsSorted7: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
             && Uint32__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint32__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
                 && Uint32__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted7)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted7)
           == MoreFuel_Uint32_Order._default.IsSorted7
         && Uint32__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint32__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGtIter
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint32__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGt
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint32_Order._default.SetAllLte
function Uint32__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Uint32__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint32__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLte(a#0, b#0) } 
    Uint32__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> true);

function Uint32__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint32__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint32()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLte(a#0, b#0) } 
    Uint32__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#0: int, y#0: int :: 
          { Uint32__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
             ==> 
            b#0[$Box(y#0)]
             ==> Uint32__Order.__default.lte#canCall(x#0, y#0))
         && Uint32__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Uint32__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Uint32__Order.__default.lte(x#0, y#0)));

// definition axiom for Uint32__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Uint32__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#1: int, y#1: int :: 
          { Uint32__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Uint32__Order.__default.lte#canCall(x#1, y#1))
         && Uint32__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Uint32__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Uint32__Order.__default.lte(x#1, y#1)));

// function declaration for Uint32_Order._default.SetAllLt
function Uint32__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Uint32__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint32__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLt(a#0, b#0) } 
    Uint32__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> true);

function Uint32__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint32__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint32()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLt(a#0, b#0) } 
    Uint32__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#0: int, y#0: int :: 
          { Uint32__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
             ==> 
            b#0[$Box(y#0)]
             ==> Uint32__Order.__default.lt#canCall(x#0, y#0))
         && Uint32__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Uint32__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Uint32__Order.__default.lt(x#0, y#0)));

// definition axiom for Uint32__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Uint32__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#1: int, y#1: int :: 
          { Uint32__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Uint32__Order.__default.lt#canCall(x#1, y#1))
         && Uint32__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Uint32__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Uint32__Order.__default.lt(x#1, y#1)));

// function declaration for Uint32_Order._default.NotMinimum
function Uint32__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Uint32__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum($LS($ly), a#0) } 
  Uint32__Order.__default.NotMinimum($LS($ly), a#0)
     == Uint32__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Uint32__Order.__default.NotMinimum($ly, a#0)
     == Uint32__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Uint32__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint32__Order.__default.NotMinimum($ly, a#0) } 
    Uint32__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Uint32__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296
     ==> Uint32__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Uint32__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint32__Order.__default.NotMinimum($LS($ly), a#0) } 
    Uint32__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> (forall b#0: int :: 
          { Uint32__Order.__default.lt(b#0, a#0) } 
          LitInt(0) <= b#0 && b#0 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(b#0, a#0))
         && Uint32__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: int :: 
            { Uint32__Order.__default.lt(b#0, a#0) } 
            LitInt(0) <= b#0 && b#0 < 4294967296 && Uint32__Order.__default.lt(b#0, a#0)));

// definition axiom for Uint32__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Uint32__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Uint32__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> (forall b#1: int :: 
          { Uint32__Order.__default.lt(b#1, a#0) } 
          LitInt(0) <= b#1 && b#1 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(b#1, LitInt(a#0)))
         && Uint32__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#1: int :: 
            { Uint32__Order.__default.lt(b#1, a#0) } 
            LitInt(0) <= b#1
               && b#1 < 4294967296
               && Uint32__Order.__default.lt(b#1, LitInt(a#0))));

// function declaration for Uint32_Order._default.MapPivotedUnion
function Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Uint32__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)));

function Uint32__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Uint32__Order.__default.MapPivotedUnion
axiom (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Uint32__Order.__default.MapPivotedUnion#requires(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 4294967296
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
     ==> Uint32__Order.__default.MapPivotedUnion#requires(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Uint32__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: int :: 
          { Uint32__Order.__default.lt(k#0, pivot#0) } 
          LitInt(0) <= k#0 && k#0 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
          Uint32_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.uint32())
               && Uint32__Order.__default.lt($Unbox($y#0): int, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lt($Unbox($y#3): int, pivot#0))); 
          (forall k#1: int :: 
              { Uint32__Order.__default.lte(pivot#0, k#1) } 
              LitInt(0) <= k#1 && k#1 < 4294967296
                 ==> Uint32__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lte(pivot#0, $Unbox($y#1): int)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(pivot#0, $Unbox($y#2): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, Tclass.NativeTypes.uint32())
                     && Uint32__Order.__default.lt($Unbox($y#4): int, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(pivot#0, $Unbox($y#5): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Uint32__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: int :: 
          { Uint32__Order.__default.lt(k#2, pivot#0) } 
          LitInt(0) <= k#2 && k#2 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(k#2, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
          Uint32_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.uint32())
               && Uint32__Order.__default.lt($Unbox($y#6): int, LitInt(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lt($Unbox($y#9): int, LitInt(pivot#0)))); 
          (forall k#3: int :: 
              { Uint32__Order.__default.lte(pivot#0, k#3) } 
              LitInt(0) <= k#3 && k#3 < 4294967296
                 ==> Uint32__Order.__default.lte#canCall(LitInt(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#7): int)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#8): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, Tclass.NativeTypes.uint32())
                     && Uint32__Order.__default.lt($Unbox($y#10): int, LitInt(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#11): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Uint32_Order._default.SetSuccessor
function Uint32__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Uint32__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Uint32__Order.__default.SetSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Uint32__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Uint32__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#4_next(m: Set Box, key: int) : int;

function $let#4$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#4_next(m, key) } 
  $let#4$canCall(m, key)
     ==> LitInt(0) <= $let#4_next(m, key)
       && $let#4_next(m, key) < 4294967296
       && 
      m[$Box($let#4_next(m, key))]
       && Uint32__Order.__default.lt(key, $let#4_next(m, key))
       && (forall other#1: int :: 
        { Uint32__Order.__default.lt($let#4_next(m, key), other#1) } 
          { Uint32__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        LitInt(0) <= other#1 && other#1 < 4294967296
           ==> 
          m[$Box(other#1)]
             && other#1 != $let#4_next(m, key)
             && Uint32__Order.__default.lt(key, other#1)
           ==> Uint32__Order.__default.lt($let#4_next(m, key), other#1)));

// definition axiom for Uint32__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Uint32__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> (forall next#0: int :: 
          { Uint32__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
          LitInt(0) <= next#0 && next#0 < 4294967296
             ==> (m#0[$Box(next#0)] ==> Uint32__Order.__default.lt#canCall(key#0, next#0))
               && (Uint32__Order.__default.lt#canCall(key#0, next#0)
                   && Uint32__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: int :: 
                  { Uint32__Order.__default.lt(next#0, other#0) } 
                    { Uint32__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 4294967296
                     ==> (other#0 != next#0 ==> Uint32__Order.__default.lt#canCall(key#0, other#0))
                       && (Uint32__Order.__default.lt#canCall(key#0, other#0)
                           && Uint32__Order.__default.lt(key#0, other#0)
                         ==> Uint32__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: int :: 
            { Uint32__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
            LitInt(0) <= next#0
               && next#0 < 4294967296
               && 
              m#0[$Box(next#0)]
               && Uint32__Order.__default.lt(key#0, next#0)
               && (forall other#0: int :: 
                { Uint32__Order.__default.lt(next#0, other#0) } 
                  { Uint32__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                LitInt(0) <= other#0 && other#0 < 4294967296
                   ==> 
                  m#0[$Box(other#0)]
                     && other#0 != next#0
                     && Uint32__Order.__default.lt(key#0, other#0)
                   ==> Uint32__Order.__default.lt(next#0, other#0)))
           ==> $let#4$canCall(m#0, key#0))
         && Uint32__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: int :: 
              { Uint32__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
              LitInt(0) <= next#0
                 && next#0 < 4294967296
                 && 
                m#0[$Box(next#0)]
                 && Uint32__Order.__default.lt(key#0, next#0)
                 && (forall other#0: int :: 
                  { Uint32__Order.__default.lt(next#0, other#0) } 
                    { Uint32__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 4294967296
                     ==> 
                    m#0[$Box(other#0)]
                       && other#0 != next#0
                       && Uint32__Order.__default.lt(key#0, other#0)
                     ==> Uint32__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#4_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Uint32__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> (forall next#2: int :: 
          { Uint32__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
          LitInt(0) <= next#2 && next#2 < 4294967296
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Uint32__Order.__default.lt#canCall(LitInt(key#0), next#2))
               && (Uint32__Order.__default.lt#canCall(LitInt(key#0), next#2)
                   && Uint32__Order.__default.lt(LitInt(key#0), next#2)
                 ==> (forall other#2: int :: 
                  { Uint32__Order.__default.lt(next#2, other#2) } 
                    { Uint32__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 4294967296
                     ==> (other#2 != next#2
                         ==> Uint32__Order.__default.lt#canCall(LitInt(key#0), other#2))
                       && (Uint32__Order.__default.lt#canCall(LitInt(key#0), other#2)
                           && Uint32__Order.__default.lt(LitInt(key#0), other#2)
                         ==> Uint32__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: int :: 
            { Uint32__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
            LitInt(0) <= next#2
               && next#2 < 4294967296
               && 
              Lit(m#0)[$Box(next#2)]
               && Uint32__Order.__default.lt(LitInt(key#0), next#2)
               && (forall other#2: int :: 
                { Uint32__Order.__default.lt(next#2, other#2) } 
                  { Uint32__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                LitInt(0) <= other#2 && other#2 < 4294967296
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && other#2 != next#2
                     && Uint32__Order.__default.lt(LitInt(key#0), other#2)
                   ==> Uint32__Order.__default.lt(next#2, other#2)))
           ==> $let#4$canCall(Lit(m#0), LitInt(key#0)))
         && Uint32__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#2: int :: 
              { Uint32__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
              LitInt(0) <= next#2
                 && next#2 < 4294967296
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Uint32__Order.__default.lt(LitInt(key#0), next#2)
                 && (forall other#2: int :: 
                  { Uint32__Order.__default.lt(next#2, other#2) } 
                    { Uint32__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 4294967296
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && other#2 != next#2
                       && Uint32__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Uint32__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#4_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Uint32_Order._default.MapSuccessor
function Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.MapSuccessor
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Uint32__Order.__default.MapSuccessor
axiom (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Uint32__Order.__default.MapSuccessor#requires(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.MapSuccessor#requires(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
           == Uint32__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Uint32__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Uint32__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Uint32_Order._default.SeqSuccessor
function Uint32__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Uint32__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Uint32__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Uint32__Order.__default.SeqSuccessor(m#0, key#0)
           == Uint32__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Uint32__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Uint32__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#2)), 
          LitInt(key#0))
         && Uint32__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Uint32__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#3)), 
            LitInt(key#0)));

// function declaration for Uint32_Order._default.SortedSeqForMap
function Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Uint32__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> true);

function Uint32__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Uint32__Order.__default.SortedSeqForMap
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap#requires(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V))
     ==> Uint32__Order.__default.SortedSeqForMap#requires(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Uint32__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
            Uint32_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Uint32__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: int :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 4294967296
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                         == key#0
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                    Uint32_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: int :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 4294967296
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                       == key#0
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Uint32__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
            Uint32_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Uint32__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: int :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 4294967296
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                         == key#1
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                    Uint32_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: int :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 4294967296
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                       == key#1
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Uint32_Order._default.minimum
function Uint32__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Uint32__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimum($LS($ly), s#0) } 
  Uint32__Order.__default.minimum($LS($ly), s#0)
     == Uint32__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.minimum($ly, s#0)
     == Uint32__Order.__default.minimum($LZ, s#0));

// consequence axiom for Uint32__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimum($ly, s#0) } 
    Uint32__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint32())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint32__Order.__default.minimum($ly, s#0))]
         && (forall y#0: int :: 
          { Uint32__Order.__default.lte(Uint32__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
             ==> Uint32__Order.__default.lte(Uint32__Order.__default.minimum($ly, s#0), y#0))
         && 
        LitInt(0) <= Uint32__Order.__default.minimum($ly, s#0)
         && Uint32__Order.__default.minimum($ly, s#0) < 4294967296);

function Uint32__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint32__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#7_a(s: Set Box) : int;

function $let#7$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#7_a(s) } 
  $let#7$canCall(s)
     ==> LitInt(0) <= $let#7_a(s) && $let#7_a(s) < 4294967296 && s[$Box($let#7_a(s))]);

// definition axiom for Uint32__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint32__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#7$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#7_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Uint32__Order.__default.minimum($ly, s'#0); 
                Uint32__Order.__default.lt#canCall($let#7_a(s#0), m'#0)))
         && Uint32__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#7_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Uint32__Order.__default.minimum($ly, s'#1); 
                  (if Uint32__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Uint32__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#7$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#7_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Uint32__Order.__default.minimum($LS($ly), s'#2); 
                Uint32__Order.__default.lt#canCall($let#7_a(Lit(s#0)), m'#2)))
         && Uint32__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#7_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Uint32__Order.__default.minimum($LS($ly), s'#3); 
                  (if Uint32__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Uint32_Order._default.minimumOpt
function Uint32__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint32__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt($LS($ly), s#0) } 
  Uint32__Order.__default.minimumOpt($LS($ly), s#0)
     == Uint32__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.minimumOpt($ly, s#0)
     == Uint32__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Uint32__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimumOpt($ly, s#0) } 
    Uint32__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (Options.Option.Some_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Uint32__Order.__default.lte($Unbox(Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
               ==> Uint32__Order.__default.lte($Unbox(Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0)))
         && (Options.Option.None_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint32__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Uint32__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimumOpt($LS($ly), s#0) } 
    Uint32__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.minimum#canCall(s#0))
         && Uint32__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.minimum(StartFuel_Uint32_Order._default.minimum, s#0)))));

// definition axiom for Uint32__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Uint32__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.minimum#canCall(Lit(s#0)))
         && Uint32__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.minimum(StartFuel_Uint32_Order._default.minimum, Lit(s#0))))));

// function declaration for Uint32_Order._default.maximum
function Uint32__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Uint32__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximum($LS($ly), s#0) } 
  Uint32__Order.__default.maximum($LS($ly), s#0)
     == Uint32__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.maximum($ly, s#0)
     == Uint32__Order.__default.maximum($LZ, s#0));

// consequence axiom for Uint32__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximum($ly, s#0) } 
    Uint32__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint32())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint32__Order.__default.maximum($ly, s#0))]
         && (forall y#0: int :: 
          { Uint32__Order.__default.lte(y#0, Uint32__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
             ==> Uint32__Order.__default.lte(y#0, Uint32__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Uint32__Order.__default.maximum($ly, s#0)
         && Uint32__Order.__default.maximum($ly, s#0) < 4294967296);

function Uint32__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint32__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#10_a(s: Set Box) : int;

function $let#10$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#10_a(s) } 
  $let#10$canCall(s)
     ==> LitInt(0) <= $let#10_a(s) && $let#10_a(s) < 4294967296 && s[$Box($let#10_a(s))]);

// definition axiom for Uint32__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint32__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#10$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#10_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Uint32__Order.__default.maximum($ly, s'#0); 
                Uint32__Order.__default.lt#canCall(m'#0, $let#10_a(s#0))))
         && Uint32__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#10_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Uint32__Order.__default.maximum($ly, s'#1); 
                  (if Uint32__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Uint32__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#10$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#10_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Uint32__Order.__default.maximum($LS($ly), s'#2); 
                Uint32__Order.__default.lt#canCall(m'#2, $let#10_a(Lit(s#0)))))
         && Uint32__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#10_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Uint32__Order.__default.maximum($LS($ly), s'#3); 
                  (if Uint32__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Uint32_Order._default.maximumOpt
function Uint32__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint32__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt($LS($ly), s#0) } 
  Uint32__Order.__default.maximumOpt($LS($ly), s#0)
     == Uint32__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.maximumOpt($ly, s#0)
     == Uint32__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Uint32__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximumOpt($ly, s#0) } 
    Uint32__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (Options.Option.Some_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Uint32__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
               ==> Uint32__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint32__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Uint32__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximumOpt($LS($ly), s#0) } 
    Uint32__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.maximum#canCall(s#0))
         && Uint32__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.maximum(StartFuel_Uint32_Order._default.maximum, s#0)))));

// definition axiom for Uint32__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Uint32__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.maximum#canCall(Lit(s#0)))
         && Uint32__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.maximum(StartFuel_Uint32_Order._default.maximum, Lit(s#0))))));

// function declaration for Uint32_Order._default.lt
function Uint32__Order.__default.lt(a#0: int, b#0: int) : bool;

function Uint32__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lt(a#0, b#0) } 
    Uint32__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lt(a#0, b#0) } 
    Uint32__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.lt(a#0, b#0)
           == (Uint32__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Uint32__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Uint32_Order._default.Min
function Uint32__Order.__default.Min(a#0: int, b#0: int) : int;

function Uint32__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Min(a#0, b#0) } 
    Uint32__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> LitInt(0) <= Uint32__Order.__default.Min(a#0, b#0)
         && Uint32__Order.__default.Min(a#0, b#0) < 4294967296);

function Uint32__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Min(a#0, b#0) } 
    Uint32__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.Min(a#0, b#0)
           == (if Uint32__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Uint32__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Uint32_Order._default.Max
function Uint32__Order.__default.Max(a#0: int, b#0: int) : int;

function Uint32__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Max(a#0, b#0) } 
    Uint32__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> LitInt(0) <= Uint32__Order.__default.Max(a#0, b#0)
         && Uint32__Order.__default.Max(a#0, b#0) < 4294967296);

function Uint32__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Max(a#0, b#0) } 
    Uint32__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.Max(a#0, b#0)
           == (if Uint32__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Uint32__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Uint32_Order._default.IsSorted
function Uint32__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint32__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted($LS($ly), run#0) } 
  Uint32__Order.__default.IsSorted($LS($ly), run#0)
     == Uint32__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Uint32__Order.__default.IsSorted($ly, run#0)
     == Uint32__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Uint32__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsSorted($ly, run#0) } 
    Uint32__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint32__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint32__Order.__default.IsSorted($ly, run#0)));

function Uint32__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Uint32__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsSorted($LS($ly), run#0) } 
    Uint32__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Uint32__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Uint32__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Uint32__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Uint32__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Uint32_Order._default.IsStrictlySortedInternal
function Uint32__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Uint32__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> true);

function Uint32__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Uint32__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Uint32__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Uint32__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Uint32_Order._default.IsStrictlySorted
function Uint32__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint32__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Uint32__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Uint32__Order.__default.IsStrictlySorted($ly, run#0)
     == Uint32__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Uint32__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySorted($ly, run#0) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint32__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint32__Order.__default.IsStrictlySorted($ly, run#0))
         && (Uint32__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0)));

function Uint32__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Uint32__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Uint32__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Uint32__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> Uint32__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Uint32__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

procedure CheckWellformed$$Uint32__Order.__default.IsSortedImpliesLte(run#0: Seq Box
       where $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    i#0: int, 
    j#0: int);
  free requires 21 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Uint32__Order.__default.IsSortedImpliesLte(run#0: Seq Box
       where $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    i#0: int, 
    j#0: int);
  // user-defined preconditions
  requires Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, run#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 < Seq#Length(run#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int);
  ensures Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$Uint32__Order.__default.SortedSubsequence(run#0: Seq Box
       where $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    i#0: int, 
    j#0: int);
  free requires 29 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Uint32__Order.__default.SortedSubsequence(run#0: Seq Box
       where $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    i#0: int, 
    j#0: int);
  // user-defined preconditions
  requires Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, run#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 <= Seq#Length(run#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Uint32__Order.__default.IsSorted#canCall(Seq#Drop(Seq#Take(run#0, j#0), i#0));
  ensures Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
    Seq#Drop(Seq#Take(run#0, j#0), i#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$Uint32__Order.__default.SortedAugment(run#0: Seq Box
       where $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 4294967296);
  free requires 65 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Uint32__Order.__default.SortedAugment(run#0: Seq Box
       where $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
         && $IsAlloc(run#0, TSeq(Tclass.NativeTypes.uint32()), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 4294967296);
  // user-defined preconditions
  requires Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, run#0);
  requires Seq#Length(run#0) > 0
     ==> Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, key#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Uint32__Order.__default.IsSorted#canCall(Seq#Append(run#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  ensures Uint32__Order.__default.IsSorted(StartFuelAssert_Uint32_Order._default.IsSorted, 
    Seq#Append(run#0, Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Uint32__Order.__default.reveal__IsSorted();
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Uint32_Order._default.IsSorted8: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Uint32__Order.__default.reveal__IsSorted();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Uint32_Order._default.IsSorted
     == $LS(MoreFuel_Uint32_Order._default.IsSorted8);
  free ensures StartFuelAssert_Uint32_Order._default.IsSorted
     == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted8));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted8)
     == MoreFuel_Uint32_Order._default.IsSorted8;



const unique class.Byte__Order.__default: ClassName;

function Tclass.Byte__Order.__default() : Ty;

// Tclass.Byte__Order.__default Tag
axiom Tag(Tclass.Byte__Order.__default()) == Tagclass.Byte__Order.__default;

const unique Tagclass.Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Byte__Order.__default()) } 
  $Is($o, Tclass.Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Byte_Order._default.SomeElement
function Byte__Order.__default.SomeElement() : int;

function Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Byte__Order.__default.SomeElement()
     && Byte__Order.__default.SomeElement() < 256;

function Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Byte__Order.__default.SomeElement
axiom Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Byte__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Byte__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// function declaration for Byte_Order._default.lte
function Byte__Order.__default.lte($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
  Byte__Order.__default.lte($LS($ly), a#0, b#0)
     == Byte__Order.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.lte($ly, a#0, b#0)
     == Byte__Order.__default.lte($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($ly, a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (forall a#1: int, b#1: int, c#0: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, c#0), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#1, c#0) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#1, c#0), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, b#1) } 
          LitInt(0) <= a#1
               && a#1 < 256
               && 
              LitInt(0) <= b#1
               && b#1 < 256
               && 
              LitInt(0) <= c#0
               && c#0 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, b#1)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#1, c#0)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, c#0))
         && Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
             && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#2: int, b#2: int, c#1: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, c#1), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#2, c#1) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#2, c#1), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, b#2) } 
          LitInt(0) <= a#2
               && a#2 < 256
               && 
              LitInt(0) <= b#2
               && b#2 < 256
               && 
              LitInt(0) <= c#1
               && c#1 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, b#2)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#2, c#1)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, c#1)));

function Byte__Order.__default.lte#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.lte
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lte#requires($ly, a#0, b#0) == true);

const MoreFuel_Byte_Order._default.ltedef0: LayerType;

// definition axiom for Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef0)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef0))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef0)
           == MoreFuel_Byte_Order._default.ltedef0
         && Byte__Order.__default.lte($LS($ly), a#0, b#0) == (a#0 <= b#0));

const MoreFuel_Byte_Order._default.ltedef1: LayerType;

// definition axiom for Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef1)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef1))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef1)
           == MoreFuel_Byte_Order._default.ltedef1
         && Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0))
           == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.ltedef
function Byte__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Byte__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($ly, a#0, b#0)
     == Byte__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($ly, a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.LargestLte
function Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted0: LayerType;

// definition axiom for Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted0)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted0)
           == MoreFuel_Byte_Order._default.IsSorted0
         && Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted1: LayerType;

// definition axiom for Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted1)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted1)
           == MoreFuel_Byte_Order._default.IsSorted1
         && Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.LargestLt
function Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted2: LayerType;

// definition axiom for Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              needle#0, 
              $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted2)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted2)
           == MoreFuel_Byte_Order._default.IsSorted2
         && Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                needle#0, 
                $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted3: LayerType;

// definition axiom for Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(needle#0), 
              $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted3)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted3)
           == MoreFuel_Byte_Order._default.IsSorted3
         && Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt(needle#0), 
                $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.IndexOfFirstGte
function Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted4: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted4)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted4)
           == MoreFuel_Byte_Order._default.IsSorted4
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted5: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted5)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted5)
           == MoreFuel_Byte_Order._default.IsSorted5
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              key#0, 
              $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(key#0), 
              $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.IndexOfFirstGt
function Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted6: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted6)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted6)
           == MoreFuel_Byte_Order._default.IsSorted6
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted7: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted7)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted7)
           == MoreFuel_Byte_Order._default.IsSorted7
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, 
              key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, 
                  key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, 
              LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, 
                  LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.SetAllLte
function Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#0: int, y#0: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#0, y#0) } 
            { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
             ==> 
            b#0[$Box(y#0)]
             ==> Byte__Order.__default.lte#canCall(x#0, y#0))
         && Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#0, y#0) } 
              { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#0, y#0)));

// definition axiom for Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#1: int, y#1: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#1, y#1) } 
            { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Byte__Order.__default.lte#canCall(x#1, y#1))
         && Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#1, y#1) } 
              { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#1, y#1)));

// function declaration for Byte_Order._default.SetAllLt
function Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#0: int, y#0: int :: 
          { Byte__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
             ==> 
            b#0[$Box(y#0)]
             ==> Byte__Order.__default.lt#canCall(x#0, y#0))
         && Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Byte__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Byte__Order.__default.lt(x#0, y#0)));

// definition axiom for Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#1: int, y#1: int :: 
          { Byte__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Byte__Order.__default.lt#canCall(x#1, y#1))
         && Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Byte__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Byte__Order.__default.lt(x#1, y#1)));

// function declaration for Byte_Order._default.NotMinimum
function Byte__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Byte__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Byte__Order.__default.NotMinimum($ly, a#0)
     == Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($ly, a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> true);

function Byte__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 256
     ==> Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#0: int :: 
          { Byte__Order.__default.lt(b#0, a#0) } 
          LitInt(0) <= b#0 && b#0 < 256 ==> Byte__Order.__default.lt#canCall(b#0, a#0))
         && Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: int :: 
            { Byte__Order.__default.lt(b#0, a#0) } 
            LitInt(0) <= b#0 && b#0 < 256 && Byte__Order.__default.lt(b#0, a#0)));

// definition axiom for Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Byte__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#1: int :: 
          { Byte__Order.__default.lt(b#1, a#0) } 
          LitInt(0) <= b#1 && b#1 < 256
             ==> Byte__Order.__default.lt#canCall(b#1, LitInt(a#0)))
         && Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#1: int :: 
            { Byte__Order.__default.lt(b#1, a#0) } 
            LitInt(0) <= b#1 && b#1 < 256 && Byte__Order.__default.lt(b#1, LitInt(a#0))));

// function declaration for Byte_Order._default.MapPivotedUnion
function Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)));

function Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.MapPivotedUnion
axiom (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 256
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
     ==> Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: int :: 
          { Byte__Order.__default.lt(k#0, pivot#0) } 
          LitInt(0) <= k#0 && k#0 < 256 ==> Byte__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#0): int, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#3): int, pivot#0))); 
          (forall k#1: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#1) } 
              LitInt(0) <= k#1 && k#1 < 256
                 ==> Byte__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#1): int)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#2): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#4): int, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#5): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: int :: 
          { Byte__Order.__default.lt(k#2, pivot#0) } 
          LitInt(0) <= k#2 && k#2 < 256
             ==> Byte__Order.__default.lt#canCall(k#2, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#6): int, LitInt(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#9): int, LitInt(pivot#0)))); 
          (forall k#3: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#3) } 
              LitInt(0) <= k#3 && k#3 < 256
                 ==> Byte__Order.__default.lte#canCall(LitInt(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#7): int)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#8): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#10): int, LitInt(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#11): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Byte_Order._default.SetSuccessor
function Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#13_next(m: Set Box, key: int) : int;

function $let#13$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#13_next(m, key) } 
  $let#13$canCall(m, key)
     ==> LitInt(0) <= $let#13_next(m, key)
       && $let#13_next(m, key) < 256
       && 
      m[$Box($let#13_next(m, key))]
       && Byte__Order.__default.lt(key, $let#13_next(m, key))
       && (forall other#1: int :: 
        { Byte__Order.__default.lt($let#13_next(m, key), other#1) } 
          { Byte__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        LitInt(0) <= other#1 && other#1 < 256
           ==> 
          m[$Box(other#1)]
             && other#1 != $let#13_next(m, key)
             && Byte__Order.__default.lt(key, other#1)
           ==> Byte__Order.__default.lt($let#13_next(m, key), other#1)));

// definition axiom for Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#0: int :: 
          { Byte__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
          LitInt(0) <= next#0 && next#0 < 256
             ==> (m#0[$Box(next#0)] ==> Byte__Order.__default.lt#canCall(key#0, next#0))
               && (Byte__Order.__default.lt#canCall(key#0, next#0)
                   && Byte__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: int :: 
                  { Byte__Order.__default.lt(next#0, other#0) } 
                    { Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 256
                     ==> (other#0 != next#0 ==> Byte__Order.__default.lt#canCall(key#0, other#0))
                       && (Byte__Order.__default.lt#canCall(key#0, other#0)
                           && Byte__Order.__default.lt(key#0, other#0)
                         ==> Byte__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: int :: 
            { Byte__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
            LitInt(0) <= next#0
               && next#0 < 256
               && 
              m#0[$Box(next#0)]
               && Byte__Order.__default.lt(key#0, next#0)
               && (forall other#0: int :: 
                { Byte__Order.__default.lt(next#0, other#0) } 
                  { Byte__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                LitInt(0) <= other#0 && other#0 < 256
                   ==> 
                  m#0[$Box(other#0)]
                     && other#0 != next#0
                     && Byte__Order.__default.lt(key#0, other#0)
                   ==> Byte__Order.__default.lt(next#0, other#0)))
           ==> $let#13$canCall(m#0, key#0))
         && Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: int :: 
              { Byte__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
              LitInt(0) <= next#0
                 && next#0 < 256
                 && 
                m#0[$Box(next#0)]
                 && Byte__Order.__default.lt(key#0, next#0)
                 && (forall other#0: int :: 
                  { Byte__Order.__default.lt(next#0, other#0) } 
                    { Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 256
                     ==> 
                    m#0[$Box(other#0)]
                       && other#0 != next#0
                       && Byte__Order.__default.lt(key#0, other#0)
                     ==> Byte__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#13_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#2: int :: 
          { Byte__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
          LitInt(0) <= next#2 && next#2 < 256
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), next#2))
               && (Byte__Order.__default.lt#canCall(LitInt(key#0), next#2)
                   && Byte__Order.__default.lt(LitInt(key#0), next#2)
                 ==> (forall other#2: int :: 
                  { Byte__Order.__default.lt(next#2, other#2) } 
                    { Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 256
                     ==> (other#2 != next#2 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), other#2))
                       && (Byte__Order.__default.lt#canCall(LitInt(key#0), other#2)
                           && Byte__Order.__default.lt(LitInt(key#0), other#2)
                         ==> Byte__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: int :: 
            { Byte__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
            LitInt(0) <= next#2
               && next#2 < 256
               && 
              Lit(m#0)[$Box(next#2)]
               && Byte__Order.__default.lt(LitInt(key#0), next#2)
               && (forall other#2: int :: 
                { Byte__Order.__default.lt(next#2, other#2) } 
                  { Byte__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                LitInt(0) <= other#2 && other#2 < 256
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && other#2 != next#2
                     && Byte__Order.__default.lt(LitInt(key#0), other#2)
                   ==> Byte__Order.__default.lt(next#2, other#2)))
           ==> $let#13$canCall(Lit(m#0), LitInt(key#0)))
         && Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#2: int :: 
              { Byte__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
              LitInt(0) <= next#2
                 && next#2 < 256
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Byte__Order.__default.lt(LitInt(key#0), next#2)
                 && (forall other#2: int :: 
                  { Byte__Order.__default.lt(next#2, other#2) } 
                    { Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 256
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && other#2 != next#2
                       && Byte__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Byte__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#13_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Byte_Order._default.MapSuccessor
function Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> $Is(Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Byte__Order.__default.MapSuccessor
axiom (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Byte_Order._default.SeqSuccessor
function Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Byte__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#2)), 
          LitInt(key#0))
         && Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Byte__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#3)), 
            LitInt(key#0)));

// function declaration for Byte_Order._default.SortedSeqForMap
function Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.SortedSeqForMap
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V))
     ==> Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: int :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                         == key#0
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: int :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                       == key#0
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: int :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                         == key#1
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: int :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                       == key#1
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Byte_Order._default.minimum
function Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum($LS($ly), s#0) } 
  Byte__Order.__default.minimum($LS($ly), s#0)
     == Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimum($ly, s#0)
     == Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimum($ly, s#0) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#0: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#0))
         && 
        LitInt(0) <= Byte__Order.__default.minimum($ly, s#0)
         && Byte__Order.__default.minimum($ly, s#0) < 256);

function Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#16_a(s: Set Box) : int;

function $let#16$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#16_a(s) } 
  $let#16$canCall(s)
     ==> LitInt(0) <= $let#16_a(s) && $let#16_a(s) < 256 && s[$Box($let#16_a(s))]);

// definition axiom for Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#16$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#16_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Byte__Order.__default.minimum($ly, s'#0); 
                Byte__Order.__default.lt#canCall($let#16_a(s#0), m'#0)))
         && Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#16_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Byte__Order.__default.minimum($ly, s'#1); 
                  (if Byte__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#16$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#16_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Byte__Order.__default.minimum($LS($ly), s'#2); 
                Byte__Order.__default.lt#canCall($let#16_a(Lit(s#0)), m'#2)))
         && Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#16_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Byte__Order.__default.minimum($LS($ly), s'#3); 
                  (if Byte__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Byte_Order._default.minimumOpt
function Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimumOpt($ly, s#0)
     == Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($ly, s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0)))
         && (Options.Option.None_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(s#0))
         && Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, s#0)))));

// definition axiom for Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Byte_Order._default.maximum
function Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum($LS($ly), s#0) } 
  Byte__Order.__default.maximum($LS($ly), s#0)
     == Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximum($ly, s#0)
     == Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximum($ly, s#0) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#0: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#0, Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#0, Byte__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Byte__Order.__default.maximum($ly, s#0)
         && Byte__Order.__default.maximum($ly, s#0) < 256);

function Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#19_a(s: Set Box) : int;

function $let#19$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#19_a(s) } 
  $let#19$canCall(s)
     ==> LitInt(0) <= $let#19_a(s) && $let#19_a(s) < 256 && s[$Box($let#19_a(s))]);

// definition axiom for Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#19$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#19_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Byte__Order.__default.maximum($ly, s'#0); 
                Byte__Order.__default.lt#canCall(m'#0, $let#19_a(s#0))))
         && Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#19_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Byte__Order.__default.maximum($ly, s'#1); 
                  (if Byte__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#19$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#19_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Byte__Order.__default.maximum($LS($ly), s'#2); 
                Byte__Order.__default.lt#canCall(m'#2, $let#19_a(Lit(s#0)))))
         && Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#19_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Byte__Order.__default.maximum($LS($ly), s'#3); 
                  (if Byte__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Byte_Order._default.maximumOpt
function Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximumOpt($ly, s#0)
     == Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($ly, s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#0, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#0, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(s#0))
         && Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, s#0)))));

// definition axiom for Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Byte_Order._default.lt
function Byte__Order.__default.lt(a#0: int, b#0: int) : bool;

function Byte__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.lt(a#0, b#0)
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             && a#0 != b#0));

// definition axiom for Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             && a#0 != b#0));

// function declaration for Byte_Order._default.Min
function Byte__Order.__default.Min(a#0: int, b#0: int) : int;

function Byte__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Min(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0) < 256);

function Byte__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then a#0
             else b#0));

// definition axiom for Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then a#0
             else b#0));

// function declaration for Byte_Order._default.Max
function Byte__Order.__default.Max(a#0: int, b#0: int) : int;

function Byte__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Max(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0) < 256);

function Byte__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then b#0
             else a#0));

// definition axiom for Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then b#0
             else a#0));

// function declaration for Byte_Order._default.IsSorted
function Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsSorted($ly, run#0)
     == Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($ly, run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0) ==> Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1) ==> Byte__Order.__default.IsSorted($ly, run#0)));

function Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(run#0, i#0)): int, 
                $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(Lit(run#0), i#1)): int, 
                $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Byte_Order._default.IsStrictlySortedInternal
function Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Byte_Order._default.IsStrictlySorted
function Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0)));

function Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

const unique class.Lexicographic__Byte__Order.__default: ClassName;

function Tclass.Lexicographic__Byte__Order.__default() : Ty;

// Tclass.Lexicographic__Byte__Order.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order.__default())
   == Tagclass.Lexicographic__Byte__Order.__default;

const unique Tagclass.Lexicographic__Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Lexicographic_Byte_Order._default.SomeElement
function Lexicographic__Byte__Order.__default.SomeElement() : Seq Box;

function Lexicographic__Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> $Is(Lexicographic__Byte__Order.__default.SomeElement(), 
    TSeq(Tclass.NativeTypes.byte()));

function Lexicographic__Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom Lexicographic__Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement for all literals(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// function declaration for Lexicographic_Byte_Order._default.lte
function Lexicographic__Byte__Order.__default.lte(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lte
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (forall a#1: Seq Box, b#1: Seq Box, c#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#1, c#0), Lexicographic__Byte__Order.__default.ltedef(b#1, c#0) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#1, c#0), Lexicographic__Byte__Order.__default.ltedef(a#1, b#1) } 
          $Is(a#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#1, b#1)
               && Lexicographic__Byte__Order.__default.ltedef(b#1, c#0)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#1, c#0))
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
             && Lexicographic__Byte__Order.__default.ltedef(b#0, a#0)
           ==> Seq#Equal(a#0, b#0))
         && (forall a#2: Seq Box, b#2: Seq Box, c#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#2, c#1), Lexicographic__Byte__Order.__default.ltedef(b#2, c#1) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#2, c#1), Lexicographic__Byte__Order.__default.ltedef(a#2, b#2) } 
          $Is(a#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#2, b#2)
               && Lexicographic__Byte__Order.__default.ltedef(b#2, c#1)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#2, c#1)));

function Lexicographic__Byte__Order.__default.lte#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lte
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.ltedef
function Lexicographic__Byte__Order.__default.ltedef(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.ltedef#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.ltedef
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.ltedef#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.ltedef
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.LargestLte
function Lexicographic__Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0)
               <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0))): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted0: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted0)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted0)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted0
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted1: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted1)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted1)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted1
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

procedure {:_induction run#0, needle#0} CheckWellformed$$Lexicographic__Byte__Order.__default.LargestLteIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    pos#0: int);
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction run#0, needle#0} Call$$Lexicographic__Byte__Order.__default.LargestLteIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    pos#0: int);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, run#0);
  requires LitInt(0 - 1) <= pos#0;
  requires pos#0 < Seq#Length(run#0);
  requires (forall i#0: int :: 
    { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 <= pos#0
       ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
    true
       ==> 
      pos#0 < i#1 && i#1 < Seq#Length(run#0)
       ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0);
  ensures pos#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), run#0, needle#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Lexicographic_Byte_Order._default.LargestLt
function Lexicographic__Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1
               < Seq#Length(run#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted2: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted2)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted2)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted2
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted3: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted3)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted3)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted3
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGte
function Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
                 <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted4: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted4)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted4)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted4
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted5: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted5)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted5)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted5
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

procedure {:_induction run#0, needle#0} CheckWellformed$$Lexicographic__Byte__Order.__default.IndexOfFirstGteIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    idx#0: int where LitInt(0) <= idx#0);
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction run#0, needle#0} Call$$Lexicographic__Byte__Order.__default.IndexOfFirstGteIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    idx#0: int where LitInt(0) <= idx#0);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, run#0);
  requires idx#0 <= Seq#Length(run#0);
  requires (forall i#0: int :: 
    { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
    LitInt(0) <= i#0 && i#0 < idx#0
       ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
    idx#0 <= i#1 && i#1 < Seq#Length(run#0)
       ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LS($LZ)), run#0, needle#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lte(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGt
function Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted6: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted6)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted6)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted6
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted7: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted7)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted7)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted7
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

procedure {:_induction run#0, needle#0} CheckWellformed$$Lexicographic__Byte__Order.__default.IndexOfFirstGtIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    idx#0: int where LitInt(0) <= idx#0);
  free requires 41 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction run#0, needle#0} Call$$Lexicographic__Byte__Order.__default.IndexOfFirstGtIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    idx#0: int where LitInt(0) <= idx#0);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, run#0);
  requires idx#0 <= Seq#Length(run#0);
  requires (forall i#0: int :: 
    { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
    LitInt(0) <= i#0 && i#0 < idx#0
       ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
    idx#0 <= i#1 && i#1 < Seq#Length(run#0)
       ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0);
  ensures idx#0
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($LS($LZ)), run#0, needle#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.SetAllLte
function Lexicographic__Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#0: Seq Box, y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#0, y#0) } 
            { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#0, y#0))
         && Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: Seq Box, y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#0, y#0) } 
              { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lte(x#0, y#0)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#1: Seq Box, y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#1, y#1) } 
            { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#1, y#1))
         && Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: Seq Box, y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#1, y#1) } 
              { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lte(x#1, y#1)));

// function declaration for Lexicographic_Byte_Order._default.SetAllLt
function Lexicographic__Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#0: Seq Box, y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#0, y#0) } 
            { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#0, y#0))
         && Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: Seq Box, y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#0, y#0) } 
              { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lt(x#0, y#0)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#1: Seq Box, y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#1, y#1) } 
            { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#1, y#1))
         && Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: Seq Box, y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#1, y#1) } 
              { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lt(x#1, y#1)));

// function declaration for Lexicographic_Byte_Order._default.NotMinimum
function Lexicographic__Byte__Order.__default.NotMinimum($ly: LayerType, a#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Lexicographic__Byte__Order.__default.NotMinimum#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#0, a#0) } 
          $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#0, a#0) } 
            $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#0, a#0)));

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0)) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(Lit(a#0))
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#1, a#0) } 
          $Is(b#1, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#1, Lit(a#0)))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0))
           == (exists b#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#1, a#0) } 
            $Is(b#1, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#1, Lit(a#0))));

// function declaration for Lexicographic_Byte_Order._default.MapPivotedUnion
function Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : Map Box Box;

function Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0), 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value)));

function Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
      left#0, 
      pivot#0, 
      right#0) } 
  $Is(left#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(right#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
     ==> Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#0, pivot#0) } 
          $Is(k#0, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#0): Seq Box, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#3): Seq Box, pivot#0))); 
          (forall k#1: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#1) } 
              $Is(k#1, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#1): Seq Box)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#2): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            left#0, 
            pivot#0, 
            right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#4): Seq Box, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#5): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        Lit(pivot#0), 
        Lit(right#0)) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          Lit(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#2, pivot#0) } 
          $Is(k#2, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#2, Lit(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#6): Seq Box, Lit(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#9): Seq Box, Lit(pivot#0)))); 
          (forall k#3: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#3) } 
              $Is(k#3, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#7): Seq Box)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#8): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            Lit(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#10): Seq Box, Lit(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#11): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Lexicographic_Byte_Order._default.SetSuccessor
function Lexicographic__Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SetSuccessor#requires(Set Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#22_next(m: Set Box, key: Seq Box) : Seq Box;

function $let#22$canCall(m: Set Box, key: Seq Box) : bool;

axiom (forall m: Set Box, key: Seq Box :: 
  { $let#22_next(m, key) } 
  $let#22$canCall(m, key)
     ==> $Is($let#22_next(m, key), TSeq(Tclass.NativeTypes.byte()))
       && 
      m[$Box($let#22_next(m, key))]
       && Lexicographic__Byte__Order.__default.lt(key, $let#22_next(m, key))
       && (forall other#1: Seq Box :: 
        { Lexicographic__Byte__Order.__default.lt($let#22_next(m, key), other#1) } 
          { Lexicographic__Byte__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        $Is(other#1, TSeq(Tclass.NativeTypes.byte()))
           ==> 
          m[$Box(other#1)]
             && !Seq#Equal(other#1, $let#22_next(m, key))
             && Lexicographic__Byte__Order.__default.lt(key, other#1)
           ==> Lexicographic__Byte__Order.__default.lt($let#22_next(m, key), other#1)));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#0) } 
            { m#0[$Box(next#0)] } 
          $Is(next#0, TSeq(Tclass.NativeTypes.byte()))
             ==> (m#0[$Box(next#0)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#0))
               && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#0)
                   && Lexicographic__Byte__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#0, other#0) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  $Is(other#0, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#0, next#0)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#0))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#0)
                           && Lexicographic__Byte__Order.__default.lt(key#0, other#0)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#0) } 
              { m#0[$Box(next#0)] } 
            $Is(next#0, TSeq(Tclass.NativeTypes.byte()))
               && 
              m#0[$Box(next#0)]
               && Lexicographic__Byte__Order.__default.lt(key#0, next#0)
               && (forall other#0: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#0, other#0) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                $Is(other#0, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  m#0[$Box(other#0)]
                     && !Seq#Equal(other#0, next#0)
                     && Lexicographic__Byte__Order.__default.lt(key#0, other#0)
                   ==> Lexicographic__Byte__Order.__default.lt(next#0, other#0)))
           ==> $let#22$canCall(m#0, key#0))
         && Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#0) } 
                { m#0[$Box(next#0)] } 
              $Is(next#0, TSeq(Tclass.NativeTypes.byte()))
                 && 
                m#0[$Box(next#0)]
                 && Lexicographic__Byte__Order.__default.lt(key#0, next#0)
                 && (forall other#0: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#0, other#0) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  $Is(other#0, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    m#0[$Box(other#0)]
                       && !Seq#Equal(other#0, next#0)
                       && Lexicographic__Byte__Order.__default.lt(key#0, other#0)
                     ==> Lexicographic__Byte__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#22_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), Lit(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#2) } 
            { m#0[$Box(next#2)] } 
          $Is(next#2, TSeq(Tclass.NativeTypes.byte()))
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#2))
               && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#2)
                   && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#2)
                 ==> (forall other#2: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#2, other#2) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  $Is(other#2, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#2, next#2)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#2))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#2)
                           && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#2)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#2) } 
              { m#0[$Box(next#2)] } 
            $Is(next#2, TSeq(Tclass.NativeTypes.byte()))
               && 
              Lit(m#0)[$Box(next#2)]
               && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#2)
               && (forall other#2: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#2, other#2) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                $Is(other#2, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && !Seq#Equal(other#2, next#2)
                     && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#2)
                   ==> Lexicographic__Byte__Order.__default.lt(next#2, other#2)))
           ==> $let#22$canCall(Lit(m#0), Lit(key#0)))
         && Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0))
           == (if (exists next#2: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#2) } 
                { m#0[$Box(next#2)] } 
              $Is(next#2, TSeq(Tclass.NativeTypes.byte()))
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#2)
                 && (forall other#2: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#2, other#2) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  $Is(other#2, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && !Seq#Equal(other#2, next#2)
                       && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#2)
                     ==> Lexicographic__Byte__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#22_next(Lit(m#0), Lit(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Lexicographic_Byte_Order._default.MapSuccessor
function Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : DatatypeType;

function Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapSuccessor$V))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), Lit(key#0))
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
           == Lit(Lexicographic__Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), Lit(key#0))));

// function declaration for Lexicographic_Byte_Order._default.SeqSuccessor
function Lexicographic__Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SeqSuccessor#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), Lit(key#0))
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#2)), 
          Lit(key#0))
         && Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#3)), 
            Lit(key#0)));

// function declaration for Lexicographic_Byte_Order._default.SortedSeqForMap
function Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V))
     ==> Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): Seq Box, 
                        key#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): Seq Box, 
                      key#0)
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
        $LS($ly), 
        Lit(s#0), 
        Lit(m#0)) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): Seq Box, 
                        key#1)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            $LS($ly), 
            Lit(s#0), 
            Lit(m#0))
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): Seq Box, 
                      key#1)
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Lexicographic_Byte_Order._default.minimum
function Lexicographic__Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#0))
         && $Is(Lexicographic__Byte__Order.__default.minimum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#25_a(s: Set Box) : Seq Box;

function $let#25$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#25_a(s) } 
  $let#25$canCall(s)
     ==> $Is($let#25_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#25_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#25$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#25_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Lexicographic__Byte__Order.__default.minimum($ly, s'#0); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#25_a(s#0), m'#0)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#25_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Lexicographic__Byte__Order.__default.minimum($ly, s'#1); 
                  (if Lexicographic__Byte__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Lexicographic__Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#25$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#25_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#2); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#25_a(Lit(s#0)), m'#2)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#25_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#3); 
                  (if Lexicographic__Byte__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Lexicographic_Byte_Order._default.minimumOpt
function Lexicographic__Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#0)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.maximum
function Lexicographic__Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(y#0, Lexicographic__Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lte(y#0, Lexicographic__Byte__Order.__default.maximum($ly, s#0)))
         && $Is(Lexicographic__Byte__Order.__default.maximum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#28_a(s: Set Box) : Seq Box;

function $let#28$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#28_a(s) } 
  $let#28$canCall(s)
     ==> $Is($let#28_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#28_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#28$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#28_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Lexicographic__Byte__Order.__default.maximum($ly, s'#0); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#0, $let#28_a(s#0))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#28_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Lexicographic__Byte__Order.__default.maximum($ly, s'#1); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Lexicographic__Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#28$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#28_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#2); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#2, $let#28_a(Lit(s#0)))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#28_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#3); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Lexicographic_Byte_Order._default.maximumOpt
function Lexicographic__Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box) } 
              { s#0[$Box(y#0)] } 
            $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.lt
function Lexicographic__Byte__Order.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lt(a#0, b#0)
           == (Lexicographic__Byte__Order.__default.lte(a#0, b#0) && !Seq#Equal(a#0, b#0)));

// definition axiom for Lexicographic__Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0))
           == (Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

// function declaration for Lexicographic_Byte_Order._default.Min
function Lexicographic__Byte__Order.__default.Min(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Min#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Min
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Min(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Min#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Min
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Min(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Lexicographic__Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Min#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then a#0
             else b#0));

// function declaration for Lexicographic_Byte_Order._default.Max
function Lexicographic__Byte__Order.__default.Max(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Max#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Max
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Max(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Max#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Max
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Max(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Lexicographic__Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Max#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then b#0
             else a#0));

// function declaration for Lexicographic_Byte_Order._default.IsSorted
function Lexicographic__Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)));

function Lexicographic__Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          j#0 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySortedInternal
function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          j#0 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySorted
function Lexicographic__Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0)));

function Lexicographic__Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

procedure CheckWellformed$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  free requires 27 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order.__default.IsSortedImpliesLte(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, run#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 < Seq#Length(run#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box);
  ensures Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Lexicographic__Byte__Order.__default.reveal__binarySearchIndexOfFirstKeyGte();
  free requires 71 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Lexicographic__Byte__Order.__default.reveal__binarySearchIndexOfFirstKeyGte();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte
     == $LS(MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte0);
  free ensures StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte
     == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte0)
     == MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Lexicographic__Byte__Order.__default.reveal__binarySearchIndexOfFirstKeyGt();
  free requires 72 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Lexicographic__Byte__Order.__default.reveal__binarySearchIndexOfFirstKeyGt();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt
     == $LS(MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt0);
  free ensures StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt
     == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt0)
     == MoreFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt0;



const unique class.Lexicographic__Byte__Order__Impl.__default: ClassName;

function Tclass.Lexicographic__Byte__Order__Impl.__default() : Ty;

// Tclass.Lexicographic__Byte__Order__Impl.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order__Impl.__default())
   == Tagclass.Lexicographic__Byte__Order__Impl.__default;

const unique Tagclass.Lexicographic__Byte__Order__Impl.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order__Impl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order__Impl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order__Impl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure CheckWellformed$$Lexicographic__Byte__Order__Impl.__default.cmp(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    b#0: Seq Box
       where $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(b#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (c#0: int where LitInt(0 - 2147483648) <= c#0 && c#0 < 2147483648);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    b#0: Seq Box
       where $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(b#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (c#0: int where LitInt(0 - 2147483648) <= c#0 && c#0 < 2147483648);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures c#0 < 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0);
  free ensures c#0 < 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lt(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lte(a#0, b#0)
       && !Seq#Equal(a#0, b#0);
  free ensures c#0 > 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0);
  free ensures c#0 > 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lt(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lte(b#0, a#0)
       && !Seq#Equal(b#0, a#0);
  free ensures true;
  ensures c#0 == LitInt(0) ==> Seq#Equal(a#0, b#0);
  free ensures c#0 < 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0);
  free ensures c#0 < 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lt(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lte(a#0, b#0)
       && !Seq#Equal(a#0, b#0);
  free ensures c#0 > 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0);
  free ensures c#0 > 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lt(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lte(b#0, a#0)
       && !Seq#Equal(b#0, a#0);
  free ensures true;
  ensures c#0 == LitInt(0) ==> Seq#Equal(a#0, b#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



const unique field$nstrings: NameFamily;

const unique field$offsets: NameFamily;

const unique field$data: NameFamily;

const unique field$Repr: NameFamily;
