// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/lib-DataStructures-KMBtree.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/KMBtree.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

// Constructor function declaration
function #_System._tuple#4._#Make4(Box, Box, Box, Box) : DatatypeType;

const unique ##_System._tuple#4._#Make4: DtCtorId;

// Constructor identifier
axiom (forall a#9#0#0: Box, a#9#1#0: Box, a#9#2#0: Box, a#9#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0) } 
  DatatypeCtorId(#_System._tuple#4._#Make4(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0))
     == ##_System._tuple#4._#Make4);

function _System.Tuple4.___hMake4_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple4.___hMake4_q(d) } 
  _System.Tuple4.___hMake4_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#4._#Make4);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple4.___hMake4_q(d) } 
  _System.Tuple4.___hMake4_q(d)
     ==> (exists a#10#0#0: Box, a#10#1#0: Box, a#10#2#0: Box, a#10#3#0: Box :: 
      d == #_System._tuple#4._#Make4(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0)));

function Tclass._System.Tuple4(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.Tuple4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty :: 
  { Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3) } 
  Tag(Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) == Tagclass._System.Tuple4);

const unique Tagclass._System.Tuple4: TyTag;

// Tclass._System.Tuple4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty :: 
  { Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3) } 
  Tclass._System.Tuple4_0(Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) == #$T0);

function Tclass._System.Tuple4_0(Ty) : Ty;

// Tclass._System.Tuple4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty :: 
  { Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3) } 
  Tclass._System.Tuple4_1(Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) == #$T1);

function Tclass._System.Tuple4_1(Ty) : Ty;

// Tclass._System.Tuple4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty :: 
  { Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3) } 
  Tclass._System.Tuple4_2(Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) == #$T2);

function Tclass._System.Tuple4_2(Ty) : Ty;

// Tclass._System.Tuple4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty :: 
  { Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3) } 
  Tclass._System.Tuple4_3(Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) == #$T3);

function Tclass._System.Tuple4_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) } 
  $IsBox(bx, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)));

// Constructor $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    a#11#0#0: Box, 
    a#11#1#0: Box, 
    a#11#2#0: Box, 
    a#11#3#0: Box :: 
  { $Is(#_System._tuple#4._#Make4(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0), 
      Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) } 
  $Is(#_System._tuple#4._#Make4(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0), 
      Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3))
     <==> $IsBox(a#11#0#0, #$T0)
       && $IsBox(a#11#1#0, #$T1)
       && $IsBox(a#11#2#0, #$T2)
       && $IsBox(a#11#3#0, #$T3));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    a#12#0#0: Box, 
    a#12#1#0: Box, 
    a#12#2#0: Box, 
    a#12#3#0: Box, 
    $h: Heap :: 
  { $IsAlloc(#_System._tuple#4._#Make4(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0), 
      Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#4._#Make4(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0), 
        Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), 
        $h)
       <==> $IsAllocBox(a#12#0#0, #$T0, $h)
         && $IsAllocBox(a#12#1#0, #$T1, $h)
         && $IsAllocBox(a#12#2#0, #$T2, $h)
         && $IsAllocBox(a#12#3#0, #$T3, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple4._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple4.___hMake4_q(d)
       && (exists #$T1: Ty, #$T2: Ty, #$T3: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h) } 
        $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h))
     ==> $IsAllocBox(_System.Tuple4._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple4._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple4.___hMake4_q(d)
       && (exists #$T0: Ty, #$T2: Ty, #$T3: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h) } 
        $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h))
     ==> $IsAllocBox(_System.Tuple4._1(d), #$T1, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T2: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple4._2(d), #$T2, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple4.___hMake4_q(d)
       && (exists #$T0: Ty, #$T1: Ty, #$T3: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h) } 
        $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h))
     ==> $IsAllocBox(_System.Tuple4._2(d), #$T2, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T3: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple4._3(d), #$T3, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple4.___hMake4_q(d)
       && (exists #$T0: Ty, #$T1: Ty, #$T2: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h) } 
        $IsAlloc(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3), $h))
     ==> $IsAllocBox(_System.Tuple4._3(d), #$T3, $h));

// Constructor literal
axiom (forall a#13#0#0: Box, a#13#1#0: Box, a#13#2#0: Box, a#13#3#0: Box :: 
  { #_System._tuple#4._#Make4(Lit(a#13#0#0), Lit(a#13#1#0), Lit(a#13#2#0), Lit(a#13#3#0)) } 
  #_System._tuple#4._#Make4(Lit(a#13#0#0), Lit(a#13#1#0), Lit(a#13#2#0), Lit(a#13#3#0))
     == Lit(#_System._tuple#4._#Make4(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0)));

function _System.Tuple4._0(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#14#0#0: Box, a#14#1#0: Box, a#14#2#0: Box, a#14#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0) } 
  _System.Tuple4._0(#_System._tuple#4._#Make4(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0))
     == a#14#0#0);

// Inductive rank
axiom (forall a#15#0#0: Box, a#15#1#0: Box, a#15#2#0: Box, a#15#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0) } 
  BoxRank(a#15#0#0)
     < DtRank(#_System._tuple#4._#Make4(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0)));

function _System.Tuple4._1(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#16#0#0: Box, a#16#1#0: Box, a#16#2#0: Box, a#16#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0) } 
  _System.Tuple4._1(#_System._tuple#4._#Make4(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0))
     == a#16#1#0);

// Inductive rank
axiom (forall a#17#0#0: Box, a#17#1#0: Box, a#17#2#0: Box, a#17#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0) } 
  BoxRank(a#17#1#0)
     < DtRank(#_System._tuple#4._#Make4(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0)));

function _System.Tuple4._2(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#18#0#0: Box, a#18#1#0: Box, a#18#2#0: Box, a#18#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0) } 
  _System.Tuple4._2(#_System._tuple#4._#Make4(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0))
     == a#18#2#0);

// Inductive rank
axiom (forall a#19#0#0: Box, a#19#1#0: Box, a#19#2#0: Box, a#19#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0) } 
  BoxRank(a#19#2#0)
     < DtRank(#_System._tuple#4._#Make4(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0)));

function _System.Tuple4._3(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#20#0#0: Box, a#20#1#0: Box, a#20#2#0: Box, a#20#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0) } 
  _System.Tuple4._3(#_System._tuple#4._#Make4(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0))
     == a#20#3#0);

// Inductive rank
axiom (forall a#21#0#0: Box, a#21#1#0: Box, a#21#2#0: Box, a#21#3#0: Box :: 
  { #_System._tuple#4._#Make4(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0) } 
  BoxRank(a#21#3#0)
     < DtRank(#_System._tuple#4._#Make4(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0)));

// Depth-one case-split function
function $IsA#_System.Tuple4(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple4(d) } 
  $IsA#_System.Tuple4(d) ==> _System.Tuple4.___hMake4_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, d: DatatypeType :: 
  { _System.Tuple4.___hMake4_q(d), $Is(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3)) } 
  $Is(d, Tclass._System.Tuple4(#$T0, #$T1, #$T2, #$T3))
     ==> _System.Tuple4.___hMake4_q(d));

// Datatype extensional equality declaration
function _System.Tuple4#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#4._#Make4
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple4#Equal(a, b) } 
  true
     ==> (_System.Tuple4#Equal(a, b)
       <==> _System.Tuple4._0(a) == _System.Tuple4._0(b)
         && _System.Tuple4._1(a) == _System.Tuple4._1(b)
         && _System.Tuple4._2(a) == _System.Tuple4._2(b)
         && _System.Tuple4._3(a) == _System.Tuple4._3(b)));

// Datatype extensionality axiom: _System._tuple#4
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple4#Equal(a, b) } 
  _System.Tuple4#Equal(a, b) <==> a == b);

const unique class._System.Tuple4: ClassName;

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const BaseFuel_Maps._default.MapRemove: LayerType;

const StartFuel_Maps._default.MapRemove: LayerType;

const StartFuelAssert_Maps._default.MapRemove: LayerType;

const BaseFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuelAssert_Maps._default.MapRemoveStrong: LayerType;

const BaseFuel_Maps._default.MapRemove1: LayerType;

const StartFuel_Maps._default.MapRemove1: LayerType;

const StartFuelAssert_Maps._default.MapRemove1: LayerType;

const BaseFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuelAssert_Maps._default.MapRemove1Strong: LayerType;

const BaseFuel_Maps._default.IMapRemove: LayerType;

const StartFuel_Maps._default.IMapRemove: LayerType;

const StartFuelAssert_Maps._default.IMapRemove: LayerType;

const BaseFuel_Maps._default.IMapRemove1: LayerType;

const StartFuel_Maps._default.IMapRemove1: LayerType;

const StartFuelAssert_Maps._default.IMapRemove1: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion: LayerType;

const BaseFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferA: LayerType;

const BaseFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferB: LayerType;

const BaseFuel_Maps._default.MapUnion: LayerType;

const StartFuel_Maps._default.MapUnion: LayerType;

const StartFuelAssert_Maps._default.MapUnion: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferA: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferB: LayerType;

const BaseFuel_Maps._default.IMapUnion: LayerType;

const StartFuel_Maps._default.IMapUnion: LayerType;

const StartFuelAssert_Maps._default.IMapUnion: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion3: LayerType;

const BaseFuel_SeqComparison._default.lte: LayerType;

const StartFuel_SeqComparison._default.lte: LayerType;

const StartFuelAssert_SeqComparison._default.lte: LayerType;

const BaseFuel_Byte_Order._default.lte: LayerType;

const StartFuel_Byte_Order._default.lte: LayerType;

const StartFuelAssert_Byte_Order._default.lte: LayerType;

const BaseFuel_Byte_Order._default.ltedef: LayerType;

const StartFuel_Byte_Order._default.ltedef: LayerType;

const StartFuelAssert_Byte_Order._default.ltedef: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Byte_Order._default.minimum: LayerType;

const StartFuel_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Byte_Order._default.minimum: LayerType;

const BaseFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Byte_Order._default.maximum: LayerType;

const StartFuel_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Byte_Order._default.maximum: LayerType;

const BaseFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Integer_Order._default.ltedef: LayerType;

const StartFuel_Integer_Order._default.ltedef: LayerType;

const StartFuelAssert_Integer_Order._default.ltedef: LayerType;

const BaseFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Integer_Order._default.NotMinimum: LayerType;

const StartFuel_Integer_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Integer_Order._default.NotMinimum: LayerType;

const BaseFuel_Integer_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Integer_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Integer_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Integer_Order._default.minimum: LayerType;

const StartFuel_Integer_Order._default.minimum: LayerType;

const StartFuelAssert_Integer_Order._default.minimum: LayerType;

const BaseFuel_Integer_Order._default.minimumOpt: LayerType;

const StartFuel_Integer_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Integer_Order._default.minimumOpt: LayerType;

const BaseFuel_Integer_Order._default.maximum: LayerType;

const StartFuel_Integer_Order._default.maximum: LayerType;

const StartFuelAssert_Integer_Order._default.maximum: LayerType;

const BaseFuel_Integer_Order._default.maximumOpt: LayerType;

const StartFuel_Integer_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Integer_Order._default.maximumOpt: LayerType;

const BaseFuel_Integer_Order._default.IsSorted: LayerType;

const StartFuel_Integer_Order._default.IsSorted: LayerType;

const StartFuelAssert_Integer_Order._default.IsSorted: LayerType;

const BaseFuel_Integer_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Integer_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Integer_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_KMBtreeModel._default.AllKeys: LayerType;

const StartFuel_KMBtreeModel._default.AllKeys: LayerType;

const StartFuelAssert_KMBtreeModel._default.AllKeys: LayerType;

const BaseFuel_KMBtreeModel._default.Interpretation: LayerType;

const StartFuel_KMBtreeModel._default.Interpretation: LayerType;

const StartFuelAssert_KMBtreeModel._default.Interpretation: LayerType;

const BaseFuel_KMBtreeModel._default.ToSeq: LayerType;

const StartFuel_KMBtreeModel._default.ToSeq: LayerType;

const StartFuelAssert_KMBtreeModel._default.ToSeq: LayerType;

const BaseFuel_KMBtree._default.SeqRepr: LayerType;

const StartFuel_KMBtree._default.SeqRepr: LayerType;

const StartFuelAssert_KMBtree._default.SeqRepr: LayerType;

const BaseFuel_KMBtree._default.I: LayerType;

const StartFuel_KMBtree._default.I: LayerType;

const StartFuelAssert_KMBtree._default.I: LayerType;

const unique class.KMBtree.__default: ClassName;

function Tclass.KMBtree.__default() : Ty;

// Tclass.KMBtree.__default Tag
axiom Tag(Tclass.KMBtree.__default()) == Tagclass.KMBtree.__default;

const unique Tagclass.KMBtree.__default: TyTag;

// Box/unbox axiom for Tclass.KMBtree.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KMBtree.__default()) } 
  $IsBox(bx, Tclass.KMBtree.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KMBtree.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KMBtree.__default()) } 
  $Is($o, Tclass.KMBtree.__default())
     <==> $o == null || dtype($o) == Tclass.KMBtree.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KMBtree.__default(), $h) } 
  $IsAlloc($o, Tclass.KMBtree.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for KMBtree._default.MaxKeysPerLeaf
function KMBtree.__default.MaxKeysPerLeaf() : int;

function KMBtree.__default.MaxKeysPerLeaf#canCall() : bool;

// consequence axiom for KMBtree.__default.MaxKeysPerLeaf
axiom 1 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.MaxKeysPerLeaf#canCall() || 1 != $FunctionContextHeight
   ==> Lit(2 < KMBtree.__default.MaxKeysPerLeaf()
         && KMBtree.__default.MaxKeysPerLeaf()
           < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(4)))
     && 
    LitInt(0) <= KMBtree.__default.MaxKeysPerLeaf()
     && KMBtree.__default.MaxKeysPerLeaf() < 18446744073709551616;

function KMBtree.__default.MaxKeysPerLeaf#requires() : bool;

// #requires axiom for KMBtree.__default.MaxKeysPerLeaf
axiom KMBtree.__default.MaxKeysPerLeaf#requires() == true;

// definition axiom for KMBtree.__default.MaxKeysPerLeaf(revealed)
axiom 1 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.MaxKeysPerLeaf#canCall() || 1 != $FunctionContextHeight
   ==> KMBtree.__default.MaxKeysPerLeaf() == LitInt(64);

// definition axiom for KMBtree.__default.MaxKeysPerLeaf for all literals(revealed)
axiom 1 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.MaxKeysPerLeaf#canCall() || 1 != $FunctionContextHeight
   ==> KMBtree.__default.MaxKeysPerLeaf() == LitInt(64);

procedure CheckWellformed$$KMBtree.__default.MaxKeysPerLeaf();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures Lit(2 < KMBtree.__default.MaxKeysPerLeaf());
  ensures Lit(KMBtree.__default.MaxKeysPerLeaf()
       < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(4)));



function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

implementation CheckWellformed$$KMBtree.__default.MaxKeysPerLeaf()
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;


    // AddWellformednessCheck for function MaxKeysPerLeaf
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/KMBtree.i.dfy(13,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    if (*)
    {
        assume LitInt(0) <= KMBtree.__default.MaxKeysPerLeaf()
           && KMBtree.__default.MaxKeysPerLeaf() < 18446744073709551616;
        assert true;
        assume true;
        if (Lit(2 < KMBtree.__default.MaxKeysPerLeaf()))
        {
            assert true;
            assume true;
            assume NativeTypes.__default.Uint64UpperBound#canCall();
            assert LitInt(4) != 0;
        }

        assume 2 < KMBtree.__default.MaxKeysPerLeaf()
           && KMBtree.__default.MaxKeysPerLeaf()
             < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(4));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        newtype$check#0 := LitInt(64);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume KMBtree.__default.MaxKeysPerLeaf() == LitInt(64);
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(KMBtree.__default.MaxKeysPerLeaf(), Tclass.NativeTypes.uint64());
    }
}



// function declaration for KMBtree._default.MaxChildren
function KMBtree.__default.MaxChildren() : int;

function KMBtree.__default.MaxChildren#canCall() : bool;

// consequence axiom for KMBtree.__default.MaxChildren
axiom 2 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.MaxChildren#canCall() || 2 != $FunctionContextHeight
   ==> Lit(3 < KMBtree.__default.MaxChildren()
         && KMBtree.__default.MaxChildren()
           < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(4)))
     && 
    LitInt(0) <= KMBtree.__default.MaxChildren()
     && KMBtree.__default.MaxChildren() < 18446744073709551616;

function KMBtree.__default.MaxChildren#requires() : bool;

// #requires axiom for KMBtree.__default.MaxChildren
axiom KMBtree.__default.MaxChildren#requires() == true;

// definition axiom for KMBtree.__default.MaxChildren(revealed)
axiom 2 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.MaxChildren#canCall() || 2 != $FunctionContextHeight
   ==> KMBtree.__default.MaxChildren() == LitInt(64);

// definition axiom for KMBtree.__default.MaxChildren for all literals(revealed)
axiom 2 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.MaxChildren#canCall() || 2 != $FunctionContextHeight
   ==> KMBtree.__default.MaxChildren() == LitInt(64);

procedure CheckWellformed$$KMBtree.__default.MaxChildren();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures Lit(3 < KMBtree.__default.MaxChildren());
  ensures Lit(KMBtree.__default.MaxChildren()
       < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(4)));



implementation CheckWellformed$$KMBtree.__default.MaxChildren()
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;


    // AddWellformednessCheck for function MaxChildren
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/KMBtree.i.dfy(14,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    if (*)
    {
        assume LitInt(0) <= KMBtree.__default.MaxChildren()
           && KMBtree.__default.MaxChildren() < 18446744073709551616;
        assert true;
        assume true;
        if (Lit(3 < KMBtree.__default.MaxChildren()))
        {
            assert true;
            assume true;
            assume NativeTypes.__default.Uint64UpperBound#canCall();
            assert LitInt(4) != 0;
        }

        assume 3 < KMBtree.__default.MaxChildren()
           && KMBtree.__default.MaxChildren()
             < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(4));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        newtype$check#0 := LitInt(64);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume KMBtree.__default.MaxChildren() == LitInt(64);
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(KMBtree.__default.MaxChildren(), Tclass.NativeTypes.uint64());
    }
}



// function declaration for KMBtree._default.DefaultValue
function KMBtree.__default.DefaultValue() : DatatypeType;

function KMBtree.__default.DefaultValue#canCall() : bool;

function Tclass.ValueMessage.Message() : Ty;

// Tclass.ValueMessage.Message Tag
axiom Tag(Tclass.ValueMessage.Message()) == Tagclass.ValueMessage.Message;

const unique Tagclass.ValueMessage.Message: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Message
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Message()) } 
  $IsBox(bx, Tclass.ValueMessage.Message())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Message()));

// consequence axiom for KMBtree.__default.DefaultValue
axiom 4 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.DefaultValue#canCall() || 4 != $FunctionContextHeight
   ==> $Is(KMBtree.__default.DefaultValue(), Tclass.ValueMessage.Message());

function KMBtree.__default.DefaultValue#requires() : bool;

// #requires axiom for KMBtree.__default.DefaultValue
axiom KMBtree.__default.DefaultValue#requires() == true;

// definition axiom for KMBtree.__default.DefaultValue(revealed)
axiom 4 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.DefaultValue#canCall() || 4 != $FunctionContextHeight
   ==> ValueMessage.__default.DefineDefault#canCall()
     && KMBtree.__default.DefaultValue() == Lit(ValueMessage.__default.DefineDefault());

// definition axiom for KMBtree.__default.DefaultValue for all literals(revealed)
axiom 4 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.DefaultValue#canCall() || 4 != $FunctionContextHeight
   ==> ValueMessage.__default.DefineDefault#canCall()
     && KMBtree.__default.DefaultValue() == Lit(ValueMessage.__default.DefineDefault());

procedure CheckWellformed$$KMBtree.__default.DefaultValue();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.DefaultValue()
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;

    b$reqreads#0 := true;

    // AddWellformednessCheck for function DefaultValue
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/KMBtree.i.dfy(16,18): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    if (*)
    {
        assume $Is(KMBtree.__default.DefaultValue(), Tclass.ValueMessage.Message());
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume ValueMessage.__default.DefineDefault#canCall();
        assume KMBtree.__default.DefaultValue() == Lit(ValueMessage.__default.DefineDefault());
        assume ValueMessage.__default.DefineDefault#canCall();
        // CheckWellformedWithResult: any expression
        assume $Is(KMBtree.__default.DefaultValue(), Tclass.ValueMessage.Message());
        assert b$reqreads#0;
    }
}



// function declaration for KMBtree._default.DefaultKey
function KMBtree.__default.DefaultKey() : Seq Box;

function KMBtree.__default.DefaultKey#canCall() : bool;

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

// consequence axiom for KMBtree.__default.DefaultKey
axiom 6 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.DefaultKey#canCall() || 6 != $FunctionContextHeight
   ==> $Is(KMBtree.__default.DefaultKey(), TSeq(Tclass.NativeTypes.byte()));

function KMBtree.__default.DefaultKey#requires() : bool;

// #requires axiom for KMBtree.__default.DefaultKey
axiom KMBtree.__default.DefaultKey#requires() == true;

// definition axiom for KMBtree.__default.DefaultKey(revealed)
axiom 6 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.DefaultKey#canCall() || 6 != $FunctionContextHeight
   ==> KMBtree.__default.DefaultKey() == Lit(Seq#Empty(): Seq Box);

// definition axiom for KMBtree.__default.DefaultKey for all literals(revealed)
axiom 6 <= $FunctionContextHeight
   ==> 
  KMBtree.__default.DefaultKey#canCall() || 6 != $FunctionContextHeight
   ==> KMBtree.__default.DefaultKey() == Lit(Seq#Empty(): Seq Box);

procedure CheckWellformed$$KMBtree.__default.DefaultKey();
  free requires 6 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.MaxSiblingHeight
function KMBtree.__default.MaxSiblingHeight($ly: LayerType, $heap: Heap, nodes#0: Seq Box) : int;

function KMBtree.__default.MaxSiblingHeight#canCall($heap: Heap, nodes#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.MaxSiblingHeight($LS($ly), $Heap, nodes#0) } 
  KMBtree.__default.MaxSiblingHeight($LS($ly), $Heap, nodes#0)
     == KMBtree.__default.MaxSiblingHeight($ly, $Heap, nodes#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.MaxSiblingHeight(AsFuelBottom($ly), $Heap, nodes#0) } 
  KMBtree.__default.MaxSiblingHeight($ly, $Heap, nodes#0)
     == KMBtree.__default.MaxSiblingHeight($LZ, $Heap, nodes#0));

function Tclass.KMBtree.Node() : Ty;

// Tclass.KMBtree.Node Tag
axiom Tag(Tclass.KMBtree.Node()) == Tagclass.KMBtree.Node;

const unique Tagclass.KMBtree.Node: TyTag;

// Box/unbox axiom for Tclass.KMBtree.Node
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KMBtree.Node()) } 
  $IsBox(bx, Tclass.KMBtree.Node())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KMBtree.Node()));

// frame axiom for KMBtree.__default.MaxSiblingHeight
axiom (forall $ly: LayerType, $h0: Heap, $h1: Heap, nodes#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.MaxSiblingHeight($ly, $h1, nodes#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.MaxSiblingHeight#canCall($h0, nodes#0)
         || $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && Sequences.__default.Set(Tclass.KMBtree.Node(), nodes#0)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.MaxSiblingHeight($ly, $h0, nodes#0)
       == KMBtree.__default.MaxSiblingHeight($ly, $h1, nodes#0));

axiom FDim(KMBtree.Node.height) == 0
   && FieldOfDecl(class.KMBtree.Node?, field$height) == KMBtree.Node.height
   && $IsGhostField(KMBtree.Node.height);

// consequence axiom for KMBtree.__default.MaxSiblingHeight
axiom 8 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.MaxSiblingHeight($ly, $Heap, nodes#0) } 
    KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0)
         || (8 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       ==> (forall i#0: int :: 
        { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
        true
           ==> 
          LitInt(0) <= i#0 && i#0 < Seq#Length(nodes#0)
           ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref, KMBtree.Node.height)
             <= KMBtree.__default.MaxSiblingHeight($ly, $Heap, nodes#0)));

function KMBtree.__default.MaxSiblingHeight#requires(LayerType, Heap, Seq Box) : bool;

// #requires axiom for KMBtree.__default.MaxSiblingHeight
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.MaxSiblingHeight#requires($ly, $Heap, nodes#0) } 
  $IsGoodHeap($Heap) && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
     ==> KMBtree.__default.MaxSiblingHeight#requires($ly, $Heap, nodes#0) == true);

// definition axiom for KMBtree.__default.MaxSiblingHeight(revealed)
axiom 8 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.MaxSiblingHeight($LS($ly), $Heap, nodes#0) } 
    KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0)
         || (8 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       ==> (!Seq#Equal(nodes#0, Seq#Empty(): Seq Box)
           ==> KMBtree.__default.MaxSiblingHeight#canCall($Heap, Seq#Drop(nodes#0, LitInt(1)))
             && Mathematics.__default.max#canCall(read($Heap, $Unbox(Seq#Index(nodes#0, LitInt(0))): ref, KMBtree.Node.height), 
              KMBtree.__default.MaxSiblingHeight($ly, $Heap, Seq#Drop(nodes#0, LitInt(1)))))
         && KMBtree.__default.MaxSiblingHeight($LS($ly), $Heap, nodes#0)
           == (if Seq#Equal(nodes#0, Seq#Empty(): Seq Box)
             then 0 - 1
             else Mathematics.__default.max(read($Heap, $Unbox(Seq#Index(nodes#0, LitInt(0))): ref, KMBtree.Node.height), 
              KMBtree.__default.MaxSiblingHeight($ly, $Heap, Seq#Drop(nodes#0, LitInt(1))))));

procedure CheckWellformed$$KMBtree.__default.MaxSiblingHeight(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction nodes#0} CheckWellformed$$KMBtree.__default.MaxSiblingHeightIsSmallest(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    parentHeight#0: int where LitInt(0) <= parentHeight#0);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction nodes#0} Call$$KMBtree.__default.MaxSiblingHeightIsSmallest(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    parentHeight#0: int where LitInt(0) <= parentHeight#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall i#1: int :: 
      { $Unbox(Seq#Index(nodes#0, i#1)): ref } 
      true
         ==> 
        LitInt(0) <= i#1 && i#1 < Seq#Length(nodes#0)
         ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.height)
           < parentHeight#0)
     ==> KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0);
  ensures (forall i#1: int :: 
      { $Unbox(Seq#Index(nodes#0, i#1)): ref } 
      true
         ==> 
        LitInt(0) <= i#1 && i#1 < Seq#Length(nodes#0)
         ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.height)
           < parentHeight#0)
     ==> KMBtree.__default.MaxSiblingHeight($LS($LS($LZ)), $Heap, nodes#0)
       < parentHeight#0;
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction nodes#0} Impl$$KMBtree.__default.MaxSiblingHeightIsSmallest(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    parentHeight#0: int where LitInt(0) <= parentHeight#0)
   returns ($_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall i#1: int :: 
      { $Unbox(Seq#Index(nodes#0, i#1)): ref } 
      true
         ==> 
        LitInt(0) <= i#1 && i#1 < Seq#Length(nodes#0)
         ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.height)
           < parentHeight#0)
     ==> KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0);
  ensures $_reverifyPost
     ==> 
    (forall i#1: int :: 
      { $Unbox(Seq#Index(nodes#0, i#1)): ref } 
      true
         ==> 
        LitInt(0) <= i#1 && i#1 < Seq#Length(nodes#0)
         ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.height)
           < parentHeight#0)
     ==> KMBtree.__default.MaxSiblingHeight($LS($LS($LZ)), $Heap, nodes#0)
       < parentHeight#0;
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction nodes#0} Impl$$KMBtree.__default.MaxSiblingHeightIsSmallest(nodes#0: Seq Box, parentHeight#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var m#0: int;
  var ##nodes#1: Seq Box;
  var nodes##0: Seq Box;
  var parentHeight##0: int;

    // AddMethodImpl: MaxSiblingHeightIsSmallest, Impl$$KMBtree.__default.MaxSiblingHeightIsSmallest
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](55,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#nodes0#0: Seq Box :: 
      $Is($ih#nodes0#0, TSeq(Tclass.KMBtree.Node()))
           && Lit(true)
           && (Seq#Rank($ih#nodes0#0) < Seq#Rank(nodes#0)
             || (Seq#Rank($ih#nodes0#0) == Seq#Rank(nodes#0)
               && 
              0 <= parentHeight#0
               && parentHeight#0 < parentHeight#0))
         ==> 
        (forall i#2: int :: 
          { $Unbox(Seq#Index($ih#nodes0#0, i#2)): ref } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length($ih#nodes0#0)
             ==> read($Heap, $Unbox(Seq#Index($ih#nodes0#0, i#2)): ref, KMBtree.Node.height)
               < parentHeight#0)
         ==> KMBtree.__default.MaxSiblingHeight($LS($LZ), $Heap, $ih#nodes0#0)
           < parentHeight#0);
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](56,11)
    assume true;
    ##nodes#1 := nodes#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#1, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0);
    assume KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0);
    m#0 := KMBtree.__default.MaxSiblingHeight($LS($LZ), $Heap, nodes#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](56,36)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](57,5)
    assume true;
    if (Seq#Equal(nodes#0, Seq#Empty(): Seq Box))
    {
    }
    else
    {
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](59,7)
        assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(nodes#0);
        assume $Unbox(Seq#Index(nodes#0, LitInt(0))): ref != null;
        assume true;
        if (m#0
           == read($Heap, $Unbox(Seq#Index(nodes#0, LitInt(0))): ref, KMBtree.Node.height))
        {
        }
        else
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](61,35)
            // TrCallStmt: Before ProcessCallStmt
            assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(nodes#0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            nodes##0 := Seq#Drop(nodes#0, LitInt(1));
            assume true;
            // ProcessCallStmt: CheckSubrange
            parentHeight##0 := parentHeight#0;
            assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume 0 <= parentHeight#0
               || Seq#Rank(nodes##0) < Seq#Rank(nodes#0)
               || parentHeight##0 == parentHeight#0;
            assume Seq#Rank(nodes##0) < Seq#Rank(nodes#0)
               || (Seq#Rank(nodes##0) == Seq#Rank(nodes#0) && parentHeight##0 < parentHeight#0);
            // ProcessCallStmt: Make the call
            call Call$$KMBtree.__default.MaxSiblingHeightIsSmallest(nodes##0, parentHeight##0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](61,60)"} true;
        }
    }
}



// function declaration for KMBtree._default.DisjointReprs
function KMBtree.__default.DisjointReprs($heap: Heap, nodes#0: Seq Box, i#0: int, j#0: int) : bool;

function KMBtree.__default.DisjointReprs#canCall($heap: Heap, nodes#0: Seq Box, i#0: int, j#0: int) : bool;

// frame axiom for KMBtree.__default.DisjointReprs
axiom (forall $h0: Heap, $h1: Heap, nodes#0: Seq Box, i#0: int, j#0: int :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.DisjointReprs($h1, nodes#0, i#0, j#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.DisjointReprs#canCall($h0, nodes#0, i#0, j#0)
         || $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == $Unbox(Seq#Index(nodes#0, i#0)): ref
             || $o == $Unbox(Seq#Index(nodes#0, j#0)): ref)
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.DisjointReprs($h0, nodes#0, i#0, j#0)
       == KMBtree.__default.DisjointReprs($h1, nodes#0, i#0, j#0));

// consequence axiom for KMBtree.__default.DisjointReprs
axiom 11 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, nodes#0: Seq Box, i#0: int, j#0: int :: 
    { KMBtree.__default.DisjointReprs($Heap, nodes#0, i#0, j#0) } 
    KMBtree.__default.DisjointReprs#canCall($Heap, nodes#0, i#0, j#0)
         || (11 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(nodes#0)
           && 
          LitInt(0) <= j#0
           && j#0 < Seq#Length(nodes#0))
       ==> true);

function KMBtree.__default.DisjointReprs#requires(Heap, Seq Box, int, int) : bool;

// #requires axiom for KMBtree.__default.DisjointReprs
axiom (forall $Heap: Heap, nodes#0: Seq Box, i#0: int, j#0: int :: 
  { KMBtree.__default.DisjointReprs#requires($Heap, nodes#0, i#0, j#0) } 
  $IsGoodHeap($Heap) && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
     ==> KMBtree.__default.DisjointReprs#requires($Heap, nodes#0, i#0, j#0)
       == (
        LitInt(0) <= i#0
         && i#0 < Seq#Length(nodes#0)
         && 
        LitInt(0) <= j#0
         && j#0 < Seq#Length(nodes#0)));

axiom FDim(KMBtree.Node.repr) == 0
   && FieldOfDecl(class.KMBtree.Node?, field$repr) == KMBtree.Node.repr
   && $IsGhostField(KMBtree.Node.repr);

// definition axiom for KMBtree.__default.DisjointReprs(revealed)
axiom 11 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, nodes#0: Seq Box, i#0: int, j#0: int :: 
    { KMBtree.__default.DisjointReprs($Heap, nodes#0, i#0, j#0) } 
    KMBtree.__default.DisjointReprs#canCall($Heap, nodes#0, i#0, j#0)
         || (11 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(nodes#0)
           && 
          LitInt(0) <= j#0
           && j#0 < Seq#Length(nodes#0))
       ==> KMBtree.__default.DisjointReprs($Heap, nodes#0, i#0, j#0)
         == Set#Disjoint(read($Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref, KMBtree.Node.repr), 
          read($Heap, $Unbox(Seq#Index(nodes#0, j#0)): ref, KMBtree.Node.repr)));

procedure CheckWellformed$$KMBtree.__default.DisjointReprs(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())), 
    i#0: int, 
    j#0: int);
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.SeqRepr
function KMBtree.__default.SeqRepr($ly: LayerType, $heap: Heap, nodes#0: Seq Box) : Set Box;

function KMBtree.__default.SeqRepr#canCall($heap: Heap, nodes#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.SeqRepr($LS($ly), $Heap, nodes#0) } 
  KMBtree.__default.SeqRepr($LS($ly), $Heap, nodes#0)
     == KMBtree.__default.SeqRepr($ly, $Heap, nodes#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.SeqRepr(AsFuelBottom($ly), $Heap, nodes#0) } 
  KMBtree.__default.SeqRepr($ly, $Heap, nodes#0)
     == KMBtree.__default.SeqRepr($LZ, $Heap, nodes#0));

// frame axiom for KMBtree.__default.SeqRepr
axiom (forall $ly: LayerType, $h0: Heap, $h1: Heap, nodes#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.SeqRepr($ly, $h1, nodes#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.SeqRepr#canCall($h0, nodes#0)
         || $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && Sequences.__default.Set(Tclass.KMBtree.Node(), nodes#0)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.SeqRepr($ly, $h0, nodes#0)
       == KMBtree.__default.SeqRepr($ly, $h1, nodes#0));

// consequence axiom for KMBtree.__default.SeqRepr
axiom 13 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.SeqRepr($ly, $Heap, nodes#0) } 
    KMBtree.__default.SeqRepr#canCall($Heap, nodes#0)
         || (13 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(nodes#0)
             ==> Set#Subset(read($Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref, KMBtree.Node.repr), 
              KMBtree.__default.SeqRepr($ly, $Heap, nodes#0)))
         && (Seq#Equal(nodes#0, Seq#Empty(): Seq Box)
           ==> Set#Equal(KMBtree.__default.SeqRepr($ly, $Heap, nodes#0), Set#Empty(): Set Box))
         && $Is(KMBtree.__default.SeqRepr($ly, $Heap, nodes#0), TSet(Tclass._System.object())));

function KMBtree.__default.SeqRepr#requires(LayerType, Heap, Seq Box) : bool;

// #requires axiom for KMBtree.__default.SeqRepr
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.SeqRepr#requires($ly, $Heap, nodes#0) } 
  $IsGoodHeap($Heap) && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
     ==> KMBtree.__default.SeqRepr#requires($ly, $Heap, nodes#0) == true);

// definition axiom for KMBtree.__default.SeqRepr(revealed)
axiom 13 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.SeqRepr($LS($ly), $Heap, nodes#0) } 
    KMBtree.__default.SeqRepr#canCall($Heap, nodes#0)
         || (13 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       ==> KMBtree.__default.SeqRepr($LS($ly), $Heap, nodes#0)
         == (lambda $y#0: Box :: 
          (exists i#1: int, o#0: ref :: 
            { read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object())
               && 
              LitInt(0) <= i#1
               && i#1 < Seq#Length(nodes#0)
               && read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)]
               && $y#0 == $Box(o#0))));

procedure {:opaque} CheckWellformed$$KMBtree.__default.SeqRepr(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure CheckWellformed$$KMBtree.__default.SeqReprSubsetExtensionality(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    parentRepr#0: Set Box
       where $Is(parentRepr#0, TSet(Tclass._System.object()))
         && $IsAlloc(parentRepr#0, TSet(Tclass._System.object()), $Heap));
  free requires 15 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.SeqReprSubsetExtensionality(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    parentRepr#0: Set Box
       where $Is(parentRepr#0, TSet(Tclass._System.object()))
         && $IsAlloc(parentRepr#0, TSet(Tclass._System.object()), $Heap));
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(nodes#0, i#1)): ref } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < Seq#Length(nodes#0)
       ==> Set#Subset(read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr), 
        parentRepr#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SeqRepr#canCall($Heap, nodes#0);
  ensures Set#Subset(KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, $Heap, nodes#0), 
    parentRepr#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$KMBtree.__default.SeqReprSubsetExtensionality(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    parentRepr#0: Set Box
       where $Is(parentRepr#0, TSet(Tclass._System.object()))
         && $IsAlloc(parentRepr#0, TSet(Tclass._System.object()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 15 == $FunctionContextHeight;
  // user-defined preconditions
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(nodes#0, i#1)): ref } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < Seq#Length(nodes#0)
       ==> Set#Subset(read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr), 
        parentRepr#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SeqRepr#canCall($Heap, nodes#0);
  ensures $_reverifyPost
     ==> Set#Subset(KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, $Heap, nodes#0), 
      parentRepr#0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$KMBtree.__default.SeqReprSubsetExtensionality(nodes#0: Seq Box, parentRepr#0: Set Box) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: SeqReprSubsetExtensionality, Impl$$KMBtree.__default.SeqReprSubsetExtensionality
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](107,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](108,19)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__SeqRepr();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](108,20)"} true;
}



procedure CheckWellformed$$KMBtree.__default.DisjointSubSeqReprsAreDisjoint(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    lo1#0: int, 
    hi1#0: int, 
    lo2#0: int, 
    hi2#0: int);
  free requires 16 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.DisjointSubSeqReprsAreDisjoint(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    lo1#0: int, 
    hi1#0: int, 
    lo2#0: int, 
    hi2#0: int);
  // user-defined preconditions
  requires LitInt(0) <= lo1#0;
  requires lo1#0 <= hi1#0;
  requires hi1#0 <= lo2#0;
  requires lo2#0 <= hi2#0;
  requires hi2#0 <= Seq#Length(nodes#0);
  requires (forall i#1: int, j#1: int :: 
    { KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#1) } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(nodes#0)
       ==> KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#1));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0))
     && KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0));
  ensures Set#Disjoint(KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, 
      $Heap, 
      Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0)), 
    KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, 
      $Heap, 
      Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$KMBtree.__default.DisjointSubSeqReprsAreDisjoint(nodes#0: Seq Box
       where $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    lo1#0: int, 
    hi1#0: int, 
    lo2#0: int, 
    hi2#0: int)
   returns ($_reverifyPost: bool);
  free requires 16 == $FunctionContextHeight;
  // user-defined preconditions
  requires LitInt(0) <= lo1#0;
  requires lo1#0 <= hi1#0;
  requires hi1#0 <= lo2#0;
  requires lo2#0 <= hi2#0;
  requires hi2#0 <= Seq#Length(nodes#0);
  requires (forall i#1: int, j#1: int :: 
    { KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#1) } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(nodes#0)
       ==> KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#1));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0))
     && KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0));
  ensures $_reverifyPost
     ==> Set#Disjoint(KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, 
        $Heap, 
        Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0)), 
      KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, 
        $Heap, 
        Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$KMBtree.__default.DisjointSubSeqReprsAreDisjoint(nodes#0: Seq Box, lo1#0: int, hi1#0: int, lo2#0: int, hi2#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var s1#0: Set Box
     where $Is(s1#0, TSet(Tclass._System.object()))
       && $IsAlloc(s1#0, TSet(Tclass._System.object()), $Heap);
  var ##nodes#3: Seq Box;
  var s2#0: Set Box
     where $Is(s2#0, TSet(Tclass._System.object()))
       && $IsAlloc(s2#0, TSet(Tclass._System.object()), $Heap);
  var ##nodes#4: Seq Box;
  var eg$o#0: ref;
  var o#0_0: ref
     where $Is(o#0_0, Tclass._System.object())
       && $IsAlloc(o#0_0, Tclass._System.object(), $Heap);
  var i1#0_0: int;
  var i2#0_0: int;
  var ##nodes#0_0: Seq Box;
  var ##i#0_0: int;
  var ##j#0_0: int;

    // AddMethodImpl: DisjointSubSeqReprsAreDisjoint, Impl$$KMBtree.__default.DisjointSubSeqReprsAreDisjoint
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](131,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](132,19)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__SeqRepr();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](132,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](133,12)
    assume true;
    assume 0 <= lo1#0 && lo1#0 <= Seq#Length(nodes#0);
    assume lo1#0 <= hi1#0 && hi1#0 <= Seq#Length(nodes#0);
    ##nodes#3 := Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#3, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0));
    assume KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0));
    s1#0 := KMBtree.__default.SeqRepr(StartFuel_KMBtree._default.SeqRepr, 
      $Heap, 
      Seq#Drop(Seq#Take(nodes#0, hi1#0), lo1#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](133,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](134,12)
    assume true;
    assume 0 <= lo2#0 && lo2#0 <= Seq#Length(nodes#0);
    assume lo2#0 <= hi2#0 && hi2#0 <= Seq#Length(nodes#0);
    ##nodes#4 := Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#4, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0));
    assume KMBtree.__default.SeqRepr#canCall($Heap, Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0));
    s2#0 := KMBtree.__default.SeqRepr(StartFuel_KMBtree._default.SeqRepr, 
      $Heap, 
      Seq#Drop(Seq#Take(nodes#0, hi2#0), lo2#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](134,38)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](135,5)
    havoc eg$o#0;
    assume $Is(eg$o#0, Tclass._System.object());
    // Begin Comprehension WF check
    if (s1#0[$Box(eg$o#0)])
    {
    }

    // End Comprehension WF check
    assume true;
    havoc o#0_0 /* where $Is(o#0_0, Tclass._System.object())
       && $IsAlloc(o#0_0, Tclass._System.object(), $Heap) */;
    if (*)
    {
        assume s1#0[$Box(o#0_0)] && s2#0[$Box(o#0_0)];
        // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](136,14)
        assume true;
        havoc i1#0_0;
        if (lo1#0 <= i1#0_0)
        {
        }

        if (lo1#0 <= i1#0_0 && i1#0_0 < hi1#0)
        {
            assume {:subsumption 0} 0 <= i1#0_0 && i1#0_0 < Seq#Length(nodes#0);
            assume {:subsumption 0} $Unbox(Seq#Index(nodes#0, i1#0_0)): ref != null;
        }

        assume true;
        assume ($Is(hi1#0 - 1, TInt)
             && 
            lo1#0 <= hi1#0 - 1
             && hi1#0 - 1 < hi1#0
             && read($Heap, $Unbox(Seq#Index(nodes#0, hi1#0 - 1)): ref, KMBtree.Node.repr)[$Box(o#0_0)])
           || 
          ($Is(lo1#0, TInt)
             && 
            lo1#0 <= lo1#0
             && lo1#0 < hi1#0
             && read($Heap, $Unbox(Seq#Index(nodes#0, lo1#0)): ref, KMBtree.Node.repr)[$Box(o#0_0)])
           || 
          ($Is(LitInt(0), TInt)
             && 
            lo1#0 <= LitInt(0)
             && 0 < hi1#0
             && read($Heap, $Unbox(Seq#Index(nodes#0, LitInt(0))): ref, KMBtree.Node.repr)[$Box(o#0_0)])
           || (exists $as#i10_0#0_0: int :: 
            lo1#0 <= $as#i10_0#0_0
               && $as#i10_0#0_0 < hi1#0
               && read($Heap, $Unbox(Seq#Index(nodes#0, $as#i10_0#0_0)): ref, KMBtree.Node.repr)[$Box(o#0_0)]);
        assume lo1#0 <= i1#0_0
           && i1#0_0 < hi1#0
           && read($Heap, $Unbox(Seq#Index(nodes#0, i1#0_0)): ref, KMBtree.Node.repr)[$Box(o#0_0)];
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](136,54)"} true;
        // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](137,14)
        assume true;
        havoc i2#0_0;
        if (lo2#0 <= i2#0_0)
        {
        }

        if (lo2#0 <= i2#0_0 && i2#0_0 < hi2#0)
        {
            assume {:subsumption 0} 0 <= i2#0_0 && i2#0_0 < Seq#Length(nodes#0);
            assume {:subsumption 0} $Unbox(Seq#Index(nodes#0, i2#0_0)): ref != null;
        }

        assume true;
        assume ($Is(hi2#0 - 1, TInt)
             && 
            lo2#0 <= hi2#0 - 1
             && hi2#0 - 1 < hi2#0
             && read($Heap, $Unbox(Seq#Index(nodes#0, hi2#0 - 1)): ref, KMBtree.Node.repr)[$Box(o#0_0)])
           || 
          ($Is(lo2#0, TInt)
             && 
            lo2#0 <= lo2#0
             && lo2#0 < hi2#0
             && read($Heap, $Unbox(Seq#Index(nodes#0, lo2#0)): ref, KMBtree.Node.repr)[$Box(o#0_0)])
           || 
          ($Is(LitInt(0), TInt)
             && 
            lo2#0 <= LitInt(0)
             && 0 < hi2#0
             && read($Heap, $Unbox(Seq#Index(nodes#0, LitInt(0))): ref, KMBtree.Node.repr)[$Box(o#0_0)])
           || (exists $as#i20_0#0_0: int :: 
            lo2#0 <= $as#i20_0#0_0
               && $as#i20_0#0_0 < hi2#0
               && read($Heap, $Unbox(Seq#Index(nodes#0, $as#i20_0#0_0)): ref, KMBtree.Node.repr)[$Box(o#0_0)]);
        assume lo2#0 <= i2#0_0
           && i2#0_0 < hi2#0
           && read($Heap, $Unbox(Seq#Index(nodes#0, i2#0_0)): ref, KMBtree.Node.repr)[$Box(o#0_0)];
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](137,54)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](138,7)
        ##nodes#0_0 := nodes#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##nodes#0_0, TSeq(Tclass.KMBtree.Node()), $Heap);
        ##i#0_0 := i1#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0_0, TInt, $Heap);
        ##j#0_0 := i2#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##j#0_0, TInt, $Heap);
        assume {:subsumption 0} LitInt(0) <= ##i#0_0;
        assume {:subsumption 0} ##i#0_0 < Seq#Length(##nodes#0_0);
        assume {:subsumption 0} LitInt(0) <= ##j#0_0;
        assume {:subsumption 0} ##j#0_0 < Seq#Length(##nodes#0_0);
        assume KMBtree.__default.DisjointReprs#canCall($Heap, nodes#0, i1#0_0, i2#0_0);
        assume KMBtree.__default.DisjointReprs#canCall($Heap, nodes#0, i1#0_0, i2#0_0);
        assume !KMBtree.__default.DisjointReprs($Heap, nodes#0, i1#0_0, i2#0_0);
    }
    else
    {
        assume !(exists eg$o#1: ref :: 
          $Is(eg$o#1, Tclass._System.object()) && s1#0[$Box(eg$o#1)] && s2#0[$Box(eg$o#1)]);
    }
}



// function declaration for KMBtree._default.WFShapeSiblings
function KMBtree.__default.WFShapeSiblings($ly: LayerType, $heap: Heap, nodes#0: Seq Box) : bool;

function KMBtree.__default.WFShapeSiblings#canCall($heap: Heap, nodes#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.WFShapeSiblings($LS($ly), $Heap, nodes#0) } 
  KMBtree.__default.WFShapeSiblings($LS($ly), $Heap, nodes#0)
     == KMBtree.__default.WFShapeSiblings($ly, $Heap, nodes#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.WFShapeSiblings(AsFuelBottom($ly), $Heap, nodes#0) } 
  KMBtree.__default.WFShapeSiblings($ly, $Heap, nodes#0)
     == KMBtree.__default.WFShapeSiblings($LZ, $Heap, nodes#0));

// frame axiom for KMBtree.__default.WFShapeSiblings
axiom (forall $ly: LayerType, $h0: Heap, $h1: Heap, nodes#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.WFShapeSiblings($ly, $h1, nodes#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.WFShapeSiblings#canCall($h0, nodes#0)
         || $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (Sequences.__default.Set(Tclass.KMBtree.Node(), nodes#0)[$Box($o)]
             || KMBtree.__default.SeqRepr(StartFuel_KMBtree._default.SeqRepr, $h0, nodes#0)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.WFShapeSiblings($ly, $h0, nodes#0)
       == KMBtree.__default.WFShapeSiblings($ly, $h1, nodes#0));

// consequence axiom for KMBtree.__default.WFShapeSiblings
axiom 17 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.WFShapeSiblings($ly, $Heap, nodes#0) } 
    KMBtree.__default.WFShapeSiblings#canCall($Heap, nodes#0)
         || (17 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       ==> true);

function KMBtree.__default.WFShapeSiblings#requires(LayerType, Heap, Seq Box) : bool;

// #requires axiom for KMBtree.__default.WFShapeSiblings
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.WFShapeSiblings#requires($ly, $Heap, nodes#0) } 
  $IsGoodHeap($Heap) && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
     ==> KMBtree.__default.WFShapeSiblings#requires($ly, $Heap, nodes#0) == true);

// definition axiom for KMBtree.__default.WFShapeSiblings(revealed)
axiom 17 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.WFShapeSiblings($LS($ly), $Heap, nodes#0) } 
    KMBtree.__default.WFShapeSiblings#canCall($Heap, nodes#0)
         || (17 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
          i#0 < Seq#Length(nodes#0)
             ==> KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref))
         && ((forall i#0: int :: 
            { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(nodes#0)
               ==> KMBtree.__default.WFShape($ly, $Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref))
           ==> (forall i#1: int, j#0: int :: 
            { KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#0) } 
            j#0 < Seq#Length(nodes#0)
               ==> KMBtree.__default.DisjointReprs#canCall($Heap, nodes#0, i#1, j#0)))
         && KMBtree.__default.WFShapeSiblings($LS($ly), $Heap, nodes#0)
           == ((forall i#0: int :: 
              { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
              true
                 ==> 
                LitInt(0) <= i#0 && i#0 < Seq#Length(nodes#0)
                 ==> KMBtree.__default.WFShape($ly, $Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref))
             && (forall i#1: int, j#0: int :: 
              { KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#0) } 
              true
                 ==> 
                LitInt(0) <= i#1 && i#1 < j#0 && j#0 < Seq#Length(nodes#0)
                 ==> KMBtree.__default.DisjointReprs($Heap, nodes#0, i#1, j#0))));

procedure CheckWellformed$$KMBtree.__default.WFShapeSiblings(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())));
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.WFShapeChildren
function KMBtree.__default.WFShapeChildren($ly: LayerType, 
    $heap: Heap, 
    nodes#0: Seq Box, 
    parentRepr#0: Set Box, 
    parentHeight#0: int)
   : bool;

function KMBtree.__default.WFShapeChildren#canCall($heap: Heap, nodes#0: Seq Box, parentRepr#0: Set Box, parentHeight#0: int)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    $Heap: Heap, 
    nodes#0: Seq Box, 
    parentRepr#0: Set Box, 
    parentHeight#0: int :: 
  { KMBtree.__default.WFShapeChildren($LS($ly), $Heap, nodes#0, parentRepr#0, parentHeight#0) } 
  KMBtree.__default.WFShapeChildren($LS($ly), $Heap, nodes#0, parentRepr#0, parentHeight#0)
     == KMBtree.__default.WFShapeChildren($ly, $Heap, nodes#0, parentRepr#0, parentHeight#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    $Heap: Heap, 
    nodes#0: Seq Box, 
    parentRepr#0: Set Box, 
    parentHeight#0: int :: 
  { KMBtree.__default.WFShapeChildren(AsFuelBottom($ly), $Heap, nodes#0, parentRepr#0, parentHeight#0) } 
  KMBtree.__default.WFShapeChildren($ly, $Heap, nodes#0, parentRepr#0, parentHeight#0)
     == KMBtree.__default.WFShapeChildren($LZ, $Heap, nodes#0, parentRepr#0, parentHeight#0));

// frame axiom for KMBtree.__default.WFShapeChildren
axiom (forall $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    nodes#0: Seq Box, 
    parentRepr#0: Set Box, 
    parentHeight#0: int :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.WFShapeChildren($ly, $h1, nodes#0, parentRepr#0, parentHeight#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.WFShapeChildren#canCall($h0, nodes#0, parentRepr#0, parentHeight#0)
         || (
          $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && $Is(parentRepr#0, TSet(Tclass._System.object()))
           && LitInt(0) <= parentHeight#0))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && parentRepr#0[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.WFShapeChildren($ly, $h0, nodes#0, parentRepr#0, parentHeight#0)
       == KMBtree.__default.WFShapeChildren($ly, $h1, nodes#0, parentRepr#0, parentHeight#0));

// consequence axiom for KMBtree.__default.WFShapeChildren
axiom 17 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      nodes#0: Seq Box, 
      parentRepr#0: Set Box, 
      parentHeight#0: int :: 
    { KMBtree.__default.WFShapeChildren($ly, $Heap, nodes#0, parentRepr#0, parentHeight#0) } 
    KMBtree.__default.WFShapeChildren#canCall($Heap, nodes#0, parentRepr#0, parentHeight#0)
         || (17 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && $Is(parentRepr#0, TSet(Tclass._System.object()))
           && LitInt(0) <= parentHeight#0)
       ==> true);

function KMBtree.__default.WFShapeChildren#requires(LayerType, Heap, Seq Box, Set Box, int) : bool;

// #requires axiom for KMBtree.__default.WFShapeChildren
axiom (forall $ly: LayerType, 
    $Heap: Heap, 
    nodes#0: Seq Box, 
    parentRepr#0: Set Box, 
    parentHeight#0: int :: 
  { KMBtree.__default.WFShapeChildren#requires($ly, $Heap, nodes#0, parentRepr#0, parentHeight#0) } 
  $IsGoodHeap($Heap)
       && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
       && $Is(parentRepr#0, TSet(Tclass._System.object()))
       && LitInt(0) <= parentHeight#0
     ==> KMBtree.__default.WFShapeChildren#requires($ly, $Heap, nodes#0, parentRepr#0, parentHeight#0)
       == true);

// definition axiom for KMBtree.__default.WFShapeChildren(revealed)
axiom 17 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      nodes#0: Seq Box, 
      parentRepr#0: Set Box, 
      parentHeight#0: int :: 
    { KMBtree.__default.WFShapeChildren($LS($ly), $Heap, nodes#0, parentRepr#0, parentHeight#0) } 
    KMBtree.__default.WFShapeChildren#canCall($Heap, nodes#0, parentRepr#0, parentHeight#0)
         || (17 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && $Is(parentRepr#0, TSet(Tclass._System.object()))
           && LitInt(0) <= parentHeight#0)
       ==> Sequences.__default.Set#canCall(Tclass.KMBtree.Node(), nodes#0)
         && (Set#Subset(Sequences.__default.Set(Tclass.KMBtree.Node(), nodes#0), parentRepr#0)
           ==> KMBtree.__default.SeqRepr#canCall($Heap, nodes#0))
         && ((forall i#0: int :: 
            { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(nodes#0)
               ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref, KMBtree.Node.height)
                 < parentHeight#0)
           ==> KMBtree.__default.WFShapeSiblings#canCall($Heap, nodes#0))
         && KMBtree.__default.WFShapeChildren($LS($ly), $Heap, nodes#0, parentRepr#0, parentHeight#0)
           == (
            Set#Subset(Sequences.__default.Set(Tclass.KMBtree.Node(), nodes#0), parentRepr#0)
             && Set#Subset(KMBtree.__default.SeqRepr(StartFuel_KMBtree._default.SeqRepr, $Heap, nodes#0), 
              parentRepr#0)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
              true
                 ==> 
                LitInt(0) <= i#0 && i#0 < Seq#Length(nodes#0)
                 ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#0)): ref, KMBtree.Node.height)
                   < parentHeight#0)
             && KMBtree.__default.WFShapeSiblings($ly, $Heap, nodes#0)));

procedure CheckWellformed$$KMBtree.__default.WFShapeChildren(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())), 
    parentRepr#0: Set Box where $Is(parentRepr#0, TSet(Tclass._System.object())), 
    parentHeight#0: int where LitInt(0) <= parentHeight#0);
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.WFShape
function KMBtree.__default.WFShape($ly: LayerType, $heap: Heap, node#0: ref) : bool;

function KMBtree.__default.WFShape#canCall($heap: Heap, node#0: ref) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.WFShape($LS($ly), $Heap, node#0) } 
  KMBtree.__default.WFShape($LS($ly), $Heap, node#0)
     == KMBtree.__default.WFShape($ly, $Heap, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.WFShape(AsFuelBottom($ly), $Heap, node#0) } 
  KMBtree.__default.WFShape($ly, $Heap, node#0)
     == KMBtree.__default.WFShape($LZ, $Heap, node#0));

// frame axiom for KMBtree.__default.WFShape
axiom (forall $ly: LayerType, $h0: Heap, $h1: Heap, node#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.WFShape($ly, $h1, node#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.WFShape#canCall($h0, node#0)
         || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && ($o == node#0 || read($h0, node#0, KMBtree.Node.repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.WFShape($ly, $h0, node#0)
       == KMBtree.__default.WFShape($ly, $h1, node#0));

// consequence axiom for KMBtree.__default.WFShape
axiom 17 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.WFShape($ly, $Heap, node#0) } 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
         || (17 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node()))
       ==> true);

function KMBtree.__default.WFShape#requires(LayerType, Heap, ref) : bool;

// #requires axiom for KMBtree.__default.WFShape
axiom (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.WFShape#requires($ly, $Heap, node#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.WFShape#requires($ly, $Heap, node#0) == true);

axiom FDim(KMBtree.Node.contents) == 0
   && FieldOfDecl(class.KMBtree.Node?, field$contents) == KMBtree.Node.contents
   && !$IsGhostField(KMBtree.Node.contents);

// definition axiom for KMBtree.__default.WFShape(revealed)
axiom 17 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.WFShape($LS($ly), $Heap, node#0) } 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
         || (17 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node()))
       ==> (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> (Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
                Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                    $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                  $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
               ==> Arrays.__default.Aliases#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueMessage.Message(), 
                KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
                KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))
             && (read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
               ==> (LitInt(0)
                     <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
                   ==> KMBtree.__default.MaxKeysPerLeaf#canCall())
                 && (KMBtree.__default.MaxKeysPerLeaf#canCall()
                     && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
                       <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
                   ==> KMBtree.__default.MaxKeysPerLeaf#canCall())))
         && (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> 
          Lit(true)
           ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
            Lit(true)
               ==> (var children#0 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                          $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                        $Box(children#0)), 
                      read($Heap, node#0, KMBtree.Node.repr))
                     ==> (0 < nchildren#0 ==> KMBtree.__default.MaxChildren#canCall())
                       && (KMBtree.__default.MaxChildren#canCall()
                           && nchildren#0 <= LitInt(KMBtree.__default.MaxChildren())
                         ==> KMBtree.__default.MaxChildren#canCall()))
                   && ((0 < nchildren#0 ==> KMBtree.__default.MaxChildren#canCall())
                       && (KMBtree.__default.MaxChildren#canCall()
                           && nchildren#0 <= LitInt(KMBtree.__default.MaxChildren())
                         ==> KMBtree.__default.MaxChildren#canCall())
                       && 
                      0 < nchildren#0
                       && nchildren#0 <= LitInt(KMBtree.__default.MaxChildren())
                       && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#0)
                     ==> KMBtree.__default.MaxChildren#canCall())
                   && ((forall i#0: int :: 
                      { $Unbox(read($Heap, children#0, IndexField(i#0))): ref } 
                      LitInt(0) <= i#0 && i#0 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#0 && i#0 < nchildren#0
                         ==> $Unbox(read($Heap, children#0, IndexField(i#0))): ref != null)
                     ==> KMBtree.__default.WFShapeChildren#canCall($Heap, 
                      Seq#Take(Seq#FromArray($Heap, children#0), nchildren#0), 
                      read($Heap, node#0, KMBtree.Node.repr), 
                      read($Heap, node#0, KMBtree.Node.height))))))
         && KMBtree.__default.WFShape($LS($ly), $Heap, node#0)
           == (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
                Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                    $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                  $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
               && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueMessage.Message(), 
                KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
                KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
               && 
              LitInt(0)
                 <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
                 <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
               && LitInt(KMBtree.__default.MaxKeysPerLeaf())
                 == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
               && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
                 == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
             else true
               && (var nchildren#0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
                true
                   && (var children#0 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                    Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                            $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                          $Box(children#0)), 
                        read($Heap, node#0, KMBtree.Node.repr))
                       && 
                      0 < nchildren#0
                       && nchildren#0 <= LitInt(KMBtree.__default.MaxChildren())
                       && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#0)
                       && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                         == LitInt(KMBtree.__default.MaxChildren() - 1)
                       && (forall i#0: int :: 
                        { $Unbox(read($Heap, children#0, IndexField(i#0))): ref } 
                        LitInt(0) <= i#0 && i#0 < 18446744073709551616
                           ==> 
                          LitInt(0) <= i#0 && i#0 < nchildren#0
                           ==> $Unbox(read($Heap, children#0, IndexField(i#0))): ref != null)
                       && KMBtree.__default.WFShapeChildren($ly, 
                        $Heap, 
                        Seq#Take(Seq#FromArray($Heap, children#0), nchildren#0), 
                        read($Heap, node#0, KMBtree.Node.repr), 
                        read($Heap, node#0, KMBtree.Node.height))
                       && (forall i#1: int :: 
                        { $Unbox(read($Heap, children#0, IndexField(i#1))): ref } 
                        LitInt(0) <= i#1 && i#1 < 18446744073709551616
                           ==> 
                          LitInt(0) <= i#1 && i#1 < nchildren#0
                           ==> !read($Heap, $Unbox(read($Heap, children#0, IndexField(i#1))): ref, KMBtree.Node.repr)[$Box(node#0)])
                       && (forall i#2: int :: 
                        { $Unbox(read($Heap, children#0, IndexField(i#2))): ref } 
                        LitInt(0) <= i#2 && i#2 < 18446744073709551616
                           ==> 
                          LitInt(0) <= i#2 && i#2 < nchildren#0
                           ==> !read($Heap, $Unbox(read($Heap, children#0, IndexField(i#2))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                       && 
                      true
                       && (forall i#3: int :: 
                        { $Unbox(read($Heap, children#0, IndexField(i#3))): ref } 
                        LitInt(0) <= i#3 && i#3 < 18446744073709551616
                           ==> 
                          LitInt(0) <= i#3 && i#3 < nchildren#0
                           ==> !read($Heap, $Unbox(read($Heap, children#0, IndexField(i#3))): ref, KMBtree.Node.repr)[$Box(children#0)])))));

procedure CheckWellformed$$KMBtree.__default.WFShape(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()));
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function Tclass.KMBtree.Node?() : Ty;

// Tclass.KMBtree.Node? Tag
axiom Tag(Tclass.KMBtree.Node?()) == Tagclass.KMBtree.Node?;

const unique Tagclass.KMBtree.Node?: TyTag;

// Box/unbox axiom for Tclass.KMBtree.Node?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KMBtree.Node?()) } 
  $IsBox(bx, Tclass.KMBtree.Node?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KMBtree.Node?()));

// function declaration for KMBtree._default.IChildren
function KMBtree.__default.IChildren($ly: LayerType, $heap: Heap, nodes#0: Seq Box, parentheight#0: int) : Seq Box;

function KMBtree.__default.IChildren#canCall($heap: Heap, nodes#0: Seq Box, parentheight#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box, parentheight#0: int :: 
  { KMBtree.__default.IChildren($LS($ly), $Heap, nodes#0, parentheight#0) } 
  KMBtree.__default.IChildren($LS($ly), $Heap, nodes#0, parentheight#0)
     == KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box, parentheight#0: int :: 
  { KMBtree.__default.IChildren(AsFuelBottom($ly), $Heap, nodes#0, parentheight#0) } 
  KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0)
     == KMBtree.__default.IChildren($LZ, $Heap, nodes#0, parentheight#0));

// frame axiom for KMBtree.__default.IChildren
axiom (forall $ly: LayerType, $h0: Heap, $h1: Heap, nodes#0: Seq Box, parentheight#0: int :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.IChildren($ly, $h1, nodes#0, parentheight#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.IChildren#canCall($h0, nodes#0, parentheight#0)
         || $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ((exists i#0: int :: 
              { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
              LitInt(0) <= i#0
                 && i#0 < Seq#Length(nodes#0)
                 && $Box($o) == Seq#Index(nodes#0, i#0))
             || (exists i#1: int, o#0: ref :: 
              { read($h0, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)] } 
              $Is(o#0, Tclass._System.object())
                 && 
                LitInt(0) <= i#1
                 && i#1 < Seq#Length(nodes#0)
                 && read($h0, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)]
                 && $Box($o) == $Box(o#0)))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.IChildren($ly, $h0, nodes#0, parentheight#0)
       == KMBtree.__default.IChildren($ly, $h1, nodes#0, parentheight#0));

function Tclass.KMBtreeModel.Node() : Ty;

// Tclass.KMBtreeModel.Node Tag
axiom Tag(Tclass.KMBtreeModel.Node()) == Tagclass.KMBtreeModel.Node;

const unique Tagclass.KMBtreeModel.Node: TyTag;

// Box/unbox axiom for Tclass.KMBtreeModel.Node
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KMBtreeModel.Node()) } 
  $IsBox(bx, Tclass.KMBtreeModel.Node())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.KMBtreeModel.Node()));

// consequence axiom for KMBtree.__default.IChildren
axiom 19 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box, parentheight#0: int :: 
    { KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0) } 
    KMBtree.__default.IChildren#canCall($Heap, nodes#0, parentheight#0)
         || (19 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && 
          (forall i#2: int :: 
            { $Unbox(Seq#Index(nodes#0, i#2)): ref } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(nodes#0)
               ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#2)): ref))
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(nodes#0, i#3)): ref } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(nodes#0)
               ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#3)): ref, KMBtree.Node.height)
                 < parentheight#0))
       ==> Seq#Length(KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0))
           == Seq#Length(nodes#0)
         && (forall i#4: int :: 
          { $Unbox(Seq#Index(nodes#0, i#4)): ref } 
            { $Unbox(Seq#Index(KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0), i#4)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#4
               && i#4
                 < Seq#Length(KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0))
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0), i#4)): DatatypeType, 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $Unbox(Seq#Index(nodes#0, i#4)): ref)))
         && $Is(KMBtree.__default.IChildren($ly, $Heap, nodes#0, parentheight#0), 
          TSeq(Tclass.KMBtreeModel.Node())));

function KMBtree.__default.IChildren#requires(LayerType, Heap, Seq Box, int) : bool;

// #requires axiom for KMBtree.__default.IChildren
axiom (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box, parentheight#0: int :: 
  { KMBtree.__default.IChildren#requires($ly, $Heap, nodes#0, parentheight#0) } 
  $IsGoodHeap($Heap) && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
     ==> KMBtree.__default.IChildren#requires($ly, $Heap, nodes#0, parentheight#0)
       == ((forall i#5: int :: 
          { $Unbox(Seq#Index(nodes#0, i#5)): ref } 
          true
             ==> 
            LitInt(0) <= i#5 && i#5 < Seq#Length(nodes#0)
             ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#5)): ref))
         && (forall i#6: int :: 
          { $Unbox(Seq#Index(nodes#0, i#6)): ref } 
          true
             ==> 
            LitInt(0) <= i#6 && i#6 < Seq#Length(nodes#0)
             ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#6)): ref, KMBtree.Node.height)
               < parentheight#0)));

// definition axiom for KMBtree.__default.IChildren(revealed)
axiom 19 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, nodes#0: Seq Box, parentheight#0: int :: 
    { KMBtree.__default.IChildren($LS($ly), $Heap, nodes#0, parentheight#0) } 
    KMBtree.__default.IChildren#canCall($Heap, nodes#0, parentheight#0)
         || (19 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && 
          (forall i#5: int :: 
            { $Unbox(Seq#Index(nodes#0, i#5)): ref } 
            true
               ==> 
              LitInt(0) <= i#5 && i#5 < Seq#Length(nodes#0)
               ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#5)): ref))
           && (forall i#6: int :: 
            { $Unbox(Seq#Index(nodes#0, i#6)): ref } 
            true
               ==> 
              LitInt(0) <= i#6 && i#6 < Seq#Length(nodes#0)
               ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#6)): ref, KMBtree.Node.height)
                 < parentheight#0))
       ==> (Seq#Length(nodes#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KMBtree.Node(), nodes#0)
             && KMBtree.__default.IChildren#canCall($Heap, 
              Sequences.__default.DropLast(Tclass.KMBtree.Node(), nodes#0), 
              parentheight#0)
             && 
            Sequences.__default.Last#canCall(Tclass.KMBtree.Node(), nodes#0)
             && KMBtree.__default.I#canCall($Heap, $Unbox(Sequences.__default.Last(Tclass.KMBtree.Node(), nodes#0)): ref))
         && KMBtree.__default.IChildren($LS($ly), $Heap, nodes#0, parentheight#0)
           == (if Seq#Length(nodes#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(KMBtree.__default.IChildren($ly, 
                $Heap, 
                Sequences.__default.DropLast(Tclass.KMBtree.Node(), nodes#0), 
                parentheight#0), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(KMBtree.__default.I($ly, 
                    $Heap, 
                    $Unbox(Sequences.__default.Last(Tclass.KMBtree.Node(), nodes#0)): ref))))));

procedure CheckWellformed$$KMBtree.__default.IChildren(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())), 
    parentheight#0: int)
   returns (result#0: Seq Box where $Is(result#0, TSeq(Tclass.KMBtreeModel.Node())));
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.IChildren(nodes#0: Seq Box, parentheight#0: int) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#8: int;
  var ##node#0: ref;
  var i#10: int;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var i#12: int;
  var i#13: int;
  var o#1: ref;
  var b$reqreads#2: bool;
  var i#14: int;
  var ##node#1: ref;
  var ##run#0: Seq Box;
  var ##nodes#0: Seq Box;
  var ##parentheight#0: int;
  var ##run#1: Seq Box;
  var ##node#2: ref;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;

    // AddWellformednessCheck for function IChildren
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](193,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> (exists i#0: int :: 
            { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(nodes#0)
               && $Box($o) == Seq#Index(nodes#0, i#0))
           || (exists i#1: int, o#0: ref :: 
            { read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object())
               && 
              LitInt(0) <= i#1
               && i#1 < Seq#Length(nodes#0)
               && read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)]
               && $Box($o) == $Box(o#0)));
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    havoc i#8;
    if (*)
    {
        assume LitInt(0) <= i#8;
        assume i#8 < Seq#Length(nodes#0);
        assume 0 <= i#8 && i#8 < Seq#Length(nodes#0);
        ##node#0 := $Unbox(Seq#Index(nodes#0, i#8)): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == ##node#0 || read($Heap, ##node#0, KMBtree.Node.repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(nodes#0, i#8)): ref);
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#8)): ref);
    }
    else
    {
        assume LitInt(0) <= i#8 && i#8 < Seq#Length(nodes#0)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#8)): ref);
    }

    assume (forall i#9: int :: 
      { $Unbox(Seq#Index(nodes#0, i#9)): ref } 
      true
         ==> 
        LitInt(0) <= i#9 && i#9 < Seq#Length(nodes#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#9)): ref));
    havoc i#10;
    if (*)
    {
        assume LitInt(0) <= i#10;
        assume i#10 < Seq#Length(nodes#0);
        assume 0 <= i#10 && i#10 < Seq#Length(nodes#0);
        assume $Unbox(Seq#Index(nodes#0, i#10)): ref != null;
        b$reqreads#1 := $_Frame[$Unbox(Seq#Index(nodes#0, i#10)): ref, KMBtree.Node.height];
        assume read($Heap, $Unbox(Seq#Index(nodes#0, i#10)): ref, KMBtree.Node.height)
           < parentheight#0;
    }
    else
    {
        assume LitInt(0) <= i#10 && i#10 < Seq#Length(nodes#0)
           ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#10)): ref, KMBtree.Node.height)
             < parentheight#0;
    }

    assume (forall i#11: int :: 
      { $Unbox(Seq#Index(nodes#0, i#11)): ref } 
      true
         ==> 
        LitInt(0) <= i#11 && i#11 < Seq#Length(nodes#0)
         ==> read($Heap, $Unbox(Seq#Index(nodes#0, i#11)): ref, KMBtree.Node.height)
           < parentheight#0);
    assume b$reqreads#0;
    assume b$reqreads#1;
    havoc i#12;
    // Begin Comprehension WF check
    if (LitInt(0) <= i#12)
    {
    }

    if (LitInt(0) <= i#12 && i#12 < Seq#Length(nodes#0))
    {
        assume 0 <= i#12 && i#12 < Seq#Length(nodes#0);
    }

    // End Comprehension WF check
    havoc i#13;
    havoc o#1;
    assume $Is(o#1, Tclass._System.object());
    // Begin Comprehension WF check
    if (LitInt(0) <= i#13)
    {
    }

    if (LitInt(0) <= i#13 && i#13 < Seq#Length(nodes#0))
    {
        assume 0 <= i#13 && i#13 < Seq#Length(nodes#0);
        assume $Unbox(Seq#Index(nodes#0, i#13)): ref != null;
        b$reqreads#2 := $_Frame[$Unbox(Seq#Index(nodes#0, i#13)): ref, KMBtree.Node.repr];
    }

    if (LitInt(0) <= i#13
       && i#13 < Seq#Length(nodes#0)
       && read($Heap, $Unbox(Seq#Index(nodes#0, i#13)): ref, KMBtree.Node.repr)[$Box(o#1)])
    {
    }

    // End Comprehension WF check
    assume b$reqreads#2;
    if (*)
    {
        assume $Is(KMBtree.__default.IChildren($LS($LZ), $Heap, nodes#0, parentheight#0), 
          TSeq(Tclass.KMBtreeModel.Node()));
        assume Seq#Length(result#0) == Seq#Length(nodes#0);
        havoc i#14;
        if (*)
        {
            assume LitInt(0) <= i#14;
            assume i#14 < Seq#Length(result#0);
            assume 0 <= i#14 && i#14 < Seq#Length(result#0);
            assume 0 <= i#14 && i#14 < Seq#Length(nodes#0);
            ##node#1 := $Unbox(Seq#Index(nodes#0, i#14)): ref;
            // assume allocatedness for argument to function
            assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#1);
            assume 0 <= parentheight#0
               || read($Heap, ##node#1, KMBtree.Node.height) == parentheight#0;
            assume read($Heap, ##node#1, KMBtree.Node.height) < parentheight#0;
            assume KMBtree.__default.I#canCall($Heap, $Unbox(Seq#Index(nodes#0, i#14)): ref);
            assume KMBtreeModel.Node#Equal($Unbox(Seq#Index(result#0, i#14)): DatatypeType, 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $Unbox(Seq#Index(nodes#0, i#14)): ref));
        }
        else
        {
            assume LitInt(0) <= i#14 && i#14 < Seq#Length(result#0)
               ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(result#0, i#14)): DatatypeType, 
                KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $Unbox(Seq#Index(nodes#0, i#14)): ref));
        }

        assume (forall i#7: int :: 
          { $Unbox(Seq#Index(nodes#0, i#7)): ref } 
            { $Unbox(Seq#Index(result#0, i#7)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#7 && i#7 < Seq#Length(result#0)
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(result#0, i#7)): DatatypeType, 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $Unbox(Seq#Index(nodes#0, i#7)): ref)));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> (exists i#0: int :: 
                { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
                LitInt(0) <= i#0
                   && i#0 < Seq#Length(nodes#0)
                   && $Box($o) == Seq#Index(nodes#0, i#0))
               || (exists i#1: int, o#0: ref :: 
                { read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)] } 
                $Is(o#0, Tclass._System.object())
                   && 
                  LitInt(0) <= i#1
                   && i#1 < Seq#Length(nodes#0)
                   && read($Heap, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)]
                   && $Box($o) == $Box(o#0)));
        if (Seq#Length(nodes#0) == LitInt(0))
        {
            assume KMBtree.__default.IChildren($LS($LZ), $Heap, nodes#0, parentheight#0)
               == Lit(Seq#Empty(): Seq Box);
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(KMBtree.__default.IChildren($LS($LZ), $Heap, nodes#0, parentheight#0), 
              TSeq(Tclass.KMBtreeModel.Node()));
        }
        else
        {
            ##run#0 := nodes#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.KMBtree.Node()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Seq#Length(##run#0) > 0;
            b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.DropLast#canCall(Tclass.KMBtree.Node(), nodes#0);
            ##nodes#0 := Sequences.__default.DropLast(Tclass.KMBtree.Node(), nodes#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
            ##parentheight#0 := parentheight#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##parentheight#0, TInt, $Heap);
            assume true;
            assume (forall i#20: int :: 
              { $Unbox(Seq#Index(##nodes#0, i#20)): ref } 
              true
                 ==> 
                LitInt(0) <= i#20 && i#20 < Seq#Length(##nodes#0)
                 ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(##nodes#0, i#20)): ref));
            assume true;
            assume (forall i#21: int :: 
              { $Unbox(Seq#Index(##nodes#0, i#21)): ref } 
              true
                 ==> 
                LitInt(0) <= i#21 && i#21 < Seq#Length(##nodes#0)
                 ==> read($Heap, $Unbox(Seq#Index(##nodes#0, i#21)): ref, KMBtree.Node.height)
                   < ##parentheight#0);
            b$reqreads#4 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ((exists i#22: int :: 
                      { $Unbox(Seq#Index(##nodes#0, i#22)): ref } 
                      LitInt(0) <= i#22
                         && i#22 < Seq#Length(##nodes#0)
                         && $Box($o) == Seq#Index(##nodes#0, i#22))
                     || (exists i#23: int, o#2: ref :: 
                      { read($Heap, $Unbox(Seq#Index(##nodes#0, i#23)): ref, KMBtree.Node.repr)[$Box(o#2)] } 
                      $Is(o#2, Tclass._System.object())
                         && 
                        LitInt(0) <= i#23
                         && i#23 < Seq#Length(##nodes#0)
                         && read($Heap, $Unbox(Seq#Index(##nodes#0, i#23)): ref, KMBtree.Node.repr)[$Box(o#2)]
                         && $Box($o) == $Box(o#2)))
                 ==> $_Frame[$o, $f]);
            assume 0 <= parentheight#0 || ##parentheight#0 == parentheight#0;
            assume 0 <= Seq#Length(nodes#0)
               || ##parentheight#0 < parentheight#0
               || Seq#Length(##nodes#0) == Seq#Length(nodes#0);
            assume ##parentheight#0 < parentheight#0
               || (##parentheight#0 == parentheight#0
                 && Seq#Length(##nodes#0) < Seq#Length(nodes#0));
            assume KMBtree.__default.IChildren#canCall($Heap, 
              Sequences.__default.DropLast(Tclass.KMBtree.Node(), nodes#0), 
              parentheight#0);
            ##run#1 := nodes#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(Tclass.KMBtree.Node()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Seq#Length(##run#1) > 0;
            b$reqreads#5 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume Sequences.__default.Last#canCall(Tclass.KMBtree.Node(), nodes#0);
            ##node#2 := $Unbox(Sequences.__default.Last(Tclass.KMBtree.Node(), nodes#0)): ref;
            // assume allocatedness for argument to function
            assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#2);
            b$reqreads#6 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == ##node#2 || read($Heap, ##node#2, KMBtree.Node.repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume 0 <= parentheight#0
               || read($Heap, ##node#2, KMBtree.Node.height) == parentheight#0;
            assume read($Heap, ##node#2, KMBtree.Node.height) < parentheight#0;
            assume KMBtree.__default.I#canCall($Heap, $Unbox(Sequences.__default.Last(Tclass.KMBtree.Node(), nodes#0)): ref);
            assume KMBtree.__default.IChildren($LS($LZ), $Heap, nodes#0, parentheight#0)
               == Seq#Append(KMBtree.__default.IChildren($LS($LZ), 
                  $Heap, 
                  Sequences.__default.DropLast(Tclass.KMBtree.Node(), nodes#0), 
                  parentheight#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(KMBtree.__default.I(StartFuel_KMBtree._default.I, 
                      $Heap, 
                      $Unbox(Sequences.__default.Last(Tclass.KMBtree.Node(), nodes#0)): ref))));
            assume Sequences.__default.DropLast#canCall(Tclass.KMBtree.Node(), nodes#0)
               && KMBtree.__default.IChildren#canCall($Heap, 
                Sequences.__default.DropLast(Tclass.KMBtree.Node(), nodes#0), 
                parentheight#0)
               && 
              Sequences.__default.Last#canCall(Tclass.KMBtree.Node(), nodes#0)
               && KMBtree.__default.I#canCall($Heap, $Unbox(Sequences.__default.Last(Tclass.KMBtree.Node(), nodes#0)): ref);
            // CheckWellformedWithResult: any expression
            assume $Is(KMBtree.__default.IChildren($LS($LZ), $Heap, nodes#0, parentheight#0), 
              TSeq(Tclass.KMBtreeModel.Node()));
        }

        assume KMBtree.__default.IChildren($LS($LZ), $Heap, nodes#0, parentheight#0)
           == result#0;
        assume b$reqreads#3;
        assume b$reqreads#4;
        assume b$reqreads#5;
        assume b$reqreads#6;
    }
}



// function declaration for KMBtree._default.I
function KMBtree.__default.I($ly: LayerType, $heap: Heap, node#0: ref) : DatatypeType;

function KMBtree.__default.I#canCall($heap: Heap, node#0: ref) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.I($LS($ly), $Heap, node#0) } 
  KMBtree.__default.I($LS($ly), $Heap, node#0)
     == KMBtree.__default.I($ly, $Heap, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.I(AsFuelBottom($ly), $Heap, node#0) } 
  KMBtree.__default.I($ly, $Heap, node#0)
     == KMBtree.__default.I($LZ, $Heap, node#0));

// frame axiom for KMBtree.__default.I
axiom (forall $ly: LayerType, $h0: Heap, $h1: Heap, node#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.I($ly, $h1, node#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.I#canCall($h0, node#0) || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && ($o == node#0 || read($h0, node#0, KMBtree.Node.repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.I($ly, $h0, node#0) == KMBtree.__default.I($ly, $h1, node#0));

// consequence axiom for KMBtree.__default.I
axiom 19 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.I($ly, $Heap, node#0) } 
    KMBtree.__default.I#canCall($Heap, node#0)
         || (19 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && KMBtree.__default.WFShape($LS($LZ), $Heap, node#0))
       ==> (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           <==> KMBtreeModel.Node.Leaf_q(KMBtree.__default.I($ly, $Heap, node#0)))
         && (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> Seq#Equal(KMBtreeModel.Node.keys(KMBtree.__default.I($ly, $Heap, node#0)), 
            Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
              KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)))))
         && (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> Seq#Equal(KMBtreeModel.Node.values(KMBtree.__default.I($ly, $Heap, node#0)), 
            Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))), 
              KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)))))
         && (KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> Seq#Equal(KMBtreeModel.Node.pivots(KMBtree.__default.I($ly, $Heap, node#0)), 
            Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
              KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1)))
         && (KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I($ly, $Heap, node#0)))
             == KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)))
         && $Is(KMBtree.__default.I($ly, $Heap, node#0), Tclass.KMBtreeModel.Node()));

function KMBtree.__default.I#requires(LayerType, Heap, ref) : bool;

// #requires axiom for KMBtree.__default.I
axiom (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.I#requires($ly, $Heap, node#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.I#requires($ly, $Heap, node#0)
       == KMBtree.__default.WFShape($LS($LZ), $Heap, node#0));

// definition axiom for KMBtree.__default.I(revealed)
axiom 19 <= $FunctionContextHeight
   ==> (forall $ly: LayerType, $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.I($LS($ly), $Heap, node#0) } 
    KMBtree.__default.I#canCall($Heap, node#0)
         || (19 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && KMBtree.__default.WFShape($LS($LZ), $Heap, node#0))
       ==> (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> (var children#0 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (var nchildren#0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              KMBtree.__default.IChildren#canCall($Heap, 
                Seq#Take(Seq#FromArray($Heap, children#0), nchildren#0), 
                read($Heap, node#0, KMBtree.Node.height)))))
         && KMBtree.__default.I($LS($ly), $Heap, node#0)
           == (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             then (var values#1 := KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)); 
              (var keys#1 := KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)); 
                (var nkeys#1 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)); 
                  #KMBtreeModel.Node.Leaf(Seq#Take(Seq#FromArray($Heap, keys#1), nkeys#1), 
                    Seq#Take(Seq#FromArray($Heap, values#1), nkeys#1)))))
             else (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              (var pivots#1 := KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)); 
                (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
                  (var bschildren#1 := KMBtree.__default.IChildren($ly, 
                        $Heap, 
                        Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
                        read($Heap, node#0, KMBtree.Node.height)); 
                    #KMBtreeModel.Node.Index(Seq#Take(Seq#FromArray($Heap, pivots#1), nchildren#1 - 1), bschildren#1)))))));

procedure {:opaque} CheckWellformed$$KMBtree.__default.I(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()))
   returns (result#0: DatatypeType where $Is(result#0, Tclass.KMBtreeModel.Node()));
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.IOfChild(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int);
  free requires 21 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.IOfChild(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int);
  // user-defined preconditions
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#2)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#2)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#2 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#10: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#10))): ref } 
              LitInt(0) <= i#10 && i#10 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#10 && i#10 < nchildren#2
                 ==> $Unbox(read($Heap, children#2, IndexField(i#10))): ref != null))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#11: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#11))): ref } 
              LitInt(0) <= i#11 && i#11 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#11 && i#11 < nchildren#2
                 ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#12: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#12))): ref } 
              LitInt(0) <= i#12 && i#12 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#12 && i#12 < nchildren#2
                 ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#12))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#13: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                  { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#2
                   ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#13: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                  { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#2
                   ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
               ==> (forall i#14: int :: 
                { $Unbox(read($Heap, children#2, IndexField(i#14))): ref } 
                LitInt(0) <= i#14 && i#14 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#14 && i#14 < nchildren#2
                   ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#14))): ref, KMBtree.Node.repr)[$Box(children#2)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  free ensures KMBtree.__default.WFShape#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  free ensures KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     && 
    KMBtree.__default.WFShape($LS($LZ), 
      $Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.contents))
       then Set#Equal(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))), 
              $Box(KMBtree.NodeContents.keys(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)))
         && read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.height)
           == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
       else true
         && (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          true
             && (var children#3 := KMBtree.NodeContents.children(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                        read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0))), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, 
                            $Unbox(read($Heap, 
                                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(childidx#0))): ref, 
                            KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr))
                 && 
                0 < nchildren#3
                 && nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0))): ref, 
                        KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr), 
                  read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.height))
                 && (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))])
                 && (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, 
                          $Unbox(read($Heap, 
                              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                              IndexField(childidx#0))): ref, 
                          KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#19: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)]))));
  free ensures $IsA#KMBtreeModel.Node($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0)): DatatypeType)
     && $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref))
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
  ensures KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
        childidx#0)): DatatypeType, 
    KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, 
      $Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.IOfChild(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int)
   returns ($_reverifyPost: bool);
  free requires 21 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#20: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#20))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#21: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#21))): ref } 
                  LitInt(0) <= i#21 && i#21 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#21 && i#21 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#21))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#22: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#22))): ref } 
                  LitInt(0) <= i#22 && i#22 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#22 && i#22 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#22))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#24: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#24))): ref, KMBtree.Node.repr)[$Box(children#4)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures $_reverifyPost
     ==> $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
  free ensures KMBtree.__default.WFShape#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))), 
              $Box(KMBtree.NodeContents.keys(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.height)
           == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                    read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0))): ref, 
                        KMBtree.Node.contents)))), 
                $Box(children#5)), 
              read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            0 < nchildren#5)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            nchildren#5 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#25: int :: 
              { $Unbox(read($Heap, children#5, IndexField(i#25))): ref } 
              LitInt(0) <= i#25 && i#25 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#25 && i#25 < nchildren#5
                 ==> $Unbox(read($Heap, children#5, IndexField(i#25))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), 
              read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr), 
              read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#26: int :: 
              { $Unbox(read($Heap, children#5, IndexField(i#26))): ref } 
              LitInt(0) <= i#26 && i#26 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#26 && i#26 < nchildren#5
                 ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#26))): ref, KMBtree.Node.repr)[read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#27: int :: 
              { $Unbox(read($Heap, children#5, IndexField(i#27))): ref } 
              LitInt(0) <= i#27 && i#27 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#27 && i#27 < nchildren#5
                 ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#27))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0))): ref, 
                      KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#28: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#28)): ref } 
                  { $Unbox(read($Heap, children#5, IndexField(i#28))): ref } 
                LitInt(0) <= i#28 && i#28 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#28 && i#28 < nchildren#5
                   ==> $Unbox(read($Heap, children#5, IndexField(i#28))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#28)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#28: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#28)): ref } 
                  { $Unbox(read($Heap, children#5, IndexField(i#28))): ref } 
                LitInt(0) <= i#28 && i#28 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#28 && i#28 < nchildren#5
                   ==> $Unbox(read($Heap, children#5, IndexField(i#28))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#28)): ref)
               ==> (forall i#29: int :: 
                { $Unbox(read($Heap, children#5, IndexField(i#29))): ref } 
                LitInt(0) <= i#29 && i#29 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#29 && i#29 < nchildren#5
                   ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#29))): ref, KMBtree.Node.repr)[$Box(children#5)]))));
  free ensures $IsA#KMBtreeModel.Node($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0)): DatatypeType)
     && $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref))
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
  ensures $_reverifyPost
     ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
          childidx#0)): DatatypeType, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, 
        $Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.IOfChild(node#0: ref, childidx#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var ##nodes#0: Seq Box;

    // AddMethodImpl: IOfChild, Impl$$KMBtree.__default.IOfChild
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](232,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), $initHeapForallStmt#0, $ih#node0#0)
           && KMBtree.NodeContents.Index_q(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= childidx#0
           && childidx#0
             < KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && (($ih#node0#0 == null && node#0 != null)
             || (($ih#node0#0 != null <==> node#0 != null)
               && 
              0 <= childidx#0
               && childidx#0 < childidx#0))
         ==> $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
             != null
           && KMBtree.__default.WFShape($LS($LZ), 
            $Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref)
           && KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $ih#node0#0)), 
                childidx#0)): DatatypeType, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref)));
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](233,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.WFShapeSiblings#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume KMBtree.__default.WFShapeSiblings#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeSiblings($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](234,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](234,14)"} true;
}



// function declaration for KMBtree._default.ISiblings
function KMBtree.__default.ISiblings($heap: Heap, nodes#0: Seq Box) : Seq Box;

function KMBtree.__default.ISiblings#canCall($heap: Heap, nodes#0: Seq Box) : bool;

// frame axiom for KMBtree.__default.ISiblings
axiom (forall $h0: Heap, $h1: Heap, nodes#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.ISiblings($h1, nodes#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.ISiblings#canCall($h0, nodes#0)
         || $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ((exists i#0: int :: 
              { $Unbox(Seq#Index(nodes#0, i#0)): ref } 
              LitInt(0) <= i#0
                 && i#0 < Seq#Length(nodes#0)
                 && $Box($o) == Seq#Index(nodes#0, i#0))
             || (exists i#1: int, o#0: ref :: 
              { read($h0, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)] } 
              $Is(o#0, Tclass._System.object())
                 && 
                LitInt(0) <= i#1
                 && i#1 < Seq#Length(nodes#0)
                 && read($h0, $Unbox(Seq#Index(nodes#0, i#1)): ref, KMBtree.Node.repr)[$Box(o#0)]
                 && $Box($o) == $Box(o#0)))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.ISiblings($h0, nodes#0)
       == KMBtree.__default.ISiblings($h1, nodes#0));

// consequence axiom for KMBtree.__default.ISiblings
axiom 22 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.ISiblings($Heap, nodes#0) } 
    KMBtree.__default.ISiblings#canCall($Heap, nodes#0)
         || (22 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(nodes#0, i#2)): ref } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(nodes#0)
               ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#2)): ref)))
       ==> Seq#Length(KMBtree.__default.ISiblings($Heap, nodes#0)) == Seq#Length(nodes#0)
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(nodes#0, i#3)): ref } 
            { $Unbox(Seq#Index(KMBtree.__default.ISiblings($Heap, nodes#0), i#3)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#3
               && i#3 < Seq#Length(KMBtree.__default.ISiblings($Heap, nodes#0))
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtree.__default.ISiblings($Heap, nodes#0), i#3)): DatatypeType, 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $Unbox(Seq#Index(nodes#0, i#3)): ref)))
         && $Is(KMBtree.__default.ISiblings($Heap, nodes#0), TSeq(Tclass.KMBtreeModel.Node())));

function KMBtree.__default.ISiblings#requires(Heap, Seq Box) : bool;

// #requires axiom for KMBtree.__default.ISiblings
axiom (forall $Heap: Heap, nodes#0: Seq Box :: 
  { KMBtree.__default.ISiblings#requires($Heap, nodes#0) } 
  $IsGoodHeap($Heap) && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
     ==> KMBtree.__default.ISiblings#requires($Heap, nodes#0)
       == (forall i#4: int :: 
        { $Unbox(Seq#Index(nodes#0, i#4)): ref } 
        true
           ==> 
          LitInt(0) <= i#4 && i#4 < Seq#Length(nodes#0)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#4)): ref)));

// definition axiom for KMBtree.__default.ISiblings(revealed)
axiom 22 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, nodes#0: Seq Box :: 
    { KMBtree.__default.ISiblings($Heap, nodes#0) } 
    KMBtree.__default.ISiblings#canCall($Heap, nodes#0)
         || (22 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(nodes#0, TSeq(Tclass.KMBtree.Node()))
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(nodes#0, i#4)): ref } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(nodes#0)
               ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(nodes#0, i#4)): ref)))
       ==> KMBtree.__default.MaxSiblingHeight#canCall($Heap, nodes#0)
         && KMBtree.__default.IChildren#canCall($Heap, nodes#0, KMBtree.__default.MaxSiblingHeight($LS($LZ), $Heap, nodes#0) + 1)
         && KMBtree.__default.ISiblings($Heap, nodes#0)
           == KMBtree.__default.IChildren($LS($LZ), 
            $Heap, 
            nodes#0, 
            KMBtree.__default.MaxSiblingHeight($LS($LZ), $Heap, nodes#0) + 1));

procedure CheckWellformed$$KMBtree.__default.ISiblings(nodes#0: Seq Box where $Is(nodes#0, TSeq(Tclass.KMBtree.Node())))
   returns (result#0: Seq Box where $Is(result#0, TSeq(Tclass.KMBtreeModel.Node())));
  free requires 22 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.WF
function KMBtree.__default.WF($heap: Heap, node#0: ref) : bool;

function KMBtree.__default.WF#canCall($heap: Heap, node#0: ref) : bool;

// frame axiom for KMBtree.__default.WF
axiom (forall $h0: Heap, $h1: Heap, node#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.WF($h1, node#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.WF#canCall($h0, node#0)
         || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && ($o == node#0 || read($h0, node#0, KMBtree.Node.repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.WF($h0, node#0) == KMBtree.__default.WF($h1, node#0));

// consequence axiom for KMBtree.__default.WF
axiom 23 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.WF($Heap, node#0) } 
    KMBtree.__default.WF#canCall($Heap, node#0)
         || (23 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node()))
       ==> 
      KMBtree.__default.WF($Heap, node#0)
       ==> read($Heap, node#0, KMBtree.Node.repr)[$Box(node#0)]);

function KMBtree.__default.WF#requires(Heap, ref) : bool;

// #requires axiom for KMBtree.__default.WF
axiom (forall $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.WF#requires($Heap, node#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.WF#requires($Heap, node#0) == true);

// definition axiom for KMBtree.__default.WF(revealed)
axiom 23 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.WF($Heap, node#0) } 
    KMBtree.__default.WF#canCall($Heap, node#0)
         || (23 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node()))
       ==> KMBtree.__default.WFShape#canCall($Heap, node#0)
         && (KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           ==> KMBtree.__default.I#canCall($Heap, node#0)
             && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && KMBtree.__default.WF($Heap, node#0)
           == (KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
             && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))));

procedure CheckWellformed$$KMBtree.__default.WF(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()));
  free requires 23 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.Interpretation
function KMBtree.__default.Interpretation($heap: Heap, node#0: ref) : Map Box Box;

function KMBtree.__default.Interpretation#canCall($heap: Heap, node#0: ref) : bool;

// frame axiom for KMBtree.__default.Interpretation
axiom (forall $h0: Heap, $h1: Heap, node#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.Interpretation($h1, node#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.Interpretation#canCall($h0, node#0)
         || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($h0, node#0, KMBtree.Node.repr)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.Interpretation($h0, node#0)
       == KMBtree.__default.Interpretation($h1, node#0));

// consequence axiom for KMBtree.__default.Interpretation
axiom 24 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.Interpretation($Heap, node#0) } 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
         || (24 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && KMBtree.__default.WF($Heap, node#0))
       ==> $Is(KMBtree.__default.Interpretation($Heap, node#0), 
        TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message())));

function KMBtree.__default.Interpretation#requires(Heap, ref) : bool;

// #requires axiom for KMBtree.__default.Interpretation
axiom (forall $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.Interpretation#requires($Heap, node#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.Interpretation#requires($Heap, node#0)
       == KMBtree.__default.WF($Heap, node#0));

// definition axiom for KMBtree.__default.Interpretation(revealed)
axiom 24 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.Interpretation($Heap, node#0) } 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
         || (24 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && KMBtree.__default.WF($Heap, node#0))
       ==> KMBtree.__default.I#canCall($Heap, node#0)
         && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         && KMBtree.__default.Interpretation($Heap, node#0)
           == KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));

procedure CheckWellformed$$KMBtree.__default.Interpretation(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()));
  free requires 24 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.Interpretation(node#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##node#1: ref;
  var ##node#2: DatatypeType;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;

    // AddWellformednessCheck for function Interpretation
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](255,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == ##node#0 || read($Heap, ##node#0, KMBtree.Node.repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume b$reqreads#0;
    assume node#0 != null;
    b$reqreads#1 := $_Frame[node#0, KMBtree.Node.repr];
    assume b$reqreads#1;
    assume node#0 != null;
    if (*)
    {
        assume $Is(KMBtree.__default.Interpretation($Heap, node#0), 
          TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
        ##node#1 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#1);
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == ##node#1 || read($Heap, ##node#1, KMBtree.Node.repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        ##node#2 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#2, Tclass.KMBtreeModel.Node(), $Heap);
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Seq#Length(KMBtreeModel.Node.keys(##node#2))
                 == Seq#Length(KMBtreeModel.Node.values(##node#2)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(##node#2)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Seq#Length(KMBtreeModel.Node.pivots(##node#2))
                 == Seq#Length(KMBtreeModel.Node.children(##node#2)) - 1);
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(##node#2)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5 && i#5 < Seq#Length(KMBtreeModel.Node.children(##node#2))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#5)): DatatypeType)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6 && i#6 < Seq#Length(KMBtreeModel.Node.children(##node#2))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#6)): DatatypeType), 
                    Set#Empty(): Set Box)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(##node#2, i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7 && i#7 < Seq#Length(KMBtreeModel.Node.children(##node#2)) - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(##node#2, i#7)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(##node#2, i#8) } 
                true
                   ==> 
                  0 < i#8 && i#8 < Seq#Length(KMBtreeModel.Node.children(##node#2))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(##node#2, i#8)));
        assume KMBtreeModel.__default.WF($LS($LZ), ##node#2);
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
        assume KMBtree.__default.Interpretation($Heap, node#0)
           == KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
        assume KMBtree.__default.I#canCall($Heap, node#0)
           && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
        // CheckWellformedWithResult: any expression
        assume $Is(KMBtree.__default.Interpretation($Heap, node#0), 
          TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()));
        assume b$reqreads#2;
        assume b$reqreads#3;
    }
}



// function declaration for KMBtree._default.ToSeq
function KMBtree.__default.ToSeq($heap: Heap, node#0: ref) : DatatypeType;

function KMBtree.__default.ToSeq#canCall($heap: Heap, node#0: ref) : bool;

// frame axiom for KMBtree.__default.ToSeq
axiom (forall $h0: Heap, $h1: Heap, node#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.ToSeq($h1, node#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.ToSeq#canCall($h0, node#0)
         || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($h0, node#0, KMBtree.Node.repr)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.ToSeq($h0, node#0) == KMBtree.__default.ToSeq($h1, node#0));

// consequence axiom for KMBtree.__default.ToSeq
axiom 26 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.ToSeq($Heap, node#0) } 
    KMBtree.__default.ToSeq#canCall($Heap, node#0)
         || (26 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && KMBtree.__default.WF($Heap, node#0))
       ==> $Is(KMBtree.__default.ToSeq($Heap, node#0), 
        Tclass._System.Tuple2(TSeq(TSeq(Tclass.NativeTypes.byte())), TSeq(Tclass.ValueMessage.Message()))));

function KMBtree.__default.ToSeq#requires(Heap, ref) : bool;

// #requires axiom for KMBtree.__default.ToSeq
axiom (forall $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.ToSeq#requires($Heap, node#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.ToSeq#requires($Heap, node#0)
       == KMBtree.__default.WF($Heap, node#0));

// definition axiom for KMBtree.__default.ToSeq(revealed)
axiom 26 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.ToSeq($Heap, node#0) } 
    KMBtree.__default.ToSeq#canCall($Heap, node#0)
         || (26 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && KMBtree.__default.WF($Heap, node#0))
       ==> KMBtree.__default.I#canCall($Heap, node#0)
         && KMBtreeModel.__default.ToSeq#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         && KMBtree.__default.ToSeq($Heap, node#0)
           == KMBtreeModel.__default.ToSeq(StartFuel_KMBtreeModel._default.ToSeq, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));

procedure CheckWellformed$$KMBtree.__default.ToSeq(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()))
   returns (kvlists#0: DatatypeType
       where $Is(kvlists#0, 
        Tclass._System.Tuple2(TSeq(TSeq(Tclass.NativeTypes.byte())), TSeq(Tclass.ValueMessage.Message()))));
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.ToSeq(node#0: ref) returns (kvlists#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##node#1: ref;
  var ##node#2: DatatypeType;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;

    // AddWellformednessCheck for function ToSeq
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](262,11): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == ##node#0 || read($Heap, ##node#0, KMBtree.Node.repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume b$reqreads#0;
    assume node#0 != null;
    b$reqreads#1 := $_Frame[node#0, KMBtree.Node.repr];
    assume b$reqreads#1;
    assume node#0 != null;
    if (*)
    {
        assume $Is(KMBtree.__default.ToSeq($Heap, node#0), 
          Tclass._System.Tuple2(TSeq(TSeq(Tclass.NativeTypes.byte())), TSeq(Tclass.ValueMessage.Message())));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
        ##node#1 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#1);
        b$reqreads#2 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == ##node#1 || read($Heap, ##node#1, KMBtree.Node.repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        ##node#2 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#2, Tclass.KMBtreeModel.Node(), $Heap);
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Seq#Length(KMBtreeModel.Node.keys(##node#2))
                 == Seq#Length(KMBtreeModel.Node.values(##node#2)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(##node#2)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Seq#Length(KMBtreeModel.Node.pivots(##node#2))
                 == Seq#Length(KMBtreeModel.Node.children(##node#2)) - 1);
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(##node#2)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5 && i#5 < Seq#Length(KMBtreeModel.Node.children(##node#2))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#5)): DatatypeType)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6 && i#6 < Seq#Length(KMBtreeModel.Node.children(##node#2))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#2), i#6)): DatatypeType), 
                    Set#Empty(): Set Box)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(##node#2, i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7 && i#7 < Seq#Length(KMBtreeModel.Node.children(##node#2)) - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(##node#2, i#7)));
        assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#2)
           ==> KMBtreeModel.__default.WF($LS($LZ), ##node#2)
             || (!KMBtreeModel.Node.Leaf_q(##node#2)
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(##node#2, i#8) } 
                true
                   ==> 
                  0 < i#8 && i#8 < Seq#Length(KMBtreeModel.Node.children(##node#2))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(##node#2, i#8)));
        assume KMBtreeModel.__default.WF($LS($LZ), ##node#2);
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume KMBtreeModel.__default.ToSeq#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
        assume _System.Tuple2.___hMake2_q(KMBtreeModel.__default.ToSeq(StartFuel_KMBtreeModel._default.ToSeq, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));
        assume KMBtree.__default.ToSeq($Heap, node#0)
           == KMBtreeModel.__default.ToSeq(StartFuel_KMBtreeModel._default.ToSeq, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
        assume KMBtree.__default.I#canCall($Heap, node#0)
           && KMBtreeModel.__default.ToSeq#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
        // CheckWellformedWithResult: any expression
        assume $Is(KMBtree.__default.ToSeq($Heap, node#0), 
          Tclass._System.Tuple2(TSeq(TSeq(Tclass.NativeTypes.byte())), TSeq(Tclass.ValueMessage.Message())));
        assume KMBtree.__default.ToSeq($Heap, node#0) == kvlists#0;
        assume b$reqreads#2;
        assume b$reqreads#3;
    }
}



function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

procedure CheckWellformed$$KMBtree.__default.QueryLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 28 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.QueryLeaf(node#0: ref, needle#0: Seq Box) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: QueryLeaf, CheckWellformed$$KMBtree.__default.QueryLeaf
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](269,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](272,19): post-state"} true;
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    ##m#0 := KMBtree.__default.Interpretation($Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := needle#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
    assume Options.Option#Equal(result#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)));
}



procedure Call$$KMBtree.__default.QueryLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#1)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#1))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#1 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#9: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
                  LitInt(0) <= i#9 && i#9 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#9 && i#9 < nchildren#1
                     ==> $Unbox(read($Heap, children#1, IndexField(i#9))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#10: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#10))): ref } 
                  LitInt(0) <= i#10 && i#10 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#10 && i#10 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#10))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#11: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#11))): ref } 
                  LitInt(0) <= i#11 && i#11 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#11 && i#11 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> (forall i#13: int :: 
                    { $Unbox(read($Heap, children#1, IndexField(i#13))): ref } 
                    LitInt(0) <= i#13 && i#13 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#13 && i#13 < nchildren#1
                       ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#13))): ref, KMBtree.Node.repr)[$Box(children#1)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#14: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#14)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#14
                   && i#14
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#14)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#15: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#15)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#15
                   && i#15
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#15)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#16: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16) } 
              true
                 ==> 
                LitInt(0) <= i#16
                   && i#16
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#17: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17) } 
              true
                 ==> 
                0 < i#17
                   && i#17
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17))));
  requires KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(result#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)))
     && 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
  ensures Options.Option#Equal(result#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.QueryLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 28 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(result#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)))
     && 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(result#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.QueryLeaf(node#0: ref, needle#0: Seq Box)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var posplus1#0: int
     where LitInt(0) <= posplus1#0 && posplus1#0 < 18446744073709551616;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var run##0: ref;
  var start##0: int;
  var newtype$check#0: int;
  var end##0: int;
  var needle##0: Seq Box;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

    // AddMethodImpl: QueryLeaf, Impl$$KMBtree.__default.QueryLeaf
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](274,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](275,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](275,14)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](276,32)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__Interpretation();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](276,33)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](277,64)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    start##0 := LitInt(0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    end##0 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := needle#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$Lexicographic__Byte__Order__Impl.__default.ArrayLargestLtePlus1(run##0, start##0, end##0, needle##0);
    // TrCallStmt: After ProcessCallStmt
    posplus1#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](277,115)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](278,5)
    newtype$check#1 := LitInt(1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    if (LitInt(1) <= posplus1#0)
    {
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#2 := LitInt(1);
        assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := posplus1#0 - 1;
        assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assume 0 <= posplus1#0 - 1
           && posplus1#0 - 1
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    }

    assume true;
    if (LitInt(1) <= posplus1#0
       && Seq#Equal($Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(posplus1#0 - 1))): Seq Box, 
        needle#0))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](279,14)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#0_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := posplus1#0 - 1;
        assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume 0 <= posplus1#0 - 1
           && posplus1#0 - 1
             < _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        result#0 := #Options.Option.Some(read($Heap, 
            KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(posplus1#0 - 1)));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](279,54)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](281,14)
        assume true;
        assume true;
        result#0 := Lit(#Options.Option.None());
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](281,20)"} true;
    }
}



procedure CheckWellformed$$KMBtree.__default.QueryIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 29 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.QueryIndex(node#0: ref, needle#0: Seq Box) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: QueryIndex, CheckWellformed$$KMBtree.__default.QueryIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](285,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](288,19): post-state"} true;
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    ##m#0 := KMBtree.__default.Interpretation($Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := needle#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
    assume Options.Option#Equal(result#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)));
}



procedure Call$$KMBtree.__default.QueryIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#1)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#1))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#1 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#9: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
                  LitInt(0) <= i#9 && i#9 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#9 && i#9 < nchildren#1
                     ==> $Unbox(read($Heap, children#1, IndexField(i#9))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#10: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#10))): ref } 
                  LitInt(0) <= i#10 && i#10 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#10 && i#10 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#10))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#11: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#11))): ref } 
                  LitInt(0) <= i#11 && i#11 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#11 && i#11 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> (forall i#13: int :: 
                    { $Unbox(read($Heap, children#1, IndexField(i#13))): ref } 
                    LitInt(0) <= i#13 && i#13 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#13 && i#13 < nchildren#1
                       ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#13))): ref, KMBtree.Node.repr)[$Box(children#1)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#14: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#14)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#14
                   && i#14
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#14)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#15: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#15)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#15
                   && i#15
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#15)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#16: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16) } 
              true
                 ==> 
                LitInt(0) <= i#16
                   && i#16
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#17: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17) } 
              true
                 ==> 
                0 < i#17
                   && i#17
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(result#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)))
     && 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
  ensures Options.Option#Equal(result#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.QueryIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 29 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(result#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)))
     && 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(result#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.QueryIndex(node#0: ref, needle#0: Seq Box)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var posplus1#0: int
     where LitInt(0) <= posplus1#0 && posplus1#0 < 18446744073709551616;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var run##0: ref;
  var start##0: int;
  var newtype$check#0: int;
  var end##0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var needle##0: Seq Box;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var $rhs##1: DatatypeType
     where $Is($rhs##1, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##1, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##0: ref;
  var needle##1: Seq Box;
  var node##0_0: DatatypeType;
  var ##node#0_0: ref;
  var key##0_0: Seq Box;

    // AddMethodImpl: QueryIndex, Impl$$KMBtree.__default.QueryIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](290,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](291,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](291,14)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](292,32)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__Interpretation();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](292,33)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](293,25)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__AllKeys();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](293,26)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](294,64)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    start##0 := LitInt(0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#1 := LitInt(1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    newtype$check#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    end##0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := needle#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$Lexicographic__Byte__Order__Impl.__default.ArrayLargestLtePlus1(run##0, start##0, end##0, needle##0);
    // TrCallStmt: After ProcessCallStmt
    posplus1#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](294,123)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](295,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](296,20)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= posplus1#0
       && posplus1#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is($Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(posplus1#0))): ref, 
      Tclass.KMBtree.Node());
    node##0 := $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(posplus1#0))): ref;
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##1 := needle#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    assume 0 <= LitInt(0)
       || (Set#Subset(read($Heap, node##0, KMBtree.Node.repr), 
          read(old($Heap), node#0, KMBtree.Node.repr))
         && !Set#Subset(read(old($Heap), node#0, KMBtree.Node.repr), 
          read($Heap, node##0, KMBtree.Node.repr)))
       || LitInt(1) == LitInt(0);
    assume (Set#Subset(read($Heap, node##0, KMBtree.Node.repr), 
          read(old($Heap), node#0, KMBtree.Node.repr))
         && !Set#Subset(read(old($Heap), node#0, KMBtree.Node.repr), 
          read($Heap, node##0, KMBtree.Node.repr)))
       || (Set#Equal(read($Heap, node##0, KMBtree.Node.repr), 
          read(old($Heap), node#0, KMBtree.Node.repr))
         && LitInt(1) < LitInt(0));
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$KMBtree.__default.Query(node##0, needle##1);
    // TrCallStmt: After ProcessCallStmt
    result#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](296,61)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](297,5)
    assume true;
    if (Options.Option.Some_q(result#0))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](298,37)
        // TrCallStmt: Before ProcessCallStmt
        ##node#0_0 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_0, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        node##0_0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0_0 := needle#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.InterpretationDelegation(node##0_0, key##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](298,53)"} true;
    }
    else
    {
    }
}



procedure CheckWellformed$$KMBtree.__default.Query(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 29 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.Query(node#0: ref, needle#0: Seq Box) returns (result#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: Query, CheckWellformed$$KMBtree.__default.Query
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](302,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](304,19): post-state"} true;
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    ##m#0 := KMBtree.__default.Interpretation($Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := needle#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
    assume Options.Option#Equal(result#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)));
}



procedure Call$$KMBtree.__default.Query(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#1)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#1))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#1 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#9: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
                  LitInt(0) <= i#9 && i#9 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#9 && i#9 < nchildren#1
                     ==> $Unbox(read($Heap, children#1, IndexField(i#9))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#10: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#10))): ref } 
                  LitInt(0) <= i#10 && i#10 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#10 && i#10 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#10))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#11: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#11))): ref } 
                  LitInt(0) <= i#11 && i#11 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#11 && i#11 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> (forall i#13: int :: 
                    { $Unbox(read($Heap, children#1, IndexField(i#13))): ref } 
                    LitInt(0) <= i#13 && i#13 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#13 && i#13 < nchildren#1
                       ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#13))): ref, KMBtree.Node.repr)[$Box(children#1)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#14: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#14)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#14
                   && i#14
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#14)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#15: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#15)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#15
                   && i#15
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#15)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#16: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16) } 
              true
                 ==> 
                LitInt(0) <= i#16
                   && i#16
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#17: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17) } 
              true
                 ==> 
                0 < i#17
                   && i#17
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(result#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)))
     && 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
  ensures Options.Option#Equal(result#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.Query(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (result#0: DatatypeType
       where $Is(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(result#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 29 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(result#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)))
     && 
    KMBtree.__default.Interpretation#canCall($Heap, node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation($Heap, node#0), 
      $Box(needle#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(result#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation($Heap, node#0), 
        $Box(needle#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.Query(node#0: ref, needle#0: Seq Box)
   returns (result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var _mcc#3#0_0: int;
  var _mcc#4#0_0: ref;
  var _mcc#5#0_0: ref;
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##0_0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##0_0: ref;
  var needle##0_0: Seq Box;
  var _mcc#0#1_0: int;
  var _mcc#1#1_0: ref;
  var _mcc#2#1_0: ref;
  var $rhs##1_0: DatatypeType
     where $Is($rhs##1_0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##1_0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##1_0: ref;
  var needle##1_0: Seq Box;

    // AddMethodImpl: Query, Impl$$KMBtree.__default.Query
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](306,2): initial state"} true;
    $_reverifyPost := false;
    assume node#0 != null;
    assume true;
    havoc _mcc#3#0_0, _mcc#4#0_0, _mcc#5#0_0;
    havoc _mcc#0#1_0, _mcc#1#1_0, _mcc#2#1_0;
    if (read($Heap, node#0, KMBtree.Node.contents)
       == #KMBtree.NodeContents.Leaf(_mcc#0#1_0, _mcc#1#1_0, _mcc#2#1_0))
    {
        assume LitInt(0) <= _mcc#0#1_0 && _mcc#0#1_0 < 18446744073709551616;
        assume $Is(_mcc#1#1_0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
           && $IsAlloc(_mcc#1#1_0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume $Is(_mcc#2#1_0, Tclass._System.array(Tclass.ValueMessage.Message()))
           && $IsAlloc(_mcc#2#1_0, Tclass._System.array(Tclass.ValueMessage.Message()), $Heap);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](308,48)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##1_0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        needle##1_0 := needle#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##1_0 := Call$$KMBtree.__default.QueryLeaf(node##1_0, needle##1_0);
        // TrCallStmt: After ProcessCallStmt
        result#0 := $rhs##1_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](308,61)"} true;
    }
    else if (read($Heap, node#0, KMBtree.Node.contents)
       == #KMBtree.NodeContents.Index(_mcc#3#0_0, _mcc#4#0_0, _mcc#5#0_0))
    {
        assume LitInt(0) <= _mcc#3#0_0 && _mcc#3#0_0 < 18446744073709551616;
        assume $Is(_mcc#4#0_0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
           && $IsAlloc(_mcc#4#0_0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
        assume $Is(_mcc#5#0_0, Tclass._System.array(Tclass.KMBtree.Node?()))
           && $IsAlloc(_mcc#5#0_0, Tclass._System.array(Tclass.KMBtree.Node?()), $Heap);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](309,50)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0_0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        needle##0_0 := needle#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume 0 <= LitInt(1)
           || (Set#Subset(read($Heap, node##0_0, KMBtree.Node.repr), 
              read(old($Heap), node#0, KMBtree.Node.repr))
             && !Set#Subset(read(old($Heap), node#0, KMBtree.Node.repr), 
              read($Heap, node##0_0, KMBtree.Node.repr)))
           || LitInt(0) == LitInt(1);
        assume (Set#Subset(read($Heap, node##0_0, KMBtree.Node.repr), 
              read(old($Heap), node#0, KMBtree.Node.repr))
             && !Set#Subset(read(old($Heap), node#0, KMBtree.Node.repr), 
              read($Heap, node##0_0, KMBtree.Node.repr)))
           || (Set#Equal(read($Heap, node##0_0, KMBtree.Node.repr), 
              read(old($Heap), node#0, KMBtree.Node.repr))
             && LitInt(0) < LitInt(1));
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$KMBtree.__default.QueryIndex(node##0_0, needle##0_0);
        // TrCallStmt: After ProcessCallStmt
        result#0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](309,63)"} true;
    }
    else
    {
        assume false;
    }
}



procedure CheckWellformed$$KMBtree.__default.Empty(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: bool);
  free requires 30 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.Empty(node#0: ref) returns (result#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;

    // AddMethodImpl: Empty, CheckWellformed$$KMBtree.__default.Empty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](313,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](315,19): post-state"} true;
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume result#0
       == 
      (Map#Card(KMBtree.__default.Interpretation($Heap, node#0))
       == LitInt(0));
}



procedure Call$$KMBtree.__default.Empty(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: bool);
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#1)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#1))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#1 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#9: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
                  LitInt(0) <= i#9 && i#9 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#9 && i#9 < nchildren#1
                     ==> $Unbox(read($Heap, children#1, IndexField(i#9))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#10: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#10))): ref } 
                  LitInt(0) <= i#10 && i#10 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#10 && i#10 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#10))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#11: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#11))): ref } 
                  LitInt(0) <= i#11 && i#11 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#11 && i#11 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                    LitInt(0) <= i#12 && i#12 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#12 && i#12 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
                   ==> (forall i#13: int :: 
                    { $Unbox(read($Heap, children#1, IndexField(i#13))): ref } 
                    LitInt(0) <= i#13 && i#13 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#13 && i#13 < nchildren#1
                       ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#13))): ref, KMBtree.Node.repr)[$Box(children#1)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#14: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#14)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#14
                   && i#14
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#14)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#15: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#15)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#15
                   && i#15
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#15)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#16: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16) } 
              true
                 ==> 
                LitInt(0) <= i#16
                   && i#16
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#16))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#17: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17) } 
              true
                 ==> 
                0 < i#17
                   && i#17
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#17))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.Interpretation#canCall($Heap, node#0);
  ensures result#0
     == 
    (Map#Card(KMBtree.__default.Interpretation($Heap, node#0))
     == LitInt(0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.Empty(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: bool, $_reverifyPost: bool);
  free requires 30 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.Interpretation#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> result#0
       == 
      (Map#Card(KMBtree.__default.Interpretation($Heap, node#0))
       == LitInt(0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.Empty(node#0: ref) returns (result#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0_0: int;
  var ##node#0_0: ref;
  var node##0: DatatypeType;
  var ##node#2: ref;

    // AddMethodImpl: Empty, Impl$$KMBtree.__default.Empty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](316,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](317,5)
    assume node#0 != null;
    assume true;
    if (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents)))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](318,34)
        // TrCallStmt: Before ProcessCallStmt
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.reveal__Interpretation();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](318,35)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](319,14)
        assume true;
        newtype$check#0_0 := LitInt(0);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        result#0 := LitInt(0)
           == KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](319,40)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](320,7)
        if (!result#0)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
            assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
            assume {:subsumption 0} 0 <= LitInt(0)
               && LitInt(0)
                 < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
            ##node#0_0 := node#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##node#0_0, Tclass.KMBtree.Node(), $Heap);
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> Set#Equal(read($Heap, ##node#0_0, KMBtree.Node.repr), 
                        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#0_0)), 
                            $Box(KMBtree.NodeContents.keys(read($Heap, ##node#0_0, KMBtree.Node.contents)))), 
                          $Box(KMBtree.NodeContents.values(read($Heap, ##node#0_0, KMBtree.Node.contents)))))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
                        Tclass.ValueMessage.Message(), 
                        KMBtree.NodeContents.keys(read($Heap, ##node#0_0, KMBtree.Node.contents)), 
                        KMBtree.NodeContents.values(read($Heap, ##node#0_0, KMBtree.Node.contents)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> read($Heap, ##node#0_0, KMBtree.Node.height) == LitInt(0)));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> LitInt(0)
                         <= KMBtree.NodeContents.nkeys(read($Heap, ##node#0_0, KMBtree.Node.contents))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> KMBtree.NodeContents.nkeys(read($Heap, ##node#0_0, KMBtree.Node.contents))
                         <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
                         == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#0_0, KMBtree.Node.contents)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, ##node#0_0, KMBtree.Node.contents)))
                         == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#0_0, KMBtree.Node.contents)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> Lit(true)));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        Lit(true))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#0_0)), 
                                $Box(KMBtree.NodeContents.pivots(read($Heap, ##node#0_0, KMBtree.Node.contents)))), 
                              $Box(children#0_0)), 
                            read($Heap, ##node#0_0, KMBtree.Node.repr))))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          0 < nchildren#0_0))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          nchildren#0_0 <= LitInt(KMBtree.__default.MaxChildren())))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#0_0)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, ##node#0_0, KMBtree.Node.contents)))
                             == LitInt(KMBtree.__default.MaxChildren() - 1)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          (forall i#0_0: int :: 
                            { $Unbox(read($Heap, children#0_0, IndexField(i#0_0))): ref } 
                            LitInt(0) <= i#0_0 && i#0_0 < 18446744073709551616
                               ==> 
                              LitInt(0) <= i#0_0 && i#0_0 < nchildren#0_0
                               ==> $Unbox(read($Heap, children#0_0, IndexField(i#0_0))): ref != null)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                            $Heap, 
                            Seq#Take(Seq#FromArray($Heap, children#0_0), nchildren#0_0), 
                            read($Heap, ##node#0_0, KMBtree.Node.repr), 
                            read($Heap, ##node#0_0, KMBtree.Node.height))))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          (forall i#0_1: int :: 
                            { $Unbox(read($Heap, children#0_0, IndexField(i#0_1))): ref } 
                            LitInt(0) <= i#0_1 && i#0_1 < 18446744073709551616
                               ==> 
                              LitInt(0) <= i#0_1 && i#0_1 < nchildren#0_0
                               ==> !read($Heap, 
                                $Unbox(read($Heap, children#0_0, IndexField(i#0_1))): ref, 
                                KMBtree.Node.repr)[$Box(##node#0_0)])))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          (forall i#0_2: int :: 
                            { $Unbox(read($Heap, children#0_0, IndexField(i#0_2))): ref } 
                            LitInt(0) <= i#0_2 && i#0_2 < 18446744073709551616
                               ==> 
                              LitInt(0) <= i#0_2 && i#0_2 < nchildren#0_0
                               ==> !read($Heap, 
                                $Unbox(read($Heap, children#0_0, IndexField(i#0_2))): ref, 
                                KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, ##node#0_0, KMBtree.Node.contents)))])))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          (forall i#0_3: int :: 
                              { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#0_0), nchildren#0_0), i#0_3)): ref } 
                                { $Unbox(read($Heap, children#0_0, IndexField(i#0_3))): ref } 
                              LitInt(0) <= i#0_3 && i#0_3 < 18446744073709551616
                                 ==> 
                                LitInt(0) <= i#0_3 && i#0_3 < nchildren#0_0
                                 ==> $Unbox(read($Heap, children#0_0, IndexField(i#0_3))): ref
                                   == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#0_0), nchildren#0_0), i#0_3)): ref)
                             ==> Lit(true)))));
            assume {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtree.__default.WFShape#canCall($Heap, ##node#0_0)
                   ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0)
                     || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#0_0, KMBtree.Node.contents))
                       ==> (var nchildren#0_0 := KMBtree.NodeContents.nchildren(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                        (var children#0_0 := KMBtree.NodeContents.children(read($Heap, ##node#0_0, KMBtree.Node.contents)); 
                          (forall i#0_3: int :: 
                              { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#0_0), nchildren#0_0), i#0_3)): ref } 
                                { $Unbox(read($Heap, children#0_0, IndexField(i#0_3))): ref } 
                              LitInt(0) <= i#0_3 && i#0_3 < 18446744073709551616
                                 ==> 
                                LitInt(0) <= i#0_3 && i#0_3 < nchildren#0_0
                                 ==> $Unbox(read($Heap, children#0_0, IndexField(i#0_3))): ref
                                   == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#0_0), nchildren#0_0), i#0_3)): ref)
                             ==> (forall i#0_4: int :: 
                              { $Unbox(read($Heap, children#0_0, IndexField(i#0_4))): ref } 
                              LitInt(0) <= i#0_4 && i#0_4 < 18446744073709551616
                                 ==> 
                                LitInt(0) <= i#0_4 && i#0_4 < nchildren#0_0
                                 ==> !read($Heap, 
                                  $Unbox(read($Heap, children#0_0, IndexField(i#0_4))): ref, 
                                  KMBtree.Node.repr)[$Box(children#0_0)])))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                         == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                        KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                         == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                           - 1));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                        KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> (forall i#0_5: int :: 
                        { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)), 
                              i#0_5)): DatatypeType } 
                        true
                           ==> 
                          LitInt(0) <= i#0_5
                             && i#0_5
                               < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                           ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)), 
                                i#0_5)): DatatypeType))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> (forall i#0_6: int :: 
                        { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)), 
                              i#0_6)): DatatypeType } 
                        true
                           ==> 
                          LitInt(0) <= i#0_6
                             && i#0_6
                               < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                           ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)), 
                                  i#0_6)): DatatypeType), 
                            Set#Empty(): Set Box))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> (forall i#0_7: int :: 
                        { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0), 
                            i#0_7) } 
                        true
                           ==> 
                          LitInt(0) <= i#0_7
                             && i#0_7
                               < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                                 - 1
                           ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0), 
                            i#0_7))));
            assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#0_0)
               ==> KMBtree.__default.WF($Heap, ##node#0_0)
                 || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                   ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                     || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#0_0))
                       ==> (forall i#0_8: int :: 
                        { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0), 
                            i#0_8) } 
                        true
                           ==> 
                          0 < i#0_8
                             && i#0_8
                               < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0)))
                           ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#0_0), 
                            i#0_8))));
            assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
        }

        assume !result#0 ==> KMBtree.__default.Interpretation#canCall($Heap, node#0);
        assume true;
        assume !result#0
           ==> Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(LitInt(0)))];
    }
    else
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](322,28)
        // TrCallStmt: Before ProcessCallStmt
        ##node#2 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#2);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        node##0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.IndexesNonempty(node##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](322,36)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](323,14)
        assume true;
        assume true;
        result#0 := Lit(false);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](323,21)"} true;
    }
}



procedure CheckWellformed$$KMBtree.__default.MinKeyInternal(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 31 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.MinKeyInternal(node#0: ref) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: DatatypeType;

    // AddMethodImpl: MinKeyInternal, CheckWellformed$$KMBtree.__default.MinKeyInternal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](327,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](330,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#2);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#3 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#3))
             == Seq#Length(KMBtreeModel.Node.values(##node#3)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#3)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#3))
             == Seq#Length(KMBtreeModel.Node.children(##node#3)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#3)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#14: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#14)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#14 && i#14 < Seq#Length(KMBtreeModel.Node.children(##node#3))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#14)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#15: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#15)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#15 && i#15 < Seq#Length(KMBtreeModel.Node.children(##node#3))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#15)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#16: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#3, i#16) } 
            true
               ==> 
              LitInt(0) <= i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(##node#3)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#3, i#16)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#17: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#3, i#17) } 
            true
               ==> 
              0 < i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(##node#3))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#3, i#17)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#3);
    assert {:subsumption 0} 0
       < Map#Card(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, ##node#3));
    assume 0
       < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, ##node#3));
    assume KMBtreeModel.__default.MinKey#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume Seq#Equal(result#0, 
      KMBtreeModel.__default.MinKey($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));
}



procedure Call$$KMBtree.__default.MinKeyInternal(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#2)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#2))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#2 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#18))): ref } 
                  LitInt(0) <= i#18 && i#18 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#18 && i#18 < nchildren#2
                     ==> $Unbox(read($Heap, children#2, IndexField(i#18))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#19: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#20: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#20))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#21))): ref } 
                    LitInt(0) <= i#21 && i#21 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#21 && i#21 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#21))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#21))): ref } 
                    LitInt(0) <= i#21 && i#21 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#21 && i#21 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#21))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref)
                   ==> (forall i#22: int :: 
                    { $Unbox(read($Heap, children#2, IndexField(i#22))): ref } 
                    LitInt(0) <= i#22 && i#22 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#22 && i#22 < nchildren#2
                       ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#22))): ref, KMBtree.Node.repr)[$Box(children#2)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#23)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#23)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#24: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#24)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#24
                   && i#24
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#24)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#25: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#25) } 
              true
                 ==> 
                LitInt(0) <= i#25
                   && i#25
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#25))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#26: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#26) } 
              true
                 ==> 
                0 < i#26
                   && i#26
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#26))));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.MinKey#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures Seq#Equal(result#0, 
    KMBtreeModel.__default.MinKey($LS($LS($LZ)), 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.MinKeyInternal(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 31 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.MinKey#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures $_reverifyPost
     ==> Seq#Equal(result#0, 
      KMBtreeModel.__default.MinKey($LS($LS($LZ)), 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.MinKeyInternal(node#0: ref) returns (result#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0_0: int;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var node##0: ref;
  var childidx##0: int;
  var ##node#4: ref;
  var node##1: DatatypeType;
  var ##node#5: ref;
  var i##0: int;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var node##2: ref;

    // AddMethodImpl: MinKeyInternal, Impl$$KMBtree.__default.MinKeyInternal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](332,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](333,5)
    assume node#0 != null;
    assume true;
    if (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents)))
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](334,7)
        newtype$check#0_0 := LitInt(0);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](334,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](335,36)
            // TrCallStmt: Before ProcessCallStmt
            assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            free call Call$$KMBtreeModel.__default.reveal__Interpretation();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](335,37)"} true;
            assume 0 < KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
            assume false;
        }

        assume 0 < KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](337,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume {:subsumption 0} 0 <= LitInt(0)
           && LitInt(0)
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume {:subsumption 0} 0 <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
             <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume {:subsumption 0} 0 <= LitInt(0)
           && LitInt(0)
             < Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
                KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
        assume true;
        assume Seq#Equal($Unbox(read($Heap, 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(LitInt(0)))): Seq Box, 
          $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
                KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
              LitInt(0))): Seq Box);
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](338,14)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume 0 <= LitInt(0)
           && LitInt(0)
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        result#0 := $Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(LitInt(0)))): Seq Box;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](338,37)"} true;
    }
    else
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](340,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume {:subsumption 0} node#0 != null;
        assume {:subsumption 0} node#0 != null;
        assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          TSeq(Tclass.KMBtree.Node()));
        ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
        // assume allocatedness for argument to function
        assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
        ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
        // assume allocatedness for argument to function
        assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
        ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
        // assume allocatedness for argument to function
        assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
        assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
          $Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](341,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0 := LitInt(0);
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##0, childidx##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](341,23)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](342,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} 0 <= LitInt(0)
           && LitInt(0)
             < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume $Is($Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(LitInt(0)))): ref, 
          Tclass.KMBtree.Node());
        ##node#4 := $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(LitInt(0)))): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#4, Tclass.KMBtree.Node(), $Heap);
        assume KMBtree.__default.WF#canCall($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(LitInt(0)))): ref);
        assume KMBtree.__default.WF#canCall($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(LitInt(0)))): ref);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WF($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(LitInt(0)))): ref);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](343,33)
        // TrCallStmt: Before ProcessCallStmt
        ##node#5 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#5);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        node##1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        assume $Is(LitInt(0), Tclass._System.nat());
        i##0 := LitInt(0);
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.ChildOfIndexNonempty(node##1, i##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](343,44)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](344,31)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Key
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        assume 0 <= LitInt(0)
           && LitInt(0)
             < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        // ProcessCallStmt: CheckSubrange
        assume $Is($Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(LitInt(0)))): ref, 
          Tclass.KMBtree.Node());
        node##2 := $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(LitInt(0)))): ref;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume Set#Subset(read($Heap, node##2, KMBtree.Node.repr), 
            read(old($Heap), node#0, KMBtree.Node.repr))
           && !Set#Subset(read(old($Heap), node#0, KMBtree.Node.repr), 
            read($Heap, node##2, KMBtree.Node.repr));
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$KMBtree.__default.MinKeyInternal(node##2);
        // TrCallStmt: After ProcessCallStmt
        result#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](344,57)"} true;
    }
}



procedure CheckWellformed$$KMBtree.__default.MinKey(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 32 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.MinKey(node#0: ref) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var key#0: Seq Box;
  var ##node#3: ref;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;

    // AddMethodImpl: MinKey, CheckWellformed$$KMBtree.__default.MinKey
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](351,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](354,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#14: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                      i#14)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#14
                     && i#14
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                        i#14)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#15: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                      i#15)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#15
                     && i#15
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                          i#15)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#16: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#16) } 
                true
                   ==> 
                  LitInt(0) <= i#16
                     && i#16
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#16))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#17: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#17) } 
                true
                   ==> 
                  0 < i#17
                     && i#17
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#17))));
    assume KMBtree.__default.WF($Heap, ##node#2);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(result#0)];
    havoc key#0;
    assume $Is(key#0, TSeq(Tclass.NativeTypes.byte()));
    if (*)
    {
        ##node#3 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                     == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                    KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                     == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       - 1));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                    KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#23: int :: 
                    { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                          i#23)): DatatypeType } 
                    true
                       ==> 
                      LitInt(0) <= i#23
                         && i#23
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                        $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                            i#23)): DatatypeType))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#24: int :: 
                    { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                          i#24)): DatatypeType } 
                    true
                       ==> 
                      LitInt(0) <= i#24
                         && i#24
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                              i#24)): DatatypeType), 
                        Set#Empty(): Set Box))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#25: int :: 
                    { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#25) } 
                    true
                       ==> 
                      LitInt(0) <= i#25
                         && i#25
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                             - 1
                       ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#25))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#26: int :: 
                    { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#26) } 
                    true
                       ==> 
                      0 < i#26
                         && i#26
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#26))));
        assume KMBtree.__default.WF($Heap, ##node#3);
        assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
        assume Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#0)];
        ##a#0 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        ##b#0 := key#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume Lexicographic__Byte__Order.__default.lte#canCall(result#0, key#0);
        assume Lexicographic__Byte__Order.__default.lte(result#0, key#0);
    }
    else
    {
        assume Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#0)]
           ==> Lexicographic__Byte__Order.__default.lte(result#0, key#0);
    }

    assume (forall key#1: Seq Box :: 
      { Lexicographic__Byte__Order.__default.lte(result#0, key#1) } 
        { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
      $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
           && Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
         ==> Lexicographic__Byte__Order.__default.lte(result#0, key#1));
}



procedure Call$$KMBtree.__default.MinKey(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#27: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#27))): ref } 
                  LitInt(0) <= i#27 && i#27 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#27 && i#27 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#27))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#28: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#29: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#29))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#30: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#30))): ref } 
                    LitInt(0) <= i#30 && i#30 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#30 && i#30 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#30))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#30: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#30))): ref } 
                    LitInt(0) <= i#30 && i#30 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#30 && i#30 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#30))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref)
                   ==> (forall i#31: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#31))): ref } 
                    LitInt(0) <= i#31 && i#31 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#31 && i#31 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#31))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#32: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#32)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#32
                   && i#32
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#32)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#33: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#33)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#33
                   && i#33
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#33)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#34: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#34) } 
              true
                 ==> 
                LitInt(0) <= i#34
                   && i#34
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#34))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#35: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#35) } 
              true
                 ==> 
                0 < i#35
                   && i#35
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#35))));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.Interpretation#canCall($Heap, node#0);
  ensures Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(result#0)];
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(result#0, key#1) } 
      { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
       ==> KMBtree.__default.Interpretation#canCall($Heap, node#0)
         && (Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
           ==> Lexicographic__Byte__Order.__default.lte#canCall(result#0, key#1)));
  ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(result#0, key#1) } 
      { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
         && Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
       ==> Lexicographic__Byte__Order.__default.lte(result#0, key#1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.MinKey(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 32 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.Interpretation#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(result#0)];
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(result#0, key#1) } 
      { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
       ==> KMBtree.__default.Interpretation#canCall($Heap, node#0)
         && (Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
           ==> Lexicographic__Byte__Order.__default.lte#canCall(result#0, key#1)));
  ensures $_reverifyPost
     ==> (forall key#1: Seq Box :: 
      { Lexicographic__Byte__Order.__default.lte(result#0, key#1) } 
        { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
      $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
           && Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
         ==> Lexicographic__Byte__Order.__default.lte(result#0, key#1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.MinKey(node#0: ref) returns (result#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var node##0: ref;
  var node##1: DatatypeType;
  var ##node#4: ref;

    // AddMethodImpl: MinKey, Impl$$KMBtree.__default.MinKey
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](356,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](357,29)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Key
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := node#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.MinKeyInternal(node##0);
    // TrCallStmt: After ProcessCallStmt
    result#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](357,34)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](358,27)
    // TrCallStmt: Before ProcessCallStmt
    ##node#4 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#4);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    // ProcessCallStmt: CheckSubrange
    node##1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.MinKeyProperties(node##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](358,35)"} true;
}



procedure CheckWellformed$$KMBtree.__default.MaxKeyInternal(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.MaxKeyInternal(node#0: ref) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: DatatypeType;

    // AddMethodImpl: MaxKeyInternal, CheckWellformed$$KMBtree.__default.MaxKeyInternal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](361,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](364,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#2);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#3 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#3))
             == Seq#Length(KMBtreeModel.Node.values(##node#3)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#3)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#3))
             == Seq#Length(KMBtreeModel.Node.children(##node#3)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#3)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#14: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#14)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#14 && i#14 < Seq#Length(KMBtreeModel.Node.children(##node#3))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#14)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#15: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#15)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#15 && i#15 < Seq#Length(KMBtreeModel.Node.children(##node#3))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#3), i#15)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#16: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#3, i#16) } 
            true
               ==> 
              LitInt(0) <= i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(##node#3)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#3, i#16)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#3)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#3)
         || (!KMBtreeModel.Node.Leaf_q(##node#3)
           ==> (forall i#17: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#3, i#17) } 
            true
               ==> 
              0 < i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(##node#3))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#3, i#17)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#3);
    assert {:subsumption 0} 0
       < Map#Card(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, ##node#3));
    assume 0
       < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, ##node#3));
    assume KMBtreeModel.__default.MaxKey#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume Seq#Equal(result#0, 
      KMBtreeModel.__default.MaxKey($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));
}



procedure Call$$KMBtree.__default.MaxKeyInternal(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#2)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#2))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#2 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#18))): ref } 
                  LitInt(0) <= i#18 && i#18 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#18 && i#18 < nchildren#2
                     ==> $Unbox(read($Heap, children#2, IndexField(i#18))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#19: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#20: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#20))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#21))): ref } 
                    LitInt(0) <= i#21 && i#21 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#21 && i#21 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#21))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#21))): ref } 
                    LitInt(0) <= i#21 && i#21 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#21 && i#21 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#21))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref)
                   ==> (forall i#22: int :: 
                    { $Unbox(read($Heap, children#2, IndexField(i#22))): ref } 
                    LitInt(0) <= i#22 && i#22 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#22 && i#22 < nchildren#2
                       ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#22))): ref, KMBtree.Node.repr)[$Box(children#2)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#23)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#23)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#24: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#24)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#24
                   && i#24
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#24)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#25: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#25) } 
              true
                 ==> 
                LitInt(0) <= i#25
                   && i#25
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#25))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#26: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#26) } 
              true
                 ==> 
                0 < i#26
                   && i#26
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#26))));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.MaxKey#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures Seq#Equal(result#0, 
    KMBtreeModel.__default.MaxKey($LS($LS($LZ)), 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.MaxKeyInternal(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 33 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.MaxKey#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures $_reverifyPost
     ==> Seq#Equal(result#0, 
      KMBtreeModel.__default.MaxKey($LS($LS($LZ)), 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.MaxKeyInternal(node#0: ref) returns (result#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0_0: int;
  var nkeys#0_0: int where LitInt(0) <= nkeys#0_0 && nkeys#0_0 < 18446744073709551616;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var newtype$check#0_5: int;
  var newtype$check#0_6: int;
  var nchildren#4: int
     where LitInt(0) <= nchildren#4 && nchildren#4 < 18446744073709551616;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var node##0: ref;
  var childidx##0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##node#4: ref;
  var node##1: DatatypeType;
  var ##node#5: ref;
  var i##0: int;
  var newtype$check#3: int;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var node##2: ref;
  var newtype$check#4: int;
  var newtype$check#5: int;

    // AddMethodImpl: MaxKeyInternal, Impl$$KMBtree.__default.MaxKeyInternal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](366,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](367,5)
    assume node#0 != null;
    assume true;
    if (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents)))
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](368,7)
        newtype$check#0_0 := LitInt(0);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](368,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](369,36)
            // TrCallStmt: Before ProcessCallStmt
            assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            free call Call$$KMBtreeModel.__default.reveal__Interpretation();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](369,37)"} true;
            assume 0 < KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
            assume false;
        }

        assume 0 < KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](371,25)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        nkeys#0_0 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](371,46)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](372,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#0_1 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        newtype$check#0_2 := nkeys#0_0 - 1;
        assume LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume {:subsumption 0} 0 <= nkeys#0_0 - 1
           && nkeys#0_0 - 1
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume {:subsumption 0} 0 <= nkeys#0_0
           && nkeys#0_0
             <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        newtype$check#0_3 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        newtype$check#0_4 := nkeys#0_0 - 1;
        assume LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        assume {:subsumption 0} 0 <= nkeys#0_0 - 1
           && nkeys#0_0 - 1
             < Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
                nkeys#0_0));
        assume true;
        assume Seq#Equal($Unbox(read($Heap, 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nkeys#0_0 - 1))): Seq Box, 
          $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
                nkeys#0_0), 
              nkeys#0_0 - 1)): Seq Box);
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](373,14)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#0_5 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        newtype$check#0_6 := nkeys#0_0 - 1;
        assume LitInt(0) <= newtype$check#0_6 && newtype$check#0_6 < 18446744073709551616;
        assume 0 <= nkeys#0_0 - 1
           && nkeys#0_0 - 1
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        result#0 := $Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(nkeys#0_0 - 1))): Seq Box;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](373,43)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](375,29)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](375,54)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](376,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume {:subsumption 0} node#0 != null;
        assume {:subsumption 0} node#0 != null;
        assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          TSeq(Tclass.KMBtree.Node()));
        ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
        // assume allocatedness for argument to function
        assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
        ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
        // assume allocatedness for argument to function
        assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
        ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
        // assume allocatedness for argument to function
        assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
        assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
          $Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](377,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0 := node#0;
        newtype$check#0 := nchildren#4;
        assume LitInt(0) <= newtype$check#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0 := nchildren#4 - 1;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##0, childidx##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](377,42)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](378,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        newtype$check#1 := LitInt(1);
        assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := nchildren#4 - 1;
        assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assume {:subsumption 0} 0 <= nchildren#4 - 1
           && nchildren#4 - 1
             < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume $Is($Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nchildren#4 - 1))): ref, 
          Tclass.KMBtree.Node());
        ##node#4 := $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(nchildren#4 - 1))): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#4, Tclass.KMBtree.Node(), $Heap);
        assume KMBtree.__default.WF#canCall($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nchildren#4 - 1))): ref);
        assume KMBtree.__default.WF#canCall($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nchildren#4 - 1))): ref);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WF($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nchildren#4 - 1))): ref);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](379,33)
        // TrCallStmt: Before ProcessCallStmt
        ##node#5 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#5);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        node##1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        newtype$check#3 := nchildren#4;
        assume LitInt(0) <= newtype$check#3;
        assume true;
        // ProcessCallStmt: CheckSubrange
        assume $Is(nchildren#4 - 1, Tclass._System.nat());
        i##0 := nchildren#4 - 1;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.ChildOfIndexNonempty(node##1, i##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](379,63)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](380,31)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Key
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        newtype$check#4 := LitInt(1);
        assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        newtype$check#5 := nchildren#4 - 1;
        assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        assume 0 <= nchildren#4 - 1
           && nchildren#4 - 1
             < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        // ProcessCallStmt: CheckSubrange
        assume $Is($Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nchildren#4 - 1))): ref, 
          Tclass.KMBtree.Node());
        node##2 := $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(nchildren#4 - 1))): ref;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume Set#Subset(read($Heap, node##2, KMBtree.Node.repr), 
            read(old($Heap), node#0, KMBtree.Node.repr))
           && !Set#Subset(read(old($Heap), node#0, KMBtree.Node.repr), 
            read($Heap, node##2, KMBtree.Node.repr));
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$KMBtree.__default.MaxKeyInternal(node##2);
        // TrCallStmt: After ProcessCallStmt
        result#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](380,69)"} true;
    }
}



procedure CheckWellformed$$KMBtree.__default.MaxKey(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 34 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.MaxKey(node#0: ref) returns (result#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var key#0: Seq Box;
  var ##node#3: ref;
  var ##a#0: Seq Box;
  var ##b#0: Seq Box;

    // AddMethodImpl: MaxKey, CheckWellformed$$KMBtree.__default.MaxKey
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](387,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](390,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#14: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                      i#14)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#14
                     && i#14
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                        i#14)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#15: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                      i#15)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#15
                     && i#15
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                          i#15)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#16: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#16) } 
                true
                   ==> 
                  LitInt(0) <= i#16
                     && i#16
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#16))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#17: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#17) } 
                true
                   ==> 
                  0 < i#17
                     && i#17
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#17))));
    assume KMBtree.__default.WF($Heap, ##node#2);
    assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
    assume Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(result#0)];
    havoc key#0;
    assume $Is(key#0, TSeq(Tclass.NativeTypes.byte()));
    if (*)
    {
        ##node#3 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                     == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                    KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                     == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       - 1));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                    KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#23: int :: 
                    { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                          i#23)): DatatypeType } 
                    true
                       ==> 
                      LitInt(0) <= i#23
                         && i#23
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                        $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                            i#23)): DatatypeType))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#24: int :: 
                    { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                          i#24)): DatatypeType } 
                    true
                       ==> 
                      LitInt(0) <= i#24
                         && i#24
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)), 
                              i#24)): DatatypeType), 
                        Set#Empty(): Set Box))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#25: int :: 
                    { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#25) } 
                    true
                       ==> 
                      LitInt(0) <= i#25
                         && i#25
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                             - 1
                       ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#25))));
        assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#3)
           ==> KMBtree.__default.WF($Heap, ##node#3)
             || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
               ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                 || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#3))
                   ==> (forall i#26: int :: 
                    { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#26) } 
                    true
                       ==> 
                      0 < i#26
                         && i#26
                           < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3)))
                       ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#3), i#26))));
        assume KMBtree.__default.WF($Heap, ##node#3);
        assume KMBtree.__default.Interpretation#canCall($Heap, node#0);
        assume Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#0)];
        ##a#0 := key#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        ##b#0 := result#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##b#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
        assume Lexicographic__Byte__Order.__default.lte#canCall(key#0, result#0);
        assume Lexicographic__Byte__Order.__default.lte(key#0, result#0);
    }
    else
    {
        assume Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#0)]
           ==> Lexicographic__Byte__Order.__default.lte(key#0, result#0);
    }

    assume (forall key#1: Seq Box :: 
      { Lexicographic__Byte__Order.__default.lte(key#1, result#0) } 
        { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
      $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
           && Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
         ==> Lexicographic__Byte__Order.__default.lte(key#1, result#0));
}



procedure Call$$KMBtree.__default.MaxKey(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#27: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#27))): ref } 
                  LitInt(0) <= i#27 && i#27 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#27 && i#27 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#27))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#28: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#29: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#29))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#30: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#30))): ref } 
                    LitInt(0) <= i#30 && i#30 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#30 && i#30 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#30))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#30: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#30))): ref } 
                    LitInt(0) <= i#30 && i#30 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#30 && i#30 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#30))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref)
                   ==> (forall i#31: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#31))): ref } 
                    LitInt(0) <= i#31 && i#31 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#31 && i#31 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#31))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#32: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#32)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#32
                   && i#32
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#32)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#33: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#33)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#33
                   && i#33
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#33)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#34: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#34) } 
              true
                 ==> 
                LitInt(0) <= i#34
                   && i#34
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#34))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#35: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#35) } 
              true
                 ==> 
                0 < i#35
                   && i#35
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#35))));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.Interpretation#canCall($Heap, node#0);
  ensures Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(result#0)];
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(key#1, result#0) } 
      { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
       ==> KMBtree.__default.Interpretation#canCall($Heap, node#0)
         && (Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
           ==> Lexicographic__Byte__Order.__default.lte#canCall(key#1, result#0)));
  ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(key#1, result#0) } 
      { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
         && Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
       ==> Lexicographic__Byte__Order.__default.lte(key#1, result#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.MaxKey(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (result#0: Seq Box
       where $Is(result#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(result#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 34 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires 0 < Map#Card(KMBtree.__default.Interpretation($Heap, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.Interpretation#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(result#0)];
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(key#1, result#0) } 
      { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
       ==> KMBtree.__default.Interpretation#canCall($Heap, node#0)
         && (Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
           ==> Lexicographic__Byte__Order.__default.lte#canCall(key#1, result#0)));
  ensures $_reverifyPost
     ==> (forall key#1: Seq Box :: 
      { Lexicographic__Byte__Order.__default.lte(key#1, result#0) } 
        { Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)] } 
      $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
           && Map#Domain(KMBtree.__default.Interpretation($Heap, node#0))[$Box(key#1)]
         ==> Lexicographic__Byte__Order.__default.lte(key#1, result#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.MaxKey(node#0: ref) returns (result#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var node##0: ref;
  var node##1: DatatypeType;
  var ##node#4: ref;

    // AddMethodImpl: MaxKey, Impl$$KMBtree.__default.MaxKey
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](392,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](393,29)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Key
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := node#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.MaxKeyInternal(node##0);
    // TrCallStmt: After ProcessCallStmt
    result#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](393,34)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](394,27)
    // TrCallStmt: Before ProcessCallStmt
    ##node#4 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#4);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    // ProcessCallStmt: CheckSubrange
    node##1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.MaxKeyProperties(node##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](394,35)"} true;
}



procedure CheckWellformed$$KMBtree.__default.EmptyTree()
   returns (root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap));
  free requires 35 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.EmptyTree() returns (root#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;

    // AddMethodImpl: EmptyTree, CheckWellformed$$KMBtree.__default.EmptyTree
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](397,9): initial state"} true;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc root#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](398,14): post-state"} true;
    ##node#0 := root#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, root#0);
    assume KMBtree.__default.WF($Heap, root#0);
    assume root#0 != null;
    assume (forall $o: ref :: 
      { read($Heap, root#0, KMBtree.Node.repr)[$Box($o)] } 
      read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    ##node#1 := root#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#1)
       ==> KMBtree.__default.WF($Heap, ##node#1)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#1))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#1), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#1);
    assume KMBtree.__default.Interpretation#canCall($Heap, root#0);
    assume Map#Equal(KMBtree.__default.Interpretation($Heap, root#0), Map#Empty(): Map Box Box);
    assume root#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents));
}



procedure Call$$KMBtree.__default.EmptyTree()
   returns (root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WF#canCall($Heap, root#0);
  free ensures KMBtree.__default.WF#canCall($Heap, root#0)
     && 
    KMBtree.__default.WF($Heap, root#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, root#0, KMBtree.Node.repr)[$Box($o)] } 
    read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures KMBtree.__default.Interpretation#canCall($Heap, root#0);
  ensures Map#Equal(KMBtree.__default.Interpretation($Heap, root#0), Map#Empty(): Map Box Box);
  free ensures true;
  ensures KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.EmptyTree()
   returns (root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap), 
    $_reverifyPost: bool);
  free requires 35 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WF#canCall($Heap, root#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, root#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> read($Heap, root#0, KMBtree.Node.height) == LitInt(0)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, root#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, root#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))), 
                    $Box(children#2)), 
                  read($Heap, root#0, KMBtree.Node.repr))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                0 < nchildren#2))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                nchildren#2 <= LitInt(KMBtree.__default.MaxChildren())))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#18))): ref } 
                  LitInt(0) <= i#18 && i#18 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#18 && i#18 < nchildren#2
                     ==> $Unbox(read($Heap, children#2, IndexField(i#18))): ref != null)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
                  read($Heap, root#0, KMBtree.Node.repr), 
                  read($Heap, root#0, KMBtree.Node.height))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#19: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(root#0)])))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#20: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#20))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))])))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#21))): ref } 
                    LitInt(0) <= i#21 && i#21 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#21 && i#21 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#21))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref)
                   ==> Lit(true)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#21))): ref } 
                    LitInt(0) <= i#21 && i#21 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#21 && i#21 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#21))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#21)): ref)
                   ==> (forall i#22: int :: 
                    { $Unbox(read($Heap, children#2, IndexField(i#22))): ref } 
                    LitInt(0) <= i#22 && i#22 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#22 && i#22 < nchildren#2
                       ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#22))): ref, KMBtree.Node.repr)[$Box(children#2)])))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 - 1));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#23: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                    i#23)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                      i#23)): DatatypeType))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#24: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                    i#24)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#24
                   && i#24
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                        i#24)): DatatypeType), 
                  Set#Empty(): Set Box))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#25: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#25) } 
              true
                 ==> 
                LitInt(0) <= i#25
                   && i#25
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#25))));
  ensures KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#26: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#26) } 
              true
                 ==> 
                0 < i#26
                   && i#26
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#26))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read($Heap, root#0, KMBtree.Node.repr)[$Box($o)] } 
      read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures KMBtree.__default.Interpretation#canCall($Heap, root#0);
  ensures $_reverifyPost
     ==> Map#Equal(KMBtree.__default.Interpretation($Heap, root#0), Map#Empty(): Map Box Box);
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.KMBtree.NodeContents() : Ty;

// Tclass.KMBtree.NodeContents Tag
axiom Tag(Tclass.KMBtree.NodeContents()) == Tagclass.KMBtree.NodeContents;

const unique Tagclass.KMBtree.NodeContents: TyTag;

// Box/unbox axiom for Tclass.KMBtree.NodeContents
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KMBtree.NodeContents()) } 
  $IsBox(bx, Tclass.KMBtree.NodeContents())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.KMBtree.NodeContents()));

implementation Impl$$KMBtree.__default.EmptyTree() returns (root#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#root#0: bool;
  var rootkeys#0: ref
     where $Is(rootkeys#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(rootkeys#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc($rhs##0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var n##0: int;
  var t##0: Box;
  var rootvalues#0: ref
     where $Is(rootvalues#0, Tclass._System.array(Tclass.ValueMessage.Message()))
       && $IsAlloc(rootvalues#0, Tclass._System.array(Tclass.ValueMessage.Message()), $Heap);
  var $rhs##1: ref
     where $Is($rhs##1, Tclass._System.array(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##1, Tclass._System.array(Tclass.ValueMessage.Message()), $Heap);
  var n##1: int;
  var t##1: Box;
  var $nw: ref;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.KMBtree.NodeContents());
  var newtype$check#0: int;
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));
  var $rhs#2: int where LitInt(0) <= $rhs#2;

    // AddMethodImpl: EmptyTree, Impl$$KMBtree.__default.EmptyTree
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](402,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](403,33)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type array<Key>
    // TrCallStmt: Before ProcessCallStmt
    assume KMBtree.__default.MaxKeysPerLeaf#canCall();
    assume KMBtree.__default.MaxKeysPerLeaf#canCall();
    // ProcessCallStmt: CheckSubrange
    n##0 := LitInt(KMBtree.__default.MaxKeysPerLeaf());
    assume KMBtree.__default.DefaultKey#canCall();
    assume KMBtree.__default.DefaultKey#canCall();
    // ProcessCallStmt: CheckSubrange
    t##0 := $Box(Lit(KMBtree.__default.DefaultKey()));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$NativeArrays.__default.newArrayFill(TSeq(Tclass.NativeTypes.byte()), n##0, t##0);
    // TrCallStmt: After ProcessCallStmt
    rootkeys#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](403,64)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](404,35)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type array<Value>
    // TrCallStmt: Before ProcessCallStmt
    assume KMBtree.__default.MaxKeysPerLeaf#canCall();
    assume KMBtree.__default.MaxKeysPerLeaf#canCall();
    // ProcessCallStmt: CheckSubrange
    n##1 := LitInt(KMBtree.__default.MaxKeysPerLeaf());
    assume KMBtree.__default.DefaultValue#canCall();
    assume KMBtree.__default.DefaultValue#canCall();
    // ProcessCallStmt: CheckSubrange
    t##1 := $Box(Lit(KMBtree.__default.DefaultValue()));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##1 := Call$$NativeArrays.__default.newArrayFill(Tclass.ValueMessage.Message(), n##1, t##1);
    // TrCallStmt: After ProcessCallStmt
    rootvalues#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](404,68)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](405,10)
    assume true;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass.KMBtree.Node?();
    assume !read($Heap, $nw, alloc);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    root#0 := $nw;
    defass#root#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](405,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](406,19)
    assume defass#root#0;
    assume root#0 != null;
    assume true;
    assume $_Frame[root#0, KMBtree.Node.contents];
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    $rhs#0 := #KMBtree.NodeContents.Leaf(LitInt(0), rootkeys#0, rootvalues#0);
    $Heap := update($Heap, root#0, KMBtree.Node.contents, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](406,50)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](407,15)
    assume defass#root#0;
    assume root#0 != null;
    assume true;
    assume $_Frame[root#0, KMBtree.Node.repr];
    assume defass#root#0;
    assume true;
    $rhs#1 := Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), $Box(rootkeys#0)), 
      $Box(rootvalues#0));
    $Heap := update($Heap, root#0, KMBtree.Node.repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](407,45)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](408,17)
    assume defass#root#0;
    assume root#0 != null;
    assume true;
    assume $_Frame[root#0, KMBtree.Node.height];
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    $rhs#2 := LitInt(0);
    $Heap := update($Heap, root#0, KMBtree.Node.height, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](408,20)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](409,32)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__Interpretation();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](409,33)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](410,39)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$Lexicographic__Byte__Order.__default.reveal__IsStrictlySorted();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](410,40)"} true;
    assert defass#root#0;
}



procedure CheckWellformed$$KMBtree.__default.LeafFromSeqs(keys#0: Seq Box
       where $Is(keys#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(keys#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    values#0: Seq Box
       where $Is(values#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(values#0, TSeq(Tclass.ValueMessage.Message()), $Heap))
   returns (node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap));
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.LeafFromSeqs(keys#0: Seq Box
       where $Is(keys#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(keys#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    values#0: Seq Box
       where $Is(values#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(values#0, TSeq(Tclass.ValueMessage.Message()), $Heap))
   returns (node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap));
  // user-defined preconditions
  requires Seq#Length(keys#0) == Seq#Length(values#0);
  requires Seq#Length(values#0) <= LitInt(KMBtree.__default.MaxKeysPerLeaf());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#0 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#0)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#0
                 && nchildren#0 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#0)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#0: int :: 
                  { $Unbox(read($Heap, children#0, IndexField(i#0))): ref } 
                  LitInt(0) <= i#0 && i#0 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#0 && i#0 < nchildren#0
                     ==> $Unbox(read($Heap, children#0, IndexField(i#0))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#0), nchildren#0), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#1: int :: 
                  { $Unbox(read($Heap, children#0, IndexField(i#1))): ref } 
                  LitInt(0) <= i#1 && i#1 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#1 && i#1 < nchildren#0
                     ==> !read($Heap, $Unbox(read($Heap, children#0, IndexField(i#1))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#2: int :: 
                  { $Unbox(read($Heap, children#0, IndexField(i#2))): ref } 
                  LitInt(0) <= i#2 && i#2 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#2 && i#2 < nchildren#0
                     ==> !read($Heap, $Unbox(read($Heap, children#0, IndexField(i#2))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#4: int :: 
                  { $Unbox(read($Heap, children#0, IndexField(i#4))): ref } 
                  LitInt(0) <= i#4 && i#4 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#4 && i#4 < nchildren#0
                     ==> !read($Heap, $Unbox(read($Heap, children#0, IndexField(i#4))): ref, KMBtree.Node.repr)[$Box(children#0)]))));
  free ensures true;
  ensures KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, node#0, KMBtree.Node.repr)[$Box($o)] } 
    read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
    keys#0);
  free ensures true;
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
    values#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.LeafFromSeqs(keys#0: Seq Box
       where $Is(keys#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(keys#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    values#0: Seq Box
       where $Is(values#0, TSeq(Tclass.ValueMessage.Message()))
         && $IsAlloc(values#0, TSeq(Tclass.ValueMessage.Message()), $Heap))
   returns (node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    $_reverifyPost: bool);
  free requires 38 == $FunctionContextHeight;
  // user-defined preconditions
  requires Seq#Length(keys#0) == Seq#Length(values#0);
  requires Seq#Length(values#0) <= LitInt(KMBtree.__default.MaxKeysPerLeaf());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#1)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#1)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#1 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#5: int :: 
              { $Unbox(read($Heap, children#1, IndexField(i#5))): ref } 
              LitInt(0) <= i#5 && i#5 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#5 && i#5 < nchildren#1
                 ==> $Unbox(read($Heap, children#1, IndexField(i#5))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#6: int :: 
              { $Unbox(read($Heap, children#1, IndexField(i#6))): ref } 
              LitInt(0) <= i#6 && i#6 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#6 && i#6 < nchildren#1
                 ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#6))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#7: int :: 
              { $Unbox(read($Heap, children#1, IndexField(i#7))): ref } 
              LitInt(0) <= i#7 && i#7 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#7 && i#7 < nchildren#1
                 ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#7))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#8: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref } 
                  { $Unbox(read($Heap, children#1, IndexField(i#8))): ref } 
                LitInt(0) <= i#8 && i#8 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#8 && i#8 < nchildren#1
                   ==> $Unbox(read($Heap, children#1, IndexField(i#8))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#8: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref } 
                  { $Unbox(read($Heap, children#1, IndexField(i#8))): ref } 
                LitInt(0) <= i#8 && i#8 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#8 && i#8 < nchildren#1
                   ==> $Unbox(read($Heap, children#1, IndexField(i#8))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref)
               ==> (forall i#9: int :: 
                { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
                LitInt(0) <= i#9 && i#9 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#9 && i#9 < nchildren#1
                   ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#9))): ref, KMBtree.Node.repr)[$Box(children#1)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read($Heap, node#0, KMBtree.Node.repr)[$Box($o)] } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
      keys#0);
  free ensures true;
  ensures $_reverifyPost
     ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
      values#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.LeafFromSeqs(keys#0: Seq Box, values#0: Seq Box) returns (node#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#node#0: bool;
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0, Tclass.KMBtree.Node(), $Heap);
  var src##0: Seq Box;
  var srcIndex##0: int;
  var newtype$check#0: int;
  var dst##0: ref;
  var dstIndex##0: int;
  var newtype$check#1: int;
  var len##0: int;
  var newtype$check#2: int;
  var src##1: Seq Box;
  var srcIndex##1: int;
  var newtype$check#3: int;
  var dst##1: ref;
  var dstIndex##1: int;
  var newtype$check#4: int;
  var len##1: int;
  var newtype$check#5: int;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.KMBtree.NodeContents());
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#nkeys#0#0: int;
  var let#1#0#0: int;
  var newtype$check#6: int;

    // AddMethodImpl: LeafFromSeqs, Impl$$KMBtree.__default.LeafFromSeqs
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](421,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](422,22)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.EmptyTree();
    // TrCallStmt: After ProcessCallStmt
    node#0 := $rhs##0;
    defass#node#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](422,23)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](423,21)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##0 := keys#0;
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##0 := LitInt(0);
    assume defass#node#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##0 := KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##0 := LitInt(0);
    newtype$check#2 := Seq#Length(keys#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := Seq#Length(keys#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$NativeArrays.__default.CopySeqIntoArray(TSeq(Tclass.NativeTypes.byte()), src##0, srcIndex##0, dst##0, dstIndex##0, len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](423,70)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](424,21)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##1 := values#0;
    newtype$check#3 := LitInt(0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##1 := LitInt(0);
    assume defass#node#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##1 := KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#4 := LitInt(0);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##1 := LitInt(0);
    newtype$check#5 := Seq#Length(values#0);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##1 := Seq#Length(values#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##1 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$NativeArrays.__default.CopySeqIntoArray(Tclass.ValueMessage.Message(), src##1, srcIndex##1, dst##1, dstIndex##1, len##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](424,76)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](425,19)
    assume defass#node#0;
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.contents];
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    havoc dt_update_tmp#0#0;
    assume $Is(dt_update_tmp#0#0, Tclass.KMBtree.NodeContents());
    assume defass#node#0;
    assume node#0 != null;
    assume let#0#0#0 == read($Heap, node#0, KMBtree.Node.contents);
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#0#0#0, Tclass.KMBtree.NodeContents());
    assume dt_update_tmp#0#0 == let#0#0#0;
    havoc dt_update#nkeys#0#0;
    assume LitInt(0) <= dt_update#nkeys#0#0 && dt_update#nkeys#0#0 < 18446744073709551616;
    newtype$check#6 := Seq#Length(keys#0);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assume let#1#0#0 == Seq#Length(keys#0);
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
    assume dt_update#nkeys#0#0 == let#1#0#0;
    assume KMBtree.NodeContents.Leaf_q(dt_update_tmp#0#0);
    assume KMBtree.NodeContents.Leaf_q(dt_update_tmp#0#0);
    assume true;
    $rhs#0 := (var dt_update_tmp#0#1 := read($Heap, node#0, KMBtree.Node.contents); 
      (var dt_update#nkeys#0#1 := Seq#Length(keys#0); 
        #KMBtree.NodeContents.Leaf(dt_update#nkeys#0#1, 
          KMBtree.NodeContents.keys(dt_update_tmp#0#1), 
          KMBtree.NodeContents.values(dt_update_tmp#0#1))));
    $Heap := update($Heap, node#0, KMBtree.Node.contents, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](425,62)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](426,5)
    assume defass#node#0;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume defass#node#0;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
      keys#0);
    assert defass#node#0;
}



procedure CheckWellformed$$KMBtree.__default.IndexFromChildren(pivots#0: Seq Box
       where $Is(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    children#0: Seq Box
       where $Is(children#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(children#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    height#0: int where LitInt(0) <= height#0)
   returns (node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap));
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.IndexFromChildren(pivots#0: Seq Box
       where $Is(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    children#0: Seq Box
       where $Is(children#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(children#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    height#0: int where LitInt(0) <= height#0)
   returns (node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap));
  // user-defined preconditions
  requires 0 < Seq#Length(children#0);
  requires Seq#Length(children#0) <= LitInt(KMBtree.__default.MaxChildren());
  requires Seq#Length(pivots#0) == Seq#Length(children#0) - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures KMBtree.__default.MaxChildren#canCall();
  ensures _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
     == LitInt(KMBtree.__default.MaxChildren() - 1);
  free ensures KMBtree.__default.MaxChildren#canCall();
  ensures _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))
     == LitInt(KMBtree.__default.MaxChildren());
  free ensures true;
  ensures KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
     == Seq#Length(children#0);
  free ensures true;
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
    pivots#0);
  free ensures true;
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
    children#0);
  free ensures true;
  ensures node#0 != null && !read(old($Heap), node#0, alloc);
  free ensures true;
  ensures KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null
     && !read(old($Heap), 
      KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)), 
      alloc);
  free ensures true;
  ensures KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null
     && !read(old($Heap), 
      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
      alloc);
  free ensures KMBtree.__default.SeqRepr#canCall($Heap, children#0);
  ensures Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
    Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
          $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
        $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))), 
      KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, $Heap, children#0)));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height) == height#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.IndexFromChildren(pivots#0: Seq Box
       where $Is(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(pivots#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    children#0: Seq Box
       where $Is(children#0, TSeq(Tclass.KMBtree.Node()))
         && $IsAlloc(children#0, TSeq(Tclass.KMBtree.Node()), $Heap), 
    height#0: int where LitInt(0) <= height#0)
   returns (node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    $_reverifyPost: bool);
  free requires 39 == $FunctionContextHeight;
  // user-defined preconditions
  requires 0 < Seq#Length(children#0);
  requires Seq#Length(children#0) <= LitInt(KMBtree.__default.MaxChildren());
  requires Seq#Length(pivots#0) == Seq#Length(children#0) - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures KMBtree.__default.MaxChildren#canCall();
  ensures $_reverifyPost
     ==> _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
       == LitInt(KMBtree.__default.MaxChildren() - 1);
  free ensures KMBtree.__default.MaxChildren#canCall();
  ensures $_reverifyPost
     ==> _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))
       == LitInt(KMBtree.__default.MaxChildren());
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       == Seq#Length(children#0);
  free ensures true;
  ensures $_reverifyPost
     ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
      pivots#0);
  free ensures true;
  ensures $_reverifyPost
     ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      children#0);
  free ensures true;
  ensures $_reverifyPost ==> node#0 != null && !read(old($Heap), node#0, alloc);
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null
       && !read(old($Heap), 
        KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)), 
        alloc);
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
         != null
       && !read(old($Heap), 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        alloc);
  free ensures KMBtree.__default.SeqRepr#canCall($Heap, children#0);
  ensures $_reverifyPost
     ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
      Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
            $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
          $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))), 
        KMBtree.__default.SeqRepr(StartFuelAssert_KMBtree._default.SeqRepr, $Heap, children#0)));
  free ensures true;
  ensures $_reverifyPost ==> read($Heap, node#0, KMBtree.Node.height) == height#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.IndexFromChildren(pivots#0: Seq Box, children#0: Seq Box, height#0: int)
   returns (node#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#node#0: bool;
  var pivotarray#0: ref
     where $Is(pivotarray#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(pivotarray#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc($rhs##0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var n##0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var t##0: Box;
  var childarray#0: ref
     where $Is(childarray#0, Tclass._System.array(Tclass.KMBtree.Node?()))
       && $IsAlloc(childarray#0, Tclass._System.array(Tclass.KMBtree.Node?()), $Heap);
  var $rhs##1: ref
     where $Is($rhs##1, Tclass._System.array(Tclass.KMBtree.Node?()))
       && $IsAlloc($rhs##1, Tclass._System.array(Tclass.KMBtree.Node?()), $Heap);
  var n##1: int;
  var t##1: Box;
  var src##0: Seq Box;
  var srcIndex##0: int;
  var newtype$check#5: int;
  var dst##0: ref;
  var dstIndex##0: int;
  var newtype$check#6: int;
  var len##0: int;
  var newtype$check#7: int;
  var src##1: Seq Box;
  var srcIndex##1: int;
  var newtype$check#8: int;
  var dst##1: ref;
  var dstIndex##1: int;
  var newtype$check#9: int;
  var len##1: int;
  var newtype$check#10: int;
  var $nw: ref;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.KMBtree.NodeContents());
  var newtype$check#11: int;
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));
  var ##nodes#1: Seq Box;
  var $rhs#2: int where LitInt(0) <= $rhs#2;

    // AddMethodImpl: IndexFromChildren, Impl$$KMBtree.__default.IndexFromChildren
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](443,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](444,35)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type array<Key>
    // TrCallStmt: Before ProcessCallStmt
    assume KMBtree.__default.MaxChildren#canCall();
    newtype$check#3 := LitInt(1);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := LitInt(KMBtree.__default.MaxChildren() - 1);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume KMBtree.__default.MaxChildren#canCall();
    // ProcessCallStmt: CheckSubrange
    n##0 := LitInt(KMBtree.__default.MaxChildren() - 1);
    assume KMBtree.__default.DefaultKey#canCall();
    assume KMBtree.__default.DefaultKey#canCall();
    // ProcessCallStmt: CheckSubrange
    t##0 := $Box(Lit(KMBtree.__default.DefaultKey()));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$NativeArrays.__default.newArrayFill(TSeq(Tclass.NativeTypes.byte()), n##0, t##0);
    // TrCallStmt: After ProcessCallStmt
    pivotarray#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](444,65)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](445,35)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type array<Node?>
    // TrCallStmt: Before ProcessCallStmt
    assume KMBtree.__default.MaxChildren#canCall();
    assume KMBtree.__default.MaxChildren#canCall();
    // ProcessCallStmt: CheckSubrange
    n##1 := LitInt(KMBtree.__default.MaxChildren());
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##1 := $Box(null);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##1 := Call$$NativeArrays.__default.newArrayFill(Tclass.KMBtree.Node?(), n##1, t##1);
    // TrCallStmt: After ProcessCallStmt
    childarray#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](445,55)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](446,21)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##0 := pivots#0;
    newtype$check#5 := LitInt(0);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##0 := pivotarray#0;
    newtype$check#6 := LitInt(0);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##0 := LitInt(0);
    newtype$check#7 := Seq#Length(pivots#0);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##0 := Seq#Length(pivots#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$NativeArrays.__default.CopySeqIntoArray(TSeq(Tclass.NativeTypes.byte()), src##0, srcIndex##0, dst##0, dstIndex##0, len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](446,66)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](447,21)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    src##1 := children#0;
    newtype$check#8 := LitInt(0);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    srcIndex##1 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    dst##1 := childarray#0;
    newtype$check#9 := LitInt(0);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    dstIndex##1 := LitInt(0);
    newtype$check#10 := Seq#Length(children#0);
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    len##1 := Seq#Length(children#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == dst##1 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$NativeArrays.__default.CopySeqIntoArray(Tclass.KMBtree.Node?(), src##1, srcIndex##1, dst##1, dstIndex##1, len##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](447,70)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](448,10)
    assume true;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass.KMBtree.Node?();
    assume !read($Heap, $nw, alloc);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    node#0 := $nw;
    defass#node#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](448,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](449,19)
    assume defass#node#0;
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.contents];
    newtype$check#11 := Seq#Length(children#0);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    assume true;
    $rhs#0 := #KMBtree.NodeContents.Index(Seq#Length(children#0), pivotarray#0, childarray#0);
    $Heap := update($Heap, node#0, KMBtree.Node.contents, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](449,72)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](450,15)
    assume defass#node#0;
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.repr];
    assume defass#node#0;
    assume defass#node#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume defass#node#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    ##nodes#1 := children#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#1, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.SeqRepr#canCall($Heap, children#0);
    assume KMBtree.__default.SeqRepr#canCall($Heap, children#0);
    $rhs#1 := Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
          $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
        $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))), 
      KMBtree.__default.SeqRepr(StartFuel_KMBtree._default.SeqRepr, $Heap, children#0));
    $Heap := update($Heap, node#0, KMBtree.Node.repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](450,89)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](451,17)
    assume defass#node#0;
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.height];
    assume true;
    $rhs#2 := height#0;
    $Heap := update($Heap, node#0, KMBtree.Node.height, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](451,25)"} true;
    assert defass#node#0;
}



// function declaration for KMBtree._default.Full
function KMBtree.__default.Full($heap: Heap, node#0: ref) : bool;

function KMBtree.__default.Full#canCall($heap: Heap, node#0: ref) : bool;

// frame axiom for KMBtree.__default.Full
axiom (forall $h0: Heap, $h1: Heap, node#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.Full($h1, node#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.Full#canCall($h0, node#0)
         || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && $o == node#0 ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.Full($h0, node#0) == KMBtree.__default.Full($h1, node#0));

// consequence axiom for KMBtree.__default.Full
axiom 40 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.Full($Heap, node#0) } 
    KMBtree.__default.Full#canCall($Heap, node#0)
         || (40 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node()))
       ==> true);

function KMBtree.__default.Full#requires(Heap, ref) : bool;

// #requires axiom for KMBtree.__default.Full
axiom (forall $Heap: Heap, node#0: ref :: 
  { KMBtree.__default.Full#requires($Heap, node#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.Full#requires($Heap, node#0) == true);

// definition axiom for KMBtree.__default.Full(revealed)
axiom 40 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref :: 
    { KMBtree.__default.Full($Heap, node#0) } 
    KMBtree.__default.Full#canCall($Heap, node#0)
         || (40 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node()))
       ==> (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> KMBtree.__default.MaxKeysPerLeaf#canCall())
         && (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
           ==> KMBtree.__default.MaxChildren#canCall())
         && KMBtree.__default.Full($Heap, node#0)
           == (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             then (var nkeys#1 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)); 
              nkeys#1 == LitInt(KMBtree.__default.MaxKeysPerLeaf()))
             else (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              nchildren#1 == LitInt(KMBtree.__default.MaxChildren()))));

procedure CheckWellformed$$KMBtree.__default.Full(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()));
  free requires 40 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure CheckWellformed$$KMBtree.__default.SplitLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    nleft#0: int where LitInt(0) <= nleft#0 && nleft#0 < 18446744073709551616, 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap));
  free requires 41 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.SplitLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    nleft#0: int where LitInt(0) <= nleft#0 && nleft#0 < 18446744073709551616, 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> (forall i#19: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                    LitInt(0) <= i#19 && i#19 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#19 && i#19 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#20: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#20)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#20
                   && i#20
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#20)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#21: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#21)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#21
                   && i#21
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#21)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#22: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22) } 
              true
                 ==> 
                LitInt(0) <= i#22
                   && i#22
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23) } 
              true
                 ==> 
                0 < i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23))));
  requires KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  requires 0 < nleft#0;
  requires nleft#0 < KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
  requires Lexicographic__Byte__Order.__default.lt#canCall($Unbox(read($Heap, 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box, 
      pivot#0)
     ==> Lexicographic__Byte__Order.__default.lt($Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(nleft#0 - 1))): Seq Box, 
        pivot#0)
       || (Lexicographic__Byte__Order.__default.lte#canCall($Unbox(read($Heap, 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(nleft#0 - 1))): Seq Box, 
          pivot#0)
         ==> Lexicographic__Byte__Order.__default.lte($Unbox(read($Heap, 
                KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(nleft#0 - 1))): Seq Box, 
            pivot#0)
           || (Lit(true)
             ==> 
            Lit(true)
             ==> 
            Lit(true)
             ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(nleft#0 - 1))): Seq Box, 
              pivot#0)));
  requires Lexicographic__Byte__Order.__default.lt#canCall($Unbox(read($Heap, 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box, 
      pivot#0)
     ==> Lexicographic__Byte__Order.__default.lt($Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(nleft#0 - 1))): Seq Box, 
        pivot#0)
       || !Seq#Equal($Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(nleft#0 - 1))): Seq Box, 
        pivot#0);
  requires Lexicographic__Byte__Order.__default.lte(pivot#0, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(nleft#0))): Seq Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#25))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#26: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#26))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(children#4)]))));
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, right#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
         && read($Heap, right#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          true
             && (var children#5 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))), 
                    $Box(children#5)), 
                  read($Heap, right#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#5
                 && nchildren#5 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#29: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#5
                     ==> $Unbox(read($Heap, children#5, IndexField(i#29))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), 
                  read($Heap, right#0, KMBtree.Node.repr), 
                  read($Heap, right#0, KMBtree.Node.height))
                 && (forall i#30: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#30))): ref } 
                  LitInt(0) <= i#30 && i#30 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#30 && i#30 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#30))): ref, KMBtree.Node.repr)[$Box(right#0)])
                 && (forall i#31: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#31))): ref } 
                  LitInt(0) <= i#31 && i#31 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#31 && i#31 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#31))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#33: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#33))): ref } 
                  LitInt(0) <= i#33 && i#33 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#33 && i#33 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#33))): ref, KMBtree.Node.repr)[$Box(children#5)]))));
  free ensures true;
  ensures Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
    read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, right#0, KMBtree.Node.repr)[$Box($o)] } 
    read($Heap, right#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, right#0)
     && KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0);
  free ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     && 
    KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     && 
    KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0))
     && KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0))
     && 
    0
       < Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
     && Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
     && 
    0
       < Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)))
     && Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)))
       == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)))
     && Seq#Equal(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
      Seq#Append(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
        KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0))))
     && Seq#Equal(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
      Seq#Append(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
        KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0))))
     && Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
      pivot#0)
     && Lexicographic__Byte__Order.__default.lte(pivot#0, 
      $Unbox(Seq#Index(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)), 
          LitInt(0))): Seq Box);
  free ensures true;
  ensures KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
     == nleft#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.SplitLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    nleft#0: int where LitInt(0) <= nleft#0 && nleft#0 < 18446744073709551616, 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    $_reverifyPost: bool);
  free requires 41 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  requires 0 < nleft#0;
  requires nleft#0 < KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
  free requires Lexicographic__Byte__Order.__default.lt#canCall($Unbox(read($Heap, 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box, 
      pivot#0)
     && 
    Lexicographic__Byte__Order.__default.lt($Unbox(read($Heap, 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box, 
      pivot#0)
     && 
    Lexicographic__Byte__Order.__default.lte($Unbox(read($Heap, 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box, 
      pivot#0)
     && !Seq#Equal($Unbox(read($Heap, 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box, 
      pivot#0);
  requires Lexicographic__Byte__Order.__default.lte(pivot#0, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(nleft#0))): Seq Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#7)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#7)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#7 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#43: int :: 
              { $Unbox(read($Heap, children#7, IndexField(i#43))): ref } 
              LitInt(0) <= i#43 && i#43 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#43 && i#43 < nchildren#7
                 ==> $Unbox(read($Heap, children#7, IndexField(i#43))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#44: int :: 
              { $Unbox(read($Heap, children#7, IndexField(i#44))): ref } 
              LitInt(0) <= i#44 && i#44 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#44 && i#44 < nchildren#7
                 ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#45: int :: 
              { $Unbox(read($Heap, children#7, IndexField(i#45))): ref } 
              LitInt(0) <= i#45 && i#45 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#45 && i#45 < nchildren#7
                 ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#45))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#46: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref } 
                  { $Unbox(read($Heap, children#7, IndexField(i#46))): ref } 
                LitInt(0) <= i#46 && i#46 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#46 && i#46 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#46))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#46: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref } 
                  { $Unbox(read($Heap, children#7, IndexField(i#46))): ref } 
                LitInt(0) <= i#46 && i#46 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#46 && i#46 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#46))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref)
               ==> (forall i#47: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#47))): ref } 
                LitInt(0) <= i#47 && i#47 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#47 && i#47 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#47))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, right#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> read($Heap, right#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))), 
                $Box(children#8)), 
              read($Heap, right#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            0 < nchildren#8)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            nchildren#8 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#48: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#48))): ref } 
              LitInt(0) <= i#48 && i#48 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#48 && i#48 < nchildren#8
                 ==> $Unbox(read($Heap, children#8, IndexField(i#48))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), 
              read($Heap, right#0, KMBtree.Node.repr), 
              read($Heap, right#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#49: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#49))): ref } 
              LitInt(0) <= i#49 && i#49 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#49 && i#49 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#49))): ref, KMBtree.Node.repr)[$Box(right#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#50: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#50))): ref } 
              LitInt(0) <= i#50 && i#50 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#50 && i#50 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#50))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#51: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                LitInt(0) <= i#51 && i#51 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#51 && i#51 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#51: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                LitInt(0) <= i#51 && i#51 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#51 && i#51 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
               ==> (forall i#52: int :: 
                { $Unbox(read($Heap, children#8, IndexField(i#52))): ref } 
                LitInt(0) <= i#52 && i#52 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#52 && i#52 < nchildren#8
                   ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(children#8)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read($Heap, right#0, KMBtree.Node.repr)[$Box($o)] } 
      read($Heap, right#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, right#0)
     && KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0);
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || 0
         < Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
         == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || 0
         < Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0)));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0)))
         == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0)));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Equal(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        Seq#Append(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0))));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Equal(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        Seq#Append(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
          KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0))));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || (Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
          pivot#0)
         ==> Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
            pivot#0)
           || (Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
                  KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
              pivot#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
                    KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
                pivot#0)
               || (Lit(true)
                 ==> 
                Lit(true)
                 ==> 
                Lit(true)
                 ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                  $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
                      KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
                  pivot#0))));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || (Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
          pivot#0)
         ==> Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
            pivot#0)
           || !Seq#Equal($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))): Seq Box, 
            pivot#0));
  ensures KMBtreeModel.__default.SplitLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || (Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, 
          $Unbox(Seq#Index(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)), 
              LitInt(0))): Seq Box)
         ==> Lexicographic__Byte__Order.__default.lte(pivot#0, 
            $Unbox(Seq#Index(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)), 
                LitInt(0))): Seq Box)
           || (Lit(true)
             ==> 
            Lit(true)
             ==> 
            Lit(true)
             ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
              pivot#0, 
              $Unbox(Seq#Index(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0)), 
                  LitInt(0))): Seq Box)));
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       == nleft#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.SplitLeaf(node#0: ref, nleft#0: int, pivot#0: Seq Box)
   returns (right#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#right#0: bool;
  var run##0: Seq Box;
  var i##0: int;
  var j##0: int;
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0, Tclass.KMBtree.Node(), $Heap);
  var keys##0: Seq Box;
  var values##0: Seq Box;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.KMBtree.NodeContents());
  var run##1: Seq Box;
  var i##1: int;
  var j##1: int;

    // AddMethodImpl: SplitLeaf, Impl$$KMBtree.__default.SplitLeaf
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](476,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](477,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](477,14)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](478,41)
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume 0 <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := nleft#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    j##0 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$Lexicographic__Byte__Order.__default.StrictlySortedSubsequence(run##0, i##0, j##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](478,125)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](479,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume {:subsumption 0} 0 <= nleft#0
       && nleft#0
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} nleft#0
         <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} 0 <= nleft#0
       && nleft#0
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} nleft#0
         <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
        nleft#0), 
      Seq#Drop(Seq#Take(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
        nleft#0));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](480,26)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume 0 <= nleft#0
       && nleft#0
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume nleft#0
         <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    keys##0 := Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
      nleft#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume 0 <= nleft#0
       && nleft#0
         <= _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume nleft#0
         <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    values##0 := Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))), 
      nleft#0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.LeafFromSeqs(keys##0, values##0);
    // TrCallStmt: After ProcessCallStmt
    right#0 := $rhs##0;
    defass#right#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](480,123)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](482,19)
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.contents];
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    $rhs#0 := #KMBtree.NodeContents.Leaf(nleft#0, 
      KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
      KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
    $Heap := update($Heap, node#0, KMBtree.Node.contents, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](482,74)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](483,41)
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Leaf_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.keys(read(old($Heap), node#0, KMBtree.Node.contents))
       != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Leaf_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume 0 <= KMBtree.NodeContents.nkeys(read(old($Heap), node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nkeys(read(old($Heap), node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.keys(read(old($Heap), node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##1 := Seq#Take(Seq#FromArray(old($Heap), 
        KMBtree.NodeContents.keys(read(old($Heap), node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nkeys(read(old($Heap), node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##1 := nleft#0 - 1;
    assume true;
    // ProcessCallStmt: CheckSubrange
    j##1 := nleft#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLt(run##1, i##1, j##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](483,120)"} true;
    assert defass#right#0;
}



// function declaration for KMBtree._default.ObjectIsInSubtree
function KMBtree.__default.ObjectIsInSubtree($heap: Heap, node#0: ref, o#0: ref, i#0: int) : bool;

function KMBtree.__default.ObjectIsInSubtree#canCall($heap: Heap, node#0: ref, o#0: ref, i#0: int) : bool;

// frame axiom for KMBtree.__default.ObjectIsInSubtree
axiom (forall $h0: Heap, $h1: Heap, node#0: ref, o#0: ref, i#0: int :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.ObjectIsInSubtree($h1, node#0, o#0, i#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.ObjectIsInSubtree#canCall($h0, node#0, o#0, i#0)
         || ($Is(node#0, Tclass.KMBtree.Node()) && $Is(o#0, Tclass._System.object())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($h0, node#0, KMBtree.Node.repr)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.ObjectIsInSubtree($h0, node#0, o#0, i#0)
       == KMBtree.__default.ObjectIsInSubtree($h1, node#0, o#0, i#0));

// consequence axiom for KMBtree.__default.ObjectIsInSubtree
axiom 42 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref, o#0: ref, i#0: int :: 
    { KMBtree.__default.ObjectIsInSubtree($Heap, node#0, o#0, i#0) } 
    KMBtree.__default.ObjectIsInSubtree#canCall($Heap, node#0, o#0, i#0)
         || (42 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && $Is(o#0, Tclass._System.object())
           && 
          KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           && KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= i#0
           && i#0 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)))
       ==> true);

function KMBtree.__default.ObjectIsInSubtree#requires(Heap, ref, ref, int) : bool;

// #requires axiom for KMBtree.__default.ObjectIsInSubtree
axiom (forall $Heap: Heap, node#0: ref, o#0: ref, i#0: int :: 
  { KMBtree.__default.ObjectIsInSubtree#requires($Heap, node#0, o#0, i#0) } 
  $IsGoodHeap($Heap)
       && $Is(node#0, Tclass.KMBtree.Node())
       && $Is(o#0, Tclass._System.object())
     ==> KMBtree.__default.ObjectIsInSubtree#requires($Heap, node#0, o#0, i#0)
       == (
        KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
         && KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
         && 
        LitInt(0) <= i#0
         && i#0 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));

// definition axiom for KMBtree.__default.ObjectIsInSubtree(revealed)
axiom 42 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref, o#0: ref, i#0: int :: 
    { KMBtree.__default.ObjectIsInSubtree($Heap, node#0, o#0, i#0) } 
    KMBtree.__default.ObjectIsInSubtree#canCall($Heap, node#0, o#0, i#0)
         || (42 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && $Is(o#0, Tclass._System.object())
           && 
          KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           && KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= i#0
           && i#0 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)))
       ==> KMBtree.__default.ObjectIsInSubtree($Heap, node#0, o#0, i#0)
         == read($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#0))): ref, 
          KMBtree.Node.repr)[$Box(o#0)]);

procedure CheckWellformed$$KMBtree.__default.ObjectIsInSubtree(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()), 
    o#0: ref where $Is(o#0, Tclass._System.object()), 
    i#0: int);
  free requires 42 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.SubRepr
function KMBtree.__default.SubRepr($heap: Heap, node#0: ref, from#0: int, to#0: int) : Set Box;

function KMBtree.__default.SubRepr#canCall($heap: Heap, node#0: ref, from#0: int, to#0: int) : bool;

// frame axiom for KMBtree.__default.SubRepr
axiom (forall $h0: Heap, $h1: Heap, node#0: ref, from#0: int, to#0: int :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.SubRepr($h1, node#0, from#0, to#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.SubRepr#canCall($h0, node#0, from#0, to#0)
         || $Is(node#0, Tclass.KMBtree.Node()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($h0, node#0, KMBtree.Node.repr)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.SubRepr($h0, node#0, from#0, to#0)
       == KMBtree.__default.SubRepr($h1, node#0, from#0, to#0));

// consequence axiom for KMBtree.__default.SubRepr
axiom 43 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref, from#0: int, to#0: int :: 
    { KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0) } 
    KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0)
         || (43 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           && KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0
             <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)))
       ==> $Is(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
        TSet(Tclass._System.object())));

function KMBtree.__default.SubRepr#requires(Heap, ref, int, int) : bool;

// #requires axiom for KMBtree.__default.SubRepr
axiom (forall $Heap: Heap, node#0: ref, from#0: int, to#0: int :: 
  { KMBtree.__default.SubRepr#requires($Heap, node#0, from#0, to#0) } 
  $IsGoodHeap($Heap) && $Is(node#0, Tclass.KMBtree.Node())
     ==> KMBtree.__default.SubRepr#requires($Heap, node#0, from#0, to#0)
       == (
        KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
         && KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0
           <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));

// definition axiom for KMBtree.__default.SubRepr(revealed)
axiom 43 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, node#0: ref, from#0: int, to#0: int :: 
    { KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0) } 
    KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0)
         || (43 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(node#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           && KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0
             <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)))
       ==> KMBtree.__default.SeqRepr#canCall($Heap, 
          Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
              to#0), 
            from#0))
         && KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0)
           == KMBtree.__default.SeqRepr(StartFuel_KMBtree._default.SeqRepr, 
            $Heap, 
            Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
                to#0), 
              from#0)));

procedure CheckWellformed$$KMBtree.__default.SubRepr(node#0: ref where $Is(node#0, Tclass.KMBtree.Node()), from#0: int, to#0: int)
   returns (result#0: Set Box where $Is(result#0, TSet(Tclass._System.object())));
  free requires 43 == $FunctionContextHeight;
  modifies $Heap, $Tick;



// function declaration for KMBtree._default.DisjointSubtrees
function KMBtree.__default.DisjointSubtrees($heap: Heap, contents#0: DatatypeType, i#0: int, j#0: int) : bool;

function KMBtree.__default.DisjointSubtrees#canCall($heap: Heap, contents#0: DatatypeType, i#0: int, j#0: int) : bool;

// frame axiom for KMBtree.__default.DisjointSubtrees
axiom (forall $h0: Heap, $h1: Heap, contents#0: DatatypeType, i#0: int, j#0: int :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), KMBtree.__default.DisjointSubtrees($h1, contents#0, i#0, j#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (KMBtree.__default.DisjointSubtrees#canCall($h0, contents#0, i#0, j#0)
         || $Is(contents#0, Tclass.KMBtree.NodeContents()))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (
            $o == KMBtree.NodeContents.children(contents#0)
             || $o
               == $Unbox(read($h0, KMBtree.NodeContents.children(contents#0), IndexField(i#0))): ref
             || $o
               == $Unbox(read($h0, KMBtree.NodeContents.children(contents#0), IndexField(j#0))): ref)
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> KMBtree.__default.DisjointSubtrees($h0, contents#0, i#0, j#0)
       == KMBtree.__default.DisjointSubtrees($h1, contents#0, i#0, j#0));

// consequence axiom for KMBtree.__default.DisjointSubtrees
axiom 44 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, contents#0: DatatypeType, i#0: int, j#0: int :: 
    { KMBtree.__default.DisjointSubtrees($Heap, contents#0, i#0, j#0) } 
    KMBtree.__default.DisjointSubtrees#canCall($Heap, contents#0, i#0, j#0)
         || (44 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(contents#0, Tclass.KMBtree.NodeContents())
           && 
          KMBtree.NodeContents.Index_q(contents#0)
           && 
          LitInt(0) <= i#0
           && i#0 < KMBtree.NodeContents.nchildren(contents#0)
           && 
          LitInt(0) <= j#0
           && j#0 < KMBtree.NodeContents.nchildren(contents#0)
           && KMBtree.NodeContents.nchildren(contents#0)
             <= _System.array.Length(KMBtree.NodeContents.children(contents#0))
           && (forall l#0: int :: 
            { $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(l#0))): ref } 
            LitInt(0) <= l#0 && l#0 < 18446744073709551616
               ==> 
              LitInt(0) <= l#0 && l#0 < KMBtree.NodeContents.nchildren(contents#0)
               ==> $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(l#0))): ref
                 != null)
           && $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(j#0))): ref
             != null)
       ==> true);

function KMBtree.__default.DisjointSubtrees#requires(Heap, DatatypeType, int, int) : bool;

// #requires axiom for KMBtree.__default.DisjointSubtrees
axiom (forall $Heap: Heap, contents#0: DatatypeType, i#0: int, j#0: int :: 
  { KMBtree.__default.DisjointSubtrees#requires($Heap, contents#0, i#0, j#0) } 
  $IsGoodHeap($Heap) && $Is(contents#0, Tclass.KMBtree.NodeContents())
     ==> KMBtree.__default.DisjointSubtrees#requires($Heap, contents#0, i#0, j#0)
       == (
        KMBtree.NodeContents.Index_q(contents#0)
         && 
        LitInt(0) <= i#0
         && i#0 < KMBtree.NodeContents.nchildren(contents#0)
         && 
        LitInt(0) <= j#0
         && j#0 < KMBtree.NodeContents.nchildren(contents#0)
         && KMBtree.NodeContents.nchildren(contents#0)
           <= _System.array.Length(KMBtree.NodeContents.children(contents#0))
         && (forall l#1: int :: 
          { $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(l#1))): ref } 
          LitInt(0) <= l#1 && l#1 < 18446744073709551616
             ==> 
            LitInt(0) <= l#1 && l#1 < KMBtree.NodeContents.nchildren(contents#0)
             ==> $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(l#1))): ref
               != null)
         && $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(j#0))): ref
           != null));

// definition axiom for KMBtree.__default.DisjointSubtrees(revealed)
axiom 44 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, contents#0: DatatypeType, i#0: int, j#0: int :: 
    { KMBtree.__default.DisjointSubtrees($Heap, contents#0, i#0, j#0) } 
    KMBtree.__default.DisjointSubtrees#canCall($Heap, contents#0, i#0, j#0)
         || (44 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && $Is(contents#0, Tclass.KMBtree.NodeContents())
           && 
          KMBtree.NodeContents.Index_q(contents#0)
           && 
          LitInt(0) <= i#0
           && i#0 < KMBtree.NodeContents.nchildren(contents#0)
           && 
          LitInt(0) <= j#0
           && j#0 < KMBtree.NodeContents.nchildren(contents#0)
           && KMBtree.NodeContents.nchildren(contents#0)
             <= _System.array.Length(KMBtree.NodeContents.children(contents#0))
           && (forall l#1: int :: 
            { $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(l#1))): ref } 
            LitInt(0) <= l#1 && l#1 < 18446744073709551616
               ==> 
              LitInt(0) <= l#1 && l#1 < KMBtree.NodeContents.nchildren(contents#0)
               ==> $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(l#1))): ref
                 != null)
           && $Unbox(read($Heap, KMBtree.NodeContents.children(contents#0), IndexField(j#0))): ref
             != null)
       ==> KMBtree.__default.DisjointReprs#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(contents#0)), 
            KMBtree.NodeContents.nchildren(contents#0)), 
          i#0, 
          j#0)
         && KMBtree.__default.DisjointSubtrees($Heap, contents#0, i#0, j#0)
           == KMBtree.__default.DisjointReprs($Heap, 
            Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(contents#0)), 
              KMBtree.NodeContents.nchildren(contents#0)), 
            i#0, 
            j#0));

procedure CheckWellformed$$KMBtree.__default.DisjointSubtrees(contents#0: DatatypeType where $Is(contents#0, Tclass.KMBtree.NodeContents()), 
    i#0: int, 
    j#0: int);
  free requires 44 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.SubReprsDisjoint(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from1#0: int, 
    to1#0: int, 
    from2#0: int, 
    to2#0: int);
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.SubReprsDisjoint(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from1#0: int, 
    to1#0: int, 
    from2#0: int, 
    to2#0: int);
  // user-defined preconditions
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#2)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#2)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#2 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#10: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#10))): ref } 
              LitInt(0) <= i#10 && i#10 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#10 && i#10 < nchildren#2
                 ==> $Unbox(read($Heap, children#2, IndexField(i#10))): ref != null))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#11: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#11))): ref } 
              LitInt(0) <= i#11 && i#11 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#11 && i#11 < nchildren#2
                 ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#12: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#12))): ref } 
              LitInt(0) <= i#12 && i#12 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#12 && i#12 < nchildren#2
                 ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#12))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#13: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                  { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#2
                   ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#13: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                  { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#2
                   ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
               ==> (forall i#14: int :: 
                { $Unbox(read($Heap, children#2, IndexField(i#14))): ref } 
                LitInt(0) <= i#14 && i#14 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#14 && i#14 < nchildren#2
                   ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#14))): ref, KMBtree.Node.repr)[$Box(children#2)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from1#0;
  requires from1#0 <= to1#0;
  requires to1#0 <= from2#0;
  requires from2#0 <= to2#0;
  requires to2#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SubRepr#canCall($Heap, node#0, from1#0, to1#0)
     && KMBtree.__default.SubRepr#canCall($Heap, node#0, from2#0, to2#0);
  ensures Set#Disjoint(KMBtree.__default.SubRepr($Heap, node#0, from1#0, to1#0), 
    KMBtree.__default.SubRepr($Heap, node#0, from2#0, to2#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.SubReprsDisjoint(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from1#0: int, 
    to1#0: int, 
    from2#0: int, 
    to2#0: int)
   returns ($_reverifyPost: bool);
  free requires 45 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#3
                 && nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#19: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from1#0;
  requires from1#0 <= to1#0;
  requires to1#0 <= from2#0;
  requires from2#0 <= to2#0;
  requires to2#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SubRepr#canCall($Heap, node#0, from1#0, to1#0)
     && KMBtree.__default.SubRepr#canCall($Heap, node#0, from2#0, to2#0);
  ensures $_reverifyPost
     ==> Set#Disjoint(KMBtree.__default.SubRepr($Heap, node#0, from1#0, to1#0), 
      KMBtree.__default.SubRepr($Heap, node#0, from2#0, to2#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.SubReprsDisjoint(node#0: ref, from1#0: int, to1#0: int, from2#0: int, to2#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var ##nodes#0: Seq Box;
  var nodes##0: Seq Box;
  var lo1##0: int;
  var hi1##0: int;
  var lo2##0: int;
  var hi2##0: int;

    // AddMethodImpl: SubReprsDisjoint, Impl$$KMBtree.__default.SubReprsDisjoint
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](525,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), $initHeapForallStmt#0, $ih#node0#0)
           && KMBtree.NodeContents.Index_q(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= from1#0
           && from1#0 <= to1#0
           && to1#0 <= from2#0
           && from2#0 <= to2#0
           && to2#0
             <= KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && (($ih#node0#0 == null && node#0 != null)
             || (($ih#node0#0 != null <==> node#0 != null)
               && ((0 <= from1#0 && from1#0 < from1#0)
                 || (from1#0 == from1#0
                   && ((0 <= to1#0 && to1#0 < to1#0)
                     || (to1#0 == to1#0
                       && ((0 <= from2#0 && from2#0 < from2#0)
                         || (from2#0 == from2#0 && 0 <= to2#0 && to2#0 < to2#0))))))))
         ==> Set#Disjoint(KMBtree.__default.SubRepr($Heap, $ih#node0#0, from1#0, to1#0), 
          KMBtree.__default.SubRepr($Heap, $ih#node0#0, from2#0, to2#0)));
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](526,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} 0 <= from1#0
       && from1#0
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume {:subsumption 0} from1#0 <= to1#0
       && to1#0
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} 0 <= from1#0
       && from1#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} from1#0 <= to1#0
       && to1#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          to1#0), 
        from1#0), 
      Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
          to1#0), 
        from1#0));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](528,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} 0 <= from2#0
       && from2#0
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume {:subsumption 0} from2#0 <= to2#0
       && to2#0
         <= Seq#Length(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} 0 <= from2#0
       && from2#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} from2#0 <= to2#0
       && to2#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          to2#0), 
        from2#0), 
      Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
          to2#0), 
        from2#0));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](530,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.WFShapeSiblings#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume KMBtree.__default.WFShapeSiblings#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeSiblings($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](533,35)
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    nodes##0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    lo1##0 := from1#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    hi1##0 := to1#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    lo2##0 := from2#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    hi2##0 := to2#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.DisjointSubSeqReprsAreDisjoint(nodes##0, lo1##0, hi1##0, lo2##0, hi2##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](533,109)"} true;
}



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.SubReprUpperBound(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int, 
    to#0: int);
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.SubReprUpperBound(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int, 
    to#0: int);
  // user-defined preconditions
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#2)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#2)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#2 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#10: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#10))): ref } 
              LitInt(0) <= i#10 && i#10 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#10 && i#10 < nchildren#2
                 ==> $Unbox(read($Heap, children#2, IndexField(i#10))): ref != null))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#11: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#11))): ref } 
              LitInt(0) <= i#11 && i#11 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#11 && i#11 < nchildren#2
                 ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#12: int :: 
              { $Unbox(read($Heap, children#2, IndexField(i#12))): ref } 
              LitInt(0) <= i#12 && i#12 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#12 && i#12 < nchildren#2
                 ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#12))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#13: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                  { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#2
                   ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#13: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                  { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#2
                   ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
               ==> (forall i#14: int :: 
                { $Unbox(read($Heap, children#2, IndexField(i#14))): ref } 
                LitInt(0) <= i#14 && i#14 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#14 && i#14 < nchildren#2
                   ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#14))): ref, KMBtree.Node.repr)[$Box(children#2)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires 1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
  ensures Set#Subset(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
    Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
          $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
        $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))))));
  free ensures to#0 - from#0
       < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
     ==> KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
  ensures to#0 - from#0
       < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
     ==> Set#Subset(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
        Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))))))
       && !Set#Subset(Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))))), 
        KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.SubReprUpperBound(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int, 
    to#0: int)
   returns ($_reverifyPost: bool);
  free requires 46 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#3
                 && nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#19: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires 1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
  ensures $_reverifyPost
     ==> Set#Subset(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
      Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
            $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
          $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))))));
  free ensures to#0 - from#0
       < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
     ==> KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
  ensures $_reverifyPost
     ==> 
    to#0 - from#0
       < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
     ==> Set#Subset(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
        Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))))))
       && !Set#Subset(Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))))), 
        KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.SubReprUpperBound(node#0: ref, from#0: int, to#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var subrepr#0: Set Box
     where $Is(subrepr#0, TSet(Tclass._System.object()))
       && $IsAlloc(subrepr#0, TSet(Tclass._System.object()), $Heap);
  var ##node#3: ref;
  var ##from#2: int;
  var ##to#2: int;
  var nchildren#5: int
     where LitInt(0) <= nchildren#5 && nchildren#5 < 18446744073709551616;
  var pivots#0: ref
     where $Is(pivots#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(pivots#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var children#5: ref
     where $Is(children#5, Tclass._System.array?(Tclass.KMBtree.Node?()))
       && $IsAlloc(children#5, Tclass._System.array?(Tclass.KMBtree.Node?()), $Heap);
  var o#0: ref;
  var i#25: int;
  var ##nodes#0_0: Seq Box;
  var ##parentRepr#0_0: Set Box;
  var ##parentHeight#0_0: int;
  var ##node#0_0: ref;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var ##node#0_1: ref;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var newtype$check#0_5: int;
  var o#0_0_0: ref;
  var i#0_0_0: int;
  var ##contents#0_0_0: DatatypeType;
  var ##i#0_0_0: int;
  var ##j#0_0_0: int;
  var o#0_0: ref;
  var i#0_11: int;
  var ##contents#0_0: DatatypeType;
  var ##i#0_0: int;
  var ##j#0_0: int;
  var wit#0_0: ref
     where $Is(wit#0_0, Tclass._System.object())
       && $IsAlloc(wit#0_0, Tclass._System.object(), $Heap);
  var newtype$check#0_6: int;
  var newtype$check#0_7: int;

    // AddMethodImpl: SubReprUpperBound, Impl$$KMBtree.__default.SubReprUpperBound
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](543,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), $initHeapForallStmt#0, $ih#node0#0)
           && KMBtree.NodeContents.Index_q(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && 1
             < KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0
             <= KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && (($ih#node0#0 == null && node#0 != null)
             || (($ih#node0#0 != null <==> node#0 != null)
               && ((0 <= from#0 && from#0 < from#0)
                 || (from#0 == from#0 && 0 <= to#0 && to#0 < to#0))))
         ==> Set#Subset(KMBtree.__default.SubRepr($Heap, $ih#node0#0, from#0, to#0), 
            Set#Difference(read($Heap, $ih#node0#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box($ih#node0#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, $ih#node0#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents))))))
           && (to#0 - from#0
               < KMBtree.NodeContents.nchildren(read($Heap, $ih#node0#0, KMBtree.Node.contents))
             ==> Set#Subset(KMBtree.__default.SubRepr($Heap, $ih#node0#0, from#0, to#0), 
                Set#Difference(read($Heap, $ih#node0#0, KMBtree.Node.repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box($ih#node0#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, $ih#node0#0, KMBtree.Node.contents)))), 
                    $Box(KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents))))))
               && !Set#Subset(Set#Difference(read($Heap, $ih#node0#0, KMBtree.Node.repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box($ih#node0#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, $ih#node0#0, KMBtree.Node.contents)))), 
                    $Box(KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents))))), 
                KMBtree.__default.SubRepr($Heap, $ih#node0#0, from#0, to#0))));
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](544,19)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__SeqRepr();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](544,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](546,17)
    assume true;
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    ##from#2 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#2, TInt, $Heap);
    ##to#2 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#2, TInt, $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume true;
    assume KMBtree.NodeContents.Index_q(read($Heap, ##node#3, KMBtree.Node.contents));
    assume true;
    assume true;
    assume true;
    assume LitInt(0) <= ##from#2
       && ##from#2 <= ##to#2
       && ##to#2
         <= KMBtree.NodeContents.nchildren(read($Heap, ##node#3, KMBtree.Node.contents));
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
    subrepr#0 := KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](546,42)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](547,19)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](547,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](548,16)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    pivots#0 := KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](548,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](549,18)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](549,42)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](551,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc o#0;
        assume $Is(o#0, Tclass._System.object());
        assume true;
        assume subrepr#0[$Box(o#0)];
        // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](554,13)
        assume true;
        havoc i#25;
        if (from#0 <= i#25)
        {
        }

        if (from#0 <= i#25 && i#25 < to#0)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
            assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
               != null;
            assume {:subsumption 0} 0 <= i#25
               && i#25
                 < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
            assume {:subsumption 0} $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#25))): ref
               != null;
        }

        assume true;
        assume ($Is(to#0 - 1, TInt)
             && 
            from#0 <= to#0 - 1
             && to#0 - 1 < to#0
             && read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(to#0 - 1))): ref, 
              KMBtree.Node.repr)[$Box(o#0)])
           || 
          ($Is(from#0, TInt)
             && 
            from#0 <= from#0
             && from#0 < to#0
             && read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(from#0))): ref, 
              KMBtree.Node.repr)[$Box(o#0)])
           || 
          ($Is(LitInt(0), TInt)
             && 
            from#0 <= LitInt(0)
             && 0 < to#0
             && read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(LitInt(0)))): ref, 
              KMBtree.Node.repr)[$Box(o#0)])
           || (exists $as#i0#0: int :: 
            from#0 <= $as#i0#0
               && $as#i0#0 < to#0
               && read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField($as#i0#0))): ref, 
                KMBtree.Node.repr)[$Box(o#0)]);
        assume from#0 <= i#25
           && i#25 < to#0
           && read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#25))): ref, 
            KMBtree.Node.repr)[$Box(o#0)];
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](554,68)"} true;
        assume read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0)];
        assume false;
    }
    else
    {
        assume (forall o#1: ref :: 
          { read($Heap, node#0, KMBtree.Node.repr)[$Box(o#1)] } { subrepr#0[$Box(o#1)] } 
          $Is(o#1, Tclass._System.object()) && subrepr#0[$Box(o#1)]
             ==> read($Heap, node#0, KMBtree.Node.repr)[$Box(o#1)]);
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](555,4)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](556,5)
    assume {:subsumption 0} node#0 != null;
    assume true;
    assume Set#Subset(subrepr#0, read($Heap, node#0, KMBtree.Node.repr));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](557,5)
    assume true;
    assume !subrepr#0[$Box(pivots#0)];
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](558,5)
    assume true;
    assume !subrepr#0[$Box(children#5)];
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](559,5)
    assume {:subsumption 0} node#0 != null;
    assume true;
    assume Set#Subset(subrepr#0, 
      Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), $Box(pivots#0)), 
          $Box(children#5))));
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](561,5)
    assume true;
    if (to#0 - from#0 < nchildren#5)
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](562,7)
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
        assume {:subsumption 0} node#0 != null;
        assume {:subsumption 0} node#0 != null;
        assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          TSeq(Tclass.KMBtree.Node()));
        ##nodes#0_0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
        // assume allocatedness for argument to function
        assume $IsAlloc(##nodes#0_0, TSeq(Tclass.KMBtree.Node()), $Heap);
        ##parentRepr#0_0 := read($Heap, node#0, KMBtree.Node.repr);
        // assume allocatedness for argument to function
        assume $IsAlloc(##parentRepr#0_0, TSet(Tclass._System.object()), $Heap);
        ##parentHeight#0_0 := read($Heap, node#0, KMBtree.Node.height);
        // assume allocatedness for argument to function
        assume $IsAlloc(##parentHeight#0_0, Tclass._System.nat(), $Heap);
        assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
          $Heap, 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
          read($Heap, node#0, KMBtree.Node.repr), 
          read($Heap, node#0, KMBtree.Node.height));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](563,7)
        assume children#5 != null;
        assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < _System.array.Length(children#5);
        assume $Is($Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref, 
          Tclass.KMBtree.Node());
        ##node#0_0 := $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_0, Tclass.KMBtree.Node(), $Heap);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LS($LZ)), 
          $Heap, 
          $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](564,7)
        assume children#5 != null;
        newtype$check#0_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := nchildren#5 - 1;
        assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume {:subsumption 0} 0 <= nchildren#5 - 1 && nchildren#5 - 1 < _System.array.Length(children#5);
        assume $Is($Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
          Tclass.KMBtree.Node());
        ##node#0_1 := $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_1, Tclass.KMBtree.Node(), $Heap);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LS($LZ)), 
          $Heap, 
          $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](565,7)
        assume children#5 != null;
        assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < _System.array.Length(children#5);
        assume {:subsumption 0} $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref != null;
        assume {:subsumption 0} node#0 != null;
        assume true;
        assume Set#Subset(read($Heap, 
              $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref, 
              KMBtree.Node.repr), 
            read($Heap, node#0, KMBtree.Node.repr))
           && !Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
            read($Heap, 
              $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref, 
              KMBtree.Node.repr));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](566,7)
        assume children#5 != null;
        assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < _System.array.Length(children#5);
        assume {:subsumption 0} $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref != null;
        assume true;
        assume !Set#Equal(read($Heap, 
            $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref, 
            KMBtree.Node.repr), 
          Set#Empty(): Set Box);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](567,7)
        assume children#5 != null;
        newtype$check#0_2 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        newtype$check#0_3 := nchildren#5 - 1;
        assume LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume {:subsumption 0} 0 <= nchildren#5 - 1 && nchildren#5 - 1 < _System.array.Length(children#5);
        assume {:subsumption 0} $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref != null;
        assume {:subsumption 0} node#0 != null;
        assume true;
        assume Set#Subset(read($Heap, 
              $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
              KMBtree.Node.repr), 
            read($Heap, node#0, KMBtree.Node.repr))
           && !Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
            read($Heap, 
              $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
              KMBtree.Node.repr));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](568,7)
        assume children#5 != null;
        newtype$check#0_4 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        newtype$check#0_5 := nchildren#5 - 1;
        assume LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        assume {:subsumption 0} 0 <= nchildren#5 - 1 && nchildren#5 - 1 < _System.array.Length(children#5);
        assume {:subsumption 0} $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref != null;
        assume true;
        assume !Set#Equal(read($Heap, 
            $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
            KMBtree.Node.repr), 
          Set#Empty(): Set Box);
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](569,7)
        assume true;
        if (0 < from#0)
        {
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](570,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc o#0_0_0;
                assume $Is(o#0_0_0, Tclass._System.object());
                assume true;
                assume subrepr#0[$Box(o#0_0_0)];
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](573,11)
                assume true;
                if (o#0_0_0 == pivots#0)
                {
                }
                else
                {
                    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](574,18)
                    assume true;
                    if (o#0_0_0 == children#5)
                    {
                    }
                    else
                    {
                        // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](576,19)
                        assume true;
                        havoc i#0_0_0;
                        if (from#0 <= i#0_0_0)
                        {
                        }

                        if (from#0 <= i#0_0_0 && i#0_0_0 < to#0)
                        {
                            assume {:subsumption 0} node#0 != null;
                        }

                        if (from#0 <= i#0_0_0
                           && i#0_0_0 < to#0
                           && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0_0)])
                        {
                            assume {:subsumption 0} node#0 != null;
                            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
                            assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
                               != null;
                            assume {:subsumption 0} 0 <= i#0_0_0
                               && i#0_0_0
                                 < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
                            assume {:subsumption 0} $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(i#0_0_0))): ref
                               != null;
                        }

                        assume true;
                        assume ($Is(to#0 - 1, TInt)
                             && 
                            from#0 <= to#0 - 1
                             && to#0 - 1 < to#0
                             && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0_0)]
                             && read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(to#0 - 1))): ref, 
                              KMBtree.Node.repr)[$Box(o#0_0_0)])
                           || 
                          ($Is(from#0, TInt)
                             && 
                            from#0 <= from#0
                             && from#0 < to#0
                             && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0_0)]
                             && read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(from#0))): ref, 
                              KMBtree.Node.repr)[$Box(o#0_0_0)])
                           || 
                          ($Is(LitInt(0), TInt)
                             && 
                            from#0 <= LitInt(0)
                             && 0 < to#0
                             && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0_0)]
                             && read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(LitInt(0)))): ref, 
                              KMBtree.Node.repr)[$Box(o#0_0_0)])
                           || (exists $as#i0_0_0#0_0_0: int :: 
                            from#0 <= $as#i0_0_0#0_0_0
                               && $as#i0_0_0#0_0_0 < to#0
                               && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0_0)]
                               && read($Heap, 
                                $Unbox(read($Heap, 
                                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                    IndexField($as#i0_0_0#0_0_0))): ref, 
                                KMBtree.Node.repr)[$Box(o#0_0_0)]);
                        assume from#0 <= i#0_0_0
                           && i#0_0_0 < to#0
                           && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0_0)]
                           && read($Heap, 
                            $Unbox(read($Heap, 
                                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(i#0_0_0))): ref, 
                            KMBtree.Node.repr)[$Box(o#0_0_0)];
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](576,92)"} true;
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](577,13)
                        assume {:subsumption 0} node#0 != null;
                        ##contents#0_0_0 := read($Heap, node#0, KMBtree.Node.contents);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##contents#0_0_0, Tclass.KMBtree.NodeContents(), $Heap);
                        ##i#0_0_0 := LitInt(0);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##i#0_0_0, TInt, $Heap);
                        ##j#0_0_0 := i#0_0_0;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##j#0_0_0, TInt, $Heap);
                        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0_0_0);
                        assume {:subsumption 0} LitInt(0) <= ##i#0_0_0;
                        assume {:subsumption 0} ##i#0_0_0 < KMBtree.NodeContents.nchildren(##contents#0_0_0);
                        assume {:subsumption 0} LitInt(0) <= ##j#0_0_0;
                        assume {:subsumption 0} ##j#0_0_0 < KMBtree.NodeContents.nchildren(##contents#0_0_0);
                        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0_0_0)
                           <= _System.array.Length(KMBtree.NodeContents.children(##contents#0_0_0));
                        assume {:subsumption 0} (forall l#0_0_0: int :: 
                          { $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0_0_0), IndexField(l#0_0_0))): ref } 
                          LitInt(0) <= l#0_0_0 && l#0_0_0 < 18446744073709551616
                             ==> 
                            LitInt(0) <= l#0_0_0
                               && l#0_0_0 < KMBtree.NodeContents.nchildren(##contents#0_0_0)
                             ==> $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0_0_0), IndexField(l#0_0_0))): ref
                               != null);
                        assume {:subsumption 0} $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0_0_0), IndexField(##j#0_0_0))): ref
                           != null;
                        assume KMBtree.__default.DisjointSubtrees#canCall($Heap, read($Heap, node#0, KMBtree.Node.contents), LitInt(0), i#0_0_0);
                        assume KMBtree.__default.DisjointSubtrees#canCall($Heap, read($Heap, node#0, KMBtree.Node.contents), LitInt(0), i#0_0_0);
                        assume true;
                        assume KMBtree.__default.DisjointSubtrees($Heap, read($Heap, node#0, KMBtree.Node.contents), LitInt(0), i#0_0_0);
                    }
                }

                assume !read($Heap, 
                  $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref, 
                  KMBtree.Node.repr)[$Box(o#0_0_0)];
                assume false;
            }
            else
            {
                assume (forall o#0_0_1: ref :: 
                  { read($Heap, $Unbox(read($Heap, children#5, IndexField(0))): ref, KMBtree.Node.repr)[$Box(o#0_0_1)] } 
                    { subrepr#0[$Box(o#0_0_1)] } 
                  $Is(o#0_0_1, Tclass._System.object()) && subrepr#0[$Box(o#0_0_1)]
                     ==> !read($Heap, 
                      $Unbox(read($Heap, children#5, IndexField(LitInt(0)))): ref, 
                      KMBtree.Node.repr)[$Box(o#0_0_1)]);
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](579,8)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](580,9)
            assume {:subsumption 0} node#0 != null;
            assume true;
            assume Set#Subset(subrepr#0, 
                Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), $Box(pivots#0)), 
                    $Box(children#5))))
               && !Set#Subset(Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), $Box(pivots#0)), 
                    $Box(children#5))), 
                subrepr#0);
        }
        else
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](582,9)
            assume true;
            assume to#0 < nchildren#5;
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](583,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc o#0_0;
                assume $Is(o#0_0, Tclass._System.object());
                assume true;
                assume subrepr#0[$Box(o#0_0)];
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](586,11)
                assume true;
                if (o#0_0 == pivots#0)
                {
                }
                else
                {
                    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](587,18)
                    assume true;
                    if (o#0_0 == children#5)
                    {
                    }
                    else
                    {
                        // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](589,19)
                        assume true;
                        havoc i#0_11;
                        if (from#0 <= i#0_11)
                        {
                        }

                        if (from#0 <= i#0_11 && i#0_11 < to#0)
                        {
                            assume {:subsumption 0} node#0 != null;
                        }

                        if (from#0 <= i#0_11
                           && i#0_11 < to#0
                           && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0)])
                        {
                            assume {:subsumption 0} node#0 != null;
                            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
                            assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
                               != null;
                            assume {:subsumption 0} 0 <= i#0_11
                               && i#0_11
                                 < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
                            assume {:subsumption 0} $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(i#0_11))): ref
                               != null;
                        }

                        assume true;
                        assume ($Is(to#0 - 1, TInt)
                             && 
                            from#0 <= to#0 - 1
                             && to#0 - 1 < to#0
                             && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0)]
                             && read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(to#0 - 1))): ref, 
                              KMBtree.Node.repr)[$Box(o#0_0)])
                           || 
                          ($Is(from#0, TInt)
                             && 
                            from#0 <= from#0
                             && from#0 < to#0
                             && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0)]
                             && read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(from#0))): ref, 
                              KMBtree.Node.repr)[$Box(o#0_0)])
                           || 
                          ($Is(LitInt(0), TInt)
                             && 
                            from#0 <= LitInt(0)
                             && 0 < to#0
                             && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0)]
                             && read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(LitInt(0)))): ref, 
                              KMBtree.Node.repr)[$Box(o#0_0)])
                           || (exists $as#i0_0#0_0: int :: 
                            from#0 <= $as#i0_0#0_0
                               && $as#i0_0#0_0 < to#0
                               && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0)]
                               && read($Heap, 
                                $Unbox(read($Heap, 
                                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                    IndexField($as#i0_0#0_0))): ref, 
                                KMBtree.Node.repr)[$Box(o#0_0)]);
                        assume from#0 <= i#0_11
                           && i#0_11 < to#0
                           && read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0_0)]
                           && read($Heap, 
                            $Unbox(read($Heap, 
                                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(i#0_11))): ref, 
                            KMBtree.Node.repr)[$Box(o#0_0)];
                        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](589,92)"} true;
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](590,13)
                        assume {:subsumption 0} node#0 != null;
                        ##contents#0_0 := read($Heap, node#0, KMBtree.Node.contents);
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##contents#0_0, Tclass.KMBtree.NodeContents(), $Heap);
                        ##i#0_0 := i#0_11;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##i#0_0, TInt, $Heap);
                        ##j#0_0 := nchildren#5 - 1;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##j#0_0, TInt, $Heap);
                        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0_0);
                        assume {:subsumption 0} LitInt(0) <= ##i#0_0;
                        assume {:subsumption 0} ##i#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
                        assume {:subsumption 0} LitInt(0) <= ##j#0_0;
                        assume {:subsumption 0} ##j#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
                        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0_0)
                           <= _System.array.Length(KMBtree.NodeContents.children(##contents#0_0));
                        assume {:subsumption 0} (forall l#0_0: int :: 
                          { $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref } 
                          LitInt(0) <= l#0_0 && l#0_0 < 18446744073709551616
                             ==> 
                            LitInt(0) <= l#0_0 && l#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0)
                             ==> $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref
                               != null);
                        assume {:subsumption 0} $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0_0), IndexField(##j#0_0))): ref
                           != null;
                        assume KMBtree.__default.DisjointSubtrees#canCall($Heap, read($Heap, node#0, KMBtree.Node.contents), i#0_11, nchildren#5 - 1);
                        assume KMBtree.__default.DisjointSubtrees#canCall($Heap, read($Heap, node#0, KMBtree.Node.contents), i#0_11, nchildren#5 - 1);
                        assume true;
                        assume KMBtree.__default.DisjointSubtrees($Heap, read($Heap, node#0, KMBtree.Node.contents), i#0_11, nchildren#5 - 1);
                    }
                }

                assume !read($Heap, 
                  $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
                  KMBtree.Node.repr)[$Box(o#0_0)];
                assume false;
            }
            else
            {
                assume (forall o#0_1: ref :: 
                  { subrepr#0[$Box(o#0_1)] } 
                  $Is(o#0_1, Tclass._System.object()) && subrepr#0[$Box(o#0_1)]
                     ==> !read($Heap, 
                      $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
                      KMBtree.Node.repr)[$Box(o#0_1)]);
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](592,8)"} true;
            // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](593,17)
            assume true;
            havoc wit#0_0;
            assume children#5 != null;
            newtype$check#0_6 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_6 && newtype$check#0_6 < 18446744073709551616;
            newtype$check#0_7 := nchildren#5 - 1;
            assume LitInt(0) <= newtype$check#0_7 && newtype$check#0_7 < 18446744073709551616;
            assume {:subsumption 0} 0 <= nchildren#5 - 1 && nchildren#5 - 1 < _System.array.Length(children#5);
            assume {:subsumption 0} $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref != null;
            assume true;
            assume ($Is(null, Tclass._System.object())
                 && read($Heap, 
                  $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
                  KMBtree.Node.repr)[$Box(null)])
               || (exists $as#wit0_0#0_0: ref :: 
                $Is($as#wit0_0#0_0, Tclass._System.object())
                   && read($Heap, 
                    $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
                    KMBtree.Node.repr)[$Box($as#wit0_0#0_0)]);
            assume read($Heap, 
              $Unbox(read($Heap, children#5, IndexField(nchildren#5 - 1))): ref, 
              KMBtree.Node.repr)[$Box(wit#0_0)];
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](593,52)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](594,9)
            assume true;
            assume !subrepr#0[$Box(wit#0_0)];
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](595,9)
            assume {:subsumption 0} node#0 != null;
            assume true;
            assume Set#Subset(subrepr#0, 
                Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), $Box(pivots#0)), 
                    $Box(children#5))))
               && !Set#Subset(Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
                  Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), $Box(pivots#0)), 
                    $Box(children#5))), 
                subrepr#0);
        }
    }
    else
    {
    }
}



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.SubReprLowerBound(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int, 
    to#0: int);
  free requires 47 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.SubReprLowerBound(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int, 
    to#0: int);
  // user-defined preconditions
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#1)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#1)));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#1 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#9: int :: 
              { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
              LitInt(0) <= i#9 && i#9 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#9 && i#9 < nchildren#1
                 ==> $Unbox(read($Heap, children#1, IndexField(i#9))): ref != null))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#10: int :: 
              { $Unbox(read($Heap, children#1, IndexField(i#10))): ref } 
              LitInt(0) <= i#10 && i#10 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#10 && i#10 < nchildren#1
                 ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#10))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#11: int :: 
              { $Unbox(read($Heap, children#1, IndexField(i#11))): ref } 
              LitInt(0) <= i#11 && i#11 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#11 && i#11 < nchildren#1
                 ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#12: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                  { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                LitInt(0) <= i#12 && i#12 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#12 && i#12 < nchildren#1
                   ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#12: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref } 
                  { $Unbox(read($Heap, children#1, IndexField(i#12))): ref } 
                LitInt(0) <= i#12 && i#12 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#12 && i#12 < nchildren#1
                   ==> $Unbox(read($Heap, children#1, IndexField(i#12))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#12)): ref)
               ==> (forall i#13: int :: 
                { $Unbox(read($Heap, children#1, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#1
                   ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#13))): ref, KMBtree.Node.repr)[$Box(children#1)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(1)
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall i#1: int :: 
    { $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
    true
       ==> 
      from#0 <= i#1 && i#1 < to#0
       ==> $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref
         != null);
  free ensures (forall i#8: int :: 
    { $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#8))): ref } 
    from#0 <= i#8 && i#8 < to#0
       ==> KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0));
  ensures (forall i#8: int :: 
    { $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#8))): ref } 
    true
       ==> 
      from#0 <= i#8 && i#8 < to#0
       ==> Set#Subset(read($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#8))): ref, 
          KMBtree.Node.repr), 
        KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.SubReprLowerBound(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int, 
    to#0: int)
   returns ($_reverifyPost: bool);
  free requires 47 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#2 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#2)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#2
                 && nchildren#2 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#14: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#14))): ref } 
                  LitInt(0) <= i#14 && i#14 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#14 && i#14 < nchildren#2
                     ==> $Unbox(read($Heap, children#2, IndexField(i#14))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#15: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#15))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#16: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#18: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#18))): ref } 
                  LitInt(0) <= i#18 && i#18 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#18 && i#18 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#18))): ref, KMBtree.Node.repr)[$Box(children#2)]))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(1)
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from#0;
  requires from#0 <= to#0;
  requires to#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures $_reverifyPost
     ==> (forall i#1: int :: 
      { $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref } 
      true
         ==> 
        from#0 <= i#1 && i#1 < to#0
         ==> $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#1))): ref
           != null);
  free ensures (forall i#8: int :: 
    { $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#8))): ref } 
    from#0 <= i#8 && i#8 < to#0
       ==> KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0));
  ensures $_reverifyPost
     ==> (forall i#8: int :: 
      { $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#8))): ref } 
      true
         ==> 
        from#0 <= i#8 && i#8 < to#0
         ==> Set#Subset(read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#8))): ref, 
            KMBtree.Node.repr), 
          KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.SubReprLowerBound(node#0: ref, from#0: int, to#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var subrepr#0: Set Box
     where $Is(subrepr#0, TSet(Tclass._System.object()))
       && $IsAlloc(subrepr#0, TSet(Tclass._System.object()), $Heap);
  var ##node#2: ref;
  var ##from#1: int;
  var ##to#1: int;
  var nchildren#4: int
     where LitInt(0) <= nchildren#4 && nchildren#4 < 18446744073709551616;
  var pivots#0: ref
     where $Is(pivots#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(pivots#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var children#4: ref
     where $Is(children#4, Tclass._System.array?(Tclass.KMBtree.Node?()))
       && $IsAlloc(children#4, Tclass._System.array?(Tclass.KMBtree.Node?()), $Heap);
  var o#0: ref;
  var i#26: int;
  var i#27: int;
  var o#2: ref;

    // AddMethodImpl: SubReprLowerBound, Impl$$KMBtree.__default.SubReprLowerBound
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](607,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), $initHeapForallStmt#0, $ih#node0#0)
           && KMBtree.NodeContents.Index_q(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && LitInt(1)
             <= KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0
             <= KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && (($ih#node0#0 == null && node#0 != null)
             || (($ih#node0#0 != null <==> node#0 != null)
               && ((0 <= from#0 && from#0 < from#0)
                 || (from#0 == from#0 && 0 <= to#0 && to#0 < to#0))))
         ==> (forall i#19: int :: 
            { $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#19))): ref } 
            true
               ==> 
              from#0 <= i#19 && i#19 < to#0
               ==> $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#19))): ref
                 != null)
           && (forall i#20: int :: 
            { $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#20))): ref } 
            true
               ==> 
              from#0 <= i#20 && i#20 < to#0
               ==> Set#Subset(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, $ih#node0#0, KMBtree.Node.contents)), 
                      IndexField(i#20))): ref, 
                  KMBtree.Node.repr), 
                KMBtree.__default.SubRepr($Heap, $ih#node0#0, from#0, to#0))));
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](608,19)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__SeqRepr();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](608,20)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](610,17)
    assume true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    ##from#1 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#1, TInt, $Heap);
    ##to#1 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#1, TInt, $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#2);
    assume true;
    assume KMBtree.NodeContents.Index_q(read($Heap, ##node#2, KMBtree.Node.contents));
    assume true;
    assume true;
    assume true;
    assume LitInt(0) <= ##from#1
       && ##from#1 <= ##to#1
       && ##to#1
         <= KMBtree.NodeContents.nchildren(read($Heap, ##node#2, KMBtree.Node.contents));
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
    subrepr#0 := KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](610,42)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](611,19)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](611,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](612,16)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    pivots#0 := KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](612,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](613,18)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](613,42)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](615,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc o#0;
        assume $Is(o#0, Tclass._System.object());
        assume true;
        assume subrepr#0[$Box(o#0)];
        // ----- assign-such-that statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](618,13)
        assume true;
        havoc i#26;
        if (from#0 <= i#26)
        {
        }

        if (from#0 <= i#26 && i#26 < to#0)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
            assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
               != null;
            assume {:subsumption 0} 0 <= i#26
               && i#26
                 < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
            assume {:subsumption 0} $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#26))): ref
               != null;
        }

        assume true;
        assume ($Is(to#0 - 1, TInt)
             && 
            from#0 <= to#0 - 1
             && to#0 - 1 < to#0
             && read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(to#0 - 1))): ref, 
              KMBtree.Node.repr)[$Box(o#0)])
           || 
          ($Is(from#0, TInt)
             && 
            from#0 <= from#0
             && from#0 < to#0
             && read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(from#0))): ref, 
              KMBtree.Node.repr)[$Box(o#0)])
           || 
          ($Is(LitInt(0), TInt)
             && 
            from#0 <= LitInt(0)
             && 0 < to#0
             && read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(LitInt(0)))): ref, 
              KMBtree.Node.repr)[$Box(o#0)])
           || (exists $as#i0#0: int :: 
            from#0 <= $as#i0#0
               && $as#i0#0 < to#0
               && read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField($as#i0#0))): ref, 
                KMBtree.Node.repr)[$Box(o#0)]);
        assume from#0 <= i#26
           && i#26 < to#0
           && read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#26))): ref, 
            KMBtree.Node.repr)[$Box(o#0)];
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](618,68)"} true;
        assume read($Heap, node#0, KMBtree.Node.repr)[$Box(o#0)];
        assume false;
    }
    else
    {
        assume (forall o#1: ref :: 
          { read($Heap, node#0, KMBtree.Node.repr)[$Box(o#1)] } { subrepr#0[$Box(o#1)] } 
          $Is(o#1, Tclass._System.object()) && subrepr#0[$Box(o#1)]
             ==> read($Heap, node#0, KMBtree.Node.repr)[$Box(o#1)]);
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](619,4)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](620,5)
    assume {:subsumption 0} node#0 != null;
    assume true;
    assume Set#Subset(subrepr#0, read($Heap, node#0, KMBtree.Node.repr));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](621,5)
    assume true;
    assume !subrepr#0[$Box(pivots#0)];
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](622,5)
    assume true;
    assume !subrepr#0[$Box(children#4)];
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](623,5)
    assume {:subsumption 0} node#0 != null;
    assume true;
    assume Set#Subset(subrepr#0, 
      Set#Difference(read($Heap, node#0, KMBtree.Node.repr), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), $Box(pivots#0)), 
          $Box(children#4))));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](625,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#27;
        assume true;
        if (from#0 <= i#27)
        {
        }

        assume true;
        assume from#0 <= i#27 && i#27 < to#0;
        // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](628,7)
        if (*)
        {
            // Assume Fuel Constant
            havoc o#2;
            assume $Is(o#2, Tclass._System.object());
            assume children#4 != null;
            assume {:subsumption 0} 0 <= i#27 && i#27 < _System.array.Length(children#4);
            assume {:subsumption 0} $Unbox(read($Heap, children#4, IndexField(i#27))): ref != null;
            assume true;
            assume read($Heap, $Unbox(read($Heap, children#4, IndexField(i#27))): ref, KMBtree.Node.repr)[$Box(o#2)];
            assume subrepr#0[$Box(o#2)];
            assume false;
        }
        else
        {
            assume (forall o#3: ref :: 
              { subrepr#0[$Box(o#3)] } 
                { read($Heap, $Unbox(read($Heap, children#4, IndexField(i#27))): ref, KMBtree.Node.repr)[$Box(o#3)] } 
              $Is(o#3, Tclass._System.object())
                   && read($Heap, $Unbox(read($Heap, children#4, IndexField(i#27))): ref, KMBtree.Node.repr)[$Box(o#3)]
                 ==> subrepr#0[$Box(o#3)]);
        }

        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](632,6)"} true;
        assume Set#Subset(read($Heap, $Unbox(read($Heap, children#4, IndexField(i#27))): ref, KMBtree.Node.repr), 
          subrepr#0);
        assume false;
    }
    else
    {
        assume (forall i#28: int :: 
          { $Unbox(read($Heap, children#4, IndexField(i#28))): ref } 
          from#0 <= i#28 && i#28 < to#0
             ==> Set#Subset(read($Heap, $Unbox(read($Heap, children#4, IndexField(i#28))): ref, KMBtree.Node.repr), 
              subrepr#0));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](633,4)"} true;
}



procedure CheckWellformed$$KMBtree.__default.IndexPrefix(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    newnchildren#0: int
       where LitInt(0) <= newnchildren#0 && newnchildren#0 < 18446744073709551616);
  free requires 48 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.IndexPrefix(node#0: ref, newnchildren#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##from#0: int;
  var ##to#0: int;
  var ##node#3: ref;
  var ##node#4: ref;
  var ##node#5: DatatypeType;
  var ##from#1: int;
  var ##to#1: int;

    // AddMethodImpl: IndexPrefix, CheckWellformed$$KMBtree.__default.IndexPrefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](637,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume LitInt(1) <= newnchildren#0;
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    if (LitInt(0) <= newnchildren#0)
    {
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    }

    assume LitInt(0) <= newnchildren#0
       && newnchildren#0
         <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](642,19): post-state"} true;
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    ##node#2 := node#0;
    ##from#0 := LitInt(0);
    ##to#0 := newnchildren#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#2);
    assume true;
    assume KMBtree.NodeContents.Index_q(read(old($Heap), ##node#2, KMBtree.Node.contents));
    assume true;
    assume true;
    assume true;
    assume LitInt(0) <= ##from#0
       && ##from#0 <= ##to#0
       && ##to#0
         <= KMBtree.NodeContents.nchildren(read(old($Heap), ##node#2, KMBtree.Node.contents));
    assume KMBtree.__default.SubRepr#canCall(old($Heap), node#0, LitInt(0), newnchildren#0);
    assume Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
      Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
            $Box(KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents)))), 
          $Box(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)))), 
        KMBtree.__default.SubRepr(old($Heap), node#0, LitInt(0), newnchildren#0)));
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#4 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#4);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#5 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtreeModel.Node(), $Heap);
    ##from#1 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#1, TInt, $Heap);
    ##to#1 := newnchildren#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#1, TInt, $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Index_q(##node#5);
    assume KMBtreeModel.Node.Index_q(##node#5);
    assert {:subsumption 0} Seq#Length(KMBtreeModel.Node.children(##node#5))
       == Seq#Length(KMBtreeModel.Node.pivots(##node#5)) + 1;
    assume Seq#Length(KMBtreeModel.Node.children(##node#5))
       == Seq#Length(KMBtreeModel.Node.pivots(##node#5)) + 1;
    assert {:subsumption 0} LitInt(0) <= ##from#1;
    assert {:subsumption 0} ##from#1 < ##to#1;
    assert {:subsumption 0} ##to#1 <= Seq#Length(KMBtreeModel.Node.children(##node#5));
    assume LitInt(0) <= ##from#1
       && ##from#1 < ##to#1
       && ##to#1 <= Seq#Length(KMBtreeModel.Node.children(##node#5));
    assume KMBtreeModel.__default.SubIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      LitInt(0), 
      newnchildren#0);
    assume KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        LitInt(0), 
        newnchildren#0));
}



procedure Call$$KMBtree.__default.IndexPrefix(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    newnchildren#0: int
       where LitInt(0) <= newnchildren#0 && newnchildren#0 < 18446744073709551616);
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> (forall i#19: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                    LitInt(0) <= i#19 && i#19 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#19 && i#19 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#20: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#20)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#20
                   && i#20
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#20)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#21: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#21)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#21
                   && i#21
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#21)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#22: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22) } 
              true
                 ==> 
                LitInt(0) <= i#22
                   && i#22
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23) } 
              true
                 ==> 
                0 < i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(1) <= newnchildren#0;
  requires LitInt(0) <= newnchildren#0;
  requires newnchildren#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#25))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#26: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#26))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(children#4)]))));
  free ensures KMBtree.__default.SubRepr#canCall(old($Heap), node#0, LitInt(0), newnchildren#0);
  ensures Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
    Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
          $Box(KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents)))), 
        $Box(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)))), 
      KMBtree.__default.SubRepr(old($Heap), node#0, LitInt(0), newnchildren#0)));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        LitInt(0), 
        newnchildren#0))
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.SubIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      LitInt(0), 
      newnchildren#0);
  ensures KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
    KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
      LitInt(0), 
      newnchildren#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.IndexPrefix(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    newnchildren#0: int
       where LitInt(0) <= newnchildren#0 && newnchildren#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 48 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(1) <= newnchildren#0;
  requires LitInt(0) <= newnchildren#0;
  requires newnchildren#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#6)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#6)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#6 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#38: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#38))): ref } 
              LitInt(0) <= i#38 && i#38 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#38 && i#38 < nchildren#6
                 ==> $Unbox(read($Heap, children#6, IndexField(i#38))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#39: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#39))): ref } 
              LitInt(0) <= i#39 && i#39 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#39 && i#39 < nchildren#6
                 ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#39))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#40: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#40))): ref } 
              LitInt(0) <= i#40 && i#40 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#40 && i#40 < nchildren#6
                 ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#40))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref } 
                  { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                LitInt(0) <= i#41 && i#41 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#41 && i#41 < nchildren#6
                   ==> $Unbox(read($Heap, children#6, IndexField(i#41))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref } 
                  { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                LitInt(0) <= i#41 && i#41 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#41 && i#41 < nchildren#6
                   ==> $Unbox(read($Heap, children#6, IndexField(i#41))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref)
               ==> (forall i#42: int :: 
                { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                LitInt(0) <= i#42 && i#42 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#42 && i#42 < nchildren#6
                   ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#42))): ref, KMBtree.Node.repr)[$Box(children#6)]))));
  free ensures KMBtree.__default.SubRepr#canCall(old($Heap), node#0, LitInt(0), newnchildren#0);
  ensures $_reverifyPost
     ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
      Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
            $Box(KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents)))), 
          $Box(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)))), 
        KMBtree.__default.SubRepr(old($Heap), node#0, LitInt(0), newnchildren#0)));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        LitInt(0), 
        newnchildren#0))
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.SubIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      LitInt(0), 
      newnchildren#0);
  ensures $_reverifyPost
     ==> KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
      KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
        LitInt(0), 
        newnchildren#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.IndexPrefix(node#0: ref, newnchildren#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var oldinode#0: DatatypeType
     where $Is(oldinode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(oldinode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#6: ref;
  var node##0: ref;
  var from##0: int;
  var to##0: int;
  var $rhs#0: Set Box where $Is($rhs#0, TSet(Tclass._System.object()));
  var ##node#7: ref;
  var ##from#2: int;
  var ##to#2: int;
  var $rhs#1: DatatypeType where $Is($rhs#1, Tclass.KMBtree.NodeContents());
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#nchildren#0#0: int;
  var let#1#0#0: int;
  var newchildren#0: Seq Box
     where $Is(newchildren#0, TSeq(Tclass.KMBtree.Node?()))
       && $IsAlloc(newchildren#0, TSeq(Tclass.KMBtree.Node?()), $Heap);
  var i#54: int;
  var newtype$check#2: int;
  var ##node#8: ref;
  var i#56: int;
  var j#0: int;
  var ##nodes#1: Seq Box;
  var ##i#0: int;
  var ##j#0: int;
  var ##node#9: ref;
  var newinode#0: DatatypeType
     where $Is(newinode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(newinode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#10: ref;
  var ##node#11: DatatypeType;
  var ##from#3: int;
  var ##to#3: int;

    // AddMethodImpl: IndexPrefix, Impl$$KMBtree.__default.IndexPrefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](647,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](648,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](649,24)
    assume true;
    ##node#6 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    oldinode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](649,33)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](650,22)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    to##0 := newnchildren#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SubReprLowerBound(node##0, from##0, to##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](650,51)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](652,15)
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.repr];
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    ##node#7 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtree.Node(), $Heap);
    ##from#2 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#2, TInt, $Heap);
    ##to#2 := newnchildren#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#2, TInt, $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7);
    assume true;
    assume KMBtree.NodeContents.Index_q(read($Heap, ##node#7, KMBtree.Node.contents));
    assume true;
    assume true;
    assume true;
    assume LitInt(0) <= ##from#2
       && ##from#2 <= ##to#2
       && ##to#2
         <= KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents));
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, LitInt(0), newnchildren#0);
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, LitInt(0), newnchildren#0);
    $rhs#0 := Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
          $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
        $Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))), 
      KMBtree.__default.SubRepr($Heap, node#0, LitInt(0), newnchildren#0));
    $Heap := update($Heap, node#0, KMBtree.Node.repr, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](652,109)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](653,19)
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.contents];
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    havoc dt_update_tmp#0#0;
    assume $Is(dt_update_tmp#0#0, Tclass.KMBtree.NodeContents());
    assume node#0 != null;
    assume let#0#0#0 == read($Heap, node#0, KMBtree.Node.contents);
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#0#0#0, Tclass.KMBtree.NodeContents());
    assume dt_update_tmp#0#0 == let#0#0#0;
    havoc dt_update#nchildren#0#0;
    assume LitInt(0) <= dt_update#nchildren#0#0
       && dt_update#nchildren#0#0 < 18446744073709551616;
    assume let#1#0#0 == newnchildren#0;
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
    assume dt_update#nchildren#0#0 == let#1#0#0;
    assume KMBtree.NodeContents.Index_q(dt_update_tmp#0#0);
    assume KMBtree.NodeContents.Index_q(dt_update_tmp#0#0);
    assume true;
    $rhs#1 := (var dt_update_tmp#0#1 := read($Heap, node#0, KMBtree.Node.contents); 
      (var dt_update#nchildren#0#1 := newnchildren#0; 
        #KMBtree.NodeContents.Index(dt_update#nchildren#0#1, 
          KMBtree.NodeContents.pivots(dt_update_tmp#0#1), 
          KMBtree.NodeContents.children(dt_update_tmp#0#1))));
    $Heap := update($Heap, node#0, KMBtree.Node.contents, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](653,62)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](655,27)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= newnchildren#0
       && newnchildren#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    newchildren#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      newnchildren#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](655,67)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](656,5)
    havoc i#54;
    assume LitInt(0) <= i#54 && i#54 < 18446744073709551616;
    // Begin Comprehension WF check
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    if (LitInt(0) <= i#54)
    {
    }

    if (LitInt(0) <= i#54 && i#54 < newnchildren#0)
    {
        assume {:subsumption 0} 0 <= i#54 && i#54 < Seq#Length(newchildren#0);
        assume $Is($Unbox(Seq#Index(newchildren#0, i#54)): ref, Tclass.KMBtree.Node());
        ##node#8 := $Unbox(Seq#Index(newchildren#0, i#54)): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#8, Tclass.KMBtree.Node(), $Heap);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#54)): ref);
    }

    // End Comprehension WF check
    assume (forall i#55: int :: 
      { $Unbox(Seq#Index(newchildren#0, i#55)): ref } 
      LitInt(0) <= i#55 && i#55 < 18446744073709551616
         ==> 
        LitInt(0) <= i#55 && i#55 < newnchildren#0
         ==> KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#55)): ref));
    assume true;
    assume (forall i#55: int :: 
      { $Unbox(Seq#Index(newchildren#0, i#55)): ref } 
      LitInt(0) <= i#55 && i#55 < 18446744073709551616
         ==> 
        LitInt(0) <= i#55 && i#55 < newnchildren#0
         ==> KMBtree.__default.WFShape($LS($LS($LZ)), $Heap, $Unbox(Seq#Index(newchildren#0, i#55)): ref));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](657,5)
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0
         <= KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} 0 <= newnchildren#0
       && newnchildren#0
         <= Seq#Length(Seq#Take(Seq#FromArray(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))));
    assume true;
    assume Seq#Equal(newchildren#0, 
      Seq#Take(Seq#Take(Seq#FromArray(old($Heap), 
            KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
        newnchildren#0));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](658,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#56, j#0;
        assume true;
        if (LitInt(0) <= i#56)
        {
        }

        if (LitInt(0) <= i#56 && i#56 < j#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#56 && i#56 < j#0 && j#0 < Seq#Length(newchildren#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](661,7)
        assume {:subsumption 0} node#0 != null;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} node#0 != null;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
        assume {:subsumption 0} 0
             <= KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
             <= _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
        assume $Is(Seq#Take(Seq#FromArray(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
          TSeq(Tclass.KMBtree.Node()));
        ##nodes#1 := Seq#Take(Seq#FromArray(old($Heap), 
            KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents)));
        ##i#0 := i#56;
        ##j#0 := j#0;
        assume $IsAlloc(Seq#Take(Seq#FromArray(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
          TSeq(Tclass.KMBtree.Node?()), 
          old($Heap));
        assume {:subsumption 0} LitInt(0) <= ##i#0;
        assume {:subsumption 0} ##i#0 < Seq#Length(##nodes#1);
        assume {:subsumption 0} LitInt(0) <= ##j#0;
        assume {:subsumption 0} ##j#0 < Seq#Length(##nodes#1);
        assume KMBtree.__default.DisjointReprs#canCall(old($Heap), 
          Seq#Take(Seq#FromArray(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
          i#56, 
          j#0);
        assume KMBtree.__default.DisjointReprs#canCall(old($Heap), 
          Seq#Take(Seq#FromArray(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
          i#56, 
          j#0);
        assume true;
        assume KMBtree.__default.DisjointReprs(old($Heap), 
          Seq#Take(Seq#FromArray(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
          i#56, 
          j#0);
        assume KMBtree.__default.DisjointReprs#canCall($Heap, newchildren#0, i#56, j#0)
           ==> KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#56, j#0)
             || Set#Disjoint(read($Heap, $Unbox(Seq#Index(newchildren#0, i#56)): ref, KMBtree.Node.repr), 
              read($Heap, $Unbox(Seq#Index(newchildren#0, j#0)): ref, KMBtree.Node.repr));
        assume false;
    }
    else
    {
        assume (forall i#57: int, j#1: int :: 
          { KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#57, j#1) } 
          LitInt(0) <= i#57 && i#57 < j#1 && j#1 < Seq#Length(newchildren#0)
             ==> KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#57, j#1));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](662,4)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](663,5)
    ##node#9 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LS($LZ)), $Heap, node#0);
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](664,24)
    assume true;
    ##node#10 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#10, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#10);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    newinode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](664,33)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](665,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](665,14)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](666,5)
    ##node#11 := oldinode#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#11, Tclass.KMBtreeModel.Node(), $Heap);
    ##from#3 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#3, TInt, $Heap);
    ##to#3 := newnchildren#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#3, TInt, $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Index_q(##node#11);
    assert {:subsumption 0} Seq#Length(KMBtreeModel.Node.children(##node#11))
       == Seq#Length(KMBtreeModel.Node.pivots(##node#11)) + 1;
    assert {:subsumption 0} LitInt(0) <= ##from#3;
    assert {:subsumption 0} ##from#3 < ##to#3;
    assert {:subsumption 0} ##to#3 <= Seq#Length(KMBtreeModel.Node.children(##node#11));
    assume KMBtreeModel.__default.SubIndex#canCall(oldinode#0, LitInt(0), newnchildren#0);
    assume $IsA#KMBtreeModel.Node(newinode#0)
       && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(oldinode#0, LitInt(0), newnchildren#0))
       && KMBtreeModel.__default.SubIndex#canCall(oldinode#0, LitInt(0), newnchildren#0);
    assume KMBtreeModel.Node#Equal(newinode#0, 
      KMBtreeModel.__default.SubIndex(oldinode#0, LitInt(0), newnchildren#0));
}



procedure CheckWellformed$$KMBtree.__default.SubIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (subnode#0: ref
       where $Is(subnode#0, Tclass.KMBtree.Node())
         && $IsAlloc(subnode#0, Tclass.KMBtree.Node(), $Heap));
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.SubIndex(node#0: ref, from#0: int, to#0: int) returns (subnode#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##from#0: int;
  var ##to#0: int;
  var ##node#3: ref;
  var ##node#4: ref;
  var ##node#5: DatatypeType;
  var ##from#1: int;
  var ##to#1: int;

    // AddMethodImpl: SubIndex, CheckWellformed$$KMBtree.__default.SubIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](669,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume 1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    if (LitInt(0) <= from#0)
    {
    }

    if (LitInt(0) <= from#0 && from#0 < to#0)
    {
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    }

    assume LitInt(0) <= from#0
       && from#0 < to#0
       && to#0
         <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc subnode#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](674,19): post-state"} true;
    ##node#1 := subnode#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, subnode#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0);
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume subnode#0 != null;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    ##from#0 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#0, TInt, $Heap);
    ##to#0 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#0, TInt, $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#2);
    assume true;
    assume KMBtree.NodeContents.Index_q(read($Heap, ##node#2, KMBtree.Node.contents));
    assume true;
    assume true;
    assume true;
    assume LitInt(0) <= ##from#0
       && ##from#0 <= ##to#0
       && ##to#0
         <= KMBtree.NodeContents.nchildren(read($Heap, ##node#2, KMBtree.Node.contents));
    assume KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume Set#Equal(read($Heap, subnode#0, KMBtree.Node.repr), 
      Set#Union(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
            $Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))), 
          $Box(KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))))));
    assume subnode#0 != null;
    assume node#0 != null;
    assume read($Heap, subnode#0, KMBtree.Node.height)
       == read($Heap, node#0, KMBtree.Node.height);
    ##node#3 := subnode#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, subnode#0);
    ##node#4 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#4);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#5 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtreeModel.Node(), $Heap);
    ##from#1 := from#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##from#1, TInt, $Heap);
    ##to#1 := to#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##to#1, TInt, $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Index_q(##node#5);
    assume KMBtreeModel.Node.Index_q(##node#5);
    assert {:subsumption 0} Seq#Length(KMBtreeModel.Node.children(##node#5))
       == Seq#Length(KMBtreeModel.Node.pivots(##node#5)) + 1;
    assume Seq#Length(KMBtreeModel.Node.children(##node#5))
       == Seq#Length(KMBtreeModel.Node.pivots(##node#5)) + 1;
    assert {:subsumption 0} LitInt(0) <= ##from#1;
    assert {:subsumption 0} ##from#1 < ##to#1;
    assert {:subsumption 0} ##to#1 <= Seq#Length(KMBtreeModel.Node.children(##node#5));
    assume LitInt(0) <= ##from#1
       && ##from#1 < ##to#1
       && ##to#1 <= Seq#Length(KMBtreeModel.Node.children(##node#5));
    assume KMBtreeModel.__default.SubIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), from#0, to#0);
    assume KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, subnode#0), 
      KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), from#0, to#0));
    assume subnode#0 != null && !read(old($Heap), subnode#0, alloc);
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents))
         != null
       && !read(old($Heap), 
        KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)), 
        alloc);
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))
         != null
       && !read(old($Heap), 
        KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)), 
        alloc);
}



procedure Call$$KMBtree.__default.SubIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (subnode#0: ref
       where $Is(subnode#0, Tclass.KMBtree.Node())
         && $IsAlloc(subnode#0, Tclass.KMBtree.Node(), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> (forall i#19: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                    LitInt(0) <= i#19 && i#19 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#19 && i#19 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#20: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#20)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#20
                   && i#20
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#20)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#21: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#21)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#21
                   && i#21
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#21)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#22: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22) } 
              true
                 ==> 
                LitInt(0) <= i#22
                   && i#22
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23) } 
              true
                 ==> 
                0 < i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires 1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from#0;
  requires from#0 < to#0;
  requires to#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, subnode#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, subnode#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, subnode#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, subnode#0, KMBtree.Node.contents)))
         && read($Heap, subnode#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, subnode#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, subnode#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, subnode#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, subnode#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, subnode#0, KMBtree.Node.repr), 
                  read($Heap, subnode#0, KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#25))): ref, KMBtree.Node.repr)[$Box(subnode#0)])
                 && (forall i#26: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#26))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(children#4)]))));
  free ensures true;
  ensures KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
  free ensures KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
  ensures Set#Equal(read($Heap, subnode#0, KMBtree.Node.repr), 
    Set#Union(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
      Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
          $Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))), 
        $Box(KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))))));
  free ensures true;
  ensures read($Heap, subnode#0, KMBtree.Node.height)
     == read($Heap, node#0, KMBtree.Node.height);
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, subnode#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), from#0, to#0))
     && 
    KMBtree.__default.I#canCall($Heap, subnode#0)
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.SubIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), from#0, to#0);
  ensures KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, subnode#0), 
    KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
      from#0, 
      to#0));
  free ensures true;
  ensures subnode#0 != null && !read(old($Heap), subnode#0, alloc);
  free ensures true;
  ensures KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents))
       != null
     && !read(old($Heap), 
      KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)), 
      alloc);
  free ensures true;
  ensures KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))
       != null
     && !read(old($Heap), 
      KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)), 
      alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.SubIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    from#0: int where LitInt(0) <= from#0 && from#0 < 18446744073709551616, 
    to#0: int where LitInt(0) <= to#0 && to#0 < 18446744073709551616)
   returns (subnode#0: ref
       where $Is(subnode#0, Tclass.KMBtree.Node())
         && $IsAlloc(subnode#0, Tclass.KMBtree.Node(), $Heap), 
    $_reverifyPost: bool);
  free requires 49 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires 1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= from#0;
  requires from#0 < to#0;
  requires to#0
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, subnode#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, subnode#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, subnode#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, subnode#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> read($Heap, subnode#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, subnode#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, subnode#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, subnode#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, subnode#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))), 
                $Box(children#6)), 
              read($Heap, subnode#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            0 < nchildren#6)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            nchildren#6 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            (forall i#38: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#38))): ref } 
              LitInt(0) <= i#38 && i#38 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#38 && i#38 < nchildren#6
                 ==> $Unbox(read($Heap, children#6, IndexField(i#38))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
              read($Heap, subnode#0, KMBtree.Node.repr), 
              read($Heap, subnode#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            (forall i#39: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#39))): ref } 
              LitInt(0) <= i#39 && i#39 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#39 && i#39 < nchildren#6
                 ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#39))): ref, KMBtree.Node.repr)[$Box(subnode#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            (forall i#40: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#40))): ref } 
              LitInt(0) <= i#40 && i#40 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#40 && i#40 < nchildren#6
                 ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#40))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref } 
                  { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                LitInt(0) <= i#41 && i#41 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#41 && i#41 < nchildren#6
                   ==> $Unbox(read($Heap, children#6, IndexField(i#41))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, subnode#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, subnode#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, subnode#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref } 
                  { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                LitInt(0) <= i#41 && i#41 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#41 && i#41 < nchildren#6
                   ==> $Unbox(read($Heap, children#6, IndexField(i#41))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref)
               ==> (forall i#42: int :: 
                { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                LitInt(0) <= i#42 && i#42 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#42 && i#42 < nchildren#6
                   ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#42))): ref, KMBtree.Node.repr)[$Box(children#6)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
  free ensures KMBtree.__default.SubRepr#canCall($Heap, node#0, from#0, to#0);
  ensures $_reverifyPost
     ==> Set#Equal(read($Heap, subnode#0, KMBtree.Node.repr), 
      Set#Union(KMBtree.__default.SubRepr($Heap, node#0, from#0, to#0), 
        Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(subnode#0)), 
            $Box(KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)))), 
          $Box(KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))))));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, subnode#0, KMBtree.Node.height)
       == read($Heap, node#0, KMBtree.Node.height);
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, subnode#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), from#0, to#0))
     && 
    KMBtree.__default.I#canCall($Heap, subnode#0)
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.SubIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), from#0, to#0);
  ensures $_reverifyPost
     ==> KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, subnode#0), 
      KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
        from#0, 
        to#0));
  free ensures true;
  ensures $_reverifyPost ==> subnode#0 != null && !read(old($Heap), subnode#0, alloc);
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents))
         != null
       && !read(old($Heap), 
        KMBtree.NodeContents.pivots(read($Heap, subnode#0, KMBtree.Node.contents)), 
        alloc);
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))
         != null
       && !read(old($Heap), 
        KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)), 
        alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.SubIndex(node#0: ref, from#0: int, to#0: int)
   returns (subnode#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#subnode#0: bool;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0, Tclass.KMBtree.Node(), $Heap);
  var pivots##0: Seq Box;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var children##0: Seq Box;
  var height##0: int;
  var newchildren#0: Seq Box
     where $Is(newchildren#0, TSeq(Tclass.KMBtree.Node?()))
       && $IsAlloc(newchildren#0, TSeq(Tclass.KMBtree.Node?()), $Heap);
  var i#44: int;
  var ##node#6: ref;
  var i#46: int;
  var j#0: int;
  var ##contents#0: DatatypeType;
  var ##i#0: int;
  var ##j#0: int;
  var i#48: int;
  var ##nodes#1: Seq Box;
  var ##nodes#2: Seq Box;
  var ##parentRepr#1: Set Box;
  var ##parentHeight#1: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##node#7: ref;
  var newtype$check#6: int;
  var newtype$check#7: int;

    // AddMethodImpl: SubIndex, Impl$$KMBtree.__default.SubIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](682,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](683,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](685,33)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume 0 <= from#0
       && from#0
         <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := to#0 - 1;
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume from#0 <= to#0 - 1
       && to#0 - 1
         <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    pivots##0 := Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
        to#0 - 1), 
      from#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= from#0
       && from#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume from#0 <= to#0
       && to#0
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is(Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
          to#0), 
        from#0), 
      TSeq(Tclass.KMBtree.Node()));
    children##0 := Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        to#0), 
      from#0);
    assume node#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    height##0 := read($Heap, node#0, KMBtree.Node.height);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.IndexFromChildren(pivots##0, children##0, height##0);
    // TrCallStmt: After ProcessCallStmt
    subnode#0 := $rhs##0;
    defass#subnode#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](685,113)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](687,27)
    assume true;
    assume defass#subnode#0;
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))
       != null;
    assume defass#subnode#0;
    assume subnode#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
    assume 0
         <= KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)));
    assume true;
    newchildren#0 := Seq#Take(Seq#FromArray($Heap, 
        KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, subnode#0, KMBtree.Node.contents)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](687,84)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](688,5)
    havoc i#44;
    // Begin Comprehension WF check
    if (LitInt(0) <= i#44)
    {
    }

    if (LitInt(0) <= i#44 && i#44 < Seq#Length(newchildren#0))
    {
        assume {:subsumption 0} 0 <= i#44 && i#44 < Seq#Length(newchildren#0);
        assume $Is($Unbox(Seq#Index(newchildren#0, i#44)): ref, Tclass.KMBtree.Node());
        ##node#6 := $Unbox(Seq#Index(newchildren#0, i#44)): ref;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#6, Tclass.KMBtree.Node(), $Heap);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#44)): ref);
    }

    // End Comprehension WF check
    assume (forall i#45: int :: 
      { $Unbox(Seq#Index(newchildren#0, i#45)): ref } 
      LitInt(0) <= i#45 && i#45 < Seq#Length(newchildren#0)
         ==> KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#45)): ref));
    assume true;
    assume (forall i#45: int :: 
      { $Unbox(Seq#Index(newchildren#0, i#45)): ref } 
      true
         ==> 
        LitInt(0) <= i#45 && i#45 < Seq#Length(newchildren#0)
         ==> KMBtree.__default.WFShape($LS($LS($LZ)), $Heap, $Unbox(Seq#Index(newchildren#0, i#45)): ref));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](689,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#46, j#0;
        assume true;
        if (LitInt(0) <= i#46)
        {
        }

        if (LitInt(0) <= i#46 && i#46 < j#0)
        {
        }

        assume true;
        assume LitInt(0) <= i#46 && i#46 < j#0 && j#0 < Seq#Length(newchildren#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](692,7)
        assume {:subsumption 0} node#0 != null;
        ##contents#0 := read($Heap, node#0, KMBtree.Node.contents);
        // assume allocatedness for argument to function
        assume $IsAlloc(##contents#0, Tclass.KMBtree.NodeContents(), $Heap);
        ##i#0 := from#0 + i#46;
        // assume allocatedness for argument to function
        assume $IsAlloc(##i#0, TInt, $Heap);
        ##j#0 := from#0 + j#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##j#0, TInt, $Heap);
        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0);
        assume {:subsumption 0} LitInt(0) <= ##i#0;
        assume {:subsumption 0} ##i#0 < KMBtree.NodeContents.nchildren(##contents#0);
        assume {:subsumption 0} LitInt(0) <= ##j#0;
        assume {:subsumption 0} ##j#0 < KMBtree.NodeContents.nchildren(##contents#0);
        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0)
           <= _System.array.Length(KMBtree.NodeContents.children(##contents#0));
        assume {:subsumption 0} (forall l#0: int :: 
          { $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref } 
          LitInt(0) <= l#0 && l#0 < 18446744073709551616
             ==> 
            LitInt(0) <= l#0 && l#0 < KMBtree.NodeContents.nchildren(##contents#0)
             ==> $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref
               != null);
        assume {:subsumption 0} $Unbox(read($Heap, KMBtree.NodeContents.children(##contents#0), IndexField(##j#0))): ref
           != null;
        assume KMBtree.__default.DisjointSubtrees#canCall($Heap, read($Heap, node#0, KMBtree.Node.contents), from#0 + i#46, from#0 + j#0);
        assume KMBtree.__default.DisjointSubtrees#canCall($Heap, read($Heap, node#0, KMBtree.Node.contents), from#0 + i#46, from#0 + j#0);
        assume true;
        assume KMBtree.__default.DisjointSubtrees($Heap, read($Heap, node#0, KMBtree.Node.contents), from#0 + i#46, from#0 + j#0);
        assume KMBtree.__default.DisjointReprs#canCall($Heap, newchildren#0, i#46, j#0)
           ==> KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#46, j#0)
             || Set#Disjoint(read($Heap, $Unbox(Seq#Index(newchildren#0, i#46)): ref, KMBtree.Node.repr), 
              read($Heap, $Unbox(Seq#Index(newchildren#0, j#0)): ref, KMBtree.Node.repr));
        assume false;
    }
    else
    {
        assume (forall i#47: int, j#1: int :: 
          { KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#47, j#1) } 
          LitInt(0) <= i#47 && i#47 < j#1 && j#1 < Seq#Length(newchildren#0)
             ==> KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#47, j#1));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](693,4)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](694,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#48;
        assume true;
        if (LitInt(0) <= i#48)
        {
        }

        assume true;
        assume LitInt(0) <= i#48 && i#48 < Seq#Length(newchildren#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](698,7)
        assume {:subsumption 0} 0 <= i#48 && i#48 < Seq#Length(newchildren#0);
        assume defass#subnode#0;
        assume {:subsumption 0} subnode#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, subnode#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} 0 <= i#48
           && i#48
             < _System.array.Length(KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)));
        assume true;
        assume $Unbox(Seq#Index(newchildren#0, i#48)): ref
           == $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, subnode#0, KMBtree.Node.contents)), 
              IndexField(i#48))): ref;
        assume !read($Heap, $Unbox(Seq#Index(newchildren#0, i#48)): ref, KMBtree.Node.repr)[$Box(subnode#0)];
        assume read($Heap, $Unbox(Seq#Index(newchildren#0, i#48)): ref, KMBtree.Node.height)
           < read($Heap, subnode#0, KMBtree.Node.height);
        assume false;
    }
    else
    {
        assume (forall i#49: int :: 
          { $Unbox(Seq#Index(newchildren#0, i#49)): ref } 
          LitInt(0) <= i#49 && i#49 < Seq#Length(newchildren#0)
             ==> !read($Heap, $Unbox(Seq#Index(newchildren#0, i#49)): ref, KMBtree.Node.repr)[$Box(subnode#0)]
               && read($Heap, $Unbox(Seq#Index(newchildren#0, i#49)): ref, KMBtree.Node.height)
                 < read($Heap, subnode#0, KMBtree.Node.height));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](699,4)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](700,5)
    assume $Is(newchildren#0, TSeq(Tclass.KMBtree.Node()));
    ##nodes#1 := newchildren#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#1, TSeq(Tclass.KMBtree.Node()), $Heap);
    assume KMBtree.__default.WFShapeSiblings#canCall($Heap, newchildren#0);
    assume KMBtree.__default.WFShapeSiblings#canCall($Heap, newchildren#0);
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeSiblings($LS($LS($LZ)), $Heap, newchildren#0);
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](701,5)
    assume defass#subnode#0;
    assume {:subsumption 0} subnode#0 != null;
    assume defass#subnode#0;
    assume {:subsumption 0} subnode#0 != null;
    assume $Is(newchildren#0, TSeq(Tclass.KMBtree.Node()));
    ##nodes#2 := newchildren#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#2, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#1 := read($Heap, subnode#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#1, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#1 := read($Heap, subnode#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#1, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      newchildren#0, 
      read($Heap, subnode#0, KMBtree.Node.repr), 
      read($Heap, subnode#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      newchildren#0, 
      read($Heap, subnode#0, KMBtree.Node.repr), 
      read($Heap, subnode#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      newchildren#0, 
      read($Heap, subnode#0, KMBtree.Node.repr), 
      read($Heap, subnode#0, KMBtree.Node.height));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](703,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](703,14)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](704,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume {:subsumption 0} 0 <= from#0
       && from#0
         <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    newtype$check#4 := LitInt(1);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := to#0 - 1;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume {:subsumption 0} from#0 <= to#0 - 1
       && to#0 - 1
         <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    ##node#7 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtree.Node(), $Heap);
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> Set#Equal(read($Heap, ##node#7, KMBtree.Node.repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#7)), 
                $Box(KMBtree.NodeContents.keys(read($Heap, ##node#7, KMBtree.Node.contents)))), 
              $Box(KMBtree.NodeContents.values(read($Heap, ##node#7, KMBtree.Node.contents))))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.NodeContents.keys(read($Heap, ##node#7, KMBtree.Node.contents)), 
            KMBtree.NodeContents.values(read($Heap, ##node#7, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> read($Heap, ##node#7, KMBtree.Node.height) == LitInt(0));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> LitInt(0)
             <= KMBtree.NodeContents.nkeys(read($Heap, ##node#7, KMBtree.Node.contents)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> KMBtree.NodeContents.nkeys(read($Heap, ##node#7, KMBtree.Node.contents))
             <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#7, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, ##node#7, KMBtree.Node.contents)))
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#7, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> Lit(true));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#7)), 
                    $Box(KMBtree.NodeContents.pivots(read($Heap, ##node#7, KMBtree.Node.contents)))), 
                  $Box(children#7)), 
                read($Heap, ##node#7, KMBtree.Node.repr)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              0 < nchildren#7)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              nchildren#7 <= LitInt(KMBtree.__default.MaxChildren()))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, ##node#7, KMBtree.Node.contents)))
                 == LitInt(KMBtree.__default.MaxChildren() - 1))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              (forall i#53: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#53))): ref } 
                LitInt(0) <= i#53 && i#53 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#53 && i#53 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#53))): ref != null))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                $Heap, 
                Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
                read($Heap, ##node#7, KMBtree.Node.repr), 
                read($Heap, ##node#7, KMBtree.Node.height)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              (forall i#54: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#54))): ref } 
                LitInt(0) <= i#54 && i#54 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#54 && i#54 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#54))): ref, KMBtree.Node.repr)[$Box(##node#7)]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              (forall i#55: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#55))): ref } 
                LitInt(0) <= i#55 && i#55 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#55 && i#55 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, ##node#7, KMBtree.Node.contents)))]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              (forall i#56: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#56)): ref } 
                    { $Unbox(read($Heap, children#7, IndexField(i#56))): ref } 
                  LitInt(0) <= i#56 && i#56 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#56 && i#56 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#56))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#56)): ref)
                 ==> Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#7)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#7, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#7, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#7, KMBtree.Node.contents)); 
              (forall i#56: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#56)): ref } 
                    { $Unbox(read($Heap, children#7, IndexField(i#56))): ref } 
                  LitInt(0) <= i#56 && i#56 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#56 && i#56 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#56))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#56)): ref)
                 ==> (forall i#57: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#57))): ref } 
                  LitInt(0) <= i#57 && i#57 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#57 && i#57 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#57))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume {:subsumption 0} 0 <= from#0
       && from#0
         <= Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));
    newtype$check#6 := LitInt(1);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    newtype$check#7 := to#0 - 1;
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume {:subsumption 0} from#0 <= to#0 - 1
       && to#0 - 1
         <= Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)));
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          to#0 - 1), 
        from#0), 
      Seq#Drop(Seq#Take(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          to#0 - 1), 
        from#0));
    assert defass#subnode#0;
}



procedure CheckWellformed$$KMBtree.__default.SplitIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    nleft#0: int where LitInt(0) <= nleft#0 && nleft#0 < 18446744073709551616)
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 50 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.SplitIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    nleft#0: int where LitInt(0) <= nleft#0 && nleft#0 < 18446744073709551616)
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> (forall i#19: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                    LitInt(0) <= i#19 && i#19 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#19 && i#19 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#20: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#20)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#20
                   && i#20
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#20)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#21: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#21)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#21
                   && i#21
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#21)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#22: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22) } 
              true
                 ==> 
                LitInt(0) <= i#22
                   && i#22
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23) } 
              true
                 ==> 
                0 < i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(2)
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires 0 < nleft#0;
  requires nleft#0
     < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#25))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#26: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#26))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(children#4)]))));
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, right#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
         && read($Heap, right#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          true
             && (var children#5 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))), 
                    $Box(children#5)), 
                  read($Heap, right#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#5
                 && nchildren#5 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#29: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#5
                     ==> $Unbox(read($Heap, children#5, IndexField(i#29))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), 
                  read($Heap, right#0, KMBtree.Node.repr), 
                  read($Heap, right#0, KMBtree.Node.height))
                 && (forall i#30: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#30))): ref } 
                  LitInt(0) <= i#30 && i#30 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#30 && i#30 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#30))): ref, KMBtree.Node.repr)[$Box(right#0)])
                 && (forall i#31: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#31))): ref } 
                  LitInt(0) <= i#31 && i#31 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#31 && i#31 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#31))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#33: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#33))): ref } 
                  LitInt(0) <= i#33 && i#33 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#33 && i#33 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#33))): ref, KMBtree.Node.repr)[$Box(children#5)]))));
  free ensures true;
  ensures Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
    read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures true;
  ensures Set#Disjoint(read($Heap, node#0, KMBtree.Node.repr), read($Heap, right#0, KMBtree.Node.repr));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, right#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  ensures read(old($Heap), node#0, KMBtree.Node.height)
     == read($Heap, right#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, right#0)
     && KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0);
  free ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     && 
    KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     && 
    KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0))
     && KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0))
     && 
    0
       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
     && Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
     && Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
       == Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
         + 1
     && KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        LitInt(0), 
        Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))))
     && KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))), 
        Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))))
     && (forall key#0: Seq Box :: 
      { Lexicographic__Byte__Order.__default.lt(key#0, pivot#0) } 
        { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), 
              KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): DatatypeType)[$Box(key#0)] } 
      $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         ==> 
        KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), 
              KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))): DatatypeType)[$Box(key#0)]
         ==> Lexicographic__Byte__Order.__default.lt(key#0, pivot#0))
     && (forall key#1: Seq Box :: 
      { Lexicographic__Byte__Order.__default.lte(pivot#0, key#1) } 
        { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)), 
              0)): DatatypeType)[$Box(key#1)] } 
      $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
         ==> 
        KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0)), 
              LitInt(0))): DatatypeType)[$Box(key#1)]
         ==> Lexicographic__Byte__Order.__default.lte(pivot#0, key#1))
     && Seq#Equal(pivot#0, 
      $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
          Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))))): Seq Box);
  free ensures true;
  ensures KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
     == nleft#0;
  free ensures true;
  ensures Seq#Equal(pivot#0, 
    $Unbox(read(old($Heap), 
        KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents)), 
        IndexField(nleft#0 - 1))): Seq Box);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.SplitIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    nleft#0: int where LitInt(0) <= nleft#0 && nleft#0 < 18446744073709551616)
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 50 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires LitInt(2)
     <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires 0 < nleft#0;
  requires nleft#0
     < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#7)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#7)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#7 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#43: int :: 
              { $Unbox(read($Heap, children#7, IndexField(i#43))): ref } 
              LitInt(0) <= i#43 && i#43 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#43 && i#43 < nchildren#7
                 ==> $Unbox(read($Heap, children#7, IndexField(i#43))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#44: int :: 
              { $Unbox(read($Heap, children#7, IndexField(i#44))): ref } 
              LitInt(0) <= i#44 && i#44 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#44 && i#44 < nchildren#7
                 ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#45: int :: 
              { $Unbox(read($Heap, children#7, IndexField(i#45))): ref } 
              LitInt(0) <= i#45 && i#45 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#45 && i#45 < nchildren#7
                 ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#45))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#46: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref } 
                  { $Unbox(read($Heap, children#7, IndexField(i#46))): ref } 
                LitInt(0) <= i#46 && i#46 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#46 && i#46 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#46))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#46: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref } 
                  { $Unbox(read($Heap, children#7, IndexField(i#46))): ref } 
                LitInt(0) <= i#46 && i#46 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#46 && i#46 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#46))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#46)): ref)
               ==> (forall i#47: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#47))): ref } 
                LitInt(0) <= i#47 && i#47 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#47 && i#47 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#47))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, right#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> read($Heap, right#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))), 
                $Box(children#8)), 
              read($Heap, right#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            0 < nchildren#8)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            nchildren#8 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#48: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#48))): ref } 
              LitInt(0) <= i#48 && i#48 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#48 && i#48 < nchildren#8
                 ==> $Unbox(read($Heap, children#8, IndexField(i#48))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), 
              read($Heap, right#0, KMBtree.Node.repr), 
              read($Heap, right#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#49: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#49))): ref } 
              LitInt(0) <= i#49 && i#49 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#49 && i#49 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#49))): ref, KMBtree.Node.repr)[$Box(right#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#50: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#50))): ref } 
              LitInt(0) <= i#50 && i#50 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#50 && i#50 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#50))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#51: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                LitInt(0) <= i#51 && i#51 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#51 && i#51 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#51: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                LitInt(0) <= i#51 && i#51 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#51 && i#51 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
               ==> (forall i#52: int :: 
                { $Unbox(read($Heap, children#8, IndexField(i#52))): ref } 
                LitInt(0) <= i#52 && i#52 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#52 && i#52 < nchildren#8
                   ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(children#8)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures true;
  ensures $_reverifyPost
     ==> Set#Disjoint(read($Heap, node#0, KMBtree.Node.repr), read($Heap, right#0, KMBtree.Node.repr));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, right#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  ensures $_reverifyPost
     ==> read(old($Heap), node#0, KMBtree.Node.height)
       == read($Heap, right#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, right#0)
     && KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0);
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || 0
         < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
         < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))
         == Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))
           + 1;
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
        KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
          LitInt(0), 
          Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0), 
        KMBtreeModel.__default.SubIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
          Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))), 
          Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || (forall key#2: Seq Box :: 
        { Lexicographic__Byte__Order.__default.lt(key#2, pivot#0) } 
          { KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
            $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), 
                KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))): DatatypeType)[$Box(key#2)] } 
        $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
           ==> 
          KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
            $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), 
                KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))): DatatypeType)[$Box(key#2)]
           ==> Lexicographic__Byte__Order.__default.lt(key#2, pivot#0));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || (forall key#3: Seq Box :: 
        { Lexicographic__Byte__Order.__default.lte(pivot#0, key#3) } 
          { KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0)), 
                0)): DatatypeType)[$Box(key#3)] } 
        $Is(key#3, TSeq(Tclass.NativeTypes.byte()))
           ==> 
          KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0)), 
                LitInt(0))): DatatypeType)[$Box(key#3)]
           ==> Lexicographic__Byte__Order.__default.lte(pivot#0, key#3));
  ensures KMBtreeModel.__default.SplitIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || Seq#Equal(pivot#0, 
        $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
            Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))))): Seq Box);
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       == nleft#0;
  free ensures true;
  ensures $_reverifyPost
     ==> Seq#Equal(pivot#0, 
      $Unbox(read(old($Heap), 
          KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents)), 
          IndexField(nleft#0 - 1))): Seq Box);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.SplitIndex(node#0: ref, nleft#0: int)
   returns (right#0: ref, pivot#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#right#0: bool;
  var node##0: ref;
  var from1##0: int;
  var to1##0: int;
  var from2##0: int;
  var to2##0: int;
  var node##1: ref;
  var from##0: int;
  var to##0: int;
  var node##2: ref;
  var from##1: int;
  var to##1: int;
  var ##node#6: ref;
  var ##node#7: DatatypeType;
  var ##i#0: int;
  var ##node#8: ref;
  var ##node#9: DatatypeType;
  var ##i#1: int;
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0, Tclass.KMBtree.Node(), $Heap);
  var node##3: ref;
  var from##2: int;
  var to##2: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var node##4: ref;
  var childidx##0: int;
  var node##5: ref;
  var newnchildren##0: int;
  var inode#0: DatatypeType
     where $Is(inode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(inode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#10: ref;
  var iright#0: DatatypeType
     where $Is(iright#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(iright#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#11: ref;
  var ##node#12: DatatypeType;
  var ##i#2: int;
  var run##0: Seq Box;
  var ##node#13: ref;
  var i##0: int;
  var j##0: int;
  var newtype$check#6: int;
  var newtype$check#7: int;

    // AddMethodImpl: SplitIndex, Impl$$KMBtree.__default.SplitIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](722,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](723,21)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from1##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    to1##0 := nleft#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from2##0 := nleft#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    to2##0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SubReprsDisjoint(node##0, from1##0, to1##0, from2##0, to2##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](723,89)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](724,22)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##1 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    to##0 := nleft#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SubReprUpperBound(node##1, from##0, to##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](724,44)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](725,22)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##2 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from##1 := nleft#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    to##1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SubReprUpperBound(node##2, from##1, to##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](725,73)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](726,5)
    ##node#6 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtree.Node(), $Heap);
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> Set#Equal(read($Heap, ##node#6, KMBtree.Node.repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#6)), 
                $Box(KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents)))), 
              $Box(KMBtree.NodeContents.values(read($Heap, ##node#6, KMBtree.Node.contents))))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents)), 
            KMBtree.NodeContents.values(read($Heap, ##node#6, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> read($Heap, ##node#6, KMBtree.Node.height) == LitInt(0));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> LitInt(0)
             <= KMBtree.NodeContents.nkeys(read($Heap, ##node#6, KMBtree.Node.contents)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> KMBtree.NodeContents.nkeys(read($Heap, ##node#6, KMBtree.Node.contents))
             <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, ##node#6, KMBtree.Node.contents)))
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> Lit(true));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#6)), 
                    $Box(KMBtree.NodeContents.pivots(read($Heap, ##node#6, KMBtree.Node.contents)))), 
                  $Box(children#9)), 
                read($Heap, ##node#6, KMBtree.Node.repr)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              0 < nchildren#9)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              nchildren#9 <= LitInt(KMBtree.__default.MaxChildren()))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#9))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, ##node#6, KMBtree.Node.contents)))
                 == LitInt(KMBtree.__default.MaxChildren() - 1))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#53: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#53))): ref } 
                LitInt(0) <= i#53 && i#53 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#53 && i#53 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#53))): ref != null))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                $Heap, 
                Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), 
                read($Heap, ##node#6, KMBtree.Node.repr), 
                read($Heap, ##node#6, KMBtree.Node.height)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#54: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#54))): ref } 
                LitInt(0) <= i#54 && i#54 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#54 && i#54 < nchildren#9
                   ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#54))): ref, KMBtree.Node.repr)[$Box(##node#6)]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#55: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#55))): ref } 
                LitInt(0) <= i#55 && i#55 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#55 && i#55 < nchildren#9
                   ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, ##node#6, KMBtree.Node.contents)))]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#56: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref } 
                    { $Unbox(read($Heap, children#9, IndexField(i#56))): ref } 
                  LitInt(0) <= i#56 && i#56 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#56 && i#56 < nchildren#9
                     ==> $Unbox(read($Heap, children#9, IndexField(i#56))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref)
                 ==> Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#9 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#56: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref } 
                    { $Unbox(read($Heap, children#9, IndexField(i#56))): ref } 
                  LitInt(0) <= i#56 && i#56 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#56 && i#56 < nchildren#9
                     ==> $Unbox(read($Heap, children#9, IndexField(i#56))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref)
                 ==> (forall i#57: int :: 
                  { $Unbox(read($Heap, children#9, IndexField(i#57))): ref } 
                  LitInt(0) <= i#57 && i#57 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#57 && i#57 < nchildren#9
                     ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#57))): ref, KMBtree.Node.repr)[$Box(children#9)]))));
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#7 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtreeModel.Node(), $Heap);
    ##i#0 := nleft#0 - 1;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#0, TInt, $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Index_q(##node#7);
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 < Seq#Length(KMBtreeModel.Node.children(##node#7)) - 1;
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 < Seq#Length(KMBtreeModel.Node.pivots(##node#7));
    assume KMBtreeModel.__default.AllKeysBelowBound#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), nleft#0 - 1);
    assume KMBtree.__default.I#canCall($Heap, node#0)
       && KMBtreeModel.__default.AllKeysBelowBound#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), nleft#0 - 1);
    assume true;
    assume KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), nleft#0 - 1);
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](727,5)
    ##node#8 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#8, Tclass.KMBtree.Node(), $Heap);
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> Set#Equal(read($Heap, ##node#8, KMBtree.Node.repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#8)), 
                $Box(KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents)))), 
              $Box(KMBtree.NodeContents.values(read($Heap, ##node#8, KMBtree.Node.contents))))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents)), 
            KMBtree.NodeContents.values(read($Heap, ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> read($Heap, ##node#8, KMBtree.Node.height) == LitInt(0));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> LitInt(0)
             <= KMBtree.NodeContents.nkeys(read($Heap, ##node#8, KMBtree.Node.contents)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> KMBtree.NodeContents.nkeys(read($Heap, ##node#8, KMBtree.Node.contents))
             <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, ##node#8, KMBtree.Node.contents)))
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> Lit(true));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#8)), 
                    $Box(KMBtree.NodeContents.pivots(read($Heap, ##node#8, KMBtree.Node.contents)))), 
                  $Box(children#10)), 
                read($Heap, ##node#8, KMBtree.Node.repr)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              0 < nchildren#10)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              nchildren#10 <= LitInt(KMBtree.__default.MaxChildren()))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#10))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, ##node#8, KMBtree.Node.contents)))
                 == LitInt(KMBtree.__default.MaxChildren() - 1))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#58: int :: 
                { $Unbox(read($Heap, children#10, IndexField(i#58))): ref } 
                LitInt(0) <= i#58 && i#58 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#58 && i#58 < nchildren#10
                   ==> $Unbox(read($Heap, children#10, IndexField(i#58))): ref != null))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                $Heap, 
                Seq#Take(Seq#FromArray($Heap, children#10), nchildren#10), 
                read($Heap, ##node#8, KMBtree.Node.repr), 
                read($Heap, ##node#8, KMBtree.Node.height)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#59: int :: 
                { $Unbox(read($Heap, children#10, IndexField(i#59))): ref } 
                LitInt(0) <= i#59 && i#59 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#59 && i#59 < nchildren#10
                   ==> !read($Heap, 
                    $Unbox(read($Heap, children#10, IndexField(i#59))): ref, 
                    KMBtree.Node.repr)[$Box(##node#8)]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#60: int :: 
                { $Unbox(read($Heap, children#10, IndexField(i#60))): ref } 
                LitInt(0) <= i#60 && i#60 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#60 && i#60 < nchildren#10
                   ==> !read($Heap, 
                    $Unbox(read($Heap, children#10, IndexField(i#60))): ref, 
                    KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, ##node#8, KMBtree.Node.contents)))]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#61: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#10), nchildren#10), i#61)): ref } 
                    { $Unbox(read($Heap, children#10, IndexField(i#61))): ref } 
                  LitInt(0) <= i#61 && i#61 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#61 && i#61 < nchildren#10
                     ==> $Unbox(read($Heap, children#10, IndexField(i#61))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#10), nchildren#10), i#61)): ref)
                 ==> Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#10 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#61: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#10), nchildren#10), i#61)): ref } 
                    { $Unbox(read($Heap, children#10, IndexField(i#61))): ref } 
                  LitInt(0) <= i#61 && i#61 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#61 && i#61 < nchildren#10
                     ==> $Unbox(read($Heap, children#10, IndexField(i#61))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#10), nchildren#10), i#61)): ref)
                 ==> (forall i#62: int :: 
                  { $Unbox(read($Heap, children#10, IndexField(i#62))): ref } 
                  LitInt(0) <= i#62 && i#62 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#62 && i#62 < nchildren#10
                     ==> !read($Heap, 
                      $Unbox(read($Heap, children#10, IndexField(i#62))): ref, 
                      KMBtree.Node.repr)[$Box(children#10)]))));
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#9 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtreeModel.Node(), $Heap);
    ##i#1 := nleft#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#1, TInt, $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Index_q(##node#9);
    assert {:subsumption 0} LitInt(0) <= ##i#1;
    assert {:subsumption 0} ##i#1 < Seq#Length(KMBtreeModel.Node.children(##node#9));
    assert {:subsumption 0} LitInt(0) <= ##i#1 - 1;
    assert {:subsumption 0} ##i#1 - 1 < Seq#Length(KMBtreeModel.Node.pivots(##node#9));
    assume KMBtreeModel.__default.AllKeysAboveBound#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), nleft#0);
    assume KMBtree.__default.I#canCall($Heap, node#0)
       && KMBtreeModel.__default.AllKeysAboveBound#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), nleft#0);
    assume true;
    assume KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), nleft#0);
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](728,22)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##3 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    from##2 := nleft#0;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    to##2 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.SubIndex(node##3, from##2, to##2);
    // TrCallStmt: After ProcessCallStmt
    right#0 := $rhs##0;
    defass#right#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](728,59)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](729,11)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
    newtype$check#4 := LitInt(1);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    newtype$check#5 := nleft#0 - 1;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
    assume 0 <= nleft#0 - 1
       && nleft#0 - 1
         < _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    pivot#0 := $Unbox(read($Heap, 
        KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(nleft#0 - 1))): Seq Box;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](729,42)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](730,13)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##4 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##0 := LitInt(0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.IOfChild(node##4, childidx##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](730,21)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](731,16)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##5 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    newnchildren##0 := nleft#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == node##5 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.IndexPrefix(node##5, newnchildren##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](731,28)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](732,21)
    assume true;
    ##node#10 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#10);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    inode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](732,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](733,22)
    assume true;
    assume defass#right#0;
    ##node#11 := right#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#11, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#11);
    assume KMBtree.__default.I#canCall($Heap, right#0);
    assume KMBtree.__default.I#canCall($Heap, right#0);
    iright#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](733,32)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](734,5)
    ##node#12 := inode#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#12, Tclass.KMBtreeModel.Node(), $Heap);
    ##i#2 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#2, TInt, $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Index_q(##node#12);
    assert {:subsumption 0} LitInt(0) <= ##i#2;
    assert {:subsumption 0} ##i#2 < Seq#Length(KMBtreeModel.Node.children(##node#12)) - 1;
    assert {:subsumption 0} LitInt(0) <= ##i#2;
    assert {:subsumption 0} ##i#2 < Seq#Length(KMBtreeModel.Node.pivots(##node#12));
    assume KMBtreeModel.__default.AllKeysBelowBound#canCall(inode#0, LitInt(0));
    assume KMBtreeModel.__default.AllKeysBelowBound#canCall(inode#0, LitInt(0));
    assume true;
    assume KMBtreeModel.__default.AllKeysBelowBound(inode#0, LitInt(0));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](735,5)
    assume KMBtreeModel.Node.Index_q(iright#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(KMBtreeModel.Node.children(iright#0));
    assume KMBtreeModel.Node.Index_q(inode#0);
    assume {:subsumption 0} 0 <= nleft#0 && nleft#0 < Seq#Length(KMBtreeModel.Node.children(inode#0));
    assume $IsA#KMBtreeModel.Node($Unbox(Seq#Index(KMBtreeModel.Node.children(iright#0), LitInt(0))): DatatypeType)
       && $IsA#KMBtreeModel.Node($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), nleft#0)): DatatypeType);
    assume KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(iright#0), LitInt(0))): DatatypeType, 
      $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), nleft#0)): DatatypeType);
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](736,42)
    // TrCallStmt: Before ProcessCallStmt
    ##node#13 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#13);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    assume KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    // ProcessCallStmt: CheckSubrange
    run##0 := KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := LitInt(0);
    newtype$check#6 := LitInt(1);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    newtype$check#7 := nleft#0 - 1;
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    j##0 := nleft#0 - 1;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLte(run##0, i##0, j##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](736,85)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](737,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](737,14)"} true;
    assert defass#right#0;
}



procedure CheckWellformed$$KMBtree.__default.SplitNode(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 51 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.SplitNode(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#4))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#20: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#20))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#21: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#21))): ref } 
                  LitInt(0) <= i#21 && i#21 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#21 && i#21 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#21))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#22: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#22))): ref } 
                  LitInt(0) <= i#22 && i#22 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#22 && i#22 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#22))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#23: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), i#23)): ref } 
                      { $Unbox(read($Heap, children#4, IndexField(i#23))): ref } 
                    LitInt(0) <= i#23 && i#23 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#23 && i#23 < nchildren#4
                       ==> $Unbox(read($Heap, children#4, IndexField(i#23))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), i#23)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#23: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), i#23)): ref } 
                      { $Unbox(read($Heap, children#4, IndexField(i#23))): ref } 
                    LitInt(0) <= i#23 && i#23 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#23 && i#23 < nchildren#4
                       ==> $Unbox(read($Heap, children#4, IndexField(i#23))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), i#23)): ref)
                   ==> (forall i#24: int :: 
                    { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                    LitInt(0) <= i#24 && i#24 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#24 && i#24 < nchildren#4
                       ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#24))): ref, KMBtree.Node.repr)[$Box(children#4)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#25: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#25)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#25
                   && i#25
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#25)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#26: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#26)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#26
                   && i#26
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#26)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#27: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#27) } 
              true
                 ==> 
                LitInt(0) <= i#27
                   && i#27
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#27))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#28: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#28) } 
              true
                 ==> 
                0 < i#28
                   && i#28
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#28))));
  requires KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#5)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#5
                 && nchildren#5 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#29: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#5
                     ==> $Unbox(read($Heap, children#5, IndexField(i#29))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#30: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#30))): ref } 
                  LitInt(0) <= i#30 && i#30 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#30 && i#30 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#30))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#31: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#31))): ref } 
                  LitInt(0) <= i#31 && i#31 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#31 && i#31 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#31))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#33: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#33))): ref } 
                  LitInt(0) <= i#33 && i#33 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#33 && i#33 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#33))): ref, KMBtree.Node.repr)[$Box(children#5)]))));
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, right#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
         && read($Heap, right#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          true
             && (var children#6 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read($Heap, right#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#6
                 && nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#34: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#34))): ref } 
                  LitInt(0) <= i#34 && i#34 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#34 && i#34 < nchildren#6
                     ==> $Unbox(read($Heap, children#6, IndexField(i#34))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                  read($Heap, right#0, KMBtree.Node.repr), 
                  read($Heap, right#0, KMBtree.Node.height))
                 && (forall i#35: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#35))): ref } 
                  LitInt(0) <= i#35 && i#35 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#35 && i#35 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#35))): ref, KMBtree.Node.repr)[$Box(right#0)])
                 && (forall i#36: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#36))): ref } 
                  LitInt(0) <= i#36 && i#36 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#36 && i#36 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#36))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#38: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#38))): ref } 
                  LitInt(0) <= i#38 && i#38 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#38 && i#38 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#38))): ref, KMBtree.Node.repr)[$Box(children#6)]))));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures true;
  ensures read($Heap, right#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures true;
  ensures Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
    read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, right#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures Set#Disjoint(read($Heap, node#0, KMBtree.Node.repr), read($Heap, right#0, KMBtree.Node.repr));
  free ensures KMBtree.__default.Full#canCall($Heap, node#0);
  ensures !KMBtree.__default.Full($Heap, node#0);
  free ensures KMBtree.__default.Full#canCall($Heap, right#0);
  ensures !KMBtree.__default.Full($Heap, right#0);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, right#0)
     && KMBtreeModel.__default.SplitNode#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0);
  free ensures KMBtreeModel.__default.SplitNode#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     && 
    KMBtreeModel.__default.SplitNode(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     && (KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0));
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
    KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0))[$Box(pivot#0)];
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.SplitNode(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns (right#0: ref
       where $Is(right#0, Tclass.KMBtree.Node())
         && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap), 
    pivot#0: Seq Box
       where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    $_reverifyPost: bool);
  free requires 51 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#8)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#8)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#8 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#48: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#48))): ref } 
              LitInt(0) <= i#48 && i#48 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#48 && i#48 < nchildren#8
                 ==> $Unbox(read($Heap, children#8, IndexField(i#48))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#49: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#49))): ref } 
              LitInt(0) <= i#49 && i#49 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#49 && i#49 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#49))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#50: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#50))): ref } 
              LitInt(0) <= i#50 && i#50 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#50 && i#50 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#50))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#51: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                LitInt(0) <= i#51 && i#51 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#51 && i#51 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#51: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                LitInt(0) <= i#51 && i#51 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#51 && i#51 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
               ==> (forall i#52: int :: 
                { $Unbox(read($Heap, children#8, IndexField(i#52))): ref } 
                LitInt(0) <= i#52 && i#52 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#52 && i#52 < nchildren#8
                   ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(children#8)]))));
  free ensures KMBtree.__default.WFShape#canCall($Heap, right#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, right#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> read($Heap, right#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, right#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, right#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, right#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(right#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))), 
                $Box(children#9)), 
              read($Heap, right#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            0 < nchildren#9)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            nchildren#9 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#9))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#53: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#53))): ref } 
              LitInt(0) <= i#53 && i#53 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#53 && i#53 < nchildren#9
                 ==> $Unbox(read($Heap, children#9, IndexField(i#53))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), 
              read($Heap, right#0, KMBtree.Node.repr), 
              read($Heap, right#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#54: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#54))): ref } 
              LitInt(0) <= i#54 && i#54 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#54 && i#54 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#54))): ref, KMBtree.Node.repr)[$Box(right#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#55: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#55))): ref } 
              LitInt(0) <= i#55 && i#55 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#55 && i#55 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, right#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#56: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#56))): ref } 
                LitInt(0) <= i#56 && i#56 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#56 && i#56 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#56))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, right#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, right#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, right#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, right#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, right#0, KMBtree.Node.contents)); 
            (forall i#56: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#56))): ref } 
                LitInt(0) <= i#56 && i#56 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#56 && i#56 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#56))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#56)): ref)
               ==> (forall i#57: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#57))): ref } 
                LitInt(0) <= i#57 && i#57 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#57 && i#57 < nchildren#9
                   ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#57))): ref, KMBtree.Node.repr)[$Box(children#9)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, right#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures true;
  ensures $_reverifyPost
     ==> Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, right#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> Set#Disjoint(read($Heap, node#0, KMBtree.Node.repr), read($Heap, right#0, KMBtree.Node.repr));
  free ensures KMBtree.__default.Full#canCall($Heap, node#0);
  ensures $_reverifyPost ==> !KMBtree.__default.Full($Heap, node#0);
  free ensures KMBtree.__default.Full#canCall($Heap, right#0);
  ensures $_reverifyPost ==> !KMBtree.__default.Full($Heap, right#0);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtree.__default.I#canCall($Heap, right#0)
     && KMBtreeModel.__default.SplitNode#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0);
  ensures KMBtreeModel.__default.SplitNode#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
      pivot#0)
     ==> KMBtreeModel.__default.SplitNode(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || 
      KMBtreeModel.__default.SplitLeaf(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0), 
        pivot#0)
       || KMBtreeModel.__default.SplitIndex(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, right#0), 
        pivot#0);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0))[$Box(pivot#0)];
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == node#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.SplitNode(node#0: ref) returns (right#0: ref, pivot#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#right#0: bool;
  var boundary#0_0: int
     where LitInt(0) <= boundary#0_0 && boundary#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var run##0_0: Seq Box;
  var i##0_0: int;
  var j##0_0: int;
  var $rhs##0_0: ref
     where $Is($rhs##0_0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0_0, Tclass.KMBtree.Node(), $Heap);
  var node##0_0: ref;
  var nleft##0_0: int;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var pivot##0_0: Seq Box;
  var boundary#0: int
     where LitInt(0) <= boundary#0 && boundary#0 < 18446744073709551616;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0, Tclass.KMBtree.Node(), $Heap);
  var $rhs##1: Seq Box
     where $Is($rhs##1, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##1, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var node##0: ref;
  var nleft##0: int;

    // AddMethodImpl: SplitNode, Impl$$KMBtree.__default.SplitNode
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> $o == node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](755,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](756,5)
    assume node#0 != null;
    assume true;
    if (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents)))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](757,20)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#0_0 := LitInt(2);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume LitInt(2) != 0;
        newtype$check#0_1 := Div(KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)), 
          LitInt(2));
        assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        boundary#0_0 := Div(KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)), 
          LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](757,43)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](758,13)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume 0 <= boundary#0_0
           && boundary#0_0
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        pivot#0 := $Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(boundary#0_0))): Seq Box;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](758,43)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](759,43)
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume 0 <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
             <= _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        // ProcessCallStmt: CheckSubrange
        run##0_0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##0_0 := boundary#0_0 - 1;
        assume true;
        // ProcessCallStmt: CheckSubrange
        j##0_0 := boundary#0_0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLt(run##0_0, i##0_0, j##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](759,123)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](760,25)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0_0 := node#0;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#0_2 := LitInt(2);
        assume LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume LitInt(2) != 0;
        newtype$check#0_3 := Div(KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)), 
          LitInt(2));
        assume LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        nleft##0_0 := Div(KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)), 
          LitInt(2));
        assume true;
        // ProcessCallStmt: CheckSubrange
        pivot##0_0 := pivot#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == node##0_0 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$KMBtree.__default.SplitLeaf(node##0_0, nleft##0_0, pivot##0_0);
        // TrCallStmt: After ProcessCallStmt
        right#0 := $rhs##0_0;
        defass#right#0 := true;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](760,62)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](762,20)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#0 := LitInt(2);
        assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume LitInt(2) != 0;
        newtype$check#1 := Div(KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)), 
          LitInt(2));
        assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        assume true;
        boundary#0 := Div(KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)), 
          LitInt(2));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](762,47)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](763,33)
        assume true;
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Key
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        nleft##0 := boundary#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == node##0 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0, $rhs##1 := Call$$KMBtree.__default.SplitIndex(node##0, nleft##0);
        // TrCallStmt: After ProcessCallStmt
        right#0 := $rhs##0;
        defass#right#0 := true;
        pivot#0 := $rhs##1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](763,48)"} true;
    }

    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](765,25)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__AllKeys();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](765,26)"} true;
    assert defass#right#0;
}



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.SplitChildOfIndexPreservesWFShape(previous$Heap: Heap, 
    current$Heap: Heap, 
    node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap), 
    childidx#0: int);
  free requires 52 == $FunctionContextHeight;
  free requires previous$Heap == $Heap
     && 
    $HeapSucc(previous$Heap, current$Heap)
     && $IsGoodHeap(current$Heap);
  requires $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap);
  requires $IsAlloc(childidx#0, TInt, previous$Heap);
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.SplitChildOfIndexPreservesWFShape(previous$Heap: Heap, 
    current$Heap: Heap, 
    node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap), 
    childidx#0: int);
  requires $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap);
  requires $IsAlloc(childidx#0, TInt, previous$Heap);
  // user-defined preconditions
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read(previous$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> read(previous$Heap, node#0, KMBtree.Node.height) == LitInt(0));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#0)), 
              read(previous$Heap, node#0, KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#0)));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            nchildren#0 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#0))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#4: int :: 
              { $Unbox(read(previous$Heap, children#0, IndexField(i#4))): ref } 
              LitInt(0) <= i#4 && i#4 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#4 && i#4 < nchildren#0
                 ==> $Unbox(read(previous$Heap, children#0, IndexField(i#4))): ref != null))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              previous$Heap, 
              Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), 
              read(previous$Heap, node#0, KMBtree.Node.repr), 
              read(previous$Heap, node#0, KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#5: int :: 
              { $Unbox(read(previous$Heap, children#0, IndexField(i#5))): ref } 
              LitInt(0) <= i#5 && i#5 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#5 && i#5 < nchildren#0
                 ==> !read(previous$Heap, 
                  $Unbox(read(previous$Heap, children#0, IndexField(i#5))): ref, 
                  KMBtree.Node.repr)[$Box(node#0)]))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#6: int :: 
              { $Unbox(read(previous$Heap, children#0, IndexField(i#6))): ref } 
              LitInt(0) <= i#6 && i#6 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#6 && i#6 < nchildren#0
                 ==> !read(previous$Heap, 
                  $Unbox(read(previous$Heap, children#0, IndexField(i#6))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#7: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref } 
                  { $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref } 
                LitInt(0) <= i#7 && i#7 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#7 && i#7 < nchildren#0
                   ==> $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#7: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref } 
                  { $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref } 
                LitInt(0) <= i#7 && i#7 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#7 && i#7 < nchildren#0
                   ==> $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref)
               ==> (forall i#8: int :: 
                { $Unbox(read(previous$Heap, children#0, IndexField(i#8))): ref } 
                LitInt(0) <= i#8 && i#8 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#8 && i#8 < nchildren#0
                   ==> !read(previous$Heap, 
                    $Unbox(read(previous$Heap, children#0, IndexField(i#8))): ref, 
                    KMBtree.Node.repr)[$Box(children#0)]))));
  requires KMBtree.NodeContents.Index_q(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full(previous$Heap, node#0);
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.Index_q(read(current$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents))
       + 1;
  requires KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires read(current$Heap, node#0, KMBtree.Node.height)
     == read(previous$Heap, node#0, KMBtree.Node.height);
  requires (forall<alpha> $o: ref, $f: Field alpha :: 
    { read(current$Heap, $o, $f) } 
    $o != null
       ==> 
      read(previous$Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !(
          $o == node#0
           || $o
             == KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents))
           || $o
             == KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))
           || $o
             == $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref)
       ==> read(current$Heap, $o, $f) == read(previous$Heap, $o, $f));
  requires (forall i#1: int :: 
    { $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
      { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < childidx#0
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref);
  requires (forall i#3: int :: 
    { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#3))): ref } 
    true
       ==> 
      childidx#0 + 1 < i#3
         && i#3
           < KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3 - 1))): ref);
  requires $Unbox(read(previous$Heap, 
        KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires $Unbox(read(current$Heap, 
        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> Set#Equal(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.height)
           == LitInt(0));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                    read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))), 
                  $Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                        $Unbox(read(current$Heap, 
                            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0))): ref, 
                        KMBtree.Node.contents)))), 
                $Box(children#1)), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            0 < nchildren#1)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            nchildren#1 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#9: int :: 
              { $Unbox(read(current$Heap, children#1, IndexField(i#9))): ref } 
              LitInt(0) <= i#9 && i#9 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#9 && i#9 < nchildren#1
                 ==> $Unbox(read(current$Heap, children#1, IndexField(i#9))): ref != null))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              current$Heap, 
              Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#10: int :: 
              { $Unbox(read(current$Heap, children#1, IndexField(i#10))): ref } 
              LitInt(0) <= i#10 && i#10 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#10 && i#10 < nchildren#1
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#1, IndexField(i#10))): ref, 
                  KMBtree.Node.repr)[read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))]))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#11: int :: 
              { $Unbox(read(current$Heap, children#1, IndexField(i#11))): ref } 
              LitInt(0) <= i#11 && i#11 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#11 && i#11 < nchildren#1
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#1, IndexField(i#11))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                      $Unbox(read(current$Heap, 
                          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0))): ref, 
                      KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#12: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref } 
                  { $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref } 
                LitInt(0) <= i#12 && i#12 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#12 && i#12 < nchildren#1
                   ==> $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#12: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref } 
                  { $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref } 
                LitInt(0) <= i#12 && i#12 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#12 && i#12 < nchildren#1
                   ==> $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref)
               ==> (forall i#13: int :: 
                { $Unbox(read(current$Heap, children#1, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#1
                   ==> !read(current$Heap, 
                    $Unbox(read(current$Heap, children#1, IndexField(i#13))): ref, 
                    KMBtree.Node.repr)[$Box(children#1)]))));
  requires Set#Subset(read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.repr), 
    read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.repr));
  requires read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height)
     == read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height);
  requires $Unbox(read(current$Heap, 
        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0 + 1))): ref
     != null;
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> Set#Equal(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.height)
           == LitInt(0));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                    read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))), 
                  $Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                        $Unbox(read(current$Heap, 
                            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0 + 1))): ref, 
                        KMBtree.Node.contents)))), 
                $Box(children#2)), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            0 < nchildren#2)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            nchildren#2 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#14: int :: 
              { $Unbox(read(current$Heap, children#2, IndexField(i#14))): ref } 
              LitInt(0) <= i#14 && i#14 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#14 && i#14 < nchildren#2
                 ==> $Unbox(read(current$Heap, children#2, IndexField(i#14))): ref != null))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              current$Heap, 
              Seq#Take(Seq#FromArray(current$Heap, children#2), nchildren#2), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.repr), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#15: int :: 
              { $Unbox(read(current$Heap, children#2, IndexField(i#15))): ref } 
              LitInt(0) <= i#15 && i#15 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#15 && i#15 < nchildren#2
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#2, IndexField(i#15))): ref, 
                  KMBtree.Node.repr)[read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))]))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#16: int :: 
              { $Unbox(read(current$Heap, children#2, IndexField(i#16))): ref } 
              LitInt(0) <= i#16 && i#16 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#16 && i#16 < nchildren#2
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#2, IndexField(i#16))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                      $Unbox(read(current$Heap, 
                          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0 + 1))): ref, 
                      KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#17: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#2), nchildren#2), i#17)): ref } 
                  { $Unbox(read(current$Heap, children#2, IndexField(i#17))): ref } 
                LitInt(0) <= i#17 && i#17 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#17 && i#17 < nchildren#2
                   ==> $Unbox(read(current$Heap, children#2, IndexField(i#17))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#2), nchildren#2), i#17)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          (var children#2 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#17: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#2), nchildren#2), i#17)): ref } 
                  { $Unbox(read(current$Heap, children#2, IndexField(i#17))): ref } 
                LitInt(0) <= i#17 && i#17 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#17 && i#17 < nchildren#2
                   ==> $Unbox(read(current$Heap, children#2, IndexField(i#17))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#2), nchildren#2), i#17)): ref)
               ==> (forall i#18: int :: 
                { $Unbox(read(current$Heap, children#2, IndexField(i#18))): ref } 
                LitInt(0) <= i#18 && i#18 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#18 && i#18 < nchildren#2
                   ==> !read(current$Heap, 
                    $Unbox(read(current$Heap, children#2, IndexField(i#18))): ref, 
                    KMBtree.Node.repr)[$Box(children#2)]))));
  requires (forall $o: ref :: 
    { read(previous$Heap, $o, alloc) } 
    read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0 + 1))): ref, 
          KMBtree.Node.repr)[$Box($o)]
         && !read(previous$Heap, 
          $Unbox(read(previous$Heap, 
              KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(previous$Heap, $o, alloc));
  requires read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref, 
      KMBtree.Node.height)
     == read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height);
  requires KMBtree.__default.DisjointSubtrees#canCall(current$Heap, 
      read(current$Heap, node#0, KMBtree.Node.contents), 
      childidx#0, 
      childidx#0 + 1)
     ==> KMBtree.__default.DisjointSubtrees(current$Heap, 
        read(current$Heap, node#0, KMBtree.Node.contents), 
        childidx#0, 
        childidx#0 + 1)
       || (KMBtree.__default.DisjointReprs#canCall(current$Heap, 
          Seq#Take(Seq#FromArray(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))), 
          childidx#0, 
          childidx#0 + 1)
         ==> KMBtree.__default.DisjointReprs(current$Heap, 
            Seq#Take(Seq#FromArray(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))), 
              KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))), 
            childidx#0, 
            childidx#0 + 1)
           || Set#Disjoint(read(current$Heap, 
              $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))), 
                    KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))), 
                  childidx#0)): ref, 
              KMBtree.Node.repr), 
            read(current$Heap, 
              $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))), 
                    KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))), 
                  childidx#0 + 1)): ref, 
              KMBtree.Node.repr)));
  requires Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
    Set#Union(read(previous$Heap, node#0, KMBtree.Node.repr), 
      read(current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref, 
        KMBtree.Node.repr)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall(current$Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))
         && read(current$Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#3 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#3 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read(current$Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#3
                 && nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#19: int :: 
                  { $Unbox(read(current$Heap, children#3, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#3
                     ==> $Unbox(read(current$Heap, children#3, IndexField(i#19))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  current$Heap, 
                  Seq#Take(Seq#FromArray(current$Heap, children#3), nchildren#3), 
                  read(current$Heap, node#0, KMBtree.Node.repr), 
                  read(current$Heap, node#0, KMBtree.Node.height))
                 && (forall i#20: int :: 
                  { $Unbox(read(current$Heap, children#3, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#3
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#3, IndexField(i#20))): ref, 
                      KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#21: int :: 
                  { $Unbox(read(current$Heap, children#3, IndexField(i#21))): ref } 
                  LitInt(0) <= i#21 && i#21 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#21 && i#21 < nchildren#3
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#3, IndexField(i#21))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#23: int :: 
                  { $Unbox(read(current$Heap, children#3, IndexField(i#23))): ref } 
                  LitInt(0) <= i#23 && i#23 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#23 && i#23 < nchildren#3
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#3, IndexField(i#23))): ref, 
                      KMBtree.Node.repr)[$Box(children#3)]))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.SplitChildOfIndexPreservesWFShape(previous$Heap: Heap, 
    current$Heap: Heap, 
    node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap), 
    childidx#0: int)
   returns ($_reverifyPost: bool);
  free requires 52 == $FunctionContextHeight;
  free requires previous$Heap == $Heap
     && 
    $HeapSucc(previous$Heap, current$Heap)
     && $IsGoodHeap(current$Heap);
  requires $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap);
  requires $IsAlloc(childidx#0, TInt, previous$Heap);
  // user-defined preconditions
  free requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read(previous$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))
         && read(previous$Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read(previous$Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read(previous$Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read(previous$Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  previous$Heap, 
                  Seq#Take(Seq#FromArray(previous$Heap, children#4), nchildren#4), 
                  read(previous$Heap, node#0, KMBtree.Node.repr), 
                  read(previous$Heap, node#0, KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read(previous$Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read(previous$Heap, 
                      $Unbox(read(previous$Heap, children#4, IndexField(i#25))): ref, 
                      KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#26: int :: 
                  { $Unbox(read(previous$Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read(previous$Heap, 
                      $Unbox(read(previous$Heap, children#4, IndexField(i#26))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read(previous$Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read(previous$Heap, 
                      $Unbox(read(previous$Heap, children#4, IndexField(i#28))): ref, 
                      KMBtree.Node.repr)[$Box(children#4)]))));
  requires KMBtree.NodeContents.Index_q(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full(previous$Heap, node#0);
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.Index_q(read(current$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents))
       + 1;
  requires KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires read(current$Heap, node#0, KMBtree.Node.height)
     == read(previous$Heap, node#0, KMBtree.Node.height);
  requires (forall<alpha> $o: ref, $f: Field alpha :: 
    { read(current$Heap, $o, $f) } 
    $o != null
       ==> 
      read(previous$Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !(
          $o == node#0
           || $o
             == KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents))
           || $o
             == KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))
           || $o
             == $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref)
       ==> read(current$Heap, $o, $f) == read(previous$Heap, $o, $f));
  requires (forall i#1: int :: 
    { $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
      { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < childidx#0
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref);
  requires (forall i#3: int :: 
    { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#3))): ref } 
    true
       ==> 
      childidx#0 + 1 < i#3
         && i#3
           < KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3 - 1))): ref);
  requires $Unbox(read(previous$Heap, 
        KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires $Unbox(read(current$Heap, 
        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  free requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     && 
    KMBtree.__default.WFShape($LS($LZ), 
      current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     && (if KMBtree.NodeContents.Leaf_q(read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.contents))
       then Set#Equal(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)))
         && read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.height)
           == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
       else true
         && (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          true
             && (var children#5 := KMBtree.NodeContents.children(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                        read(current$Heap, 
                          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0))), 
                      $Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                            $Unbox(read(current$Heap, 
                                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(childidx#0))): ref, 
                            KMBtree.Node.contents)))), 
                    $Box(children#5)), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr))
                 && 
                0 < nchildren#5
                 && nchildren#5 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, 
                        $Unbox(read(current$Heap, 
                            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0))): ref, 
                        KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#29: int :: 
                  { $Unbox(read(current$Heap, children#5, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#5
                     ==> $Unbox(read(current$Heap, children#5, IndexField(i#29))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  current$Heap, 
                  Seq#Take(Seq#FromArray(current$Heap, children#5), nchildren#5), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.height))
                 && (forall i#30: int :: 
                  { $Unbox(read(current$Heap, children#5, IndexField(i#30))): ref } 
                  LitInt(0) <= i#30 && i#30 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#30 && i#30 < nchildren#5
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#5, IndexField(i#30))): ref, 
                      KMBtree.Node.repr)[read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))])
                 && (forall i#31: int :: 
                  { $Unbox(read(current$Heap, children#5, IndexField(i#31))): ref } 
                  LitInt(0) <= i#31 && i#31 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#31 && i#31 < nchildren#5
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#5, IndexField(i#31))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                          $Unbox(read(current$Heap, 
                              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                              IndexField(childidx#0))): ref, 
                          KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#33: int :: 
                  { $Unbox(read(current$Heap, children#5, IndexField(i#33))): ref } 
                  LitInt(0) <= i#33 && i#33 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#33 && i#33 < nchildren#5
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#5, IndexField(i#33))): ref, 
                      KMBtree.Node.repr)[$Box(children#5)]))));
  requires Set#Subset(read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.repr), 
    read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.repr));
  requires read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height)
     == read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height);
  requires $Unbox(read(current$Heap, 
        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0 + 1))): ref
     != null;
  free requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     && 
    KMBtree.__default.WFShape($LS($LZ), 
      current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref)
     && (if KMBtree.NodeContents.Leaf_q(read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0 + 1))): ref, 
          KMBtree.Node.contents))
       then Set#Equal(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents)))
         && read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref, 
            KMBtree.Node.height)
           == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)))
       else true
         && (var nchildren#6 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.contents)); 
          true
             && (var children#6 := KMBtree.NodeContents.children(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                        read(current$Heap, 
                          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0 + 1))), 
                      $Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                            $Unbox(read(current$Heap, 
                                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(childidx#0 + 1))): ref, 
                            KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.repr))
                 && 
                0 < nchildren#6
                 && nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, 
                        $Unbox(read(current$Heap, 
                            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0 + 1))): ref, 
                        KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#34: int :: 
                  { $Unbox(read(current$Heap, children#6, IndexField(i#34))): ref } 
                  LitInt(0) <= i#34 && i#34 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#34 && i#34 < nchildren#6
                     ==> $Unbox(read(current$Heap, children#6, IndexField(i#34))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  current$Heap, 
                  Seq#Take(Seq#FromArray(current$Heap, children#6), nchildren#6), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.repr), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0 + 1))): ref, 
                    KMBtree.Node.height))
                 && (forall i#35: int :: 
                  { $Unbox(read(current$Heap, children#6, IndexField(i#35))): ref } 
                  LitInt(0) <= i#35 && i#35 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#35 && i#35 < nchildren#6
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#6, IndexField(i#35))): ref, 
                      KMBtree.Node.repr)[read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))])
                 && (forall i#36: int :: 
                  { $Unbox(read(current$Heap, children#6, IndexField(i#36))): ref } 
                  LitInt(0) <= i#36 && i#36 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#36 && i#36 < nchildren#6
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#6, IndexField(i#36))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                          $Unbox(read(current$Heap, 
                              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                              IndexField(childidx#0 + 1))): ref, 
                          KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#38: int :: 
                  { $Unbox(read(current$Heap, children#6, IndexField(i#38))): ref } 
                  LitInt(0) <= i#38 && i#38 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#38 && i#38 < nchildren#6
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#6, IndexField(i#38))): ref, 
                      KMBtree.Node.repr)[$Box(children#6)]))));
  requires (forall $o: ref :: 
    { read(previous$Heap, $o, alloc) } 
    read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0 + 1))): ref, 
          KMBtree.Node.repr)[$Box($o)]
         && !read(previous$Heap, 
          $Unbox(read(previous$Heap, 
              KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(previous$Heap, $o, alloc));
  requires read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref, 
      KMBtree.Node.height)
     == read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height);
  free requires KMBtree.__default.DisjointSubtrees#canCall(current$Heap, 
      read(current$Heap, node#0, KMBtree.Node.contents), 
      childidx#0, 
      childidx#0 + 1)
     && 
    KMBtree.__default.DisjointSubtrees(current$Heap, 
      read(current$Heap, node#0, KMBtree.Node.contents), 
      childidx#0, 
      childidx#0 + 1)
     && $Is(Seq#Take(Seq#FromArray(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node?()))
     && KMBtree.__default.DisjointReprs(current$Heap, 
      Seq#Take(Seq#FromArray(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))), 
      childidx#0, 
      childidx#0 + 1);
  requires Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
    Set#Union(read(previous$Heap, node#0, KMBtree.Node.repr), 
      read(current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0 + 1))): ref, 
        KMBtree.Node.repr)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall(current$Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> read(current$Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#7)), 
              read(current$Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#7)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            nchildren#7 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#39: int :: 
              { $Unbox(read(current$Heap, children#7, IndexField(i#39))): ref } 
              LitInt(0) <= i#39 && i#39 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#39 && i#39 < nchildren#7
                 ==> $Unbox(read(current$Heap, children#7, IndexField(i#39))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              current$Heap, 
              Seq#Take(Seq#FromArray(current$Heap, children#7), nchildren#7), 
              read(current$Heap, node#0, KMBtree.Node.repr), 
              read(current$Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#40: int :: 
              { $Unbox(read(current$Heap, children#7, IndexField(i#40))): ref } 
              LitInt(0) <= i#40 && i#40 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#40 && i#40 < nchildren#7
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#7, IndexField(i#40))): ref, 
                  KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
              { $Unbox(read(current$Heap, children#7, IndexField(i#41))): ref } 
              LitInt(0) <= i#41 && i#41 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#41 && i#41 < nchildren#7
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#7, IndexField(i#41))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#42: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#7), nchildren#7), i#42)): ref } 
                  { $Unbox(read(current$Heap, children#7, IndexField(i#42))): ref } 
                LitInt(0) <= i#42 && i#42 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#42 && i#42 < nchildren#7
                   ==> $Unbox(read(current$Heap, children#7, IndexField(i#42))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#7), nchildren#7), i#42)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#7 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#42: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#7), nchildren#7), i#42)): ref } 
                  { $Unbox(read(current$Heap, children#7, IndexField(i#42))): ref } 
                LitInt(0) <= i#42 && i#42 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#42 && i#42 < nchildren#7
                   ==> $Unbox(read(current$Heap, children#7, IndexField(i#42))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#7), nchildren#7), i#42)): ref)
               ==> (forall i#43: int :: 
                { $Unbox(read(current$Heap, children#7, IndexField(i#43))): ref } 
                LitInt(0) <= i#43 && i#43 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#43 && i#43 < nchildren#7
                   ==> !read(current$Heap, 
                    $Unbox(read(current$Heap, children#7, IndexField(i#43))): ref, 
                    KMBtree.Node.repr)[$Box(children#7)]))));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.SplitChildOfIndexPreservesWFShape(previous$Heap: Heap, current$Heap: Heap, node#0: ref, childidx#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var newchildren#0: Seq Box
     where $Is(newchildren#0, TSeq(Tclass.KMBtree.Node?()))
       && $IsAlloc(newchildren#0, TSeq(Tclass.KMBtree.Node?()), $Heap);
  var i#47: int;
  var ##contents#0_0: DatatypeType;
  var ##i#0_0: int;
  var ##j#0_0: int;
  var ##contents#1: DatatypeType;
  var ##i#1: int;
  var ##j#1: int;
  var nodes##0: Seq Box;
  var parentRepr##0: Set Box;
  var i#54: int;
  var j#0: int;
  var ##contents#3_0: DatatypeType;
  var ##i#3_0: int;
  var ##j#3_0: int;
  var ##contents#3_1: DatatypeType;
  var ##i#3_1: int;
  var ##j#3_1: int;
  var ##contents#3_2: DatatypeType;
  var ##i#3_2: int;
  var ##j#3_2: int;
  var ##node#3_0: ref;
  var ##node#3_1: ref;
  var ##contents#4_0: DatatypeType;
  var ##i#4_0: int;
  var ##j#4_0: int;
  var ##contents#4_1: DatatypeType;
  var ##i#4_1: int;
  var ##j#4_1: int;
  var ##node#4_0: ref;
  var ##contents#5_0: DatatypeType;
  var ##i#5_0: int;
  var ##j#5_0: int;
  var ##contents#5_1: DatatypeType;
  var ##i#5_1: int;
  var ##j#5_1: int;
  var ##node#5_0: ref;
  var ##contents#7_0: DatatypeType;
  var ##i#7_0: int;
  var ##j#7_0: int;
  var ##contents#7_1: DatatypeType;
  var ##i#7_1: int;
  var ##j#7_1: int;
  var ##contents#7_2: DatatypeType;
  var ##i#7_2: int;
  var ##j#7_2: int;
  var ##node#7_0: ref;
  var ##node#7_1: ref;
  var ##contents#8_0: DatatypeType;
  var ##i#8_0: int;
  var ##j#8_0: int;
  var ##contents#8_1: DatatypeType;
  var ##i#8_1: int;
  var ##j#8_1: int;
  var ##node#8_0: ref;
  var ##contents#9_0: DatatypeType;
  var ##i#9_0: int;
  var ##j#9_0: int;
  var ##contents#9_1: DatatypeType;
  var ##i#9_1: int;
  var ##j#9_1: int;
  var ##node#9_0: ref;
  var ##contents#2: DatatypeType;
  var ##i#2: int;
  var ##j#2: int;
  var ##contents#3: DatatypeType;
  var ##i#3: int;
  var ##j#3: int;
  var ##contents#4: DatatypeType;
  var ##i#4: int;
  var ##j#4: int;
  var ##node#5: ref;
  var ##node#6: ref;
  var ##nodes#1: Seq Box;
  var ##parentRepr#1: Set Box;
  var ##parentHeight#1: int;

    // AddMethodImpl: SplitChildOfIndexPreservesWFShape, Impl$$KMBtree.__default.SplitChildOfIndexPreservesWFShape
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $Heap := current$Heap;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](832,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), old($Heap), $ih#node0#0)
           && KMBtree.NodeContents.Index_q(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && !KMBtree.__default.Full(old($Heap), $ih#node0#0)
           && 
          LitInt(0) <= childidx#0
           && childidx#0
             < KMBtree.NodeContents.nchildren(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.Index_q(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
             == KMBtree.NodeContents.nchildren(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
               + 1
           && KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
             == KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.pivots(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
             == KMBtree.NodeContents.pivots(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.height)
             == read(old($Heap), $ih#node0#0, KMBtree.Node.height)
           && (forall<alpha> $o: ref, $f: Field alpha :: 
            { read($initHeapForallStmt#0, $o, $f) } 
            $o != null
               ==> 
              read(old($Heap), $ih#node0#0, KMBtree.Node.repr)[$Box($o)]
                 && !(
                  $o == $ih#node0#0
                   || $o
                     == KMBtree.NodeContents.pivots(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
                   || $o
                     == KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
                   || $o
                     == $Unbox(read($initHeapForallStmt#0, 
                        KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref)
               ==> read($initHeapForallStmt#0, $o, $f) == read(old($Heap), $o, $f))
           && (forall i#44: int :: 
            { $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#44))): ref } 
              { $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#44))): ref } 
            true
               ==> 
              LitInt(0) <= i#44 && i#44 < childidx#0
               ==> $Unbox(read($initHeapForallStmt#0, 
                    KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#44))): ref
                 == $Unbox(read(old($Heap), 
                    KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#44))): ref)
           && (forall i#45: int :: 
            { $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#45))): ref } 
            true
               ==> 
              childidx#0 + 1 < i#45
                 && i#45
                   < KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
               ==> $Unbox(read($initHeapForallStmt#0, 
                    KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref
                 == $Unbox(read(old($Heap), 
                    KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#45 - 1))): ref)
           && $Unbox(read(old($Heap), 
                KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
             != null
           && $Unbox(read($initHeapForallStmt#0, 
                KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
             != null
           && KMBtree.__default.WFShape($LS($LZ), 
            $initHeapForallStmt#0, 
            $Unbox(read($initHeapForallStmt#0, 
                KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref)
           && Set#Subset(read($initHeapForallStmt#0, 
              $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.repr), 
            read(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.repr))
           && read($initHeapForallStmt#0, 
              $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.height)
             == read(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.height)
           && $Unbox(read($initHeapForallStmt#0, 
                KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref
             != null
           && KMBtree.__default.WFShape($LS($LZ), 
            $initHeapForallStmt#0, 
            $Unbox(read($initHeapForallStmt#0, 
                KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0 + 1))): ref)
           && (forall $o: ref :: 
            { read(old($Heap), $o, alloc) } 
            read($initHeapForallStmt#0, 
                  $Unbox(read($initHeapForallStmt#0, 
                      KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0 + 1))): ref, 
                  KMBtree.Node.repr)[$Box($o)]
                 && !read(old($Heap), 
                  $Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.repr)[$Box($o)]
               ==> $o != null && !read(old($Heap), $o, alloc))
           && read($initHeapForallStmt#0, 
              $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0 + 1))): ref, 
              KMBtree.Node.height)
             == read(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.height)
           && KMBtree.__default.DisjointSubtrees($initHeapForallStmt#0, 
            read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents), 
            childidx#0, 
            childidx#0 + 1)
           && Set#Equal(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.repr), 
            Set#Union(read(old($Heap), $ih#node0#0, KMBtree.Node.repr), 
              read($initHeapForallStmt#0, 
                $Unbox(read($initHeapForallStmt#0, 
                    KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0 + 1))): ref, 
                KMBtree.Node.repr)))
           && (($ih#node0#0 == null && node#0 != null)
             || (($ih#node0#0 != null <==> node#0 != null)
               && 
              0 <= childidx#0
               && childidx#0 < childidx#0))
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $ih#node0#0));
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](833,5)
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0
         <= KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume $Is(Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray(old($Heap), 
        KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents)));
    ##parentRepr#0 := read(old($Heap), node#0, KMBtree.Node.repr);
    ##parentHeight#0 := read(old($Heap), node#0, KMBtree.Node.height);
    assume $IsAlloc(Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node?()), 
      old($Heap));
    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.repr), 
      TSet(Tclass._System.object()), 
      old($Heap));
    assume KMBtree.__default.WFShapeChildren#canCall(old($Heap), 
      Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      read(old($Heap), node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall(old($Heap), 
      Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      read(old($Heap), node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      old($Heap), 
      Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      read(old($Heap), node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.height));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](835,21)
    assume true;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    newchildren#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](835,72)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](837,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#47;
        assume true;
        if (LitInt(0) <= i#47)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        }

        assume true;
        assume LitInt(0) <= i#47
           && i#47
             < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](847,7)
        assume true;
        if (i#47 < childidx#0)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](848,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#0_0 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#0_0 := i#47;
            ##j#0_0 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0_0);
            assume {:subsumption 0} LitInt(0) <= ##i#0_0;
            assume {:subsumption 0} ##i#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
            assume {:subsumption 0} LitInt(0) <= ##j#0_0;
            assume {:subsumption 0} ##j#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0_0)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#0_0));
            assume {:subsumption 0} (forall l#0_0: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref } 
              LitInt(0) <= l#0_0 && l#0_0 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#0_0 && l#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(##j#0_0))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#47, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#47, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#47, childidx#0);
        }
        else
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](849,14)
            assume true;
            if (i#47 == childidx#0)
            {
            }
            else
            {
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](850,14)
                assume true;
                if (i#47 == childidx#0 + 1)
                {
                }
                else
                {
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](852,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    ##contents#1 := read(old($Heap), node#0, KMBtree.Node.contents);
                    ##i#1 := childidx#0;
                    ##j#1 := i#47 - 1;
                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                      Tclass.KMBtree.NodeContents(), 
                      old($Heap));
                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#1);
                    assume {:subsumption 0} LitInt(0) <= ##i#1;
                    assume {:subsumption 0} ##i#1 < KMBtree.NodeContents.nchildren(##contents#1);
                    assume {:subsumption 0} LitInt(0) <= ##j#1;
                    assume {:subsumption 0} ##j#1 < KMBtree.NodeContents.nchildren(##contents#1);
                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#1)
                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#1));
                    assume {:subsumption 0} (forall l#1: int :: 
                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(l#1))): ref } 
                      LitInt(0) <= l#1 && l#1 < 18446744073709551616
                         ==> 
                        LitInt(0) <= l#1 && l#1 < KMBtree.NodeContents.nchildren(##contents#1)
                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(l#1))): ref
                           != null);
                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(##j#1))): ref
                       != null;
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), 
                      read(old($Heap), node#0, KMBtree.Node.contents), 
                      childidx#0, 
                      i#47 - 1);
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), 
                      read(old($Heap), node#0, KMBtree.Node.contents), 
                      childidx#0, 
                      i#47 - 1);
                    assume true;
                    assume KMBtree.__default.DisjointSubtrees(old($Heap), 
                      read(old($Heap), node#0, KMBtree.Node.contents), 
                      childidx#0, 
                      i#47 - 1);
                }
            }
        }

        assume $Unbox(Seq#Index(newchildren#0, i#47)): ref != null;
        assume read($Heap, node#0, KMBtree.Node.repr)[Seq#Index(newchildren#0, i#47)];
        assume Set#Subset(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr), 
            read($Heap, node#0, KMBtree.Node.repr))
           && !Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
            read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr));
        assume !read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr)[$Box(node#0)];
        assume !read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))];
        assume !read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))];
        assume read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.height)
           < read($Heap, node#0, KMBtree.Node.height);
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> Set#Equal(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr), 
                Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, Seq#Index(newchildren#0, i#47)), 
                    $Box(KMBtree.NodeContents.keys(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)))), 
                  $Box(KMBtree.NodeContents.values(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueMessage.Message(), 
                KMBtree.NodeContents.keys(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)), 
                KMBtree.NodeContents.values(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.height)
                 == LitInt(0));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> LitInt(0)
                 <= KMBtree.NodeContents.nkeys(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> KMBtree.NodeContents.nkeys(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
                 <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
                 == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)))
                 == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> Lit(true));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                Lit(true)));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, Seq#Index(newchildren#0, i#47)), 
                        $Box(KMBtree.NodeContents.pivots(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)))), 
                      $Box(children#8)), 
                    read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr)))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  0 < nchildren#8)));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  nchildren#8 <= LitInt(KMBtree.__default.MaxChildren()))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)))
                     == LitInt(KMBtree.__default.MaxChildren() - 1))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  (forall i#48: int :: 
                    { $Unbox(read($Heap, children#8, IndexField(i#48))): ref } 
                    LitInt(0) <= i#48 && i#48 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#48 && i#48 < nchildren#8
                       ==> $Unbox(read($Heap, children#8, IndexField(i#48))): ref != null))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                    $Heap, 
                    Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), 
                    read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.repr), 
                    read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.height)))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  (forall i#49: int :: 
                    { $Unbox(read($Heap, children#8, IndexField(i#49))): ref } 
                    LitInt(0) <= i#49 && i#49 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#49 && i#49 < nchildren#8
                       ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#49))): ref, KMBtree.Node.repr)[Seq#Index(newchildren#0, i#47)]))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  (forall i#50: int :: 
                    { $Unbox(read($Heap, children#8, IndexField(i#50))): ref } 
                    LitInt(0) <= i#50 && i#50 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#50 && i#50 < nchildren#8
                       ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#50))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)))]))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  (forall i#51: int :: 
                      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                        { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                      LitInt(0) <= i#51 && i#51 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#51 && i#51 < nchildren#8
                         ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                           == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
                     ==> Lit(true))));
        assume KMBtree.__default.WFShape#canCall($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents))
               ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                (var children#8 := KMBtree.NodeContents.children(read($Heap, $Unbox(Seq#Index(newchildren#0, i#47)): ref, KMBtree.Node.contents)); 
                  (forall i#51: int :: 
                      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref } 
                        { $Unbox(read($Heap, children#8, IndexField(i#51))): ref } 
                      LitInt(0) <= i#51 && i#51 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#51 && i#51 < nchildren#8
                         ==> $Unbox(read($Heap, children#8, IndexField(i#51))): ref
                           == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#51)): ref)
                     ==> (forall i#52: int :: 
                      { $Unbox(read($Heap, children#8, IndexField(i#52))): ref } 
                      LitInt(0) <= i#52 && i#52 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#52 && i#52 < nchildren#8
                         ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(children#8)]))));
        assume false;
    }
    else
    {
        assume (forall i#53: int :: 
          { $Unbox(Seq#Index(newchildren#0, i#53)): ref } 
          LitInt(0) <= i#53
               && i#53
                 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             ==> $Unbox(Seq#Index(newchildren#0, i#53)): ref != null
               && read($Heap, node#0, KMBtree.Node.repr)[Seq#Index(newchildren#0, i#53)]
               && 
              Set#Subset(read($Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref, KMBtree.Node.repr), 
                read($Heap, node#0, KMBtree.Node.repr))
               && !Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
                read($Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref, KMBtree.Node.repr))
               && !read($Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref, KMBtree.Node.repr)[$Box(node#0)]
               && !read($Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]
               && !read($Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))]
               && read($Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref, KMBtree.Node.height)
                 < read($Heap, node#0, KMBtree.Node.height)
               && KMBtree.__default.WFShape($LS($LZ), $Heap, $Unbox(Seq#Index(newchildren#0, i#53)): ref));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](854,4)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](855,32)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is(newchildren#0, TSeq(Tclass.KMBtree.Node()));
    nodes##0 := newchildren#0;
    assume node#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    parentRepr##0 := read($Heap, node#0, KMBtree.Node.repr);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SeqReprSubsetExtensionality(nodes##0, parentRepr##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](855,55)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](857,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#54, j#0;
        assume true;
        if (LitInt(0) <= i#54)
        {
        }

        if (LitInt(0) <= i#54 && i#54 < j#0)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        }

        assume true;
        assume LitInt(0) <= i#54
           && i#54 < j#0
           && j#0 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](860,7)
        assume true;
        if (j#0 < childidx#0)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](861,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#3_0 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#3_0 := i#54;
            ##j#3_0 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#3_0);
            assume {:subsumption 0} LitInt(0) <= ##i#3_0;
            assume {:subsumption 0} ##i#3_0 < KMBtree.NodeContents.nchildren(##contents#3_0);
            assume {:subsumption 0} LitInt(0) <= ##j#3_0;
            assume {:subsumption 0} ##j#3_0 < KMBtree.NodeContents.nchildren(##contents#3_0);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#3_0)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#3_0));
            assume {:subsumption 0} (forall l#3_0: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_0), IndexField(l#3_0))): ref } 
              LitInt(0) <= l#3_0 && l#3_0 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#3_0 && l#3_0 < KMBtree.NodeContents.nchildren(##contents#3_0)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_0), IndexField(l#3_0))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_0), IndexField(##j#3_0))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](862,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#3_1 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#3_1 := j#0;
            ##j#3_1 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#3_1);
            assume {:subsumption 0} LitInt(0) <= ##i#3_1;
            assume {:subsumption 0} ##i#3_1 < KMBtree.NodeContents.nchildren(##contents#3_1);
            assume {:subsumption 0} LitInt(0) <= ##j#3_1;
            assume {:subsumption 0} ##j#3_1 < KMBtree.NodeContents.nchildren(##contents#3_1);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#3_1)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#3_1));
            assume {:subsumption 0} (forall l#3_1: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_1), IndexField(l#3_1))): ref } 
              LitInt(0) <= l#3_1 && l#3_1 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#3_1 && l#3_1 < KMBtree.NodeContents.nchildren(##contents#3_1)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_1), IndexField(l#3_1))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_1), IndexField(##j#3_1))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), j#0, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), j#0, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), j#0, childidx#0);
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](863,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#3_2 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#3_2 := i#54;
            ##j#3_2 := j#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#3_2);
            assume {:subsumption 0} LitInt(0) <= ##i#3_2;
            assume {:subsumption 0} ##i#3_2 < KMBtree.NodeContents.nchildren(##contents#3_2);
            assume {:subsumption 0} LitInt(0) <= ##j#3_2;
            assume {:subsumption 0} ##j#3_2 < KMBtree.NodeContents.nchildren(##contents#3_2);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#3_2)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#3_2));
            assume {:subsumption 0} (forall l#3_2: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_2), IndexField(l#3_2))): ref } 
              LitInt(0) <= l#3_2 && l#3_2 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#3_2 && l#3_2 < KMBtree.NodeContents.nchildren(##contents#3_2)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_2), IndexField(l#3_2))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_2), IndexField(##j#3_2))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0);
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](864,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
            assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
               != null;
            assume {:subsumption 0} 0 <= i#54
               && i#54
                 < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
            assume $Is($Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(i#54))): ref, 
              Tclass.KMBtree.Node());
            ##node#3_0 := $Unbox(read(old($Heap), 
                KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                IndexField(i#54))): ref;
            assume $IsAlloc($Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(i#54))): ref, 
              Tclass.KMBtree.Node?(), 
              old($Heap));
            assume KMBtree.__default.WFShape#canCall(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(i#54))): ref);
            assume KMBtree.__default.WFShape#canCall(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(i#54))): ref);
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume KMBtree.__default.WFShape($LS($LS($LZ)), 
              old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(i#54))): ref);
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](865,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
            assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
               != null;
            assume {:subsumption 0} 0 <= j#0
               && j#0
                 < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
            assume $Is($Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(j#0))): ref, 
              Tclass.KMBtree.Node());
            ##node#3_1 := $Unbox(read(old($Heap), 
                KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                IndexField(j#0))): ref;
            assume $IsAlloc($Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(j#0))): ref, 
              Tclass.KMBtree.Node?(), 
              old($Heap));
            assume KMBtree.__default.WFShape#canCall(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(j#0))): ref);
            assume KMBtree.__default.WFShape#canCall(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(j#0))): ref);
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume true;
            assume KMBtree.__default.WFShape($LS($LS($LZ)), 
              old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                  IndexField(j#0))): ref);
        }
        else
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](866,14)
            assume true;
            if (j#0 == childidx#0)
            {
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](867,9)
                assume {:subsumption 0} node#0 != null;
                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                ##contents#4_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                ##i#4_0 := i#54;
                ##j#4_0 := childidx#0;
                assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                  Tclass.KMBtree.NodeContents(), 
                  old($Heap));
                assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#4_0);
                assume {:subsumption 0} LitInt(0) <= ##i#4_0;
                assume {:subsumption 0} ##i#4_0 < KMBtree.NodeContents.nchildren(##contents#4_0);
                assume {:subsumption 0} LitInt(0) <= ##j#4_0;
                assume {:subsumption 0} ##j#4_0 < KMBtree.NodeContents.nchildren(##contents#4_0);
                assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#4_0)
                   <= _System.array.Length(KMBtree.NodeContents.children(##contents#4_0));
                assume {:subsumption 0} (forall l#4_0: int :: 
                  { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_0), IndexField(l#4_0))): ref } 
                  LitInt(0) <= l#4_0 && l#4_0 < 18446744073709551616
                     ==> 
                    LitInt(0) <= l#4_0 && l#4_0 < KMBtree.NodeContents.nchildren(##contents#4_0)
                     ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_0), IndexField(l#4_0))): ref
                       != null);
                assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_0), IndexField(##j#4_0))): ref
                   != null;
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                assume true;
                assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](868,9)
                assume {:subsumption 0} node#0 != null;
                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                ##contents#4_1 := read(old($Heap), node#0, KMBtree.Node.contents);
                ##i#4_1 := i#54;
                ##j#4_1 := j#0;
                assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                  Tclass.KMBtree.NodeContents(), 
                  old($Heap));
                assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#4_1);
                assume {:subsumption 0} LitInt(0) <= ##i#4_1;
                assume {:subsumption 0} ##i#4_1 < KMBtree.NodeContents.nchildren(##contents#4_1);
                assume {:subsumption 0} LitInt(0) <= ##j#4_1;
                assume {:subsumption 0} ##j#4_1 < KMBtree.NodeContents.nchildren(##contents#4_1);
                assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#4_1)
                   <= _System.array.Length(KMBtree.NodeContents.children(##contents#4_1));
                assume {:subsumption 0} (forall l#4_1: int :: 
                  { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_1), IndexField(l#4_1))): ref } 
                  LitInt(0) <= l#4_1 && l#4_1 < 18446744073709551616
                     ==> 
                    LitInt(0) <= l#4_1 && l#4_1 < KMBtree.NodeContents.nchildren(##contents#4_1)
                     ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_1), IndexField(l#4_1))): ref
                       != null);
                assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_1), IndexField(##j#4_1))): ref
                   != null;
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0);
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0);
                assume true;
                assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0);
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](869,9)
                assume {:subsumption 0} node#0 != null;
                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                   != null;
                assume {:subsumption 0} 0 <= i#54
                   && i#54
                     < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                assume $Is($Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                      IndexField(i#54))): ref, 
                  Tclass.KMBtree.Node());
                ##node#4_0 := $Unbox(read(old($Heap), 
                    KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                    IndexField(i#54))): ref;
                assume $IsAlloc($Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                      IndexField(i#54))): ref, 
                  Tclass.KMBtree.Node?(), 
                  old($Heap));
                assume KMBtree.__default.WFShape#canCall(old($Heap), 
                  $Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                      IndexField(i#54))): ref);
                assume KMBtree.__default.WFShape#canCall(old($Heap), 
                  $Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                      IndexField(i#54))): ref);
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume true;
                assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                  old($Heap), 
                  $Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                      IndexField(i#54))): ref);
            }
            else
            {
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](870,14)
                if (i#54 < childidx#0)
                {
                }

                assume true;
                if (i#54 < childidx#0 && j#0 == childidx#0 + 1)
                {
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](871,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    ##contents#5_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                    ##i#5_0 := i#54;
                    ##j#5_0 := childidx#0;
                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                      Tclass.KMBtree.NodeContents(), 
                      old($Heap));
                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#5_0);
                    assume {:subsumption 0} LitInt(0) <= ##i#5_0;
                    assume {:subsumption 0} ##i#5_0 < KMBtree.NodeContents.nchildren(##contents#5_0);
                    assume {:subsumption 0} LitInt(0) <= ##j#5_0;
                    assume {:subsumption 0} ##j#5_0 < KMBtree.NodeContents.nchildren(##contents#5_0);
                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#5_0)
                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#5_0));
                    assume {:subsumption 0} (forall l#5_0: int :: 
                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_0), IndexField(l#5_0))): ref } 
                      LitInt(0) <= l#5_0 && l#5_0 < 18446744073709551616
                         ==> 
                        LitInt(0) <= l#5_0 && l#5_0 < KMBtree.NodeContents.nchildren(##contents#5_0)
                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_0), IndexField(l#5_0))): ref
                           != null);
                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_0), IndexField(##j#5_0))): ref
                       != null;
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                    assume true;
                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](872,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    ##contents#5_1 := read(old($Heap), node#0, KMBtree.Node.contents);
                    ##i#5_1 := i#54;
                    ##j#5_1 := j#0 - 1;
                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                      Tclass.KMBtree.NodeContents(), 
                      old($Heap));
                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#5_1);
                    assume {:subsumption 0} LitInt(0) <= ##i#5_1;
                    assume {:subsumption 0} ##i#5_1 < KMBtree.NodeContents.nchildren(##contents#5_1);
                    assume {:subsumption 0} LitInt(0) <= ##j#5_1;
                    assume {:subsumption 0} ##j#5_1 < KMBtree.NodeContents.nchildren(##contents#5_1);
                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#5_1)
                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#5_1));
                    assume {:subsumption 0} (forall l#5_1: int :: 
                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_1), IndexField(l#5_1))): ref } 
                      LitInt(0) <= l#5_1 && l#5_1 < 18446744073709551616
                         ==> 
                        LitInt(0) <= l#5_1 && l#5_1 < KMBtree.NodeContents.nchildren(##contents#5_1)
                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_1), IndexField(l#5_1))): ref
                           != null);
                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_1), IndexField(##j#5_1))): ref
                       != null;
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                    assume true;
                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](873,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                       != null;
                    assume {:subsumption 0} 0 <= i#54
                       && i#54
                         < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                    assume $Is($Unbox(read(old($Heap), 
                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                          IndexField(i#54))): ref, 
                      Tclass.KMBtree.Node());
                    ##node#5_0 := $Unbox(read(old($Heap), 
                        KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                        IndexField(i#54))): ref;
                    assume $IsAlloc($Unbox(read(old($Heap), 
                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                          IndexField(i#54))): ref, 
                      Tclass.KMBtree.Node?(), 
                      old($Heap));
                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                      $Unbox(read(old($Heap), 
                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                          IndexField(i#54))): ref);
                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                      $Unbox(read(old($Heap), 
                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                          IndexField(i#54))): ref);
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume true;
                    assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                      old($Heap), 
                      $Unbox(read(old($Heap), 
                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                          IndexField(i#54))): ref);
                }
                else
                {
                    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](874,14)
                    if (i#54 == childidx#0)
                    {
                    }

                    assume true;
                    if (i#54 == childidx#0 && j#0 == childidx#0 + 1)
                    {
                    }
                    else
                    {
                        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](875,14)
                        if (i#54 < childidx#0)
                        {
                        }

                        assume true;
                        if (i#54 < childidx#0 && childidx#0 + 1 < j#0)
                        {
                            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](876,9)
                            assume {:subsumption 0} node#0 != null;
                            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                            ##contents#7_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                            ##i#7_0 := i#54;
                            ##j#7_0 := childidx#0;
                            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                              Tclass.KMBtree.NodeContents(), 
                              old($Heap));
                            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#7_0);
                            assume {:subsumption 0} LitInt(0) <= ##i#7_0;
                            assume {:subsumption 0} ##i#7_0 < KMBtree.NodeContents.nchildren(##contents#7_0);
                            assume {:subsumption 0} LitInt(0) <= ##j#7_0;
                            assume {:subsumption 0} ##j#7_0 < KMBtree.NodeContents.nchildren(##contents#7_0);
                            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#7_0)
                               <= _System.array.Length(KMBtree.NodeContents.children(##contents#7_0));
                            assume {:subsumption 0} (forall l#7_0: int :: 
                              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_0), IndexField(l#7_0))): ref } 
                              LitInt(0) <= l#7_0 && l#7_0 < 18446744073709551616
                                 ==> 
                                LitInt(0) <= l#7_0 && l#7_0 < KMBtree.NodeContents.nchildren(##contents#7_0)
                                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_0), IndexField(l#7_0))): ref
                                   != null);
                            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_0), IndexField(##j#7_0))): ref
                               != null;
                            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                            assume true;
                            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, childidx#0);
                            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](877,9)
                            assume {:subsumption 0} node#0 != null;
                            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                            ##contents#7_1 := read(old($Heap), node#0, KMBtree.Node.contents);
                            ##i#7_1 := childidx#0;
                            ##j#7_1 := j#0 - 1;
                            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                              Tclass.KMBtree.NodeContents(), 
                              old($Heap));
                            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#7_1);
                            assume {:subsumption 0} LitInt(0) <= ##i#7_1;
                            assume {:subsumption 0} ##i#7_1 < KMBtree.NodeContents.nchildren(##contents#7_1);
                            assume {:subsumption 0} LitInt(0) <= ##j#7_1;
                            assume {:subsumption 0} ##j#7_1 < KMBtree.NodeContents.nchildren(##contents#7_1);
                            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#7_1)
                               <= _System.array.Length(KMBtree.NodeContents.children(##contents#7_1));
                            assume {:subsumption 0} (forall l#7_1: int :: 
                              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_1), IndexField(l#7_1))): ref } 
                              LitInt(0) <= l#7_1 && l#7_1 < 18446744073709551616
                                 ==> 
                                LitInt(0) <= l#7_1 && l#7_1 < KMBtree.NodeContents.nchildren(##contents#7_1)
                                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_1), IndexField(l#7_1))): ref
                                   != null);
                            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_1), IndexField(##j#7_1))): ref
                               != null;
                            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                            assume true;
                            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](878,9)
                            assume {:subsumption 0} node#0 != null;
                            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                            ##contents#7_2 := read(old($Heap), node#0, KMBtree.Node.contents);
                            ##i#7_2 := i#54;
                            ##j#7_2 := j#0 - 1;
                            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                              Tclass.KMBtree.NodeContents(), 
                              old($Heap));
                            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#7_2);
                            assume {:subsumption 0} LitInt(0) <= ##i#7_2;
                            assume {:subsumption 0} ##i#7_2 < KMBtree.NodeContents.nchildren(##contents#7_2);
                            assume {:subsumption 0} LitInt(0) <= ##j#7_2;
                            assume {:subsumption 0} ##j#7_2 < KMBtree.NodeContents.nchildren(##contents#7_2);
                            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#7_2)
                               <= _System.array.Length(KMBtree.NodeContents.children(##contents#7_2));
                            assume {:subsumption 0} (forall l#7_2: int :: 
                              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_2), IndexField(l#7_2))): ref } 
                              LitInt(0) <= l#7_2 && l#7_2 < 18446744073709551616
                                 ==> 
                                LitInt(0) <= l#7_2 && l#7_2 < KMBtree.NodeContents.nchildren(##contents#7_2)
                                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_2), IndexField(l#7_2))): ref
                                   != null);
                            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#7_2), IndexField(##j#7_2))): ref
                               != null;
                            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                            assume true;
                            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](879,9)
                            assume {:subsumption 0} node#0 != null;
                            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                            assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                            assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                               != null;
                            assume {:subsumption 0} 0 <= i#54
                               && i#54
                                 < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                            assume $Is($Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(i#54))): ref, 
                              Tclass.KMBtree.Node());
                            ##node#7_0 := $Unbox(read(old($Heap), 
                                KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                IndexField(i#54))): ref;
                            assume $IsAlloc($Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(i#54))): ref, 
                              Tclass.KMBtree.Node?(), 
                              old($Heap));
                            assume KMBtree.__default.WFShape#canCall(old($Heap), 
                              $Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(i#54))): ref);
                            assume KMBtree.__default.WFShape#canCall(old($Heap), 
                              $Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(i#54))): ref);
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                              old($Heap), 
                              $Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(i#54))): ref);
                            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](880,9)
                            assume {:subsumption 0} node#0 != null;
                            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                            assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                            assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                               != null;
                            assume {:subsumption 0} 0 <= j#0 - 1
                               && j#0 - 1
                                 < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                            assume $Is($Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(j#0 - 1))): ref, 
                              Tclass.KMBtree.Node());
                            ##node#7_1 := $Unbox(read(old($Heap), 
                                KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                IndexField(j#0 - 1))): ref;
                            assume $IsAlloc($Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(j#0 - 1))): ref, 
                              Tclass.KMBtree.Node?(), 
                              old($Heap));
                            assume KMBtree.__default.WFShape#canCall(old($Heap), 
                              $Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(j#0 - 1))): ref);
                            assume KMBtree.__default.WFShape#canCall(old($Heap), 
                              $Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(j#0 - 1))): ref);
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume true;
                            assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                              old($Heap), 
                              $Unbox(read(old($Heap), 
                                  KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                  IndexField(j#0 - 1))): ref);
                        }
                        else
                        {
                            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](881,14)
                            if (i#54 == childidx#0)
                            {
                            }

                            assume true;
                            if (i#54 == childidx#0 && childidx#0 + 1 < j#0)
                            {
                                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](882,9)
                                assume {:subsumption 0} node#0 != null;
                                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                ##contents#8_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                                ##i#8_0 := childidx#0;
                                ##j#8_0 := j#0 - 1;
                                assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                  Tclass.KMBtree.NodeContents(), 
                                  old($Heap));
                                assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#8_0);
                                assume {:subsumption 0} LitInt(0) <= ##i#8_0;
                                assume {:subsumption 0} ##i#8_0 < KMBtree.NodeContents.nchildren(##contents#8_0);
                                assume {:subsumption 0} LitInt(0) <= ##j#8_0;
                                assume {:subsumption 0} ##j#8_0 < KMBtree.NodeContents.nchildren(##contents#8_0);
                                assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#8_0)
                                   <= _System.array.Length(KMBtree.NodeContents.children(##contents#8_0));
                                assume {:subsumption 0} (forall l#8_0: int :: 
                                  { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#8_0), IndexField(l#8_0))): ref } 
                                  LitInt(0) <= l#8_0 && l#8_0 < 18446744073709551616
                                     ==> 
                                    LitInt(0) <= l#8_0 && l#8_0 < KMBtree.NodeContents.nchildren(##contents#8_0)
                                     ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#8_0), IndexField(l#8_0))): ref
                                       != null);
                                assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#8_0), IndexField(##j#8_0))): ref
                                   != null;
                                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                assume true;
                                assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](883,9)
                                assume {:subsumption 0} node#0 != null;
                                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                ##contents#8_1 := read(old($Heap), node#0, KMBtree.Node.contents);
                                ##i#8_1 := i#54;
                                ##j#8_1 := j#0 - 1;
                                assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                  Tclass.KMBtree.NodeContents(), 
                                  old($Heap));
                                assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#8_1);
                                assume {:subsumption 0} LitInt(0) <= ##i#8_1;
                                assume {:subsumption 0} ##i#8_1 < KMBtree.NodeContents.nchildren(##contents#8_1);
                                assume {:subsumption 0} LitInt(0) <= ##j#8_1;
                                assume {:subsumption 0} ##j#8_1 < KMBtree.NodeContents.nchildren(##contents#8_1);
                                assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#8_1)
                                   <= _System.array.Length(KMBtree.NodeContents.children(##contents#8_1));
                                assume {:subsumption 0} (forall l#8_1: int :: 
                                  { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#8_1), IndexField(l#8_1))): ref } 
                                  LitInt(0) <= l#8_1 && l#8_1 < 18446744073709551616
                                     ==> 
                                    LitInt(0) <= l#8_1 && l#8_1 < KMBtree.NodeContents.nchildren(##contents#8_1)
                                     ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#8_1), IndexField(l#8_1))): ref
                                       != null);
                                assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#8_1), IndexField(##j#8_1))): ref
                                   != null;
                                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                                assume true;
                                assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54, j#0 - 1);
                                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](884,9)
                                assume {:subsumption 0} node#0 != null;
                                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                                assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                                   != null;
                                assume {:subsumption 0} 0 <= j#0 - 1
                                   && j#0 - 1
                                     < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                                assume $Is($Unbox(read(old($Heap), 
                                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                      IndexField(j#0 - 1))): ref, 
                                  Tclass.KMBtree.Node());
                                ##node#8_0 := $Unbox(read(old($Heap), 
                                    KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                    IndexField(j#0 - 1))): ref;
                                assume $IsAlloc($Unbox(read(old($Heap), 
                                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                      IndexField(j#0 - 1))): ref, 
                                  Tclass.KMBtree.Node?(), 
                                  old($Heap));
                                assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                  $Unbox(read(old($Heap), 
                                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                      IndexField(j#0 - 1))): ref);
                                assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                  $Unbox(read(old($Heap), 
                                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                      IndexField(j#0 - 1))): ref);
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume true;
                                assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                                  old($Heap), 
                                  $Unbox(read(old($Heap), 
                                      KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                      IndexField(j#0 - 1))): ref);
                            }
                            else
                            {
                                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](885,14)
                                if (i#54 == childidx#0 + 1)
                                {
                                }

                                assume true;
                                if (i#54 == childidx#0 + 1 && childidx#0 + 1 < j#0)
                                {
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](886,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    ##contents#9_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                                    ##i#9_0 := childidx#0;
                                    ##j#9_0 := j#0 - 1;
                                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                      Tclass.KMBtree.NodeContents(), 
                                      old($Heap));
                                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#9_0);
                                    assume {:subsumption 0} LitInt(0) <= ##i#9_0;
                                    assume {:subsumption 0} ##i#9_0 < KMBtree.NodeContents.nchildren(##contents#9_0);
                                    assume {:subsumption 0} LitInt(0) <= ##j#9_0;
                                    assume {:subsumption 0} ##j#9_0 < KMBtree.NodeContents.nchildren(##contents#9_0);
                                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#9_0)
                                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#9_0));
                                    assume {:subsumption 0} (forall l#9_0: int :: 
                                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#9_0), IndexField(l#9_0))): ref } 
                                      LitInt(0) <= l#9_0 && l#9_0 < 18446744073709551616
                                         ==> 
                                        LitInt(0) <= l#9_0 && l#9_0 < KMBtree.NodeContents.nchildren(##contents#9_0)
                                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#9_0), IndexField(l#9_0))): ref
                                           != null);
                                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#9_0), IndexField(##j#9_0))): ref
                                       != null;
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                    assume true;
                                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](887,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    ##contents#9_1 := read(old($Heap), node#0, KMBtree.Node.contents);
                                    ##i#9_1 := i#54 - 1;
                                    ##j#9_1 := j#0 - 1;
                                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                      Tclass.KMBtree.NodeContents(), 
                                      old($Heap));
                                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#9_1);
                                    assume {:subsumption 0} LitInt(0) <= ##i#9_1;
                                    assume {:subsumption 0} ##i#9_1 < KMBtree.NodeContents.nchildren(##contents#9_1);
                                    assume {:subsumption 0} LitInt(0) <= ##j#9_1;
                                    assume {:subsumption 0} ##j#9_1 < KMBtree.NodeContents.nchildren(##contents#9_1);
                                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#9_1)
                                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#9_1));
                                    assume {:subsumption 0} (forall l#9_1: int :: 
                                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#9_1), IndexField(l#9_1))): ref } 
                                      LitInt(0) <= l#9_1 && l#9_1 < 18446744073709551616
                                         ==> 
                                        LitInt(0) <= l#9_1 && l#9_1 < KMBtree.NodeContents.nchildren(##contents#9_1)
                                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#9_1), IndexField(l#9_1))): ref
                                           != null);
                                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#9_1), IndexField(##j#9_1))): ref
                                       != null;
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54 - 1, j#0 - 1);
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54 - 1, j#0 - 1);
                                    assume true;
                                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54 - 1, j#0 - 1);
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](888,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                                    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                                       != null;
                                    assume {:subsumption 0} 0 <= j#0 - 1
                                       && j#0 - 1
                                         < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                                    assume $Is($Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref, 
                                      Tclass.KMBtree.Node());
                                    ##node#9_0 := $Unbox(read(old($Heap), 
                                        KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                        IndexField(j#0 - 1))): ref;
                                    assume $IsAlloc($Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref, 
                                      Tclass.KMBtree.Node?(), 
                                      old($Heap));
                                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref);
                                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref);
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                                      old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref);
                                }
                                else
                                {
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](890,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    ##contents#2 := read(old($Heap), node#0, KMBtree.Node.contents);
                                    ##i#2 := childidx#0;
                                    ##j#2 := i#54 - 1;
                                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                      Tclass.KMBtree.NodeContents(), 
                                      old($Heap));
                                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#2);
                                    assume {:subsumption 0} LitInt(0) <= ##i#2;
                                    assume {:subsumption 0} ##i#2 < KMBtree.NodeContents.nchildren(##contents#2);
                                    assume {:subsumption 0} LitInt(0) <= ##j#2;
                                    assume {:subsumption 0} ##j#2 < KMBtree.NodeContents.nchildren(##contents#2);
                                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#2)
                                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#2));
                                    assume {:subsumption 0} (forall l#2: int :: 
                                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2), IndexField(l#2))): ref } 
                                      LitInt(0) <= l#2 && l#2 < 18446744073709551616
                                         ==> 
                                        LitInt(0) <= l#2 && l#2 < KMBtree.NodeContents.nchildren(##contents#2)
                                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2), IndexField(l#2))): ref
                                           != null);
                                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2), IndexField(##j#2))): ref
                                       != null;
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), 
                                      read(old($Heap), node#0, KMBtree.Node.contents), 
                                      childidx#0, 
                                      i#54 - 1);
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), 
                                      read(old($Heap), node#0, KMBtree.Node.contents), 
                                      childidx#0, 
                                      i#54 - 1);
                                    assume true;
                                    assume KMBtree.__default.DisjointSubtrees(old($Heap), 
                                      read(old($Heap), node#0, KMBtree.Node.contents), 
                                      childidx#0, 
                                      i#54 - 1);
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](891,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    ##contents#3 := read(old($Heap), node#0, KMBtree.Node.contents);
                                    ##i#3 := childidx#0;
                                    ##j#3 := j#0 - 1;
                                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                      Tclass.KMBtree.NodeContents(), 
                                      old($Heap));
                                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#3);
                                    assume {:subsumption 0} LitInt(0) <= ##i#3;
                                    assume {:subsumption 0} ##i#3 < KMBtree.NodeContents.nchildren(##contents#3);
                                    assume {:subsumption 0} LitInt(0) <= ##j#3;
                                    assume {:subsumption 0} ##j#3 < KMBtree.NodeContents.nchildren(##contents#3);
                                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#3)
                                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#3));
                                    assume {:subsumption 0} (forall l#3: int :: 
                                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3), IndexField(l#3))): ref } 
                                      LitInt(0) <= l#3 && l#3 < 18446744073709551616
                                         ==> 
                                        LitInt(0) <= l#3 && l#3 < KMBtree.NodeContents.nchildren(##contents#3)
                                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3), IndexField(l#3))): ref
                                           != null);
                                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3), IndexField(##j#3))): ref
                                       != null;
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                    assume true;
                                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0 - 1);
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](892,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    ##contents#4 := read(old($Heap), node#0, KMBtree.Node.contents);
                                    ##i#4 := i#54 - 1;
                                    ##j#4 := j#0 - 1;
                                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                                      Tclass.KMBtree.NodeContents(), 
                                      old($Heap));
                                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#4);
                                    assume {:subsumption 0} LitInt(0) <= ##i#4;
                                    assume {:subsumption 0} ##i#4 < KMBtree.NodeContents.nchildren(##contents#4);
                                    assume {:subsumption 0} LitInt(0) <= ##j#4;
                                    assume {:subsumption 0} ##j#4 < KMBtree.NodeContents.nchildren(##contents#4);
                                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#4)
                                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#4));
                                    assume {:subsumption 0} (forall l#4: int :: 
                                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4), IndexField(l#4))): ref } 
                                      LitInt(0) <= l#4 && l#4 < 18446744073709551616
                                         ==> 
                                        LitInt(0) <= l#4 && l#4 < KMBtree.NodeContents.nchildren(##contents#4)
                                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4), IndexField(l#4))): ref
                                           != null);
                                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4), IndexField(##j#4))): ref
                                       != null;
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54 - 1, j#0 - 1);
                                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54 - 1, j#0 - 1);
                                    assume true;
                                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#54 - 1, j#0 - 1);
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](893,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                                    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                                       != null;
                                    assume {:subsumption 0} 0 <= i#54 - 1
                                       && i#54 - 1
                                         < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                                    assume $Is($Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(i#54 - 1))): ref, 
                                      Tclass.KMBtree.Node());
                                    ##node#5 := $Unbox(read(old($Heap), 
                                        KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                        IndexField(i#54 - 1))): ref;
                                    assume $IsAlloc($Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(i#54 - 1))): ref, 
                                      Tclass.KMBtree.Node?(), 
                                      old($Heap));
                                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(i#54 - 1))): ref);
                                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(i#54 - 1))): ref);
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                                      old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(i#54 - 1))): ref);
                                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](894,9)
                                    assume {:subsumption 0} node#0 != null;
                                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                                    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
                                    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
                                       != null;
                                    assume {:subsumption 0} 0 <= j#0 - 1
                                       && j#0 - 1
                                         < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
                                    assume $Is($Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref, 
                                      Tclass.KMBtree.Node());
                                    ##node#6 := $Unbox(read(old($Heap), 
                                        KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                        IndexField(j#0 - 1))): ref;
                                    assume $IsAlloc($Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref, 
                                      Tclass.KMBtree.Node?(), 
                                      old($Heap));
                                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref);
                                    assume KMBtree.__default.WFShape#canCall(old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref);
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume true;
                                    assume KMBtree.__default.WFShape($LS($LS($LZ)), 
                                      old($Heap), 
                                      $Unbox(read(old($Heap), 
                                          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                                          IndexField(j#0 - 1))): ref);
                                }
                            }
                        }
                    }
                }
            }
        }

        assume KMBtree.__default.DisjointReprs#canCall($Heap, newchildren#0, i#54, j#0)
           ==> KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#54, j#0)
             || Set#Disjoint(read($Heap, $Unbox(Seq#Index(newchildren#0, i#54)): ref, KMBtree.Node.repr), 
              read($Heap, $Unbox(Seq#Index(newchildren#0, j#0)): ref, KMBtree.Node.repr));
        assume false;
    }
    else
    {
        assume (forall i#65: int, j#1: int :: 
          { KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#65, j#1) } 
          LitInt(0) <= i#65
               && i#65 < j#1
               && j#1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.__default.DisjointReprs($Heap, newchildren#0, i#65, j#1));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](896,4)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](898,5)
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(newchildren#0, TSeq(Tclass.KMBtree.Node()));
    ##nodes#1 := newchildren#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#1, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#1 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#1, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#1 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#1, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      newchildren#0, 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      newchildren#0, 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      newchildren#0, 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
}



procedure CheckWellformed$$KMBtree.__default.SplitChildOfIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616);
  free requires 53 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.SplitChildOfIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616);
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#15: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#15))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#16: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#16))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#17: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#17))): ref } 
                  LitInt(0) <= i#17 && i#17 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#17 && i#17 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#17))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#18: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#18))): ref } 
                    LitInt(0) <= i#18 && i#18 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#18 && i#18 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#18))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#18)): ref)
                   ==> (forall i#19: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                    LitInt(0) <= i#19 && i#19 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#19 && i#19 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#19))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#20: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#20)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#20
                   && i#20
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#20)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#21: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#21)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#21
                   && i#21
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#21)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#22: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22) } 
              true
                 ==> 
                LitInt(0) <= i#22
                   && i#22
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#22))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#23: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23) } 
              true
                 ==> 
                0 < i#23
                   && i#23
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#23))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read($Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#4), nchildren#4), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#25))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#26: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#26))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read($Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read($Heap, $Unbox(read($Heap, children#4, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(children#4)]))));
  free ensures true;
  ensures KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0);
  free ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     && 
    KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     && 
    KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0))
     && KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    LitInt(0) <= childidx#0
     && childidx#0
       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
     && Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
         + 1
     && Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       == Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
         + 1
     && Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
       == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)))
         - 1
     && KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
          childidx#0)): DatatypeType, 
      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0)): DatatypeType, 
      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0 + 1)): DatatypeType, 
      $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0)): Seq Box)
     && Seq#Equal(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
        StartFuel_Sequences._default.insert, 
        KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0), 
        childidx#0))
     && Seq#Equal(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
        StartFuel_Sequences._default.replace1with2, 
        KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0), 
        Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
          childidx#0 + 1), 
        childidx#0));
  free ensures true;
  ensures $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  free ensures true;
  ensures $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0 + 1))): ref
     != null;
  free ensures KMBtree.__default.Full#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  ensures !KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  free ensures KMBtree.__default.Full#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0 + 1))): ref);
  ensures !KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0 + 1))): ref);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
          childidx#0)): DatatypeType);
  ensures KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        childidx#0)): DatatypeType)[read($Heap, 
    KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)), 
    IndexField(childidx#0))];
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || $o
           == KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents))
         || $o
           == KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
         || $o
           == $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.SplitChildOfIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 53 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
  requires $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#6)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#6)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#6 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#38: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#38))): ref } 
              LitInt(0) <= i#38 && i#38 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#38 && i#38 < nchildren#6
                 ==> $Unbox(read($Heap, children#6, IndexField(i#38))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#39: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#39))): ref } 
              LitInt(0) <= i#39 && i#39 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#39 && i#39 < nchildren#6
                 ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#39))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#40: int :: 
              { $Unbox(read($Heap, children#6, IndexField(i#40))): ref } 
              LitInt(0) <= i#40 && i#40 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#40 && i#40 < nchildren#6
                 ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#40))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref } 
                  { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                LitInt(0) <= i#41 && i#41 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#41 && i#41 < nchildren#6
                   ==> $Unbox(read($Heap, children#6, IndexField(i#41))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#41: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref } 
                  { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                LitInt(0) <= i#41 && i#41 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#41 && i#41 < nchildren#6
                   ==> $Unbox(read($Heap, children#6, IndexField(i#41))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#41)): ref)
               ==> (forall i#42: int :: 
                { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                LitInt(0) <= i#42 && i#42 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#42 && i#42 < nchildren#6
                   ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#42))): ref, KMBtree.Node.repr)[$Box(children#6)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0);
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0));
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || KMBtreeModel.Node.Index_q(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || LitInt(0) <= childidx#0;
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || childidx#0
         < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)));
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
         == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))
           + 1;
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
         == Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))
           + 1;
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))
         == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)))
           - 1;
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || (KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
              childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
              childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
              childidx#0 + 1)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
              childidx#0)): Seq Box)
         ==> KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
                childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                childidx#0)): Seq Box)
           || 
          KMBtreeModel.__default.SplitLeaf($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
                childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                childidx#0)): Seq Box)
           || KMBtreeModel.__default.SplitIndex($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
                childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                childidx#0)): Seq Box));
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || Seq#Equal(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
        Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
          StartFuelAssert_Sequences._default.insert, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
          Seq#Index(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
            childidx#0), 
          childidx#0));
  ensures KMBtreeModel.__default.SplitChildOfIndex#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
        childidx#0)
       || Seq#Equal(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
        Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
          StartFuelAssert_Sequences._default.replace1with2, 
          KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
          Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
            childidx#0), 
          Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
            childidx#0 + 1), 
          childidx#0));
  free ensures true;
  ensures $_reverifyPost
     ==> $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
  free ensures true;
  ensures $_reverifyPost
     ==> $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref
       != null;
  free ensures KMBtree.__default.Full#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  ensures $_reverifyPost
     ==> !KMBtree.__default.Full($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
  free ensures KMBtree.__default.Full#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0 + 1))): ref);
  ensures $_reverifyPost
     ==> !KMBtree.__default.Full($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0 + 1))): ref);
  free ensures KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
          childidx#0)): DatatypeType);
  ensures $_reverifyPost
     ==> KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
          childidx#0)): DatatypeType)[read($Heap, 
      KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)), 
      IndexField(childidx#0))];
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || $o
           == KMBtree.NodeContents.pivots(read(old($Heap), node#0, KMBtree.Node.contents))
         || $o
           == KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
         || $o
           == $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.SplitChildOfIndex(node#0: ref, childidx#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var i#44: int;
  var newtype$check#5: int;
  var node##0: ref;
  var childidx##0: int;
  var right#0: ref
     where $Is(right#0, Tclass.KMBtree.Node())
       && $IsAlloc(right#0, Tclass.KMBtree.Node(), $Heap);
  var pivot#0: Seq Box
     where $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc(pivot#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0, Tclass.KMBtree.Node(), $Heap);
  var $rhs##1: Seq Box
     where $Is($rhs##1, TSeq(Tclass.NativeTypes.byte()))
       && $IsAlloc($rhs##1, TSeq(Tclass.NativeTypes.byte()), $Heap);
  var node##1: ref;
  var arr##0: ref;
  var length##0: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var element##0: Box;
  var pos##0: int;
  var arr##1: ref;
  var length##1: int;
  var element##1: Box;
  var pos##1: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.KMBtree.NodeContents());
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#nchildren#0#0: int;
  var let#1#0#0: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));
  var node##2: ref;
  var childidx##1: int;
  var ioldnode#0: DatatypeType
     where $Is(ioldnode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(ioldnode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#10: ref;
  var inode#0: DatatypeType
     where $Is(inode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(inode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#11: ref;
  var iright#0: DatatypeType
     where $Is(iright#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(iright#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#12: ref;
  var target#0: Seq Box
     where $Is(target#0, TSeq(Tclass.KMBtreeModel.Node()))
       && $IsAlloc(target#0, TSeq(Tclass.KMBtreeModel.Node()), $Heap);
  var ##s#0: Seq Box;
  var ##a#0: DatatypeType;
  var ##b#0: DatatypeType;
  var ##pos#0: int;
  var i#61: int;
  var node##3: ref;
  var childidx##2: int;
  var ##contents#0_0: DatatypeType;
  var ##i#0_0: int;
  var ##j#0_0: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var ##contents#0: DatatypeType;
  var ##i#0: int;
  var ##j#0: int;
  var node##4: ref;
  var childidx##3: int;
  var node##5: ref;
  var childidx##4: int;

    // AddMethodImpl: SplitChildOfIndex, Impl$$KMBtree.__default.SplitChildOfIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0
           || $o == KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))
           || $o == KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
           || $o
             == $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](919,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](920,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](922,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#44;
        assume LitInt(0) <= i#44 && i#44 < 18446744073709551616;
        newtype$check#5 := LitInt(0);
        assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        if (LitInt(0) <= i#44)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        }

        assume true;
        assume LitInt(0) <= i#44
           && i#44
             < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](925,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0 := i#44;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##0, childidx##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](925,30)"} true;
        assume KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
              i#44)): DatatypeType, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, 
            $Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#44))): ref));
        assume false;
    }
    else
    {
        assume (forall i#45: int :: 
          { $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#45))): ref } 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#45)): DatatypeType } 
          LitInt(0) <= i#45
               && i#45 < 18446744073709551616
               && 
              LitInt(0) <= i#45
               && i#45
                 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#45)): DatatypeType, 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, 
                $Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref)));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](926,4)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](928,34)
    assume true;
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Key
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is($Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      Tclass.KMBtree.Node());
    node##1 := $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == node##1 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0, $rhs##1 := Call$$KMBtree.__default.SplitNode(node##1);
    // TrCallStmt: After ProcessCallStmt
    right#0 := $rhs##0;
    pivot#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](928,67)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](929,18)
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    arr##0 := KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#6 := LitInt(1);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    newtype$check#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    length##0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume true;
    // ProcessCallStmt: CheckSubrange
    element##0 := $Box(pivot#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    pos##0 := childidx#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == arr##0 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$Arrays.__default.Insert(TSeq(Tclass.NativeTypes.byte()), arr##0, length##0, element##0, pos##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](929,83)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](930,18)
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    arr##1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    length##1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    element##1 := $Box(right#0);
    newtype$check#8 := LitInt(1);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 18446744073709551616;
    newtype$check#9 := childidx#0 + 1;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    pos##1 := childidx#0 + 1;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) && $o == arr##1 ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$Arrays.__default.Insert(Tclass.KMBtree.Node?(), arr##1, length##1, element##1, pos##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](930,87)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](931,19)
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.contents];
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    havoc dt_update_tmp#0#0;
    assume $Is(dt_update_tmp#0#0, Tclass.KMBtree.NodeContents());
    assume node#0 != null;
    assume let#0#0#0 == read($Heap, node#0, KMBtree.Node.contents);
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#0#0#0, Tclass.KMBtree.NodeContents());
    assume dt_update_tmp#0#0 == let#0#0#0;
    havoc dt_update#nchildren#0#0;
    assume LitInt(0) <= dt_update#nchildren#0#0
       && dt_update#nchildren#0#0 < 18446744073709551616;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#10 := LitInt(1);
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 18446744073709551616;
    newtype$check#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) + 1;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < 18446744073709551616;
    assume let#1#0#0
       == KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) + 1;
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
    assume dt_update#nchildren#0#0 == let#1#0#0;
    assume KMBtree.NodeContents.Index_q(dt_update_tmp#0#0);
    assume KMBtree.NodeContents.Index_q(dt_update_tmp#0#0);
    assume true;
    $rhs#0 := (var dt_update_tmp#0#1 := read($Heap, node#0, KMBtree.Node.contents); 
      (var dt_update#nchildren#0#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) + 1; 
        #KMBtree.NodeContents.Index(dt_update#nchildren#0#1, 
          KMBtree.NodeContents.pivots(dt_update_tmp#0#1), 
          KMBtree.NodeContents.children(dt_update_tmp#0#1))));
    $Heap := update($Heap, node#0, KMBtree.Node.contents, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](931,77)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](932,15)
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.repr];
    assume node#0 != null;
    assume right#0 != null;
    assume true;
    $rhs#1 := Set#Union(read($Heap, node#0, KMBtree.Node.repr), read($Heap, right#0, KMBtree.Node.repr));
    $Heap := update($Heap, node#0, KMBtree.Node.repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](932,39)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](934,38)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##2 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##1 := childidx#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SplitChildOfIndexPreservesWFShape(old($Heap), $Heap, node##2, childidx##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](934,60)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](936,24)
    assume true;
    ##node#10 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#10);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ioldnode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](936,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](937,21)
    assume true;
    ##node#11 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#11, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#11);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    inode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](937,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](938,22)
    assume true;
    ##node#12 := right#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#12, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#12);
    assume KMBtree.__default.I#canCall($Heap, right#0);
    assume KMBtree.__default.I#canCall($Heap, right#0);
    iright#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, right#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](938,32)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](939,22)
    assume true;
    assume KMBtreeModel.Node.Index_q(ioldnode#0);
    assume KMBtreeModel.Node.Index_q(inode#0);
    assume 0 <= childidx#0 && childidx#0 < Seq#Length(KMBtreeModel.Node.children(inode#0));
    ##s#0 := KMBtreeModel.Node.children(ioldnode#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##s#0, TSeq(Tclass.KMBtreeModel.Node()), $Heap);
    ##a#0 := $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), childidx#0)): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##a#0, Tclass.KMBtreeModel.Node(), $Heap);
    ##b#0 := iright#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##b#0, Tclass.KMBtreeModel.Node(), $Heap);
    ##pos#0 := childidx#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##pos#0, TInt, $Heap);
    assert {:subsumption 0} LitInt(0) <= ##pos#0;
    assert {:subsumption 0} ##pos#0 < Seq#Length(##s#0);
    assume LitInt(0) <= ##pos#0 && ##pos#0 < Seq#Length(##s#0);
    assume Sequences.__default.replace1with2#canCall(Tclass.KMBtreeModel.Node(), 
      KMBtreeModel.Node.children(ioldnode#0), 
      Seq#Index(KMBtreeModel.Node.children(inode#0), childidx#0), 
      $Box(iright#0), 
      childidx#0);
    assume Sequences.__default.replace1with2#canCall(Tclass.KMBtreeModel.Node(), 
      KMBtreeModel.Node.children(ioldnode#0), 
      Seq#Index(KMBtreeModel.Node.children(inode#0), childidx#0), 
      $Box(iright#0), 
      childidx#0);
    target#0 := Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
      StartFuel_Sequences._default.replace1with2, 
      KMBtreeModel.Node.children(ioldnode#0), 
      Seq#Index(KMBtreeModel.Node.children(inode#0), childidx#0), 
      $Box(iright#0), 
      childidx#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](939,111)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](940,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#61;
        assume true;
        if (LitInt(0) <= i#61)
        {
            assume KMBtreeModel.Node.Index_q(inode#0);
        }

        assume true;
        assume LitInt(0) <= i#61 && i#61 < Seq#Length(KMBtreeModel.Node.children(inode#0));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](943,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##3 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##2 := i#61;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##3, childidx##2);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](943,23)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](944,7)
        assume true;
        if (i#61 < childidx#0)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](945,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#0_0 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#0_0 := i#61;
            ##j#0_0 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0_0);
            assume {:subsumption 0} LitInt(0) <= ##i#0_0;
            assume {:subsumption 0} ##i#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
            assume {:subsumption 0} LitInt(0) <= ##j#0_0;
            assume {:subsumption 0} ##j#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0_0)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#0_0));
            assume {:subsumption 0} (forall l#0_0: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref } 
              LitInt(0) <= l#0_0 && l#0_0 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#0_0 && l#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(##j#0_0))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#61, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#61, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#61, childidx#0);
        }
        else
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](946,14)
            assume true;
            if (i#61 == childidx#0)
            {
            }
            else
            {
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](947,14)
                newtype$check#12 := LitInt(1);
                assume LitInt(0) <= newtype$check#12 && newtype$check#12 < 18446744073709551616;
                newtype$check#13 := childidx#0 + 1;
                assume LitInt(0) <= newtype$check#13 && newtype$check#13 < 18446744073709551616;
                assume true;
                if (i#61 == childidx#0 + 1)
                {
                }
                else
                {
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](949,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    ##contents#0 := read(old($Heap), node#0, KMBtree.Node.contents);
                    ##i#0 := childidx#0;
                    ##j#0 := i#61 - 1;
                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                      Tclass.KMBtree.NodeContents(), 
                      old($Heap));
                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0);
                    assume {:subsumption 0} LitInt(0) <= ##i#0;
                    assume {:subsumption 0} ##i#0 < KMBtree.NodeContents.nchildren(##contents#0);
                    assume {:subsumption 0} LitInt(0) <= ##j#0;
                    assume {:subsumption 0} ##j#0 < KMBtree.NodeContents.nchildren(##contents#0);
                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0)
                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#0));
                    assume {:subsumption 0} (forall l#0: int :: 
                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref } 
                      LitInt(0) <= l#0 && l#0 < 18446744073709551616
                         ==> 
                        LitInt(0) <= l#0 && l#0 < KMBtree.NodeContents.nchildren(##contents#0)
                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref
                           != null);
                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(##j#0))): ref
                       != null;
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), 
                      read(old($Heap), node#0, KMBtree.Node.contents), 
                      childidx#0, 
                      i#61 - 1);
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), 
                      read(old($Heap), node#0, KMBtree.Node.contents), 
                      childidx#0, 
                      i#61 - 1);
                    assume true;
                    assume KMBtree.__default.DisjointSubtrees(old($Heap), 
                      read(old($Heap), node#0, KMBtree.Node.contents), 
                      childidx#0, 
                      i#61 - 1);
                }
            }
        }

        assume KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#61)): DatatypeType, 
          $Unbox(Seq#Index(target#0, i#61)): DatatypeType);
        assume false;
    }
    else
    {
        assume (forall i#62: int :: 
          { $Unbox(Seq#Index(target#0, i#62)): DatatypeType } 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#62)): DatatypeType } 
          LitInt(0) <= i#62 && i#62 < Seq#Length(KMBtreeModel.Node.children(inode#0))
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#62)): DatatypeType, 
              $Unbox(Seq#Index(target#0, i#62)): DatatypeType));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](951,4)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](953,13)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##4 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##3 := childidx#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.IOfChild(node##4, childidx##3);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](953,35)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](954,13)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##5 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##4 := childidx#0 + 1;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.IOfChild(node##5, childidx##4);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](954,39)"} true;
}



procedure CheckWellformed$$KMBtree.__default.InsertLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 54 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.InsertLeaf(node#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: ref;
  var ##node#4: ref;
  var ##leaf#0: DatatypeType;
  var ##key#0: Seq Box;
  var ##value#0: DatatypeType;
  var ##node#5: ref;
  var ##node#6: DatatypeType;
  var ##node#7: ref;
  var ##node#8: DatatypeType;
  var ##node#9: ref;
  var ##node#10: DatatypeType;
  var ##node#11: ref;
  var ##node#12: DatatypeType;
  var ##node#13: ref;
  var ##node#14: DatatypeType;
  var ##node#15: ref;
  var ##m#0: Map Box Box;
  var ##key#1: Seq Box;

    // AddMethodImpl: InsertLeaf, CheckWellformed$$KMBtree.__default.InsertLeaf
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0
           || $o == KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))
           || $o == KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](957,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, node#0);
    assume !KMBtree.__default.Full($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == node#0
           || $o == KMBtree.NodeContents.keys(read(old($Heap), node#0, KMBtree.Node.contents))
           || $o
             == KMBtree.NodeContents.values(read(old($Heap), node#0, KMBtree.Node.contents)));
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldvalue#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](961,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.repr));
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#4 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#4);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##leaf#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##leaf#0, Tclass.KMBtreeModel.Node(), $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    ##value#0 := value#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##value#0, Tclass.ValueMessage.Message(), $Heap);
    assert {:subsumption 0} KMBtreeModel.Node.Leaf_q(##leaf#0);
    assume KMBtreeModel.Node.Leaf_q(##leaf#0);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> Seq#Length(KMBtreeModel.Node.keys(##leaf#0))
             == Seq#Length(KMBtreeModel.Node.values(##leaf#0)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##leaf#0)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (!KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##leaf#0))
             == Seq#Length(KMBtreeModel.Node.children(##leaf#0)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (!KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##leaf#0)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (!KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> (forall i#10: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##leaf#0), i#10)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#10 && i#10 < Seq#Length(KMBtreeModel.Node.children(##leaf#0))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##leaf#0), i#10)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (!KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> (forall i#11: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##leaf#0), i#11)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#11 && i#11 < Seq#Length(KMBtreeModel.Node.children(##leaf#0))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##leaf#0), i#11)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (!KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> (forall i#12: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##leaf#0, i#12) } 
            true
               ==> 
              LitInt(0) <= i#12 && i#12 < Seq#Length(KMBtreeModel.Node.children(##leaf#0)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##leaf#0, i#12)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##leaf#0)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##leaf#0)
         || (!KMBtreeModel.Node.Leaf_q(##leaf#0)
           ==> (forall i#13: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##leaf#0, i#13) } 
            true
               ==> 
              0 < i#13 && i#13 < Seq#Length(KMBtreeModel.Node.children(##leaf#0))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##leaf#0, i#13)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##leaf#0);
    assume KMBtreeModel.__default.InsertLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      key#0, 
      value#0);
    assume KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), 
      KMBtreeModel.__default.InsertLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        key#0, 
        value#0));
    ##node#5 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#5);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#6 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#7 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#8 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#8, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#8))
             == Seq#Length(KMBtreeModel.Node.values(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#8))
             == Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#24: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#24)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#24 && i#24 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#24)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#25: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#25)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#25 && i#25 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#25)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#26: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#26) } 
            true
               ==> 
              LitInt(0) <= i#26 && i#26 < Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#26)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#27: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#27) } 
            true
               ==> 
              0 < i#27 && i#27 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#27)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#8);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#9 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#9);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#10 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#10, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (KMBtreeModel.Node.Leaf_q(##node#10)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#10))
             == Seq#Length(KMBtreeModel.Node.values(##node#10)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (KMBtreeModel.Node.Leaf_q(##node#10)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#10)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (!KMBtreeModel.Node.Leaf_q(##node#10)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#10))
             == Seq#Length(KMBtreeModel.Node.children(##node#10)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (!KMBtreeModel.Node.Leaf_q(##node#10)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#10)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (!KMBtreeModel.Node.Leaf_q(##node#10)
           ==> (forall i#33: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#10), i#33)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#33 && i#33 < Seq#Length(KMBtreeModel.Node.children(##node#10))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#10), i#33)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (!KMBtreeModel.Node.Leaf_q(##node#10)
           ==> (forall i#34: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#10), i#34)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#34 && i#34 < Seq#Length(KMBtreeModel.Node.children(##node#10))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#10), i#34)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (!KMBtreeModel.Node.Leaf_q(##node#10)
           ==> (forall i#35: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#10, i#35) } 
            true
               ==> 
              LitInt(0) <= i#35
                 && i#35 < Seq#Length(KMBtreeModel.Node.children(##node#10)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#10, i#35)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#10)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#10)
         || (!KMBtreeModel.Node.Leaf_q(##node#10)
           ==> (forall i#36: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#10, i#36) } 
            true
               ==> 
              0 < i#36 && i#36 < Seq#Length(KMBtreeModel.Node.children(##node#10))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#10, i#36)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#10);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Map#Equal(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
    ##node#11 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#11, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#11);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#12 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#12, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#13 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#13);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#14 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#14, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
    ##node#15 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> (forall i#52: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)), 
                      i#52)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#52
                     && i#52
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)), 
                        i#52)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> (forall i#53: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)), 
                      i#53)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#53
                     && i#53
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)), 
                          i#53)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> (forall i#54: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15), 
                    i#54) } 
                true
                   ==> 
                  LitInt(0) <= i#54
                     && i#54
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15), 
                    i#54))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#15)
       ==> KMBtree.__default.WF(old($Heap), ##node#15)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#15))
               ==> (forall i#55: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15), 
                    i#55) } 
                true
                   ==> 
                  0 < i#55
                     && i#55
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#15), 
                    i#55))));
    assume KMBtree.__default.WF(old($Heap), ##node#15);
    assume KMBtree.__default.Interpretation#canCall(old($Heap), node#0);
    ##m#0 := KMBtree.__default.Interpretation(old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#1 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
    assume Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
}



procedure Call$$KMBtree.__default.InsertLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#8)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#8))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#8 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#56: int :: 
                  { $Unbox(read($Heap, children#8, IndexField(i#56))): ref } 
                  LitInt(0) <= i#56 && i#56 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#56 && i#56 < nchildren#8
                     ==> $Unbox(read($Heap, children#8, IndexField(i#56))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#57: int :: 
                  { $Unbox(read($Heap, children#8, IndexField(i#57))): ref } 
                  LitInt(0) <= i#57 && i#57 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#57 && i#57 < nchildren#8
                     ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#57))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#58: int :: 
                  { $Unbox(read($Heap, children#8, IndexField(i#58))): ref } 
                  LitInt(0) <= i#58 && i#58 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#58 && i#58 < nchildren#8
                     ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#58))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#59: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#59)): ref } 
                      { $Unbox(read($Heap, children#8, IndexField(i#59))): ref } 
                    LitInt(0) <= i#59 && i#59 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#59 && i#59 < nchildren#8
                       ==> $Unbox(read($Heap, children#8, IndexField(i#59))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#59)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#59: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#59)): ref } 
                      { $Unbox(read($Heap, children#8, IndexField(i#59))): ref } 
                    LitInt(0) <= i#59 && i#59 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#59 && i#59 < nchildren#8
                       ==> $Unbox(read($Heap, children#8, IndexField(i#59))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#59)): ref)
                   ==> (forall i#60: int :: 
                    { $Unbox(read($Heap, children#8, IndexField(i#60))): ref } 
                    LitInt(0) <= i#60 && i#60 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#60 && i#60 < nchildren#8
                       ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#60))): ref, KMBtree.Node.repr)[$Box(children#8)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#61: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#61)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#61
                   && i#61
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#61)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#62: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#62)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#62
                   && i#62
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#62)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#63: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#63) } 
              true
                 ==> 
                LitInt(0) <= i#63
                   && i#63
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#63))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#64: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#64) } 
              true
                 ==> 
                0 < i#64
                   && i#64
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#64))));
  requires KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#9)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#9
                 && nchildren#9 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#9)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#65: int :: 
                  { $Unbox(read($Heap, children#9, IndexField(i#65))): ref } 
                  LitInt(0) <= i#65 && i#65 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#65 && i#65 < nchildren#9
                     ==> $Unbox(read($Heap, children#9, IndexField(i#65))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#66: int :: 
                  { $Unbox(read($Heap, children#9, IndexField(i#66))): ref } 
                  LitInt(0) <= i#66 && i#66 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#66 && i#66 < nchildren#9
                     ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#66))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#67: int :: 
                  { $Unbox(read($Heap, children#9, IndexField(i#67))): ref } 
                  LitInt(0) <= i#67 && i#67 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#67 && i#67 < nchildren#9
                     ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#67))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#69: int :: 
                  { $Unbox(read($Heap, children#9, IndexField(i#69))): ref } 
                  LitInt(0) <= i#69 && i#69 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#69 && i#69 < nchildren#9
                     ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#69))): ref, KMBtree.Node.repr)[$Box(children#9)]))));
  free ensures true;
  ensures Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
    read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.InsertLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        key#0, 
        value#0))
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.InsertLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      key#0, 
      value#0);
  ensures KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
    KMBtreeModel.__default.InsertLeaf(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
      key#0, 
      value#0));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && (forall i#70: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#70)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#70
               && i#70
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#70)): DatatypeType))
         && (forall i#71: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#71)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#71
               && i#71
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                    i#71)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#72: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#72) } 
          true
             ==> 
            LitInt(0) <= i#72
               && i#72
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#72))
         && (forall i#73: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#73) } 
          true
             ==> 
            0 < i#73
               && i#73
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#73)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      $Box(key#0), 
      $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures Options.Option#Equal(oldvalue#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || $o == KMBtree.NodeContents.keys(read(old($Heap), node#0, KMBtree.Node.contents))
         || $o
           == KMBtree.NodeContents.values(read(old($Heap), node#0, KMBtree.Node.contents)));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.InsertLeaf(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 54 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#11)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#11)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#11 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#11))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#83: int :: 
              { $Unbox(read($Heap, children#11, IndexField(i#83))): ref } 
              LitInt(0) <= i#83 && i#83 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#83 && i#83 < nchildren#11
                 ==> $Unbox(read($Heap, children#11, IndexField(i#83))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#11), nchildren#11), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#84: int :: 
              { $Unbox(read($Heap, children#11, IndexField(i#84))): ref } 
              LitInt(0) <= i#84 && i#84 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#84 && i#84 < nchildren#11
                 ==> !read($Heap, 
                  $Unbox(read($Heap, children#11, IndexField(i#84))): ref, 
                  KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#85: int :: 
              { $Unbox(read($Heap, children#11, IndexField(i#85))): ref } 
              LitInt(0) <= i#85 && i#85 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#85 && i#85 < nchildren#11
                 ==> !read($Heap, 
                  $Unbox(read($Heap, children#11, IndexField(i#85))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#86: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#11), nchildren#11), i#86)): ref } 
                  { $Unbox(read($Heap, children#11, IndexField(i#86))): ref } 
                LitInt(0) <= i#86 && i#86 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#86 && i#86 < nchildren#11
                   ==> $Unbox(read($Heap, children#11, IndexField(i#86))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#11), nchildren#11), i#86)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#11 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#11 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#86: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#11), nchildren#11), i#86)): ref } 
                  { $Unbox(read($Heap, children#11, IndexField(i#86))): ref } 
                LitInt(0) <= i#86 && i#86 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#86 && i#86 < nchildren#11
                   ==> $Unbox(read($Heap, children#11, IndexField(i#86))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#11), nchildren#11), i#86)): ref)
               ==> (forall i#87: int :: 
                { $Unbox(read($Heap, children#11, IndexField(i#87))): ref } 
                LitInt(0) <= i#87 && i#87 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#87 && i#87 < nchildren#11
                   ==> !read($Heap, 
                    $Unbox(read($Heap, children#11, IndexField(i#87))): ref, 
                    KMBtree.Node.repr)[$Box(children#11)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.repr));
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.InsertLeaf(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
        key#0, 
        value#0))
     && 
    KMBtree.__default.I#canCall($Heap, node#0)
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.InsertLeaf#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0), 
      key#0, 
      value#0);
  ensures $_reverifyPost
     ==> KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), 
      KMBtreeModel.__default.InsertLeaf(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0), 
        key#0, 
        value#0));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             - 1);
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#88: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#88)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#88
               && i#88
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                  i#88)): DatatypeType)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#89: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#89)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#89
               && i#89
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#89)): DatatypeType), 
              Set#Empty(): Set Box)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#90: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#90) } 
          true
             ==> 
            LitInt(0) <= i#90
               && i#90
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#90)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#91: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#91) } 
          true
             ==> 
            0 < i#91
               && i#91
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#91)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || $o == KMBtree.NodeContents.keys(read(old($Heap), node#0, KMBtree.Node.contents))
         || $o
           == KMBtree.NodeContents.values(read(old($Heap), node#0, KMBtree.Node.contents)));
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.InsertLeaf(node#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var posplus1#0: int
     where LitInt(0) <= posplus1#0 && posplus1#0 < 18446744073709551616;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var run##0: ref;
  var start##0: int;
  var newtype$check#0: int;
  var end##0: int;
  var needle##0: Seq Box;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var $rhs#0_0: DatatypeType where $Is($rhs#0_0, Tclass.ValueMessage.Message());
  var arr##0: ref;
  var length##0: int;
  var element##0: Box;
  var pos##0: int;
  var arr##1: ref;
  var length##1: int;
  var element##1: Box;
  var pos##1: int;
  var $rhs#0: DatatypeType where $Is($rhs#0, Tclass.KMBtree.NodeContents());
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#nkeys#0#0: int;
  var let#1#0#0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var leaf##0: DatatypeType;
  var ##node#16: ref;
  var key##0: Seq Box;
  var value##0: DatatypeType;

    // AddMethodImpl: InsertLeaf, Impl$$KMBtree.__default.InsertLeaf
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0
           || $o == KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))
           || $o == KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](969,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](970,13)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.reveal__I();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](970,14)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](971,32)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__Interpretation();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](971,33)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](972,25)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__AllKeys();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](972,26)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](973,64)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    start##0 := LitInt(0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    end##0 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := key#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$Lexicographic__Byte__Order__Impl.__default.ArrayLargestLtePlus1(run##0, start##0, end##0, needle##0);
    // TrCallStmt: After ProcessCallStmt
    posplus1#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](973,112)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](974,5)
    newtype$check#1 := LitInt(1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    if (LitInt(1) <= posplus1#0)
    {
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#2 := LitInt(1);
        assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        newtype$check#3 := posplus1#0 - 1;
        assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assume 0 <= posplus1#0 - 1
           && posplus1#0 - 1
             < _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)));
    }

    assume true;
    if (LitInt(1) <= posplus1#0
       && Seq#Equal($Unbox(read($Heap, 
            KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(posplus1#0 - 1))): Seq Box, 
        key#0))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](975,16)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#0_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := posplus1#0 - 1;
        assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume 0 <= posplus1#0 - 1
           && posplus1#0 - 1
             < _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        oldvalue#0 := #Options.Option.Some(read($Heap, 
            KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(posplus1#0 - 1)));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](975,56)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](976,40)
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)) != null;
        newtype$check#0_2 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        newtype$check#0_3 := posplus1#0 - 1;
        assume LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume 0 <= posplus1#0 - 1
           && posplus1#0 - 1
             < _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        assume $_Frame[KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)), IndexField(posplus1#0 - 1)];
        assume true;
        $rhs#0_0 := value#0;
        $Heap := update($Heap, 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(posplus1#0 - 1), 
          $Box($rhs#0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](976,47)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](978,16)
        assume true;
        assume true;
        oldvalue#0 := Lit(#Options.Option.None());
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](978,22)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](979,20)
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        // ProcessCallStmt: CheckSubrange
        arr##0 := KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents));
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        // ProcessCallStmt: CheckSubrange
        length##0 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        // ProcessCallStmt: CheckSubrange
        element##0 := $Box(key#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        pos##0 := posplus1#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == arr##0 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$Arrays.__default.Insert(TSeq(Tclass.NativeTypes.byte()), arr##0, length##0, element##0, pos##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](979,75)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](980,20)
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        // ProcessCallStmt: CheckSubrange
        arr##1 := KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents));
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        // ProcessCallStmt: CheckSubrange
        length##1 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents));
        assume true;
        // ProcessCallStmt: CheckSubrange
        element##1 := $Box(value#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        pos##1 := posplus1#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) && $o == arr##1 ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$Arrays.__default.Insert(Tclass.ValueMessage.Message(), arr##1, length##1, element##1, pos##1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](980,79)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](981,21)
        assume node#0 != null;
        assume true;
        assume $_Frame[node#0, KMBtree.Node.contents];
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        havoc dt_update_tmp#0#0;
        assume $Is(dt_update_tmp#0#0, Tclass.KMBtree.NodeContents());
        assume node#0 != null;
        assume let#0#0#0 == read($Heap, node#0, KMBtree.Node.contents);
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(let#0#0#0, Tclass.KMBtree.NodeContents());
        assume dt_update_tmp#0#0 == let#0#0#0;
        havoc dt_update#nkeys#0#0;
        assume LitInt(0) <= dt_update#nkeys#0#0 && dt_update#nkeys#0#0 < 18446744073709551616;
        assume node#0 != null;
        assume KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#4 := LitInt(1);
        assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
        newtype$check#5 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)) + 1;
        assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        assume let#1#0#0
           == KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)) + 1;
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
        assume dt_update#nkeys#0#0 == let#1#0#0;
        assume KMBtree.NodeContents.Leaf_q(dt_update_tmp#0#0);
        assume KMBtree.NodeContents.Leaf_q(dt_update_tmp#0#0);
        assume true;
        $rhs#0 := (var dt_update_tmp#0#1 := read($Heap, node#0, KMBtree.Node.contents); 
          (var dt_update#nkeys#0#1 := KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)) + 1; 
            #KMBtree.NodeContents.Leaf(dt_update#nkeys#0#1, 
              KMBtree.NodeContents.keys(dt_update_tmp#0#1), 
              KMBtree.NodeContents.values(dt_update_tmp#0#1))));
        $Heap := update($Heap, node#0, KMBtree.Node.contents, $rhs#0);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](981,71)"} true;
    }

    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](983,30)
    // TrCallStmt: Before ProcessCallStmt
    ##node#16 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#16);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    // ProcessCallStmt: CheckSubrange
    leaf##0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := key#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := value#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.InsertLeafIsCorrect(leaf##0, key##0, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](983,55)"} true;
}



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.InsertIndexChildNotFullPreservesWFShape(previous$Heap: Heap, 
    current$Heap: Heap, 
    node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap), 
    childidx#0: int);
  free requires 55 == $FunctionContextHeight;
  free requires previous$Heap == $Heap
     && 
    $HeapSucc(previous$Heap, current$Heap)
     && $IsGoodHeap(current$Heap);
  requires $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap);
  requires $IsAlloc(childidx#0, TInt, previous$Heap);
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.InsertIndexChildNotFullPreservesWFShape(previous$Heap: Heap, 
    current$Heap: Heap, 
    node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap), 
    childidx#0: int);
  requires $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap);
  requires $IsAlloc(childidx#0, TInt, previous$Heap);
  // user-defined preconditions
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read(previous$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> read(previous$Heap, node#0, KMBtree.Node.height) == LitInt(0));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#0)), 
              read(previous$Heap, node#0, KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#0)));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            nchildren#0 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#0))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#4: int :: 
              { $Unbox(read(previous$Heap, children#0, IndexField(i#4))): ref } 
              LitInt(0) <= i#4 && i#4 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#4 && i#4 < nchildren#0
                 ==> $Unbox(read(previous$Heap, children#0, IndexField(i#4))): ref != null))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              previous$Heap, 
              Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), 
              read(previous$Heap, node#0, KMBtree.Node.repr), 
              read(previous$Heap, node#0, KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#5: int :: 
              { $Unbox(read(previous$Heap, children#0, IndexField(i#5))): ref } 
              LitInt(0) <= i#5 && i#5 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#5 && i#5 < nchildren#0
                 ==> !read(previous$Heap, 
                  $Unbox(read(previous$Heap, children#0, IndexField(i#5))): ref, 
                  KMBtree.Node.repr)[$Box(node#0)]))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#6: int :: 
              { $Unbox(read(previous$Heap, children#0, IndexField(i#6))): ref } 
              LitInt(0) <= i#6 && i#6 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#6 && i#6 < nchildren#0
                 ==> !read(previous$Heap, 
                  $Unbox(read(previous$Heap, children#0, IndexField(i#6))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#7: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref } 
                  { $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref } 
                LitInt(0) <= i#7 && i#7 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#7 && i#7 < nchildren#0
                   ==> $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#0 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          (var children#0 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#7: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref } 
                  { $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref } 
                LitInt(0) <= i#7 && i#7 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#7 && i#7 < nchildren#0
                   ==> $Unbox(read(previous$Heap, children#0, IndexField(i#7))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(previous$Heap, children#0), nchildren#0), i#7)): ref)
               ==> (forall i#8: int :: 
                { $Unbox(read(previous$Heap, children#0, IndexField(i#8))): ref } 
                LitInt(0) <= i#8 && i#8 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#8 && i#8 < nchildren#0
                   ==> !read(previous$Heap, 
                    $Unbox(read(previous$Heap, children#0, IndexField(i#8))): ref, 
                    KMBtree.Node.repr)[$Box(children#0)]))));
  requires KMBtree.NodeContents.Index_q(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.Index_q(read(current$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires read(current$Heap, node#0, KMBtree.Node.height)
     == read(previous$Heap, node#0, KMBtree.Node.height);
  requires $Unbox(read(previous$Heap, 
        KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires $Unbox(read(current$Heap, 
        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires (forall<alpha> $o: ref, $f: Field alpha :: 
    { read(current$Heap, $o, $f) } 
    $o != null
       ==> 
      read(previous$Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !($o == node#0
           || read(previous$Heap, 
            $Unbox(read(previous$Heap, 
                KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr)[$Box($o)])
       ==> read(current$Heap, $o, $f) == read(previous$Heap, $o, $f));
  requires (forall i#1: int :: 
    { $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
      { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < childidx#0
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref);
  requires (forall i#3: int :: 
    { $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#3))): ref } 
      { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#3))): ref } 
    true
       ==> 
      childidx#0 < i#3
         && i#3
           < KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3))): ref);
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> Set#Equal(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents))))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.height)
           == LitInt(0));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> Lit(true));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          Lit(true)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                    read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))), 
                  $Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                        $Unbox(read(current$Heap, 
                            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0))): ref, 
                        KMBtree.Node.contents)))), 
                $Box(children#1)), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr)))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            0 < nchildren#1)));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            nchildren#1 <= LitInt(KMBtree.__default.MaxChildren()))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#9: int :: 
              { $Unbox(read(current$Heap, children#1, IndexField(i#9))): ref } 
              LitInt(0) <= i#9 && i#9 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#9 && i#9 < nchildren#1
                 ==> $Unbox(read(current$Heap, children#1, IndexField(i#9))): ref != null))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              current$Heap, 
              Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr), 
              read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.height)))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#10: int :: 
              { $Unbox(read(current$Heap, children#1, IndexField(i#10))): ref } 
              LitInt(0) <= i#10 && i#10 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#10 && i#10 < nchildren#1
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#1, IndexField(i#10))): ref, 
                  KMBtree.Node.repr)[read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))]))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#11: int :: 
              { $Unbox(read(current$Heap, children#1, IndexField(i#11))): ref } 
              LitInt(0) <= i#11 && i#11 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#11 && i#11 < nchildren#1
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#1, IndexField(i#11))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                      $Unbox(read(current$Heap, 
                          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0))): ref, 
                      KMBtree.Node.contents)))]))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#12: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref } 
                  { $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref } 
                LitInt(0) <= i#12 && i#12 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#12 && i#12 < nchildren#1
                   ==> $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref)
               ==> Lit(true))));
  requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     ==> KMBtree.__default.WFShape($LS($LZ), 
        current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.contents))
         ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          (var children#1 := KMBtree.NodeContents.children(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)); 
            (forall i#12: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref } 
                  { $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref } 
                LitInt(0) <= i#12 && i#12 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#12 && i#12 < nchildren#1
                   ==> $Unbox(read(current$Heap, children#1, IndexField(i#12))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#1), nchildren#1), i#12)): ref)
               ==> (forall i#13: int :: 
                { $Unbox(read(current$Heap, children#1, IndexField(i#13))): ref } 
                LitInt(0) <= i#13 && i#13 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#13 && i#13 < nchildren#1
                   ==> !read(current$Heap, 
                    $Unbox(read(current$Heap, children#1, IndexField(i#13))): ref, 
                    KMBtree.Node.repr)[$Box(children#1)]))));
  requires read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height)
     == read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height);
  requires (forall $o: ref :: 
    { read(previous$Heap, $o, alloc) } 
    read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]
         && !read(previous$Heap, 
          $Unbox(read(previous$Heap, 
              KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(previous$Heap, $o, alloc));
  requires Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
    Set#Union(read(previous$Heap, node#0, KMBtree.Node.repr), 
      read(current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref, 
        KMBtree.Node.repr)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall(current$Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))
         && read(current$Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#2 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#2 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#2)), 
                  read(current$Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#2
                 && nchildren#2 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#14: int :: 
                  { $Unbox(read(current$Heap, children#2, IndexField(i#14))): ref } 
                  LitInt(0) <= i#14 && i#14 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#14 && i#14 < nchildren#2
                     ==> $Unbox(read(current$Heap, children#2, IndexField(i#14))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  current$Heap, 
                  Seq#Take(Seq#FromArray(current$Heap, children#2), nchildren#2), 
                  read(current$Heap, node#0, KMBtree.Node.repr), 
                  read(current$Heap, node#0, KMBtree.Node.height))
                 && (forall i#15: int :: 
                  { $Unbox(read(current$Heap, children#2, IndexField(i#15))): ref } 
                  LitInt(0) <= i#15 && i#15 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#15 && i#15 < nchildren#2
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#2, IndexField(i#15))): ref, 
                      KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#16: int :: 
                  { $Unbox(read(current$Heap, children#2, IndexField(i#16))): ref } 
                  LitInt(0) <= i#16 && i#16 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#16 && i#16 < nchildren#2
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#2, IndexField(i#16))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#18: int :: 
                  { $Unbox(read(current$Heap, children#2, IndexField(i#18))): ref } 
                  LitInt(0) <= i#18 && i#18 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#18 && i#18 < nchildren#2
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#2, IndexField(i#18))): ref, 
                      KMBtree.Node.repr)[$Box(children#2)]))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.InsertIndexChildNotFullPreservesWFShape(previous$Heap: Heap, 
    current$Heap: Heap, 
    node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap), 
    childidx#0: int)
   returns ($_reverifyPost: bool);
  free requires 55 == $FunctionContextHeight;
  free requires previous$Heap == $Heap
     && 
    $HeapSucc(previous$Heap, current$Heap)
     && $IsGoodHeap(current$Heap);
  requires $IsAlloc(node#0, Tclass.KMBtree.Node(), previous$Heap);
  requires $IsAlloc(childidx#0, TInt, previous$Heap);
  // user-defined preconditions
  free requires KMBtree.__default.WFShape#canCall(previous$Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), previous$Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read(previous$Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read(previous$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))
         && read(previous$Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(previous$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(previous$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(previous$Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#3 := KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#3 := KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read(previous$Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#3
                 && nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#19: int :: 
                  { $Unbox(read(previous$Heap, children#3, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#3
                     ==> $Unbox(read(previous$Heap, children#3, IndexField(i#19))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  previous$Heap, 
                  Seq#Take(Seq#FromArray(previous$Heap, children#3), nchildren#3), 
                  read(previous$Heap, node#0, KMBtree.Node.repr), 
                  read(previous$Heap, node#0, KMBtree.Node.height))
                 && (forall i#20: int :: 
                  { $Unbox(read(previous$Heap, children#3, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#3
                     ==> !read(previous$Heap, 
                      $Unbox(read(previous$Heap, children#3, IndexField(i#20))): ref, 
                      KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#21: int :: 
                  { $Unbox(read(previous$Heap, children#3, IndexField(i#21))): ref } 
                  LitInt(0) <= i#21 && i#21 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#21 && i#21 < nchildren#3
                     ==> !read(previous$Heap, 
                      $Unbox(read(previous$Heap, children#3, IndexField(i#21))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#23: int :: 
                  { $Unbox(read(previous$Heap, children#3, IndexField(i#23))): ref } 
                  LitInt(0) <= i#23 && i#23 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#23 && i#23 < nchildren#3
                     ==> !read(previous$Heap, 
                      $Unbox(read(previous$Heap, children#3, IndexField(i#23))): ref, 
                      KMBtree.Node.repr)[$Box(children#3)]))));
  requires KMBtree.NodeContents.Index_q(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires LitInt(0) <= childidx#0;
  requires childidx#0
     < KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.Index_q(read(current$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.nchildren(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents))
     == KMBtree.NodeContents.pivots(read(previous$Heap, node#0, KMBtree.Node.contents));
  requires read(current$Heap, node#0, KMBtree.Node.height)
     == read(previous$Heap, node#0, KMBtree.Node.height);
  requires $Unbox(read(previous$Heap, 
        KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires $Unbox(read(current$Heap, 
        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires (forall<alpha> $o: ref, $f: Field alpha :: 
    { read(current$Heap, $o, $f) } 
    $o != null
       ==> 
      read(previous$Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !($o == node#0
           || read(previous$Heap, 
            $Unbox(read(previous$Heap, 
                KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr)[$Box($o)])
       ==> read(current$Heap, $o, $f) == read(previous$Heap, $o, $f));
  requires (forall i#1: int :: 
    { $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
      { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#1))): ref } 
    true
       ==> 
      LitInt(0) <= i#1 && i#1 < childidx#0
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#1))): ref);
  requires (forall i#3: int :: 
    { $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#3))): ref } 
      { $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#3))): ref } 
    true
       ==> 
      childidx#0 < i#3
         && i#3
           < KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents))
       ==> $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3))): ref
         == $Unbox(read(previous$Heap, 
            KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(i#3))): ref);
  free requires KMBtree.__default.WFShape#canCall(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     && 
    KMBtree.__default.WFShape($LS($LZ), 
      current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref)
     && (if KMBtree.NodeContents.Leaf_q(read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.contents))
       then Set#Equal(read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, 
                  $Unbox(read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents)))
         && read(current$Heap, 
            $Unbox(read(current$Heap, 
                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.height)
           == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read(current$Heap, 
              $Unbox(read(current$Heap, 
                  KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)))
       else true
         && (var nchildren#4 := KMBtree.NodeContents.nchildren(read(current$Heap, 
                $Unbox(read(current$Heap, 
                    KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.contents)); 
          true
             && (var children#4 := KMBtree.NodeContents.children(read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                        read(current$Heap, 
                          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(childidx#0))), 
                      $Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                            $Unbox(read(current$Heap, 
                                KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(childidx#0))): ref, 
                            KMBtree.Node.contents)))), 
                    $Box(children#4)), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr))
                 && 
                0 < nchildren#4
                 && nchildren#4 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#4)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, 
                        $Unbox(read(current$Heap, 
                            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(childidx#0))): ref, 
                        KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#24: int :: 
                  { $Unbox(read(current$Heap, children#4, IndexField(i#24))): ref } 
                  LitInt(0) <= i#24 && i#24 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#24 && i#24 < nchildren#4
                     ==> $Unbox(read(current$Heap, children#4, IndexField(i#24))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  current$Heap, 
                  Seq#Take(Seq#FromArray(current$Heap, children#4), nchildren#4), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr), 
                  read(current$Heap, 
                    $Unbox(read(current$Heap, 
                        KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.height))
                 && (forall i#25: int :: 
                  { $Unbox(read(current$Heap, children#4, IndexField(i#25))): ref } 
                  LitInt(0) <= i#25 && i#25 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#25 && i#25 < nchildren#4
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#4, IndexField(i#25))): ref, 
                      KMBtree.Node.repr)[read(current$Heap, 
                      KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))])
                 && (forall i#26: int :: 
                  { $Unbox(read(current$Heap, children#4, IndexField(i#26))): ref } 
                  LitInt(0) <= i#26 && i#26 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#26 && i#26 < nchildren#4
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#4, IndexField(i#26))): ref, 
                      KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, 
                          $Unbox(read(current$Heap, 
                              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
                              IndexField(childidx#0))): ref, 
                          KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#28: int :: 
                  { $Unbox(read(current$Heap, children#4, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#4
                     ==> !read(current$Heap, 
                      $Unbox(read(current$Heap, children#4, IndexField(i#28))): ref, 
                      KMBtree.Node.repr)[$Box(children#4)]))));
  requires read(current$Heap, 
      $Unbox(read(current$Heap, 
          KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height)
     == read(previous$Heap, 
      $Unbox(read(previous$Heap, 
          KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      KMBtree.Node.height);
  requires (forall $o: ref :: 
    { read(previous$Heap, $o, alloc) } 
    read(current$Heap, 
          $Unbox(read(current$Heap, 
              KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]
         && !read(previous$Heap, 
          $Unbox(read(previous$Heap, 
              KMBtree.NodeContents.children(read(previous$Heap, node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(previous$Heap, $o, alloc));
  requires Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
    Set#Union(read(previous$Heap, node#0, KMBtree.Node.repr), 
      read(current$Heap, 
        $Unbox(read(current$Heap, 
            KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref, 
        KMBtree.Node.repr)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall(current$Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read(current$Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> read(current$Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read(current$Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read(current$Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read(current$Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#5)), 
              read(current$Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#5)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            nchildren#5 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#29: int :: 
              { $Unbox(read(current$Heap, children#5, IndexField(i#29))): ref } 
              LitInt(0) <= i#29 && i#29 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#29 && i#29 < nchildren#5
                 ==> $Unbox(read(current$Heap, children#5, IndexField(i#29))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              current$Heap, 
              Seq#Take(Seq#FromArray(current$Heap, children#5), nchildren#5), 
              read(current$Heap, node#0, KMBtree.Node.repr), 
              read(current$Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#30: int :: 
              { $Unbox(read(current$Heap, children#5, IndexField(i#30))): ref } 
              LitInt(0) <= i#30 && i#30 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#30 && i#30 < nchildren#5
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#5, IndexField(i#30))): ref, 
                  KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#31: int :: 
              { $Unbox(read(current$Heap, children#5, IndexField(i#31))): ref } 
              LitInt(0) <= i#31 && i#31 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#31 && i#31 < nchildren#5
                 ==> !read(current$Heap, 
                  $Unbox(read(current$Heap, children#5, IndexField(i#31))): ref, 
                  KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(current$Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#32: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#5), nchildren#5), i#32)): ref } 
                  { $Unbox(read(current$Heap, children#5, IndexField(i#32))): ref } 
                LitInt(0) <= i#32 && i#32 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#32 && i#32 < nchildren#5
                   ==> $Unbox(read(current$Heap, children#5, IndexField(i#32))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#5), nchildren#5), i#32)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall(current$Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), current$Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read(current$Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read(current$Heap, node#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read(current$Heap, node#0, KMBtree.Node.contents)); 
            (forall i#32: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#5), nchildren#5), i#32)): ref } 
                  { $Unbox(read(current$Heap, children#5, IndexField(i#32))): ref } 
                LitInt(0) <= i#32 && i#32 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#32 && i#32 < nchildren#5
                   ==> $Unbox(read(current$Heap, children#5, IndexField(i#32))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(current$Heap, children#5), nchildren#5), i#32)): ref)
               ==> (forall i#33: int :: 
                { $Unbox(read(current$Heap, children#5, IndexField(i#33))): ref } 
                LitInt(0) <= i#33 && i#33 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#33 && i#33 < nchildren#5
                   ==> !read(current$Heap, 
                    $Unbox(read(current$Heap, children#5, IndexField(i#33))): ref, 
                    KMBtree.Node.repr)[$Box(children#5)]))));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.InsertIndexChildNotFullPreservesWFShape(previous$Heap: Heap, current$Heap: Heap, node#0: ref, childidx#0: int)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var i#37: int;
  var newtype$check#0: int;
  var ##node#3: ref;
  var i#39: int;
  var ##contents#0_0: DatatypeType;
  var ##i#0_0: int;
  var ##j#0_0: int;
  var ##contents#0: DatatypeType;
  var ##i#0: int;
  var ##j#0: int;
  var nodes##0: Seq Box;
  var parentRepr##0: Set Box;
  var i#46: int;
  var j#0: int;
  var ##contents#1: DatatypeType;
  var ##i#1: int;
  var ##j#1: int;
  var ##contents#2_0: DatatypeType;
  var ##i#2_0: int;
  var ##j#2_0: int;
  var ##contents#2_1: DatatypeType;
  var ##i#2_1: int;
  var ##j#2_1: int;
  var ##contents#3_0: DatatypeType;
  var ##i#3_0: int;
  var ##j#3_0: int;
  var ##contents#4_0: DatatypeType;
  var ##i#4_0: int;
  var ##j#4_0: int;
  var ##contents#4_1: DatatypeType;
  var ##i#4_1: int;
  var ##j#4_1: int;
  var ##contents#5_0: DatatypeType;
  var ##i#5_0: int;
  var ##j#5_0: int;
  var ##contents#2: DatatypeType;
  var ##i#2: int;
  var ##j#2: int;
  var ##contents#3: DatatypeType;
  var ##i#3: int;
  var ##j#3: int;

    // AddMethodImpl: InsertIndexChildNotFullPreservesWFShape, Impl$$KMBtree.__default.InsertIndexChildNotFullPreservesWFShape
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $Heap := current$Heap;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1005,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WFShape($LS($LZ), old($Heap), $ih#node0#0)
           && KMBtree.NodeContents.Index_q(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && 
          LitInt(0) <= childidx#0
           && childidx#0
             < KMBtree.NodeContents.nchildren(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.Index_q(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
             == KMBtree.NodeContents.nchildren(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
             == KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && KMBtree.NodeContents.pivots(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
             == KMBtree.NodeContents.pivots(read(old($Heap), $ih#node0#0, KMBtree.Node.contents))
           && read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.height)
             == read(old($Heap), $ih#node0#0, KMBtree.Node.height)
           && $Unbox(read(old($Heap), 
                KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
             != null
           && $Unbox(read($initHeapForallStmt#0, 
                KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
             != null
           && (forall<alpha> $o: ref, $f: Field alpha :: 
            { read($initHeapForallStmt#0, $o, $f) } 
            $o != null
               ==> 
              read(old($Heap), $ih#node0#0, KMBtree.Node.repr)[$Box($o)]
                 && !($o == $ih#node0#0
                   || read(old($Heap), 
                    $Unbox(read(old($Heap), 
                        KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                        IndexField(childidx#0))): ref, 
                    KMBtree.Node.repr)[$Box($o)])
               ==> read($initHeapForallStmt#0, $o, $f) == read(old($Heap), $o, $f))
           && (forall i#34: int :: 
            { $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#34))): ref } 
              { $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#34))): ref } 
            true
               ==> 
              LitInt(0) <= i#34 && i#34 < childidx#0
               ==> $Unbox(read($initHeapForallStmt#0, 
                    KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#34))): ref
                 == $Unbox(read(old($Heap), 
                    KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#34))): ref)
           && (forall i#35: int :: 
            { $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#35))): ref } 
              { $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(i#35))): ref } 
            true
               ==> 
              childidx#0 < i#35
                 && i#35
                   < KMBtree.NodeContents.nchildren(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents))
               ==> $Unbox(read($initHeapForallStmt#0, 
                    KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#35))): ref
                 == $Unbox(read(old($Heap), 
                    KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(i#35))): ref)
           && KMBtree.__default.WFShape($LS($LZ), 
            $initHeapForallStmt#0, 
            $Unbox(read($initHeapForallStmt#0, 
                KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref)
           && read($initHeapForallStmt#0, 
              $Unbox(read($initHeapForallStmt#0, 
                  KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.height)
             == read(old($Heap), 
              $Unbox(read(old($Heap), 
                  KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                  IndexField(childidx#0))): ref, 
              KMBtree.Node.height)
           && (forall $o: ref :: 
            { read(old($Heap), $o, alloc) } 
            read($initHeapForallStmt#0, 
                  $Unbox(read($initHeapForallStmt#0, 
                      KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.repr)[$Box($o)]
                 && !read(old($Heap), 
                  $Unbox(read(old($Heap), 
                      KMBtree.NodeContents.children(read(old($Heap), $ih#node0#0, KMBtree.Node.contents)), 
                      IndexField(childidx#0))): ref, 
                  KMBtree.Node.repr)[$Box($o)]
               ==> $o != null && !read(old($Heap), $o, alloc))
           && Set#Equal(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.repr), 
            Set#Union(read(old($Heap), $ih#node0#0, KMBtree.Node.repr), 
              read($initHeapForallStmt#0, 
                $Unbox(read($initHeapForallStmt#0, 
                    KMBtree.NodeContents.children(read($initHeapForallStmt#0, $ih#node0#0, KMBtree.Node.contents)), 
                    IndexField(childidx#0))): ref, 
                KMBtree.Node.repr)))
           && (($ih#node0#0 == null && node#0 != null)
             || (($ih#node0#0 != null <==> node#0 != null)
               && 
              0 <= childidx#0
               && childidx#0 < childidx#0))
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, $ih#node0#0));
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1006,5)
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0
         <= KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume {:subsumption 0} node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume $Is(Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray(old($Heap), 
        KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents)));
    ##parentRepr#0 := read(old($Heap), node#0, KMBtree.Node.repr);
    ##parentHeight#0 := read(old($Heap), node#0, KMBtree.Node.height);
    assume $IsAlloc(Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node?()), 
      old($Heap));
    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.repr), 
      TSet(Tclass._System.object()), 
      old($Heap));
    assume KMBtree.__default.WFShapeChildren#canCall(old($Heap), 
      Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      read(old($Heap), node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall(old($Heap), 
      Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      read(old($Heap), node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      old($Heap), 
      Seq#Take(Seq#FromArray(old($Heap), 
          KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read(old($Heap), node#0, KMBtree.Node.contents))), 
      read(old($Heap), node#0, KMBtree.Node.repr), 
      read(old($Heap), node#0, KMBtree.Node.height));
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1007,5)
    havoc i#37;
    assume LitInt(0) <= i#37 && i#37 < 18446744073709551616;
    // Begin Comprehension WF check
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    if (LitInt(0) <= i#37)
    {
        assume {:subsumption 0} node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    }

    if (LitInt(0) <= i#37
       && i#37
         < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)))
    {
        assume {:subsumption 0} node#0 != null;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        assume KMBtree.NodeContents.Index_q(read(old($Heap), node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents))
           != null;
        assume {:subsumption 0} 0 <= i#37
           && i#37
             < _System.array.Length(KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)));
        assume $Is($Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(i#37))): ref, 
          Tclass.KMBtree.Node());
        ##node#3 := $Unbox(read(old($Heap), 
            KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
            IndexField(i#37))): ref;
        assume $IsAlloc($Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(i#37))): ref, 
          Tclass.KMBtree.Node?(), 
          old($Heap));
        assume KMBtree.__default.WFShape#canCall(old($Heap), 
          $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(i#37))): ref);
    }

    // End Comprehension WF check
    assume (forall i#38: int :: 
      { $Unbox(read(old($Heap), 
            KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
            IndexField(i#38))): ref } 
      LitInt(0) <= i#38 && i#38 < 18446744073709551616
         ==> 
        LitInt(0) <= i#38
           && i#38
             < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.__default.WFShape#canCall(old($Heap), 
          $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(i#38))): ref));
    assume (forall i#38: int :: 
      { $Unbox(read(old($Heap), 
            KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
            IndexField(i#38))): ref } 
      LitInt(0) <= i#38 && i#38 < 18446744073709551616
         ==> 
        LitInt(0) <= i#38
           && i#38
             < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.__default.WFShape($LS($LZ), 
          old($Heap), 
          $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(i#38))): ref));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1009,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#39;
        assume true;
        if (LitInt(0) <= i#39)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        }

        assume true;
        assume LitInt(0) <= i#39
           && i#39
             < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1019,7)
        assume true;
        if (i#39 < childidx#0)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1020,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#0_0 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#0_0 := i#39;
            ##j#0_0 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0_0);
            assume {:subsumption 0} LitInt(0) <= ##i#0_0;
            assume {:subsumption 0} ##i#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
            assume {:subsumption 0} LitInt(0) <= ##j#0_0;
            assume {:subsumption 0} ##j#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0_0)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#0_0));
            assume {:subsumption 0} (forall l#0_0: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref } 
              LitInt(0) <= l#0_0 && l#0_0 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#0_0 && l#0_0 < KMBtree.NodeContents.nchildren(##contents#0_0)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(l#0_0))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0_0), IndexField(##j#0_0))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#39, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#39, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#39, childidx#0);
        }
        else
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1021,14)
            assume true;
            if (i#39 == childidx#0)
            {
            }
            else
            {
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1023,9)
                assume {:subsumption 0} node#0 != null;
                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                ##contents#0 := read(old($Heap), node#0, KMBtree.Node.contents);
                ##i#0 := childidx#0;
                ##j#0 := i#39;
                assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                  Tclass.KMBtree.NodeContents(), 
                  old($Heap));
                assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0);
                assume {:subsumption 0} LitInt(0) <= ##i#0;
                assume {:subsumption 0} ##i#0 < KMBtree.NodeContents.nchildren(##contents#0);
                assume {:subsumption 0} LitInt(0) <= ##j#0;
                assume {:subsumption 0} ##j#0 < KMBtree.NodeContents.nchildren(##contents#0);
                assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0)
                   <= _System.array.Length(KMBtree.NodeContents.children(##contents#0));
                assume {:subsumption 0} (forall l#0: int :: 
                  { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref } 
                  LitInt(0) <= l#0 && l#0 < 18446744073709551616
                     ==> 
                    LitInt(0) <= l#0 && l#0 < KMBtree.NodeContents.nchildren(##contents#0)
                     ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref
                       != null);
                assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(##j#0))): ref
                   != null;
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#39);
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#39);
                assume true;
                assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#39);
            }
        }

        assume $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#39))): ref
           != null;
        assume read($Heap, node#0, KMBtree.Node.repr)[read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(i#39))];
        assume Set#Subset(read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref, 
              KMBtree.Node.repr), 
            read($Heap, node#0, KMBtree.Node.repr))
           && !Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
            read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref, 
              KMBtree.Node.repr));
        assume !read($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#39))): ref, 
          KMBtree.Node.repr)[$Box(node#0)];
        assume !read($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#39))): ref, 
          KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))];
        assume !read($Heap, 
          $Unbox(read($Heap, 
              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
              IndexField(i#39))): ref, 
          KMBtree.Node.repr)[$Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))];
        assume read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref, 
            KMBtree.Node.height)
           < read($Heap, node#0, KMBtree.Node.height);
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> Set#Equal(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.repr), 
                Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                      read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(i#39))), 
                    $Box(KMBtree.NodeContents.keys(read($Heap, 
                          $Unbox(read($Heap, 
                              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                              IndexField(i#39))): ref, 
                          KMBtree.Node.contents)))), 
                  $Box(KMBtree.NodeContents.values(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents))))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueMessage.Message(), 
                KMBtree.NodeContents.keys(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(i#39))): ref, 
                    KMBtree.Node.contents)), 
                KMBtree.NodeContents.values(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(i#39))): ref, 
                    KMBtree.Node.contents))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.height)
                 == LitInt(0));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> LitInt(0)
                 <= KMBtree.NodeContents.nkeys(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(i#39))): ref, 
                    KMBtree.Node.contents)));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> KMBtree.NodeContents.nkeys(read($Heap, 
                    $Unbox(read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(i#39))): ref, 
                    KMBtree.Node.contents))
                 <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
                 == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)))
                 == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> Lit(true));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                Lit(true)));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                          read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))), 
                        $Box(KMBtree.NodeContents.pivots(read($Heap, 
                              $Unbox(read($Heap, 
                                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                  IndexField(i#39))): ref, 
                              KMBtree.Node.contents)))), 
                      $Box(children#6)), 
                    read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.repr)))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  0 < nchildren#6)));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  nchildren#6 <= LitInt(KMBtree.__default.MaxChildren()))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, 
                          $Unbox(read($Heap, 
                              KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                              IndexField(i#39))): ref, 
                          KMBtree.Node.contents)))
                     == LitInt(KMBtree.__default.MaxChildren() - 1))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  (forall i#40: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#40))): ref } 
                    LitInt(0) <= i#40 && i#40 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#40 && i#40 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#40))): ref != null))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                    $Heap, 
                    Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                    read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.repr), 
                    read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.height)))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  (forall i#41: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#41))): ref } 
                    LitInt(0) <= i#41 && i#41 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#41 && i#41 < nchildren#6
                       ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#41))): ref, KMBtree.Node.repr)[read($Heap, 
                        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                        IndexField(i#39))]))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  (forall i#42: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                    LitInt(0) <= i#42 && i#42 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#42 && i#42 < nchildren#6
                       ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#42))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, 
                            $Unbox(read($Heap, 
                                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                                IndexField(i#39))): ref, 
                            KMBtree.Node.contents)))]))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  (forall i#43: int :: 
                      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#43)): ref } 
                        { $Unbox(read($Heap, children#6, IndexField(i#43))): ref } 
                      LitInt(0) <= i#43 && i#43 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#43 && i#43 < nchildren#6
                         ==> $Unbox(read($Heap, children#6, IndexField(i#43))): ref
                           == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#43)): ref)
                     ==> Lit(true))));
        assume KMBtree.__default.WFShape#canCall($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#39))): ref)
           ==> KMBtree.__default.WFShape($LS($LZ), 
              $Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                  IndexField(i#39))): ref)
             || (!KMBtree.NodeContents.Leaf_q(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#39))): ref, 
                  KMBtree.Node.contents))
               ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, 
                      $Unbox(read($Heap, 
                          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                          IndexField(i#39))): ref, 
                      KMBtree.Node.contents)); 
                (var children#6 := KMBtree.NodeContents.children(read($Heap, 
                        $Unbox(read($Heap, 
                            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                            IndexField(i#39))): ref, 
                        KMBtree.Node.contents)); 
                  (forall i#43: int :: 
                      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#43)): ref } 
                        { $Unbox(read($Heap, children#6, IndexField(i#43))): ref } 
                      LitInt(0) <= i#43 && i#43 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#43 && i#43 < nchildren#6
                         ==> $Unbox(read($Heap, children#6, IndexField(i#43))): ref
                           == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#43)): ref)
                     ==> (forall i#44: int :: 
                      { $Unbox(read($Heap, children#6, IndexField(i#44))): ref } 
                      LitInt(0) <= i#44 && i#44 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#44 && i#44 < nchildren#6
                         ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(children#6)]))));
        assume false;
    }
    else
    {
        assume (forall i#45: int :: 
          { $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#45))): ref } 
          LitInt(0) <= i#45
               && i#45
                 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             ==> $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref
                 != null
               && read($Heap, node#0, KMBtree.Node.repr)[read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#45))]
               && 
              Set#Subset(read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#45))): ref, 
                  KMBtree.Node.repr), 
                read($Heap, node#0, KMBtree.Node.repr))
               && !Set#Subset(read($Heap, node#0, KMBtree.Node.repr), 
                read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#45))): ref, 
                  KMBtree.Node.repr))
               && !read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref, 
                KMBtree.Node.repr)[$Box(node#0)]
               && !read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref, 
                KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]
               && !read($Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref, 
                KMBtree.Node.repr)[$Box(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)))]
               && read($Heap, 
                  $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                      IndexField(i#45))): ref, 
                  KMBtree.Node.height)
                 < read($Heap, node#0, KMBtree.Node.height)
               && KMBtree.__default.WFShape($LS($LZ), 
                $Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#45))): ref));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1025,4)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1026,32)
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    nodes##0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    assume node#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    parentRepr##0 := read($Heap, node#0, KMBtree.Node.repr);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.SeqReprSubsetExtensionality(nodes##0, parentRepr##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1026,93)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1028,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#46, j#0;
        assume true;
        if (LitInt(0) <= i#46)
        {
        }

        if (LitInt(0) <= i#46 && i#46 < j#0)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        }

        assume true;
        assume LitInt(0) <= i#46
           && i#46 < j#0
           && j#0 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1031,7)
        assume {:subsumption 0} node#0 != null;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        ##contents#1 := read(old($Heap), node#0, KMBtree.Node.contents);
        ##i#1 := i#46;
        ##j#1 := j#0;
        assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
          Tclass.KMBtree.NodeContents(), 
          old($Heap));
        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#1);
        assume {:subsumption 0} LitInt(0) <= ##i#1;
        assume {:subsumption 0} ##i#1 < KMBtree.NodeContents.nchildren(##contents#1);
        assume {:subsumption 0} LitInt(0) <= ##j#1;
        assume {:subsumption 0} ##j#1 < KMBtree.NodeContents.nchildren(##contents#1);
        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#1)
           <= _System.array.Length(KMBtree.NodeContents.children(##contents#1));
        assume {:subsumption 0} (forall l#1: int :: 
          { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(l#1))): ref } 
          LitInt(0) <= l#1 && l#1 < 18446744073709551616
             ==> 
            LitInt(0) <= l#1 && l#1 < KMBtree.NodeContents.nchildren(##contents#1)
             ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(l#1))): ref
               != null);
        assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(##j#1))): ref
           != null;
        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, j#0);
        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, j#0);
        assume true;
        assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, j#0);
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1032,7)
        assume true;
        if (j#0 < childidx#0)
        {
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1033,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#2_0 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#2_0 := i#46;
            ##j#2_0 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#2_0);
            assume {:subsumption 0} LitInt(0) <= ##i#2_0;
            assume {:subsumption 0} ##i#2_0 < KMBtree.NodeContents.nchildren(##contents#2_0);
            assume {:subsumption 0} LitInt(0) <= ##j#2_0;
            assume {:subsumption 0} ##j#2_0 < KMBtree.NodeContents.nchildren(##contents#2_0);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#2_0)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#2_0));
            assume {:subsumption 0} (forall l#2_0: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2_0), IndexField(l#2_0))): ref } 
              LitInt(0) <= l#2_0 && l#2_0 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#2_0 && l#2_0 < KMBtree.NodeContents.nchildren(##contents#2_0)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2_0), IndexField(l#2_0))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2_0), IndexField(##j#2_0))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1034,9)
            assume {:subsumption 0} node#0 != null;
            assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
            ##contents#2_1 := read(old($Heap), node#0, KMBtree.Node.contents);
            ##i#2_1 := j#0;
            ##j#2_1 := childidx#0;
            assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
              Tclass.KMBtree.NodeContents(), 
              old($Heap));
            assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#2_1);
            assume {:subsumption 0} LitInt(0) <= ##i#2_1;
            assume {:subsumption 0} ##i#2_1 < KMBtree.NodeContents.nchildren(##contents#2_1);
            assume {:subsumption 0} LitInt(0) <= ##j#2_1;
            assume {:subsumption 0} ##j#2_1 < KMBtree.NodeContents.nchildren(##contents#2_1);
            assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#2_1)
               <= _System.array.Length(KMBtree.NodeContents.children(##contents#2_1));
            assume {:subsumption 0} (forall l#2_1: int :: 
              { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2_1), IndexField(l#2_1))): ref } 
              LitInt(0) <= l#2_1 && l#2_1 < 18446744073709551616
                 ==> 
                LitInt(0) <= l#2_1 && l#2_1 < KMBtree.NodeContents.nchildren(##contents#2_1)
                 ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2_1), IndexField(l#2_1))): ref
                   != null);
            assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2_1), IndexField(##j#2_1))): ref
               != null;
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), j#0, childidx#0);
            assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), j#0, childidx#0);
            assume true;
            assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), j#0, childidx#0);
        }
        else
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1035,14)
            assume true;
            if (j#0 == childidx#0)
            {
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1036,9)
                assume {:subsumption 0} node#0 != null;
                assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                ##contents#3_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                ##i#3_0 := i#46;
                ##j#3_0 := childidx#0;
                assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                  Tclass.KMBtree.NodeContents(), 
                  old($Heap));
                assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#3_0);
                assume {:subsumption 0} LitInt(0) <= ##i#3_0;
                assume {:subsumption 0} ##i#3_0 < KMBtree.NodeContents.nchildren(##contents#3_0);
                assume {:subsumption 0} LitInt(0) <= ##j#3_0;
                assume {:subsumption 0} ##j#3_0 < KMBtree.NodeContents.nchildren(##contents#3_0);
                assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#3_0)
                   <= _System.array.Length(KMBtree.NodeContents.children(##contents#3_0));
                assume {:subsumption 0} (forall l#3_0: int :: 
                  { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_0), IndexField(l#3_0))): ref } 
                  LitInt(0) <= l#3_0 && l#3_0 < 18446744073709551616
                     ==> 
                    LitInt(0) <= l#3_0 && l#3_0 < KMBtree.NodeContents.nchildren(##contents#3_0)
                     ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_0), IndexField(l#3_0))): ref
                       != null);
                assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3_0), IndexField(##j#3_0))): ref
                   != null;
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
                assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
                assume true;
                assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
            }
            else
            {
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1037,14)
                if (i#46 < childidx#0)
                {
                }

                assume true;
                if (i#46 < childidx#0 && childidx#0 < j#0)
                {
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1038,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    ##contents#4_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                    ##i#4_0 := i#46;
                    ##j#4_0 := childidx#0;
                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                      Tclass.KMBtree.NodeContents(), 
                      old($Heap));
                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#4_0);
                    assume {:subsumption 0} LitInt(0) <= ##i#4_0;
                    assume {:subsumption 0} ##i#4_0 < KMBtree.NodeContents.nchildren(##contents#4_0);
                    assume {:subsumption 0} LitInt(0) <= ##j#4_0;
                    assume {:subsumption 0} ##j#4_0 < KMBtree.NodeContents.nchildren(##contents#4_0);
                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#4_0)
                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#4_0));
                    assume {:subsumption 0} (forall l#4_0: int :: 
                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_0), IndexField(l#4_0))): ref } 
                      LitInt(0) <= l#4_0 && l#4_0 < 18446744073709551616
                         ==> 
                        LitInt(0) <= l#4_0 && l#4_0 < KMBtree.NodeContents.nchildren(##contents#4_0)
                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_0), IndexField(l#4_0))): ref
                           != null);
                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_0), IndexField(##j#4_0))): ref
                       != null;
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
                    assume true;
                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#46, childidx#0);
                    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1039,9)
                    assume {:subsumption 0} node#0 != null;
                    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                    ##contents#4_1 := read(old($Heap), node#0, KMBtree.Node.contents);
                    ##i#4_1 := childidx#0;
                    ##j#4_1 := j#0;
                    assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                      Tclass.KMBtree.NodeContents(), 
                      old($Heap));
                    assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#4_1);
                    assume {:subsumption 0} LitInt(0) <= ##i#4_1;
                    assume {:subsumption 0} ##i#4_1 < KMBtree.NodeContents.nchildren(##contents#4_1);
                    assume {:subsumption 0} LitInt(0) <= ##j#4_1;
                    assume {:subsumption 0} ##j#4_1 < KMBtree.NodeContents.nchildren(##contents#4_1);
                    assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#4_1)
                       <= _System.array.Length(KMBtree.NodeContents.children(##contents#4_1));
                    assume {:subsumption 0} (forall l#4_1: int :: 
                      { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_1), IndexField(l#4_1))): ref } 
                      LitInt(0) <= l#4_1 && l#4_1 < 18446744073709551616
                         ==> 
                        LitInt(0) <= l#4_1 && l#4_1 < KMBtree.NodeContents.nchildren(##contents#4_1)
                         ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_1), IndexField(l#4_1))): ref
                           != null);
                    assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#4_1), IndexField(##j#4_1))): ref
                       != null;
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                    assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                    assume true;
                    assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                }
                else
                {
                    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1040,14)
                    if (i#46 == childidx#0)
                    {
                    }

                    assume true;
                    if (i#46 == childidx#0 && childidx#0 < j#0)
                    {
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1041,9)
                        assume {:subsumption 0} node#0 != null;
                        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                        ##contents#5_0 := read(old($Heap), node#0, KMBtree.Node.contents);
                        ##i#5_0 := childidx#0;
                        ##j#5_0 := j#0;
                        assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                          Tclass.KMBtree.NodeContents(), 
                          old($Heap));
                        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#5_0);
                        assume {:subsumption 0} LitInt(0) <= ##i#5_0;
                        assume {:subsumption 0} ##i#5_0 < KMBtree.NodeContents.nchildren(##contents#5_0);
                        assume {:subsumption 0} LitInt(0) <= ##j#5_0;
                        assume {:subsumption 0} ##j#5_0 < KMBtree.NodeContents.nchildren(##contents#5_0);
                        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#5_0)
                           <= _System.array.Length(KMBtree.NodeContents.children(##contents#5_0));
                        assume {:subsumption 0} (forall l#5_0: int :: 
                          { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_0), IndexField(l#5_0))): ref } 
                          LitInt(0) <= l#5_0 && l#5_0 < 18446744073709551616
                             ==> 
                            LitInt(0) <= l#5_0 && l#5_0 < KMBtree.NodeContents.nchildren(##contents#5_0)
                             ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_0), IndexField(l#5_0))): ref
                               != null);
                        assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#5_0), IndexField(##j#5_0))): ref
                           != null;
                        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                        assume true;
                        assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                    }
                    else
                    {
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1043,9)
                        assume {:subsumption 0} node#0 != null;
                        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                        ##contents#2 := read(old($Heap), node#0, KMBtree.Node.contents);
                        ##i#2 := childidx#0;
                        ##j#2 := i#46;
                        assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                          Tclass.KMBtree.NodeContents(), 
                          old($Heap));
                        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#2);
                        assume {:subsumption 0} LitInt(0) <= ##i#2;
                        assume {:subsumption 0} ##i#2 < KMBtree.NodeContents.nchildren(##contents#2);
                        assume {:subsumption 0} LitInt(0) <= ##j#2;
                        assume {:subsumption 0} ##j#2 < KMBtree.NodeContents.nchildren(##contents#2);
                        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#2)
                           <= _System.array.Length(KMBtree.NodeContents.children(##contents#2));
                        assume {:subsumption 0} (forall l#2: int :: 
                          { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2), IndexField(l#2))): ref } 
                          LitInt(0) <= l#2 && l#2 < 18446744073709551616
                             ==> 
                            LitInt(0) <= l#2 && l#2 < KMBtree.NodeContents.nchildren(##contents#2)
                             ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2), IndexField(l#2))): ref
                               != null);
                        assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#2), IndexField(##j#2))): ref
                           != null;
                        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#46);
                        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#46);
                        assume true;
                        assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#46);
                        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1044,9)
                        assume {:subsumption 0} node#0 != null;
                        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
                        ##contents#3 := read(old($Heap), node#0, KMBtree.Node.contents);
                        ##i#3 := childidx#0;
                        ##j#3 := j#0;
                        assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
                          Tclass.KMBtree.NodeContents(), 
                          old($Heap));
                        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#3);
                        assume {:subsumption 0} LitInt(0) <= ##i#3;
                        assume {:subsumption 0} ##i#3 < KMBtree.NodeContents.nchildren(##contents#3);
                        assume {:subsumption 0} LitInt(0) <= ##j#3;
                        assume {:subsumption 0} ##j#3 < KMBtree.NodeContents.nchildren(##contents#3);
                        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#3)
                           <= _System.array.Length(KMBtree.NodeContents.children(##contents#3));
                        assume {:subsumption 0} (forall l#3: int :: 
                          { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3), IndexField(l#3))): ref } 
                          LitInt(0) <= l#3 && l#3 < 18446744073709551616
                             ==> 
                            LitInt(0) <= l#3 && l#3 < KMBtree.NodeContents.nchildren(##contents#3)
                             ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3), IndexField(l#3))): ref
                               != null);
                        assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#3), IndexField(##j#3))): ref
                           != null;
                        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                        assume true;
                        assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, j#0);
                    }
                }
            }
        }

        assume KMBtree.__default.DisjointReprs#canCall($Heap, 
            Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
              KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
            i#46, 
            j#0)
           ==> KMBtree.__default.DisjointReprs($Heap, 
              Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
                KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
              i#46, 
              j#0)
             || Set#Disjoint(read($Heap, 
                $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
                      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
                    i#46)): ref, 
                KMBtree.Node.repr), 
              read($Heap, 
                $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
                      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
                    j#0)): ref, 
                KMBtree.Node.repr));
        assume false;
    }
    else
    {
        assume (forall i#47: int, j#1: int :: 
          { KMBtree.__default.DisjointReprs($Heap, 
              Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
                KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
              i#47, 
              j#1) } 
          LitInt(0) <= i#47
               && i#47 < j#1
               && j#1 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.__default.DisjointReprs($Heap, 
              Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
                KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
              i#47, 
              j#1));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1046,4)"} true;
}



procedure CheckWellformed$$KMBtree.__default.InsertIndexChildNotFull(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616, 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 58 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.InsertIndexChildNotFull(node#0: ref, childidx#0: int, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##run#0: Seq Box;
  var ##needle#0: Seq Box;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: ref;
  var ##node#4: DatatypeType;
  var ##node#5: ref;
  var ##node#6: DatatypeType;
  var ##node#7: ref;
  var ##node#8: DatatypeType;
  var ##node#9: ref;
  var ##node#10: DatatypeType;
  var ##node#11: ref;
  var ##node#12: DatatypeType;
  var ##node#13: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: InsertIndexChildNotFull, CheckWellformed$$KMBtree.__default.InsertIndexChildNotFull
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0
           || $o
             == $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
           || read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1049,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume 0
         <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
         <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    ##run#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##needle#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#0);
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, ##run#0);
    assume Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
      key#0);
    assume childidx#0
       == Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
          key#0)
         + 1;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Is($Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      Tclass.KMBtree.Node());
    ##node#1 := $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
    assume !KMBtree.__default.Full($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == node#0
           || $o
             == $Unbox(read(old($Heap), 
                KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
           || read(old($Heap), 
            $Unbox(read(old($Heap), 
                KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldvalue#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1056,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#4 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#5 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#5);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#6 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#6))
             == Seq#Length(KMBtreeModel.Node.values(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#6))
             == Seq#Length(KMBtreeModel.Node.children(##node#6)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#10: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#10)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#10 && i#10 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#10)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#11: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#11)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#11 && i#11 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#11)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#12: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#6, i#12) } 
            true
               ==> 
              LitInt(0) <= i#12 && i#12 < Seq#Length(KMBtreeModel.Node.children(##node#6)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#6, i#12)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#13: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#6, i#13) } 
            true
               ==> 
              0 < i#13 && i#13 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#6, i#13)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#6);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#7 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#7);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#8 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#8, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#8))
             == Seq#Length(KMBtreeModel.Node.values(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#8))
             == Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#19: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#19)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#19)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#20: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#20)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#20 && i#20 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#20)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#21: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#21) } 
            true
               ==> 
              LitInt(0) <= i#21 && i#21 < Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#21)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#22: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#22) } 
            true
               ==> 
              0 < i#22 && i#22 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#22)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#8);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Map#Equal(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
    ##node#9 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#9);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#10 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#10, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#11 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#11);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#12 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#12, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Set#Subset(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
    ##node#13 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#38: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                      i#38)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#38
                     && i#38
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                        i#38)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#39: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                      i#39)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#39
                     && i#39
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                          i#39)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#40: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#40) } 
                true
                   ==> 
                  LitInt(0) <= i#40
                     && i#40
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#40))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#41: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#41) } 
                true
                   ==> 
                  0 < i#41
                     && i#41
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#41))));
    assume KMBtree.__default.WF(old($Heap), ##node#13);
    assume KMBtree.__default.Interpretation#canCall(old($Heap), node#0);
    ##m#0 := KMBtree.__default.Interpretation(old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
    assume Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
}



procedure Call$$KMBtree.__default.InsertIndexChildNotFull(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616, 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#6))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#42: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                  LitInt(0) <= i#42 && i#42 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#42 && i#42 < nchildren#6
                     ==> $Unbox(read($Heap, children#6, IndexField(i#42))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#43: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#43))): ref } 
                  LitInt(0) <= i#43 && i#43 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#43 && i#43 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#43))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#44: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#44))): ref } 
                  LitInt(0) <= i#44 && i#44 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#44 && i#44 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#45: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#45))): ref } 
                    LitInt(0) <= i#45 && i#45 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#45 && i#45 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#45))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#45: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#45))): ref } 
                    LitInt(0) <= i#45 && i#45 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#45 && i#45 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#45))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref)
                   ==> (forall i#46: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#46))): ref } 
                    LitInt(0) <= i#46 && i#46 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#46 && i#46 < nchildren#6
                       ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#46))): ref, KMBtree.Node.repr)[$Box(children#6)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#47: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#47)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#47
                   && i#47
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#47)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#48: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#48)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#48
                   && i#48
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#48)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#49: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#49) } 
              true
                 ==> 
                LitInt(0) <= i#49
                   && i#49
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#49))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#50: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#50) } 
              true
                 ==> 
                0 < i#50
                   && i#50
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#50))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires childidx#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), 
        Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
        key#0)
       + 1;
  requires $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires !KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#7)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#7
                 && nchildren#7 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#51: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#51))): ref } 
                  LitInt(0) <= i#51 && i#51 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#51 && i#51 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#51))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#52: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#52))): ref } 
                  LitInt(0) <= i#52 && i#52 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#52 && i#52 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#53: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#53))): ref } 
                  LitInt(0) <= i#53 && i#53 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#53 && i#53 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#53))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#55: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#55))): ref } 
                  LitInt(0) <= i#55 && i#55 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#55 && i#55 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && (forall i#56: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#56)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#56
               && i#56
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#56)): DatatypeType))
         && (forall i#57: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#57)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#57
               && i#57
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                    i#57)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#58: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#58) } 
          true
             ==> 
            LitInt(0) <= i#58
               && i#58
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#58))
         && (forall i#59: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#59) } 
          true
             ==> 
            0 < i#59
               && i#59
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#59)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      $Box(key#0), 
      $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures Options.Option#Equal(oldvalue#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || $o
           == $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref
         || read(old($Heap), 
          $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.InsertIndexChildNotFull(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616, 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 58 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires childidx#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), 
        Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
        key#0)
       + 1;
  requires $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  requires !KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#9)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#9)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#9 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#9))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#69: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#69))): ref } 
              LitInt(0) <= i#69 && i#69 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#69 && i#69 < nchildren#9
                 ==> $Unbox(read($Heap, children#9, IndexField(i#69))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#70: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#70))): ref } 
              LitInt(0) <= i#70 && i#70 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#70 && i#70 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#70))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#71: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#71))): ref } 
              LitInt(0) <= i#71 && i#71 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#71 && i#71 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#71))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#72: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#72))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#72: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#72))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref)
               ==> (forall i#73: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#73))): ref } 
                LitInt(0) <= i#73 && i#73 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#73 && i#73 < nchildren#9
                   ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#73))): ref, KMBtree.Node.repr)[$Box(children#9)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             - 1);
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#74: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#74)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#74
               && i#74
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                  i#74)): DatatypeType)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#75: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#75)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#75
               && i#75
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#75)): DatatypeType), 
              Set#Empty(): Set Box)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#76: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#76) } 
          true
             ==> 
            LitInt(0) <= i#76
               && i#76
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#76)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#77: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#77) } 
          true
             ==> 
            0 < i#77
               && i#77
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#77)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || $o
           == $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref
         || read(old($Heap), 
          $Unbox(read(old($Heap), 
              KMBtree.NodeContents.children(read(old($Heap), node#0, KMBtree.Node.contents)), 
              IndexField(childidx#0))): ref, 
          KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.InsertIndexChildNotFull(node#0: ref, childidx#0: int, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var i#79: int;
  var newtype$check#2: int;
  var node##0: ref;
  var childidx##0: int;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##1: ref;
  var key##0: Seq Box;
  var value##0: DatatypeType;
  var ##node#14: ref;
  var ##m#1: Map Box Box;
  var ##key#1: Seq Box;
  var $rhs#0: Set Box where $Is($rhs#0, TSet(Tclass._System.object()));
  var node##2: ref;
  var childidx##1: int;
  var oldinode#0: DatatypeType
     where $Is(oldinode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(oldinode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#15: ref;
  var inode#0: DatatypeType
     where $Is(inode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(inode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#16: ref;
  var oldchild#0: DatatypeType
     where $Is(oldchild#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(oldchild#0, Tclass.KMBtreeModel.Node(), $Heap);
  var newchild#0: DatatypeType
     where $Is(newchild#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(newchild#0, Tclass.KMBtreeModel.Node(), $Heap);
  var i#100: int;
  var node##3: ref;
  var childidx##2: int;
  var ##contents#0: DatatypeType;
  var ##i#0: int;
  var ##j#0: int;
  var i#102: int;
  var node##4: ref;
  var childidx##3: int;
  var ##contents#1: DatatypeType;
  var ##i#1: int;
  var ##j#1: int;
  var node##5: ref;
  var childidx##4: int;
  var node##6: DatatypeType;
  var key##1: Seq Box;
  var value##1: DatatypeType;
  var pos##0: int;
  var newnode##0: DatatypeType;
  var newchild##0: DatatypeType;

    // AddMethodImpl: InsertIndexChildNotFull, Impl$$KMBtree.__default.InsertIndexChildNotFull
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0
           || $o
             == $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref
           || read($Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(childidx#0))): ref, 
            KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1065,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1066,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1068,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#79;
        assume LitInt(0) <= i#79 && i#79 < 18446744073709551616;
        newtype$check#2 := LitInt(0);
        assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        if (LitInt(0) <= i#79)
        {
            assume {:subsumption 0} node#0 != null;
            assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        }

        assume true;
        assume LitInt(0) <= i#79
           && i#79
             < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1071,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0 := i#79;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##0, childidx##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1071,30)"} true;
        assume KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, 
            $Heap, 
            $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#79))): ref), 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
              i#79)): DatatypeType);
        assume false;
    }
    else
    {
        assume (forall i#80: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#80)): DatatypeType } 
            { $Unbox(read($Heap, 
                KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                IndexField(i#80))): ref } 
          LitInt(0) <= i#80
               && i#80 < 18446744073709551616
               && 
              LitInt(0) <= i#80
               && i#80
                 < KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuel_KMBtree._default.I, 
                $Heap, 
                $Unbox(read($Heap, 
                    KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
                    IndexField(i#80))): ref), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#80)): DatatypeType));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1072,4)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1074,27)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume true;
    // ProcessCallStmt: CheckSubrange
    assume $Is($Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      Tclass.KMBtree.Node());
    node##1 := $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := key#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := value#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == node##1 || read($Heap, node##1, KMBtree.Node.repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume 0 <= read(old($Heap), node#0, KMBtree.Node.height)
       || read($Heap, node##1, KMBtree.Node.height)
         == read(old($Heap), node#0, KMBtree.Node.height);
    assume 0 <= LitInt(0)
       || read($Heap, node##1, KMBtree.Node.height)
         < read(old($Heap), node#0, KMBtree.Node.height)
       || LitInt(2) == LitInt(0);
    assume read($Heap, node##1, KMBtree.Node.height)
         < read(old($Heap), node#0, KMBtree.Node.height)
       || (read($Heap, node##1, KMBtree.Node.height)
           == read(old($Heap), node#0, KMBtree.Node.height)
         && LitInt(2) < LitInt(0));
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.InsertNode(node##1, key##0, value##0);
    // TrCallStmt: After ProcessCallStmt
    oldvalue#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1074,72)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1075,5)
    ##node#14 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> Set#Equal(read(old($Heap), ##node#14, KMBtree.Node.repr), 
                Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#14)), 
                    $Box(KMBtree.NodeContents.keys(read(old($Heap), ##node#14, KMBtree.Node.contents)))), 
                  $Box(KMBtree.NodeContents.values(read(old($Heap), ##node#14, KMBtree.Node.contents)))))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueMessage.Message(), 
                KMBtree.NodeContents.keys(read(old($Heap), ##node#14, KMBtree.Node.contents)), 
                KMBtree.NodeContents.values(read(old($Heap), ##node#14, KMBtree.Node.contents)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> read(old($Heap), ##node#14, KMBtree.Node.height) == LitInt(0)));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> LitInt(0)
                 <= KMBtree.NodeContents.nkeys(read(old($Heap), ##node#14, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> KMBtree.NodeContents.nkeys(read(old($Heap), ##node#14, KMBtree.Node.contents))
                 <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
                 == _System.array.Length(KMBtree.NodeContents.keys(read(old($Heap), ##node#14, KMBtree.Node.contents)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> _System.array.Length(KMBtree.NodeContents.values(read(old($Heap), ##node#14, KMBtree.Node.contents)))
                 == _System.array.Length(KMBtree.NodeContents.keys(read(old($Heap), ##node#14, KMBtree.Node.contents)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#14)), 
                        $Box(KMBtree.NodeContents.pivots(read(old($Heap), ##node#14, KMBtree.Node.contents)))), 
                      $Box(children#10)), 
                    read(old($Heap), ##node#14, KMBtree.Node.repr))))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  0 < nchildren#10))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  nchildren#10 <= LitInt(KMBtree.__default.MaxChildren())))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#10)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  _System.array.Length(KMBtree.NodeContents.pivots(read(old($Heap), ##node#14, KMBtree.Node.contents)))
                     == LitInt(KMBtree.__default.MaxChildren() - 1)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  (forall i#81: int :: 
                    { $Unbox(read(old($Heap), children#10, IndexField(i#81))): ref } 
                    LitInt(0) <= i#81 && i#81 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#81 && i#81 < nchildren#10
                       ==> $Unbox(read(old($Heap), children#10, IndexField(i#81))): ref != null)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                    old($Heap), 
                    Seq#Take(Seq#FromArray(old($Heap), children#10), nchildren#10), 
                    read(old($Heap), ##node#14, KMBtree.Node.repr), 
                    read(old($Heap), ##node#14, KMBtree.Node.height))))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  (forall i#82: int :: 
                    { $Unbox(read(old($Heap), children#10, IndexField(i#82))): ref } 
                    LitInt(0) <= i#82 && i#82 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#82 && i#82 < nchildren#10
                       ==> !read(old($Heap), 
                        $Unbox(read(old($Heap), children#10, IndexField(i#82))): ref, 
                        KMBtree.Node.repr)[$Box(##node#14)])))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  (forall i#83: int :: 
                    { $Unbox(read(old($Heap), children#10, IndexField(i#83))): ref } 
                    LitInt(0) <= i#83 && i#83 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#83 && i#83 < nchildren#10
                       ==> !read(old($Heap), 
                        $Unbox(read(old($Heap), children#10, IndexField(i#83))): ref, 
                        KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(old($Heap), ##node#14, KMBtree.Node.contents)))])))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  (forall i#84: int :: 
                      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#10), nchildren#10), i#84)): ref } 
                        { $Unbox(read(old($Heap), children#10, IndexField(i#84))): ref } 
                      LitInt(0) <= i#84 && i#84 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#84 && i#84 < nchildren#10
                         ==> $Unbox(read(old($Heap), children#10, IndexField(i#84))): ref
                           == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#10), nchildren#10), i#84)): ref)
                     ==> Lit(true)))));
    assume {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtree.__default.WFShape#canCall(old($Heap), ##node#14)
           ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#14)
             || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#14, KMBtree.Node.contents))
               ==> (var nchildren#10 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                (var children#10 := KMBtree.NodeContents.children(read(old($Heap), ##node#14, KMBtree.Node.contents)); 
                  (forall i#84: int :: 
                      { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#10), nchildren#10), i#84)): ref } 
                        { $Unbox(read(old($Heap), children#10, IndexField(i#84))): ref } 
                      LitInt(0) <= i#84 && i#84 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#84 && i#84 < nchildren#10
                         ==> $Unbox(read(old($Heap), children#10, IndexField(i#84))): ref
                           == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#10), nchildren#10), i#84)): ref)
                     ==> (forall i#85: int :: 
                      { $Unbox(read(old($Heap), children#10, IndexField(i#85))): ref } 
                      LitInt(0) <= i#85 && i#85 < 18446744073709551616
                         ==> 
                        LitInt(0) <= i#85 && i#85 < nchildren#10
                         ==> !read(old($Heap), 
                          $Unbox(read(old($Heap), children#10, IndexField(i#85))): ref, 
                          KMBtree.Node.repr)[$Box(children#10)])))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> (forall i#86: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)), 
                      i#86)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#86
                     && i#86
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)), 
                        i#86)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> (forall i#87: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)), 
                      i#87)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#87
                     && i#87
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)), 
                          i#87)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> (forall i#88: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14), 
                    i#88) } 
                true
                   ==> 
                  LitInt(0) <= i#88
                     && i#88
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14), 
                    i#88))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#14)
       ==> KMBtree.__default.WF(old($Heap), ##node#14)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#14))
               ==> (forall i#89: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14), 
                    i#89) } 
                true
                   ==> 
                  0 < i#89
                     && i#89
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#14), 
                    i#89))));
    assume KMBtree.__default.Interpretation#canCall(old($Heap), node#0);
    ##m#1 := KMBtree.__default.Interpretation(old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#1, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#1 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#1, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
    assume $IsA#Options.Option(oldvalue#0)
       && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.__default.Interpretation(old($Heap), node#0), 
          $Box(key#0)))
       && 
      KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
       && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0));
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1075,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1076,15)
        // TrCallStmt: Before ProcessCallStmt
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.reveal__I();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1076,16)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1077,34)
        // TrCallStmt: Before ProcessCallStmt
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.reveal__Interpretation();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1077,35)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1078,27)
        // TrCallStmt: Before ProcessCallStmt
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.reveal__AllKeys();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1078,28)"} true;
        assume Options.Option#Equal(oldvalue#0, 
          Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.__default.Interpretation(old($Heap), node#0), 
            $Box(key#0)));
        assume false;
    }

    assume Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1080,15)
    assume node#0 != null;
    assume true;
    assume $_Frame[node#0, KMBtree.Node.repr];
    assume node#0 != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
    assume true;
    $rhs#0 := Set#Union(read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, 
        $Unbox(read($Heap, 
            KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): ref, 
        KMBtree.Node.repr));
    $Heap := update($Heap, node#0, KMBtree.Node.repr, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1080,66)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1082,44)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##2 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##1 := childidx#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.InsertIndexChildNotFullPreservesWFShape(old($Heap), $Heap, node##2, childidx##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1082,66)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1084,24)
    assume true;
    ##node#15 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#15);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    oldinode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1084,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1085,21)
    assume true;
    ##node#16 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#16, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#16);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    inode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1085,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1086,24)
    assume true;
    assume KMBtreeModel.Node.Index_q(oldinode#0);
    assume 0 <= childidx#0
       && childidx#0 < Seq#Length(KMBtreeModel.Node.children(oldinode#0));
    assume true;
    oldchild#0 := $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), childidx#0)): DatatypeType;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1086,53)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1087,24)
    assume true;
    assume KMBtreeModel.Node.Index_q(inode#0);
    assume 0 <= childidx#0 && childidx#0 < Seq#Length(KMBtreeModel.Node.children(inode#0));
    assume true;
    newchild#0 := $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), childidx#0)): DatatypeType;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1087,50)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1089,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#100;
        assume true;
        if (LitInt(0) <= i#100)
        {
        }

        assume true;
        assume LitInt(0) <= i#100 && i#100 < childidx#0;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1092,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##3 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##2 := i#100;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##3, childidx##2);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1092,23)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1093,7)
        assume {:subsumption 0} node#0 != null;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        ##contents#0 := read(old($Heap), node#0, KMBtree.Node.contents);
        ##i#0 := i#100;
        ##j#0 := childidx#0;
        assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
          Tclass.KMBtree.NodeContents(), 
          old($Heap));
        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#0);
        assume {:subsumption 0} LitInt(0) <= ##i#0;
        assume {:subsumption 0} ##i#0 < KMBtree.NodeContents.nchildren(##contents#0);
        assume {:subsumption 0} LitInt(0) <= ##j#0;
        assume {:subsumption 0} ##j#0 < KMBtree.NodeContents.nchildren(##contents#0);
        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#0)
           <= _System.array.Length(KMBtree.NodeContents.children(##contents#0));
        assume {:subsumption 0} (forall l#0: int :: 
          { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref } 
          LitInt(0) <= l#0 && l#0 < 18446744073709551616
             ==> 
            LitInt(0) <= l#0 && l#0 < KMBtree.NodeContents.nchildren(##contents#0)
             ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(l#0))): ref
               != null);
        assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#0), IndexField(##j#0))): ref
           != null;
        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#100, childidx#0);
        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#100, childidx#0);
        assume true;
        assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), i#100, childidx#0);
        assume KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#100)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), i#100)): DatatypeType);
        assume false;
    }
    else
    {
        assume (forall i#101: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), i#101)): DatatypeType } 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#101)): DatatypeType } 
          LitInt(0) <= i#101 && i#101 < childidx#0
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#101)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), i#101)): DatatypeType));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1094,4)"} true;
    // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1095,5)
    if (*)
    {
        // Assume Fuel Constant
        havoc i#102;
        assume true;
        if (childidx#0 < i#102)
        {
            assume KMBtreeModel.Node.Index_q(inode#0);
        }

        assume true;
        assume childidx#0 < i#102 && i#102 < Seq#Length(KMBtreeModel.Node.children(inode#0));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1098,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##4 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##3 := i#102;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.IOfChild(node##4, childidx##3);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1098,23)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1099,7)
        assume {:subsumption 0} node#0 != null;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        ##contents#1 := read(old($Heap), node#0, KMBtree.Node.contents);
        ##i#1 := childidx#0;
        ##j#1 := i#102;
        assume $IsAlloc(read(old($Heap), node#0, KMBtree.Node.contents), 
          Tclass.KMBtree.NodeContents(), 
          old($Heap));
        assume {:subsumption 0} KMBtree.NodeContents.Index_q(##contents#1);
        assume {:subsumption 0} LitInt(0) <= ##i#1;
        assume {:subsumption 0} ##i#1 < KMBtree.NodeContents.nchildren(##contents#1);
        assume {:subsumption 0} LitInt(0) <= ##j#1;
        assume {:subsumption 0} ##j#1 < KMBtree.NodeContents.nchildren(##contents#1);
        assume {:subsumption 0} KMBtree.NodeContents.nchildren(##contents#1)
           <= _System.array.Length(KMBtree.NodeContents.children(##contents#1));
        assume {:subsumption 0} (forall l#1: int :: 
          { $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(l#1))): ref } 
          LitInt(0) <= l#1 && l#1 < 18446744073709551616
             ==> 
            LitInt(0) <= l#1 && l#1 < KMBtree.NodeContents.nchildren(##contents#1)
             ==> $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(l#1))): ref
               != null);
        assume {:subsumption 0} $Unbox(read(old($Heap), KMBtree.NodeContents.children(##contents#1), IndexField(##j#1))): ref
           != null;
        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#102);
        assume KMBtree.__default.DisjointSubtrees#canCall(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#102);
        assume true;
        assume KMBtree.__default.DisjointSubtrees(old($Heap), read(old($Heap), node#0, KMBtree.Node.contents), childidx#0, i#102);
        assume KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#102)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), i#102)): DatatypeType);
        assume false;
    }
    else
    {
        assume (forall i#103: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), i#103)): DatatypeType } 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#103)): DatatypeType } 
          childidx#0 < i#103 && i#103 < Seq#Length(KMBtreeModel.Node.children(inode#0))
             ==> KMBtreeModel.Node#Equal($Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), i#103)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(oldinode#0), i#103)): DatatypeType));
    }

    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1100,4)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1102,13)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##5 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##4 := childidx#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.IOfChild(node##5, childidx##4);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1102,35)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1103,35)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##6 := oldinode#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##1 := key#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##1 := value#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    pos##0 := childidx#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    newnode##0 := inode#0;
    assume KMBtreeModel.Node.Index_q(inode#0);
    assume 0 <= childidx#0 && childidx#0 < Seq#Length(KMBtreeModel.Node.children(inode#0));
    assume true;
    // ProcessCallStmt: CheckSubrange
    newchild##0 := $Unbox(Seq#Index(KMBtreeModel.Node.children(inode#0), childidx#0)): DatatypeType;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.RecursiveInsertIsCorrect(node##6, key##1, value##1, pos##0, newnode##0, newchild##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1103,106)"} true;
}



procedure CheckWellformed$$KMBtree.__default.InsertIndexSelectAndPrepareChild(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616);
  free requires 57 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.InsertIndexSelectAndPrepareChild(node#0: ref, key#0: Seq Box) returns (childidx#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: ref;
  var ##node#4: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##run#0: Seq Box;
  var ##needle#0: Seq Box;
  var ##node#5: ref;
  var ##node#6: ref;
  var ##node#7: DatatypeType;
  var ##node#8: ref;
  var ##node#9: DatatypeType;
  var ##node#10: ref;
  var ##node#11: DatatypeType;
  var ##node#12: ref;
  var ##node#13: DatatypeType;

    // AddMethodImpl: InsertIndexSelectAndPrepareChild, CheckWellformed$$KMBtree.__default.InsertIndexSelectAndPrepareChild
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0 || read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1106,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, node#0);
    assume !KMBtree.__default.Full($Heap, node#0);
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == node#0
           || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc childidx#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1110,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#4 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume 0
         <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
         <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
    ##run#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
    ##needle#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assert {:subsumption 0} Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, ##run#0);
    assume Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, ##run#0);
    assume Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
      key#0);
    assume childidx#0
       == Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
          key#0)
         + 1;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Is($Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      Tclass.KMBtree.Node());
    ##node#5 := $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
    assume !KMBtree.__default.Full($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
    ##node#6 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#7 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#7))
             == Seq#Length(KMBtreeModel.Node.values(##node#7)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#7)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#7))
             == Seq#Length(KMBtreeModel.Node.children(##node#7)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#7)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#10: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#10)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#10 && i#10 < Seq#Length(KMBtreeModel.Node.children(##node#7))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#10)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#11: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#11)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#11 && i#11 < Seq#Length(KMBtreeModel.Node.children(##node#7))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#11)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#12: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#7, i#12) } 
            true
               ==> 
              LitInt(0) <= i#12 && i#12 < Seq#Length(KMBtreeModel.Node.children(##node#7)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#7, i#12)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#13: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#7, i#13) } 
            true
               ==> 
              0 < i#13 && i#13 < Seq#Length(KMBtreeModel.Node.children(##node#7))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#7, i#13)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#7);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#8 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#9 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#9))
             == Seq#Length(KMBtreeModel.Node.values(##node#9)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#9)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#9))
             == Seq#Length(KMBtreeModel.Node.children(##node#9)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#9)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#19: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#19)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(##node#9))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#19)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#20: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#20)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#20 && i#20 < Seq#Length(KMBtreeModel.Node.children(##node#9))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#20)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#21: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#9, i#21) } 
            true
               ==> 
              LitInt(0) <= i#21 && i#21 < Seq#Length(KMBtreeModel.Node.children(##node#9)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#9, i#21)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#22: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#9, i#22) } 
            true
               ==> 
              0 < i#22 && i#22 < Seq#Length(KMBtreeModel.Node.children(##node#9))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#9, i#22)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#9);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Map#Equal(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)));
    ##node#10 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#10, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#10);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#11 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#11, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#12 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#12);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#13 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#13, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)));
}



procedure Call$$KMBtree.__default.InsertIndexSelectAndPrepareChild(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616);
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#5)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#5))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#5 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#33: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#33))): ref } 
                  LitInt(0) <= i#33 && i#33 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#33 && i#33 < nchildren#5
                     ==> $Unbox(read($Heap, children#5, IndexField(i#33))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#34: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#34))): ref } 
                  LitInt(0) <= i#34 && i#34 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#34 && i#34 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#34))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#35: int :: 
                  { $Unbox(read($Heap, children#5, IndexField(i#35))): ref } 
                  LitInt(0) <= i#35 && i#35 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#35 && i#35 < nchildren#5
                     ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#35))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#36: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref } 
                      { $Unbox(read($Heap, children#5, IndexField(i#36))): ref } 
                    LitInt(0) <= i#36 && i#36 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#36 && i#36 < nchildren#5
                       ==> $Unbox(read($Heap, children#5, IndexField(i#36))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#5 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#36: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref } 
                      { $Unbox(read($Heap, children#5, IndexField(i#36))): ref } 
                    LitInt(0) <= i#36 && i#36 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#36 && i#36 < nchildren#5
                       ==> $Unbox(read($Heap, children#5, IndexField(i#36))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref)
                   ==> (forall i#37: int :: 
                    { $Unbox(read($Heap, children#5, IndexField(i#37))): ref } 
                    LitInt(0) <= i#37 && i#37 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#37 && i#37 < nchildren#5
                       ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#37))): ref, KMBtree.Node.repr)[$Box(children#5)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#38: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#38)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#38
                   && i#38
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#38)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#39: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#39)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#39
                   && i#39
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#39)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#40: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#40) } 
              true
                 ==> 
                LitInt(0) <= i#40
                   && i#40
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#40))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#41: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#41) } 
              true
                 ==> 
                0 < i#41
                   && i#41
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#41))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#6
                 && nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#42: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                  LitInt(0) <= i#42 && i#42 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#42 && i#42 < nchildren#6
                     ==> $Unbox(read($Heap, children#6, IndexField(i#42))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#43: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#43))): ref } 
                  LitInt(0) <= i#43 && i#43 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#43 && i#43 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#43))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#44: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#44))): ref } 
                  LitInt(0) <= i#44 && i#44 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#44 && i#44 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#46: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#46))): ref } 
                  LitInt(0) <= i#46 && i#46 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#46 && i#46 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#46))): ref, KMBtree.Node.repr)[$Box(children#6)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && (forall i#47: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#47)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#47
               && i#47
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#47)): DatatypeType))
         && (forall i#48: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#48)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#48
               && i#48
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                    i#48)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#49: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#49) } 
          true
             ==> 
            LitInt(0) <= i#49
               && i#49
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#49))
         && (forall i#50: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#50) } 
          true
             ==> 
            0 < i#50
               && i#50
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#50)));
  free ensures true;
  ensures KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
    key#0);
  ensures childidx#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), 
        Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
        key#0)
       + 1;
  free ensures true;
  ensures $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref
     != null;
  free ensures KMBtree.__default.Full#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  ensures !KMBtree.__default.Full($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.InsertIndexSelectAndPrepareChild(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (childidx#0: int
       where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 57 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#8)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#8)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#8 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#60: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#60))): ref } 
              LitInt(0) <= i#60 && i#60 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#60 && i#60 < nchildren#8
                 ==> $Unbox(read($Heap, children#8, IndexField(i#60))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#61: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#61))): ref } 
              LitInt(0) <= i#61 && i#61 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#61 && i#61 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#61))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#62: int :: 
              { $Unbox(read($Heap, children#8, IndexField(i#62))): ref } 
              LitInt(0) <= i#62 && i#62 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#62 && i#62 < nchildren#8
                 ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#62))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#63: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#63)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#63))): ref } 
                LitInt(0) <= i#63 && i#63 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#63 && i#63 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#63))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#63)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#8 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#63: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#63)): ref } 
                  { $Unbox(read($Heap, children#8, IndexField(i#63))): ref } 
                LitInt(0) <= i#63 && i#63 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#63 && i#63 < nchildren#8
                   ==> $Unbox(read($Heap, children#8, IndexField(i#63))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#8), nchildren#8), i#63)): ref)
               ==> (forall i#64: int :: 
                { $Unbox(read($Heap, children#8, IndexField(i#64))): ref } 
                LitInt(0) <= i#64 && i#64 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#64 && i#64 < nchildren#8
                   ==> !read($Heap, $Unbox(read($Heap, children#8, IndexField(i#64))): ref, KMBtree.Node.repr)[$Box(children#8)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             - 1);
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#65: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#65)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#65
               && i#65
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                  i#65)): DatatypeType)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#66: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#66)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#66
               && i#66
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#66)): DatatypeType), 
              Set#Empty(): Set Box)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#67: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#67) } 
          true
             ==> 
            LitInt(0) <= i#67
               && i#67
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#67)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#68: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#68) } 
          true
             ==> 
            0 < i#68
               && i#68
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#68)));
  free ensures true;
  ensures $_reverifyPost
     ==> KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  free ensures Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
    key#0);
  ensures $_reverifyPost
     ==> childidx#0
       == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), 
          Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
            KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1), 
          key#0)
         + 1;
  free ensures true;
  ensures $_reverifyPost
     ==> $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref
       != null;
  free ensures KMBtree.__default.Full#canCall($Heap, 
    $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref);
  ensures $_reverifyPost
     ==> !KMBtree.__default.Full($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.InsertIndexSelectAndPrepareChild(node#0: ref, key#0: Seq Box) returns (childidx#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var run##0: ref;
  var start##0: int;
  var newtype$check#2: int;
  var end##0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var needle##0: Seq Box;
  var ##node#14: ref;
  var oldpivots#0_0: Seq Box
     where $Is(oldpivots#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(oldpivots#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var node##0_0: ref;
  var childidx##0_0: int;
  var newpivots#0_0: Seq Box
     where $Is(newpivots#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(newpivots#0_0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var oldindex##0_0: DatatypeType;
  var ##node#0_0: ref;
  var newindex##0_0: DatatypeType;
  var ##node#0_1: ref;
  var childidx##0_1: int;
  var oldindex##0_1: DatatypeType;
  var ##node#0_2: ref;
  var newindex##0_1: DatatypeType;
  var ##node#0_3: ref;
  var childidx##0_2: int;
  var oldindex##0_2: DatatypeType;
  var ##node#0_4: ref;
  var newindex##0_2: DatatypeType;
  var ##node#0_5: ref;
  var childidx##0_3: int;
  var t#0_0: int where LitInt(0 - 2147483648) <= t#0_0 && t#0_0 < 2147483648;
  var $rhs##0_0: int
     where LitInt(0 - 2147483648) <= $rhs##0_0 && $rhs##0_0 < 2147483648;
  var a##0_0: Seq Box;
  var b##0_0: Seq Box;
  var newtype$check#0_4: int;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var i#0_0_0: int;
  var run##0_0: Seq Box;
  var newtype$check#0_5: int;
  var newtype$check#0_6: int;
  var needle##0_0: Seq Box;
  var pos##0_0: int;

    // AddMethodImpl: InsertIndexSelectAndPrepareChild, Impl$$KMBtree.__default.InsertIndexSelectAndPrepareChild
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0 || read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1121,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1122,25)
    // TrCallStmt: Before ProcessCallStmt
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call Call$$KMBtreeModel.__default.reveal__AllKeys();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1122,26)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1123,5)
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume {:subsumption 0} 0 <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
       && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume {:subsumption 0} node#0 != null;
    assume {:subsumption 0} node#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
      KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, node#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, node#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))), 
        KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents))), 
      read($Heap, node#0, KMBtree.Node.repr), 
      read($Heap, node#0, KMBtree.Node.height));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1125,52)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume true;
    // ProcessCallStmt: CheckSubrange
    run##0 := KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    start##0 := LitInt(0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    newtype$check#3 := LitInt(1);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    newtype$check#4 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    end##0 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
    assume true;
    // ProcessCallStmt: CheckSubrange
    needle##0 := key#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$Lexicographic__Byte__Order__Impl.__default.ArrayLargestLtePlus1(run##0, start##0, end##0, needle##0);
    // TrCallStmt: After ProcessCallStmt
    childidx#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1125,108)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1126,5)
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents))
       != null;
    assume 0 <= childidx#0
       && childidx#0
         < _System.array.Length(KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)));
    assume $Is($Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref, 
      Tclass.KMBtree.Node());
    ##node#14 := $Unbox(read($Heap, 
        KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
        IndexField(childidx#0))): ref;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#14, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
    assume KMBtree.__default.Full#canCall($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref);
    if (KMBtree.__default.Full($Heap, 
      $Unbox(read($Heap, 
          KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)), 
          IndexField(childidx#0))): ref))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1127,27)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#0_0 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
        assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume 0
             <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
           && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
             <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        oldpivots#0_0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1127,78)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1128,24)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0_0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0_0 := childidx#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && (
                $o == node##0_0
                 || $o == KMBtree.NodeContents.pivots(read($Heap, node##0_0, KMBtree.Node.contents))
                 || $o
                   == KMBtree.NodeContents.children(read($Heap, node##0_0, KMBtree.Node.contents))
                 || $o
                   == $Unbox(read($Heap, 
                      KMBtree.NodeContents.children(read($Heap, node##0_0, KMBtree.Node.contents)), 
                      IndexField(childidx##0_0))): ref)
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.SplitChildOfIndex(node##0_0, childidx##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1128,39)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1129,27)
        assume true;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#0_2 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        newtype$check#0_3 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
        assume LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assume 0
             <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
           && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
             <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        newpivots#0_0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1129,78)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1130,41)
        // TrCallStmt: Before ProcessCallStmt
        ##node#0_0 := node#0;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#0_0);
        assume KMBtree.__default.I#canCall(old($Heap), node#0);
        assume KMBtree.__default.I#canCall(old($Heap), node#0);
        // ProcessCallStmt: CheckSubrange
        oldindex##0_0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
        ##node#0_1 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_1, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_1);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        newindex##0_0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0_1 := childidx#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.SplitChildOfIndexPreservesWF(oldindex##0_0, newindex##0_0, childidx##0_1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1130,80)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1131,53)
        // TrCallStmt: Before ProcessCallStmt
        ##node#0_2 := node#0;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#0_2);
        assume KMBtree.__default.I#canCall(old($Heap), node#0);
        assume KMBtree.__default.I#canCall(old($Heap), node#0);
        // ProcessCallStmt: CheckSubrange
        oldindex##0_1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
        ##node#0_3 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_3, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_3);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        newindex##0_1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0_2 := childidx#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.SplitChildOfIndexPreservesInterpretation(oldindex##0_1, newindex##0_1, childidx##0_2);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1131,92)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1132,46)
        // TrCallStmt: Before ProcessCallStmt
        ##node#0_4 := node#0;
        assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#0_4);
        assume KMBtree.__default.I#canCall(old($Heap), node#0);
        assume KMBtree.__default.I#canCall(old($Heap), node#0);
        // ProcessCallStmt: CheckSubrange
        oldindex##0_2 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
        ##node#0_5 := node#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_5, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_5);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        assume KMBtree.__default.I#canCall($Heap, node#0);
        // ProcessCallStmt: CheckSubrange
        newindex##0_2 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        childidx##0_3 := childidx#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.SplitChildOfIndexPreservesAllKeys(oldindex##0_2, newindex##0_2, childidx##0_3);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1132,85)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1134,41)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type int32
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume 0 <= childidx#0
           && childidx#0
             < _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := $Unbox(read($Heap, 
            KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)), 
            IndexField(childidx#0))): Seq Box;
        assume true;
        // ProcessCallStmt: CheckSubrange
        b##0_0 := key#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call $rhs##0_0 := Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a##0_0, b##0_0);
        // TrCallStmt: After ProcessCallStmt
        t#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1134,77)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1135,7)
        newtype$check#0_4 := LitInt(0);
        assume LitInt(0 - 2147483648) <= newtype$check#0_4 && newtype$check#0_4 < 2147483648;
        assume true;
        if (t#0_0 <= LitInt(0))
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1136,18)
            assume true;
            newtype$check#0_0_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
            newtype$check#0_0_1 := childidx#0 + 1;
            assume LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
            assume true;
            childidx#0 := childidx#0 + 1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1136,32)"} true;
            // ----- forall statement (proof) ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1137,9)
            if (*)
            {
                // Assume Fuel Constant
                havoc i#0_0_0;
                assume true;
                if (childidx#0 - 1 < i#0_0_0)
                {
                }

                assume true;
                assume childidx#0 - 1 < i#0_0_0 && i#0_0_0 < Seq#Length(newpivots#0_0);
                // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1140,11)
                assume {:subsumption 0} 0 <= i#0_0_0 && i#0_0_0 < Seq#Length(newpivots#0_0);
                assume {:subsumption 0} 0 <= i#0_0_0 - 1 && i#0_0_0 - 1 < Seq#Length(oldpivots#0_0);
                assume true;
                assume Seq#Equal($Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box, 
                  $Unbox(Seq#Index(oldpivots#0_0, i#0_0_0 - 1)): Seq Box);
                assert Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)
                     || (Lexicographic__Byte__Order.__default.lte#canCall(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)
                       ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)
                         || (Lit(true)
                           ==> 
                          Lit(true)
                           ==> 
                          Lit(true)
                           ==> SeqComparison.__default.lte(StartFuelAssert_SeqComparison._default.lte, 
                            key#0, 
                            $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)));
                assert Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)
                   ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box)
                     || !Seq#Equal(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_0)): Seq Box);
                assume false;
            }
            else
            {
                assume (forall i#0_0_1: int :: 
                  { $Unbox(Seq#Index(newpivots#0_0, i#0_0_1)): Seq Box } 
                  childidx#0 - 1 < i#0_0_1 && i#0_0_1 < Seq#Length(newpivots#0_0)
                     ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(newpivots#0_0, i#0_0_1)): Seq Box));
            }

            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1141,8)"} true;
        }
        else
        {
        }

        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1143,36)
        // TrCallStmt: Before ProcessCallStmt
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        assume KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)) != null;
        assume node#0 != null;
        assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
        newtype$check#0_5 := LitInt(1);
        assume LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        newtype$check#0_6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1;
        assume LitInt(0) <= newtype$check#0_6 && newtype$check#0_6 < 18446744073709551616;
        assume 0
             <= KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
           && KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1
             <= _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)));
        assume true;
        // ProcessCallStmt: CheckSubrange
        run##0_0 := Seq#Take(Seq#FromArray($Heap, KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents))), 
          KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)) - 1);
        assume true;
        // ProcessCallStmt: CheckSubrange
        needle##0_0 := key#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        pos##0_0 := childidx#0 - 1;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$Lexicographic__Byte__Order.__default.LargestLteIsUnique(run##0_0, needle##0_0, pos##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1143,112)"} true;
    }
    else
    {
    }
}



procedure CheckWellformed$$KMBtree.__default.InsertIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 58 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.InsertIndex(node#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: ref;
  var ##node#4: DatatypeType;
  var ##node#5: ref;
  var ##node#6: DatatypeType;
  var ##node#7: ref;
  var ##node#8: DatatypeType;
  var ##node#9: ref;
  var ##node#10: DatatypeType;
  var ##node#11: ref;
  var ##node#12: DatatypeType;
  var ##node#13: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: InsertIndex, CheckWellformed$$KMBtree.__default.InsertIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0 || read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1147,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    assume node#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, node#0);
    assume !KMBtree.__default.Full($Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == node#0
           || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldvalue#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1151,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#4 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#5 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#5);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#6 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#6))
             == Seq#Length(KMBtreeModel.Node.values(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#6))
             == Seq#Length(KMBtreeModel.Node.children(##node#6)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#10: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#10)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#10 && i#10 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#10)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#11: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#11)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#11 && i#11 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#11)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#12: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#6, i#12) } 
            true
               ==> 
              LitInt(0) <= i#12 && i#12 < Seq#Length(KMBtreeModel.Node.children(##node#6)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#6, i#12)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#13: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#6, i#13) } 
            true
               ==> 
              0 < i#13 && i#13 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#6, i#13)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#6);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#7 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#7);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#8 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#8, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#8))
             == Seq#Length(KMBtreeModel.Node.values(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#8))
             == Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#19: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#19)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#19)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#20: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#20)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#20 && i#20 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#20)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#21: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#21) } 
            true
               ==> 
              LitInt(0) <= i#21 && i#21 < Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#21)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#22: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#22) } 
            true
               ==> 
              0 < i#22 && i#22 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#22)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#8);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Map#Equal(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
    ##node#9 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#9);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#10 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#10, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#11 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#11);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#12 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#12, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Set#Subset(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
    ##node#13 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#38: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                      i#38)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#38
                     && i#38
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                        i#38)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#39: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                      i#39)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#39
                     && i#39
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                          i#39)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#40: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#40) } 
                true
                   ==> 
                  LitInt(0) <= i#40
                     && i#40
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#40))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#41: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#41) } 
                true
                   ==> 
                  0 < i#41
                     && i#41
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#41))));
    assume KMBtree.__default.WF(old($Heap), ##node#13);
    assume KMBtree.__default.Interpretation#canCall(old($Heap), node#0);
    ##m#0 := KMBtree.__default.Interpretation(old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
    assume Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
}



procedure Call$$KMBtree.__default.InsertIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#6))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#42: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                  LitInt(0) <= i#42 && i#42 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#42 && i#42 < nchildren#6
                     ==> $Unbox(read($Heap, children#6, IndexField(i#42))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#43: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#43))): ref } 
                  LitInt(0) <= i#43 && i#43 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#43 && i#43 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#43))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#44: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#44))): ref } 
                  LitInt(0) <= i#44 && i#44 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#44 && i#44 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#45: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#45))): ref } 
                    LitInt(0) <= i#45 && i#45 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#45 && i#45 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#45))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#45: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#45))): ref } 
                    LitInt(0) <= i#45 && i#45 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#45 && i#45 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#45))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref)
                   ==> (forall i#46: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#46))): ref } 
                    LitInt(0) <= i#46 && i#46 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#46 && i#46 < nchildren#6
                       ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#46))): ref, KMBtree.Node.repr)[$Box(children#6)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#47: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#47)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#47
                   && i#47
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#47)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#48: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#48)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#48
                   && i#48
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#48)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#49: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#49) } 
              true
                 ==> 
                LitInt(0) <= i#49
                   && i#49
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#49))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#50: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#50) } 
              true
                 ==> 
                0 < i#50
                   && i#50
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#50))));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#7)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#7
                 && nchildren#7 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#51: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#51))): ref } 
                  LitInt(0) <= i#51 && i#51 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#51 && i#51 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#51))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#52: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#52))): ref } 
                  LitInt(0) <= i#52 && i#52 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#52 && i#52 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#53: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#53))): ref } 
                  LitInt(0) <= i#53 && i#53 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#53 && i#53 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#53))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#55: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#55))): ref } 
                  LitInt(0) <= i#55 && i#55 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#55 && i#55 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && (forall i#56: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#56)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#56
               && i#56
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#56)): DatatypeType))
         && (forall i#57: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#57)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#57
               && i#57
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                    i#57)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#58: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#58) } 
          true
             ==> 
            LitInt(0) <= i#58
               && i#58
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#58))
         && (forall i#59: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#59) } 
          true
             ==> 
            0 < i#59
               && i#59
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#59)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      $Box(key#0), 
      $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures Options.Option#Equal(oldvalue#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.InsertIndex(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 58 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.NodeContents.Index_q(read($Heap, node#0, KMBtree.Node.contents));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#9)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#9)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#9 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#9))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#69: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#69))): ref } 
              LitInt(0) <= i#69 && i#69 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#69 && i#69 < nchildren#9
                 ==> $Unbox(read($Heap, children#9, IndexField(i#69))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#70: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#70))): ref } 
              LitInt(0) <= i#70 && i#70 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#70 && i#70 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#70))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#71: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#71))): ref } 
              LitInt(0) <= i#71 && i#71 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#71 && i#71 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#71))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#72: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#72))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#72: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#72))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref)
               ==> (forall i#73: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#73))): ref } 
                LitInt(0) <= i#73 && i#73 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#73 && i#73 < nchildren#9
                   ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#73))): ref, KMBtree.Node.repr)[$Box(children#9)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             - 1);
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#74: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#74)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#74
               && i#74
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                  i#74)): DatatypeType)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#75: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#75)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#75
               && i#75
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#75)): DatatypeType), 
              Set#Empty(): Set Box)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#76: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#76) } 
          true
             ==> 
            LitInt(0) <= i#76
               && i#76
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#76)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#77: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#77) } 
          true
             ==> 
            0 < i#77
               && i#77
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#77)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.InsertIndex(node#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var childidx#0: int
     where LitInt(0) <= childidx#0 && childidx#0 < 18446744073709551616;
  var $rhs##0: int where LitInt(0) <= $rhs##0 && $rhs##0 < 18446744073709551616;
  var node##0: ref;
  var key##0: Seq Box;
  var $rhs##1: DatatypeType
     where $Is($rhs##1, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##1, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##1: ref;
  var childidx##0: int;
  var key##1: Seq Box;
  var value##0: DatatypeType;

    // AddMethodImpl: InsertIndex, Impl$$KMBtree.__default.InsertIndex
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0 || read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1160,2): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1161,61)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type uint64
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := key#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == node##0 || read($Heap, node##0, KMBtree.Node.repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.InsertIndexSelectAndPrepareChild(node##0, key##0);
    // TrCallStmt: After ProcessCallStmt
    childidx#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1161,71)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1162,40)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##1 := node#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##0 := childidx#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##1 := key#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := value#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && (
            $o == node##1
             || $o
               == $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node##1, KMBtree.Node.contents)), 
                  IndexField(childidx##0))): ref
             || read($Heap, 
              $Unbox(read($Heap, 
                  KMBtree.NodeContents.children(read($Heap, node##1, KMBtree.Node.contents)), 
                  IndexField(childidx##0))): ref, 
              KMBtree.Node.repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume 0 <= read(old($Heap), node#0, KMBtree.Node.height)
       || read($Heap, node##1, KMBtree.Node.height)
         == read(old($Heap), node#0, KMBtree.Node.height);
    assume 0 <= LitInt(1)
       || read($Heap, node##1, KMBtree.Node.height)
         < read(old($Heap), node#0, KMBtree.Node.height)
       || LitInt(0) == LitInt(1);
    assume read($Heap, node##1, KMBtree.Node.height)
         < read(old($Heap), node#0, KMBtree.Node.height)
       || (read($Heap, node##1, KMBtree.Node.height)
           == read(old($Heap), node#0, KMBtree.Node.height)
         && LitInt(0) < LitInt(1));
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$KMBtree.__default.InsertIndexChildNotFull(node##1, childidx##0, key##1, value##0);
    // TrCallStmt: After ProcessCallStmt
    oldvalue#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1162,67)"} true;
}



procedure CheckWellformed$$KMBtree.__default.InsertNode(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 58 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.InsertNode(node#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: ref;
  var ##node#4: DatatypeType;
  var ##node#5: ref;
  var ##node#6: DatatypeType;
  var ##node#7: ref;
  var ##node#8: DatatypeType;
  var ##node#9: ref;
  var ##node#10: DatatypeType;
  var ##node#11: ref;
  var ##node#12: DatatypeType;
  var ##node#13: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: InsertNode, CheckWellformed$$KMBtree.__default.InsertNode
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0 || read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1165,9): initial state"} true;
    ##node#0 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, node#0);
    assume KMBtree.__default.WF($Heap, node#0);
    ##node#1 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, node#0);
    assume !KMBtree.__default.Full($Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          $o == node#0
           || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldvalue#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1168,19): post-state"} true;
    ##node#2 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WFShape#canCall($Heap, node#0);
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, node#0);
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assume node#0 != null;
    assume node#0 != null;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
    ##node#3 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#3, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#3);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#4 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    assume KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#5 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#5);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#6 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#6))
             == Seq#Length(KMBtreeModel.Node.values(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#6))
             == Seq#Length(KMBtreeModel.Node.children(##node#6)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#6)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#10: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#10)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#10 && i#10 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#10)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#11: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#11)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#11 && i#11 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#6), i#11)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#12: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#6, i#12) } 
            true
               ==> 
              LitInt(0) <= i#12 && i#12 < Seq#Length(KMBtreeModel.Node.children(##node#6)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#6, i#12)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#6)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#6)
         || (!KMBtreeModel.Node.Leaf_q(##node#6)
           ==> (forall i#13: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#6, i#13) } 
            true
               ==> 
              0 < i#13 && i#13 < Seq#Length(KMBtreeModel.Node.children(##node#6))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#6, i#13)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#6);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#7 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#7);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#8 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#8, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#8))
             == Seq#Length(KMBtreeModel.Node.values(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#8))
             == Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#8)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#19: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#19)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#19)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#20: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#20)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#20 && i#20 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#8), i#20)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#21: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#21) } 
            true
               ==> 
              LitInt(0) <= i#21 && i#21 < Seq#Length(KMBtreeModel.Node.children(##node#8)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#8, i#21)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#8)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#8)
         || (!KMBtreeModel.Node.Leaf_q(##node#8)
           ==> (forall i#22: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#22) } 
            true
               ==> 
              0 < i#22 && i#22 < Seq#Length(KMBtreeModel.Node.children(##node#8))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#8, i#22)));
    assume KMBtreeModel.__default.WF($LS($LZ), ##node#8);
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Map#Equal(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
    ##node#9 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#9);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    ##node#10 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#10, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
    ##node#11 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#11);
    assume KMBtree.__default.I#canCall(old($Heap), node#0);
    ##node#12 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#12, Tclass.KMBtreeModel.Node(), $Heap);
    assume KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
    assume Set#Subset(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
    ##node#13 := node#0;
    assume $IsAlloc(node#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#38: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                      i#38)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#38
                     && i#38
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                        i#38)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#39: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                      i#39)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#39
                     && i#39
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)), 
                          i#39)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#40: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#40) } 
                true
                   ==> 
                  LitInt(0) <= i#40
                     && i#40
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#40))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#13)
       ==> KMBtree.__default.WF(old($Heap), ##node#13)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#13))
               ==> (forall i#41: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#41) } 
                true
                   ==> 
                  0 < i#41
                     && i#41
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#13), 
                    i#41))));
    assume KMBtree.__default.WF(old($Heap), ##node#13);
    assume KMBtree.__default.Interpretation#canCall(old($Heap), node#0);
    ##m#0 := KMBtree.__default.Interpretation(old($Heap), node#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
    assume Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
}



procedure Call$$KMBtree.__default.InsertNode(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#6))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#42: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#42))): ref } 
                  LitInt(0) <= i#42 && i#42 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#42 && i#42 < nchildren#6
                     ==> $Unbox(read($Heap, children#6, IndexField(i#42))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#43: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#43))): ref } 
                  LitInt(0) <= i#43 && i#43 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#43 && i#43 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#43))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#44: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#44))): ref } 
                  LitInt(0) <= i#44 && i#44 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#44 && i#44 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#44))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#45: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#45))): ref } 
                    LitInt(0) <= i#45 && i#45 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#45 && i#45 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#45))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#45: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#45))): ref } 
                    LitInt(0) <= i#45 && i#45 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#45 && i#45 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#45))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#45)): ref)
                   ==> (forall i#46: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#46))): ref } 
                    LitInt(0) <= i#46 && i#46 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#46 && i#46 < nchildren#6
                       ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#46))): ref, KMBtree.Node.repr)[$Box(children#6)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#47: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#47)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#47
                   && i#47
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#47)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#48: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#48)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#48
                   && i#48
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#48)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#49: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#49) } 
              true
                 ==> 
                LitInt(0) <= i#49
                   && i#49
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#49))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#50: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#50) } 
              true
                 ==> 
                0 < i#50
                   && i#50
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#50))));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
         && read($Heap, node#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          true
             && (var children#7 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#7)), 
                  read($Heap, node#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#7
                 && nchildren#7 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#51: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#51))): ref } 
                  LitInt(0) <= i#51 && i#51 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#51 && i#51 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#51))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))
                 && (forall i#52: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#52))): ref } 
                  LitInt(0) <= i#52 && i#52 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#52 && i#52 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#52))): ref, KMBtree.Node.repr)[$Box(node#0)])
                 && (forall i#53: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#53))): ref } 
                  LitInt(0) <= i#53 && i#53 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#53 && i#53 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#53))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#55: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#55))): ref } 
                  LitInt(0) <= i#55 && i#55 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#55 && i#55 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, node#0, KMBtree.Node.height)
     == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
         && (forall i#56: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#56)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#56
               && i#56
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                  i#56)): DatatypeType))
         && (forall i#57: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                i#57)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#57
               && i#57
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)), 
                    i#57)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#58: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#58) } 
          true
             ==> 
            LitInt(0) <= i#58
               && i#58
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#58))
         && (forall i#59: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#59) } 
          true
             ==> 
            0 < i#59
               && i#59
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0), i#59)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      $Box(key#0), 
      $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures Options.Option#Equal(oldvalue#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.InsertNode(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 58 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires !KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, node#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(children#9)), 
              read($Heap, node#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            0 < nchildren#9)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            nchildren#9 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#9))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#69: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#69))): ref } 
              LitInt(0) <= i#69 && i#69 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#69 && i#69 < nchildren#9
                 ==> $Unbox(read($Heap, children#9, IndexField(i#69))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), 
              read($Heap, node#0, KMBtree.Node.repr), 
              read($Heap, node#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#70: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#70))): ref } 
              LitInt(0) <= i#70 && i#70 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#70 && i#70 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#70))): ref, KMBtree.Node.repr)[$Box(node#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#71: int :: 
              { $Unbox(read($Heap, children#9, IndexField(i#71))): ref } 
              LitInt(0) <= i#71 && i#71 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#71 && i#71 < nchildren#9
                 ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#71))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#72: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#72))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, node#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
         ==> (var nchildren#9 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
          (var children#9 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
            (forall i#72: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref } 
                  { $Unbox(read($Heap, children#9, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#9
                   ==> $Unbox(read($Heap, children#9, IndexField(i#72))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#9), nchildren#9), i#72)): ref)
               ==> (forall i#73: int :: 
                { $Unbox(read($Heap, children#9, IndexField(i#73))): ref } 
                LitInt(0) <= i#73 && i#73 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#73 && i#73 < nchildren#9
                   ==> !read($Heap, $Unbox(read($Heap, children#9, IndexField(i#73))): ref, KMBtree.Node.repr)[$Box(children#9)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, node#0, KMBtree.Node.height)
       == read(old($Heap), node#0, KMBtree.Node.height);
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             - 1);
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0))));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#74: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#74)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#74
               && i#74
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                  i#74)): DatatypeType)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#75: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                i#75)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#75
               && i#75
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#75)): DatatypeType), 
              Set#Empty(): Set Box)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#76: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#76) } 
          true
             ==> 
            LitInt(0) <= i#76
               && i#76
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                   - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#76)));
  ensures KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
       || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> (forall i#77: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#77) } 
          true
             ==> 
            0 < i#77
               && i#77
                 < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#77)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        $Box(key#0), 
        $Box(value#0)));
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
     && 
    KMBtree.__default.I#canCall(old($Heap), node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), node#0));
  ensures $_reverifyPost
     ==> Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
          KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), node#0)), 
        Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), node#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), node#0), 
      $Box(key#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), node#0), 
        $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == node#0
         || read(old($Heap), node#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.InsertNode(node#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (oldvalue#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##0_0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##0_0: ref;
  var key##0_0: Seq Box;
  var value##0_0: DatatypeType;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##0: ref;
  var key##0: Seq Box;
  var value##0: DatatypeType;

    // AddMethodImpl: InsertNode, Impl$$KMBtree.__default.InsertNode
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == node#0 || read($Heap, node#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1177,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1178,5)
    assume node#0 != null;
    assume true;
    if (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents)))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1179,29)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0_0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0_0 := key#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        value##0_0 := value#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && (
                $o == node##0_0
                 || $o == KMBtree.NodeContents.keys(read($Heap, node##0_0, KMBtree.Node.contents))
                 || $o == KMBtree.NodeContents.values(read($Heap, node##0_0, KMBtree.Node.contents)))
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$KMBtree.__default.InsertLeaf(node##0_0, key##0_0, value##0_0);
        // TrCallStmt: After ProcessCallStmt
        oldvalue#0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1179,46)"} true;
    }
    else
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1181,30)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0 := node#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0 := key#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        value##0 := value#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == node##0 || read($Heap, node##0, KMBtree.Node.repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume 0 <= read(old($Heap), node#0, KMBtree.Node.height)
           || read($Heap, node##0, KMBtree.Node.height)
             == read(old($Heap), node#0, KMBtree.Node.height);
        assume 0 <= LitInt(2)
           || read($Heap, node##0, KMBtree.Node.height)
             < read(old($Heap), node#0, KMBtree.Node.height)
           || LitInt(1) == LitInt(2);
        assume read($Heap, node##0, KMBtree.Node.height)
             < read(old($Heap), node#0, KMBtree.Node.height)
           || (read($Heap, node##0, KMBtree.Node.height)
               == read(old($Heap), node#0, KMBtree.Node.height)
             && LitInt(1) < LitInt(2));
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$KMBtree.__default.InsertIndex(node##0, key##0, value##0);
        // TrCallStmt: After ProcessCallStmt
        oldvalue#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1181,47)"} true;
    }
}



procedure CheckWellformed$$KMBtree.__default.Grow(root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap))
   returns (newroot#0: ref
       where $Is(newroot#0, Tclass.KMBtree.Node())
         && $IsAlloc(newroot#0, Tclass.KMBtree.Node(), $Heap));
  free requires 59 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$KMBtree.__default.Grow(root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap))
   returns (newroot#0: ref
       where $Is(newroot#0, Tclass.KMBtree.Node())
         && $IsAlloc(newroot#0, Tclass.KMBtree.Node(), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, root#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> read($Heap, root#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, root#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, root#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))), 
                    $Box(children#2)), 
                  read($Heap, root#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                0 < nchildren#2))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                nchildren#2 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#2)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#10: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#10))): ref } 
                  LitInt(0) <= i#10 && i#10 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#10 && i#10 < nchildren#2
                     ==> $Unbox(read($Heap, children#2, IndexField(i#10))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), 
                  read($Heap, root#0, KMBtree.Node.repr), 
                  read($Heap, root#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#11: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#11))): ref } 
                  LitInt(0) <= i#11 && i#11 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#11 && i#11 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#11))): ref, KMBtree.Node.repr)[$Box(root#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#12: int :: 
                  { $Unbox(read($Heap, children#2, IndexField(i#12))): ref } 
                  LitInt(0) <= i#12 && i#12 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#12 && i#12 < nchildren#2
                     ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#12))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#13: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                    LitInt(0) <= i#13 && i#13 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#13 && i#13 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#2 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#2 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#13: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref } 
                      { $Unbox(read($Heap, children#2, IndexField(i#13))): ref } 
                    LitInt(0) <= i#13 && i#13 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#13 && i#13 < nchildren#2
                       ==> $Unbox(read($Heap, children#2, IndexField(i#13))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#2), nchildren#2), i#13)): ref)
                   ==> (forall i#14: int :: 
                    { $Unbox(read($Heap, children#2, IndexField(i#14))): ref } 
                    LitInt(0) <= i#14 && i#14 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#14 && i#14 < nchildren#2
                       ==> !read($Heap, $Unbox(read($Heap, children#2, IndexField(i#14))): ref, KMBtree.Node.repr)[$Box(children#2)])))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#15: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                    i#15)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#15
                   && i#15
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                      i#15)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#16: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                    i#16)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#16
                   && i#16
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                        i#16)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#17: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#17) } 
              true
                 ==> 
                LitInt(0) <= i#17
                   && i#17
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#17))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#18: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#18) } 
              true
                 ==> 
                0 < i#18
                   && i#18
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#18))));
  requires KMBtree.__default.Full($Heap, root#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, newroot#0);
  free ensures KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
     && (if KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
       then Set#Equal(read($Heap, newroot#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))))
         && !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))
         && read($Heap, newroot#0, KMBtree.Node.height) == LitInt(0)
         && 
        LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, newroot#0, KMBtree.Node.contents))
         && KMBtree.NodeContents.nkeys(read($Heap, newroot#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf())
         && LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))
         && _System.array.Length(KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))
       else true
         && (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          true
             && (var children#3 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, newroot#0, KMBtree.Node.repr))
                 && 
                0 < nchildren#3
                 && nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())
                 && LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)
                 && _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)
                 && (forall i#19: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#19))): ref } 
                  LitInt(0) <= i#19 && i#19 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#19 && i#19 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#19))): ref != null)
                 && KMBtree.__default.WFShapeChildren($LS($LZ), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, newroot#0, KMBtree.Node.repr), 
                  read($Heap, newroot#0, KMBtree.Node.height))
                 && (forall i#20: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#20))): ref } 
                  LitInt(0) <= i#20 && i#20 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#20 && i#20 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#20))): ref, KMBtree.Node.repr)[$Box(newroot#0)])
                 && (forall i#21: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#21))): ref } 
                  LitInt(0) <= i#21 && i#21 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#21 && i#21 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#21))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))])
                 && 
                true
                 && (forall i#23: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#23))): ref } 
                  LitInt(0) <= i#23 && i#23 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#23 && i#23 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#23))): ref, KMBtree.Node.repr)[$Box(children#3)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, newroot#0, KMBtree.Node.repr)[$Box($o)]
         && !read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures read($Heap, newroot#0, KMBtree.Node.height)
     == read($Heap, root#0, KMBtree.Node.height) + 1;
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.Grow(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0)))
     && 
    KMBtree.__default.I#canCall($Heap, newroot#0)
     && 
    KMBtree.__default.I#canCall($Heap, root#0)
     && KMBtreeModel.__default.Grow#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0));
  ensures KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0), 
    KMBtreeModel.__default.Grow(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)));
  free ensures KMBtree.__default.Full#canCall($Heap, newroot#0);
  ensures !KMBtree.__default.Full($Heap, newroot#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.Grow(root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap))
   returns (newroot#0: ref
       where $Is(newroot#0, Tclass.KMBtree.Node())
         && $IsAlloc(newroot#0, Tclass.KMBtree.Node(), $Heap), 
    $_reverifyPost: bool);
  free requires 59 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, root#0)
     && 
    KMBtree.__default.WF($Heap, root#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0));
  requires KMBtree.__default.Full($Heap, root#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WFShape#canCall($Heap, newroot#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> Set#Equal(read($Heap, newroot#0, KMBtree.Node.repr), 
          Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), 
              $Box(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))), 
            $Box(KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
          Tclass.ValueMessage.Message(), 
          KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)), 
          KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> read($Heap, newroot#0, KMBtree.Node.height) == LitInt(0));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> LitInt(0)
           <= KMBtree.NodeContents.nkeys(read($Heap, newroot#0, KMBtree.Node.contents)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> KMBtree.NodeContents.nkeys(read($Heap, newroot#0, KMBtree.Node.contents))
           <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))
           == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> Lit(true));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), 
                  $Box(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))), 
                $Box(children#5)), 
              read($Heap, newroot#0, KMBtree.Node.repr)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            0 < nchildren#5)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            nchildren#5 <= LitInt(KMBtree.__default.MaxChildren()))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#5))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))
               == LitInt(KMBtree.__default.MaxChildren() - 1))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            (forall i#33: int :: 
              { $Unbox(read($Heap, children#5, IndexField(i#33))): ref } 
              LitInt(0) <= i#33 && i#33 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#33 && i#33 < nchildren#5
                 ==> $Unbox(read($Heap, children#5, IndexField(i#33))): ref != null))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
              $Heap, 
              Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), 
              read($Heap, newroot#0, KMBtree.Node.repr), 
              read($Heap, newroot#0, KMBtree.Node.height)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            (forall i#34: int :: 
              { $Unbox(read($Heap, children#5, IndexField(i#34))): ref } 
              LitInt(0) <= i#34 && i#34 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#34 && i#34 < nchildren#5
                 ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#34))): ref, KMBtree.Node.repr)[$Box(newroot#0)]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            (forall i#35: int :: 
              { $Unbox(read($Heap, children#5, IndexField(i#35))): ref } 
              LitInt(0) <= i#35 && i#35 < 18446744073709551616
                 ==> 
                LitInt(0) <= i#35 && i#35 < nchildren#5
                 ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#35))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))]))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            (forall i#36: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref } 
                  { $Unbox(read($Heap, children#5, IndexField(i#36))): ref } 
                LitInt(0) <= i#36 && i#36 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#36 && i#36 < nchildren#5
                   ==> $Unbox(read($Heap, children#5, IndexField(i#36))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref)
               ==> Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WFShape#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
       || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
         ==> (var nchildren#5 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
          (var children#5 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
            (forall i#36: int :: 
                { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref } 
                  { $Unbox(read($Heap, children#5, IndexField(i#36))): ref } 
                LitInt(0) <= i#36 && i#36 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#36 && i#36 < nchildren#5
                   ==> $Unbox(read($Heap, children#5, IndexField(i#36))): ref
                     == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#5), nchildren#5), i#36)): ref)
               ==> (forall i#37: int :: 
                { $Unbox(read($Heap, children#5, IndexField(i#37))): ref } 
                LitInt(0) <= i#37 && i#37 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#37 && i#37 < nchildren#5
                   ==> !read($Heap, $Unbox(read($Heap, children#5, IndexField(i#37))): ref, KMBtree.Node.repr)[$Box(children#5)]))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, newroot#0, KMBtree.Node.repr)[$Box($o)]
           && !read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures true;
  ensures $_reverifyPost
     ==> read($Heap, newroot#0, KMBtree.Node.height)
       == read($Heap, root#0, KMBtree.Node.height) + 1;
  free ensures $IsA#KMBtreeModel.Node(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
     && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.Grow(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0)))
     && 
    KMBtree.__default.I#canCall($Heap, newroot#0)
     && 
    KMBtree.__default.I#canCall($Heap, root#0)
     && KMBtreeModel.__default.Grow#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0));
  ensures $_reverifyPost
     ==> KMBtreeModel.Node#Equal(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0), 
      KMBtreeModel.__default.Grow(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)));
  free ensures KMBtree.__default.Full#canCall($Heap, newroot#0);
  ensures $_reverifyPost ==> !KMBtree.__default.Full($Heap, newroot#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.Grow(root#0: ref) returns (newroot#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#newroot#0: bool;
  var $nw: ref;
  var newpivots#0: ref
     where $Is(newpivots#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc(newpivots#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $IsAlloc($rhs##0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap);
  var n##0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var t##0: Box;
  var newchildren#0: ref
     where $Is(newchildren#0, Tclass._System.array?(Tclass.KMBtree.Node?()))
       && $IsAlloc(newchildren#0, Tclass._System.array?(Tclass.KMBtree.Node?()), $Heap);
  var $rhs##1: ref
     where $Is($rhs##1, Tclass._System.array(Tclass.KMBtree.Node?()))
       && $IsAlloc($rhs##1, Tclass._System.array(Tclass.KMBtree.Node?()), $Heap);
  var n##1: int;
  var t##1: Box;
  var $rhs#0: ref where $Is($rhs#0, Tclass.KMBtree.Node?());
  var $rhs#1: DatatypeType where $Is($rhs#1, Tclass.KMBtree.NodeContents());
  var newtype$check#2: int;
  var $rhs#2: Set Box where $Is($rhs#2, TSet(Tclass._System.object()));
  var $rhs#3: int where LitInt(0) <= $rhs#3;
  var ##nodes#0: Seq Box;
  var ##parentRepr#0: Set Box;
  var ##parentHeight#0: int;
  var inewroot#0: DatatypeType
     where $Is(inewroot#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(inewroot#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#7: ref;
  var node##0: ref;
  var childidx##0: int;
  var ##node#8: ref;

    // AddMethodImpl: Grow, Impl$$KMBtree.__default.Grow
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1193,2): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1194,13)
    assume true;
    havoc $nw;
    assume $nw != null && dtype($nw) == Tclass.KMBtree.Node?();
    assume !read($Heap, $nw, alloc);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    newroot#0 := $nw;
    defass#newroot#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1194,23)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1195,34)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type array<Key>
    // TrCallStmt: Before ProcessCallStmt
    assume KMBtree.__default.MaxChildren#canCall();
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    newtype$check#1 := LitInt(KMBtree.__default.MaxChildren() - 1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume KMBtree.__default.MaxChildren#canCall();
    // ProcessCallStmt: CheckSubrange
    n##0 := LitInt(KMBtree.__default.MaxChildren() - 1);
    assume KMBtree.__default.DefaultKey#canCall();
    assume KMBtree.__default.DefaultKey#canCall();
    // ProcessCallStmt: CheckSubrange
    t##0 := $Box(Lit(KMBtree.__default.DefaultKey()));
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##0 := Call$$NativeArrays.__default.newArrayFill(TSeq(Tclass.NativeTypes.byte()), n##0, t##0);
    // TrCallStmt: After ProcessCallStmt
    newpivots#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1195,64)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1196,36)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type array?<Node?>
    // TrCallStmt: Before ProcessCallStmt
    assume KMBtree.__default.MaxChildren#canCall();
    assume KMBtree.__default.MaxChildren#canCall();
    // ProcessCallStmt: CheckSubrange
    n##1 := LitInt(KMBtree.__default.MaxChildren());
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##1 := $Box(null);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    free call $rhs##1 := Call$$NativeArrays.__default.newArrayFill(Tclass.KMBtree.Node?(), n##1, t##1);
    // TrCallStmt: After ProcessCallStmt
    newchildren#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1196,56)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1197,20)
    assume newchildren#0 != null;
    assume 0 <= LitInt(0) && LitInt(0) < _System.array.Length(newchildren#0);
    assume true;
    assume $_Frame[newchildren#0, IndexField(LitInt(0))];
    assume true;
    $rhs#0 := root#0;
    $Heap := update($Heap, newchildren#0, IndexField(LitInt(0)), $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1197,26)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1198,22)
    assume defass#newroot#0;
    assume newroot#0 != null;
    assume true;
    assume $_Frame[newroot#0, KMBtree.Node.contents];
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume $Is(newchildren#0, Tclass._System.array(Tclass.KMBtree.Node?()));
    assume true;
    $rhs#1 := #KMBtree.NodeContents.Index(LitInt(1), newpivots#0, newchildren#0);
    $Heap := update($Heap, newroot#0, KMBtree.Node.contents, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1198,56)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1199,18)
    assume defass#newroot#0;
    assume newroot#0 != null;
    assume true;
    assume $_Frame[newroot#0, KMBtree.Node.repr];
    assume defass#newroot#0;
    assume root#0 != null;
    assume true;
    assume $Is(Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), $Box(newpivots#0)), 
          $Box(newchildren#0)), 
        read($Heap, root#0, KMBtree.Node.repr)), 
      TSet(Tclass._System.object()));
    $rhs#2 := Set#Union(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), $Box(newpivots#0)), 
        $Box(newchildren#0)), 
      read($Heap, root#0, KMBtree.Node.repr));
    $Heap := update($Heap, newroot#0, KMBtree.Node.repr, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1199,65)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1200,20)
    assume defass#newroot#0;
    assume newroot#0 != null;
    assume true;
    assume $_Frame[newroot#0, KMBtree.Node.height];
    assume root#0 != null;
    assume true;
    assume $Is(read($Heap, root#0, KMBtree.Node.height) + 1, Tclass._System.nat());
    $rhs#3 := read($Heap, root#0, KMBtree.Node.height) + 1;
    $Heap := update($Heap, newroot#0, KMBtree.Node.height, $rhs#3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1200,37)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1202,5)
    assume defass#newroot#0;
    assume {:subsumption 0} newroot#0 != null;
    assume KMBtree.NodeContents.Index_q(read($Heap, newroot#0, KMBtree.Node.contents));
    assume KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents))
       != null;
    assume {:subsumption 0} 0 <= LitInt(1)
       && LitInt(1)
         <= _System.array.Length(KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)));
    assume defass#newroot#0;
    assume {:subsumption 0} newroot#0 != null;
    assume defass#newroot#0;
    assume {:subsumption 0} newroot#0 != null;
    assume $Is(Seq#Take(Seq#FromArray($Heap, 
          KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents))), 
        LitInt(1)), 
      TSeq(Tclass.KMBtree.Node()));
    ##nodes#0 := Seq#Take(Seq#FromArray($Heap, 
        KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents))), 
      LitInt(1));
    // assume allocatedness for argument to function
    assume $IsAlloc(##nodes#0, TSeq(Tclass.KMBtree.Node()), $Heap);
    ##parentRepr#0 := read($Heap, newroot#0, KMBtree.Node.repr);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentRepr#0, TSet(Tclass._System.object()), $Heap);
    ##parentHeight#0 := read($Heap, newroot#0, KMBtree.Node.height);
    // assume allocatedness for argument to function
    assume $IsAlloc(##parentHeight#0, Tclass._System.nat(), $Heap);
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, 
          KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents))), 
        LitInt(1)), 
      read($Heap, newroot#0, KMBtree.Node.repr), 
      read($Heap, newroot#0, KMBtree.Node.height));
    assume KMBtree.__default.WFShapeChildren#canCall($Heap, 
      Seq#Take(Seq#FromArray($Heap, 
          KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents))), 
        LitInt(1)), 
      read($Heap, newroot#0, KMBtree.Node.repr), 
      read($Heap, newroot#0, KMBtree.Node.height));
    if (*)
    {
        // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1202,5)
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1202,109)
        // TrCallStmt: Before ProcessCallStmt
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.reveal__SeqRepr();
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1202,110)"} true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume false;
    }

    assume KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
      $Heap, 
      Seq#Take(Seq#FromArray($Heap, 
          KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents))), 
        LitInt(1)), 
      read($Heap, newroot#0, KMBtree.Node.repr), 
      read($Heap, newroot#0, KMBtree.Node.height));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1204,24)
    assume true;
    assume defass#newroot#0;
    ##node#7 := newroot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#7);
    assume KMBtree.__default.I#canCall($Heap, newroot#0);
    assume KMBtree.__default.I#canCall($Heap, newroot#0);
    inewroot#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1204,36)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1205,13)
    // TrCallStmt: Before ProcessCallStmt
    assume defass#newroot#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := newroot#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    childidx##0 := LitInt(0);
    assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$KMBtree.__default.IOfChild(node##0, childidx##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1205,24)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1206,5)
    assume KMBtreeModel.Node.Index_q(inewroot#0);
    ##node#8 := root#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#8, Tclass.KMBtree.Node(), $Heap);
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> Set#Equal(read($Heap, ##node#8, KMBtree.Node.repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#8)), 
                $Box(KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents)))), 
              $Box(KMBtree.NodeContents.values(read($Heap, ##node#8, KMBtree.Node.contents))))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents)), 
            KMBtree.NodeContents.values(read($Heap, ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> read($Heap, ##node#8, KMBtree.Node.height) == LitInt(0));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> LitInt(0)
             <= KMBtree.NodeContents.nkeys(read($Heap, ##node#8, KMBtree.Node.contents)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> KMBtree.NodeContents.nkeys(read($Heap, ##node#8, KMBtree.Node.contents))
             <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, ##node#8, KMBtree.Node.contents)))
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> Lit(true));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#8)), 
                    $Box(KMBtree.NodeContents.pivots(read($Heap, ##node#8, KMBtree.Node.contents)))), 
                  $Box(children#7)), 
                read($Heap, ##node#8, KMBtree.Node.repr)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              0 < nchildren#7)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              nchildren#7 <= LitInt(KMBtree.__default.MaxChildren()))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, ##node#8, KMBtree.Node.contents)))
                 == LitInt(KMBtree.__default.MaxChildren() - 1))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#44: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#44))): ref } 
                LitInt(0) <= i#44 && i#44 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#44 && i#44 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#44))): ref != null))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                $Heap, 
                Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
                read($Heap, ##node#8, KMBtree.Node.repr), 
                read($Heap, ##node#8, KMBtree.Node.height)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#45: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#45))): ref } 
                LitInt(0) <= i#45 && i#45 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#45 && i#45 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#45))): ref, KMBtree.Node.repr)[$Box(##node#8)]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#46: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#46))): ref } 
                LitInt(0) <= i#46 && i#46 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#46 && i#46 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#46))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, ##node#8, KMBtree.Node.contents)))]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#47: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#47)): ref } 
                    { $Unbox(read($Heap, children#7, IndexField(i#47))): ref } 
                  LitInt(0) <= i#47 && i#47 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#47 && i#47 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#47))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#47)): ref)
                 ==> Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#8, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#8, KMBtree.Node.contents)); 
              (forall i#47: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#47)): ref } 
                    { $Unbox(read($Heap, children#7, IndexField(i#47))): ref } 
                  LitInt(0) <= i#47 && i#47 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#47 && i#47 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#47))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#47)): ref)
                 ==> (forall i#48: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#48))): ref } 
                  LitInt(0) <= i#48 && i#48 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#48 && i#48 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#48))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
    assume KMBtree.__default.I#canCall($Heap, root#0);
    assume KMBtree.__default.I#canCall($Heap, root#0);
    assume true;
    assume Seq#Equal(KMBtreeModel.Node.children(inewroot#0), 
      Seq#Build(Seq#Empty(): Seq Box, 
        $Box(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))));
    assert defass#newroot#0;
}



procedure {:_induction node#0} CheckWellformed$$KMBtree.__default.FullImpliesAllKeysNonEmpty(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap));
  free requires 60 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtree.__default.FullImpliesAllKeysNonEmpty(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, node#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> read($Heap, node#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, node#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, node#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, node#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(node#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))), 
                    $Box(children#1)), 
                  read($Heap, node#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                0 < nchildren#1))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                nchildren#1 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#5: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#5))): ref } 
                  LitInt(0) <= i#5 && i#5 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#5 && i#5 < nchildren#1
                     ==> $Unbox(read($Heap, children#1, IndexField(i#5))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), 
                  read($Heap, node#0, KMBtree.Node.repr), 
                  read($Heap, node#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#6: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#6))): ref } 
                  LitInt(0) <= i#6 && i#6 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#6 && i#6 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#6))): ref, KMBtree.Node.repr)[$Box(node#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#7: int :: 
                  { $Unbox(read($Heap, children#1, IndexField(i#7))): ref } 
                  LitInt(0) <= i#7 && i#7 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#7 && i#7 < nchildren#1
                     ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#7))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, node#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#8: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#8))): ref } 
                    LitInt(0) <= i#8 && i#8 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#8 && i#8 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#8))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtree.__default.WFShape#canCall($Heap, node#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, node#0, KMBtree.Node.contents))
             ==> (var nchildren#1 := KMBtree.NodeContents.nchildren(read($Heap, node#0, KMBtree.Node.contents)); 
              (var children#1 := KMBtree.NodeContents.children(read($Heap, node#0, KMBtree.Node.contents)); 
                (forall i#8: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref } 
                      { $Unbox(read($Heap, children#1, IndexField(i#8))): ref } 
                    LitInt(0) <= i#8 && i#8 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#8 && i#8 < nchildren#1
                       ==> $Unbox(read($Heap, children#1, IndexField(i#8))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#1), nchildren#1), i#8)): ref)
                   ==> (forall i#9: int :: 
                    { $Unbox(read($Heap, children#1, IndexField(i#9))): ref } 
                    LitInt(0) <= i#9 && i#9 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#9 && i#9 < nchildren#1
                       ==> !read($Heap, $Unbox(read($Heap, children#1, IndexField(i#9))): ref, KMBtree.Node.repr)[$Box(children#1)])))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#10: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#10)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#10
                   && i#10
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                      i#10)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#11: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                    i#11)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#11
                   && i#11
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
                        i#11)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#12: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#12) } 
              true
                 ==> 
                LitInt(0) <= i#12
                   && i#12
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#12))));
  requires KMBtree.__default.WF#canCall($Heap, node#0)
     ==> KMBtree.__default.WF($Heap, node#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0))
             ==> (forall i#13: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#13) } 
              true
                 ==> 
                0 < i#13
                   && i#13
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0), i#13))));
  requires KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
    Set#Empty(): Set Box);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} Impl$$KMBtree.__default.FullImpliesAllKeysNonEmpty(node#0: ref
       where $Is(node#0, Tclass.KMBtree.Node())
         && $IsAlloc(node#0, Tclass.KMBtree.Node(), $Heap))
   returns ($_reverifyPost: bool);
  free requires 60 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, node#0)
     && 
    KMBtree.__default.WF($Heap, node#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, node#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  requires KMBtree.__default.Full($Heap, node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.I#canCall($Heap, node#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0));
  ensures $_reverifyPost
     ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, node#0)), 
      Set#Empty(): Set Box);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction node#0} Impl$$KMBtree.__default.FullImpliesAllKeysNonEmpty(node#0: ref) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var inode#0: DatatypeType
     where $Is(inode#0, Tclass.KMBtreeModel.Node())
       && $IsAlloc(inode#0, Tclass.KMBtreeModel.Node(), $Heap);
  var ##node#4: ref;
  var ##node#0_0: DatatypeType;
  var ##node#5: DatatypeType;

    // AddMethodImpl: FullImpliesAllKeysNonEmpty, Impl$$KMBtree.__default.FullImpliesAllKeysNonEmpty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1213,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#node0#0: ref :: 
      $Is($ih#node0#0, Tclass.KMBtree.Node())
           && 
          KMBtree.__default.WF($initHeapForallStmt#0, $ih#node0#0)
           && KMBtree.__default.Full($initHeapForallStmt#0, $ih#node0#0)
           && 
          $ih#node0#0 == null
           && node#0 != null
         ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
            KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, $ih#node0#0)), 
          Set#Empty(): Set Box));
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1214,15)
    assume true;
    ##node#4 := node#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#4, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#4);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    assume KMBtree.__default.I#canCall($Heap, node#0);
    inode#0 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, node#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1214,24)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1215,5)
    assume true;
    if (KMBtreeModel.Node.Leaf_q(inode#0))
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1216,7)
        assume KMBtreeModel.Node.Leaf_q(inode#0);
        assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(KMBtreeModel.Node.keys(inode#0));
        ##node#0_0 := inode#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_0, Tclass.KMBtreeModel.Node(), $Heap);
        assume KMBtreeModel.__default.AllKeys#canCall(inode#0);
        assume KMBtreeModel.__default.AllKeys#canCall(inode#0);
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1216,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1216,77)
            // TrCallStmt: Before ProcessCallStmt
            assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            free call Call$$KMBtreeModel.__default.reveal__AllKeys();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1216,78)"} true;
            assume true;
            assume false;
        }

        assume KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, inode#0)[Seq#Index(KMBtreeModel.Node.keys(inode#0), LitInt(0))];
    }
    else
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1218,7)
        assume KMBtreeModel.Node.Index_q(inode#0);
        assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(KMBtreeModel.Node.pivots(inode#0));
        ##node#5 := inode#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#5, Tclass.KMBtreeModel.Node(), $Heap);
        assume KMBtreeModel.__default.AllKeys#canCall(inode#0);
        assume KMBtreeModel.__default.AllKeys#canCall(inode#0);
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1218,7)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1218,79)
            // TrCallStmt: Before ProcessCallStmt
            assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            free call Call$$KMBtreeModel.__default.reveal__AllKeys();
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1218,80)"} true;
            assume true;
            assume false;
        }

        assume KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, inode#0)[Seq#Index(KMBtreeModel.Node.pivots(inode#0), LitInt(0))];
    }
}



procedure CheckWellformed$$KMBtree.__default.Insert(root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (newroot#0: ref
       where $Is(newroot#0, Tclass.KMBtree.Node())
         && $IsAlloc(newroot#0, Tclass.KMBtree.Node(), $Heap), 
    oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  free requires 61 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$KMBtree.__default.Insert(root#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (newroot#0: ref, oldvalue#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##node#0: ref;
  var ##node#1: ref;
  var ##node#2: ref;
  var ##node#3: ref;
  var ##node#4: ref;
  var ##m#0: Map Box Box;
  var ##key#0: Seq Box;

    // AddMethodImpl: Insert, CheckWellformed$$KMBtree.__default.Insert
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1222,9): initial state"} true;
    ##node#0 := root#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#0, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, root#0);
    assume KMBtree.__default.WF($Heap, root#0);
    assume root#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), root#0, KMBtree.Node.repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc newroot#0, oldvalue#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1224,14): post-state"} true;
    ##node#1 := newroot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#1, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.WF#canCall($Heap, newroot#0);
    assume KMBtree.__default.WF($Heap, newroot#0);
    assume newroot#0 != null;
    assume root#0 != null;
    assume $IsAlloc(root#0, Tclass.KMBtree.Node(), old($Heap));
    assume (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, newroot#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), root#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    ##node#2 := newroot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#2, Tclass.KMBtree.Node(), $Heap);
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                      i#5)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#5
                     && i#5
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                        i#5)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#6: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                      i#6)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#6
                     && i#6
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)), 
                          i#6)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#7: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#7) } 
                true
                   ==> 
                  LitInt(0) <= i#7
                     && i#7
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#7))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall($Heap, ##node#2)
       ==> KMBtree.__default.WF($Heap, ##node#2)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
           ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, ##node#2))
               ==> (forall i#8: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#8) } 
                true
                   ==> 
                  0 < i#8
                     && i#8
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, ##node#2), i#8))));
    assume KMBtree.__default.WF($Heap, ##node#2);
    assume KMBtree.__default.Interpretation#canCall($Heap, newroot#0);
    ##node#3 := root#0;
    assume $IsAlloc(root#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> (forall i#14: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)), 
                      i#14)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#14
                     && i#14
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)), 
                        i#14)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> (forall i#15: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)), 
                      i#15)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#15
                     && i#15
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)), 
                          i#15)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> (forall i#16: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3), 
                    i#16) } 
                true
                   ==> 
                  LitInt(0) <= i#16
                     && i#16
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3), 
                    i#16))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#3)
       ==> KMBtree.__default.WF(old($Heap), ##node#3)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#3))
               ==> (forall i#17: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3), 
                    i#17) } 
                true
                   ==> 
                  0 < i#17
                     && i#17
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#3), 
                    i#17))));
    assume KMBtree.__default.WF(old($Heap), ##node#3);
    assume KMBtree.__default.Interpretation#canCall(old($Heap), root#0);
    assume Map#Equal(KMBtree.__default.Interpretation($Heap, newroot#0), 
      Map#Build(KMBtree.__default.Interpretation(old($Heap), root#0), $Box(key#0), $Box(value#0)));
    ##node#4 := root#0;
    assume $IsAlloc(root#0, Tclass.KMBtree.Node(), old($Heap));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                 == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                 == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                   - 1));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> (forall i#23: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)), 
                      i#23)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#23
                     && i#23
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                   ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)), 
                        i#23)): DatatypeType))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> (forall i#24: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)), 
                      i#24)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#24
                     && i#24
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)), 
                          i#24)): DatatypeType), 
                    Set#Empty(): Set Box))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> (forall i#25: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4), 
                    i#25) } 
                true
                   ==> 
                  LitInt(0) <= i#25
                     && i#25
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                         - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4), 
                    i#25))));
    assert {:subsumption 0} KMBtree.__default.WF#canCall(old($Heap), ##node#4)
       ==> KMBtree.__default.WF(old($Heap), ##node#4)
         || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
           ==> KMBtreeModel.__default.WF($LS($LZ), 
              KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
             || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), ##node#4))
               ==> (forall i#26: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4), 
                    i#26) } 
                true
                   ==> 
                  0 < i#26
                     && i#26
                       < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4)))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, old($Heap), ##node#4), 
                    i#26))));
    assume KMBtree.__default.WF(old($Heap), ##node#4);
    assume KMBtree.__default.Interpretation#canCall(old($Heap), root#0);
    ##m#0 := KMBtree.__default.Interpretation(old($Heap), root#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##m#0, 
      TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()), 
      $Heap);
    ##key#0 := key#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##key#0, TSeq(Tclass.NativeTypes.byte()), $Heap);
    assume Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), root#0), 
      $Box(key#0));
    assume Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), root#0), 
        $Box(key#0)));
}



procedure Call$$KMBtree.__default.Insert(root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (newroot#0: ref
       where $Is(newroot#0, Tclass.KMBtree.Node())
         && $IsAlloc(newroot#0, Tclass.KMBtree.Node(), $Heap), 
    oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap));
  // user-defined preconditions
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, root#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> read($Heap, root#0, KMBtree.Node.height) == LitInt(0)));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, root#0, KMBtree.Node.contents))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, root#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, root#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, root#0, KMBtree.Node.contents)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> Lit(true)));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              Lit(true))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(root#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))), 
                    $Box(children#3)), 
                  read($Heap, root#0, KMBtree.Node.repr))))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                0 < nchildren#3))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                nchildren#3 <= LitInt(KMBtree.__default.MaxChildren())))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#3)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#27: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#27))): ref } 
                  LitInt(0) <= i#27 && i#27 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#27 && i#27 < nchildren#3
                     ==> $Unbox(read($Heap, children#3, IndexField(i#27))): ref != null)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), 
                  read($Heap, root#0, KMBtree.Node.repr), 
                  read($Heap, root#0, KMBtree.Node.height))))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#28: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#28))): ref } 
                  LitInt(0) <= i#28 && i#28 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#28 && i#28 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#28))): ref, KMBtree.Node.repr)[$Box(root#0)])))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#29: int :: 
                  { $Unbox(read($Heap, children#3, IndexField(i#29))): ref } 
                  LitInt(0) <= i#29 && i#29 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#29 && i#29 < nchildren#3
                     ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#29))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, root#0, KMBtree.Node.contents)))])))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#30: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#30))): ref } 
                    LitInt(0) <= i#30 && i#30 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#30 && i#30 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#30))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref)
                   ==> Lit(true)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtree.__default.WFShape#canCall($Heap, root#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, root#0, KMBtree.Node.contents))
             ==> (var nchildren#3 := KMBtree.NodeContents.nchildren(read($Heap, root#0, KMBtree.Node.contents)); 
              (var children#3 := KMBtree.NodeContents.children(read($Heap, root#0, KMBtree.Node.contents)); 
                (forall i#30: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref } 
                      { $Unbox(read($Heap, children#3, IndexField(i#30))): ref } 
                    LitInt(0) <= i#30 && i#30 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#30 && i#30 < nchildren#3
                       ==> $Unbox(read($Heap, children#3, IndexField(i#30))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#3), nchildren#3), i#30)): ref)
                   ==> (forall i#31: int :: 
                    { $Unbox(read($Heap, children#3, IndexField(i#31))): ref } 
                    LitInt(0) <= i#31 && i#31 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#31 && i#31 < nchildren#3
                       ==> !read($Heap, $Unbox(read($Heap, children#3, IndexField(i#31))): ref, KMBtree.Node.repr)[$Box(children#3)])))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 - 1));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#32: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                    i#32)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#32
                   && i#32
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                      i#32)): DatatypeType))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#33: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                    i#33)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#33
                   && i#33
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)), 
                        i#33)): DatatypeType), 
                  Set#Empty(): Set Box))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#34: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#34) } 
              true
                 ==> 
                LitInt(0) <= i#34
                   && i#34
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#34))));
  requires KMBtree.__default.WF#canCall($Heap, root#0)
     ==> KMBtree.__default.WF($Heap, root#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0))
             ==> (forall i#35: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#35) } 
              true
                 ==> 
                0 < i#35
                   && i#35
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, root#0), i#35))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WF#canCall($Heap, newroot#0);
  free ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     && 
    KMBtree.__default.WF($Heap, newroot#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read(old($Heap), $o, alloc) } 
    read($Heap, newroot#0, KMBtree.Node.repr)[$Box($o)]
         && !read(old($Heap), root#0, KMBtree.Node.repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures KMBtree.__default.Interpretation#canCall($Heap, newroot#0)
     && KMBtree.__default.Interpretation#canCall(old($Heap), root#0);
  ensures Map#Equal(KMBtree.__default.Interpretation($Heap, newroot#0), 
    Map#Build(KMBtree.__default.Interpretation(old($Heap), root#0), $Box(key#0), $Box(value#0)));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), root#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), root#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), root#0), 
      $Box(key#0));
  ensures Options.Option#Equal(oldvalue#0, 
    Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), root#0), 
      $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), root#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$KMBtree.__default.Insert(root#0: ref
       where $Is(root#0, Tclass.KMBtree.Node())
         && $IsAlloc(root#0, Tclass.KMBtree.Node(), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0))
   returns (newroot#0: ref
       where $Is(newroot#0, Tclass.KMBtree.Node())
         && $IsAlloc(newroot#0, Tclass.KMBtree.Node(), $Heap), 
    oldvalue#0: DatatypeType
       where $Is(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
         && $IsAlloc(oldvalue#0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap), 
    $_reverifyPost: bool);
  free requires 61 == $FunctionContextHeight;
  // user-defined preconditions
  free requires KMBtree.__default.WF#canCall($Heap, root#0)
     && 
    KMBtree.__default.WF($Heap, root#0)
     && 
    KMBtree.__default.WFShape($LS($LZ), $Heap, root#0)
     && KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtree.__default.WF#canCall($Heap, newroot#0);
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> Set#Equal(read($Heap, newroot#0, KMBtree.Node.repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), 
                  $Box(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))), 
                $Box(KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
              Tclass.ValueMessage.Message(), 
              KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)), 
              KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> read($Heap, newroot#0, KMBtree.Node.height) == LitInt(0)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> LitInt(0)
               <= KMBtree.NodeContents.nkeys(read($Heap, newroot#0, KMBtree.Node.contents))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> KMBtree.NodeContents.nkeys(read($Heap, newroot#0, KMBtree.Node.contents))
               <= LitInt(KMBtree.__default.MaxKeysPerLeaf())));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, newroot#0, KMBtree.Node.contents)))
               == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, newroot#0, KMBtree.Node.contents)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> Lit(true)));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              Lit(true))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(newroot#0)), 
                      $Box(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))), 
                    $Box(children#6)), 
                  read($Heap, newroot#0, KMBtree.Node.repr))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                0 < nchildren#6))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                nchildren#6 <= LitInt(KMBtree.__default.MaxChildren())))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#6)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))
                   == LitInt(KMBtree.__default.MaxChildren() - 1)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                (forall i#54: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#54))): ref } 
                  LitInt(0) <= i#54 && i#54 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#54 && i#54 < nchildren#6
                     ==> $Unbox(read($Heap, children#6, IndexField(i#54))): ref != null)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                  $Heap, 
                  Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), 
                  read($Heap, newroot#0, KMBtree.Node.repr), 
                  read($Heap, newroot#0, KMBtree.Node.height))))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                (forall i#55: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#55))): ref } 
                  LitInt(0) <= i#55 && i#55 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#55 && i#55 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#55))): ref, KMBtree.Node.repr)[$Box(newroot#0)])))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                (forall i#56: int :: 
                  { $Unbox(read($Heap, children#6, IndexField(i#56))): ref } 
                  LitInt(0) <= i#56 && i#56 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#56 && i#56 < nchildren#6
                     ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#56))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, newroot#0, KMBtree.Node.contents)))])))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                (forall i#57: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#57)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#57))): ref } 
                    LitInt(0) <= i#57 && i#57 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#57 && i#57 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#57))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#57)): ref)
                   ==> Lit(true)))));
  ensures $_reverifyPost
     ==> 
    KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtree.__default.WFShape#canCall($Heap, newroot#0)
         ==> KMBtree.__default.WFShape($LS($LZ), $Heap, newroot#0)
           || (!KMBtree.NodeContents.Leaf_q(read($Heap, newroot#0, KMBtree.Node.contents))
             ==> (var nchildren#6 := KMBtree.NodeContents.nchildren(read($Heap, newroot#0, KMBtree.Node.contents)); 
              (var children#6 := KMBtree.NodeContents.children(read($Heap, newroot#0, KMBtree.Node.contents)); 
                (forall i#57: int :: 
                    { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#57)): ref } 
                      { $Unbox(read($Heap, children#6, IndexField(i#57))): ref } 
                    LitInt(0) <= i#57 && i#57 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#57 && i#57 < nchildren#6
                       ==> $Unbox(read($Heap, children#6, IndexField(i#57))): ref
                         == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#6), nchildren#6), i#57)): ref)
                   ==> (forall i#58: int :: 
                    { $Unbox(read($Heap, children#6, IndexField(i#58))): ref } 
                    LitInt(0) <= i#58 && i#58 < 18446744073709551616
                       ==> 
                      LitInt(0) <= i#58 && i#58 < nchildren#6
                       ==> !read($Heap, $Unbox(read($Heap, children#6, IndexField(i#58))): ref, KMBtree.Node.repr)[$Box(children#6)])))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> Seq#Length(KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
               == Seq#Length(KMBtreeModel.Node.values(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.keys(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> Seq#Length(KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
               == Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
                 - 1));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              KMBtreeModel.Node.pivots(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> (forall i#59: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)), 
                    i#59)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#59
                   && i#59
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
                 ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)), 
                      i#59)): DatatypeType))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> (forall i#60: int :: 
              { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)), 
                    i#60)): DatatypeType } 
              true
                 ==> 
                LitInt(0) <= i#60
                   && i#60
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
                 ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)), 
                        i#60)): DatatypeType), 
                  Set#Empty(): Set Box))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> (forall i#61: int :: 
              { KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0), i#61) } 
              true
                 ==> 
                LitInt(0) <= i#61
                   && i#61
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
                       - 1
                 ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0), i#61))));
  ensures KMBtree.__default.WF#canCall($Heap, newroot#0)
     ==> KMBtree.__default.WF($Heap, newroot#0)
       || (KMBtreeModel.__default.WF#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
         ==> KMBtreeModel.__default.WF($LS($LZ), KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
           || (!KMBtreeModel.Node.Leaf_q(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
             ==> (forall i#62: int :: 
              { KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0), i#62) } 
              true
                 ==> 
                0 < i#62
                   && i#62
                     < Seq#Length(KMBtreeModel.Node.children(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0)))
                 ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtree.__default.I(StartFuelAssert_KMBtree._default.I, $Heap, newroot#0), i#62))));
  free ensures true;
  ensures $_reverifyPost
     ==> (forall $o: ref :: 
      { read(old($Heap), $o, alloc) } 
      read($Heap, newroot#0, KMBtree.Node.repr)[$Box($o)]
           && !read(old($Heap), root#0, KMBtree.Node.repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures KMBtree.__default.Interpretation#canCall($Heap, newroot#0)
     && KMBtree.__default.Interpretation#canCall(old($Heap), root#0);
  ensures $_reverifyPost
     ==> Map#Equal(KMBtree.__default.Interpretation($Heap, newroot#0), 
      Map#Build(KMBtree.__default.Interpretation(old($Heap), root#0), $Box(key#0), $Box(value#0)));
  free ensures $IsA#Options.Option(oldvalue#0)
     && $IsA#Options.Option(Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), root#0), 
        $Box(key#0)))
     && 
    KMBtree.__default.Interpretation#canCall(old($Heap), root#0)
     && Maps.__default.MapLookupOption#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtree.__default.Interpretation(old($Heap), root#0), 
      $Box(key#0));
  ensures $_reverifyPost
     ==> Options.Option#Equal(oldvalue#0, 
      Maps.__default.MapLookupOption(TSeq(Tclass.NativeTypes.byte()), 
        Tclass.ValueMessage.Message(), 
        KMBtree.__default.Interpretation(old($Heap), root#0), 
        $Box(key#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), root#0, KMBtree.Node.repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$KMBtree.__default.Insert(root#0: ref, key#0: Seq Box, value#0: DatatypeType)
   returns (newroot#0: ref, oldvalue#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#newroot#0: bool;
  var ##node#5: ref;
  var node##0_0: ref;
  var node##0_1: DatatypeType;
  var ##node#0_0: ref;
  var $rhs##0_0: ref
     where $Is($rhs##0_0, Tclass.KMBtree.Node())
       && $IsAlloc($rhs##0_0, Tclass.KMBtree.Node(), $Heap);
  var root##0_0: ref;
  var node##0_2: DatatypeType;
  var ##node#0_1: ref;
  var ##node#6: ref;
  var ##node#7: DatatypeType;
  var ##node#8: ref;
  var ##node#9: DatatypeType;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.ValueMessage.Message()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.ValueMessage.Message()), $Heap);
  var node##0: ref;
  var key##0: Seq Box;
  var value##0: DatatypeType;

    // AddMethodImpl: Insert, Impl$$KMBtree.__default.Insert
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.AllKeys)
       == StartFuel_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.AllKeys)
       == StartFuelAssert_KMBtreeModel._default.AllKeys;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.Interpretation)
       == StartFuel_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.Interpretation)
       == StartFuelAssert_KMBtreeModel._default.Interpretation;
    assume AsFuelBottom(StartFuel_KMBtreeModel._default.ToSeq)
       == StartFuel_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuelAssert_KMBtreeModel._default.ToSeq)
       == StartFuelAssert_KMBtreeModel._default.ToSeq;
    assume AsFuelBottom(StartFuel_KMBtree._default.SeqRepr)
       == StartFuel_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.SeqRepr)
       == StartFuelAssert_KMBtree._default.SeqRepr;
    assume AsFuelBottom(StartFuel_KMBtree._default.I) == StartFuel_KMBtree._default.I;
    assume AsFuelBottom(StartFuelAssert_KMBtree._default.I)
       == StartFuelAssert_KMBtree._default.I;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, root#0, KMBtree.Node.repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1229,2): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1230,5)
    ##node#5 := root#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#5, Tclass.KMBtree.Node(), $Heap);
    assume KMBtree.__default.Full#canCall($Heap, root#0);
    assume KMBtree.__default.Full#canCall($Heap, root#0);
    if (KMBtree.__default.Full($Heap, root#0))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1231,33)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        node##0_0 := root#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$KMBtree.__default.FullImpliesAllKeysNonEmpty(node##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1231,38)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1232,28)
        // TrCallStmt: Before ProcessCallStmt
        ##node#0_0 := root#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_0, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_0);
        assume KMBtree.__default.I#canCall($Heap, root#0);
        assume KMBtree.__default.I#canCall($Heap, root#0);
        // ProcessCallStmt: CheckSubrange
        node##0_1 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0);
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.GrowPreservesWF(node##0_1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1232,36)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1233,22)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Node
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        root##0_0 := root#0;
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$KMBtree.__default.Grow(root##0_0);
        // TrCallStmt: After ProcessCallStmt
        newroot#0 := $rhs##0_0;
        defass#newroot#0 := true;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1233,27)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1234,40)
        // TrCallStmt: Before ProcessCallStmt
        ##node#0_1 := root#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##node#0_1, Tclass.KMBtree.Node(), $Heap);
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume true;
        assume KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#0_1);
        assume KMBtree.__default.I#canCall($Heap, root#0);
        assume KMBtree.__default.I#canCall($Heap, root#0);
        // ProcessCallStmt: CheckSubrange
        node##0_2 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, root#0);
        assume (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        free call Call$$KMBtreeModel.__default.GrowPreservesInterpretation(node##0_2);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1234,48)"} true;
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1236,15)
        assume true;
        assume true;
        newroot#0 := root#0;
        defass#newroot#0 := true;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1236,21)"} true;
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1238,5)
    assume defass#newroot#0;
    ##node#6 := newroot#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#6, Tclass.KMBtree.Node(), $Heap);
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> Set#Equal(read($Heap, ##node#6, KMBtree.Node.repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#6)), 
                $Box(KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents)))), 
              $Box(KMBtree.NodeContents.values(read($Heap, ##node#6, KMBtree.Node.contents))))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents)), 
            KMBtree.NodeContents.values(read($Heap, ##node#6, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> read($Heap, ##node#6, KMBtree.Node.height) == LitInt(0));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> LitInt(0)
             <= KMBtree.NodeContents.nkeys(read($Heap, ##node#6, KMBtree.Node.contents)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> KMBtree.NodeContents.nkeys(read($Heap, ##node#6, KMBtree.Node.contents))
             <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> _System.array.Length(KMBtree.NodeContents.values(read($Heap, ##node#6, KMBtree.Node.contents)))
             == _System.array.Length(KMBtree.NodeContents.keys(read($Heap, ##node#6, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> Lit(true));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#6)), 
                    $Box(KMBtree.NodeContents.pivots(read($Heap, ##node#6, KMBtree.Node.contents)))), 
                  $Box(children#7)), 
                read($Heap, ##node#6, KMBtree.Node.repr)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              0 < nchildren#7)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              nchildren#7 <= LitInt(KMBtree.__default.MaxChildren()))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#7))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              _System.array.Length(KMBtree.NodeContents.pivots(read($Heap, ##node#6, KMBtree.Node.contents)))
                 == LitInt(KMBtree.__default.MaxChildren() - 1))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#63: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#63))): ref } 
                LitInt(0) <= i#63 && i#63 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#63 && i#63 < nchildren#7
                   ==> $Unbox(read($Heap, children#7, IndexField(i#63))): ref != null))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                $Heap, 
                Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), 
                read($Heap, ##node#6, KMBtree.Node.repr), 
                read($Heap, ##node#6, KMBtree.Node.height)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#64: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#64))): ref } 
                LitInt(0) <= i#64 && i#64 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#64 && i#64 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#64))): ref, KMBtree.Node.repr)[$Box(##node#6)]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#65: int :: 
                { $Unbox(read($Heap, children#7, IndexField(i#65))): ref } 
                LitInt(0) <= i#65 && i#65 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#65 && i#65 < nchildren#7
                   ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#65))): ref, KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read($Heap, ##node#6, KMBtree.Node.contents)))]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#66: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#66)): ref } 
                    { $Unbox(read($Heap, children#7, IndexField(i#66))): ref } 
                  LitInt(0) <= i#66 && i#66 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#66 && i#66 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#66))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#66)): ref)
                 ==> Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall($Heap, ##node#6)
       ==> KMBtree.__default.WFShape($LS($LZ), $Heap, ##node#6)
         || (!KMBtree.NodeContents.Leaf_q(read($Heap, ##node#6, KMBtree.Node.contents))
           ==> (var nchildren#7 := KMBtree.NodeContents.nchildren(read($Heap, ##node#6, KMBtree.Node.contents)); 
            (var children#7 := KMBtree.NodeContents.children(read($Heap, ##node#6, KMBtree.Node.contents)); 
              (forall i#66: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#66)): ref } 
                    { $Unbox(read($Heap, children#7, IndexField(i#66))): ref } 
                  LitInt(0) <= i#66 && i#66 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#66 && i#66 < nchildren#7
                     ==> $Unbox(read($Heap, children#7, IndexField(i#66))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray($Heap, children#7), nchildren#7), i#66)): ref)
                 ==> (forall i#67: int :: 
                  { $Unbox(read($Heap, children#7, IndexField(i#67))): ref } 
                  LitInt(0) <= i#67 && i#67 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#67 && i#67 < nchildren#7
                     ==> !read($Heap, $Unbox(read($Heap, children#7, IndexField(i#67))): ref, KMBtree.Node.repr)[$Box(children#7)]))));
    assume KMBtree.__default.I#canCall($Heap, newroot#0);
    ##node#7 := KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#7, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#7))
             == Seq#Length(KMBtreeModel.Node.values(##node#7)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#7)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#7))
             == Seq#Length(KMBtreeModel.Node.children(##node#7)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#7)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#68: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#68)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#68 && i#68 < Seq#Length(KMBtreeModel.Node.children(##node#7))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#68)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#69: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#69)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#69 && i#69 < Seq#Length(KMBtreeModel.Node.children(##node#7))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#7), i#69)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#70: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#7, i#70) } 
            true
               ==> 
              LitInt(0) <= i#70 && i#70 < Seq#Length(KMBtreeModel.Node.children(##node#7)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#7, i#70)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#7)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#7)
         || (!KMBtreeModel.Node.Leaf_q(##node#7)
           ==> (forall i#71: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#7, i#71) } 
            true
               ==> 
              0 < i#71 && i#71 < Seq#Length(KMBtreeModel.Node.children(##node#7))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#7, i#71)));
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0));
    ##node#8 := root#0;
    assume $IsAlloc(root#0, Tclass.KMBtree.Node(), old($Heap));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> Set#Equal(read(old($Heap), ##node#8, KMBtree.Node.repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#8)), 
                $Box(KMBtree.NodeContents.keys(read(old($Heap), ##node#8, KMBtree.Node.contents)))), 
              $Box(KMBtree.NodeContents.values(read(old($Heap), ##node#8, KMBtree.Node.contents))))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> !Arrays.__default.Aliases(TSeq(Tclass.NativeTypes.byte()), 
            Tclass.ValueMessage.Message(), 
            KMBtree.NodeContents.keys(read(old($Heap), ##node#8, KMBtree.Node.contents)), 
            KMBtree.NodeContents.values(read(old($Heap), ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> read(old($Heap), ##node#8, KMBtree.Node.height) == LitInt(0));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> LitInt(0)
             <= KMBtree.NodeContents.nkeys(read(old($Heap), ##node#8, KMBtree.Node.contents)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> KMBtree.NodeContents.nkeys(read(old($Heap), ##node#8, KMBtree.Node.contents))
             <= LitInt(KMBtree.__default.MaxKeysPerLeaf()));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> LitInt(KMBtree.__default.MaxKeysPerLeaf())
             == _System.array.Length(KMBtree.NodeContents.keys(read(old($Heap), ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> _System.array.Length(KMBtree.NodeContents.values(read(old($Heap), ##node#8, KMBtree.Node.contents)))
             == _System.array.Length(KMBtree.NodeContents.keys(read(old($Heap), ##node#8, KMBtree.Node.contents))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> Lit(true));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            Lit(true)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              Set#Subset(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(##node#8)), 
                    $Box(KMBtree.NodeContents.pivots(read(old($Heap), ##node#8, KMBtree.Node.contents)))), 
                  $Box(children#8)), 
                read(old($Heap), ##node#8, KMBtree.Node.repr)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              0 < nchildren#8)));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              nchildren#8 <= LitInt(KMBtree.__default.MaxChildren()))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              LitInt(KMBtree.__default.MaxChildren()) == _System.array.Length(children#8))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              _System.array.Length(KMBtree.NodeContents.pivots(read(old($Heap), ##node#8, KMBtree.Node.contents)))
                 == LitInt(KMBtree.__default.MaxChildren() - 1))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              (forall i#72: int :: 
                { $Unbox(read(old($Heap), children#8, IndexField(i#72))): ref } 
                LitInt(0) <= i#72 && i#72 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#72 && i#72 < nchildren#8
                   ==> $Unbox(read(old($Heap), children#8, IndexField(i#72))): ref != null))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              KMBtree.__default.WFShapeChildren($LS($LS($LZ)), 
                old($Heap), 
                Seq#Take(Seq#FromArray(old($Heap), children#8), nchildren#8), 
                read(old($Heap), ##node#8, KMBtree.Node.repr), 
                read(old($Heap), ##node#8, KMBtree.Node.height)))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              (forall i#73: int :: 
                { $Unbox(read(old($Heap), children#8, IndexField(i#73))): ref } 
                LitInt(0) <= i#73 && i#73 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#73 && i#73 < nchildren#8
                   ==> !read(old($Heap), 
                    $Unbox(read(old($Heap), children#8, IndexField(i#73))): ref, 
                    KMBtree.Node.repr)[$Box(##node#8)]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              (forall i#74: int :: 
                { $Unbox(read(old($Heap), children#8, IndexField(i#74))): ref } 
                LitInt(0) <= i#74 && i#74 < 18446744073709551616
                   ==> 
                  LitInt(0) <= i#74 && i#74 < nchildren#8
                   ==> !read(old($Heap), 
                    $Unbox(read(old($Heap), children#8, IndexField(i#74))): ref, 
                    KMBtree.Node.repr)[$Box(KMBtree.NodeContents.pivots(read(old($Heap), ##node#8, KMBtree.Node.contents)))]))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              (forall i#75: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#8), nchildren#8), i#75)): ref } 
                    { $Unbox(read(old($Heap), children#8, IndexField(i#75))): ref } 
                  LitInt(0) <= i#75 && i#75 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#75 && i#75 < nchildren#8
                     ==> $Unbox(read(old($Heap), children#8, IndexField(i#75))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#8), nchildren#8), i#75)): ref)
                 ==> Lit(true))));
    assume {:subsumption 0} KMBtree.__default.WFShape#canCall(old($Heap), ##node#8)
       ==> KMBtree.__default.WFShape($LS($LZ), old($Heap), ##node#8)
         || (!KMBtree.NodeContents.Leaf_q(read(old($Heap), ##node#8, KMBtree.Node.contents))
           ==> (var nchildren#8 := KMBtree.NodeContents.nchildren(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
            (var children#8 := KMBtree.NodeContents.children(read(old($Heap), ##node#8, KMBtree.Node.contents)); 
              (forall i#75: int :: 
                  { $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#8), nchildren#8), i#75)): ref } 
                    { $Unbox(read(old($Heap), children#8, IndexField(i#75))): ref } 
                  LitInt(0) <= i#75 && i#75 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#75 && i#75 < nchildren#8
                     ==> $Unbox(read(old($Heap), children#8, IndexField(i#75))): ref
                       == $Unbox(Seq#Index(Seq#Take(Seq#FromArray(old($Heap), children#8), nchildren#8), i#75)): ref)
                 ==> (forall i#76: int :: 
                  { $Unbox(read(old($Heap), children#8, IndexField(i#76))): ref } 
                  LitInt(0) <= i#76 && i#76 < 18446744073709551616
                     ==> 
                    LitInt(0) <= i#76 && i#76 < nchildren#8
                     ==> !read(old($Heap), 
                      $Unbox(read(old($Heap), children#8, IndexField(i#76))): ref, 
                      KMBtree.Node.repr)[$Box(children#8)]))));
    assume KMBtree.__default.I#canCall(old($Heap), root#0);
    ##node#9 := KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), root#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##node#9, Tclass.KMBtreeModel.Node(), $Heap);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Seq#Length(KMBtreeModel.Node.keys(##node#9))
             == Seq#Length(KMBtreeModel.Node.values(##node#9)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.keys(##node#9)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Seq#Length(KMBtreeModel.Node.pivots(##node#9))
             == Seq#Length(KMBtreeModel.Node.children(##node#9)) - 1);
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            KMBtreeModel.Node.pivots(##node#9)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#77: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#77)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#77 && i#77 < Seq#Length(KMBtreeModel.Node.children(##node#9))
               ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#77)): DatatypeType)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#78: int :: 
            { $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#78)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#78 && i#78 < Seq#Length(KMBtreeModel.Node.children(##node#9))
               ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(##node#9), i#78)): DatatypeType), 
                Set#Empty(): Set Box)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#79: int :: 
            { KMBtreeModel.__default.AllKeysBelowBound(##node#9, i#79) } 
            true
               ==> 
              LitInt(0) <= i#79 && i#79 < Seq#Length(KMBtreeModel.Node.children(##node#9)) - 1
               ==> KMBtreeModel.__default.AllKeysBelowBound(##node#9, i#79)));
    assert {:subsumption 0} KMBtreeModel.__default.WF#canCall(##node#9)
       ==> KMBtreeModel.__default.WF($LS($LZ), ##node#9)
         || (!KMBtreeModel.Node.Leaf_q(##node#9)
           ==> (forall i#80: int :: 
            { KMBtreeModel.__default.AllKeysAboveBound(##node#9, i#80) } 
            true
               ==> 
              0 < i#80 && i#80 < Seq#Length(KMBtreeModel.Node.children(##node#9))
               ==> KMBtreeModel.__default.AllKeysAboveBound(##node#9, i#80)));
    assume KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), root#0));
    assume KMBtree.__default.I#canCall($Heap, newroot#0)
       && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0))
       && 
      KMBtree.__default.I#canCall(old($Heap), root#0)
       && KMBtreeModel.__default.Interpretation#canCall(KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), root#0));
    assume true;
    assume Map#Equal(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, $Heap, newroot#0)), 
      KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
        KMBtree.__default.I(StartFuel_KMBtree._default.I, old($Heap), root#0)));
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1239,27)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<Value>
    // TrCallStmt: Before ProcessCallStmt
    assume defass#newroot#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    node##0 := newroot#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := key#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := value#0;
    assume (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == node##0 || read($Heap, node##0, KMBtree.Node.repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$KMBtree.__default.InsertNode(node##0, key##0, value##0);
    // TrCallStmt: After ProcessCallStmt
    oldvalue#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/lib/DataStructures/MutableBtree.i.dfy[KMBtree](1239,47)"} true;
    assert defass#newroot#0;
}



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$KMBtree.__default.reveal__SeqRepr();
  free requires 14 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_KMBtree._default.SeqRepr0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$KMBtree.__default.reveal__SeqRepr();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_KMBtree._default.SeqRepr == $LS(MoreFuel_KMBtree._default.SeqRepr0);
  free ensures StartFuelAssert_KMBtree._default.SeqRepr
     == $LS($LS(MoreFuel_KMBtree._default.SeqRepr0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_KMBtree._default.SeqRepr0)
     == MoreFuel_KMBtree._default.SeqRepr0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$KMBtree.__default.reveal__I();
  free requires 20 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_KMBtree._default.I0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$KMBtree.__default.reveal__I();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_KMBtree._default.I == $LS(MoreFuel_KMBtree._default.I0);
  free ensures StartFuelAssert_KMBtree._default.I == $LS($LS(MoreFuel_KMBtree._default.I0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_KMBtree._default.I0) == MoreFuel_KMBtree._default.I0;



const unique class.KMBtree.Node?: ClassName;

// Node: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KMBtree.Node?()) } 
  $Is($o, Tclass.KMBtree.Node?())
     <==> $o == null || dtype($o) == Tclass.KMBtree.Node?());

// Node: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KMBtree.Node?(), $h) } 
  $IsAlloc($o, Tclass.KMBtree.Node?(), $h) <==> $o == null || read($h, $o, alloc));

const KMBtree.Node.contents: Field DatatypeType;

// Node.contents: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, KMBtree.Node.contents) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.KMBtree.Node?()
     ==> $Is(read($h, $o, KMBtree.Node.contents), Tclass.KMBtree.NodeContents()));

// Node.contents: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, KMBtree.Node.contents) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.KMBtree.Node?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, KMBtree.Node.contents), Tclass.KMBtree.NodeContents(), $h));

const KMBtree.Node.repr: Field (Set Box);

// Node.repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, KMBtree.Node.repr) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.KMBtree.Node?()
     ==> $Is(read($h, $o, KMBtree.Node.repr), TSet(Tclass._System.object())));

// Node.repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, KMBtree.Node.repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.KMBtree.Node?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, KMBtree.Node.repr), TSet(Tclass._System.object()), $h));

const KMBtree.Node.height: Field int;

// Node.height: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, KMBtree.Node.height) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.KMBtree.Node?()
     ==> $Is(read($h, $o, KMBtree.Node.height), Tclass._System.nat()));

// Node.height: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, KMBtree.Node.height) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.KMBtree.Node?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, KMBtree.Node.height), Tclass._System.nat(), $h));

// KMBtree.Node: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.KMBtree.Node()) } 
  $Is(c#0, Tclass.KMBtree.Node())
     <==> $Is(c#0, Tclass.KMBtree.Node?()) && c#0 != null);

// KMBtree.Node: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.KMBtree.Node(), $h) } 
  $IsAlloc(c#0, Tclass.KMBtree.Node(), $h)
     <==> $IsAlloc(c#0, Tclass.KMBtree.Node?(), $h));

// Constructor function declaration
function #KMBtree.NodeContents.Leaf(int, ref, ref) : DatatypeType;

const unique ##KMBtree.NodeContents.Leaf: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: ref, a#0#2#0: ref :: 
  { #KMBtree.NodeContents.Leaf(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#KMBtree.NodeContents.Leaf(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##KMBtree.NodeContents.Leaf);

function KMBtree.NodeContents.Leaf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { KMBtree.NodeContents.Leaf_q(d) } 
  KMBtree.NodeContents.Leaf_q(d)
     <==> DatatypeCtorId(d) == ##KMBtree.NodeContents.Leaf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { KMBtree.NodeContents.Leaf_q(d) } 
  KMBtree.NodeContents.Leaf_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: ref, a#1#2#0: ref :: 
      d == #KMBtree.NodeContents.Leaf(a#1#0#0, a#1#1#0, a#1#2#0)));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: ref, a#2#2#0: ref :: 
  { $Is(#KMBtree.NodeContents.Leaf(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.KMBtree.NodeContents()) } 
  $Is(#KMBtree.NodeContents.Leaf(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.KMBtree.NodeContents())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $Is(a#2#2#0, Tclass._System.array(Tclass.ValueMessage.Message())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: ref, a#3#2#0: ref, $h: Heap :: 
  { $IsAlloc(#KMBtree.NodeContents.Leaf(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.KMBtree.NodeContents(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#KMBtree.NodeContents.Leaf(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.KMBtree.NodeContents(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $h)
         && $IsAlloc(a#3#2#0, Tclass._System.array(Tclass.ValueMessage.Message()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtree.NodeContents.nkeys(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      KMBtree.NodeContents.Leaf_q(d)
       && $IsAlloc(d, Tclass.KMBtree.NodeContents(), $h)
     ==> $IsAlloc(KMBtree.NodeContents.nkeys(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtree.NodeContents.keys(d), 
      Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      KMBtree.NodeContents.Leaf_q(d)
       && $IsAlloc(d, Tclass.KMBtree.NodeContents(), $h)
     ==> $IsAlloc(KMBtree.NodeContents.keys(d), 
      Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtree.NodeContents.values(d), 
      Tclass._System.array(Tclass.ValueMessage.Message()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      KMBtree.NodeContents.Leaf_q(d)
       && $IsAlloc(d, Tclass.KMBtree.NodeContents(), $h)
     ==> $IsAlloc(KMBtree.NodeContents.values(d), 
      Tclass._System.array(Tclass.ValueMessage.Message()), 
      $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: ref, a#4#2#0: ref :: 
  { #KMBtree.NodeContents.Leaf(LitInt(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0)) } 
  #KMBtree.NodeContents.Leaf(LitInt(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0))
     == Lit(#KMBtree.NodeContents.Leaf(a#4#0#0, a#4#1#0, a#4#2#0)));

function KMBtree.NodeContents.nkeys(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: ref, a#5#2#0: ref :: 
  { #KMBtree.NodeContents.Leaf(a#5#0#0, a#5#1#0, a#5#2#0) } 
  KMBtree.NodeContents.nkeys(#KMBtree.NodeContents.Leaf(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

function KMBtree.NodeContents.keys(DatatypeType) : ref;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: ref, a#6#2#0: ref :: 
  { #KMBtree.NodeContents.Leaf(a#6#0#0, a#6#1#0, a#6#2#0) } 
  KMBtree.NodeContents.keys(#KMBtree.NodeContents.Leaf(a#6#0#0, a#6#1#0, a#6#2#0))
     == a#6#1#0);

function KMBtree.NodeContents.values(DatatypeType) : ref;

// Constructor injectivity
axiom (forall a#7#0#0: int, a#7#1#0: ref, a#7#2#0: ref :: 
  { #KMBtree.NodeContents.Leaf(a#7#0#0, a#7#1#0, a#7#2#0) } 
  KMBtree.NodeContents.values(#KMBtree.NodeContents.Leaf(a#7#0#0, a#7#1#0, a#7#2#0))
     == a#7#2#0);

// Constructor function declaration
function #KMBtree.NodeContents.Index(int, ref, ref) : DatatypeType;

const unique ##KMBtree.NodeContents.Index: DtCtorId;

// Constructor identifier
axiom (forall a#8#0#0: int, a#8#1#0: ref, a#8#2#0: ref :: 
  { #KMBtree.NodeContents.Index(a#8#0#0, a#8#1#0, a#8#2#0) } 
  DatatypeCtorId(#KMBtree.NodeContents.Index(a#8#0#0, a#8#1#0, a#8#2#0))
     == ##KMBtree.NodeContents.Index);

function KMBtree.NodeContents.Index_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { KMBtree.NodeContents.Index_q(d) } 
  KMBtree.NodeContents.Index_q(d)
     <==> DatatypeCtorId(d) == ##KMBtree.NodeContents.Index);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { KMBtree.NodeContents.Index_q(d) } 
  KMBtree.NodeContents.Index_q(d)
     ==> (exists a#9#0#0: int, a#9#1#0: ref, a#9#2#0: ref :: 
      d == #KMBtree.NodeContents.Index(a#9#0#0, a#9#1#0, a#9#2#0)));

// Constructor $Is
axiom (forall a#10#0#0: int, a#10#1#0: ref, a#10#2#0: ref :: 
  { $Is(#KMBtree.NodeContents.Index(a#10#0#0, a#10#1#0, a#10#2#0), 
      Tclass.KMBtree.NodeContents()) } 
  $Is(#KMBtree.NodeContents.Index(a#10#0#0, a#10#1#0, a#10#2#0), 
      Tclass.KMBtree.NodeContents())
     <==> $Is(a#10#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#10#1#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
       && $Is(a#10#2#0, Tclass._System.array(Tclass.KMBtree.Node?())));

// Constructor $IsAlloc
axiom (forall a#11#0#0: int, a#11#1#0: ref, a#11#2#0: ref, $h: Heap :: 
  { $IsAlloc(#KMBtree.NodeContents.Index(a#11#0#0, a#11#1#0, a#11#2#0), 
      Tclass.KMBtree.NodeContents(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#KMBtree.NodeContents.Index(a#11#0#0, a#11#1#0, a#11#2#0), 
        Tclass.KMBtree.NodeContents(), 
        $h)
       <==> $IsAlloc(a#11#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#11#1#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $h)
         && $IsAlloc(a#11#2#0, Tclass._System.array(Tclass.KMBtree.Node?()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtree.NodeContents.nchildren(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      KMBtree.NodeContents.Index_q(d)
       && $IsAlloc(d, Tclass.KMBtree.NodeContents(), $h)
     ==> $IsAlloc(KMBtree.NodeContents.nchildren(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtree.NodeContents.pivots(d), 
      Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      KMBtree.NodeContents.Index_q(d)
       && $IsAlloc(d, Tclass.KMBtree.NodeContents(), $h)
     ==> $IsAlloc(KMBtree.NodeContents.pivots(d), 
      Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtree.NodeContents.children(d), 
      Tclass._System.array(Tclass.KMBtree.Node?()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      KMBtree.NodeContents.Index_q(d)
       && $IsAlloc(d, Tclass.KMBtree.NodeContents(), $h)
     ==> $IsAlloc(KMBtree.NodeContents.children(d), 
      Tclass._System.array(Tclass.KMBtree.Node?()), 
      $h));

// Constructor literal
axiom (forall a#12#0#0: int, a#12#1#0: ref, a#12#2#0: ref :: 
  { #KMBtree.NodeContents.Index(LitInt(a#12#0#0), Lit(a#12#1#0), Lit(a#12#2#0)) } 
  #KMBtree.NodeContents.Index(LitInt(a#12#0#0), Lit(a#12#1#0), Lit(a#12#2#0))
     == Lit(#KMBtree.NodeContents.Index(a#12#0#0, a#12#1#0, a#12#2#0)));

function KMBtree.NodeContents.nchildren(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#13#0#0: int, a#13#1#0: ref, a#13#2#0: ref :: 
  { #KMBtree.NodeContents.Index(a#13#0#0, a#13#1#0, a#13#2#0) } 
  KMBtree.NodeContents.nchildren(#KMBtree.NodeContents.Index(a#13#0#0, a#13#1#0, a#13#2#0))
     == a#13#0#0);

function KMBtree.NodeContents.pivots(DatatypeType) : ref;

// Constructor injectivity
axiom (forall a#14#0#0: int, a#14#1#0: ref, a#14#2#0: ref :: 
  { #KMBtree.NodeContents.Index(a#14#0#0, a#14#1#0, a#14#2#0) } 
  KMBtree.NodeContents.pivots(#KMBtree.NodeContents.Index(a#14#0#0, a#14#1#0, a#14#2#0))
     == a#14#1#0);

function KMBtree.NodeContents.children(DatatypeType) : ref;

// Constructor injectivity
axiom (forall a#15#0#0: int, a#15#1#0: ref, a#15#2#0: ref :: 
  { #KMBtree.NodeContents.Index(a#15#0#0, a#15#1#0, a#15#2#0) } 
  KMBtree.NodeContents.children(#KMBtree.NodeContents.Index(a#15#0#0, a#15#1#0, a#15#2#0))
     == a#15#2#0);

// Depth-one case-split function
function $IsA#KMBtree.NodeContents(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#KMBtree.NodeContents(d) } 
  $IsA#KMBtree.NodeContents(d)
     ==> KMBtree.NodeContents.Leaf_q(d) || KMBtree.NodeContents.Index_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { KMBtree.NodeContents.Index_q(d), $Is(d, Tclass.KMBtree.NodeContents()) } 
    { KMBtree.NodeContents.Leaf_q(d), $Is(d, Tclass.KMBtree.NodeContents()) } 
  $Is(d, Tclass.KMBtree.NodeContents())
     ==> KMBtree.NodeContents.Leaf_q(d) || KMBtree.NodeContents.Index_q(d));

// Datatype extensional equality declaration
function KMBtree.NodeContents#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #KMBtree.NodeContents.Leaf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { KMBtree.NodeContents#Equal(a, b), KMBtree.NodeContents.Leaf_q(a) } 
    { KMBtree.NodeContents#Equal(a, b), KMBtree.NodeContents.Leaf_q(b) } 
  KMBtree.NodeContents.Leaf_q(a) && KMBtree.NodeContents.Leaf_q(b)
     ==> (KMBtree.NodeContents#Equal(a, b)
       <==> KMBtree.NodeContents.nkeys(a) == KMBtree.NodeContents.nkeys(b)
         && KMBtree.NodeContents.keys(a) == KMBtree.NodeContents.keys(b)
         && KMBtree.NodeContents.values(a) == KMBtree.NodeContents.values(b)));

// Datatype extensional equality definition: #KMBtree.NodeContents.Index
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { KMBtree.NodeContents#Equal(a, b), KMBtree.NodeContents.Index_q(a) } 
    { KMBtree.NodeContents#Equal(a, b), KMBtree.NodeContents.Index_q(b) } 
  KMBtree.NodeContents.Index_q(a) && KMBtree.NodeContents.Index_q(b)
     ==> (KMBtree.NodeContents#Equal(a, b)
       <==> KMBtree.NodeContents.nchildren(a) == KMBtree.NodeContents.nchildren(b)
         && KMBtree.NodeContents.pivots(a) == KMBtree.NodeContents.pivots(b)
         && KMBtree.NodeContents.children(a) == KMBtree.NodeContents.children(b)));

// Datatype extensionality axiom: KMBtree.NodeContents
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { KMBtree.NodeContents#Equal(a, b) } 
  KMBtree.NodeContents#Equal(a, b) <==> a == b);

const unique class.KMBtree.NodeContents: ClassName;

// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#21#0#0: Box :: 
  { #Options.Option.Some(a#21#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#21#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#22#0#0: Box :: d == #Options.Option.Some(a#22#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#23#0#0: Box :: 
  { $Is(#Options.Option.Some(a#23#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#23#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#23#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#24#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#24#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#24#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#24#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#25#0#0: Box :: 
  { #Options.Option.Some(Lit(a#25#0#0)) } 
  #Options.Option.Some(Lit(a#25#0#0)) == Lit(#Options.Option.Some(a#25#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#26#0#0: Box :: 
  { #Options.Option.Some(a#26#0#0) } 
  Options.Option.value(#Options.Option.Some(a#26#0#0)) == a#26#0#0);

// Inductive rank
axiom (forall a#27#0#0: Box :: 
  { #Options.Option.Some(a#27#0#0) } 
  BoxRank(a#27#0#0) < DtRank(#Options.Option.Some(a#27#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#3 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#3)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#3 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#3)): DatatypeType)));

function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#2: Box :: 
          $IsBox($y#2, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#2] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#3: Box :: 
          $IsBox($y#3, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#3] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#2: Box :: 
          $IsBox($y#2, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#2] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#3: Box :: 
          $IsBox($y#3, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#3] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#2: int, j#2: int :: 
          { Seq#Index(a#0, j#2), Seq#Index(a#0, i#2) } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#2
               && j#2 < Seq#Length(a#0)
               && i#2 != j#2
             ==> Seq#Index(a#0, i#2) != Seq#Index(a#0, j#2)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#3: int, j#3: int :: 
          { Seq#Index(a#0, j#3), Seq#Index(a#0, i#3) } 
          true
             ==> 
            LitInt(0) <= i#3
               && i#3 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#3
               && j#3 < Seq#Length(Lit(a#0))
               && i#3 != j#3
             ==> Seq#Index(Lit(a#0), i#3) != Seq#Index(Lit(a#0), j#3)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#3 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#3));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#4 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#4));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#5 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#5));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#1)): int } 
          LitInt(0) <= i#1 && i#1 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#1)): int == i#1)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#4: int :: 
            { Seq#Index(run#0, i#4) } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#4))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#5: int :: 
          { Seq#Index(run#0, i#5) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#5) } 
          true
             ==> 
            LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#5)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#5)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#6: int :: 
        { Seq#Index(run#0, i#6) } 
        true
           ==> 
          LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#6))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#6: int :: 
            { Seq#Index(run#0, i#6) } 
            true
               ==> 
              LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#6))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#4: int :: 
            { Seq#Index(run#0, i#4) } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#4))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#5: int :: 
          { Seq#Index(run#0, i#5) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#5) } 
          true
             ==> 
            LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#5)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#5)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#6: int :: 
        { Seq#Index(run#0, i#6) } 
        true
           ==> 
          LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#6))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#6: int :: 
            { Seq#Index(run#0, i#6) } 
            true
               ==> 
              LitInt(0) <= i#6 && i#6 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#6))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x1#0: Box, _o1#0: ref :: 
            $IsBox(_x1#0, Sequences._default.Filter$E)
               && $Is(_o1#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x1#0)[$Box(_o1#0)]
               && $Box($o) == $Box(_o1#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#3))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#4: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#4) } 
          LitInt(0) <= i#4
             ==> 
            i#4
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#4))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#4))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#5: int :: 
        { Seq#Index(run#0, i#5) } 
        true
           ==> 
          LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#5))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#5: int :: 
            { Seq#Index(run#0, i#5) } 
            true
               ==> 
              LitInt(0) <= i#5 && i#5 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#5))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#2) } 
          LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#3) } 
          pos#0 <= i#3 && i#3 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#3)
               == Seq#Index(s#0, i#3 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(s#0, i#3) } 
          true
             ==> 
            pos#0 <= i#3 && i#3 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#3 + 1)
               == Seq#Index(s#0, i#3))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(s#0, i#3) } 
          true
             ==> 
            pos#0 < i#3 && i#3 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#3 + 1)
               == Seq#Index(s#0, i#3))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#2: int :: 
          { Seq#Index(s#0, i#2) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#2)
               == Seq#Index(s#0, i#2))
         && (forall i#3: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#3) } 
          true
             ==> 
            pos#0 < i#3 && i#3 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#3)
               == Seq#Index(s#0, i#3 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#2: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#2) } 
            { Seq#Index(a#0, i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#2)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#2))
         && (forall i#3: int :: 
          { Seq#Index(b#0, i#3) } 
          true
             ==> 
            LitInt(0) <= i#3 && i#3 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#3)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#3))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#2: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#2) } 
            { Seq#Index(a#0, i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#2)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#2))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#3: int :: 
          { Seq#Index(c#0, i#3) } 
          true
             ==> 
            LitInt(0) <= i#3 && i#3 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#3)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#3))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#1: int :: 
            { Seq#Index(run#0, j#1) } 
            i#0 <= j#1 && j#1 < Seq#Length(run#0) ==> Seq#Index(run#0, j#1) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#1) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#1) } 
          LitInt(0) <= i#1
               && i#1
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#1)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
            { Seq#Index(a#0, i#1) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#1)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#1)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#1), Seq#Index(b#0, i#1))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(z#0, i#1)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#1) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#1), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#1)), 
              $Unbox(Seq#Index(z#0, i#1)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#2, b#2 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#2, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#2, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#3, b#3 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#3, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#3, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(seqs#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#1)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#1)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape2: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape2)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape2))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape2)
           == MoreFuel_Sequences._default.FlattenShape2
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape3: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape3)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape3))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape3)
           == MoreFuel_Sequences._default.FlattenShape3
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength2: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength2)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength2))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength2)
           == MoreFuel_Sequences._default.FlattenLength2
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength3: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength3)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength3))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength3)
           == MoreFuel_Sequences._default.FlattenLength3
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#1) } 
          LitInt(0) <= i#1 && i#1 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#1)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));

const unique class.Maps.__default: ClassName;

function Tclass.Maps.__default() : Ty;

// Tclass.Maps.__default Tag
axiom Tag(Tclass.Maps.__default()) == Tagclass.Maps.__default;

const unique Tagclass.Maps.__default: TyTag;

// Box/unbox axiom for Tclass.Maps.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Maps.__default()) } 
  $IsBox(bx, Tclass.Maps.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Maps.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Maps.__default()) } 
  $Is($o, Tclass.Maps.__default())
     <==> $o == null || dtype($o) == Tclass.Maps.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Maps.__default(), $h) } 
  $IsAlloc($o, Tclass.Maps.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Maps._default.IMapsTo
function Maps.__default.IMapsTo(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsTo
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> true);

function Maps.__default.IMapsTo#requires(Ty, Ty, IMap Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsTo
axiom (forall Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
       && $IsBox(k#0, Maps._default.IMapsTo$K)
       && $IsBox(v#0, Maps._default.IMapsTo$V)
     ==> Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.IMapsTo(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.IMapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsTo
function Maps.__default.MapsTo(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsTo
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> true);

function Maps.__default.MapsTo#requires(Ty, Ty, Map Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.MapsTo
axiom (forall Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
       && $IsBox(k#0, Maps._default.MapsTo$K)
       && $IsBox(v#0, Maps._default.MapsTo$V)
     ==> Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.MapsTo(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsAgreeOnKey
function Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsAgreeOnKey
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> true);

function Maps.__default.MapsAgreeOnKey#requires(Ty, Ty, Map Box Box, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapsAgreeOnKey
axiom (forall Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K)
     ==> Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.MapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(m#0)[k#0] == Map#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[k#0] == Map#Elements(Lit(m'#0))[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[Lit(k#0)] == Map#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IMapsAgreeOnKey
function Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsAgreeOnKey
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> true);

function Maps.__default.IMapsAgreeOnKey#requires(Ty, Ty, IMap Box Box, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsAgreeOnKey
axiom (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K)
     ==> Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(m#0)[k#0] == IMap#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.IMapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
        Maps._default.IMapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(Lit(m#0))[Lit(k#0)] == IMap#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IsSubIMap
function Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

function Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubIMap
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> true);

function Maps.__default.IsSubIMap#requires(Ty, Ty, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IsSubIMap
axiom (forall Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box :: 
  { Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
  $Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
       && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
     ==> Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubIMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
           ==> (forall key#2: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2) } 
              { IMap#Domain(sub#0)[key#2] } 
            $IsBox(key#2, Maps._default.IsSubIMap$K)
               ==> 
              IMap#Domain(sub#0)[key#2]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
           == (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
             && (forall key#2: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2) } 
                { IMap#Domain(sub#0)[key#2] } 
              $IsBox(key#2, Maps._default.IsSubIMap$K)
                 ==> 
                IMap#Domain(sub#0)[key#2]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#2))));

// definition axiom for Maps.__default.IsSubIMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
           ==> (forall key#3: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#3) } 
              { IMap#Domain(sub#0)[key#3] } 
            $IsBox(key#3, Maps._default.IsSubIMap$K)
               ==> 
              Lit(IMap#Domain(Lit(sub#0)))[key#3]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, 
                Maps._default.IsSubIMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#3)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
           == (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
             && (forall key#3: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#3) } 
                { IMap#Domain(sub#0)[key#3] } 
              $IsBox(key#3, Maps._default.IsSubIMap$K)
                 ==> 
                Lit(IMap#Domain(Lit(sub#0)))[key#3]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, 
                  Maps._default.IsSubIMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#3))));

// function declaration for Maps._default.IsSubMap
function Maps.__default.IsSubMap(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

function Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubMap
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> true);

function Maps.__default.IsSubMap#requires(Ty, Ty, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.IsSubMap
axiom (forall Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box :: 
  { Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
  $Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
       && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
     ==> Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
           ==> (forall key#2: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2) } 
              { Map#Domain(sub#0)[key#2] } 
            $IsBox(key#2, Maps._default.IsSubMap$K)
               ==> 
              Map#Domain(sub#0)[key#2]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
           == (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
             && (forall key#2: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2) } 
                { Map#Domain(sub#0)[key#2] } 
              $IsBox(key#2, Maps._default.IsSubMap$K)
                 ==> 
                Map#Domain(sub#0)[key#2]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#2))));

// definition axiom for Maps.__default.IsSubMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    {:weight 3} { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
           ==> (forall key#3: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#3) } 
              { Map#Domain(sub#0)[key#3] } 
            $IsBox(key#3, Maps._default.IsSubMap$K)
               ==> 
              Lit(Map#Domain(Lit(sub#0)))[key#3]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, 
                Maps._default.IsSubMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#3)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
           == (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
             && (forall key#3: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#3) } 
                { Map#Domain(sub#0)[key#3] } 
              $IsBox(key#3, Maps._default.IsSubMap$K)
                 ==> 
                Lit(Map#Domain(Lit(sub#0)))[key#3]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, 
                  Maps._default.IsSubMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#3))));

// function declaration for Maps._default.MapRemove
function Maps.__default.MapRemove(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
      Maps._default.MapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemove
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> (forall k#2: Box :: 
          { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#2] } 
            { ks#0[k#2] } 
            { Map#Domain(m#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(m#0)[k#2] && !ks#0[k#2]
             ==> Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#2])
         && (forall k#3: Box :: 
          { ks#0[k#3] } 
            { Map#Domain(m#0)[k#3] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#3] } 
          $IsBox(k#3, Maps._default.MapRemove$K)
             ==> (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#3]
                 ==> Map#Domain(m#0)[k#3])
               && (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#3]
                 ==> !ks#0[k#3]))
         && (forall j#2: Box :: 
          { Map#Elements(m#0)[j#2] } 
            { Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2] } 
          $IsBox(j#2, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2]
             ==> Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#2]
               == Map#Elements(m#0)[j#2])
         && Set#Card(Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)));

function Maps.__default.MapRemove#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemove
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
       && $Is(ks#0, TSet(Maps._default.MapRemove$K))
     ==> Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRemove(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
         == (var m'#2 := Map#Glue((lambda $w#5: Box :: 
                $IsBox($w#5, Maps._default.MapRemove$K) && Map#Domain(m#0)[$w#5] && !ks#0[$w#5]), 
              (lambda $w#5: Box :: Map#Elements(m#0)[$w#5]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#2));

// definition axiom for Maps.__default.MapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
        Maps._default.MapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, 
          Maps._default.MapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == (var m'#3 := Map#Glue((lambda $w#7: Box :: 
                $IsBox($w#7, Maps._default.MapRemove$K)
                   && 
                  Map#Domain(m#0)[$w#7]
                   && !Lit(ks#0)[$w#7]), 
              (lambda $w#7: Box :: Map#Elements(Lit(m#0))[$w#7]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#3));

// function declaration for Maps._default.MapRemoveStrong
function Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemoveStrong
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)), 
          Set#Difference(Map#Domain(m#0), ks#0))
         && (forall j#1: Box :: 
          { Map#Elements(m#0)[j#1] } 
            { Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1] } 
            { Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemoveStrong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1]
             ==> Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#1]
               == Map#Elements(m#0)[j#1])
         && Set#Card(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V)));

function Maps.__default.MapRemoveStrong#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemoveStrong
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
       && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K))
     ==> Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
       == true);

const MoreFuel_Maps._default.MapRemove2: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        m#0, 
        ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove2)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove2))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove2)
           == MoreFuel_Maps._default.MapRemove2
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            m#0, 
            ks#0)
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            m#0, 
            ks#0));

const MoreFuel_Maps._default.MapRemove3: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove3)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove3))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove3)
           == MoreFuel_Maps._default.MapRemove3
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(ks#0))
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            Lit(m#0), 
            Lit(ks#0)));

// function declaration for Maps._default.MapRemove1
function Maps.__default.MapRemove1(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
      Maps._default.MapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.MapRemove1
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> (forall j#4: Box :: 
          { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#4] } 
            { Map#Domain(m#0)[j#4] } 
          $IsBox(j#4, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(m#0)[j#4] && j#4 != k#0
             ==> Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#4])
         && (forall j#5: Box :: 
          { Map#Domain(m#0)[j#5] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#5] } 
          $IsBox(j#5, Maps._default.MapRemove1$K)
             ==> (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#5]
                 ==> Map#Domain(m#0)[j#5])
               && (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#5]
                 ==> j#5 != k#0))
         && (forall j#6: Box :: 
          { Map#Elements(m#0)[j#6] } 
            { Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6] } 
          $IsBox(j#6, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6]
             ==> Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#6]
               == Map#Elements(m#0)[j#6])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)))
           <= Set#Card(Map#Domain(m#0))
         && (Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0) - 1)
         && (!Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0))
         && $Is(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0), 
          TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)));

function Maps.__default.MapRemove1#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
       && $IsBox(k#0, Maps._default.MapRemove1$K)
     ==> Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.MapRemove1(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
         == (var m'#3 := Map#Glue((lambda $w#7: Box :: 
                $IsBox($w#7, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#7] && $w#7 != k#0), 
              (lambda $w#7: Box :: Map#Elements(m#0)[$w#7]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#3));

// definition axiom for Maps.__default.MapRemove1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0)
         == (var m'#4 := Map#Glue((lambda $w#9: Box :: 
                $IsBox($w#9, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#9] && $w#9 != k#0), 
              (lambda $w#9: Box :: Map#Elements(Lit(m#0))[$w#9]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#4));

// definition axiom for Maps.__default.MapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
        Maps._default.MapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
          Maps._default.MapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == (var m'#5 := Map#Glue((lambda $w#11: Box :: 
                $IsBox($w#11, Maps._default.MapRemove1$K)
                   && 
                  Map#Domain(m#0)[$w#11]
                   && $w#11 != k#0), 
              (lambda $w#11: Box :: Map#Elements(Lit(m#0))[$w#11]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#5));

// function declaration for Maps._default.MapRemove1Strong
function Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LZ, 
      m#0, 
      k#0));

// consequence axiom for Maps.__default.MapRemove1Strong
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0)), 
          Set#Difference(Map#Domain(m#0), Set#UnionOne(Set#Empty(): Set Box, k#0)))
         && (forall j#1: Box :: 
          { Map#Elements(m#0)[j#1] } 
            { Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#1] } 
            { Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemove1Strong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#1]
             ==> Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                  Maps._default.MapRemove1Strong$V, 
                  $ly, 
                  m#0, 
                  k#0))[j#1]
               == Map#Elements(m#0)[j#1])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $ly, 
            m#0, 
            k#0), 
          TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V)));

function Maps.__default.MapRemove1Strong#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1Strong
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
       && $IsBox(k#0, Maps._default.MapRemove1Strong$K)
     ==> Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0)
       == true);

const MoreFuel_Maps._default.MapRemove13: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove13)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove13))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove13)
           == MoreFuel_Maps._default.MapRemove13
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            m#0, 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            m#0, 
            k#0));

const MoreFuel_Maps._default.MapRemove14: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove14)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove14))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove14)
           == MoreFuel_Maps._default.MapRemove14
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            k#0));

const MoreFuel_Maps._default.MapRemove15: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove15)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove15))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove15)
           == MoreFuel_Maps._default.MapRemove15
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(k#0))
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            Lit(k#0)));

// function declaration for Maps._default.IMapRemove
function Maps.__default.IMapRemove(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
      Maps._default.IMapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.IMapRemove
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)), 
          ISet#Difference(IMap#Domain(m#0), ks#0))
         && (forall j#2: Box :: 
          { IMap#Elements(m#0)[j#2] } 
            { IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2] } 
            { IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2] } 
          $IsBox(j#2, Maps._default.IMapRemove$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2]
             ==> IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#2]
               == IMap#Elements(m#0)[j#2])
         && $Is(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

function Maps.__default.IMapRemove#requires(Ty, Ty, LayerType, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRemove
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
       && $Is(ks#0, TISet(Maps._default.IMapRemove$K))
     ==> Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRemove(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#2]
               && !ks#0[$w#2]), 
          (lambda $w#2: Box :: IMap#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// definition axiom for Maps.__default.IMapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
        Maps._default.IMapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
          Maps._default.IMapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#3]
               && !Lit(ks#0)[$w#3]), 
          (lambda $w#3: Box :: IMap#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// function declaration for Maps._default.IMapRemove1
function Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box)
   : IMap Box Box;

function Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
      Maps._default.IMapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.IMapRemove1
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)), 
          ISet#Difference(IMap#Domain(m#0), ISet#UnionOne(ISet#Empty(): ISet Box, k#0)))
         && (forall j#2: Box :: 
          { IMap#Elements(m#0)[j#2] } 
            { IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2] } 
            { IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2] } 
          $IsBox(j#2, Maps._default.IMapRemove1$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2]
             ==> IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#2]
               == IMap#Elements(m#0)[j#2])
         && $Is(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

function Maps.__default.IMapRemove1#requires(Ty, Ty, LayerType, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapRemove1
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
       && $IsBox(k#0, Maps._default.IMapRemove1$K)
     ==> Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapRemove1(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#2]
               && $w#2 != k#0), 
          (lambda $w#2: Box :: IMap#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// definition axiom for Maps.__default.IMapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
        Maps._default.IMapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
          Maps._default.IMapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#3]
               && $w#3 != k#0), 
          (lambda $w#3: Box :: IMap#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// function declaration for Maps._default.MapRestrict
function Maps.__default.MapRestrict(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// consequence axiom for Maps.__default.MapRestrict
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> $Is(Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

function Maps.__default.MapRestrict#requires(Ty, Ty, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRestrict
axiom (forall Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
       && $Is(ks#0, TSet(Maps._default.MapRestrict$K))
     ==> Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapRestrict$K) && ks#0[$w#2] && Map#Domain(m#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(m#0)[$w#2]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// definition axiom for Maps.__default.MapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapRestrict$K)
               && 
              Lit(ks#0)[$w#3]
               && Map#Domain(m#0)[$w#3]), 
          (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// function declaration for Maps._default.MapIRestrict
function Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : Map Box Box;

function Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.MapIRestrict
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> $Is(Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

function Maps.__default.MapIRestrict#requires(Ty, Ty, Map Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.MapIRestrict
axiom (forall Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
       && $Is(ks#0, TISet(Maps._default.MapIRestrict$K))
     ==> Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapIRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#3]
               && ks#0[$w#3]), 
          (lambda $w#3: Box :: Map#Elements(m#0)[$w#3]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         == Map#Glue((lambda $w#4: Box :: 
            $IsBox($w#4, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#4]
               && ks#0[$w#4]), 
          (lambda $w#4: Box :: Map#Elements(Lit(m#0))[$w#4]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#5: Box :: 
            $IsBox($w#5, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#5]
               && Lit(ks#0)[$w#5]), 
          (lambda $w#5: Box :: Map#Elements(Lit(m#0))[$w#5]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// function declaration for Maps._default.IMapRestrict
function Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.IMapRestrict
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> $Is(Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0), 
        TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

function Maps.__default.IMapRestrict#requires(Ty, Ty, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRestrict
axiom (forall Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
       && $Is(ks#0, TISet(Maps._default.IMapRestrict$K))
     ==> Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRestrict(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapRestrict$K)
               && 
              ks#0[$w#2]
               && IMap#Domain(m#0)[$w#2]), 
          (lambda $w#2: Box :: IMap#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// definition axiom for Maps.__default.IMapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapRestrict$K)
               && 
              Lit(ks#0)[$w#3]
               && IMap#Domain(m#0)[$w#3]), 
          (lambda $w#3: Box :: IMap#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// function declaration for Maps._default.MapDisjointUnion
function Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapDisjointUnion
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
              Maps._default.MapDisjointUnion$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#2: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Elements(mapa#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#2]
             ==> Map#Elements(mapa#0)[k#2]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2])
         && (forall k#3: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { Map#Elements(mapb#0)[k#3] } 
            { Map#Domain(mapb#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#3]
             ==> Map#Elements(mapb#0)[k#3]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3])
         && $Is(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
            Maps._default.MapDisjointUnion$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

function Maps.__default.MapDisjointUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
     ==> Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)));

// definition axiom for Maps.__default.MapDisjointUnion(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapDisjointUnion$U)
               && (Map#Domain(mapa#0)[$w#2] || Map#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapa#0)[$w#2]
               then Map#Elements(mapa#0)[$w#2]
               else Map#Elements(mapb#0)[$w#2])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// definition axiom for Maps.__default.MapDisjointUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapDisjointUnion$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#3] || Lit(Map#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapa#0)[$w#3]
               then Map#Elements(Lit(mapa#0))[$w#3]
               else Map#Elements(Lit(mapb#0))[$w#3])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// function declaration for Maps._default.MapUnionPreferA
function Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferA
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
              Maps._default.MapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { Map#Elements(mapa#0)[k#3] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { Map#Domain(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#3]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == Map#Elements(mapa#0)[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(mapb#0)[k#4] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapb#0)[k#4] && !Map#Domain(mapa#0)[k#4]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == Map#Elements(mapb#0)[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(mapa#0)[k#5] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { Map#Domain(mapb#0)[k#5] } 
            { Map#Domain(mapa#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#5] && !Map#Domain(mapb#0)[k#5]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == Map#Elements(mapa#0)[k#5])
         && $Is(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
            Maps._default.MapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

function Maps.__default.MapUnionPreferA#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferA
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
     ==> Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapUnionPreferA$U)
               && (Map#Domain(mapa#0)[$w#2] || Map#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapa#0)[$w#2]
               then Map#Elements(mapa#0)[$w#2]
               else Map#Elements(mapb#0)[$w#2])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// definition axiom for Maps.__default.MapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapUnionPreferA$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#3] || Lit(Map#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapa#0)[$w#3]
               then Map#Elements(Lit(mapa#0))[$w#3]
               else Map#Elements(Lit(mapb#0))[$w#3])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// function declaration for Maps._default.MapUnionPreferB
function Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferB
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
              Maps._default.MapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { Map#Elements(mapb#0)[k#3] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { Map#Domain(mapb#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapb#0)[k#3]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == Map#Elements(mapb#0)[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(mapa#0)[k#4] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#4] && !Map#Domain(mapb#0)[k#4]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == Map#Elements(mapa#0)[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(mapa#0)[k#5] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { Map#Domain(mapb#0)[k#5] } 
            { Map#Domain(mapa#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#5] && !Map#Domain(mapb#0)[k#5]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == Map#Elements(mapa#0)[k#5])
         && $Is(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
            Maps._default.MapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

function Maps.__default.MapUnionPreferB#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferB
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
     ==> Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapUnionPreferB$U)
               && (Map#Domain(mapa#0)[$w#2] || Map#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapb#0)[$w#2]
               then Map#Elements(mapb#0)[$w#2]
               else Map#Elements(mapa#0)[$w#2])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// definition axiom for Maps.__default.MapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapUnionPreferB$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#3] || Lit(Map#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapb#0)[$w#3]
               then Map#Elements(Lit(mapb#0))[$w#3]
               else Map#Elements(Lit(mapa#0))[$w#3])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// function declaration for Maps._default.MapUnion
function Maps.__default.MapUnion(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
      Maps._default.MapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.MapUnion
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#3] } 
            { Map#Elements(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#3] && !Map#Domain(mapb#0)[k#3]
             ==> Map#Elements(mapa#0)[k#3]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#4] } 
            { Map#Elements(mapb#0)[k#4] } 
          $IsBox(k#4, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#4] && !Map#Domain(mapa#0)[k#4]
             ==> Map#Elements(mapb#0)[k#4]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(mapa#0)[k#5] } 
            { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#5] } 
            { Map#Elements(mapb#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#5] && Map#Domain(mapb#0)[k#5]
             ==> Map#Elements(mapb#0)[k#5]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#5]
               || Map#Elements(mapa#0)[k#5]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#5])
         && $Is(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0), 
          TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)));

function Maps.__default.MapUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnion
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
     ==> Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnion(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.MapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
        Maps._default.MapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.IMapUnionPreferA
function Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferA
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
              Maps._default.IMapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { IMap#Elements(mapa#0)[k#3] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { IMap#Domain(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapa#0)[k#3]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == IMap#Elements(mapa#0)[k#3])
         && (forall k#4: Box :: 
          { IMap#Elements(mapb#0)[k#4] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#4] && !IMap#Domain(mapa#0)[k#4]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == IMap#Elements(mapb#0)[k#4])
         && (forall k#5: Box :: 
          { IMap#Elements(mapb#0)[k#5] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { IMap#Domain(mapa#0)[k#5] } 
            { IMap#Domain(mapb#0)[k#5] } 
          $IsBox(k#5, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#5] && !IMap#Domain(mapa#0)[k#5]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == IMap#Elements(mapb#0)[k#5])
         && $Is(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
            Maps._default.IMapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

function Maps.__default.IMapUnionPreferA#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferA
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
     ==> Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapUnionPreferA$U)
               && (IMap#Domain(mapa#0)[$w#2] || IMap#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if IMap#Domain(mapa#0)[$w#2]
               then IMap#Elements(mapa#0)[$w#2]
               else IMap#Elements(mapb#0)[$w#2])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// definition axiom for Maps.__default.IMapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapUnionPreferA$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#3] || Lit(IMap#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if IMap#Domain(mapa#0)[$w#3]
               then IMap#Elements(Lit(mapa#0))[$w#3]
               else IMap#Elements(Lit(mapb#0))[$w#3])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// function declaration for Maps._default.IMapUnionPreferB
function Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferB
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
              Maps._default.IMapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { IMap#Elements(mapb#0)[k#3] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#3] } 
            { IMap#Domain(mapb#0)[k#3] } 
          $IsBox(k#3, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapb#0)[k#3]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#3]
               == IMap#Elements(mapb#0)[k#3])
         && (forall k#4: Box :: 
          { IMap#Elements(mapa#0)[k#4] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#4] } 
          $IsBox(k#4, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#4] && !IMap#Domain(mapb#0)[k#4]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#4]
               == IMap#Elements(mapa#0)[k#4])
         && (forall k#5: Box :: 
          { IMap#Elements(mapa#0)[k#5] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#5] } 
            { IMap#Domain(mapb#0)[k#5] } 
            { IMap#Domain(mapa#0)[k#5] } 
          $IsBox(k#5, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#5] && !IMap#Domain(mapb#0)[k#5]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#5]
               == IMap#Elements(mapa#0)[k#5])
         && $Is(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
            Maps._default.IMapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

function Maps.__default.IMapUnionPreferB#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferB
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
     ==> Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.IMapUnionPreferB$U)
               && (IMap#Domain(mapa#0)[$w#2] || IMap#Domain(mapb#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if IMap#Domain(mapb#0)[$w#2]
               then IMap#Elements(mapb#0)[$w#2]
               else IMap#Elements(mapa#0)[$w#2])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// definition axiom for Maps.__default.IMapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.IMapUnionPreferB$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#3] || Lit(IMap#Domain(Lit(mapb#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if IMap#Domain(mapb#0)[$w#3]
               then IMap#Elements(Lit(mapb#0))[$w#3]
               else IMap#Elements(Lit(mapa#0))[$w#3])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// function declaration for Maps._default.IMapUnion
function Maps.__default.IMapUnion(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
      Maps._default.IMapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.IMapUnion
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#3: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#3] } 
            { IMap#Elements(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#3] && !IMap#Domain(mapb#0)[k#3]
             ==> IMap#Elements(mapa#0)[k#3]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#3])
         && (forall k#4: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#4] } 
            { IMap#Elements(mapb#0)[k#4] } 
          $IsBox(k#4, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapb#0)[k#4] && !IMap#Domain(mapa#0)[k#4]
             ==> IMap#Elements(mapb#0)[k#4]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#4])
         && (forall k#5: Box :: 
          { IMap#Elements(mapa#0)[k#5] } 
            { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#5] } 
            { IMap#Elements(mapb#0)[k#5] } 
          $IsBox(k#5, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#5] && IMap#Domain(mapb#0)[k#5]
             ==> IMap#Elements(mapb#0)[k#5]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#5]
               || IMap#Elements(mapa#0)[k#5]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#5])
         && $Is(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0), 
          TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)));

function Maps.__default.IMapUnion#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnion
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
       && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
     ==> Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnion(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.IMapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
        Maps._default.IMapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.MapDisjointUnion3
function Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LZ, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// consequence axiom for Maps.__default.MapDisjointUnion3
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              $ly, 
              mapa#0, 
              mapb#0, 
              mapc#0)), 
          Set#Union(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
         && (!Set#Equal(Map#Domain(mapa#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapb#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapc#0), Set#Empty(): Set Box)
           ==> !Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0)), 
            Set#Empty(): Set Box))
         && (forall k#3: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#3] } 
            { Map#Elements(mapa#0)[k#3] } 
            { Map#Domain(mapa#0)[k#3] } 
          $IsBox(k#3, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapa#0)[k#3]
             ==> Map#Elements(mapa#0)[k#3]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#3])
         && (forall k#4: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#4] } 
            { Map#Elements(mapb#0)[k#4] } 
            { Map#Domain(mapb#0)[k#4] } 
          $IsBox(k#4, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapb#0)[k#4]
             ==> Map#Elements(mapb#0)[k#4]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#4])
         && (forall k#5: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#5] } 
            { Map#Elements(mapc#0)[k#5] } 
            { Map#Domain(mapc#0)[k#5] } 
          $IsBox(k#5, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapc#0)[k#5]
             ==> Map#Elements(mapc#0)[k#5]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#5])
         && 
        Map#Equal(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)))
         && Map#Equal(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapa#0, 
              mapb#0), 
            mapc#0))
         && $Is(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

function Maps.__default.MapDisjointUnion3#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion3
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  $Is(mapa#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapb#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapc#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
     ==> Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0)
       == (
        Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0))));

// definition axiom for Maps.__default.MapDisjointUnion3(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0, 
          mapc#0)
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapDisjointUnion3$U)
               && (
                Map#Domain(mapa#0)[$w#2]
                 || Map#Domain(mapb#0)[$w#2]
                 || Map#Domain(mapc#0)[$w#2])), 
          (lambda $w#2: Box :: 
            (if Map#Domain(mapa#0)[$w#2]
               then Map#Elements(mapa#0)[$w#2]
               else (if Map#Domain(mapb#0)[$w#2]
                 then Map#Elements(mapb#0)[$w#2]
                 else Map#Elements(mapc#0)[$w#2]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// definition axiom for Maps.__default.MapDisjointUnion3 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0), 
        Lit(mapc#0)) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Set#Union(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))), 
            Map#Domain(Lit(mapc#0))))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         == Map#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapDisjointUnion3$U)
               && (
                Lit(Map#Domain(Lit(mapa#0)))[$w#3]
                 || Lit(Map#Domain(Lit(mapb#0)))[$w#3]
                 || Lit(Map#Domain(Lit(mapc#0)))[$w#3])), 
          (lambda $w#3: Box :: 
            (if Map#Domain(mapa#0)[$w#3]
               then Map#Elements(Lit(mapa#0))[$w#3]
               else (if Map#Domain(mapb#0)[$w#3]
                 then Map#Elements(Lit(mapb#0))[$w#3]
                 else Map#Elements(Lit(mapc#0))[$w#3]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// function declaration for Maps._default.MapToImap
function Maps.__default.MapToImap(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : IMap Box Box;

function Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.MapToImap
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> $Is(Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0), 
        TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

function Maps.__default.MapToImap#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapToImap
axiom (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
  { Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
  $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
     ==> Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
       == true);

// definition axiom for Maps.__default.MapToImap(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         == IMap#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(m#0)[$w#2]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// definition axiom for Maps.__default.MapToImap for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0)) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         == IMap#Glue((lambda $w#3: Box :: 
            $IsBox($w#3, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#3]), 
          (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// function declaration for Maps._default.MapLookupOption
function Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapLookupOption
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> $Is(Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.MapLookupOption$V)));

function Maps.__default.MapLookupOption#requires(Ty, Ty, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapLookupOption
axiom (forall Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box :: 
  { Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
       && $IsBox(key#0, Maps._default.MapLookupOption$K)
     ==> Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.MapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

// function declaration for Maps._default.ImapLookupOption
function Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.ImapLookupOption
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> $Is(Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.ImapLookupOption$V)));

function Maps.__default.ImapLookupOption#requires(Ty, Ty, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.ImapLookupOption
axiom (forall Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box :: 
  { Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
       && $IsBox(key#0, Maps._default.ImapLookupOption$K)
     ==> Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.ImapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.ImapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
        Maps._default.ImapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

const unique class.SeqComparison.__default: ClassName;

function Tclass.SeqComparison.__default() : Ty;

// Tclass.SeqComparison.__default Tag
axiom Tag(Tclass.SeqComparison.__default()) == Tagclass.SeqComparison.__default;

const unique Tagclass.SeqComparison.__default: TyTag;

// Box/unbox axiom for Tclass.SeqComparison.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SeqComparison.__default()) } 
  $IsBox(bx, Tclass.SeqComparison.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SeqComparison.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SeqComparison.__default()) } 
  $Is($o, Tclass.SeqComparison.__default())
     <==> $o == null || dtype($o) == Tclass.SeqComparison.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SeqComparison.__default(), $h) } 
  $IsAlloc($o, Tclass.SeqComparison.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for SeqComparison._default.lte
function SeqComparison.__default.lte($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
  SeqComparison.__default.lte($LS($ly), a#0, b#0)
     == SeqComparison.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  SeqComparison.__default.lte($ly, a#0, b#0)
     == SeqComparison.__default.lte($LZ, a#0, b#0));

// consequence axiom for SeqComparison.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($ly, a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lte
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lte#requires($ly, a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int <= $Unbox(Seq#Index(a#0, LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(a#0, LitInt(0))): int <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(a#0, LitInt(0))): int < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int < $Unbox(Seq#Index(a#0, LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($ly, Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0)
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(Lit(b#0)) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(Lit(b#0)) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))))));

// function declaration for SeqComparison._default.lt
function SeqComparison.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for SeqComparison.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lt#requires(a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && SeqComparison.__default.lt(a#0, b#0)
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0)
             && !Seq#Equal(a#0, b#0)));

// definition axiom for SeqComparison.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lt(Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && SeqComparison.__default.lt(Lit(a#0), Lit(b#0))
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

const unique class.NativeArrays.__default: ClassName;

function Tclass.NativeArrays.__default() : Ty;

// Tclass.NativeArrays.__default Tag
axiom Tag(Tclass.NativeArrays.__default()) == Tagclass.NativeArrays.__default;

const unique Tagclass.NativeArrays.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArrays.__default()) } 
  $IsBox(bx, Tclass.NativeArrays.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArrays.__default()) } 
  $Is($o, Tclass.NativeArrays.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArrays.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure {:extern "NativeArrays_Compile", "newArrayFill"} CheckWellformed$$NativeArrays.__default.newArrayFill(NativeArrays._default.newArrayFill$T: Ty, 
    n#0: int where LitInt(0) <= n#0 && n#0 < 18446744073709551616, 
    t#0: Box
       where $IsBox(t#0, NativeArrays._default.newArrayFill$T)
         && $IsAllocBox(t#0, NativeArrays._default.newArrayFill$T, $Heap))
   returns (ar#0: ref
       where $Is(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T))
         && $IsAlloc(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "newArrayFill"} Call$$NativeArrays.__default.newArrayFill(NativeArrays._default.newArrayFill$T: Ty, 
    n#0: int where LitInt(0) <= n#0 && n#0 < 18446744073709551616, 
    t#0: Box
       where $IsBox(t#0, NativeArrays._default.newArrayFill$T)
         && $IsAllocBox(t#0, NativeArrays._default.newArrayFill$T, $Heap))
   returns (ar#0: ref
       where $Is(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T))
         && $IsAlloc(ar#0, Tclass._System.array(NativeArrays._default.newArrayFill$T), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures _System.array.Length(ar#0) == n#0;
  free ensures true;
  ensures (forall i#0: int :: 
    { read($Heap, ar#0, IndexField(i#0)) } 
    LitInt(0) <= i#0 && i#0 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < n#0
       ==> read($Heap, ar#0, IndexField(i#0)) == t#0);
  free ensures true;
  ensures ar#0 != null && !read(old($Heap), ar#0, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:extern "NativeArrays_Compile", "CopySeqIntoArray"} CheckWellformed$$NativeArrays.__default.CopySeqIntoArray(NativeArrays._default.CopySeqIntoArray$A: Ty, 
    src#0: Seq Box
       where $Is(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:extern "NativeArrays_Compile", "CopySeqIntoArray"} Call$$NativeArrays.__default.CopySeqIntoArray(NativeArrays._default.CopySeqIntoArray$A: Ty, 
    src#0: Seq Box
       where $Is(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(src#0, TSeq(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    srcIndex#0: int
       where LitInt(0) <= srcIndex#0 && srcIndex#0 < 18446744073709551616, 
    dst#0: ref
       where $Is(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A))
         && $IsAlloc(dst#0, Tclass._System.array(NativeArrays._default.CopySeqIntoArray$A), $Heap), 
    dstIndex#0: int
       where LitInt(0) <= dstIndex#0 && dstIndex#0 < 18446744073709551616, 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  // user-defined preconditions
  requires srcIndex#0 + len#0 <= Seq#Length(src#0);
  requires dstIndex#0 + len#0 <= _System.array.Length(dst#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall i#0: int :: 
    { Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0) } 
      { read($Heap, dst#0, IndexField(i#0)) } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 < _System.array.Length(dst#0)
       ==> read($Heap, dst#0, IndexField(i#0))
         == (if dstIndex#0 <= i#0 && i#0 < dstIndex#0 + len#0
           then Seq#Index(src#0, i#0 - dstIndex#0 + srcIndex#0)
           else Seq#Index(Seq#FromArray(old($Heap), dst#0), i#0)));
  free ensures true;
  ensures (forall i#1: int :: 
    { Seq#Index(src#0, i#1) } 
    true
       ==> 
      srcIndex#0 <= i#1 && i#1 < srcIndex#0 + len#0
       ==> Seq#Index(src#0, i#1)
         == read($Heap, dst#0, IndexField(i#1 - srcIndex#0 + dstIndex#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == dst#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



const unique class.Byte__Order.__default: ClassName;

function Tclass.Byte__Order.__default() : Ty;

// Tclass.Byte__Order.__default Tag
axiom Tag(Tclass.Byte__Order.__default()) == Tagclass.Byte__Order.__default;

const unique Tagclass.Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Byte__Order.__default()) } 
  $Is($o, Tclass.Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Byte_Order._default.SomeElement
function Byte__Order.__default.SomeElement() : int;

function Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Byte__Order.__default.SomeElement()
     && Byte__Order.__default.SomeElement() < 256;

function Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Byte__Order.__default.SomeElement
axiom Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Byte__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Byte__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// function declaration for Byte_Order._default.lte
function Byte__Order.__default.lte($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
  Byte__Order.__default.lte($LS($ly), a#0, b#0)
     == Byte__Order.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.lte($ly, a#0, b#0)
     == Byte__Order.__default.lte($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($ly, a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (forall a#3: int, b#3: int, c#2: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, c#2), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#3, c#2) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#3, c#2), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, b#3) } 
          LitInt(0) <= a#3
               && a#3 < 256
               && 
              LitInt(0) <= b#3
               && b#3 < 256
               && 
              LitInt(0) <= c#2
               && c#2 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, b#3)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#3, c#2)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#3, c#2))
         && Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
             && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#4: int, b#4: int, c#3: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, c#3), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#4, c#3) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#4, c#3), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, b#4) } 
          LitInt(0) <= a#4
               && a#4 < 256
               && 
              LitInt(0) <= b#4
               && b#4 < 256
               && 
              LitInt(0) <= c#3
               && c#3 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, b#4)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#4, c#3)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#4, c#3)));

function Byte__Order.__default.lte#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.lte
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lte#requires($ly, a#0, b#0) == true);

const MoreFuel_Byte_Order._default.ltedef2: LayerType;

// definition axiom for Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef2)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef2))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef2)
           == MoreFuel_Byte_Order._default.ltedef2
         && Byte__Order.__default.lte($LS($ly), a#0, b#0) == (a#0 <= b#0));

const MoreFuel_Byte_Order._default.ltedef3: LayerType;

// definition axiom for Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef3)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef3))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef3)
           == MoreFuel_Byte_Order._default.ltedef3
         && Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0))
           == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.ltedef
function Byte__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Byte__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($ly, a#0, b#0)
     == Byte__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($ly, a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.LargestLte
function Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted8: LayerType;

// definition axiom for Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted8)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted8)
           == MoreFuel_Byte_Order._default.IsSorted8
         && Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted9: LayerType;

// definition axiom for Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted9)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted9)
           == MoreFuel_Byte_Order._default.IsSorted9
         && Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.LargestLt
function Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted10: LayerType;

// definition axiom for Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              needle#0, 
              $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted10)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted10)
           == MoreFuel_Byte_Order._default.IsSorted10
         && Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                needle#0, 
                $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted11: LayerType;

// definition axiom for Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(needle#0), 
              $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted11)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted11)
           == MoreFuel_Byte_Order._default.IsSorted11
         && Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt(needle#0), 
                $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.IndexOfFirstGte
function Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted12: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted12)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted12)
           == MoreFuel_Byte_Order._default.IsSorted12
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted13: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted13)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted13)
           == MoreFuel_Byte_Order._default.IsSorted13
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              key#0, 
              $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(key#0), 
              $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.IndexOfFirstGt
function Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted14: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted14)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted14)
           == MoreFuel_Byte_Order._default.IsSorted14
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted15: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted15)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted15)
           == MoreFuel_Byte_Order._default.IsSorted15
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, 
              key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, 
                  key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, 
              LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, 
                  LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.SetAllLte
function Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#2: int, y#2: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#2, y#2) } 
            { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
             ==> 
            b#0[$Box(y#2)]
             ==> Byte__Order.__default.lte#canCall(x#2, y#2))
         && Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#2, y#2) } 
              { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#2, y#2)));

// definition axiom for Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#3: int, y#3: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#3, y#3) } 
            { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Byte__Order.__default.lte#canCall(x#3, y#3))
         && Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#3, y#3) } 
              { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#3, y#3)));

// function declaration for Byte_Order._default.SetAllLt
function Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#2: int, y#2: int :: 
          { Byte__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
             ==> 
            b#0[$Box(y#2)]
             ==> Byte__Order.__default.lt#canCall(x#2, y#2))
         && Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Byte__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            LitInt(0) <= x#2 && x#2 < 256 && LitInt(0) <= y#2 && y#2 < 256
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Byte__Order.__default.lt(x#2, y#2)));

// definition axiom for Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#3: int, y#3: int :: 
          { Byte__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Byte__Order.__default.lt#canCall(x#3, y#3))
         && Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Byte__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            LitInt(0) <= x#3 && x#3 < 256 && LitInt(0) <= y#3 && y#3 < 256
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Byte__Order.__default.lt(x#3, y#3)));

// function declaration for Byte_Order._default.NotMinimum
function Byte__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Byte__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Byte__Order.__default.NotMinimum($ly, a#0)
     == Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($ly, a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> true);

function Byte__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 256
     ==> Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#2: int :: 
          { Byte__Order.__default.lt(b#2, a#0) } 
          LitInt(0) <= b#2 && b#2 < 256 ==> Byte__Order.__default.lt#canCall(b#2, a#0))
         && Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: int :: 
            { Byte__Order.__default.lt(b#2, a#0) } 
            LitInt(0) <= b#2 && b#2 < 256 && Byte__Order.__default.lt(b#2, a#0)));

// definition axiom for Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Byte__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#3: int :: 
          { Byte__Order.__default.lt(b#3, a#0) } 
          LitInt(0) <= b#3 && b#3 < 256
             ==> Byte__Order.__default.lt#canCall(b#3, LitInt(a#0)))
         && Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#3: int :: 
            { Byte__Order.__default.lt(b#3, a#0) } 
            LitInt(0) <= b#3 && b#3 < 256 && Byte__Order.__default.lt(b#3, LitInt(a#0))));

// function declaration for Byte_Order._default.MapPivotedUnion
function Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)));

function Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.MapPivotedUnion
axiom (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 256
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
     ==> Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: int :: 
          { Byte__Order.__default.lt(k#4, pivot#0) } 
          LitInt(0) <= k#4 && k#4 < 256 ==> Byte__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#12): int, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#15): int, pivot#0))); 
          (forall k#5: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#5) } 
              LitInt(0) <= k#5 && k#5 < 256
                 ==> Byte__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#13): int)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#14): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#16): int, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#17): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: int :: 
          { Byte__Order.__default.lt(k#6, pivot#0) } 
          LitInt(0) <= k#6 && k#6 < 256
             ==> Byte__Order.__default.lt#canCall(k#6, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#18): int, LitInt(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#21): int, LitInt(pivot#0)))); 
          (forall k#7: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#7) } 
              LitInt(0) <= k#7 && k#7 < 256
                 ==> Byte__Order.__default.lte#canCall(LitInt(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#19): int)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#20): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#22): int, LitInt(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#23): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Byte_Order._default.SetSuccessor
function Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#4_next(m: Set Box, key: int) : int;

function $let#4$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#4_next(m, key) } 
  $let#4$canCall(m, key)
     ==> LitInt(0) <= $let#4_next(m, key)
       && $let#4_next(m, key) < 256
       && 
      m[$Box($let#4_next(m, key))]
       && Byte__Order.__default.lt(key, $let#4_next(m, key))
       && (forall other#4: int :: 
        { Byte__Order.__default.lt($let#4_next(m, key), other#4) } 
          { Byte__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        LitInt(0) <= other#4 && other#4 < 256
           ==> 
          m[$Box(other#4)]
             && other#4 != $let#4_next(m, key)
             && Byte__Order.__default.lt(key, other#4)
           ==> Byte__Order.__default.lt($let#4_next(m, key), other#4)));

// definition axiom for Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#4: int :: 
          { Byte__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
          LitInt(0) <= next#4 && next#4 < 256
             ==> (m#0[$Box(next#4)] ==> Byte__Order.__default.lt#canCall(key#0, next#4))
               && (Byte__Order.__default.lt#canCall(key#0, next#4)
                   && Byte__Order.__default.lt(key#0, next#4)
                 ==> (forall other#3: int :: 
                  { Byte__Order.__default.lt(next#4, other#3) } 
                    { Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  LitInt(0) <= other#3 && other#3 < 256
                     ==> (other#3 != next#4 ==> Byte__Order.__default.lt#canCall(key#0, other#3))
                       && (Byte__Order.__default.lt#canCall(key#0, other#3)
                           && Byte__Order.__default.lt(key#0, other#3)
                         ==> Byte__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: int :: 
            { Byte__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
            LitInt(0) <= next#4
               && next#4 < 256
               && 
              m#0[$Box(next#4)]
               && Byte__Order.__default.lt(key#0, next#4)
               && (forall other#3: int :: 
                { Byte__Order.__default.lt(next#4, other#3) } 
                  { Byte__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                LitInt(0) <= other#3 && other#3 < 256
                   ==> 
                  m#0[$Box(other#3)]
                     && other#3 != next#4
                     && Byte__Order.__default.lt(key#0, other#3)
                   ==> Byte__Order.__default.lt(next#4, other#3)))
           ==> $let#4$canCall(m#0, key#0))
         && Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: int :: 
              { Byte__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
              LitInt(0) <= next#4
                 && next#4 < 256
                 && 
                m#0[$Box(next#4)]
                 && Byte__Order.__default.lt(key#0, next#4)
                 && (forall other#3: int :: 
                  { Byte__Order.__default.lt(next#4, other#3) } 
                    { Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  LitInt(0) <= other#3 && other#3 < 256
                     ==> 
                    m#0[$Box(other#3)]
                       && other#3 != next#4
                       && Byte__Order.__default.lt(key#0, other#3)
                     ==> Byte__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#4_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#6: int :: 
          { Byte__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
          LitInt(0) <= next#6 && next#6 < 256
             ==> (Lit(m#0)[$Box(next#6)]
                 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), next#6))
               && (Byte__Order.__default.lt#canCall(LitInt(key#0), next#6)
                   && Byte__Order.__default.lt(LitInt(key#0), next#6)
                 ==> (forall other#5: int :: 
                  { Byte__Order.__default.lt(next#6, other#5) } 
                    { Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  LitInt(0) <= other#5 && other#5 < 256
                     ==> (other#5 != next#6 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), other#5))
                       && (Byte__Order.__default.lt#canCall(LitInt(key#0), other#5)
                           && Byte__Order.__default.lt(LitInt(key#0), other#5)
                         ==> Byte__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: int :: 
            { Byte__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
            LitInt(0) <= next#6
               && next#6 < 256
               && 
              Lit(m#0)[$Box(next#6)]
               && Byte__Order.__default.lt(LitInt(key#0), next#6)
               && (forall other#5: int :: 
                { Byte__Order.__default.lt(next#6, other#5) } 
                  { Byte__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                LitInt(0) <= other#5 && other#5 < 256
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && other#5 != next#6
                     && Byte__Order.__default.lt(LitInt(key#0), other#5)
                   ==> Byte__Order.__default.lt(next#6, other#5)))
           ==> $let#4$canCall(Lit(m#0), LitInt(key#0)))
         && Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#6: int :: 
              { Byte__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
              LitInt(0) <= next#6
                 && next#6 < 256
                 && 
                Lit(m#0)[$Box(next#6)]
                 && Byte__Order.__default.lt(LitInt(key#0), next#6)
                 && (forall other#5: int :: 
                  { Byte__Order.__default.lt(next#6, other#5) } 
                    { Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  LitInt(0) <= other#5 && other#5 < 256
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && other#5 != next#6
                       && Byte__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Byte__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#4_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Byte_Order._default.MapSuccessor
function Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> $Is(Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Byte__Order.__default.MapSuccessor
axiom (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Byte_Order._default.SeqSuccessor
function Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: 
            $IsBox($y#4, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#4)), 
          key#0)
         && Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Byte__Order.__default.SetSuccessor((lambda $y#5: Box :: 
              $IsBox($y#5, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#5)), 
            key#0));

// definition axiom for Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#6)), 
          LitInt(key#0))
         && Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Byte__Order.__default.SetSuccessor((lambda $y#7: Box :: 
              $IsBox($y#7, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#7)), 
            LitInt(key#0)));

// function declaration for Byte_Order._default.SortedSeqForMap
function Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.SortedSeqForMap
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V))
     ==> Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: int :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            LitInt(0) <= key#2 && key#2 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                         == key#2
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: int :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              LitInt(0) <= key#2 && key#2 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                       == key#2
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: int :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            LitInt(0) <= key#3 && key#3 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                         == key#3
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: int :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              LitInt(0) <= key#3 && key#3 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                       == key#3
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Byte_Order._default.minimum
function Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum($LS($ly), s#0) } 
  Byte__Order.__default.minimum($LS($ly), s#0)
     == Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimum($ly, s#0)
     == Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimum($ly, s#0) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#1: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#1))
         && 
        LitInt(0) <= Byte__Order.__default.minimum($ly, s#0)
         && Byte__Order.__default.minimum($ly, s#0) < 256);

function Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#7_a(s: Set Box) : int;

function $let#7$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#7_a(s) } 
  $let#7$canCall(s)
     ==> LitInt(0) <= $let#7_a(s) && $let#7_a(s) < 256 && s[$Box($let#7_a(s))]);

// definition axiom for Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#7$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#7_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Byte__Order.__default.minimum($ly, s'#4); 
                Byte__Order.__default.lt#canCall($let#7_a(s#0), m'#4)))
         && Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#7_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Byte__Order.__default.minimum($ly, s'#5); 
                  (if Byte__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#7$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#7_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Byte__Order.__default.minimum($LS($ly), s'#6); 
                Byte__Order.__default.lt#canCall($let#7_a(Lit(s#0)), m'#6)))
         && Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#7_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Byte__Order.__default.minimum($LS($ly), s'#7); 
                  (if Byte__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Byte_Order._default.minimumOpt
function Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimumOpt($ly, s#0)
     == Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($ly, s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1)))
         && (Options.Option.None_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(s#0))
         && Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, s#0)))));

// definition axiom for Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Byte_Order._default.maximum
function Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum($LS($ly), s#0) } 
  Byte__Order.__default.maximum($LS($ly), s#0)
     == Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximum($ly, s#0)
     == Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximum($ly, s#0) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#1: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#1, Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#1, Byte__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Byte__Order.__default.maximum($ly, s#0)
         && Byte__Order.__default.maximum($ly, s#0) < 256);

function Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#10_a(s: Set Box) : int;

function $let#10$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#10_a(s) } 
  $let#10$canCall(s)
     ==> LitInt(0) <= $let#10_a(s) && $let#10_a(s) < 256 && s[$Box($let#10_a(s))]);

// definition axiom for Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#10$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#10_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Byte__Order.__default.maximum($ly, s'#4); 
                Byte__Order.__default.lt#canCall(m'#4, $let#10_a(s#0))))
         && Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#10_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Byte__Order.__default.maximum($ly, s'#5); 
                  (if Byte__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#10$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#10_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Byte__Order.__default.maximum($LS($ly), s'#6); 
                Byte__Order.__default.lt#canCall(m'#6, $let#10_a(Lit(s#0)))))
         && Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#10_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Byte__Order.__default.maximum($LS($ly), s'#7); 
                  (if Byte__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Byte_Order._default.maximumOpt
function Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximumOpt($ly, s#0)
     == Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($ly, s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#1, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#1)] } 
            LitInt(0) <= y#1 && y#1 < 256 && s#0[$Box(y#1)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#1, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(s#0))
         && Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, s#0)))));

// definition axiom for Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Byte_Order._default.lt
function Byte__Order.__default.lt(a#0: int, b#0: int) : bool;

function Byte__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.lt(a#0, b#0)
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             && a#0 != b#0));

// definition axiom for Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             && a#0 != b#0));

// function declaration for Byte_Order._default.Min
function Byte__Order.__default.Min(a#0: int, b#0: int) : int;

function Byte__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Min(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0) < 256);

function Byte__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then a#0
             else b#0));

// definition axiom for Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then a#0
             else b#0));

// function declaration for Byte_Order._default.Max
function Byte__Order.__default.Max(a#0: int, b#0: int) : int;

function Byte__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Max(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0) < 256);

function Byte__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then b#0
             else a#0));

// definition axiom for Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then b#0
             else a#0));

// function declaration for Byte_Order._default.IsSorted
function Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsSorted($ly, run#0)
     == Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($ly, run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0) ==> Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1) ==> Byte__Order.__default.IsSorted($ly, run#0)));

function Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(run#0, i#2)): int, 
                $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(Lit(run#0), i#3)): int, 
                $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Byte_Order._default.IsStrictlySortedInternal
function Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Byte_Order._default.IsStrictlySorted
function Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0)));

function Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

const unique class.Lexicographic__Byte__Order.__default: ClassName;

function Tclass.Lexicographic__Byte__Order.__default() : Ty;

// Tclass.Lexicographic__Byte__Order.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order.__default())
   == Tagclass.Lexicographic__Byte__Order.__default;

const unique Tagclass.Lexicographic__Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Lexicographic_Byte_Order._default.SomeElement
function Lexicographic__Byte__Order.__default.SomeElement() : Seq Box;

function Lexicographic__Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> $Is(Lexicographic__Byte__Order.__default.SomeElement(), 
    TSeq(Tclass.NativeTypes.byte()));

function Lexicographic__Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom Lexicographic__Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement for all literals(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// function declaration for Lexicographic_Byte_Order._default.lte
function Lexicographic__Byte__Order.__default.lte(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lte
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (forall a#3: Seq Box, b#3: Seq Box, c#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#3, c#2), Lexicographic__Byte__Order.__default.ltedef(b#3, c#2) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#3, c#2), Lexicographic__Byte__Order.__default.ltedef(a#3, b#3) } 
          $Is(a#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#3, b#3)
               && Lexicographic__Byte__Order.__default.ltedef(b#3, c#2)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#3, c#2))
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
             && Lexicographic__Byte__Order.__default.ltedef(b#0, a#0)
           ==> Seq#Equal(a#0, b#0))
         && (forall a#4: Seq Box, b#4: Seq Box, c#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#4, c#3), Lexicographic__Byte__Order.__default.ltedef(b#4, c#3) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#4, c#3), Lexicographic__Byte__Order.__default.ltedef(a#4, b#4) } 
          $Is(a#4, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#4, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#4, b#4)
               && Lexicographic__Byte__Order.__default.ltedef(b#4, c#3)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#4, c#3)));

function Lexicographic__Byte__Order.__default.lte#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lte
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.ltedef
function Lexicographic__Byte__Order.__default.ltedef(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.ltedef#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.ltedef
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.ltedef#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.ltedef
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

procedure CheckWellformed$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLt(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  free requires 20 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLt(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, run#0);
  requires LitInt(0) <= i#0;
  requires i#0 < j#0;
  requires j#0 < Seq#Length(run#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box);
  free ensures Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)
     && 
    Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)
     && 
    Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)
     && !Seq#Equal($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Lexicographic_Byte_Order._default.LargestLte
function Lexicographic__Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0)
               <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0))): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted8: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted8)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted8)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted8
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted9: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted9)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted9)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted9
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

procedure {:_induction run#0, needle#0} CheckWellformed$$Lexicographic__Byte__Order.__default.LargestLteIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    pos#0: int);
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction run#0, needle#0} Call$$Lexicographic__Byte__Order.__default.LargestLteIsUnique(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    pos#0: int);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, run#0);
  requires LitInt(0 - 1) <= pos#0;
  requires pos#0 < Seq#Length(run#0);
  requires (forall i#0: int :: 
    { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
    true
       ==> 
      LitInt(0) <= i#0 && i#0 <= pos#0
       ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0));
  requires (forall i#1: int :: 
    { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
    true
       ==> 
      pos#0 < i#1 && i#1 < Seq#Length(run#0)
       ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0);
  ensures pos#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), run#0, needle#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Lexicographic_Byte_Order._default.LargestLt
function Lexicographic__Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1
               < Seq#Length(run#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted10: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted10)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted10)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted10
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted11: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted11)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted11)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted11
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGte
function Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          LitInt(0) <= i#2
               && i#2 < Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
                 <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted12: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted12)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted12)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted12
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted13: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted13)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted13)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted13
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lte(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGt
function Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          LitInt(0) <= i#2
               && i#2 < Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): Seq Box, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted14: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted14)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted14)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted14
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted15: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted15)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted15)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted15
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), mid#5, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.SetAllLte
function Lexicographic__Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#2: Seq Box, y#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#2, y#2) } 
            { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#2)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#2, y#2))
         && Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: Seq Box, y#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#2, y#2) } 
              { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Lexicographic__Byte__Order.__default.lte(x#2, y#2)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#3: Seq Box, y#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#3, y#3) } 
            { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#3, y#3))
         && Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: Seq Box, y#3: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#3, y#3) } 
              { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Lexicographic__Byte__Order.__default.lte(x#3, y#3)));

// function declaration for Lexicographic_Byte_Order._default.SetAllLt
function Lexicographic__Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#2: Seq Box, y#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#2, y#2) } 
            { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#2)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#2, y#2))
         && Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: Seq Box, y#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#2, y#2) } 
              { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            $Is(x#2, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#2, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Lexicographic__Byte__Order.__default.lt(x#2, y#2)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#3: Seq Box, y#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#3, y#3) } 
            { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#3)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#3, y#3))
         && Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: Seq Box, y#3: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#3, y#3) } 
              { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            $Is(x#3, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#3, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Lexicographic__Byte__Order.__default.lt(x#3, y#3)));

// function declaration for Lexicographic_Byte_Order._default.NotMinimum
function Lexicographic__Byte__Order.__default.NotMinimum($ly: LayerType, a#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Lexicographic__Byte__Order.__default.NotMinimum#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#2, a#0) } 
          $Is(b#2, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#2, a#0))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#2, a#0) } 
            $Is(b#2, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#2, a#0)));

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0)) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(Lit(a#0))
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#3: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#3, a#0) } 
          $Is(b#3, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#3, Lit(a#0)))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0))
           == (exists b#3: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#3, a#0) } 
            $Is(b#3, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#3, Lit(a#0))));

// function declaration for Lexicographic_Byte_Order._default.MapPivotedUnion
function Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : Map Box Box;

function Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0), 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value)));

function Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
      left#0, 
      pivot#0, 
      right#0) } 
  $Is(left#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(right#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
     ==> Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#4, pivot#0) } 
          $Is(k#4, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#12): Seq Box, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#15): Seq Box, pivot#0))); 
          (forall k#5: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#5) } 
              $Is(k#5, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#13): Seq Box)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#14): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            left#0, 
            pivot#0, 
            right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#16): Seq Box, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#17): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        Lit(pivot#0), 
        Lit(right#0)) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          Lit(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#6, pivot#0) } 
          $Is(k#6, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#6, Lit(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#18): Seq Box, Lit(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#21): Seq Box, Lit(pivot#0)))); 
          (forall k#7: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#7) } 
              $Is(k#7, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#19): Seq Box)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#20): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            Lit(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#22): Seq Box, Lit(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#23): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Lexicographic_Byte_Order._default.SetSuccessor
function Lexicographic__Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SetSuccessor#requires(Set Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#13_next(m: Set Box, key: Seq Box) : Seq Box;

function $let#13$canCall(m: Set Box, key: Seq Box) : bool;

axiom (forall m: Set Box, key: Seq Box :: 
  { $let#13_next(m, key) } 
  $let#13$canCall(m, key)
     ==> $Is($let#13_next(m, key), TSeq(Tclass.NativeTypes.byte()))
       && 
      m[$Box($let#13_next(m, key))]
       && Lexicographic__Byte__Order.__default.lt(key, $let#13_next(m, key))
       && (forall other#4: Seq Box :: 
        { Lexicographic__Byte__Order.__default.lt($let#13_next(m, key), other#4) } 
          { Lexicographic__Byte__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        $Is(other#4, TSeq(Tclass.NativeTypes.byte()))
           ==> 
          m[$Box(other#4)]
             && !Seq#Equal(other#4, $let#13_next(m, key))
             && Lexicographic__Byte__Order.__default.lt(key, other#4)
           ==> Lexicographic__Byte__Order.__default.lt($let#13_next(m, key), other#4)));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#4: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#4) } 
            { m#0[$Box(next#4)] } 
          $Is(next#4, TSeq(Tclass.NativeTypes.byte()))
             ==> (m#0[$Box(next#4)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#4))
               && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#4)
                   && Lexicographic__Byte__Order.__default.lt(key#0, next#4)
                 ==> (forall other#3: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#4, other#3) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  $Is(other#3, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#3, next#4)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#3))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#3)
                           && Lexicographic__Byte__Order.__default.lt(key#0, other#3)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#4) } 
              { m#0[$Box(next#4)] } 
            $Is(next#4, TSeq(Tclass.NativeTypes.byte()))
               && 
              m#0[$Box(next#4)]
               && Lexicographic__Byte__Order.__default.lt(key#0, next#4)
               && (forall other#3: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#4, other#3) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                $Is(other#3, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  m#0[$Box(other#3)]
                     && !Seq#Equal(other#3, next#4)
                     && Lexicographic__Byte__Order.__default.lt(key#0, other#3)
                   ==> Lexicographic__Byte__Order.__default.lt(next#4, other#3)))
           ==> $let#13$canCall(m#0, key#0))
         && Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#4) } 
                { m#0[$Box(next#4)] } 
              $Is(next#4, TSeq(Tclass.NativeTypes.byte()))
                 && 
                m#0[$Box(next#4)]
                 && Lexicographic__Byte__Order.__default.lt(key#0, next#4)
                 && (forall other#3: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#4, other#3) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  $Is(other#3, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    m#0[$Box(other#3)]
                       && !Seq#Equal(other#3, next#4)
                       && Lexicographic__Byte__Order.__default.lt(key#0, other#3)
                     ==> Lexicographic__Byte__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#13_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), Lit(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#6: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#6) } 
            { m#0[$Box(next#6)] } 
          $Is(next#6, TSeq(Tclass.NativeTypes.byte()))
             ==> (Lit(m#0)[$Box(next#6)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#6))
               && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#6)
                   && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#6)
                 ==> (forall other#5: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#6, other#5) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  $Is(other#5, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#5, next#6)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#5))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#5)
                           && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#5)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#6) } 
              { m#0[$Box(next#6)] } 
            $Is(next#6, TSeq(Tclass.NativeTypes.byte()))
               && 
              Lit(m#0)[$Box(next#6)]
               && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#6)
               && (forall other#5: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#6, other#5) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                $Is(other#5, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && !Seq#Equal(other#5, next#6)
                     && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#5)
                   ==> Lexicographic__Byte__Order.__default.lt(next#6, other#5)))
           ==> $let#13$canCall(Lit(m#0), Lit(key#0)))
         && Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0))
           == (if (exists next#6: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#6) } 
                { m#0[$Box(next#6)] } 
              $Is(next#6, TSeq(Tclass.NativeTypes.byte()))
                 && 
                Lit(m#0)[$Box(next#6)]
                 && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#6)
                 && (forall other#5: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#6, other#5) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  $Is(other#5, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && !Seq#Equal(other#5, next#6)
                       && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#5)
                     ==> Lexicographic__Byte__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#13_next(Lit(m#0), Lit(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Lexicographic_Byte_Order._default.MapSuccessor
function Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : DatatypeType;

function Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapSuccessor$V))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), Lit(key#0))
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
           == Lit(Lexicographic__Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), Lit(key#0))));

// function declaration for Lexicographic_Byte_Order._default.SeqSuccessor
function Lexicographic__Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SeqSuccessor#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: 
            $IsBox($y#4, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#4)), 
          key#0)
         && Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#5: Box :: 
              $IsBox($y#5, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#5)), 
            key#0));

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), Lit(key#0))
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: 
            $IsBox($y#6, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#6)), 
          Lit(key#0))
         && Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#7: Box :: 
              $IsBox($y#7, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#7)), 
            Lit(key#0)));

// function declaration for Lexicographic_Byte_Order._default.SortedSeqForMap
function Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V))
     ==> Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): Seq Box, 
                        key#2)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): Seq Box, 
                      key#2)
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
        $LS($ly), 
        Lit(s#0), 
        Lit(m#0)) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            $Is(key#3, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): Seq Box, 
                        key#3)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            $LS($ly), 
            Lit(s#0), 
            Lit(m#0))
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              $Is(key#3, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): Seq Box, 
                      key#3)
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Lexicographic_Byte_Order._default.minimum
function Lexicographic__Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#1))
         && $Is(Lexicographic__Byte__Order.__default.minimum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#16_a(s: Set Box) : Seq Box;

function $let#16$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#16_a(s) } 
  $let#16$canCall(s)
     ==> $Is($let#16_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#16_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#16$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#16_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Lexicographic__Byte__Order.__default.minimum($ly, s'#4); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#16_a(s#0), m'#4)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#16_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Lexicographic__Byte__Order.__default.minimum($ly, s'#5); 
                  (if Lexicographic__Byte__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Lexicographic__Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#16$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#16_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#6); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#16_a(Lit(s#0)), m'#6)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#16_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#7); 
                  (if Lexicographic__Byte__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Lexicographic_Byte_Order._default.minimumOpt
function Lexicographic__Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#1)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.maximum
function Lexicographic__Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(y#1, Lexicographic__Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lte(y#1, Lexicographic__Byte__Order.__default.maximum($ly, s#0)))
         && $Is(Lexicographic__Byte__Order.__default.maximum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#19_a(s: Set Box) : Seq Box;

function $let#19$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#19_a(s) } 
  $let#19$canCall(s)
     ==> $Is($let#19_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#19_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#19$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#19_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Lexicographic__Byte__Order.__default.maximum($ly, s'#4); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#4, $let#19_a(s#0))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#19_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Lexicographic__Byte__Order.__default.maximum($ly, s'#5); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Lexicographic__Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#19$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#19_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#6); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#6, $let#19_a(Lit(s#0)))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#19_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#7); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Lexicographic_Byte_Order._default.maximumOpt
function Lexicographic__Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box) } 
              { s#0[$Box(y#1)] } 
            $Is(y#1, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.lt
function Lexicographic__Byte__Order.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lt(a#0, b#0)
           == (Lexicographic__Byte__Order.__default.lte(a#0, b#0) && !Seq#Equal(a#0, b#0)));

// definition axiom for Lexicographic__Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0))
           == (Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

// function declaration for Lexicographic_Byte_Order._default.Min
function Lexicographic__Byte__Order.__default.Min(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Min#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Min
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Min(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Min#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Min
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Min(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Lexicographic__Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Min#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then a#0
             else b#0));

// function declaration for Lexicographic_Byte_Order._default.Max
function Lexicographic__Byte__Order.__default.Max(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Max#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Max
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Max(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Max#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Max
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Max(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Lexicographic__Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Max#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then b#0
             else a#0));

// function declaration for Lexicographic_Byte_Order._default.IsSorted
function Lexicographic__Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)));

function Lexicographic__Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          j#2 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySortedInternal
function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
          j#2 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): Seq Box, $Unbox(Seq#Index(run#0, i#2)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): Seq Box, $Unbox(Seq#Index(run#0, j#2)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): Seq Box, $Unbox(Seq#Index(run#0, i#3)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#3)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySorted
function Lexicographic__Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0)));

function Lexicographic__Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

procedure CheckWellformed$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLte(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  free requires 68 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order.__default.IsStrictlySortedImpliesLte(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, run#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 < Seq#Length(run#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box);
  ensures Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$Lexicographic__Byte__Order.__default.StrictlySortedSubsequence(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  free requires 23 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order.__default.StrictlySortedSubsequence(run#0: Seq Box
       where $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    i#0: int, 
    j#0: int);
  // user-defined preconditions
  requires Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, run#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= j#0;
  requires j#0 <= Seq#Length(run#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Seq#Drop(Seq#Take(run#0, j#0), i#0));
  ensures Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
    Seq#Drop(Seq#Take(run#0, j#0), i#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$Lexicographic__Byte__Order.__default.reveal__IsStrictlySorted();
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$Lexicographic__Byte__Order.__default.reveal__IsStrictlySorted();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted
     == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1);
  free ensures StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted
     == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1)
     == MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1;



const unique class.Lexicographic__Byte__Order__Impl.__default: ClassName;

function Tclass.Lexicographic__Byte__Order__Impl.__default() : Ty;

// Tclass.Lexicographic__Byte__Order__Impl.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order__Impl.__default())
   == Tagclass.Lexicographic__Byte__Order__Impl.__default;

const unique Tagclass.Lexicographic__Byte__Order__Impl.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order__Impl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order__Impl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order__Impl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

procedure CheckWellformed$$Lexicographic__Byte__Order__Impl.__default.cmp(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    b#0: Seq Box
       where $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(b#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (c#0: int where LitInt(0 - 2147483648) <= c#0 && c#0 < 2147483648);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order__Impl.__default.cmp(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(a#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    b#0: Seq Box
       where $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(b#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (c#0: int where LitInt(0 - 2147483648) <= c#0 && c#0 < 2147483648);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures c#0 < 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0);
  free ensures c#0 < 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lt(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lte(a#0, b#0)
       && !Seq#Equal(a#0, b#0);
  free ensures c#0 > 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0);
  free ensures c#0 > 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lt(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lte(b#0, a#0)
       && !Seq#Equal(b#0, a#0);
  free ensures true;
  ensures c#0 == LitInt(0) ==> Seq#Equal(a#0, b#0);
  free ensures c#0 < 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0);
  free ensures c#0 < 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lt(a#0, b#0)
       && 
      Lexicographic__Byte__Order.__default.lte(a#0, b#0)
       && !Seq#Equal(a#0, b#0);
  free ensures c#0 > 0 ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0);
  free ensures c#0 > 0
     ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lt(b#0, a#0)
       && 
      Lexicographic__Byte__Order.__default.lte(b#0, a#0)
       && !Seq#Equal(b#0, a#0);
  free ensures true;
  ensures c#0 == LitInt(0) ==> Seq#Equal(a#0, b#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$Lexicographic__Byte__Order__Impl.__default.ArrayLargestLtePlus1(run#0: ref
       where $Is(run#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616, 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (posplus1#0: int
       where LitInt(0) <= posplus1#0 && posplus1#0 < 18446744073709551616);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Lexicographic__Byte__Order__Impl.__default.ArrayLargestLtePlus1(run#0: ref
       where $Is(run#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())))
         && $IsAlloc(run#0, Tclass._System.array(TSeq(Tclass.NativeTypes.byte())), $Heap), 
    start#0: int where LitInt(0) <= start#0 && start#0 < 18446744073709551616, 
    end#0: int where LitInt(0) <= end#0 && end#0 < 18446744073709551616, 
    needle#0: Seq Box
       where $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(needle#0, TSeq(Tclass.NativeTypes.byte()), $Heap))
   returns (posplus1#0: int
       where LitInt(0) <= posplus1#0 && posplus1#0 < 18446744073709551616);
  // user-defined preconditions
  requires LitInt(0) <= start#0;
  requires start#0 <= end#0;
  requires end#0 <= _System.array.Length(run#0);
  requires _System.array.Length(run#0)
     < Div(NativeTypes.__default.Uint64UpperBound(), LitInt(2));
  requires Lexicographic__Byte__Order.__default.IsSorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted, 
    Seq#Drop(Seq#Take(Seq#FromArray($Heap, run#0), end#0), start#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Drop(Seq#Take(Seq#FromArray($Heap, run#0), end#0), start#0), needle#0);
  ensures posplus1#0
     == start#0
       + Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), 
        Seq#Drop(Seq#Take(Seq#FromArray($Heap, run#0), end#0), start#0), 
        needle#0)
       + 1;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



const unique class.Integer__Order.__default: ClassName;

function Tclass.Integer__Order.__default() : Ty;

// Tclass.Integer__Order.__default Tag
axiom Tag(Tclass.Integer__Order.__default()) == Tagclass.Integer__Order.__default;

const unique Tagclass.Integer__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Integer__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Integer__Order.__default()) } 
  $IsBox(bx, Tclass.Integer__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Integer__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Integer__Order.__default()) } 
  $Is($o, Tclass.Integer__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Integer__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Integer__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Integer__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Integer_Order._default.SomeElement
function Integer__Order.__default.SomeElement() : int;

function Integer__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Integer__Order.__default.SomeElement
axiom true ==> true ==> true;

function Integer__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Integer__Order.__default.SomeElement
axiom Integer__Order.__default.SomeElement#requires() == true;

// definition axiom for Integer__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Integer__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Integer__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Integer__Order.__default.SomeElement() == LitInt(0);

// function declaration for Integer_Order._default.lte
function Integer__Order.__default.lte(a#0: int, b#0: int) : bool;

function Integer__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lte(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
           || Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0))
         && (forall a#3: int, b#3: int, c#2: int :: 
          { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, c#2), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#3, c#2) } 
            { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#3, c#2), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, b#3) } 
          true
             ==> 
            Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, b#3)
               && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#3, c#2)
             ==> Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#3, c#2))
         && Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
           || Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0))
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
             && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#4: int, b#4: int, c#3: int :: 
          { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, c#3), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#4, c#3) } 
            { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#4, c#3), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, b#4) } 
          true
             ==> 
            Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, b#4)
               && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#4, c#3)
             ==> Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#4, c#3)));

function Integer__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.lte#requires(a#0, b#0) } 
  Integer__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Integer_Order._default.ltedef2: LayerType;

// definition axiom for Integer__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lte(a#0, b#0) } 
    true
       ==> Integer__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Integer_Order._default.ltedef
           == $LS(MoreFuel_Integer_Order._default.ltedef2)
         && StartFuelAssert_Integer_Order._default.ltedef
           == $LS($LS(MoreFuel_Integer_Order._default.ltedef2))
         && AsFuelBottom(MoreFuel_Integer_Order._default.ltedef2)
           == MoreFuel_Integer_Order._default.ltedef2
         && Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0));

const MoreFuel_Integer_Order._default.ltedef3: LayerType;

// definition axiom for Integer__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Integer_Order._default.ltedef
           == $LS(MoreFuel_Integer_Order._default.ltedef3)
         && StartFuelAssert_Integer_Order._default.ltedef
           == $LS($LS(MoreFuel_Integer_Order._default.ltedef3))
         && AsFuelBottom(MoreFuel_Integer_Order._default.ltedef3)
           == MoreFuel_Integer_Order._default.ltedef3
         && Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Integer_Order._default.ltedef
function Integer__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Integer__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Integer__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Integer__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Integer__Order.__default.ltedef($ly, a#0, b#0)
     == Integer__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Integer__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Integer__Order.__default.ltedef($ly, a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Integer__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  Integer__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Integer__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Integer__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    true ==> Integer__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Integer__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Integer_Order._default.LargestLte
function Integer__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Integer__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLte($ly, run#0, needle#0)
     == Integer__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Integer__Order.__default.LargestLte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
         && Integer__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Integer__Order.__default.LargestLte($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Integer__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Integer__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted8: LayerType;

// definition axiom for Integer__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.LargestLte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Integer__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Integer__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted8)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted8))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted8)
           == MoreFuel_Integer_Order._default.IsSorted8
         && Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Integer_Order._default.IsSorted9: LayerType;

// definition axiom for Integer__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Integer__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Integer__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Integer__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted9)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted9))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted9)
           == MoreFuel_Integer_Order._default.IsSorted9
         && Integer__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Integer__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Integer_Order._default.LargestLt
function Integer__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Integer__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLt($ly, run#0, needle#0)
     == Integer__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Integer__Order.__default.LargestLt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Integer__Order.__default.LargestLt($ly, run#0, needle#0)
         && Integer__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          true
             ==> 
            LitInt(0) <= i#2
               && i#2 <= Integer__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          true
             ==> 
            Integer__Order.__default.LargestLt($ly, run#0, needle#0) < i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Integer__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Integer__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Integer__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted10: LayerType;

// definition axiom for Integer__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.LargestLt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Integer__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Integer__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted10)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted10))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted10)
           == MoreFuel_Integer_Order._default.IsSorted10
         && Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Integer_Order._default.IsSorted11: LayerType;

// definition axiom for Integer__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Integer__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Integer__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Integer__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted11)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted11))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted11)
           == MoreFuel_Integer_Order._default.IsSorted11
         && Integer__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Integer__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Integer_Order._default.IndexOfFirstGte
function Integer__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Integer__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted12: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, run#0)
             && Integer__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
             && (!Integer__Order.__default.lt($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               ==> Sequences.__default.DropLast#canCall(TInt, run#0)
                 && Integer__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TInt, run#0), needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted12)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted12))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted12)
           == MoreFuel_Integer_Order._default.IsSorted12
         && Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lt($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               then Seq#Length(run#0)
               else Integer__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(TInt, run#0), needle#0))));

const MoreFuel_Integer_Order._default.IsSorted13: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, Lit(run#0))
             && Integer__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Integer__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TInt, Lit(run#0))
                 && Integer__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0))))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted13)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted13))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted13)
           == MoreFuel_Integer_Order._default.IsSorted13
         && Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0)))));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGteIter
function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#3, hi#0)
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Integer__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGte
function Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Integer_Order._default.IndexOfFirstGt
function Integer__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(run#0, i#2)): int } 
          LitInt(0) <= i#2
               && i#2 < Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, needle#0))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(run#0, i#3)): int } 
          Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#3
               && i#3 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#3)): int))
         && LitInt(0) <= Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Integer__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted14: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, run#0)
             && Integer__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
             && (!Integer__Order.__default.lte($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               ==> Sequences.__default.DropLast#canCall(TInt, run#0)
                 && Integer__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TInt, run#0), needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted14)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted14))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted14)
           == MoreFuel_Integer_Order._default.IsSorted14
         && Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lte($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               then Seq#Length(run#0)
               else Integer__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(TInt, run#0), needle#0))));

const MoreFuel_Integer_Order._default.IsSorted15: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, Lit(run#0))
             && Integer__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Integer__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TInt, Lit(run#0))
                 && Integer__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0))))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted15)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted15))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted15)
           == MoreFuel_Integer_Order._default.IsSorted15
         && Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0)))));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGtIter
function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
               && (Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#3, hi#0))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#3))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#3 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#3 - 1)): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#3, hi#0)
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#3)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
               && (Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#4, LitInt(hi#0)))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#4 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#4))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#4 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#4 - 1))): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#4, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#4)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Integer__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
               && (Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0)))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#5 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#5 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#5 - 1))): int, LitInt(key#0))
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#5, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#5)))
             else lo#0));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGt
function Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Integer_Order._default.SetAllLte
function Integer__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Integer__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Integer__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLte(a#0, b#0) } 
    Integer__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> true);

function Integer__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Integer__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Integer__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt))
     ==> Integer__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLte(a#0, b#0) } 
    Integer__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#2: int, y#2: int :: 
          { Integer__Order.__default.lte(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          b#0[$Box(y#2)] ==> Integer__Order.__default.lte#canCall(x#2, y#2))
         && Integer__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Integer__Order.__default.lte(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            true
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Integer__Order.__default.lte(x#2, y#2)));

// definition axiom for Integer__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Integer__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#3: int, y#3: int :: 
          { Integer__Order.__default.lte(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          Lit(b#0)[$Box(y#3)] ==> Integer__Order.__default.lte#canCall(x#3, y#3))
         && Integer__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Integer__Order.__default.lte(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            true
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Integer__Order.__default.lte(x#3, y#3)));

// function declaration for Integer_Order._default.SetAllLt
function Integer__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Integer__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Integer__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLt(a#0, b#0) } 
    Integer__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> true);

function Integer__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Integer__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Integer__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt))
     ==> Integer__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLt(a#0, b#0) } 
    Integer__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#2: int, y#2: int :: 
          { Integer__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
          b#0[$Box(y#2)] ==> Integer__Order.__default.lt#canCall(x#2, y#2))
         && Integer__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#2: int, y#2: int :: 
            { Integer__Order.__default.lt(x#2, y#2) } { b#0[$Box(y#2)], a#0[$Box(x#2)] } 
            true
               ==> 
              a#0[$Box(x#2)] && b#0[$Box(y#2)]
               ==> Integer__Order.__default.lt(x#2, y#2)));

// definition axiom for Integer__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Integer__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#3: int, y#3: int :: 
          { Integer__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
          Lit(b#0)[$Box(y#3)] ==> Integer__Order.__default.lt#canCall(x#3, y#3))
         && Integer__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#3: int, y#3: int :: 
            { Integer__Order.__default.lt(x#3, y#3) } { b#0[$Box(y#3)], a#0[$Box(x#3)] } 
            true
               ==> 
              Lit(a#0)[$Box(x#3)] && Lit(b#0)[$Box(y#3)]
               ==> Integer__Order.__default.lt(x#3, y#3)));

// function declaration for Integer_Order._default.NotMinimum
function Integer__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Integer__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum($LS($ly), a#0) } 
  Integer__Order.__default.NotMinimum($LS($ly), a#0)
     == Integer__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Integer__Order.__default.NotMinimum($ly, a#0)
     == Integer__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Integer__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Integer__Order.__default.NotMinimum($ly, a#0) } 
    true ==> true);

function Integer__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Integer__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum#requires($ly, a#0) } 
  Integer__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Integer__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Integer__Order.__default.NotMinimum($LS($ly), a#0) } 
    true
       ==> (forall b#2: int :: 
          { Integer__Order.__default.lt(b#2, a#0) } 
          Integer__Order.__default.lt#canCall(b#2, a#0))
         && Integer__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#2: int :: 
            { Integer__Order.__default.lt(b#2, a#0) } 
            Integer__Order.__default.lt(b#2, a#0)));

// definition axiom for Integer__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Integer__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    true
       ==> (forall b#3: int :: 
          { Integer__Order.__default.lt(b#3, a#0) } 
          Integer__Order.__default.lt#canCall(b#3, LitInt(a#0)))
         && Integer__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#3: int :: 
            { Integer__Order.__default.lt(b#3, a#0) } 
            Integer__Order.__default.lt(b#3, LitInt(a#0))));

// function declaration for Integer_Order._default.MapPivotedUnion
function Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Integer__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)));

function Integer__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Integer__Order.__default.MapPivotedUnion
axiom (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Integer__Order.__default.MapPivotedUnion#requires(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
       && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
     ==> Integer__Order.__default.MapPivotedUnion#requires(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Integer__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#4: int :: 
          { Integer__Order.__default.lt(k#4, pivot#0) } 
          Integer__Order.__default.lt#canCall(k#4, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TInt, 
          Integer_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#12: Box :: 
            $IsBox($y#12, TInt) && Integer__Order.__default.lt($Unbox($y#12): int, pivot#0)))
         && (var restricted_left#2 := Maps.__default.MapIRestrict(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#15: Box :: 
                $IsBox($y#15, TInt) && Integer__Order.__default.lt($Unbox($y#15): int, pivot#0))); 
          (forall k#5: int :: 
              { Integer__Order.__default.lte(pivot#0, k#5) } 
              Integer__Order.__default.lte#canCall(pivot#0, k#5))
             && Maps.__default.MapIRestrict#canCall(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#13: Box :: 
                $IsBox($y#13, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#13): int)))
             && (var restricted_right#2 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#14: Box :: 
                    $IsBox($y#14, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#14): int))); 
              Maps.__default.MapDisjointUnion#canCall(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                restricted_left#2, 
                restricted_right#2)))
         && Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#2 := Maps.__default.MapIRestrict(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#16: Box :: 
                  $IsBox($y#16, TInt) && Integer__Order.__default.lt($Unbox($y#16): int, pivot#0))); 
            (var restricted_right#2 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#17: Box :: 
                    $IsBox($y#17, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#17): int))); 
              Maps.__default.MapDisjointUnion(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#2, 
                restricted_right#2))));

// definition axiom for Integer__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#6: int :: 
          { Integer__Order.__default.lt(k#6, pivot#0) } 
          Integer__Order.__default.lt#canCall(k#6, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TInt, 
          Integer_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#18: Box :: 
            $IsBox($y#18, TInt)
               && Integer__Order.__default.lt($Unbox($y#18): int, LitInt(pivot#0))))
         && (var restricted_left#3 := Maps.__default.MapIRestrict(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#21: Box :: 
                $IsBox($y#21, TInt)
                   && Integer__Order.__default.lt($Unbox($y#21): int, LitInt(pivot#0)))); 
          (forall k#7: int :: 
              { Integer__Order.__default.lte(pivot#0, k#7) } 
              Integer__Order.__default.lte#canCall(LitInt(pivot#0), k#7))
             && Maps.__default.MapIRestrict#canCall(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#19: Box :: 
                $IsBox($y#19, TInt)
                   && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#19): int)))
             && (var restricted_right#3 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#20: Box :: 
                    $IsBox($y#20, TInt)
                       && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#20): int))); 
              Maps.__default.MapDisjointUnion#canCall(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                restricted_left#3, 
                restricted_right#3)))
         && Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#3 := Maps.__default.MapIRestrict(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#22: Box :: 
                  $IsBox($y#22, TInt)
                     && Integer__Order.__default.lt($Unbox($y#22): int, LitInt(pivot#0)))); 
            (var restricted_right#3 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#23: Box :: 
                    $IsBox($y#23, TInt)
                       && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#23): int))); 
              Maps.__default.MapDisjointUnion(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#3, 
                restricted_right#3))));

// function declaration for Integer_Order._default.SetSuccessor
function Integer__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Integer__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Integer__Order.__default.SetSuccessor(m#0, key#0) } 
    Integer__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSet(TInt))
       ==> $Is(Integer__Order.__default.SetSuccessor(m#0, key#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Integer__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Integer__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(m#0, TSet(TInt))
     ==> Integer__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#22_next(m: Set Box, key: int) : int;

function $let#22$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#22_next(m, key) } 
  $let#22$canCall(m, key)
     ==> m[$Box($let#22_next(m, key))]
       && Integer__Order.__default.lt(key, $let#22_next(m, key))
       && (forall other#4: int :: 
        { Integer__Order.__default.lt($let#22_next(m, key), other#4) } 
          { Integer__Order.__default.lt(key, other#4) } 
          { m[$Box(other#4)] } 
        true
           ==> 
          m[$Box(other#4)]
             && other#4 != $let#22_next(m, key)
             && Integer__Order.__default.lt(key, other#4)
           ==> Integer__Order.__default.lt($let#22_next(m, key), other#4)));

// definition axiom for Integer__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Integer__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($IsGoodHeap($Heap) && $Is(m#0, TSet(TInt)))
       ==> (forall next#4: int :: 
          { Integer__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
          (m#0[$Box(next#4)] ==> Integer__Order.__default.lt#canCall(key#0, next#4))
             && (Integer__Order.__default.lt#canCall(key#0, next#4)
                 && Integer__Order.__default.lt(key#0, next#4)
               ==> (forall other#3: int :: 
                { Integer__Order.__default.lt(next#4, other#3) } 
                  { Integer__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                (other#3 != next#4 ==> Integer__Order.__default.lt#canCall(key#0, other#3))
                   && (Integer__Order.__default.lt#canCall(key#0, other#3)
                       && Integer__Order.__default.lt(key#0, other#3)
                     ==> Integer__Order.__default.lt#canCall(next#4, other#3)))))
         && ((exists next#4: int :: 
            { Integer__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
            m#0[$Box(next#4)]
               && Integer__Order.__default.lt(key#0, next#4)
               && (forall other#3: int :: 
                { Integer__Order.__default.lt(next#4, other#3) } 
                  { Integer__Order.__default.lt(key#0, other#3) } 
                  { m#0[$Box(other#3)] } 
                true
                   ==> 
                  m#0[$Box(other#3)]
                     && other#3 != next#4
                     && Integer__Order.__default.lt(key#0, other#3)
                   ==> Integer__Order.__default.lt(next#4, other#3)))
           ==> $let#22$canCall(m#0, key#0))
         && Integer__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#4: int :: 
              { Integer__Order.__default.lt(key#0, next#4) } { m#0[$Box(next#4)] } 
              m#0[$Box(next#4)]
                 && Integer__Order.__default.lt(key#0, next#4)
                 && (forall other#3: int :: 
                  { Integer__Order.__default.lt(next#4, other#3) } 
                    { Integer__Order.__default.lt(key#0, other#3) } 
                    { m#0[$Box(other#3)] } 
                  true
                     ==> 
                    m#0[$Box(other#3)]
                       && other#3 != next#4
                       && Integer__Order.__default.lt(key#0, other#3)
                     ==> Integer__Order.__default.lt(next#4, other#3)))
             then (var next#5 := $let#22_next(m#0, key#0); #Options.Option.Some($Box(next#5)))
             else #Options.Option.None()));

// definition axiom for Integer__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($IsGoodHeap($Heap) && $Is(m#0, TSet(TInt)))
       ==> (forall next#6: int :: 
          { Integer__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
          (Lit(m#0)[$Box(next#6)]
               ==> Integer__Order.__default.lt#canCall(LitInt(key#0), next#6))
             && (Integer__Order.__default.lt#canCall(LitInt(key#0), next#6)
                 && Integer__Order.__default.lt(LitInt(key#0), next#6)
               ==> (forall other#5: int :: 
                { Integer__Order.__default.lt(next#6, other#5) } 
                  { Integer__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                (other#5 != next#6
                     ==> Integer__Order.__default.lt#canCall(LitInt(key#0), other#5))
                   && (Integer__Order.__default.lt#canCall(LitInt(key#0), other#5)
                       && Integer__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Integer__Order.__default.lt#canCall(next#6, other#5)))))
         && ((exists next#6: int :: 
            { Integer__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
            Lit(m#0)[$Box(next#6)]
               && Integer__Order.__default.lt(LitInt(key#0), next#6)
               && (forall other#5: int :: 
                { Integer__Order.__default.lt(next#6, other#5) } 
                  { Integer__Order.__default.lt(key#0, other#5) } 
                  { m#0[$Box(other#5)] } 
                true
                   ==> 
                  Lit(m#0)[$Box(other#5)]
                     && other#5 != next#6
                     && Integer__Order.__default.lt(LitInt(key#0), other#5)
                   ==> Integer__Order.__default.lt(next#6, other#5)))
           ==> $let#22$canCall(Lit(m#0), LitInt(key#0)))
         && Integer__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#6: int :: 
              { Integer__Order.__default.lt(key#0, next#6) } { m#0[$Box(next#6)] } 
              Lit(m#0)[$Box(next#6)]
                 && Integer__Order.__default.lt(LitInt(key#0), next#6)
                 && (forall other#5: int :: 
                  { Integer__Order.__default.lt(next#6, other#5) } 
                    { Integer__Order.__default.lt(key#0, other#5) } 
                    { m#0[$Box(other#5)] } 
                  true
                     ==> 
                    Lit(m#0)[$Box(other#5)]
                       && other#5 != next#6
                       && Integer__Order.__default.lt(LitInt(key#0), other#5)
                     ==> Integer__Order.__default.lt(next#6, other#5)))
             then (var next#7 := $let#22_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#7)))
             else #Options.Option.None()));

// function declaration for Integer_Order._default.MapSuccessor
function Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.MapSuccessor
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, m#0, key#0)
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> $Is(Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TInt)));

function Integer__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Integer__Order.__default.MapSuccessor
axiom (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Integer__Order.__default.MapSuccessor#requires(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
     ==> Integer__Order.__default.MapSuccessor#requires(Integer_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, m#0, key#0)
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> Integer__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0)
           == Integer__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Integer__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> Integer__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Integer__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Integer_Order._default.SeqSuccessor
function Integer__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Integer__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.SeqSuccessor(m#0, key#0) } 
    Integer__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSeq(TInt))
       ==> $Is(Integer__Order.__default.SeqSuccessor(m#0, key#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TInt))
     ==> Integer__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Integer__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.SeqSuccessor(m#0, key#0) } 
    Integer__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSeq(TInt))
       ==> Integer__Order.__default.SetSuccessor#canCall((lambda $y#4: Box :: $IsBox($y#4, TInt) && Seq#Contains(m#0, $y#4)), key#0)
         && Integer__Order.__default.SeqSuccessor(m#0, key#0)
           == Integer__Order.__default.SetSuccessor((lambda $y#5: Box :: $IsBox($y#5, TInt) && Seq#Contains(m#0, $y#5)), key#0));

// definition axiom for Integer__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Integer__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || $Is(m#0, TSeq(TInt))
       ==> Integer__Order.__default.SetSuccessor#canCall((lambda $y#6: Box :: $IsBox($y#6, TInt) && Seq#Contains(m#0, $y#6)), 
          LitInt(key#0))
         && Integer__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Integer__Order.__default.SetSuccessor((lambda $y#7: Box :: $IsBox($y#7, TInt) && Seq#Contains(m#0, $y#7)), 
            LitInt(key#0)));

// function declaration for Integer_Order._default.SortedSeqForMap
function Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Integer__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> true);

function Integer__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Integer__Order.__default.SortedSeqForMap
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap#requires(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V))
     ==> Integer__Order.__default.SortedSeqForMap#requires(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Integer__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TInt, Integer_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TInt, 
            Integer_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Integer__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                Integer_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                  Integer_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
            (i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                 ==> 
                i#4 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))))
         && ((forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              (i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                   ==> 
                  i#4 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
           ==> (forall key#2: int :: 
            { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
            Map#Domain(m#0)[$Box(key#2)]
               ==> (forall i#5: int :: 
                { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                (i#5 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                         == key#2
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#5)): DatatypeType)))))
         && Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                    Integer_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#4: int :: 
              { $Unbox(Seq#Index(s#0, i#4)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)])
                   && (LitInt(0) <= i#4 && i#4 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#4)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#4)): DatatypeType)))
             && (forall key#2: int :: 
              { Map#Elements(m#0)[$Box(key#2)] } { Map#Domain(m#0)[$Box(key#2)] } 
              true
                 ==> 
                Map#Domain(m#0)[$Box(key#2)]
                 ==> (exists i#5: int :: 
                  { $Unbox(Seq#Index(s#0, i#5)): DatatypeType } 
                  LitInt(0) <= i#5
                     && i#5 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#5)): DatatypeType)): int
                       == key#2
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#5)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#2)]))));

// definition axiom for Integer__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TInt, Integer_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TInt, 
            Integer_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Integer__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                Integer_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                  Integer_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
            (i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                 ==> 
                i#6 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              (i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                   ==> 
                  i#6 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
           ==> (forall key#3: int :: 
            { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
            Map#Domain(m#0)[$Box(key#3)]
               ==> (forall i#7: int :: 
                { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                (i#7 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                         == key#3
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)))))
         && Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                    Integer_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(s#0, i#6)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)])
                   && (LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#6)): DatatypeType)))
             && (forall key#3: int :: 
              { Map#Elements(m#0)[$Box(key#3)] } { Map#Domain(m#0)[$Box(key#3)] } 
              true
                 ==> 
                Map#Domain(m#0)[$Box(key#3)]
                 ==> (exists i#7: int :: 
                  { $Unbox(Seq#Index(s#0, i#7)): DatatypeType } 
                  LitInt(0) <= i#7
                     && i#7 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)): int
                       == key#3
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#7)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#3)]))));

// function declaration for Integer_Order._default.minimum
function Integer__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Integer__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimum($LS($ly), s#0) } 
  Integer__Order.__default.minimum($LS($ly), s#0)
     == Integer__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.minimum($ly, s#0)
     == Integer__Order.__default.minimum($LZ, s#0));

// consequence axiom for Integer__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimum($ly, s#0) } 
    Integer__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Integer__Order.__default.minimum($ly, s#0))]
         && (forall y#1: int :: 
          { Integer__Order.__default.lte(Integer__Order.__default.minimum($ly, s#0), y#1) } 
            { s#0[$Box(y#1)] } 
          s#0[$Box(y#1)]
             ==> Integer__Order.__default.lte(Integer__Order.__default.minimum($ly, s#0), y#1)));

function Integer__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Integer__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#25_a(s: Set Box) : int;

function $let#25$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#25_a(s) } 
  $let#25$canCall(s) ==> s[$Box($let#25_a(s))]);

// definition axiom for Integer__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Integer__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.minimum#canCall(s#0)
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> $let#25$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#25_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Integer__Order.__default.minimum#canCall(s'#4)
               && (var m'#4 := Integer__Order.__default.minimum($ly, s'#4); 
                Integer__Order.__default.lt#canCall($let#25_a(s#0), m'#4)))
         && Integer__Order.__default.minimum($LS($ly), s#0)
           == (var a#2 := $let#25_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Integer__Order.__default.minimum($ly, s'#5); 
                  (if Integer__Order.__default.lt(a#2, m'#5) then a#2 else m'#5))))));

// definition axiom for Integer__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.minimum#canCall(Lit(s#0))
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#25$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#25_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Integer__Order.__default.minimum#canCall(s'#6)
               && (var m'#6 := Integer__Order.__default.minimum($LS($ly), s'#6); 
                Integer__Order.__default.lt#canCall($let#25_a(Lit(s#0)), m'#6)))
         && Integer__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#3 := $let#25_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Integer__Order.__default.minimum($LS($ly), s'#7); 
                  (if Integer__Order.__default.lt(a#3, m'#7) then a#3 else m'#7))))));

// function declaration for Integer_Order._default.minimumOpt
function Integer__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Integer__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt($LS($ly), s#0) } 
  Integer__Order.__default.minimumOpt($LS($ly), s#0)
     == Integer__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.minimumOpt($ly, s#0)
     == Integer__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Integer__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimumOpt($ly, s#0) } 
    Integer__Order.__default.minimumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (Options.Option.Some_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Integer__Order.__default.lte($Unbox(Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1) } 
              { s#0[$Box(y#1)] } 
            s#0[$Box(y#1)]
               ==> Integer__Order.__default.lte($Unbox(Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))): int, 
                y#1)))
         && (Options.Option.None_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Integer__Order.__default.minimumOpt($ly, s#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Integer__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimumOpt($LS($ly), s#0) } 
    Integer__Order.__default.minimumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.minimum#canCall(s#0))
         && Integer__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.minimum(StartFuel_Integer_Order._default.minimum, s#0)))));

// definition axiom for Integer__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Integer__Order.__default.minimumOpt#canCall(Lit(s#0)) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.minimum#canCall(Lit(s#0)))
         && Integer__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.minimum(StartFuel_Integer_Order._default.minimum, Lit(s#0))))));

// function declaration for Integer_Order._default.maximum
function Integer__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Integer__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximum($LS($ly), s#0) } 
  Integer__Order.__default.maximum($LS($ly), s#0)
     == Integer__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.maximum($ly, s#0)
     == Integer__Order.__default.maximum($LZ, s#0));

// consequence axiom for Integer__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximum($ly, s#0) } 
    Integer__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Integer__Order.__default.maximum($ly, s#0))]
         && (forall y#1: int :: 
          { Integer__Order.__default.lte(y#1, Integer__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#1)] } 
          s#0[$Box(y#1)]
             ==> Integer__Order.__default.lte(y#1, Integer__Order.__default.maximum($ly, s#0))));

function Integer__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Integer__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#28_a(s: Set Box) : int;

function $let#28$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#28_a(s) } 
  $let#28$canCall(s) ==> s[$Box($let#28_a(s))]);

// definition axiom for Integer__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Integer__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.maximum#canCall(s#0)
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> $let#28$canCall(s#0)
         && (var s'#4 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#28_a(s#0)))); 
          !Set#Equal(s'#4, Set#Empty(): Set Box)
             ==> Integer__Order.__default.maximum#canCall(s'#4)
               && (var m'#4 := Integer__Order.__default.maximum($ly, s'#4); 
                Integer__Order.__default.lt#canCall(m'#4, $let#28_a(s#0))))
         && Integer__Order.__default.maximum($LS($ly), s#0)
           == (var a#2 := $let#28_a(s#0); 
            (var s'#5 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#2))); 
              (if Set#Equal(s'#5, Set#Empty(): Set Box)
                 then a#2
                 else (var m'#5 := Integer__Order.__default.maximum($ly, s'#5); 
                  (if Integer__Order.__default.lt(m'#5, a#2) then a#2 else m'#5))))));

// definition axiom for Integer__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.maximum#canCall(Lit(s#0))
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#28$canCall(Lit(s#0))
         && (var s'#6 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#28_a(Lit(s#0))))); 
          !Set#Equal(s'#6, Set#Empty(): Set Box)
             ==> Integer__Order.__default.maximum#canCall(s'#6)
               && (var m'#6 := Integer__Order.__default.maximum($LS($ly), s'#6); 
                Integer__Order.__default.lt#canCall(m'#6, $let#28_a(Lit(s#0)))))
         && Integer__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#3 := $let#28_a(Lit(s#0)); 
            (var s'#7 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#3))); 
              (if Set#Equal(s'#7, Set#Empty(): Set Box)
                 then a#3
                 else (var m'#7 := Integer__Order.__default.maximum($LS($ly), s'#7); 
                  (if Integer__Order.__default.lt(m'#7, a#3) then a#3 else m'#7))))));

// function declaration for Integer_Order._default.maximumOpt
function Integer__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Integer__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt($LS($ly), s#0) } 
  Integer__Order.__default.maximumOpt($LS($ly), s#0)
     == Integer__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.maximumOpt($ly, s#0)
     == Integer__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Integer__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximumOpt($ly, s#0) } 
    Integer__Order.__default.maximumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (Options.Option.Some_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#1: int :: 
            { Integer__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#1)] } 
            s#0[$Box(y#1)]
               ==> Integer__Order.__default.lte(y#1, 
                $Unbox(Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Integer__Order.__default.maximumOpt($ly, s#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Integer__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximumOpt($LS($ly), s#0) } 
    Integer__Order.__default.maximumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.maximum#canCall(s#0))
         && Integer__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.maximum(StartFuel_Integer_Order._default.maximum, s#0)))));

// definition axiom for Integer__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Integer__Order.__default.maximumOpt#canCall(Lit(s#0)) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.maximum#canCall(Lit(s#0)))
         && Integer__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.maximum(StartFuel_Integer_Order._default.maximum, Lit(s#0))))));

// function declaration for Integer_Order._default.lt
function Integer__Order.__default.lt(a#0: int, b#0: int) : bool;

function Integer__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lt(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.lt#requires(a#0, b#0) } 
  Integer__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lt(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.lt(a#0, b#0)
           == (Integer__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Integer__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Integer_Order._default.Min
function Integer__Order.__default.Min(a#0: int, b#0: int) : int;

function Integer__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Min(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.Min#requires(a#0, b#0) } 
  Integer__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Min(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.Min(a#0, b#0)
           == (if Integer__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Integer__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Integer_Order._default.Max
function Integer__Order.__default.Max(a#0: int, b#0: int) : int;

function Integer__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Max(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.Max#requires(a#0, b#0) } 
  Integer__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Max(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.Max(a#0, b#0)
           == (if Integer__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Integer__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Integer_Order._default.IsSorted
function Integer__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Integer__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted($LS($ly), run#0) } 
  Integer__Order.__default.IsSorted($LS($ly), run#0)
     == Integer__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Integer__Order.__default.IsSorted($ly, run#0)
     == Integer__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Integer__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsSorted($ly, run#0) } 
    Integer__Order.__default.IsSorted#canCall(run#0) || $Is(run#0, TSeq(TInt))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Integer__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Integer__Order.__default.IsSorted($ly, run#0)));

function Integer__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Integer__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsSorted($LS($ly), run#0) } 
    Integer__Order.__default.IsSorted#canCall(run#0) || $Is(run#0, TSeq(TInt))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Integer__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 <= j#2 && j#2 < Seq#Length(run#0)
               ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Integer__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Integer__Order.__default.IsSorted#canCall(Lit(run#0)) || $Is(run#0, TSeq(TInt))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Integer__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Integer__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 <= j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Integer__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Integer_Order._default.IsStrictlySortedInternal
function Integer__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Integer__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySortedInternal(run#0) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> true);

function Integer__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Integer__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySortedInternal(run#0) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> (forall i#2: int, j#2: int :: 
          { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
          j#2 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int))
         && Integer__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#2: int, j#2: int :: 
            { $Unbox(Seq#Index(run#0, j#2)): int, $Unbox(Seq#Index(run#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(run#0)
               ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#2)): int, $Unbox(Seq#Index(run#0, j#2)): int)));

// definition axiom for Integer__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TInt))
       ==> (forall i#3: int, j#3: int :: 
          { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
          j#3 < Seq#Length(Lit(run#0))
             ==> Integer__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int))
         && Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#3: int, j#3: int :: 
            { $Unbox(Seq#Index(run#0, j#3)): int, $Unbox(Seq#Index(run#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Lit(run#0))
               ==> Integer__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#3)): int, $Unbox(Seq#Index(Lit(run#0), j#3)): int)));

// function declaration for Integer_Order._default.IsStrictlySorted
function Integer__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Integer__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Integer__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Integer__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Integer__Order.__default.IsStrictlySorted($ly, run#0)
     == Integer__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Integer__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySorted($ly, run#0) } 
    Integer__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Integer__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Integer__Order.__default.IsStrictlySorted($ly, run#0))
         && (Integer__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0)));

function Integer__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Integer__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Integer__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Integer__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#2 := Integer__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#2 then b#2 else b#2)));

// definition axiom for Integer__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Integer__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TInt))
       ==> Integer__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Integer__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#3 := Lit(Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#3 then b#3 else b#3)));

const unique class.Mathematics.__default: ClassName;

function Tclass.Mathematics.__default() : Ty;

// Tclass.Mathematics.__default Tag
axiom Tag(Tclass.Mathematics.__default()) == Tagclass.Mathematics.__default;

const unique Tagclass.Mathematics.__default: TyTag;

// Box/unbox axiom for Tclass.Mathematics.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Mathematics.__default()) } 
  $IsBox(bx, Tclass.Mathematics.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Mathematics.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Mathematics.__default()) } 
  $Is($o, Tclass.Mathematics.__default())
     <==> $o == null || dtype($o) == Tclass.Mathematics.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Mathematics.__default(), $h) } 
  $IsAlloc($o, Tclass.Mathematics.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Mathematics._default.min
function Mathematics.__default.min(a#0: int, b#0: int) : int;

function Mathematics.__default.min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Mathematics.__default.min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Mathematics.__default.min(a#0, b#0) } 
    true ==> true);

function Mathematics.__default.min#requires(int, int) : bool;

// #requires axiom for Mathematics.__default.min
axiom (forall a#0: int, b#0: int :: 
  { Mathematics.__default.min#requires(a#0, b#0) } 
  Mathematics.__default.min#requires(a#0, b#0) == true);

// definition axiom for Mathematics.__default.min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Mathematics.__default.min(a#0, b#0) } 
    true ==> Mathematics.__default.min(a#0, b#0) == (if a#0 < b#0 then a#0 else b#0));

// definition axiom for Mathematics.__default.min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Mathematics.__default.min(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Mathematics.__default.min(LitInt(a#0), LitInt(b#0))
         == (if a#0 < b#0 then a#0 else b#0));

// function declaration for Mathematics._default.max
function Mathematics.__default.max(a#0: int, b#0: int) : int;

function Mathematics.__default.max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Mathematics.__default.max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Mathematics.__default.max(a#0, b#0) } 
    true ==> true);

function Mathematics.__default.max#requires(int, int) : bool;

// #requires axiom for Mathematics.__default.max
axiom (forall a#0: int, b#0: int :: 
  { Mathematics.__default.max#requires(a#0, b#0) } 
  Mathematics.__default.max#requires(a#0, b#0) == true);

// definition axiom for Mathematics.__default.max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Mathematics.__default.max(a#0, b#0) } 
    true ==> Mathematics.__default.max(a#0, b#0) == (if a#0 < b#0 then b#0 else a#0));

// definition axiom for Mathematics.__default.max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Mathematics.__default.max(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Mathematics.__default.max(LitInt(a#0), LitInt(b#0))
         == (if a#0 < b#0 then b#0 else a#0));

// function declaration for Mathematics._default.Set
function Mathematics.__default.Set(Mathematics._default.Set$T: Ty, ms#0: MultiSet Box) : Set Box;

function Mathematics.__default.Set#canCall(Mathematics._default.Set$T: Ty, ms#0: MultiSet Box) : bool;

// consequence axiom for Mathematics.__default.Set
axiom true
   ==> (forall Mathematics._default.Set$T: Ty, ms#0: MultiSet Box :: 
    { Mathematics.__default.Set(Mathematics._default.Set$T, ms#0) } 
    Mathematics.__default.Set#canCall(Mathematics._default.Set$T, ms#0)
         || $Is(ms#0, TMultiSet(Mathematics._default.Set$T))
       ==> $Is(Mathematics.__default.Set(Mathematics._default.Set$T, ms#0), 
        TSet(Mathematics._default.Set$T)));

function Mathematics.__default.Set#requires(Ty, MultiSet Box) : bool;

// #requires axiom for Mathematics.__default.Set
axiom (forall Mathematics._default.Set$T: Ty, ms#0: MultiSet Box :: 
  { Mathematics.__default.Set#requires(Mathematics._default.Set$T, ms#0) } 
  $Is(ms#0, TMultiSet(Mathematics._default.Set$T))
     ==> Mathematics.__default.Set#requires(Mathematics._default.Set$T, ms#0) == true);

// definition axiom for Mathematics.__default.Set(revealed)
axiom true
   ==> (forall Mathematics._default.Set$T: Ty, ms#0: MultiSet Box :: 
    { Mathematics.__default.Set(Mathematics._default.Set$T, ms#0) } 
    Mathematics.__default.Set#canCall(Mathematics._default.Set$T, ms#0)
         || $Is(ms#0, TMultiSet(Mathematics._default.Set$T))
       ==> Mathematics.__default.Set(Mathematics._default.Set$T, ms#0)
         == (lambda $y#2: Box :: $IsBox($y#2, Mathematics._default.Set$T) && ms#0[$y#2] > 0));

// definition axiom for Mathematics.__default.Set for all literals(revealed)
axiom true
   ==> (forall Mathematics._default.Set$T: Ty, ms#0: MultiSet Box :: 
    {:weight 3} { Mathematics.__default.Set(Mathematics._default.Set$T, Lit(ms#0)) } 
    Mathematics.__default.Set#canCall(Mathematics._default.Set$T, Lit(ms#0))
         || $Is(ms#0, TMultiSet(Mathematics._default.Set$T))
       ==> Mathematics.__default.Set(Mathematics._default.Set$T, Lit(ms#0))
         == (lambda $y#3: Box :: 
          $IsBox($y#3, Mathematics._default.Set$T) && Lit(ms#0)[$y#3] > 0));

// function declaration for Mathematics._default.ISet
function Mathematics.__default.ISet(Mathematics._default.ISet$T: Ty, ms#0: Set Box) : ISet Box;

function Mathematics.__default.ISet#canCall(Mathematics._default.ISet$T: Ty, ms#0: Set Box) : bool;

// consequence axiom for Mathematics.__default.ISet
axiom true
   ==> (forall Mathematics._default.ISet$T: Ty, ms#0: Set Box :: 
    { Mathematics.__default.ISet(Mathematics._default.ISet$T, ms#0) } 
    Mathematics.__default.ISet#canCall(Mathematics._default.ISet$T, ms#0)
         || $Is(ms#0, TSet(Mathematics._default.ISet$T))
       ==> $Is(Mathematics.__default.ISet(Mathematics._default.ISet$T, ms#0), 
        TISet(Mathematics._default.ISet$T)));

function Mathematics.__default.ISet#requires(Ty, Set Box) : bool;

// #requires axiom for Mathematics.__default.ISet
axiom (forall Mathematics._default.ISet$T: Ty, ms#0: Set Box :: 
  { Mathematics.__default.ISet#requires(Mathematics._default.ISet$T, ms#0) } 
  $Is(ms#0, TSet(Mathematics._default.ISet$T))
     ==> Mathematics.__default.ISet#requires(Mathematics._default.ISet$T, ms#0) == true);

// definition axiom for Mathematics.__default.ISet(revealed)
axiom true
   ==> (forall Mathematics._default.ISet$T: Ty, ms#0: Set Box :: 
    { Mathematics.__default.ISet(Mathematics._default.ISet$T, ms#0) } 
    Mathematics.__default.ISet#canCall(Mathematics._default.ISet$T, ms#0)
         || $Is(ms#0, TSet(Mathematics._default.ISet$T))
       ==> Mathematics.__default.ISet(Mathematics._default.ISet$T, ms#0)
         == (lambda $y#2: Box :: $IsBox($y#2, Mathematics._default.ISet$T) && ms#0[$y#2]));

// definition axiom for Mathematics.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Mathematics._default.ISet$T: Ty, ms#0: Set Box :: 
    {:weight 3} { Mathematics.__default.ISet(Mathematics._default.ISet$T, Lit(ms#0)) } 
    Mathematics.__default.ISet#canCall(Mathematics._default.ISet$T, Lit(ms#0))
         || $Is(ms#0, TSet(Mathematics._default.ISet$T))
       ==> Mathematics.__default.ISet(Mathematics._default.ISet$T, Lit(ms#0))
         == (lambda $y#3: Box :: 
          $IsBox($y#3, Mathematics._default.ISet$T) && Lit(ms#0)[$y#3]));

function Tclass.ValueType.Value() : Ty;

// Tclass.ValueType.Value Tag
axiom Tag(Tclass.ValueType.Value()) == Tagclass.ValueType.Value;

const unique Tagclass.ValueType.Value: TyTag;

// Box/unbox axiom for Tclass.ValueType.Value
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.Value()) } 
  $IsBox(bx, Tclass.ValueType.Value())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.ValueType.Value()));

// ValueType.Value: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.ValueType.Value()) } 
  $Is(s#0, Tclass.ValueType.Value())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// ValueType.Value: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.ValueType.Value(), $h) } 
  $IsAlloc(s#0, Tclass.ValueType.Value(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.ValueType.__default: ClassName;

function Tclass.ValueType.__default() : Ty;

// Tclass.ValueType.__default Tag
axiom Tag(Tclass.ValueType.__default()) == Tagclass.ValueType.__default;

const unique Tagclass.ValueType.__default: TyTag;

// Box/unbox axiom for Tclass.ValueType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.__default()) } 
  $IsBox(bx, Tclass.ValueType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueType.__default()) } 
  $Is($o, Tclass.ValueType.__default())
     <==> $o == null || dtype($o) == Tclass.ValueType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueType.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueType._default.MaxLen
function ValueType.__default.MaxLen() : int;

function ValueType.__default.MaxLen#canCall() : bool;

// consequence axiom for ValueType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= ValueType.__default.MaxLen()
     && ValueType.__default.MaxLen() < 18446744073709551616;

function ValueType.__default.MaxLen#requires() : bool;

// #requires axiom for ValueType.__default.MaxLen
axiom ValueType.__default.MaxLen#requires() == true;

// definition axiom for ValueType.__default.MaxLen(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// definition axiom for ValueType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// function declaration for ValueType._default.DefaultValue
function ValueType.__default.DefaultValue() : Seq Box;

function ValueType.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueType.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueType.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueType.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueType.__default.DefaultValue
axiom ValueType.__default.DefaultValue#requires() == true;

// definition axiom for ValueType.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// definition axiom for ValueType.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// function declaration for ValueType._default.Len
function ValueType.__default.Len(v#0: Seq Box) : int;

function ValueType.__default.Len#canCall(v#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.Len
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> LitInt(0) <= ValueType.__default.Len(v#0));

function ValueType.__default.Len#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.Len
axiom (forall v#0: Seq Box :: 
  { ValueType.__default.Len#requires(v#0) } 
  $Is(v#0, Tclass.ValueType.Value())
     ==> ValueType.__default.Len#requires(v#0) == true);

// definition axiom for ValueType.__default.Len(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(v#0) == Seq#Length(v#0));

// definition axiom for ValueType.__default.Len for all literals(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    {:weight 3} { ValueType.__default.Len(Lit(v#0)) } 
    ValueType.__default.Len#canCall(Lit(v#0)) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(Lit(v#0)) == Seq#Length(Lit(v#0)));

// function declaration for ValueType._default.ValidMessageBytestring
function ValueType.__default.ValidMessageBytestring(s#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestring#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestring
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function ValueType.__default.ValidMessageBytestring#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestring
axiom (forall s#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestring#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueType.__default.ValidMessageBytestring#requires(s#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestring(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(s#0)
           == (Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())));

// definition axiom for ValueType.__default.ValidMessageBytestring for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestring(Lit(s#0)) } 
    ValueType.__default.ValidMessageBytestring#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())));

// function declaration for ValueType._default.ValidMessageBytestrings
function ValueType.__default.ValidMessageBytestrings(strs#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestrings#canCall(strs#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestrings
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function ValueType.__default.ValidMessageBytestrings#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestrings
axiom (forall strs#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestrings#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueType.__default.ValidMessageBytestrings#requires(strs#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestrings(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#2: int :: 
          { $Unbox(Seq#Index(strs#0, i#2)): Seq Box } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(strs#0)
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(strs#0, i#2)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(strs#0)
           == (forall i#2: int :: 
            { $Unbox(Seq#Index(strs#0, i#2)): Seq Box } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(strs#0)
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(strs#0, i#2)): Seq Box)));

// definition axiom for ValueType.__default.ValidMessageBytestrings for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestrings(Lit(strs#0)) } 
    ValueType.__default.ValidMessageBytestrings#canCall(Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#3: int :: 
          { $Unbox(Seq#Index(strs#0, i#3)): Seq Box } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(strs#0))
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(Lit(strs#0), i#3)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(Lit(strs#0))
           == (forall i#3: int :: 
            { $Unbox(Seq#Index(strs#0, i#3)): Seq Box } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(strs#0))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(Lit(strs#0), i#3)): Seq Box)));

// Constructor function declaration
function #ValueMessage.Delta.NoDelta() : DatatypeType;

const unique ##ValueMessage.Delta.NoDelta: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ValueMessage.Delta.NoDelta()) == ##ValueMessage.Delta.NoDelta;

function ValueMessage.Delta.NoDelta_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d) } 
  ValueMessage.Delta.NoDelta_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Delta.NoDelta);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d) } 
  ValueMessage.Delta.NoDelta_q(d) ==> d == #ValueMessage.Delta.NoDelta());

function Tclass.ValueMessage.Delta() : Ty;

// Tclass.ValueMessage.Delta Tag
axiom Tag(Tclass.ValueMessage.Delta()) == Tagclass.ValueMessage.Delta;

const unique Tagclass.ValueMessage.Delta: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Delta
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Delta()) } 
  $IsBox(bx, Tclass.ValueMessage.Delta())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Delta()));

// Constructor $Is
axiom $Is(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom #ValueMessage.Delta.NoDelta() == Lit(#ValueMessage.Delta.NoDelta());

// Depth-one case-split function
function $IsA#ValueMessage.Delta(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Delta(d) } 
  $IsA#ValueMessage.Delta(d) ==> ValueMessage.Delta.NoDelta_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d), $Is(d, Tclass.ValueMessage.Delta()) } 
  $Is(d, Tclass.ValueMessage.Delta()) ==> ValueMessage.Delta.NoDelta_q(d));

// Datatype extensional equality declaration
function ValueMessage.Delta#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Delta.NoDelta
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Delta#Equal(a, b) } 
  true ==> (ValueMessage.Delta#Equal(a, b) <==> true));

// Datatype extensionality axiom: ValueMessage.Delta
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Delta#Equal(a, b) } 
  ValueMessage.Delta#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Delta: ClassName;

const unique class.ValueMessage.__default: ClassName;

function Tclass.ValueMessage.__default() : Ty;

// Tclass.ValueMessage.__default Tag
axiom Tag(Tclass.ValueMessage.__default()) == Tagclass.ValueMessage.__default;

const unique Tagclass.ValueMessage.__default: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.__default()) } 
  $IsBox(bx, Tclass.ValueMessage.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueMessage.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueMessage.__default()) } 
  $Is($o, Tclass.ValueMessage.__default())
     <==> $o == null || dtype($o) == Tclass.ValueMessage.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueMessage.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueMessage.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueMessage._default.NopDelta
function ValueMessage.__default.NopDelta() : DatatypeType;

function ValueMessage.__default.NopDelta#canCall() : bool;

// consequence axiom for ValueMessage.__default.NopDelta
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.NopDelta(), Tclass.ValueMessage.Delta());

function ValueMessage.__default.NopDelta#requires() : bool;

// #requires axiom for ValueMessage.__default.NopDelta
axiom ValueMessage.__default.NopDelta#requires() == true;

// definition axiom for ValueMessage.__default.NopDelta(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta() == Lit(#ValueMessage.Delta.NoDelta());

// definition axiom for ValueMessage.__default.NopDelta for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta() == Lit(#ValueMessage.Delta.NoDelta());

// function declaration for ValueMessage._default.DefaultValue
function ValueMessage.__default.DefaultValue() : Seq Box;

function ValueMessage.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueMessage.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueMessage.__default.DefaultValue
axiom ValueMessage.__default.DefaultValue#requires() == true;

// definition axiom for ValueMessage.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefaultValue() == Lit(ValueType.__default.DefaultValue());

// definition axiom for ValueMessage.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefaultValue() == Lit(ValueType.__default.DefaultValue());

// function declaration for ValueMessage._default.CombineDeltas
function ValueMessage.__default.CombineDeltas(newdelta#0: DatatypeType, olddelta#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.CombineDeltas#canCall(newdelta#0: DatatypeType, olddelta#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.CombineDeltas
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> (ValueMessage.Delta#Equal(newdelta#0, ValueMessage.__default.NopDelta())
           ==> ValueMessage.Delta#Equal(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), olddelta#0))
         && (ValueMessage.Delta#Equal(olddelta#0, ValueMessage.__default.NopDelta())
           ==> ValueMessage.Delta#Equal(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), newdelta#0))
         && $Is(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), 
          Tclass.ValueMessage.Delta()));

function ValueMessage.__default.CombineDeltas#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.CombineDeltas
axiom (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
  { ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) } 
  $Is(newdelta#0, Tclass.ValueMessage.Delta())
       && $Is(olddelta#0, Tclass.ValueMessage.Delta())
     ==> ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) == true);

// definition axiom for ValueMessage.__default.CombineDeltas(revealed)
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0)
         == Lit(#ValueMessage.Delta.NoDelta()));

// definition axiom for ValueMessage.__default.CombineDeltas for all literals(revealed)
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.CombineDeltas(Lit(newdelta#0), Lit(olddelta#0)) } 
    ValueMessage.__default.CombineDeltas#canCall(Lit(newdelta#0), Lit(olddelta#0))
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> ValueMessage.__default.CombineDeltas(Lit(newdelta#0), Lit(olddelta#0))
         == Lit(#ValueMessage.Delta.NoDelta()));

// function declaration for ValueMessage._default.ApplyDelta
function ValueMessage.__default.ApplyDelta(delta#0: DatatypeType, value#0: Seq Box) : Seq Box;

function ValueMessage.__default.ApplyDelta#canCall(delta#0: DatatypeType, value#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.ApplyDelta
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> (ValueMessage.Delta#Equal(delta#0, ValueMessage.__default.NopDelta())
           ==> Seq#Equal(ValueMessage.__default.ApplyDelta(delta#0, value#0), value#0))
         && $Is(ValueMessage.__default.ApplyDelta(delta#0, value#0), Tclass.ValueType.Value()));

function ValueMessage.__default.ApplyDelta#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.ApplyDelta
axiom (forall delta#0: DatatypeType, value#0: Seq Box :: 
  { ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) } 
  $Is(delta#0, Tclass.ValueMessage.Delta())
       && $Is(value#0, Tclass.ValueType.Value())
     ==> ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) == true);

// definition axiom for ValueMessage.__default.ApplyDelta(revealed)
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> ValueMessage.__default.ApplyDelta(delta#0, value#0) == value#0);

// definition axiom for ValueMessage.__default.ApplyDelta for all literals(revealed)
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.ApplyDelta(Lit(delta#0), Lit(value#0)) } 
    ValueMessage.__default.ApplyDelta#canCall(Lit(delta#0), Lit(value#0))
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> ValueMessage.__default.ApplyDelta(Lit(delta#0), Lit(value#0)) == Lit(value#0));

// function declaration for ValueMessage._default.bytestring_to_Message
function ValueMessage.__default.bytestring__to__Message(s#0: Seq Box) : DatatypeType;

function ValueMessage.__default.bytestring__to__Message#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.bytestring__to__Message
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> $Is(ValueMessage.__default.bytestring__to__Message(s#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.bytestring__to__Message#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestring__to__Message
axiom (forall s#0: Seq Box :: 
  { ValueMessage.__default.bytestring__to__Message#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueMessage.__default.bytestring__to__Message#requires(s#0)
       == (Seq#Length(s#0) < 4294967296));

// definition axiom for ValueMessage.__default.bytestring__to__Message(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> ValueType.__default.MaxLen#canCall()
         && (LitInt(ValueType.__default.MaxLen()) < Seq#Length(s#0)
           ==> ValueType.__default.DefaultValue#canCall())
         && ValueMessage.__default.bytestring__to__Message(s#0)
           == (if Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())
             then #ValueMessage.Message.Define(s#0)
             else #ValueMessage.Message.Define(Lit(ValueType.__default.DefaultValue()))));

// definition axiom for ValueMessage.__default.bytestring__to__Message for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.bytestring__to__Message(Lit(s#0)) } 
    ValueMessage.__default.bytestring__to__Message#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) < 4294967296)
       ==> ValueType.__default.MaxLen#canCall()
         && (LitInt(ValueType.__default.MaxLen()) < Seq#Length(Lit(s#0))
           ==> ValueType.__default.DefaultValue#canCall())
         && ValueMessage.__default.bytestring__to__Message(Lit(s#0))
           == (if Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())
             then #ValueMessage.Message.Define(Lit(s#0))
             else #ValueMessage.Message.Define(Lit(ValueType.__default.DefaultValue()))));

// function declaration for ValueMessage._default.EncodableMessage
function ValueMessage.__default.EncodableMessage(msg#0: DatatypeType) : bool;

function ValueMessage.__default.EncodableMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> true);

function ValueMessage.__default.EncodableMessage#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessage
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.EncodableMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.EncodableMessage#requires(msg#0) == true);

// definition axiom for ValueMessage.__default.EncodableMessage(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.EncodableMessage(msg#0)
         == (true && ValueMessage.Message.Define_q(msg#0)));

// definition axiom for ValueMessage.__default.EncodableMessage for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.EncodableMessage(Lit(msg#0)) } 
    ValueMessage.__default.EncodableMessage#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.EncodableMessage(Lit(msg#0))
         == Lit(true && ValueMessage.Message.Define_q(Lit(msg#0))));

// function declaration for ValueMessage._default.EncodableMessageSeq
function ValueMessage.__default.EncodableMessageSeq(msgs#0: Seq Box) : bool;

function ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessageSeq
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function ValueMessage.__default.EncodableMessageSeq#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessageSeq
axiom (forall msgs#0: Seq Box :: 
  { ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) == true);

// definition axiom for ValueMessage.__default.EncodableMessageSeq(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Lit(true)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(msgs#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(msgs#0)
               ==> ValueMessage.__default.EncodableMessage#canCall($Unbox(Seq#Index(msgs#0, i#2)): DatatypeType)))
         && ValueMessage.__default.EncodableMessageSeq(msgs#0)
           == (true
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(msgs#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(msgs#0)
                 ==> ValueMessage.__default.EncodableMessage($Unbox(Seq#Index(msgs#0, i#2)): DatatypeType))));

// definition axiom for ValueMessage.__default.EncodableMessageSeq for all literals(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0)) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(Lit(msgs#0))
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Lit(true)
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(msgs#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(msgs#0))
               ==> ValueMessage.__default.EncodableMessage#canCall($Unbox(Seq#Index(Lit(msgs#0), i#3)): DatatypeType)))
         && ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0))
           == (true
             && (forall i#3: int :: 
              { $Unbox(Seq#Index(msgs#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(msgs#0))
                 ==> ValueMessage.__default.EncodableMessage($Unbox(Seq#Index(Lit(msgs#0), i#3)): DatatypeType))));

// function declaration for ValueMessage._default.Message_to_bytestring
function ValueMessage.__default.Message__to__bytestring(msg#0: DatatypeType) : Seq Box;

function ValueMessage.__default.Message__to__bytestring#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Message__to__bytestring
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> $Is(ValueMessage.__default.Message__to__bytestring(msg#0), 
        TSeq(Tclass.NativeTypes.byte())));

function ValueMessage.__default.Message__to__bytestring#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Message__to__bytestring
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.Message__to__bytestring#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Message__to__bytestring#requires(msg#0)
       == ValueMessage.Message.Define_q(msg#0));

// definition axiom for ValueMessage.__default.Message__to__bytestring(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> ValueMessage.__default.Message__to__bytestring(msg#0)
         == ValueMessage.Message.value(msg#0));

// definition axiom for ValueMessage.__default.Message__to__bytestring for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Message__to__bytestring(Lit(msg#0)) } 
    ValueMessage.__default.Message__to__bytestring#canCall(Lit(msg#0))
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && Lit(ValueMessage.Message.Define_q(Lit(msg#0))))
       ==> ValueMessage.__default.Message__to__bytestring(Lit(msg#0))
         == Lit(ValueMessage.Message.value(Lit(msg#0))));

// function declaration for ValueMessage._default.messageSeq_to_bytestringSeq
function ValueMessage.__default.messageSeq__to__bytestringSeq($ly: LayerType, msgs#0: Seq Box) : Seq Box;

function ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq(AsFuelBottom($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($LZ, msgs#0));

// consequence axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
           == Seq#Length(msgs#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(msgs#0, i#1)): DatatypeType } 
            { $Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#1)): Seq Box } 
          LitInt(0) <= i#1
               && i#1
                 < Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
             ==> Seq#Equal($Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#1)): Seq Box, 
              ValueMessage.__default.Message__to__bytestring($Unbox(Seq#Index(msgs#0, i#1)): DatatypeType)))
         && $Is(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function ValueMessage.__default.messageSeq__to__bytestringSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0)
       == ValueMessage.__default.EncodableMessageSeq(msgs#0));

// definition axiom for ValueMessage.__default.messageSeq__to__bytestringSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> (Seq#Length(msgs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0))
             && 
            Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && ValueMessage.__default.Message__to__bytestring#canCall($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)): DatatypeType))
         && ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
           == (if Seq#Length(msgs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.Message__to__bytestring($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)): DatatypeType))))));

// definition axiom for ValueMessage.__default.messageSeq__to__bytestringSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), Lit(msgs#0)) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Lit(msgs#0))
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Lit(ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0))))
       ==> (Seq#Length(Lit(msgs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && ValueMessage.__default.Message__to__bytestring#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType)))
         && ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), Lit(msgs#0))
           == (if Seq#Length(Lit(msgs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.Message__to__bytestring(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType))))))));

// function declaration for ValueMessage._default.bytestringSeq_to_MessageSeq
function ValueMessage.__default.bytestringSeq__to__MessageSeq($ly: LayerType, strings#0: Seq Box) : Seq Box;

function ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq(AsFuelBottom($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($LZ, strings#0));

// consequence axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(strings#0, i#4)): Seq Box } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#4)): Seq Box) < 4294967296))
       ==> Seq#Length(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0))
           == Seq#Length(strings#0)
         && (forall i#5: int :: 
          { $Unbox(Seq#Index(strings#0, i#5)): Seq Box } 
            { $Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#5)): DatatypeType } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(strings#0)
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#5)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(strings#0, i#5)): Seq Box)))
         && $Is(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), 
          TSeq(Tclass.ValueMessage.Message())));

function ValueMessage.__default.bytestringSeq__to__MessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0) } 
  $Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0)
       == (forall i#6: int :: 
        { $Unbox(Seq#Index(strings#0, i#6)): Seq Box } 
        LitInt(0) <= i#6 && i#6 < Seq#Length(strings#0)
           ==> Seq#Length($Unbox(Seq#Index(strings#0, i#6)): Seq Box) < 4294967296));

// definition axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#6: int :: 
            { $Unbox(Seq#Index(strings#0, i#6)): Seq Box } 
            LitInt(0) <= i#6 && i#6 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#6)): Seq Box) < 4294967296))
       ==> (Seq#Length(strings#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strings#0)
             && ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strings#0))
             && 
            Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strings#0)
             && ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strings#0)): Seq Box))
         && ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
           == (if Seq#Length(strings#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strings#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.bytestring__to__Message($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strings#0)): Seq Box))))));

// definition axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), Lit(strings#0)) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Lit(strings#0))
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#7: int :: 
            { $Unbox(Seq#Index(strings#0, i#7)): Seq Box } 
            LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(strings#0))
               ==> Seq#Length($Unbox(Seq#Index(Lit(strings#0), i#7)): Seq Box) < 4294967296))
       ==> (Seq#Length(Lit(strings#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))
             && ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))))
             && 
            Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))
             && ValueMessage.__default.bytestring__to__Message#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))): Seq Box)))
         && ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), Lit(strings#0))
           == (if Seq#Length(Lit(strings#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.bytestring__to__Message(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))): Seq Box))))))));

// function declaration for ValueMessage._default.Merge
function ValueMessage.__default.Merge(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.Merge#canCall(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Merge
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> $Is(ValueMessage.__default.Merge(newmessage#0, oldmessage#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.Merge#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Merge
axiom (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
  { ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) } 
  $Is(newmessage#0, Tclass.ValueMessage.Message())
       && $Is(oldmessage#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) == true);

// definition axiom for ValueMessage.__default.Merge(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
         && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0))))
         && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
             && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var value#4 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var delta#4 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#4, value#4))))
             && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var olddelta#4 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var newdelta#4 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#4, olddelta#4)))))
         && ValueMessage.__default.Merge(newmessage#0, oldmessage#0)
           == (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
             then (var newvalue#5 := ValueMessage.Message.value($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
              #ValueMessage.Message.Define(newvalue#5))
             else (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               then (var value#5 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var delta#5 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#5, value#5))))
               else (var olddelta#5 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var newdelta#5 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#5, olddelta#5)))))));

// definition axiom for ValueMessage.__default.Merge for all literals(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0)) } 
    ValueMessage.__default.Merge#canCall(Lit(newmessage#0), Lit(oldmessage#0))
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
         && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0))))))
         && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
             && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var value#6 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var delta#6 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#6, value#6))))
             && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var olddelta#6 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var newdelta#6 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#6, olddelta#6)))))
         && ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0))
           == (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
             then (var newvalue#7 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
              Lit(#ValueMessage.Message.Define(newvalue#7)))
             else (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
               then (var value#7 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var delta#7 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.ApplyDelta(delta#7, value#7))))))
               else (var olddelta#7 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var newdelta#7 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.CombineDeltas(newdelta#7, olddelta#7)))))))));

// function declaration for ValueMessage._default.IdentityMessage
function ValueMessage.__default.IdentityMessage() : DatatypeType;

function ValueMessage.__default.IdentityMessage#canCall() : bool;

// consequence axiom for ValueMessage.__default.IdentityMessage
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.IdentityMessage(), Tclass.ValueMessage.Message());

function ValueMessage.__default.IdentityMessage#requires() : bool;

// #requires axiom for ValueMessage.__default.IdentityMessage
axiom ValueMessage.__default.IdentityMessage#requires() == true;

// definition axiom for ValueMessage.__default.IdentityMessage(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta())));

// definition axiom for ValueMessage.__default.IdentityMessage for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta())));

// function declaration for ValueMessage._default.DefineDefault
function ValueMessage.__default.DefineDefault() : DatatypeType;

function ValueMessage.__default.DefineDefault#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefineDefault
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefineDefault(), Tclass.ValueMessage.Message());

function ValueMessage.__default.DefineDefault#requires() : bool;

// #requires axiom for ValueMessage.__default.DefineDefault
axiom ValueMessage.__default.DefineDefault#requires() == true;

// definition axiom for ValueMessage.__default.DefineDefault(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.DefaultValue())));

// definition axiom for ValueMessage.__default.DefineDefault for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.DefaultValue())));

// Constructor function declaration
function #ValueMessage.Message.Define(Seq Box) : DatatypeType;

const unique ##ValueMessage.Message.Define: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#0#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Define(a#0#0#0))
     == ##ValueMessage.Message.Define);

function ValueMessage.Message.Define_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Define);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #ValueMessage.Message.Define(a#1#0#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#2#0#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Define_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(Lit(a#4#0#0)) } 
  #ValueMessage.Message.Define(Lit(a#4#0#0))
     == Lit(#ValueMessage.Message.Define(a#4#0#0)));

function ValueMessage.Message.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#5#0#0) } 
  ValueMessage.Message.value(#ValueMessage.Message.Define(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #ValueMessage.Message.Update(DatatypeType) : DatatypeType;

const unique ##ValueMessage.Message.Update: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#6#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Update(a#6#0#0))
     == ##ValueMessage.Message.Update);

function ValueMessage.Message.Update_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Update);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     ==> (exists a#7#0#0: DatatypeType :: d == #ValueMessage.Message.Update(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: DatatypeType :: 
  { $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#8#0#0, Tclass.ValueMessage.Delta()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#9#0#0, Tclass.ValueMessage.Delta(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Update_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom (forall a#10#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(Lit(a#10#0#0)) } 
  #ValueMessage.Message.Update(Lit(a#10#0#0))
     == Lit(#ValueMessage.Message.Update(a#10#0#0)));

function ValueMessage.Message.delta(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#11#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#11#0#0) } 
  ValueMessage.Message.delta(#ValueMessage.Message.Update(a#11#0#0)) == a#11#0#0);

// Inductive rank
axiom (forall a#12#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#12#0#0) } 
  DtRank(a#12#0#0) < DtRank(#ValueMessage.Message.Update(a#12#0#0)));

// Depth-one case-split function
function $IsA#ValueMessage.Message(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Message(d) } 
  $IsA#ValueMessage.Message(d)
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
    { ValueMessage.Message.Define_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
  $Is(d, Tclass.ValueMessage.Message())
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Datatype extensional equality declaration
function ValueMessage.Message#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Message.Define
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(b) } 
  ValueMessage.Message.Define_q(a) && ValueMessage.Message.Define_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> Seq#Equal(ValueMessage.Message.value(a), ValueMessage.Message.value(b))));

// Datatype extensional equality definition: #ValueMessage.Message.Update
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(b) } 
  ValueMessage.Message.Update_q(a) && ValueMessage.Message.Update_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> ValueMessage.Delta#Equal(ValueMessage.Message.delta(a), ValueMessage.Message.delta(b))));

// Datatype extensionality axiom: ValueMessage.Message
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b) } 
  ValueMessage.Message#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Message: ClassName;

const unique class.KMBtreeModel.__default: ClassName;

function Tclass.KMBtreeModel.__default() : Ty;

// Tclass.KMBtreeModel.__default Tag
axiom Tag(Tclass.KMBtreeModel.__default()) == Tagclass.KMBtreeModel.__default;

const unique Tagclass.KMBtreeModel.__default: TyTag;

// Box/unbox axiom for Tclass.KMBtreeModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KMBtreeModel.__default()) } 
  $IsBox(bx, Tclass.KMBtreeModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.KMBtreeModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KMBtreeModel.__default()) } 
  $Is($o, Tclass.KMBtreeModel.__default())
     <==> $o == null || dtype($o) == Tclass.KMBtreeModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KMBtreeModel.__default(), $h) } 
  $IsAlloc($o, Tclass.KMBtreeModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for KMBtreeModel._default.AllKeys
function KMBtreeModel.__default.AllKeys($ly: LayerType, node#0: DatatypeType) : Set Box;

function KMBtreeModel.__default.AllKeys#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.AllKeys($LS($ly), node#0) } 
  KMBtreeModel.__default.AllKeys($LS($ly), node#0)
     == KMBtreeModel.__default.AllKeys($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.AllKeys(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.AllKeys($ly, node#0)
     == KMBtreeModel.__default.AllKeys($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.AllKeys
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.AllKeys($ly, node#0) } 
    KMBtreeModel.__default.AllKeys#canCall(node#0)
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> (KMBtreeModel.Node.Leaf_q(node#0)
             && 0 < Seq#Length(KMBtreeModel.Node.keys(node#0))
           ==> !Set#Equal(KMBtreeModel.__default.AllKeys($ly, node#0), Set#Empty(): Set Box))
         && (KMBtreeModel.Node.Index_q(node#0)
             && 0 < Seq#Length(KMBtreeModel.Node.pivots(node#0))
           ==> !Set#Equal(KMBtreeModel.__default.AllKeys($ly, node#0), Set#Empty(): Set Box))
         && $Is(KMBtreeModel.__default.AllKeys($ly, node#0), 
          TSet(TSeq(Tclass.NativeTypes.byte()))));

function KMBtreeModel.__default.AllKeys#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.AllKeys
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.AllKeys#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.AllKeys#requires($ly, node#0) == true);

// definition axiom for KMBtreeModel.__default.AllKeys(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.AllKeys($LS($ly), node#0) } 
    KMBtreeModel.__default.AllKeys#canCall(node#0)
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> (var children#5 := KMBtreeModel.Node.children(node#0); 
            (forall i#6: int, k#16: Seq Box :: 
              { KMBtreeModel.__default.AllKeys($ly, $Unbox(Seq#Index(children#5, i#6)): DatatypeType)[$Box(k#16)] } 
              $Is(k#16, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                i#6 < Seq#Length(children#5)
                 ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(children#5, i#6)): DatatypeType))))
         && KMBtreeModel.__default.AllKeys($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then (var values#6 := KMBtreeModel.Node.values(node#0); 
              (var keys#6 := KMBtreeModel.Node.keys(node#0); 
                (var result#12 := (lambda $y#18: Box :: 
                      $IsBox($y#18, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(keys#6, $y#18)); 
                  (if 0 < Seq#Length(KMBtreeModel.Node.keys(node#0))
                     then result#12
                     else result#12))))
             else (var children#6 := KMBtreeModel.Node.children(node#0); 
              (var pivots#6 := KMBtreeModel.Node.pivots(node#0); 
                (var result#13 := Set#Union((lambda $y#19: Box :: 
                        $IsBox($y#19, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(pivots#6, $y#19)), 
                      (lambda $y#20: Box :: 
                        (exists i#7: int, k#17: Seq Box :: 
                          { KMBtreeModel.__default.AllKeys($ly, $Unbox(Seq#Index(children#6, i#7)): DatatypeType)[$Box(k#17)] } 
                          $Is(k#17, TSeq(Tclass.NativeTypes.byte()))
                             && 
                            LitInt(0) <= i#7
                             && i#7 < Seq#Length(children#6)
                             && KMBtreeModel.__default.AllKeys($ly, $Unbox(Seq#Index(children#6, i#7)): DatatypeType)[$Box(k#17)]
                             && $y#20 == $Box(k#17)))); 
                  (if 0 < Seq#Length(KMBtreeModel.Node.pivots(node#0))
                     then result#13
                     else result#13))))));

// definition axiom for KMBtreeModel.__default.AllKeys for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.AllKeys($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.AllKeys#canCall(Lit(node#0))
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> (var children#7 := Lit(KMBtreeModel.Node.children(Lit(node#0))); 
            (forall i#8: int, k#20: Seq Box :: 
              { KMBtreeModel.__default.AllKeys($LS($ly), $Unbox(Seq#Index(children#7, i#8)): DatatypeType)[$Box(k#20)] } 
              $Is(k#20, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                i#8 < Seq#Length(children#7)
                 ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(children#7, i#8)): DatatypeType))))
         && KMBtreeModel.__default.AllKeys($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then (var values#8 := Lit(KMBtreeModel.Node.values(Lit(node#0))); 
              (var keys#8 := Lit(KMBtreeModel.Node.keys(Lit(node#0))); 
                (var result#16 := (lambda $y#24: Box :: 
                      $IsBox($y#24, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(keys#8, $y#24)); 
                  (if 0 < Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(node#0))))
                     then result#16
                     else result#16))))
             else (var children#8 := Lit(KMBtreeModel.Node.children(Lit(node#0))); 
              (var pivots#8 := Lit(KMBtreeModel.Node.pivots(Lit(node#0))); 
                (var result#17 := Set#Union((lambda $y#25: Box :: 
                        $IsBox($y#25, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(pivots#8, $y#25)), 
                      (lambda $y#26: Box :: 
                        (exists i#9: int, k#21: Seq Box :: 
                          { KMBtreeModel.__default.AllKeys($LS($ly), $Unbox(Seq#Index(children#8, i#9)): DatatypeType)[$Box(k#21)] } 
                          $Is(k#21, TSeq(Tclass.NativeTypes.byte()))
                             && 
                            LitInt(0) <= i#9
                             && i#9 < Seq#Length(children#8)
                             && KMBtreeModel.__default.AllKeys($LS($ly), $Unbox(Seq#Index(children#8, i#9)): DatatypeType)[$Box(k#21)]
                             && $y#26 == $Box(k#21)))); 
                  (if 0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0))))
                     then result#17
                     else result#17))))));

// function declaration for KMBtreeModel._default.AllKeysBelowBound
function KMBtreeModel.__default.AllKeysBelowBound(node#0: DatatypeType, i#0: int) : bool;

function KMBtreeModel.__default.AllKeysBelowBound#canCall(node#0: DatatypeType, i#0: int) : bool;

// consequence axiom for KMBtreeModel.__default.AllKeysBelowBound
axiom true
   ==> (forall node#0: DatatypeType, i#0: int :: 
    { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#0) } 
    KMBtreeModel.__default.AllKeysBelowBound#canCall(node#0, i#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.Node.Index_q(node#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(KMBtreeModel.Node.pivots(node#0)))
       ==> true);

function KMBtreeModel.__default.AllKeysBelowBound#requires(DatatypeType, int) : bool;

// #requires axiom for KMBtreeModel.__default.AllKeysBelowBound
axiom (forall node#0: DatatypeType, i#0: int :: 
  { KMBtreeModel.__default.AllKeysBelowBound#requires(node#0, i#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.AllKeysBelowBound#requires(node#0, i#0)
       == (
        KMBtreeModel.Node.Index_q(node#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(KMBtreeModel.Node.pivots(node#0))));

// definition axiom for KMBtreeModel.__default.AllKeysBelowBound(revealed)
axiom true
   ==> (forall node#0: DatatypeType, i#0: int :: 
    { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#0) } 
    KMBtreeModel.__default.AllKeysBelowBound#canCall(node#0, i#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.Node.Index_q(node#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(KMBtreeModel.Node.pivots(node#0)))
       ==> (forall key#4: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#4, $Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0)): Seq Box) } 
            { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)] } 
          $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
             ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)
               && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#4, $Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0)): Seq Box)))
         && KMBtreeModel.__default.AllKeysBelowBound(node#0, i#0)
           == (forall key#4: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#4, $Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0)): Seq Box) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)] } 
            $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)]
               ==> Lexicographic__Byte__Order.__default.lt(key#4, $Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0)): Seq Box)));

// definition axiom for KMBtreeModel.__default.AllKeysBelowBound for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, i#0: int :: 
    {:weight 3} { KMBtreeModel.__default.AllKeysBelowBound(Lit(node#0), LitInt(i#0)) } 
    KMBtreeModel.__default.AllKeysBelowBound#canCall(Lit(node#0), LitInt(i#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          Lit(KMBtreeModel.Node.Index_q(Lit(node#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0)))))
       ==> (forall key#5: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#5, $Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0)): Seq Box) } 
            { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#5)] } 
          $Is(key#5, TSeq(Tclass.NativeTypes.byte()))
             ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(i#0))): DatatypeType)
               && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(i#0))): DatatypeType)[$Box(key#5)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#5, 
                  $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), LitInt(i#0))): Seq Box)))
         && KMBtreeModel.__default.AllKeysBelowBound(Lit(node#0), LitInt(i#0))
           == (forall key#5: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#5, $Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0)): Seq Box) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#5)] } 
            $Is(key#5, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(i#0))): DatatypeType)[$Box(key#5)]
               ==> Lexicographic__Byte__Order.__default.lt(key#5, 
                $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), LitInt(i#0))): Seq Box)));

// function declaration for KMBtreeModel._default.AllKeysAboveBound
function KMBtreeModel.__default.AllKeysAboveBound(node#0: DatatypeType, i#0: int) : bool;

function KMBtreeModel.__default.AllKeysAboveBound#canCall(node#0: DatatypeType, i#0: int) : bool;

// consequence axiom for KMBtreeModel.__default.AllKeysAboveBound
axiom true
   ==> (forall node#0: DatatypeType, i#0: int :: 
    { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#0) } 
    KMBtreeModel.__default.AllKeysAboveBound#canCall(node#0, i#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.Node.Index_q(node#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(KMBtreeModel.Node.children(node#0))
           && 
          LitInt(0) <= i#0 - 1
           && i#0 - 1 < Seq#Length(KMBtreeModel.Node.pivots(node#0)))
       ==> true);

function KMBtreeModel.__default.AllKeysAboveBound#requires(DatatypeType, int) : bool;

// #requires axiom for KMBtreeModel.__default.AllKeysAboveBound
axiom (forall node#0: DatatypeType, i#0: int :: 
  { KMBtreeModel.__default.AllKeysAboveBound#requires(node#0, i#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.AllKeysAboveBound#requires(node#0, i#0)
       == (
        KMBtreeModel.Node.Index_q(node#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(KMBtreeModel.Node.children(node#0))
         && 
        LitInt(0) <= i#0 - 1
         && i#0 - 1 < Seq#Length(KMBtreeModel.Node.pivots(node#0))));

// definition axiom for KMBtreeModel.__default.AllKeysAboveBound(revealed)
axiom true
   ==> (forall node#0: DatatypeType, i#0: int :: 
    { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#0) } 
    KMBtreeModel.__default.AllKeysAboveBound#canCall(node#0, i#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.Node.Index_q(node#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(KMBtreeModel.Node.children(node#0))
           && 
          LitInt(0) <= i#0 - 1
           && i#0 - 1 < Seq#Length(KMBtreeModel.Node.pivots(node#0)))
       ==> (forall key#4: Seq Box :: 
          { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)] } 
          $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
             ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)
               && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)]
                 ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0 - 1)): Seq Box, key#4)))
         && KMBtreeModel.__default.AllKeysAboveBound(node#0, i#0)
           == (forall key#4: Seq Box :: 
            { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)] } 
            $Is(key#4, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#4)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(KMBtreeModel.Node.pivots(node#0), i#0 - 1)): Seq Box, key#4)));

// definition axiom for KMBtreeModel.__default.AllKeysAboveBound for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, i#0: int :: 
    {:weight 3} { KMBtreeModel.__default.AllKeysAboveBound(Lit(node#0), LitInt(i#0)) } 
    KMBtreeModel.__default.AllKeysAboveBound#canCall(Lit(node#0), LitInt(i#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          Lit(KMBtreeModel.Node.Index_q(Lit(node#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
           && 
          LitInt(0) <= LitInt(i#0 - 1)
           && i#0 - 1 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0)))))
       ==> (forall key#5: Seq Box :: 
          { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#5)] } 
          $Is(key#5, TSeq(Tclass.NativeTypes.byte()))
             ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(i#0))): DatatypeType)
               && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(i#0))): DatatypeType)[$Box(key#5)]
                 ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), LitInt(i#0 - 1))): Seq Box, 
                  key#5)))
         && KMBtreeModel.__default.AllKeysAboveBound(Lit(node#0), LitInt(i#0))
           == (forall key#5: Seq Box :: 
            { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType)[$Box(key#5)] } 
            $Is(key#5, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(i#0))): DatatypeType)[$Box(key#5)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), LitInt(i#0 - 1))): Seq Box, 
                key#5)));

// function declaration for KMBtreeModel._default.WF
function KMBtreeModel.__default.WF($ly: LayerType, node#0: DatatypeType) : bool;

function KMBtreeModel.__default.WF#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.WF($LS($ly), node#0) } 
  KMBtreeModel.__default.WF($LS($ly), node#0)
     == KMBtreeModel.__default.WF($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.WF(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.WF($ly, node#0) == KMBtreeModel.__default.WF($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.WF
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.WF($ly, node#0) } 
    KMBtreeModel.__default.WF#canCall(node#0)
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> true);

function KMBtreeModel.__default.WF#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.WF
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.WF#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.WF#requires($ly, node#0) == true);

// definition axiom for KMBtreeModel.__default.WF(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.WF($LS($ly), node#0) } 
    KMBtreeModel.__default.WF#canCall(node#0)
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> (KMBtreeModel.Node.Leaf_q(node#0)
           ==> 
          Seq#Length(KMBtreeModel.Node.keys(node#0))
             == Seq#Length(KMBtreeModel.Node.values(node#0))
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(KMBtreeModel.Node.keys(node#0)))
         && (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> (Seq#Length(KMBtreeModel.Node.pivots(node#0))
                 == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(KMBtreeModel.Node.pivots(node#0)))
             && (Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(KMBtreeModel.Node.pivots(node#0))
                 && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                  KMBtreeModel.Node.pivots(node#0))
               ==> (forall i#16: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType } 
                i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
                   ==> KMBtreeModel.__default.WF#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType)))
             && ((forall i#16: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType } 
                  i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
                     ==> KMBtreeModel.__default.WF#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType))
                 && (forall i#16: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType } 
                  true
                     ==> 
                    LitInt(0) <= i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
                     ==> KMBtreeModel.__default.WF($ly, $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType))
               ==> (forall i#17: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType } 
                i#17 < Seq#Length(KMBtreeModel.Node.children(node#0))
                   ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType)))
             && ((forall i#17: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType } 
                  i#17 < Seq#Length(KMBtreeModel.Node.children(node#0))
                     ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType))
                 && (forall i#17: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType } 
                  true
                     ==> 
                    LitInt(0) <= i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(node#0))
                     ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                        $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType), 
                      Set#Empty(): Set Box))
               ==> (forall i#18: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18) } 
                i#18 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound#canCall(node#0, i#18)))
             && ((forall i#18: int :: 
                  { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18) } 
                  i#18 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
                     ==> KMBtreeModel.__default.AllKeysBelowBound#canCall(node#0, i#18))
                 && (forall i#18: int :: 
                  { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18) } 
                  true
                     ==> 
                    LitInt(0) <= i#18 && i#18 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
                     ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18))
               ==> (forall i#19: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19) } 
                i#19 < Seq#Length(KMBtreeModel.Node.children(node#0))
                   ==> KMBtreeModel.__default.AllKeysAboveBound#canCall(node#0, i#19))))
         && KMBtreeModel.__default.WF($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then Seq#Length(KMBtreeModel.Node.keys(node#0))
                 == Seq#Length(KMBtreeModel.Node.values(node#0))
               && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.keys(node#0))
             else Seq#Length(KMBtreeModel.Node.pivots(node#0))
                 == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
               && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                KMBtreeModel.Node.pivots(node#0))
               && (forall i#16: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
                   ==> KMBtreeModel.__default.WF($ly, $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType))
               && (forall i#17: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(node#0))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType), 
                    Set#Empty(): Set Box))
               && (forall i#18: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18) } 
                true
                   ==> 
                  LitInt(0) <= i#18 && i#18 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18))
               && (forall i#19: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19) } 
                true
                   ==> 
                  0 < i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(node#0))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19))));

// definition axiom for KMBtreeModel.__default.WF for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.WF($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.WF#canCall(Lit(node#0))
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> (Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> 
          Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(node#0))))
             == Seq#Length(Lit(KMBtreeModel.Node.values(Lit(node#0))))
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(KMBtreeModel.Node.keys(Lit(node#0)))))
         && (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> (Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0))))
                 == Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
               ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(KMBtreeModel.Node.pivots(Lit(node#0)))))
             && (Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(KMBtreeModel.Node.pivots(Lit(node#0))))
                 && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                  Lit(KMBtreeModel.Node.pivots(Lit(node#0))))
               ==> (forall i#20: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#20)): DatatypeType } 
                i#20 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                   ==> KMBtreeModel.__default.WF#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#20)): DatatypeType)))
             && ((forall i#20: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#20)): DatatypeType } 
                  i#20 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                     ==> KMBtreeModel.__default.WF#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#20)): DatatypeType))
                 && (forall i#20: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#20)): DatatypeType } 
                  true
                     ==> 
                    LitInt(0) <= i#20
                       && i#20 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                     ==> KMBtreeModel.__default.WF($LS($ly), 
                      $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#20)): DatatypeType))
               ==> (forall i#21: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#21)): DatatypeType } 
                i#21 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                   ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#21)): DatatypeType)))
             && ((forall i#21: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#21)): DatatypeType } 
                  i#21 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                     ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#21)): DatatypeType))
                 && (forall i#21: int :: 
                  { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#21)): DatatypeType } 
                  true
                     ==> 
                    LitInt(0) <= i#21
                       && i#21 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                     ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                        $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#21)): DatatypeType), 
                      Set#Empty(): Set Box))
               ==> (forall i#22: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#22) } 
                i#22 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound#canCall(Lit(node#0), i#22)))
             && ((forall i#22: int :: 
                  { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#22) } 
                  i#22 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
                     ==> KMBtreeModel.__default.AllKeysBelowBound#canCall(Lit(node#0), i#22))
                 && (forall i#22: int :: 
                  { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#22) } 
                  true
                     ==> 
                    LitInt(0) <= i#22
                       && i#22 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
                     ==> KMBtreeModel.__default.AllKeysBelowBound(Lit(node#0), i#22))
               ==> (forall i#23: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#23) } 
                i#23 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                   ==> KMBtreeModel.__default.AllKeysAboveBound#canCall(Lit(node#0), i#23))))
         && KMBtreeModel.__default.WF($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(node#0))))
                 == Seq#Length(Lit(KMBtreeModel.Node.values(Lit(node#0))))
               && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                Lit(KMBtreeModel.Node.keys(Lit(node#0))))
             else Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0))))
                 == Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
               && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
                Lit(KMBtreeModel.Node.pivots(Lit(node#0))))
               && (forall i#20: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#20)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#20
                     && i#20 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                   ==> KMBtreeModel.__default.WF($LS($ly), 
                    $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#20)): DatatypeType))
               && (forall i#21: int :: 
                { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#21)): DatatypeType } 
                true
                   ==> 
                  LitInt(0) <= i#21
                     && i#21 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                   ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                      $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), i#21)): DatatypeType), 
                    Set#Empty(): Set Box))
               && (forall i#22: int :: 
                { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#22) } 
                true
                   ==> 
                  LitInt(0) <= i#22
                     && i#22 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))) - 1
                   ==> KMBtreeModel.__default.AllKeysBelowBound(Lit(node#0), i#22))
               && (forall i#23: int :: 
                { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#23) } 
                true
                   ==> 
                  0 < i#23 && i#23 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
                   ==> KMBtreeModel.__default.AllKeysAboveBound(Lit(node#0), i#23))));

// function declaration for KMBtreeModel._default.Interpretation
function KMBtreeModel.__default.Interpretation($ly: LayerType, node#0: DatatypeType) : Map Box Box;

function KMBtreeModel.__default.Interpretation#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.Interpretation($LS($ly), node#0) } 
  KMBtreeModel.__default.Interpretation($LS($ly), node#0)
     == KMBtreeModel.__default.Interpretation($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.Interpretation(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.Interpretation($ly, node#0)
     == KMBtreeModel.__default.Interpretation($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.Interpretation
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.Interpretation($ly, node#0) } 
    KMBtreeModel.__default.Interpretation#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && KMBtreeModel.__default.WF($LS($LZ), node#0))
       ==> $Is(KMBtreeModel.__default.Interpretation($ly, node#0), 
        TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message())));

function KMBtreeModel.__default.Interpretation#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.Interpretation
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.Interpretation#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.Interpretation#requires($ly, node#0)
       == KMBtreeModel.__default.WF($LS($LZ), node#0));

// definition axiom for KMBtreeModel.__default.Interpretation(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.Interpretation($LS($ly), node#0) } 
    KMBtreeModel.__default.Interpretation#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && KMBtreeModel.__default.WF($LS($LZ), node#0))
       ==> (KMBtreeModel.Node.Leaf_q(node#0)
           ==> (forall k#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.keys(node#0), k#0) } 
              { Seq#Contains(KMBtreeModel.Node.keys(node#0), $Box(k#0)) } 
            $Is(k#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Seq#Contains(KMBtreeModel.Node.keys(node#0), $Box(k#0))
               ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(KMBtreeModel.Node.keys(node#0), k#0)))
         && (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> (forall key#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, node#0)[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               ==> KMBtreeModel.__default.AllKeys#canCall(node#0)
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, node#0)[$Box(key#0)]
                   ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(KMBtreeModel.Node.pivots(node#0), key#0)
                     && KMBtreeModel.__default.Interpretation#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
                          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                             + 1)): DatatypeType))
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, node#0)[$Box(key#0)]
                     && Map#Domain(KMBtreeModel.__default.Interpretation($ly, 
                        $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
                            Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                               + 1)): DatatypeType))[$Box(key#0)]
                   ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(KMBtreeModel.Node.pivots(node#0), key#0)
                     && KMBtreeModel.__default.Interpretation#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
                          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                             + 1)): DatatypeType))))
         && KMBtreeModel.__default.Interpretation($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then Map#Glue((lambda $w#6: Box :: 
                $Is($Unbox($w#6): Seq Box, TSeq(Tclass.NativeTypes.byte()))
                   && Seq#Contains(KMBtreeModel.Node.keys(node#0), $w#6)), 
              (lambda $w#6: Box :: 
                Seq#Index(KMBtreeModel.Node.values(node#0), 
                  Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.keys(node#0), $Unbox($w#6): Seq Box))), 
              TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()))
             else Map#Glue((lambda $w#7: Box :: 
                $Is($Unbox($w#7): Seq Box, TSeq(Tclass.NativeTypes.byte()))
                   && 
                  KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, node#0)[$w#7]
                   && Map#Domain(KMBtreeModel.__default.Interpretation($ly, 
                      $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
                          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), $Unbox($w#7): Seq Box)
                             + 1)): DatatypeType))[$w#7]), 
              (lambda $w#7: Box :: 
                Map#Elements(KMBtreeModel.__default.Interpretation($ly, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
                        Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), $Unbox($w#7): Seq Box)
                           + 1)): DatatypeType))[$w#7]), 
              TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()))));

// definition axiom for KMBtreeModel.__default.Interpretation for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.Interpretation($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.Interpretation#canCall(Lit(node#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(node#0))))
       ==> (Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> (forall k#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.keys(node#0), k#0) } 
              { Seq#Contains(KMBtreeModel.Node.keys(node#0), $Box(k#0)) } 
            $Is(k#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Seq#Contains(KMBtreeModel.Node.keys(Lit(node#0)), $Box(k#0))
               ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(KMBtreeModel.Node.keys(Lit(node#0))), k#0)))
         && (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> (forall key#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, node#0)[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               ==> KMBtreeModel.__default.AllKeys#canCall(Lit(node#0))
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, Lit(node#0))[$Box(key#0)]
                   ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), key#0)
                     && KMBtreeModel.__default.Interpretation#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), 
                          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.pivots(Lit(node#0))), key#0)
                             + 1)): DatatypeType))
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, Lit(node#0))[$Box(key#0)]
                     && Map#Domain(KMBtreeModel.__default.Interpretation($LS($ly), 
                        $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), 
                            Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.pivots(Lit(node#0))), key#0)
                               + 1)): DatatypeType))[$Box(key#0)]
                   ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), key#0)
                     && KMBtreeModel.__default.Interpretation#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), 
                          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.pivots(Lit(node#0))), key#0)
                             + 1)): DatatypeType))))
         && KMBtreeModel.__default.Interpretation($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then Map#Glue((lambda $w#8: Box :: 
                $Is($Unbox($w#8): Seq Box, TSeq(Tclass.NativeTypes.byte()))
                   && Seq#Contains(KMBtreeModel.Node.keys(Lit(node#0)), $w#8)), 
              (lambda $w#8: Box :: 
                Seq#Index(Lit(KMBtreeModel.Node.values(Lit(node#0))), 
                  Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.keys(Lit(node#0))), $Unbox($w#8): Seq Box))), 
              TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()))
             else Map#Glue((lambda $w#9: Box :: 
                $Is($Unbox($w#9): Seq Box, TSeq(Tclass.NativeTypes.byte()))
                   && 
                  KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, Lit(node#0))[$w#9]
                   && Map#Domain(KMBtreeModel.__default.Interpretation($LS($ly), 
                      $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), 
                          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.pivots(Lit(node#0))), $Unbox($w#9): Seq Box)
                             + 1)): DatatypeType))[$w#9]), 
              (lambda $w#9: Box :: 
                Map#Elements(KMBtreeModel.__default.Interpretation($LS($ly), 
                    $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), 
                        Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.pivots(Lit(node#0))), $Unbox($w#9): Seq Box)
                           + 1)): DatatypeType))[$w#9]), 
              TMap(TSeq(Tclass.NativeTypes.byte()), Tclass.ValueMessage.Message()))));

procedure {:_induction node#0, key#0} CheckWellformed$$KMBtreeModel.__default.InterpretationDelegation(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  free requires 12 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0, key#0} Call$$KMBtreeModel.__default.InterpretationDelegation(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#24: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#24)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#24 && i#24 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#24)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#25: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#25)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#25 && i#25 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#25)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#26: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#26) } 
          true
             ==> 
            LitInt(0) <= i#26 && i#26 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#26)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#27: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#27) } 
          true
             ==> 
            0 < i#27 && i#27 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#27)));
  requires KMBtreeModel.Node.Index_q(node#0);
  requires Map#Domain(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
          Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), KMBtreeModel.Node.pivots(node#0), key#0)
             + 1)): DatatypeType))[$Box(key#0)];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.Interpretation#canCall(node#0)
     && 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(KMBtreeModel.Node.pivots(node#0), key#0)
     && KMBtreeModel.__default.Interpretation#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
          Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
             + 1)): DatatypeType)
     && Maps.__default.MapsTo#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0), 
      $Box(key#0), 
      Map#Elements(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
              Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                 + 1)): DatatypeType))[$Box(key#0)]);
  free ensures Maps.__default.MapsTo#canCall(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0), 
      $Box(key#0), 
      Map#Elements(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
              Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                 + 1)): DatatypeType))[$Box(key#0)])
     && 
    Maps.__default.MapsTo(TSeq(Tclass.NativeTypes.byte()), 
      Tclass.ValueMessage.Message(), 
      KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0), 
      $Box(key#0), 
      Map#Elements(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
              Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                 + 1)): DatatypeType))[$Box(key#0)])
     && 
    Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#0)]
     && ValueMessage.Message#Equal($Unbox(Map#Elements(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#0)]): DatatypeType, 
      $Unbox(Map#Elements(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), 
                Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.pivots(node#0), key#0)
                   + 1)): DatatypeType))[$Box(key#0)]): DatatypeType);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} CheckWellformed$$KMBtreeModel.__default.IndexesNonempty(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtreeModel.__default.IndexesNonempty(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#16: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#17: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#18: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18) } 
          true
             ==> 
            LitInt(0) <= i#18 && i#18 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#19: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19) } 
          true
             ==> 
            0 < i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19)));
  requires KMBtreeModel.Node.Index_q(node#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.Interpretation#canCall(node#0);
  ensures 0
     < Map#Card(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} CheckWellformed$$KMBtreeModel.__default.ChildOfIndexNonempty(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0), 
    i#0: int where LitInt(0) <= i#0);
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtreeModel.__default.ChildOfIndexNonempty(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0), 
    i#0: int where LitInt(0) <= i#0);
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#13: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#13)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#13 && i#13 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#13)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#14: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#14)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#14 && i#14 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#14)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#15: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#15) } 
          true
             ==> 
            LitInt(0) <= i#15 && i#15 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#15)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#16: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#16) } 
          true
             ==> 
            0 < i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#16)));
  requires KMBtreeModel.Node.Index_q(node#0);
  requires i#0 < Seq#Length(KMBtreeModel.Node.children(node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.Interpretation#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType);
  ensures 0
     < Map#Card(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#0)): DatatypeType));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for KMBtreeModel._default.MinKey
function KMBtreeModel.__default.MinKey($ly: LayerType, node#0: DatatypeType) : Seq Box;

function KMBtreeModel.__default.MinKey#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.MinKey($LS($ly), node#0) } 
  KMBtreeModel.__default.MinKey($LS($ly), node#0)
     == KMBtreeModel.__default.MinKey($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.MinKey(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.MinKey($ly, node#0)
     == KMBtreeModel.__default.MinKey($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.MinKey
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.MinKey($ly, node#0) } 
    KMBtreeModel.__default.MinKey#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.__default.WF($LS($LZ), node#0)
           && 0
             < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0)))
       ==> $Is(KMBtreeModel.__default.MinKey($ly, node#0), TSeq(Tclass.NativeTypes.byte())));

function KMBtreeModel.__default.MinKey#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.MinKey
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.MinKey#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.MinKey#requires($ly, node#0)
       == (KMBtreeModel.__default.WF($LS($LZ), node#0)
         && 0
           < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))));

// definition axiom for KMBtreeModel.__default.MinKey(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.MinKey($LS($ly), node#0) } 
    KMBtreeModel.__default.MinKey#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.__default.WF($LS($LZ), node#0)
           && 0
             < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0)))
       ==> (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> KMBtreeModel.__default.MinKey#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), LitInt(0))): DatatypeType))
         && KMBtreeModel.__default.MinKey($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then $Unbox(Seq#Index(KMBtreeModel.Node.keys(node#0), LitInt(0))): Seq Box
             else KMBtreeModel.__default.MinKey($ly, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), LitInt(0))): DatatypeType)));

// definition axiom for KMBtreeModel.__default.MinKey for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.MinKey($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.MinKey#canCall(Lit(node#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(node#0)))
           && 0
             < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, Lit(node#0))))
       ==> (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> KMBtreeModel.__default.MinKey#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(0))): DatatypeType))
         && KMBtreeModel.__default.MinKey($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then $Unbox(Seq#Index(Lit(KMBtreeModel.Node.keys(Lit(node#0))), LitInt(0))): Seq Box
             else KMBtreeModel.__default.MinKey($LS($ly), 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(0))): DatatypeType)));

procedure {:_induction node#0} CheckWellformed$$KMBtreeModel.__default.MinKeyProperties(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtreeModel.__default.MinKeyProperties(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#36: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#36)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#36 && i#36 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#36)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#37: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#37)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#37 && i#37 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#37)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#38: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#38) } 
          true
             ==> 
            LitInt(0) <= i#38 && i#38 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#38)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#39: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#39) } 
          true
             ==> 
            0 < i#39 && i#39 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#39)));
  requires 0
     < Map#Card(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.MinKey#canCall(node#0)
     && KMBtreeModel.__default.Interpretation#canCall(node#0);
  ensures Map#Domain(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0))[$Box(KMBtreeModel.__default.MinKey($LS($LS($LZ)), node#0))];
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(KMBtreeModel.__default.MinKey($LS($LZ), node#0), key#1) } 
      { Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
       ==> KMBtreeModel.__default.Interpretation#canCall(node#0)
         && (Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)]
           ==> KMBtreeModel.__default.MinKey#canCall(node#0)
             && Lexicographic__Byte__Order.__default.lte#canCall(KMBtreeModel.__default.MinKey($LS($LZ), node#0), key#1)));
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(KMBtreeModel.__default.MinKey($LS($LZ), node#0), key#1) } 
      { Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
         && Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)]
       ==> Lexicographic__Byte__Order.__default.lte(KMBtreeModel.__default.MinKey($LS($LZ), node#0), key#1));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for KMBtreeModel._default.MaxKey
function KMBtreeModel.__default.MaxKey($ly: LayerType, node#0: DatatypeType) : Seq Box;

function KMBtreeModel.__default.MaxKey#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.MaxKey($LS($ly), node#0) } 
  KMBtreeModel.__default.MaxKey($LS($ly), node#0)
     == KMBtreeModel.__default.MaxKey($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.MaxKey(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.MaxKey($ly, node#0)
     == KMBtreeModel.__default.MaxKey($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.MaxKey
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.MaxKey($ly, node#0) } 
    KMBtreeModel.__default.MaxKey#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.__default.WF($LS($LZ), node#0)
           && 0
             < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0)))
       ==> $Is(KMBtreeModel.__default.MaxKey($ly, node#0), TSeq(Tclass.NativeTypes.byte())));

function KMBtreeModel.__default.MaxKey#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.MaxKey
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.MaxKey#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.MaxKey#requires($ly, node#0)
       == (KMBtreeModel.__default.WF($LS($LZ), node#0)
         && 0
           < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))));

// definition axiom for KMBtreeModel.__default.MaxKey(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.MaxKey($LS($ly), node#0) } 
    KMBtreeModel.__default.MaxKey#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.__default.WF($LS($LZ), node#0)
           && 0
             < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0)))
       ==> (KMBtreeModel.Node.Leaf_q(node#0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(node#0)))
         && (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(node#0))
             && KMBtreeModel.__default.MaxKey#canCall($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(node#0))): DatatypeType))
         && KMBtreeModel.__default.MaxKey($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(node#0))): Seq Box
             else KMBtreeModel.__default.MaxKey($ly, 
              $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(node#0))): DatatypeType)));

// definition axiom for KMBtreeModel.__default.MaxKey for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.MaxKey($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.MaxKey#canCall(Lit(node#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(node#0)))
           && 0
             < Map#Card(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, Lit(node#0))))
       ==> (Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(node#0)))))
         && (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(node#0))))
             && KMBtreeModel.__default.MaxKey#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(node#0))))): DatatypeType)))
         && KMBtreeModel.__default.MaxKey($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(node#0))))): Seq Box
             else KMBtreeModel.__default.MaxKey($LS($ly), 
              Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(node#0))))): DatatypeType))));

procedure {:_induction node#0} CheckWellformed$$KMBtreeModel.__default.MaxKeyProperties(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  free requires 21 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtreeModel.__default.MaxKeyProperties(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#36: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#36)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#36 && i#36 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#36)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#37: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#37)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#37 && i#37 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#37)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#38: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#38) } 
          true
             ==> 
            LitInt(0) <= i#38 && i#38 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#38)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#39: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#39) } 
          true
             ==> 
            0 < i#39 && i#39 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#39)));
  requires 0
     < Map#Card(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.MaxKey#canCall(node#0)
     && KMBtreeModel.__default.Interpretation#canCall(node#0);
  ensures Map#Domain(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0))[$Box(KMBtreeModel.__default.MaxKey($LS($LS($LZ)), node#0))];
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(key#1, KMBtreeModel.__default.MaxKey($LS($LZ), node#0)) } 
      { Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
       ==> KMBtreeModel.__default.Interpretation#canCall(node#0)
         && (Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)]
           ==> KMBtreeModel.__default.MaxKey#canCall(node#0)
             && Lexicographic__Byte__Order.__default.lte#canCall(key#1, KMBtreeModel.__default.MaxKey($LS($LZ), node#0))));
  free ensures (forall key#1: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(key#1, KMBtreeModel.__default.MaxKey($LS($LZ), node#0)) } 
      { Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)] } 
    $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
         && Map#Domain(KMBtreeModel.__default.Interpretation(StartFuel_KMBtreeModel._default.Interpretation, node#0))[$Box(key#1)]
       ==> Lexicographic__Byte__Order.__default.lte(key#1, KMBtreeModel.__default.MaxKey($LS($LZ), node#0)));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for KMBtreeModel._default.SplitLeaf
function KMBtreeModel.__default.SplitLeaf(oldleaf#0: DatatypeType, 
    leftleaf#0: DatatypeType, 
    rightleaf#0: DatatypeType, 
    pivot#0: Seq Box)
   : bool;

function KMBtreeModel.__default.SplitLeaf#canCall(oldleaf#0: DatatypeType, 
    leftleaf#0: DatatypeType, 
    rightleaf#0: DatatypeType, 
    pivot#0: Seq Box)
   : bool;

// consequence axiom for KMBtreeModel.__default.SplitLeaf
axiom true
   ==> (forall oldleaf#0: DatatypeType, 
      leftleaf#0: DatatypeType, 
      rightleaf#0: DatatypeType, 
      pivot#0: Seq Box :: 
    { KMBtreeModel.__default.SplitLeaf(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0) } 
    KMBtreeModel.__default.SplitLeaf#canCall(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0)
         || (
          $Is(oldleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(leftleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(rightleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function KMBtreeModel.__default.SplitLeaf#requires(DatatypeType, DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for KMBtreeModel.__default.SplitLeaf
axiom (forall oldleaf#0: DatatypeType, 
    leftleaf#0: DatatypeType, 
    rightleaf#0: DatatypeType, 
    pivot#0: Seq Box :: 
  { KMBtreeModel.__default.SplitLeaf#requires(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0) } 
  $Is(oldleaf#0, Tclass.KMBtreeModel.Node())
       && $Is(leftleaf#0, Tclass.KMBtreeModel.Node())
       && $Is(rightleaf#0, Tclass.KMBtreeModel.Node())
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
     ==> KMBtreeModel.__default.SplitLeaf#requires(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0)
       == true);

// definition axiom for KMBtreeModel.__default.SplitLeaf(revealed)
axiom true
   ==> (forall oldleaf#0: DatatypeType, 
      leftleaf#0: DatatypeType, 
      rightleaf#0: DatatypeType, 
      pivot#0: Seq Box :: 
    { KMBtreeModel.__default.SplitLeaf(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0) } 
    KMBtreeModel.__default.SplitLeaf#canCall(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0)
         || (
          $Is(oldleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(leftleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(rightleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Equal(KMBtreeModel.Node.values(oldleaf#0), 
            Seq#Append(KMBtreeModel.Node.values(leftleaf#0), KMBtreeModel.Node.values(rightleaf#0)))
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(leftleaf#0))
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(leftleaf#0))): Seq Box, 
              pivot#0))
         && (Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(leftleaf#0))
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(leftleaf#0))): Seq Box, 
              pivot#0)
             && Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(leftleaf#0))): Seq Box, 
              pivot#0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, 
            $Unbox(Seq#Index(KMBtreeModel.Node.keys(rightleaf#0), LitInt(0))): Seq Box))
         && KMBtreeModel.__default.SplitLeaf(oldleaf#0, leftleaf#0, rightleaf#0, pivot#0)
           == (
            KMBtreeModel.Node.Leaf_q(oldleaf#0)
             && KMBtreeModel.Node.Leaf_q(leftleaf#0)
             && KMBtreeModel.Node.Leaf_q(rightleaf#0)
             && 
            0 < Seq#Length(KMBtreeModel.Node.keys(leftleaf#0))
             && Seq#Length(KMBtreeModel.Node.keys(leftleaf#0))
               == Seq#Length(KMBtreeModel.Node.values(leftleaf#0))
             && 
            0 < Seq#Length(KMBtreeModel.Node.keys(rightleaf#0))
             && Seq#Length(KMBtreeModel.Node.keys(rightleaf#0))
               == Seq#Length(KMBtreeModel.Node.values(rightleaf#0))
             && Seq#Equal(KMBtreeModel.Node.keys(oldleaf#0), 
              Seq#Append(KMBtreeModel.Node.keys(leftleaf#0), KMBtreeModel.Node.keys(rightleaf#0)))
             && Seq#Equal(KMBtreeModel.Node.values(oldleaf#0), 
              Seq#Append(KMBtreeModel.Node.values(leftleaf#0), KMBtreeModel.Node.values(rightleaf#0)))
             && Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.keys(leftleaf#0))): Seq Box, 
              pivot#0)
             && Lexicographic__Byte__Order.__default.lte(pivot#0, 
              $Unbox(Seq#Index(KMBtreeModel.Node.keys(rightleaf#0), LitInt(0))): Seq Box)));

// definition axiom for KMBtreeModel.__default.SplitLeaf for all literals(revealed)
axiom true
   ==> (forall oldleaf#0: DatatypeType, 
      leftleaf#0: DatatypeType, 
      rightleaf#0: DatatypeType, 
      pivot#0: Seq Box :: 
    {:weight 3} { KMBtreeModel.__default.SplitLeaf(Lit(oldleaf#0), Lit(leftleaf#0), Lit(rightleaf#0), Lit(pivot#0)) } 
    KMBtreeModel.__default.SplitLeaf#canCall(Lit(oldleaf#0), Lit(leftleaf#0), Lit(rightleaf#0), Lit(pivot#0))
         || (
          $Is(oldleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(leftleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(rightleaf#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Equal(KMBtreeModel.Node.values(Lit(oldleaf#0)), 
            Seq#Append(KMBtreeModel.Node.values(Lit(leftleaf#0)), 
              KMBtreeModel.Node.values(Lit(rightleaf#0))))
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))): Seq Box), 
              Lit(pivot#0)))
         && (Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))): Seq Box), 
              Lit(pivot#0))
             && Lit(Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))): Seq Box), 
                Lit(pivot#0)))
           ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), 
            $Unbox(Seq#Index(Lit(KMBtreeModel.Node.keys(Lit(rightleaf#0))), LitInt(0))): Seq Box))
         && KMBtreeModel.__default.SplitLeaf(Lit(oldleaf#0), Lit(leftleaf#0), Lit(rightleaf#0), Lit(pivot#0))
           == (
            KMBtreeModel.Node.Leaf_q(Lit(oldleaf#0))
             && KMBtreeModel.Node.Leaf_q(Lit(leftleaf#0))
             && KMBtreeModel.Node.Leaf_q(Lit(rightleaf#0))
             && 
            0 < Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.values(Lit(leftleaf#0))))
             && 
            0 < Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(rightleaf#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(rightleaf#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.values(Lit(rightleaf#0))))
             && Seq#Equal(KMBtreeModel.Node.keys(Lit(oldleaf#0)), 
              Seq#Append(KMBtreeModel.Node.keys(Lit(leftleaf#0)), 
                KMBtreeModel.Node.keys(Lit(rightleaf#0))))
             && Seq#Equal(KMBtreeModel.Node.values(Lit(oldleaf#0)), 
              Seq#Append(KMBtreeModel.Node.values(Lit(leftleaf#0)), 
                KMBtreeModel.Node.values(Lit(rightleaf#0))))
             && Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.keys(Lit(leftleaf#0))))): Seq Box), 
              Lit(pivot#0))
             && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.keys(Lit(rightleaf#0))), LitInt(0))): Seq Box)));

// function declaration for KMBtreeModel._default.SubIndex
function KMBtreeModel.__default.SubIndex(node#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function KMBtreeModel.__default.SubIndex#canCall(node#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for KMBtreeModel.__default.SubIndex
axiom true
   ==> (forall node#0: DatatypeType, from#0: int, to#0: int :: 
    { KMBtreeModel.__default.SubIndex(node#0, from#0, to#0) } 
    KMBtreeModel.__default.SubIndex#canCall(node#0, from#0, to#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.Node.Index_q(node#0)
           && Seq#Length(KMBtreeModel.Node.children(node#0))
             == Seq#Length(KMBtreeModel.Node.pivots(node#0)) + 1
           && 
          LitInt(0) <= from#0
           && from#0 < to#0
           && to#0 <= Seq#Length(KMBtreeModel.Node.children(node#0)))
       ==> $Is(KMBtreeModel.__default.SubIndex(node#0, from#0, to#0), 
        Tclass.KMBtreeModel.Node()));

function KMBtreeModel.__default.SubIndex#requires(DatatypeType, int, int) : bool;

// #requires axiom for KMBtreeModel.__default.SubIndex
axiom (forall node#0: DatatypeType, from#0: int, to#0: int :: 
  { KMBtreeModel.__default.SubIndex#requires(node#0, from#0, to#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.SubIndex#requires(node#0, from#0, to#0)
       == (
        KMBtreeModel.Node.Index_q(node#0)
         && Seq#Length(KMBtreeModel.Node.children(node#0))
           == Seq#Length(KMBtreeModel.Node.pivots(node#0)) + 1
         && 
        LitInt(0) <= from#0
         && from#0 < to#0
         && to#0 <= Seq#Length(KMBtreeModel.Node.children(node#0))));

// definition axiom for KMBtreeModel.__default.SubIndex(revealed)
axiom true
   ==> (forall node#0: DatatypeType, from#0: int, to#0: int :: 
    { KMBtreeModel.__default.SubIndex(node#0, from#0, to#0) } 
    KMBtreeModel.__default.SubIndex#canCall(node#0, from#0, to#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          KMBtreeModel.Node.Index_q(node#0)
           && Seq#Length(KMBtreeModel.Node.children(node#0))
             == Seq#Length(KMBtreeModel.Node.pivots(node#0)) + 1
           && 
          LitInt(0) <= from#0
           && from#0 < to#0
           && to#0 <= Seq#Length(KMBtreeModel.Node.children(node#0)))
       ==> KMBtreeModel.__default.SubIndex(node#0, from#0, to#0)
         == #KMBtreeModel.Node.Index(Seq#Drop(Seq#Take(KMBtreeModel.Node.pivots(node#0), to#0 - 1), from#0), 
          Seq#Drop(Seq#Take(KMBtreeModel.Node.children(node#0), to#0), from#0)));

// definition axiom for KMBtreeModel.__default.SubIndex for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { KMBtreeModel.__default.SubIndex(Lit(node#0), LitInt(from#0), LitInt(to#0)) } 
    KMBtreeModel.__default.SubIndex#canCall(Lit(node#0), LitInt(from#0), LitInt(to#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && 
          Lit(KMBtreeModel.Node.Index_q(Lit(node#0)))
           && Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0))))
             == Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0)))) + 1
           && 
          LitInt(0) <= LitInt(from#0)
           && from#0 < to#0
           && LitInt(to#0) <= Seq#Length(Lit(KMBtreeModel.Node.children(Lit(node#0)))))
       ==> KMBtreeModel.__default.SubIndex(Lit(node#0), LitInt(from#0), LitInt(to#0))
         == Lit(#KMBtreeModel.Node.Index(Lit(Seq#Drop(Seq#Take(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), LitInt(to#0 - 1)), 
                LitInt(from#0))), 
            Lit(Seq#Drop(Seq#Take(Lit(KMBtreeModel.Node.children(Lit(node#0))), LitInt(to#0)), 
                LitInt(from#0))))));

// function declaration for KMBtreeModel._default.SplitIndex
function KMBtreeModel.__default.SplitIndex(oldindex#0: DatatypeType, 
    leftindex#0: DatatypeType, 
    rightindex#0: DatatypeType, 
    pivot#0: Seq Box)
   : bool;

function KMBtreeModel.__default.SplitIndex#canCall(oldindex#0: DatatypeType, 
    leftindex#0: DatatypeType, 
    rightindex#0: DatatypeType, 
    pivot#0: Seq Box)
   : bool;

// consequence axiom for KMBtreeModel.__default.SplitIndex
axiom true
   ==> (forall oldindex#0: DatatypeType, 
      leftindex#0: DatatypeType, 
      rightindex#0: DatatypeType, 
      pivot#0: Seq Box :: 
    { KMBtreeModel.__default.SplitIndex(oldindex#0, leftindex#0, rightindex#0, pivot#0) } 
    KMBtreeModel.__default.SplitIndex#canCall(oldindex#0, leftindex#0, rightindex#0, pivot#0)
         || (
          $Is(oldindex#0, Tclass.KMBtreeModel.Node())
           && $Is(leftindex#0, Tclass.KMBtreeModel.Node())
           && $Is(rightindex#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function KMBtreeModel.__default.SplitIndex#requires(DatatypeType, DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for KMBtreeModel.__default.SplitIndex
axiom (forall oldindex#0: DatatypeType, 
    leftindex#0: DatatypeType, 
    rightindex#0: DatatypeType, 
    pivot#0: Seq Box :: 
  { KMBtreeModel.__default.SplitIndex#requires(oldindex#0, leftindex#0, rightindex#0, pivot#0) } 
  $Is(oldindex#0, Tclass.KMBtreeModel.Node())
       && $Is(leftindex#0, Tclass.KMBtreeModel.Node())
       && $Is(rightindex#0, Tclass.KMBtreeModel.Node())
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
     ==> KMBtreeModel.__default.SplitIndex#requires(oldindex#0, leftindex#0, rightindex#0, pivot#0)
       == true);

// definition axiom for KMBtreeModel.__default.SplitIndex(revealed)
axiom true
   ==> (forall oldindex#0: DatatypeType, 
      leftindex#0: DatatypeType, 
      rightindex#0: DatatypeType, 
      pivot#0: Seq Box :: 
    { KMBtreeModel.__default.SplitIndex(oldindex#0, leftindex#0, rightindex#0, pivot#0) } 
    KMBtreeModel.__default.SplitIndex#canCall(oldindex#0, leftindex#0, rightindex#0, pivot#0)
         || (
          $Is(oldindex#0, Tclass.KMBtreeModel.Node())
           && $Is(leftindex#0, Tclass.KMBtreeModel.Node())
           && $Is(rightindex#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             == Seq#Length(KMBtreeModel.Node.pivots(oldindex#0)) + 1
           ==> $IsA#KMBtreeModel.Node(leftindex#0)
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(oldindex#0, LitInt(0), Seq#Length(KMBtreeModel.Node.children(leftindex#0))))
             && KMBtreeModel.__default.SubIndex#canCall(oldindex#0, LitInt(0), Seq#Length(KMBtreeModel.Node.children(leftindex#0))))
         && ($IsA#KMBtreeModel.Node(leftindex#0)
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(oldindex#0, LitInt(0), Seq#Length(KMBtreeModel.Node.children(leftindex#0))))
             && KMBtreeModel.__default.SubIndex#canCall(oldindex#0, LitInt(0), Seq#Length(KMBtreeModel.Node.children(leftindex#0)))
             && KMBtreeModel.Node#Equal(leftindex#0, 
              KMBtreeModel.__default.SubIndex(oldindex#0, LitInt(0), Seq#Length(KMBtreeModel.Node.children(leftindex#0))))
           ==> $IsA#KMBtreeModel.Node(rightindex#0)
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(oldindex#0, 
                Seq#Length(KMBtreeModel.Node.children(leftindex#0)), 
                Seq#Length(KMBtreeModel.Node.children(oldindex#0))))
             && KMBtreeModel.__default.SubIndex#canCall(oldindex#0, 
              Seq#Length(KMBtreeModel.Node.children(leftindex#0)), 
              Seq#Length(KMBtreeModel.Node.children(oldindex#0))))
         && ($IsA#KMBtreeModel.Node(rightindex#0)
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(oldindex#0, 
                Seq#Length(KMBtreeModel.Node.children(leftindex#0)), 
                Seq#Length(KMBtreeModel.Node.children(oldindex#0))))
             && KMBtreeModel.__default.SubIndex#canCall(oldindex#0, 
              Seq#Length(KMBtreeModel.Node.children(leftindex#0)), 
              Seq#Length(KMBtreeModel.Node.children(oldindex#0)))
             && KMBtreeModel.Node#Equal(rightindex#0, 
              KMBtreeModel.__default.SubIndex(oldindex#0, 
                Seq#Length(KMBtreeModel.Node.children(leftindex#0)), 
                Seq#Length(KMBtreeModel.Node.children(oldindex#0))))
           ==> (forall key#8: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#8, pivot#0) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)] } 
            $Is(key#8, TSeq(Tclass.NativeTypes.byte()))
               ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))
                 && KMBtreeModel.__default.AllKeys#canCall($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                    $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)]
                   ==> Lexicographic__Byte__Order.__default.lt#canCall(key#8, pivot#0))))
         && ((forall key#8: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#8, pivot#0) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)] } 
              $Is(key#8, TSeq(Tclass.NativeTypes.byte()))
                 ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))
                   && KMBtreeModel.__default.AllKeys#canCall($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)
                   && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                      $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)]
                     ==> Lexicographic__Byte__Order.__default.lt#canCall(key#8, pivot#0)))
             && (forall key#8: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#8, pivot#0) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)] } 
              $Is(key#8, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)]
                 ==> Lexicographic__Byte__Order.__default.lt(key#8, pivot#0))
           ==> (forall key#9: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(pivot#0, key#9) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), 0)): DatatypeType)[$Box(key#9)] } 
            $Is(key#9, TSeq(Tclass.NativeTypes.byte()))
               ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), LitInt(0))): DatatypeType)
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), LitInt(0))): DatatypeType)[$Box(key#9)]
                   ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, key#9))))
         && KMBtreeModel.__default.SplitIndex(oldindex#0, leftindex#0, rightindex#0, pivot#0)
           == (
            KMBtreeModel.Node.Index_q(oldindex#0)
             && KMBtreeModel.Node.Index_q(leftindex#0)
             && KMBtreeModel.Node.Index_q(rightindex#0)
             && 
            0 < Seq#Length(KMBtreeModel.Node.children(leftindex#0))
             && Seq#Length(KMBtreeModel.Node.children(leftindex#0))
               < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             && Seq#Length(KMBtreeModel.Node.children(oldindex#0))
               == Seq#Length(KMBtreeModel.Node.pivots(oldindex#0)) + 1
             && KMBtreeModel.Node#Equal(leftindex#0, 
              KMBtreeModel.__default.SubIndex(oldindex#0, LitInt(0), Seq#Length(KMBtreeModel.Node.children(leftindex#0))))
             && KMBtreeModel.Node#Equal(rightindex#0, 
              KMBtreeModel.__default.SubIndex(oldindex#0, 
                Seq#Length(KMBtreeModel.Node.children(leftindex#0)), 
                Seq#Length(KMBtreeModel.Node.children(oldindex#0))))
             && (forall key#8: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#8, pivot#0) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)] } 
              $Is(key#8, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#8)]
                 ==> Lexicographic__Byte__Order.__default.lt(key#8, pivot#0))
             && (forall key#9: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, key#9) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), 0)): DatatypeType)[$Box(key#9)] } 
              $Is(key#9, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), LitInt(0))): DatatypeType)[$Box(key#9)]
                 ==> Lexicographic__Byte__Order.__default.lte(pivot#0, key#9))
             && Seq#Equal(pivot#0, 
              $Unbox(Seq#Index(KMBtreeModel.Node.pivots(oldindex#0), 
                  Seq#Length(KMBtreeModel.Node.pivots(leftindex#0)))): Seq Box)));

// definition axiom for KMBtreeModel.__default.SplitIndex for all literals(revealed)
axiom true
   ==> (forall oldindex#0: DatatypeType, 
      leftindex#0: DatatypeType, 
      rightindex#0: DatatypeType, 
      pivot#0: Seq Box :: 
    {:weight 3} { KMBtreeModel.__default.SplitIndex(Lit(oldindex#0), Lit(leftindex#0), Lit(rightindex#0), Lit(pivot#0)) } 
    KMBtreeModel.__default.SplitIndex#canCall(Lit(oldindex#0), Lit(leftindex#0), Lit(rightindex#0), Lit(pivot#0))
         || (
          $Is(oldindex#0, Tclass.KMBtreeModel.Node())
           && $Is(leftindex#0, Tclass.KMBtreeModel.Node())
           && $Is(rightindex#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))
             == Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0)))) + 1
           ==> $IsA#KMBtreeModel.Node(Lit(leftindex#0))
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                LitInt(0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))))
             && KMBtreeModel.__default.SubIndex#canCall(Lit(oldindex#0), 
              LitInt(0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))))
         && ($IsA#KMBtreeModel.Node(Lit(leftindex#0))
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                LitInt(0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))))
             && KMBtreeModel.__default.SubIndex#canCall(Lit(oldindex#0), 
              LitInt(0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))))
             && KMBtreeModel.Node#Equal(leftindex#0, 
              KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                LitInt(0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))))
           ==> $IsA#KMBtreeModel.Node(Lit(rightindex#0))
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))))
             && KMBtreeModel.__default.SubIndex#canCall(Lit(oldindex#0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))))
         && ($IsA#KMBtreeModel.Node(Lit(rightindex#0))
             && $IsA#KMBtreeModel.Node(KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))))
             && KMBtreeModel.__default.SubIndex#canCall(Lit(oldindex#0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0)))))
             && KMBtreeModel.Node#Equal(rightindex#0, 
              KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))))
           ==> (forall key#10: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#10, pivot#0) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#10)] } 
            $Is(key#10, TSeq(Tclass.NativeTypes.byte()))
               ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))
                 && KMBtreeModel.__default.AllKeys#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))): DatatypeType))
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                    Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))): DatatypeType))[$Box(key#10)]
                   ==> Lexicographic__Byte__Order.__default.lt#canCall(key#10, Lit(pivot#0)))))
         && ((forall key#10: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#10, pivot#0) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#10)] } 
              $Is(key#10, TSeq(Tclass.NativeTypes.byte()))
                 ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))
                   && KMBtreeModel.__default.AllKeys#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))): DatatypeType))
                   && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))): DatatypeType))[$Box(key#10)]
                     ==> Lexicographic__Byte__Order.__default.lt#canCall(key#10, Lit(pivot#0))))
             && (forall key#10: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#10, pivot#0) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#10)] } 
              $Is(key#10, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))): DatatypeType))[$Box(key#10)]
                 ==> Lexicographic__Byte__Order.__default.lt(key#10, Lit(pivot#0)))
           ==> (forall key#11: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(pivot#0, key#11) } 
              { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), 0)): DatatypeType)[$Box(key#11)] } 
            $Is(key#11, TSeq(Tclass.NativeTypes.byte()))
               ==> KMBtreeModel.__default.AllKeys#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(rightindex#0))), LitInt(0))): DatatypeType)
                 && (KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                    $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(rightindex#0))), LitInt(0))): DatatypeType)[$Box(key#11)]
                   ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), key#11))))
         && KMBtreeModel.__default.SplitIndex(Lit(oldindex#0), Lit(leftindex#0), Lit(rightindex#0), Lit(pivot#0))
           == (
            KMBtreeModel.Node.Index_q(Lit(oldindex#0))
             && KMBtreeModel.Node.Index_q(Lit(leftindex#0))
             && KMBtreeModel.Node.Index_q(Lit(rightindex#0))
             && 
            0 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))
               < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0)))) + 1
             && KMBtreeModel.Node#Equal(leftindex#0, 
              KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                LitInt(0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))))
             && KMBtreeModel.Node#Equal(rightindex#0, 
              KMBtreeModel.__default.SubIndex(Lit(oldindex#0), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(leftindex#0)))), 
                Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))))
             && (forall key#10: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#10, pivot#0) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(leftindex#0))): DatatypeType)[$Box(key#10)] } 
              $Is(key#10, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(leftindex#0))))): DatatypeType))[$Box(key#10)]
                 ==> Lexicographic__Byte__Order.__default.lt(key#10, Lit(pivot#0)))
             && (forall key#11: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, key#11) } 
                { KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(KMBtreeModel.Node.children(rightindex#0), 0)): DatatypeType)[$Box(key#11)] } 
              $Is(key#11, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                  $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(rightindex#0))), LitInt(0))): DatatypeType)[$Box(key#11)]
                 ==> Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), key#11))
             && Seq#Equal(pivot#0, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))), 
                  Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(leftindex#0)))))): Seq Box)));

// function declaration for KMBtreeModel._default.SplitNode
function KMBtreeModel.__default.SplitNode(oldnode#0: DatatypeType, 
    leftnode#0: DatatypeType, 
    rightnode#0: DatatypeType, 
    pivot#0: Seq Box)
   : bool;

function KMBtreeModel.__default.SplitNode#canCall(oldnode#0: DatatypeType, 
    leftnode#0: DatatypeType, 
    rightnode#0: DatatypeType, 
    pivot#0: Seq Box)
   : bool;

// consequence axiom for KMBtreeModel.__default.SplitNode
axiom true
   ==> (forall oldnode#0: DatatypeType, 
      leftnode#0: DatatypeType, 
      rightnode#0: DatatypeType, 
      pivot#0: Seq Box :: 
    { KMBtreeModel.__default.SplitNode(oldnode#0, leftnode#0, rightnode#0, pivot#0) } 
    KMBtreeModel.__default.SplitNode#canCall(oldnode#0, leftnode#0, rightnode#0, pivot#0)
         || (
          $Is(oldnode#0, Tclass.KMBtreeModel.Node())
           && $Is(leftnode#0, Tclass.KMBtreeModel.Node())
           && $Is(rightnode#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function KMBtreeModel.__default.SplitNode#requires(DatatypeType, DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for KMBtreeModel.__default.SplitNode
axiom (forall oldnode#0: DatatypeType, 
    leftnode#0: DatatypeType, 
    rightnode#0: DatatypeType, 
    pivot#0: Seq Box :: 
  { KMBtreeModel.__default.SplitNode#requires(oldnode#0, leftnode#0, rightnode#0, pivot#0) } 
  $Is(oldnode#0, Tclass.KMBtreeModel.Node())
       && $Is(leftnode#0, Tclass.KMBtreeModel.Node())
       && $Is(rightnode#0, Tclass.KMBtreeModel.Node())
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
     ==> KMBtreeModel.__default.SplitNode#requires(oldnode#0, leftnode#0, rightnode#0, pivot#0)
       == true);

// definition axiom for KMBtreeModel.__default.SplitNode(revealed)
axiom true
   ==> (forall oldnode#0: DatatypeType, 
      leftnode#0: DatatypeType, 
      rightnode#0: DatatypeType, 
      pivot#0: Seq Box :: 
    { KMBtreeModel.__default.SplitNode(oldnode#0, leftnode#0, rightnode#0, pivot#0) } 
    KMBtreeModel.__default.SplitNode#canCall(oldnode#0, leftnode#0, rightnode#0, pivot#0)
         || (
          $Is(oldnode#0, Tclass.KMBtreeModel.Node())
           && $Is(leftnode#0, Tclass.KMBtreeModel.Node())
           && $Is(rightnode#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> KMBtreeModel.__default.SplitLeaf#canCall(oldnode#0, leftnode#0, rightnode#0, pivot#0)
         && (!KMBtreeModel.__default.SplitLeaf(oldnode#0, leftnode#0, rightnode#0, pivot#0)
           ==> KMBtreeModel.__default.SplitIndex#canCall(oldnode#0, leftnode#0, rightnode#0, pivot#0))
         && KMBtreeModel.__default.SplitNode(oldnode#0, leftnode#0, rightnode#0, pivot#0)
           == (KMBtreeModel.__default.SplitLeaf(oldnode#0, leftnode#0, rightnode#0, pivot#0)
             || KMBtreeModel.__default.SplitIndex(oldnode#0, leftnode#0, rightnode#0, pivot#0)));

// definition axiom for KMBtreeModel.__default.SplitNode for all literals(revealed)
axiom true
   ==> (forall oldnode#0: DatatypeType, 
      leftnode#0: DatatypeType, 
      rightnode#0: DatatypeType, 
      pivot#0: Seq Box :: 
    {:weight 3} { KMBtreeModel.__default.SplitNode(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0)) } 
    KMBtreeModel.__default.SplitNode#canCall(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0))
         || (
          $Is(oldnode#0, Tclass.KMBtreeModel.Node())
           && $Is(leftnode#0, Tclass.KMBtreeModel.Node())
           && $Is(rightnode#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte())))
       ==> KMBtreeModel.__default.SplitLeaf#canCall(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0))
         && (!Lit(KMBtreeModel.__default.SplitLeaf(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0)))
           ==> KMBtreeModel.__default.SplitIndex#canCall(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0)))
         && KMBtreeModel.__default.SplitNode(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0))
           == Lit(KMBtreeModel.__default.SplitLeaf(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0))
               || KMBtreeModel.__default.SplitIndex(Lit(oldnode#0), Lit(leftnode#0), Lit(rightnode#0), Lit(pivot#0))));

// function declaration for KMBtreeModel._default.SplitChildOfIndex
function KMBtreeModel.__default.SplitChildOfIndex(oldindex#0: DatatypeType, newindex#0: DatatypeType, childidx#0: int) : bool;

function KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0: DatatypeType, newindex#0: DatatypeType, childidx#0: int) : bool;

// consequence axiom for KMBtreeModel.__default.SplitChildOfIndex
axiom true
   ==> (forall oldindex#0: DatatypeType, newindex#0: DatatypeType, childidx#0: int :: 
    { KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0) } 
    KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
         || ($Is(oldindex#0, Tclass.KMBtreeModel.Node())
           && $Is(newindex#0, Tclass.KMBtreeModel.Node()))
       ==> true);

function KMBtreeModel.__default.SplitChildOfIndex#requires(DatatypeType, DatatypeType, int) : bool;

// #requires axiom for KMBtreeModel.__default.SplitChildOfIndex
axiom (forall oldindex#0: DatatypeType, newindex#0: DatatypeType, childidx#0: int :: 
  { KMBtreeModel.__default.SplitChildOfIndex#requires(oldindex#0, newindex#0, childidx#0) } 
  $Is(oldindex#0, Tclass.KMBtreeModel.Node())
       && $Is(newindex#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.SplitChildOfIndex#requires(oldindex#0, newindex#0, childidx#0)
       == true);

// definition axiom for KMBtreeModel.__default.SplitChildOfIndex(revealed)
axiom true
   ==> (forall oldindex#0: DatatypeType, newindex#0: DatatypeType, childidx#0: int :: 
    { KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0) } 
    KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
         || ($Is(oldindex#0, Tclass.KMBtreeModel.Node())
           && $Is(newindex#0, Tclass.KMBtreeModel.Node()))
       ==> (Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
             == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1
           ==> KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box))
         && (KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
             && KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           ==> Sequences.__default.insert#canCall(TSeq(Tclass.NativeTypes.byte()), 
            KMBtreeModel.Node.pivots(oldindex#0), 
            Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
            childidx#0))
         && (Sequences.__default.insert#canCall(TSeq(Tclass.NativeTypes.byte()), 
              KMBtreeModel.Node.pivots(oldindex#0), 
              Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
              childidx#0)
             && Seq#Equal(KMBtreeModel.Node.pivots(newindex#0), 
              Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
                StartFuel_Sequences._default.insert, 
                KMBtreeModel.Node.pivots(oldindex#0), 
                Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
                childidx#0))
           ==> Sequences.__default.replace1with2#canCall(Tclass.KMBtreeModel.Node(), 
            KMBtreeModel.Node.children(oldindex#0), 
            Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0), 
            Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1), 
            childidx#0))
         && KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
           == (
            KMBtreeModel.Node.Index_q(oldindex#0)
             && KMBtreeModel.Node.Index_q(newindex#0)
             && 
            LitInt(0) <= childidx#0
             && childidx#0 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             && Seq#Length(KMBtreeModel.Node.children(newindex#0))
               == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) + 1
             && Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
               == Seq#Length(KMBtreeModel.Node.pivots(oldindex#0)) + 1
             && Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
               == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1
             && KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
              $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
             && Seq#Equal(KMBtreeModel.Node.pivots(newindex#0), 
              Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
                StartFuel_Sequences._default.insert, 
                KMBtreeModel.Node.pivots(oldindex#0), 
                Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
                childidx#0))
             && Seq#Equal(KMBtreeModel.Node.children(newindex#0), 
              Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
                StartFuel_Sequences._default.replace1with2, 
                KMBtreeModel.Node.children(oldindex#0), 
                Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0), 
                Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1), 
                childidx#0))));

// definition axiom for KMBtreeModel.__default.SplitChildOfIndex for all literals(revealed)
axiom true
   ==> (forall oldindex#0: DatatypeType, newindex#0: DatatypeType, childidx#0: int :: 
    {:weight 3} { KMBtreeModel.__default.SplitChildOfIndex(Lit(oldindex#0), Lit(newindex#0), LitInt(childidx#0)) } 
    KMBtreeModel.__default.SplitChildOfIndex#canCall(Lit(oldindex#0), Lit(newindex#0), LitInt(childidx#0))
         || ($Is(oldindex#0, Tclass.KMBtreeModel.Node())
           && $Is(newindex#0, Tclass.KMBtreeModel.Node()))
       ==> (Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))))
             == Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0)))) - 1
           ==> KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))), LitInt(childidx#0))): DatatypeType, 
            $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0))): DatatypeType, 
            $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0 + 1))): DatatypeType, 
            $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0))): Seq Box))
         && (KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))), LitInt(childidx#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0 + 1))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0))): Seq Box)
             && KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))), LitInt(childidx#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0 + 1))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0))): Seq Box)
           ==> Sequences.__default.insert#canCall(TSeq(Tclass.NativeTypes.byte()), 
            Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))), 
            Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0)), 
            LitInt(childidx#0)))
         && (Sequences.__default.insert#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))), 
              Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0)), 
              LitInt(childidx#0))
             && Seq#Equal(KMBtreeModel.Node.pivots(Lit(newindex#0)), 
              Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
                StartFuel_Sequences._default.insert, 
                Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))), 
                Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0)), 
                LitInt(childidx#0)))
           ==> Sequences.__default.replace1with2#canCall(Tclass.KMBtreeModel.Node(), 
            Lit(KMBtreeModel.Node.children(Lit(oldindex#0))), 
            Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0)), 
            Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0 + 1)), 
            LitInt(childidx#0)))
         && KMBtreeModel.__default.SplitChildOfIndex(Lit(oldindex#0), Lit(newindex#0), LitInt(childidx#0))
           == (
            KMBtreeModel.Node.Index_q(Lit(oldindex#0))
             && KMBtreeModel.Node.Index_q(Lit(newindex#0))
             && 
            LitInt(0) <= LitInt(childidx#0)
             && childidx#0 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newindex#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0)))) + 1
             && Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0)))) + 1
             && Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.children(Lit(oldindex#0)))) - 1
             && KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(oldindex#0))), LitInt(childidx#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0 + 1))): DatatypeType, 
              $Unbox(Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0))): Seq Box)
             && Seq#Equal(KMBtreeModel.Node.pivots(Lit(newindex#0)), 
              Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
                StartFuel_Sequences._default.insert, 
                Lit(KMBtreeModel.Node.pivots(Lit(oldindex#0))), 
                Seq#Index(Lit(KMBtreeModel.Node.pivots(Lit(newindex#0))), LitInt(childidx#0)), 
                LitInt(childidx#0)))
             && Seq#Equal(KMBtreeModel.Node.children(Lit(newindex#0)), 
              Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
                StartFuel_Sequences._default.replace1with2, 
                Lit(KMBtreeModel.Node.children(Lit(oldindex#0))), 
                Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0)), 
                Seq#Index(Lit(KMBtreeModel.Node.children(Lit(newindex#0))), LitInt(childidx#0 + 1)), 
                LitInt(childidx#0)))));

procedure {:_induction oldindex#0, newindex#0} CheckWellformed$$KMBtreeModel.__default.SplitChildOfIndexPreservesWF(oldindex#0: DatatypeType
       where $Is(oldindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(oldindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(oldindex#0), 
    newindex#0: DatatypeType
       where $Is(newindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newindex#0), 
    childidx#0: int);
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction oldindex#0, newindex#0} Call$$KMBtreeModel.__default.SplitChildOfIndexPreservesWF(oldindex#0: DatatypeType
       where $Is(oldindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(oldindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(oldindex#0), 
    newindex#0: DatatypeType
       where $Is(newindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newindex#0), 
    childidx#0: int);
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(oldindex#0))
           == Seq#Length(KMBtreeModel.Node.values(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
           == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#26: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#26)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#26 && i#26 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#26)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#27: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#27)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#27 && i#27 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#27)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#28: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(oldindex#0, i#28) } 
          true
             ==> 
            LitInt(0) <= i#28
               && i#28 < Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(oldindex#0, i#28)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#29: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(oldindex#0, i#29) } 
          true
             ==> 
            0 < i#29 && i#29 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(oldindex#0, i#29)));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || KMBtreeModel.Node.Index_q(oldindex#0);
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || KMBtreeModel.Node.Index_q(newindex#0);
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || LitInt(0) <= childidx#0;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || childidx#0 < Seq#Length(KMBtreeModel.Node.children(oldindex#0));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.children(newindex#0))
         == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) + 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
         == Seq#Length(KMBtreeModel.Node.pivots(oldindex#0)) + 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
         == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || (KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
         ==> KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           || 
          KMBtreeModel.__default.SplitLeaf($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           || KMBtreeModel.__default.SplitIndex($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Equal(KMBtreeModel.Node.pivots(newindex#0), 
        Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
          StartFuelAssert_Sequences._default.insert, 
          KMBtreeModel.Node.pivots(oldindex#0), 
          Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
          childidx#0));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Equal(KMBtreeModel.Node.children(newindex#0), 
        Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
          StartFuelAssert_Sequences._default.replace1with2, 
          KMBtreeModel.Node.children(oldindex#0), 
          Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0), 
          Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1), 
          childidx#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.WF#canCall(newindex#0);
  free ensures KMBtreeModel.__default.WF#canCall(newindex#0)
     && 
    KMBtreeModel.__default.WF($LS($LZ), newindex#0)
     && (if KMBtreeModel.Node.Leaf_q(newindex#0)
       then Seq#Length(KMBtreeModel.Node.keys(newindex#0))
           == Seq#Length(KMBtreeModel.Node.values(newindex#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(newindex#0))
       else Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
           == Seq#Length(KMBtreeModel.Node.children(newindex#0)) - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(newindex#0))
         && (forall i#30: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#30)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#30 && i#30 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#30)): DatatypeType))
         && (forall i#31: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#31)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#31 && i#31 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#31)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#32: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(newindex#0, i#32) } 
          true
             ==> 
            LitInt(0) <= i#32
               && i#32 < Seq#Length(KMBtreeModel.Node.children(newindex#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(newindex#0, i#32))
         && (forall i#33: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(newindex#0, i#33) } 
          true
             ==> 
            0 < i#33 && i#33 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(newindex#0, i#33)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction oldindex#0, newindex#0} CheckWellformed$$KMBtreeModel.__default.SplitChildOfIndexPreservesAllKeys(oldindex#0: DatatypeType
       where $Is(oldindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(oldindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(oldindex#0), 
    newindex#0: DatatypeType
       where $Is(newindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newindex#0), 
    childidx#0: int);
  free requires 40 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction oldindex#0, newindex#0} Call$$KMBtreeModel.__default.SplitChildOfIndexPreservesAllKeys(oldindex#0: DatatypeType
       where $Is(oldindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(oldindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(oldindex#0), 
    newindex#0: DatatypeType
       where $Is(newindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newindex#0), 
    childidx#0: int);
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(oldindex#0))
           == Seq#Length(KMBtreeModel.Node.values(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
           == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#17: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#17)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#17)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#18: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#18)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#18 && i#18 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#18)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#19: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(oldindex#0, i#19) } 
          true
             ==> 
            LitInt(0) <= i#19
               && i#19 < Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(oldindex#0, i#19)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#20: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(oldindex#0, i#20) } 
          true
             ==> 
            0 < i#20 && i#20 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(oldindex#0, i#20)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(newindex#0))
           == Seq#Length(KMBtreeModel.Node.values(newindex#0)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(newindex#0)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
           == Seq#Length(KMBtreeModel.Node.children(newindex#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(newindex#0)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#21: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#21)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#21 && i#21 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#21)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#22: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#22)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#22 && i#22 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#22)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#23: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(newindex#0, i#23) } 
          true
             ==> 
            LitInt(0) <= i#23
               && i#23 < Seq#Length(KMBtreeModel.Node.children(newindex#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(newindex#0, i#23)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#24: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(newindex#0, i#24) } 
          true
             ==> 
            0 < i#24 && i#24 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(newindex#0, i#24)));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || KMBtreeModel.Node.Index_q(oldindex#0);
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || KMBtreeModel.Node.Index_q(newindex#0);
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || LitInt(0) <= childidx#0;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || childidx#0 < Seq#Length(KMBtreeModel.Node.children(oldindex#0));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.children(newindex#0))
         == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) + 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
         == Seq#Length(KMBtreeModel.Node.pivots(oldindex#0)) + 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
         == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || (KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
         ==> KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           || 
          KMBtreeModel.__default.SplitLeaf($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           || KMBtreeModel.__default.SplitIndex($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Equal(KMBtreeModel.Node.pivots(newindex#0), 
        Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
          StartFuelAssert_Sequences._default.insert, 
          KMBtreeModel.Node.pivots(oldindex#0), 
          Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
          childidx#0));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Equal(KMBtreeModel.Node.children(newindex#0), 
        Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
          StartFuelAssert_Sequences._default.replace1with2, 
          KMBtreeModel.Node.children(oldindex#0), 
          Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0), 
          Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1), 
          childidx#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.AllKeys#canCall(newindex#0)
     && KMBtreeModel.__default.AllKeys#canCall(oldindex#0);
  ensures Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, newindex#0), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, oldindex#0), 
      Set#UnionOne(Set#Empty(): Set Box, 
        Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction oldindex#0, newindex#0} CheckWellformed$$KMBtreeModel.__default.SplitChildOfIndexPreservesInterpretation(oldindex#0: DatatypeType
       where $Is(oldindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(oldindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(oldindex#0), 
    newindex#0: DatatypeType
       where $Is(newindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newindex#0), 
    childidx#0: int);
  free requires 43 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction oldindex#0, newindex#0} Call$$KMBtreeModel.__default.SplitChildOfIndexPreservesInterpretation(oldindex#0: DatatypeType
       where $Is(oldindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(oldindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(oldindex#0), 
    newindex#0: DatatypeType
       where $Is(newindex#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newindex#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newindex#0), 
    childidx#0: int);
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(oldindex#0))
           == Seq#Length(KMBtreeModel.Node.values(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
           == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(oldindex#0)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#24: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#24)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#24 && i#24 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#24)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#25: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#25)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#25 && i#25 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), i#25)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#26: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(oldindex#0, i#26) } 
          true
             ==> 
            LitInt(0) <= i#26
               && i#26 < Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(oldindex#0, i#26)));
  requires KMBtreeModel.__default.WF#canCall(oldindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), oldindex#0)
       || (!KMBtreeModel.Node.Leaf_q(oldindex#0)
         ==> (forall i#27: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(oldindex#0, i#27) } 
          true
             ==> 
            0 < i#27 && i#27 < Seq#Length(KMBtreeModel.Node.children(oldindex#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(oldindex#0, i#27)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(newindex#0))
           == Seq#Length(KMBtreeModel.Node.values(newindex#0)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(newindex#0)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
           == Seq#Length(KMBtreeModel.Node.children(newindex#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(newindex#0)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#28: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#28)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#28 && i#28 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#28)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#29: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#29)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#29 && i#29 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), i#29)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#30: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(newindex#0, i#30) } 
          true
             ==> 
            LitInt(0) <= i#30
               && i#30 < Seq#Length(KMBtreeModel.Node.children(newindex#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(newindex#0, i#30)));
  requires KMBtreeModel.__default.WF#canCall(newindex#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newindex#0)
       || (!KMBtreeModel.Node.Leaf_q(newindex#0)
         ==> (forall i#31: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(newindex#0, i#31) } 
          true
             ==> 
            0 < i#31 && i#31 < Seq#Length(KMBtreeModel.Node.children(newindex#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(newindex#0, i#31)));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || KMBtreeModel.Node.Index_q(oldindex#0);
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || KMBtreeModel.Node.Index_q(newindex#0);
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || LitInt(0) <= childidx#0;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || childidx#0 < Seq#Length(KMBtreeModel.Node.children(oldindex#0));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.children(newindex#0))
         == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) + 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(newindex#0))
         == Seq#Length(KMBtreeModel.Node.pivots(oldindex#0)) + 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Length(KMBtreeModel.Node.pivots(oldindex#0))
         == Seq#Length(KMBtreeModel.Node.children(oldindex#0)) - 1;
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || (KMBtreeModel.__default.SplitNode#canCall($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
          $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
         ==> KMBtreeModel.__default.SplitNode($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           || 
          KMBtreeModel.__default.SplitLeaf($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box)
           || KMBtreeModel.__default.SplitIndex($Unbox(Seq#Index(KMBtreeModel.Node.children(oldindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1)): DatatypeType, 
            $Unbox(Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0)): Seq Box));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Equal(KMBtreeModel.Node.pivots(newindex#0), 
        Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
          StartFuelAssert_Sequences._default.insert, 
          KMBtreeModel.Node.pivots(oldindex#0), 
          Seq#Index(KMBtreeModel.Node.pivots(newindex#0), childidx#0), 
          childidx#0));
  requires KMBtreeModel.__default.SplitChildOfIndex#canCall(oldindex#0, newindex#0, childidx#0)
     ==> KMBtreeModel.__default.SplitChildOfIndex(oldindex#0, newindex#0, childidx#0)
       || Seq#Equal(KMBtreeModel.Node.children(newindex#0), 
        Sequences.__default.replace1with2(Tclass.KMBtreeModel.Node(), 
          StartFuelAssert_Sequences._default.replace1with2, 
          KMBtreeModel.Node.children(oldindex#0), 
          Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0), 
          Seq#Index(KMBtreeModel.Node.children(newindex#0), childidx#0 + 1), 
          childidx#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.Interpretation#canCall(newindex#0)
     && KMBtreeModel.__default.Interpretation#canCall(oldindex#0);
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, newindex#0), 
    KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, oldindex#0));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for KMBtreeModel._default.InsertLeaf
function KMBtreeModel.__default.InsertLeaf(leaf#0: DatatypeType, key#0: Seq Box, value#0: DatatypeType) : DatatypeType;

function KMBtreeModel.__default.InsertLeaf#canCall(leaf#0: DatatypeType, key#0: Seq Box, value#0: DatatypeType) : bool;

// consequence axiom for KMBtreeModel.__default.InsertLeaf
axiom true
   ==> (forall leaf#0: DatatypeType, key#0: Seq Box, value#0: DatatypeType :: 
    { KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0) } 
    KMBtreeModel.__default.InsertLeaf#canCall(leaf#0, key#0, value#0)
         || (
          $Is(leaf#0, Tclass.KMBtreeModel.Node())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(value#0, Tclass.ValueMessage.Message())
           && 
          KMBtreeModel.Node.Leaf_q(leaf#0)
           && KMBtreeModel.__default.WF($LS($LZ), leaf#0))
       ==> KMBtreeModel.Node.Leaf_q(KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0))
         && KMBtreeModel.__default.WF($LS($LZ), KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0))
         && $Is(KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0), 
          Tclass.KMBtreeModel.Node()));

function KMBtreeModel.__default.InsertLeaf#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.InsertLeaf
axiom (forall leaf#0: DatatypeType, key#0: Seq Box, value#0: DatatypeType :: 
  { KMBtreeModel.__default.InsertLeaf#requires(leaf#0, key#0, value#0) } 
  $Is(leaf#0, Tclass.KMBtreeModel.Node())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(value#0, Tclass.ValueMessage.Message())
     ==> KMBtreeModel.__default.InsertLeaf#requires(leaf#0, key#0, value#0)
       == (KMBtreeModel.Node.Leaf_q(leaf#0)
         && KMBtreeModel.__default.WF($LS($LZ), leaf#0)));

// definition axiom for KMBtreeModel.__default.InsertLeaf(revealed)
axiom true
   ==> (forall leaf#0: DatatypeType, key#0: Seq Box, value#0: DatatypeType :: 
    { KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0) } 
    KMBtreeModel.__default.InsertLeaf#canCall(leaf#0, key#0, value#0)
         || (
          $Is(leaf#0, Tclass.KMBtreeModel.Node())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(value#0, Tclass.ValueMessage.Message())
           && 
          KMBtreeModel.Node.Leaf_q(leaf#0)
           && KMBtreeModel.__default.WF($LS($LZ), leaf#0))
       ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(KMBtreeModel.Node.keys(leaf#0), key#0)
         && (var llte#3 := Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.keys(leaf#0), key#0); 
          !(LitInt(0) <= llte#3
               && Seq#Equal($Unbox(Seq#Index(KMBtreeModel.Node.keys(leaf#0), llte#3)): Seq Box, key#0))
             ==> Sequences.__default.insert#canCall(TSeq(Tclass.NativeTypes.byte()), 
                KMBtreeModel.Node.keys(leaf#0), 
                $Box(key#0), 
                llte#3 + 1)
               && Sequences.__default.insert#canCall(Tclass.ValueMessage.Message(), 
                KMBtreeModel.Node.values(leaf#0), 
                $Box(value#0), 
                llte#3 + 1))
         && KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0)
           == (var llte#3 := Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), KMBtreeModel.Node.keys(leaf#0), key#0); 
            (if LitInt(0) <= llte#3
                 && Seq#Equal($Unbox(Seq#Index(KMBtreeModel.Node.keys(leaf#0), llte#3)): Seq Box, key#0)
               then #KMBtreeModel.Node.Leaf(KMBtreeModel.Node.keys(leaf#0), 
                Seq#Update(KMBtreeModel.Node.values(leaf#0), llte#3, $Box(value#0)))
               else #KMBtreeModel.Node.Leaf(Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
                  StartFuel_Sequences._default.insert, 
                  KMBtreeModel.Node.keys(leaf#0), 
                  $Box(key#0), 
                  llte#3 + 1), 
                Sequences.__default.insert(Tclass.ValueMessage.Message(), 
                  StartFuel_Sequences._default.insert, 
                  KMBtreeModel.Node.values(leaf#0), 
                  $Box(value#0), 
                  llte#3 + 1)))));

// definition axiom for KMBtreeModel.__default.InsertLeaf for all literals(revealed)
axiom true
   ==> (forall leaf#0: DatatypeType, key#0: Seq Box, value#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.InsertLeaf(Lit(leaf#0), Lit(key#0), Lit(value#0)) } 
    KMBtreeModel.__default.InsertLeaf#canCall(Lit(leaf#0), Lit(key#0), Lit(value#0))
         || (
          $Is(leaf#0, Tclass.KMBtreeModel.Node())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(value#0, Tclass.ValueMessage.Message())
           && 
          Lit(KMBtreeModel.Node.Leaf_q(Lit(leaf#0)))
           && Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(leaf#0))))
       ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), Lit(key#0))
         && (var llte#4 := LitInt(Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), Lit(key#0))); 
          !(LitInt(0) <= llte#4
               && Seq#Equal($Unbox(Seq#Index(Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), llte#4)): Seq Box, 
                key#0))
             ==> Sequences.__default.insert#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), 
                $Box(Lit(key#0)), 
                llte#4 + 1)
               && Sequences.__default.insert#canCall(Tclass.ValueMessage.Message(), 
                Lit(KMBtreeModel.Node.values(Lit(leaf#0))), 
                $Box(Lit(value#0)), 
                llte#4 + 1))
         && KMBtreeModel.__default.InsertLeaf(Lit(leaf#0), Lit(key#0), Lit(value#0))
           == (var llte#4 := LitInt(Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), Lit(key#0))); 
            (if LitInt(0) <= llte#4
                 && Seq#Equal($Unbox(Seq#Index(Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), llte#4)): Seq Box, 
                  key#0)
               then #KMBtreeModel.Node.Leaf(Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), 
                Seq#Update(Lit(KMBtreeModel.Node.values(Lit(leaf#0))), llte#4, $Box(Lit(value#0))))
               else #KMBtreeModel.Node.Leaf(Sequences.__default.insert(TSeq(Tclass.NativeTypes.byte()), 
                  StartFuel_Sequences._default.insert, 
                  Lit(KMBtreeModel.Node.keys(Lit(leaf#0))), 
                  $Box(Lit(key#0)), 
                  LitInt(llte#4 + 1)), 
                Sequences.__default.insert(Tclass.ValueMessage.Message(), 
                  StartFuel_Sequences._default.insert, 
                  Lit(KMBtreeModel.Node.values(Lit(leaf#0))), 
                  $Box(Lit(value#0)), 
                  LitInt(llte#4 + 1))))));

procedure {:_induction leaf#0} CheckWellformed$$KMBtreeModel.__default.InsertLeafIsCorrect(leaf#0: DatatypeType
       where $Is(leaf#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(leaf#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(leaf#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0));
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction leaf#0} Call$$KMBtreeModel.__default.InsertLeafIsCorrect(leaf#0: DatatypeType
       where $Is(leaf#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(leaf#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(leaf#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0));
  // user-defined preconditions
  requires KMBtreeModel.Node.Leaf_q(leaf#0);
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(leaf#0))
           == Seq#Length(KMBtreeModel.Node.values(leaf#0)));
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(leaf#0)));
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (!KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(leaf#0))
           == Seq#Length(KMBtreeModel.Node.children(leaf#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (!KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(leaf#0)));
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (!KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> (forall i#33: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(leaf#0), i#33)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#33 && i#33 < Seq#Length(KMBtreeModel.Node.children(leaf#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(leaf#0), i#33)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (!KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> (forall i#34: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(leaf#0), i#34)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#34 && i#34 < Seq#Length(KMBtreeModel.Node.children(leaf#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(leaf#0), i#34)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (!KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> (forall i#35: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(leaf#0, i#35) } 
          true
             ==> 
            LitInt(0) <= i#35 && i#35 < Seq#Length(KMBtreeModel.Node.children(leaf#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(leaf#0, i#35)));
  requires KMBtreeModel.__default.WF#canCall(leaf#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), leaf#0)
       || (!KMBtreeModel.Node.Leaf_q(leaf#0)
         ==> (forall i#36: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(leaf#0, i#36) } 
          true
             ==> 
            0 < i#36 && i#36 < Seq#Length(KMBtreeModel.Node.children(leaf#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(leaf#0, i#36)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.InsertLeaf#canCall(leaf#0, key#0, value#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0))
     && KMBtreeModel.__default.Interpretation#canCall(leaf#0);
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0)), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, leaf#0), 
      $Box(key#0), 
      $Box(value#0)));
  free ensures KMBtreeModel.__default.InsertLeaf#canCall(leaf#0, key#0, value#0)
     && KMBtreeModel.__default.AllKeys#canCall(KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0))
     && KMBtreeModel.__default.AllKeys#canCall(leaf#0);
  ensures Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
      KMBtreeModel.__default.InsertLeaf(leaf#0, key#0, value#0)), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, leaf#0), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0, key#0, newnode#0, newchild#0} CheckWellformed$$KMBtreeModel.__default.RecursiveInsertIsCorrect(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0), 
    pos#0: int, 
    newnode#0: DatatypeType
       where $Is(newnode#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newnode#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newnode#0), 
    newchild#0: DatatypeType
       where $Is(newchild#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newchild#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newchild#0));
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0, key#0, newnode#0, newchild#0} Call$$KMBtreeModel.__default.RecursiveInsertIsCorrect(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0), 
    key#0: Seq Box
       where $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
         && $IsAlloc(key#0, TSeq(Tclass.NativeTypes.byte()), $Heap), 
    value#0: DatatypeType
       where $Is(value#0, Tclass.ValueMessage.Message())
         && $IsAlloc(value#0, Tclass.ValueMessage.Message(), $Heap)
         && $IsA#ValueMessage.Message(value#0), 
    pos#0: int, 
    newnode#0: DatatypeType
       where $Is(newnode#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newnode#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newnode#0), 
    newchild#0: DatatypeType
       where $Is(newchild#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(newchild#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(newchild#0));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#64: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#64)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#64 && i#64 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#64)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#65: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#65)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#65 && i#65 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#65)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#66: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#66) } 
          true
             ==> 
            LitInt(0) <= i#66 && i#66 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#66)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#67: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#67) } 
          true
             ==> 
            0 < i#67 && i#67 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#67)));
  requires KMBtreeModel.Node.Index_q(node#0);
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(newchild#0))
           == Seq#Length(KMBtreeModel.Node.values(newchild#0)));
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(newchild#0)));
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (!KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(newchild#0))
           == Seq#Length(KMBtreeModel.Node.children(newchild#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (!KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(newchild#0)));
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (!KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> (forall i#68: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newchild#0), i#68)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#68 && i#68 < Seq#Length(KMBtreeModel.Node.children(newchild#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newchild#0), i#68)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (!KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> (forall i#69: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newchild#0), i#69)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#69 && i#69 < Seq#Length(KMBtreeModel.Node.children(newchild#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(newchild#0), i#69)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (!KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> (forall i#70: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(newchild#0, i#70) } 
          true
             ==> 
            LitInt(0) <= i#70
               && i#70 < Seq#Length(KMBtreeModel.Node.children(newchild#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(newchild#0, i#70)));
  requires KMBtreeModel.__default.WF#canCall(newchild#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), newchild#0)
       || (!KMBtreeModel.Node.Leaf_q(newchild#0)
         ==> (forall i#71: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(newchild#0, i#71) } 
          true
             ==> 
            0 < i#71 && i#71 < Seq#Length(KMBtreeModel.Node.children(newchild#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(newchild#0, i#71)));
  requires pos#0
     == Lexicographic__Byte__Order.__default.LargestLte($LS($LS($LZ)), KMBtreeModel.Node.pivots(node#0), key#0)
       + 1;
  requires Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, newchild#0), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
        $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), pos#0)): DatatypeType), 
      $Box(key#0), 
      $Box(value#0)));
  requires KMBtreeModel.Node#Equal(newnode#0, 
    (var dt_update_tmp#0#1 := node#0; 
      (var dt_update#children#0#1 := Seq#Update(KMBtreeModel.Node.children(node#0), pos#0, $Box(newchild#0)); 
        #KMBtreeModel.Node.Index(KMBtreeModel.Node.pivots(dt_update_tmp#0#1), dt_update#children#0#1))));
  requires Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, newchild#0), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
        $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), pos#0)): DatatypeType), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.WF#canCall(newnode#0);
  free ensures KMBtreeModel.__default.WF#canCall(newnode#0)
     && 
    KMBtreeModel.__default.WF($LS($LZ), newnode#0)
     && (if KMBtreeModel.Node.Leaf_q(newnode#0)
       then Seq#Length(KMBtreeModel.Node.keys(newnode#0))
           == Seq#Length(KMBtreeModel.Node.values(newnode#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(newnode#0))
       else Seq#Length(KMBtreeModel.Node.pivots(newnode#0))
           == Seq#Length(KMBtreeModel.Node.children(newnode#0)) - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(newnode#0))
         && (forall i#72: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newnode#0), i#72)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#72 && i#72 < Seq#Length(KMBtreeModel.Node.children(newnode#0))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(newnode#0), i#72)): DatatypeType))
         && (forall i#73: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(newnode#0), i#73)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#73 && i#73 < Seq#Length(KMBtreeModel.Node.children(newnode#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(newnode#0), i#73)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#74: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(newnode#0, i#74) } 
          true
             ==> 
            LitInt(0) <= i#74
               && i#74 < Seq#Length(KMBtreeModel.Node.children(newnode#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(newnode#0, i#74))
         && (forall i#75: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(newnode#0, i#75) } 
          true
             ==> 
            0 < i#75 && i#75 < Seq#Length(KMBtreeModel.Node.children(newnode#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(newnode#0, i#75)));
  free ensures KMBtreeModel.__default.Interpretation#canCall(newnode#0)
     && KMBtreeModel.__default.Interpretation#canCall(node#0);
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, newnode#0), 
    Map#Build(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0), 
      $Box(key#0), 
      $Box(value#0)));
  free ensures KMBtreeModel.__default.AllKeys#canCall(newnode#0)
     && KMBtreeModel.__default.AllKeys#canCall(node#0);
  ensures Set#Subset(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, newnode#0), 
    Set#Union(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, node#0), 
      Set#UnionOne(Set#Empty(): Set Box, $Box(key#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for KMBtreeModel._default.Grow
function KMBtreeModel.__default.Grow(node#0: DatatypeType) : DatatypeType;

function KMBtreeModel.__default.Grow#canCall(node#0: DatatypeType) : bool;

// consequence axiom for KMBtreeModel.__default.Grow
axiom true
   ==> (forall node#0: DatatypeType :: 
    { KMBtreeModel.__default.Grow(node#0) } 
    KMBtreeModel.__default.Grow#canCall(node#0)
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> $Is(KMBtreeModel.__default.Grow(node#0), Tclass.KMBtreeModel.Node()));

function KMBtreeModel.__default.Grow#requires(DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.Grow
axiom (forall node#0: DatatypeType :: 
  { KMBtreeModel.__default.Grow#requires(node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.Grow#requires(node#0) == true);

// definition axiom for KMBtreeModel.__default.Grow(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    { KMBtreeModel.__default.Grow(node#0) } 
    KMBtreeModel.__default.Grow#canCall(node#0)
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> KMBtreeModel.__default.Grow(node#0)
         == #KMBtreeModel.Node.Index(Lit(Seq#Empty(): Seq Box), Seq#Build(Seq#Empty(): Seq Box, $Box(node#0))));

// definition axiom for KMBtreeModel.__default.Grow for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.Grow(Lit(node#0)) } 
    KMBtreeModel.__default.Grow#canCall(Lit(node#0))
         || $Is(node#0, Tclass.KMBtreeModel.Node())
       ==> KMBtreeModel.__default.Grow(Lit(node#0))
         == Lit(#KMBtreeModel.Node.Index(Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(node#0)))))));

procedure {:_induction node#0} CheckWellformed$$KMBtreeModel.__default.GrowPreservesWF(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  free requires 48 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtreeModel.__default.GrowPreservesWF(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#16: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#16 && i#16 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#16)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#17: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#17 && i#17 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#17)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#18: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18) } 
          true
             ==> 
            LitInt(0) <= i#18 && i#18 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#18)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#19: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19) } 
          true
             ==> 
            0 < i#19 && i#19 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#19)));
  requires !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, node#0), 
    Set#Empty(): Set Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.Grow#canCall(node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtreeModel.__default.Grow(node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtreeModel.__default.Grow(node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtreeModel.__default.Grow(node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtreeModel.__default.Grow(node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtreeModel.__default.Grow(node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtreeModel.__default.Grow(node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtreeModel.__default.Grow(node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtreeModel.__default.Grow(node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0))) - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtreeModel.__default.Grow(node#0)))
         && (forall i#20: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#20)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#20
               && i#20
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#20)): DatatypeType))
         && (forall i#21: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#21)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#21
               && i#21
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#21)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#22: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtreeModel.__default.Grow(node#0), i#22) } 
          true
             ==> 
            LitInt(0) <= i#22
               && i#22
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0))) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtreeModel.__default.Grow(node#0), i#22))
         && (forall i#23: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtreeModel.__default.Grow(node#0), i#23) } 
          true
             ==> 
            0 < i#23
               && i#23
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtreeModel.__default.Grow(node#0), i#23)));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction node#0} CheckWellformed$$KMBtreeModel.__default.GrowPreservesInterpretation(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  free requires 50 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction node#0} Call$$KMBtreeModel.__default.GrowPreservesInterpretation(node#0: DatatypeType
       where $Is(node#0, Tclass.KMBtreeModel.Node())
         && $IsAlloc(node#0, Tclass.KMBtreeModel.Node(), $Heap)
         && $IsA#KMBtreeModel.Node(node#0));
  // user-defined preconditions
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.keys(node#0))
           == Seq#Length(KMBtreeModel.Node.values(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Seq#Length(KMBtreeModel.Node.pivots(node#0))
           == Seq#Length(KMBtreeModel.Node.children(node#0)) - 1);
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(node#0)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#32: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#32)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#32 && i#32 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.WF($LS($LS($LZ)), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#32)): DatatypeType)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#33: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#33)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#33 && i#33 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(node#0), i#33)): DatatypeType), 
              Set#Empty(): Set Box)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#34: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(node#0, i#34) } 
          true
             ==> 
            LitInt(0) <= i#34 && i#34 < Seq#Length(KMBtreeModel.Node.children(node#0)) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(node#0, i#34)));
  requires KMBtreeModel.__default.WF#canCall(node#0)
     ==> KMBtreeModel.__default.WF($LS($LZ), node#0)
       || (!KMBtreeModel.Node.Leaf_q(node#0)
         ==> (forall i#35: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(node#0, i#35) } 
          true
             ==> 
            0 < i#35 && i#35 < Seq#Length(KMBtreeModel.Node.children(node#0))
             ==> KMBtreeModel.__default.AllKeysAboveBound(node#0, i#35)));
  requires !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuelAssert_KMBtreeModel._default.AllKeys, node#0), 
    Set#Empty(): Set Box);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures KMBtreeModel.__default.Grow#canCall(node#0)
     && KMBtreeModel.__default.WF#canCall(KMBtreeModel.__default.Grow(node#0));
  free ensures KMBtreeModel.__default.WF#canCall(KMBtreeModel.__default.Grow(node#0))
     && 
    KMBtreeModel.__default.WF($LS($LZ), KMBtreeModel.__default.Grow(node#0))
     && (if KMBtreeModel.Node.Leaf_q(KMBtreeModel.__default.Grow(node#0))
       then Seq#Length(KMBtreeModel.Node.keys(KMBtreeModel.__default.Grow(node#0)))
           == Seq#Length(KMBtreeModel.Node.values(KMBtreeModel.__default.Grow(node#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.keys(KMBtreeModel.__default.Grow(node#0)))
       else Seq#Length(KMBtreeModel.Node.pivots(KMBtreeModel.__default.Grow(node#0)))
           == Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0))) - 1
         && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          KMBtreeModel.Node.pivots(KMBtreeModel.__default.Grow(node#0)))
         && (forall i#36: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#36)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#36
               && i#36
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)))
             ==> KMBtreeModel.__default.WF($LS($LZ), 
              $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#36)): DatatypeType))
         && (forall i#37: int :: 
          { $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#37)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#37
               && i#37
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)))
             ==> !Set#Equal(KMBtreeModel.__default.AllKeys(StartFuel_KMBtreeModel._default.AllKeys, 
                $Unbox(Seq#Index(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)), i#37)): DatatypeType), 
              Set#Empty(): Set Box))
         && (forall i#38: int :: 
          { KMBtreeModel.__default.AllKeysBelowBound(KMBtreeModel.__default.Grow(node#0), i#38) } 
          true
             ==> 
            LitInt(0) <= i#38
               && i#38
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0))) - 1
             ==> KMBtreeModel.__default.AllKeysBelowBound(KMBtreeModel.__default.Grow(node#0), i#38))
         && (forall i#39: int :: 
          { KMBtreeModel.__default.AllKeysAboveBound(KMBtreeModel.__default.Grow(node#0), i#39) } 
          true
             ==> 
            0 < i#39
               && i#39
                 < Seq#Length(KMBtreeModel.Node.children(KMBtreeModel.__default.Grow(node#0)))
             ==> KMBtreeModel.__default.AllKeysAboveBound(KMBtreeModel.__default.Grow(node#0), i#39)));
  free ensures KMBtreeModel.__default.Grow#canCall(node#0)
     && KMBtreeModel.__default.Interpretation#canCall(KMBtreeModel.__default.Grow(node#0))
     && KMBtreeModel.__default.Interpretation#canCall(node#0);
  ensures Map#Equal(KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, 
      KMBtreeModel.__default.Grow(node#0)), 
    KMBtreeModel.__default.Interpretation(StartFuelAssert_KMBtreeModel._default.Interpretation, node#0));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for KMBtreeModel._default.ReplacePivot
function KMBtreeModel.__default.ReplacePivot(node#0: DatatypeType, pivotidx#0: int, pivot#0: Seq Box) : DatatypeType;

function KMBtreeModel.__default.ReplacePivot#canCall(node#0: DatatypeType, pivotidx#0: int, pivot#0: Seq Box) : bool;

// consequence axiom for KMBtreeModel.__default.ReplacePivot
axiom true
   ==> (forall node#0: DatatypeType, pivotidx#0: int, pivot#0: Seq Box :: 
    { KMBtreeModel.__default.ReplacePivot(node#0, pivotidx#0, pivot#0) } 
    KMBtreeModel.__default.ReplacePivot#canCall(node#0, pivotidx#0, pivot#0)
         || (
          $Is(node#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          KMBtreeModel.__default.WF($LS($LZ), node#0)
           && KMBtreeModel.Node.Index_q(node#0)
           && 
          LitInt(0) <= pivotidx#0
           && pivotidx#0 < Seq#Length(KMBtreeModel.Node.pivots(node#0)))
       ==> $Is(KMBtreeModel.__default.ReplacePivot(node#0, pivotidx#0, pivot#0), 
        Tclass.KMBtreeModel.Node()));

function KMBtreeModel.__default.ReplacePivot#requires(DatatypeType, int, Seq Box) : bool;

// #requires axiom for KMBtreeModel.__default.ReplacePivot
axiom (forall node#0: DatatypeType, pivotidx#0: int, pivot#0: Seq Box :: 
  { KMBtreeModel.__default.ReplacePivot#requires(node#0, pivotidx#0, pivot#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
     ==> KMBtreeModel.__default.ReplacePivot#requires(node#0, pivotidx#0, pivot#0)
       == (
        KMBtreeModel.__default.WF($LS($LZ), node#0)
         && KMBtreeModel.Node.Index_q(node#0)
         && 
        LitInt(0) <= pivotidx#0
         && pivotidx#0 < Seq#Length(KMBtreeModel.Node.pivots(node#0))));

// definition axiom for KMBtreeModel.__default.ReplacePivot(revealed)
axiom true
   ==> (forall node#0: DatatypeType, pivotidx#0: int, pivot#0: Seq Box :: 
    { KMBtreeModel.__default.ReplacePivot(node#0, pivotidx#0, pivot#0) } 
    KMBtreeModel.__default.ReplacePivot#canCall(node#0, pivotidx#0, pivot#0)
         || (
          $Is(node#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          KMBtreeModel.__default.WF($LS($LZ), node#0)
           && KMBtreeModel.Node.Index_q(node#0)
           && 
          LitInt(0) <= pivotidx#0
           && pivotidx#0 < Seq#Length(KMBtreeModel.Node.pivots(node#0)))
       ==> KMBtreeModel.__default.ReplacePivot(node#0, pivotidx#0, pivot#0)
         == (var dt_update_tmp#0#3 := node#0; 
          (var dt_update#pivots#0#3 := Seq#Update(KMBtreeModel.Node.pivots(node#0), pivotidx#0, $Box(pivot#0)); 
            #KMBtreeModel.Node.Index(dt_update#pivots#0#3, KMBtreeModel.Node.children(dt_update_tmp#0#3)))));

// definition axiom for KMBtreeModel.__default.ReplacePivot for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, pivotidx#0: int, pivot#0: Seq Box :: 
    {:weight 3} { KMBtreeModel.__default.ReplacePivot(Lit(node#0), LitInt(pivotidx#0), Lit(pivot#0)) } 
    KMBtreeModel.__default.ReplacePivot#canCall(Lit(node#0), LitInt(pivotidx#0), Lit(pivot#0))
         || (
          $Is(node#0, Tclass.KMBtreeModel.Node())
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(node#0)))
           && Lit(KMBtreeModel.Node.Index_q(Lit(node#0)))
           && 
          LitInt(0) <= LitInt(pivotidx#0)
           && pivotidx#0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(node#0)))))
       ==> KMBtreeModel.__default.ReplacePivot(Lit(node#0), LitInt(pivotidx#0), Lit(pivot#0))
         == (var dt_update_tmp#0#4 := Lit(node#0); 
          (var dt_update#pivots#0#4 := Seq#Update(Lit(KMBtreeModel.Node.pivots(Lit(node#0))), 
                LitInt(pivotidx#0), 
                $Box(Lit(pivot#0))); 
            #KMBtreeModel.Node.Index(dt_update#pivots#0#4, Lit(KMBtreeModel.Node.children(dt_update_tmp#0#4))))));

// function declaration for KMBtreeModel._default.AppendChild
function KMBtreeModel.__default.AppendChild(oldparent#0: DatatypeType, newparent#0: DatatypeType) : bool;

function KMBtreeModel.__default.AppendChild#canCall(oldparent#0: DatatypeType, newparent#0: DatatypeType) : bool;

// consequence axiom for KMBtreeModel.__default.AppendChild
axiom true
   ==> (forall oldparent#0: DatatypeType, newparent#0: DatatypeType :: 
    { KMBtreeModel.__default.AppendChild(oldparent#0, newparent#0) } 
    KMBtreeModel.__default.AppendChild#canCall(oldparent#0, newparent#0)
         || ($Is(oldparent#0, Tclass.KMBtreeModel.Node())
           && $Is(newparent#0, Tclass.KMBtreeModel.Node()))
       ==> true);

function KMBtreeModel.__default.AppendChild#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.AppendChild
axiom (forall oldparent#0: DatatypeType, newparent#0: DatatypeType :: 
  { KMBtreeModel.__default.AppendChild#requires(oldparent#0, newparent#0) } 
  $Is(oldparent#0, Tclass.KMBtreeModel.Node())
       && $Is(newparent#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.AppendChild#requires(oldparent#0, newparent#0) == true);

// definition axiom for KMBtreeModel.__default.AppendChild(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, newparent#0: DatatypeType :: 
    { KMBtreeModel.__default.AppendChild(oldparent#0, newparent#0) } 
    KMBtreeModel.__default.AppendChild#canCall(oldparent#0, newparent#0)
         || ($Is(oldparent#0, Tclass.KMBtreeModel.Node())
           && $Is(newparent#0, Tclass.KMBtreeModel.Node()))
       ==> (1 < Seq#Length(KMBtreeModel.Node.children(newparent#0))
             && Seq#Length(KMBtreeModel.Node.children(newparent#0))
               == Seq#Length(KMBtreeModel.Node.pivots(newparent#0)) + 1
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0)))
         && (Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))
             && Seq#Equal(KMBtreeModel.Node.pivots(newparent#0), 
              Seq#Append(KMBtreeModel.Node.pivots(oldparent#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0)))))
           ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(newparent#0)))
         && (Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(newparent#0))
             && Seq#Equal(KMBtreeModel.Node.children(newparent#0), 
              Seq#Append(KMBtreeModel.Node.children(oldparent#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(newparent#0)))))
           ==> 
          0 < Seq#Length(KMBtreeModel.Node.pivots(oldparent#0))
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(oldparent#0))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(oldparent#0))): Seq Box, 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))): Seq Box))
         && ((0 < Seq#Length(KMBtreeModel.Node.pivots(oldparent#0))
               ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(oldparent#0))
                 && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))
                 && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(oldparent#0))): Seq Box, 
                  $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))): Seq Box))
             && (0 < Seq#Length(KMBtreeModel.Node.pivots(oldparent#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(oldparent#0))): Seq Box, 
                $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))): Seq Box))
           ==> KMBtreeModel.__default.AllKeysBelowBound#canCall(newparent#0, Seq#Length(KMBtreeModel.Node.children(newparent#0)) - 2))
         && (KMBtreeModel.__default.AllKeysBelowBound#canCall(newparent#0, Seq#Length(KMBtreeModel.Node.children(newparent#0)) - 2)
             && KMBtreeModel.__default.AllKeysBelowBound(newparent#0, Seq#Length(KMBtreeModel.Node.children(newparent#0)) - 2)
           ==> KMBtreeModel.__default.AllKeysAboveBound#canCall(newparent#0, Seq#Length(KMBtreeModel.Node.children(newparent#0)) - 1))
         && KMBtreeModel.__default.AppendChild(oldparent#0, newparent#0)
           == (
            KMBtreeModel.Node.Index_q(oldparent#0)
             && KMBtreeModel.Node.Index_q(newparent#0)
             && 
            1 < Seq#Length(KMBtreeModel.Node.children(newparent#0))
             && Seq#Length(KMBtreeModel.Node.children(newparent#0))
               == Seq#Length(KMBtreeModel.Node.pivots(newparent#0)) + 1
             && Seq#Equal(KMBtreeModel.Node.pivots(newparent#0), 
              Seq#Append(KMBtreeModel.Node.pivots(oldparent#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0)))))
             && Seq#Equal(KMBtreeModel.Node.children(newparent#0), 
              Seq#Append(KMBtreeModel.Node.children(oldparent#0), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  Sequences.__default.Last(Tclass.KMBtreeModel.Node(), KMBtreeModel.Node.children(newparent#0)))))
             && (0 < Seq#Length(KMBtreeModel.Node.pivots(oldparent#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(oldparent#0))): Seq Box, 
                $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), KMBtreeModel.Node.pivots(newparent#0))): Seq Box))
             && KMBtreeModel.__default.AllKeysBelowBound(newparent#0, Seq#Length(KMBtreeModel.Node.children(newparent#0)) - 2)
             && KMBtreeModel.__default.AllKeysAboveBound(newparent#0, Seq#Length(KMBtreeModel.Node.children(newparent#0)) - 1)));

// definition axiom for KMBtreeModel.__default.AppendChild for all literals(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, newparent#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.AppendChild(Lit(oldparent#0), Lit(newparent#0)) } 
    KMBtreeModel.__default.AppendChild#canCall(Lit(oldparent#0), Lit(newparent#0))
         || ($Is(oldparent#0, Tclass.KMBtreeModel.Node())
           && $Is(newparent#0, Tclass.KMBtreeModel.Node()))
       ==> (1 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(newparent#0)))) + 1
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0)))))
         && (Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))
             && Seq#Equal(KMBtreeModel.Node.pivots(Lit(newparent#0)), 
              Seq#Append(KMBtreeModel.Node.pivots(Lit(oldparent#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))): Seq Box)))))
           ==> Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(newparent#0)))))
         && (Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(newparent#0))))
             && Seq#Equal(KMBtreeModel.Node.children(Lit(newparent#0)), 
              Seq#Append(KMBtreeModel.Node.children(Lit(oldparent#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(newparent#0))))): DatatypeType)))))
           ==> 
          0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))): Seq Box), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))): Seq Box)))
         && ((0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))
               ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))
                 && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))
                 && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))): Seq Box), 
                  Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))): Seq Box)))
             && (0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))
               ==> Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))): Seq Box), 
                Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))): Seq Box)))
           ==> KMBtreeModel.__default.AllKeysBelowBound#canCall(Lit(newparent#0), 
            Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0)))) - 2))
         && (KMBtreeModel.__default.AllKeysBelowBound#canCall(Lit(newparent#0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0)))) - 2)
             && KMBtreeModel.__default.AllKeysBelowBound(Lit(newparent#0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0)))) - 2)
           ==> KMBtreeModel.__default.AllKeysAboveBound#canCall(Lit(newparent#0), 
            Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0)))) - 1))
         && KMBtreeModel.__default.AppendChild(Lit(oldparent#0), Lit(newparent#0))
           == (
            KMBtreeModel.Node.Index_q(Lit(oldparent#0))
             && KMBtreeModel.Node.Index_q(Lit(newparent#0))
             && 
            1 < Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0))))
             && Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0))))
               == Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(newparent#0)))) + 1
             && Seq#Equal(KMBtreeModel.Node.pivots(Lit(newparent#0)), 
              Seq#Append(KMBtreeModel.Node.pivots(Lit(oldparent#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))): Seq Box)))))
             && Seq#Equal(KMBtreeModel.Node.children(Lit(newparent#0)), 
              Seq#Append(KMBtreeModel.Node.children(Lit(oldparent#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(KMBtreeModel.Node.children(Lit(newparent#0))))): DatatypeType)))))
             && (0 < Seq#Length(Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))
               ==> Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(oldparent#0))))): Seq Box), 
                Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(KMBtreeModel.Node.pivots(Lit(newparent#0))))): Seq Box)))
             && KMBtreeModel.__default.AllKeysBelowBound(Lit(newparent#0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0)))) - 2)
             && KMBtreeModel.__default.AllKeysAboveBound(Lit(newparent#0), 
              Seq#Length(Lit(KMBtreeModel.Node.children(Lit(newparent#0)))) - 1)));

// function declaration for KMBtreeModel._default.NumElementsOfChildren
function KMBtreeModel.__default.NumElementsOfChildren($ly: LayerType, nodes#0: Seq Box) : int;

function KMBtreeModel.__default.NumElementsOfChildren#canCall(nodes#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, nodes#0: Seq Box :: 
  { KMBtreeModel.__default.NumElementsOfChildren($LS($ly), nodes#0) } 
  KMBtreeModel.__default.NumElementsOfChildren($LS($ly), nodes#0)
     == KMBtreeModel.__default.NumElementsOfChildren($ly, nodes#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, nodes#0: Seq Box :: 
  { KMBtreeModel.__default.NumElementsOfChildren(AsFuelBottom($ly), nodes#0) } 
  KMBtreeModel.__default.NumElementsOfChildren($ly, nodes#0)
     == KMBtreeModel.__default.NumElementsOfChildren($LZ, nodes#0));

// consequence axiom for KMBtreeModel.__default.NumElementsOfChildren
axiom true
   ==> (forall $ly: LayerType, nodes#0: Seq Box :: 
    { KMBtreeModel.__default.NumElementsOfChildren($ly, nodes#0) } 
    KMBtreeModel.__default.NumElementsOfChildren#canCall(nodes#0)
         || ($Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
           && (forall i#10: int :: 
            { $Unbox(Seq#Index(nodes#0, i#10)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#10 && i#10 < Seq#Length(nodes#0)
               ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(nodes#0, i#10)): DatatypeType)))
       ==> LitInt(0) <= KMBtreeModel.__default.NumElementsOfChildren($ly, nodes#0));

function KMBtreeModel.__default.NumElementsOfChildren#requires(LayerType, Seq Box) : bool;

// #requires axiom for KMBtreeModel.__default.NumElementsOfChildren
axiom (forall $ly: LayerType, nodes#0: Seq Box :: 
  { KMBtreeModel.__default.NumElementsOfChildren#requires($ly, nodes#0) } 
  $Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
     ==> KMBtreeModel.__default.NumElementsOfChildren#requires($ly, nodes#0)
       == (forall i#11: int :: 
        { $Unbox(Seq#Index(nodes#0, i#11)): DatatypeType } 
        true
           ==> 
          LitInt(0) <= i#11 && i#11 < Seq#Length(nodes#0)
           ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(nodes#0, i#11)): DatatypeType)));

// definition axiom for KMBtreeModel.__default.NumElementsOfChildren(revealed)
axiom true
   ==> (forall $ly: LayerType, nodes#0: Seq Box :: 
    { KMBtreeModel.__default.NumElementsOfChildren($LS($ly), nodes#0) } 
    KMBtreeModel.__default.NumElementsOfChildren#canCall(nodes#0)
         || ($Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
           && (forall i#11: int :: 
            { $Unbox(Seq#Index(nodes#0, i#11)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#11 && i#11 < Seq#Length(nodes#0)
               ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(nodes#0, i#11)): DatatypeType)))
       ==> (Seq#Length(nodes#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KMBtreeModel.Node(), nodes#0)
             && KMBtreeModel.__default.NumElementsOfChildren#canCall(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), nodes#0))
             && 
            Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), nodes#0)
             && KMBtreeModel.__default.NumElements#canCall($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), nodes#0)): DatatypeType))
         && KMBtreeModel.__default.NumElementsOfChildren($LS($ly), nodes#0)
           == (if Seq#Length(nodes#0) == LitInt(0)
             then 0
             else KMBtreeModel.__default.NumElementsOfChildren($ly, Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), nodes#0))
               + KMBtreeModel.__default.NumElements($ly, 
                $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), nodes#0)): DatatypeType)));

// definition axiom for KMBtreeModel.__default.NumElementsOfChildren for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, nodes#0: Seq Box :: 
    {:weight 3} { KMBtreeModel.__default.NumElementsOfChildren($LS($ly), Lit(nodes#0)) } 
    KMBtreeModel.__default.NumElementsOfChildren#canCall(Lit(nodes#0))
         || ($Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
           && (forall i#12: int :: 
            { $Unbox(Seq#Index(nodes#0, i#12)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#12 && i#12 < Seq#Length(Lit(nodes#0))
               ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(Lit(nodes#0), i#12)): DatatypeType)))
       ==> (Seq#Length(Lit(nodes#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KMBtreeModel.Node(), Lit(nodes#0))
             && KMBtreeModel.__default.NumElementsOfChildren#canCall(Lit(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), Lit(nodes#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(nodes#0))
             && KMBtreeModel.__default.NumElements#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(nodes#0))): DatatypeType)))
         && KMBtreeModel.__default.NumElementsOfChildren($LS($ly), Lit(nodes#0))
           == (if Seq#Length(Lit(nodes#0)) == LitInt(0)
             then 0
             else KMBtreeModel.__default.NumElementsOfChildren($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), Lit(nodes#0))))
               + KMBtreeModel.__default.NumElements($LS($ly), 
                Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(nodes#0))): DatatypeType))));

// function declaration for KMBtreeModel._default.NumElements
function KMBtreeModel.__default.NumElements($ly: LayerType, node#0: DatatypeType) : int;

function KMBtreeModel.__default.NumElements#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.NumElements($LS($ly), node#0) } 
  KMBtreeModel.__default.NumElements($LS($ly), node#0)
     == KMBtreeModel.__default.NumElements($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.NumElements(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.NumElements($ly, node#0)
     == KMBtreeModel.__default.NumElements($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.NumElements
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.NumElements($ly, node#0) } 
    KMBtreeModel.__default.NumElements#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && KMBtreeModel.__default.WF($LS($LZ), node#0))
       ==> LitInt(0) <= KMBtreeModel.__default.NumElements($ly, node#0));

function KMBtreeModel.__default.NumElements#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.NumElements
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.NumElements#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.NumElements#requires($ly, node#0)
       == KMBtreeModel.__default.WF($LS($LZ), node#0));

// definition axiom for KMBtreeModel.__default.NumElements(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.NumElements($LS($ly), node#0) } 
    KMBtreeModel.__default.NumElements#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && KMBtreeModel.__default.WF($LS($LZ), node#0))
       ==> (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> KMBtreeModel.__default.NumElementsOfChildren#canCall(KMBtreeModel.Node.children(node#0)))
         && KMBtreeModel.__default.NumElements($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then Seq#Length(KMBtreeModel.Node.keys(node#0))
             else KMBtreeModel.__default.NumElementsOfChildren($ly, KMBtreeModel.Node.children(node#0))));

// definition axiom for KMBtreeModel.__default.NumElements for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.NumElements($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.NumElements#canCall(Lit(node#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(node#0))))
       ==> (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> KMBtreeModel.__default.NumElementsOfChildren#canCall(Lit(KMBtreeModel.Node.children(Lit(node#0)))))
         && KMBtreeModel.__default.NumElements($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then Seq#Length(Lit(KMBtreeModel.Node.keys(Lit(node#0))))
             else KMBtreeModel.__default.NumElementsOfChildren($LS($ly), Lit(KMBtreeModel.Node.children(Lit(node#0))))));

// function declaration for KMBtreeModel._default.ToSeqChildren
function KMBtreeModel.__default.ToSeqChildren($ly: LayerType, nodes#0: Seq Box) : DatatypeType;

function KMBtreeModel.__default.ToSeqChildren#canCall(nodes#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, nodes#0: Seq Box :: 
  { KMBtreeModel.__default.ToSeqChildren($LS($ly), nodes#0) } 
  KMBtreeModel.__default.ToSeqChildren($LS($ly), nodes#0)
     == KMBtreeModel.__default.ToSeqChildren($ly, nodes#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, nodes#0: Seq Box :: 
  { KMBtreeModel.__default.ToSeqChildren(AsFuelBottom($ly), nodes#0) } 
  KMBtreeModel.__default.ToSeqChildren($ly, nodes#0)
     == KMBtreeModel.__default.ToSeqChildren($LZ, nodes#0));

// consequence axiom for KMBtreeModel.__default.ToSeqChildren
axiom true
   ==> (forall $ly: LayerType, nodes#0: Seq Box :: 
    { KMBtreeModel.__default.ToSeqChildren($ly, nodes#0) } 
    KMBtreeModel.__default.ToSeqChildren#canCall(nodes#0)
         || ($Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
           && (forall i#17: int :: 
            { $Unbox(Seq#Index(nodes#0, i#17)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#17 && i#17 < Seq#Length(nodes#0)
               ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(nodes#0, i#17)): DatatypeType)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box)
           == Seq#Length(nodes#0)
         && (forall i#18: int :: 
          { $Unbox(Seq#Index(nodes#0, i#18)): DatatypeType } 
            { $Unbox(Seq#Index($Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box, 
                i#18)): Seq Box } 
            { $Unbox(Seq#Index($Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box, 
                i#18)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#18 && i#18 < Seq#Length(nodes#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box, 
                  i#18), 
                Seq#Index($Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box, 
                  i#18)), 
              KMBtreeModel.__default.ToSeq(StartFuel_KMBtreeModel._default.ToSeq, 
                $Unbox(Seq#Index(nodes#0, i#18)): DatatypeType)))
         && Seq#Equal(Sequences.__default.FlattenShape(TSeq(Tclass.NativeTypes.byte()), 
            StartFuel_Sequences._default.FlattenShape, 
            $Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box), 
          Sequences.__default.FlattenShape(Tclass.ValueMessage.Message(), 
            StartFuel_Sequences._default.FlattenShape, 
            $Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0))): Seq Box))
         && $Is(KMBtreeModel.__default.ToSeqChildren($ly, nodes#0), 
          Tclass._System.Tuple2(TSeq(TSeq(TSeq(Tclass.NativeTypes.byte()))), 
            TSeq(TSeq(Tclass.ValueMessage.Message())))));

function KMBtreeModel.__default.ToSeqChildren#requires(LayerType, Seq Box) : bool;

// #requires axiom for KMBtreeModel.__default.ToSeqChildren
axiom (forall $ly: LayerType, nodes#0: Seq Box :: 
  { KMBtreeModel.__default.ToSeqChildren#requires($ly, nodes#0) } 
  $Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
     ==> KMBtreeModel.__default.ToSeqChildren#requires($ly, nodes#0)
       == (forall i#19: int :: 
        { $Unbox(Seq#Index(nodes#0, i#19)): DatatypeType } 
        true
           ==> 
          LitInt(0) <= i#19 && i#19 < Seq#Length(nodes#0)
           ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(nodes#0, i#19)): DatatypeType)));

// definition axiom for KMBtreeModel.__default.ToSeqChildren(revealed)
axiom true
   ==> (forall $ly: LayerType, nodes#0: Seq Box :: 
    { KMBtreeModel.__default.ToSeqChildren($LS($ly), nodes#0) } 
    KMBtreeModel.__default.ToSeqChildren#canCall(nodes#0)
         || ($Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
           && (forall i#19: int :: 
            { $Unbox(Seq#Index(nodes#0, i#19)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#19 && i#19 < Seq#Length(nodes#0)
               ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(nodes#0, i#19)): DatatypeType)))
       ==> (Seq#Length(nodes#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KMBtreeModel.Node(), nodes#0)
             && KMBtreeModel.__default.ToSeqChildren#canCall(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), nodes#0))
             && (var kv1#3 := KMBtreeModel.__default.ToSeqChildren($ly, Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), nodes#0)); 
              Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), nodes#0)
                 && KMBtreeModel.__default.ToSeq#canCall($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), nodes#0)): DatatypeType)
                 && (var kv2#3 := KMBtreeModel.__default.ToSeq($ly, 
                      $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), nodes#0)): DatatypeType); 
                  _System.Tuple2.___hMake2_q(kv1#3)
                     && _System.Tuple2.___hMake2_q(kv2#3)
                     && 
                    _System.Tuple2.___hMake2_q(kv1#3)
                     && _System.Tuple2.___hMake2_q(kv2#3))))
         && KMBtreeModel.__default.ToSeqChildren($LS($ly), nodes#0)
           == (if Seq#Length(nodes#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var kv1#3 := KMBtreeModel.__default.ToSeqChildren($ly, Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), nodes#0)); 
              (var kv2#3 := KMBtreeModel.__default.ToSeq($ly, 
                    $Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), nodes#0)): DatatypeType); 
                #_System._tuple#2._#Make2($Box(Seq#Append($Unbox(_System.Tuple2._0(kv1#3)): Seq Box, 
                      Seq#Build(Seq#Empty(): Seq Box, _System.Tuple2._0(kv2#3)))), 
                  $Box(Seq#Append($Unbox(_System.Tuple2._1(kv1#3)): Seq Box, 
                      Seq#Build(Seq#Empty(): Seq Box, _System.Tuple2._1(kv2#3)))))))));

// definition axiom for KMBtreeModel.__default.ToSeqChildren for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, nodes#0: Seq Box :: 
    {:weight 3} { KMBtreeModel.__default.ToSeqChildren($LS($ly), Lit(nodes#0)) } 
    KMBtreeModel.__default.ToSeqChildren#canCall(Lit(nodes#0))
         || ($Is(nodes#0, TSeq(Tclass.KMBtreeModel.Node()))
           && (forall i#20: int :: 
            { $Unbox(Seq#Index(nodes#0, i#20)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#20 && i#20 < Seq#Length(Lit(nodes#0))
               ==> KMBtreeModel.__default.WF($LS($LZ), $Unbox(Seq#Index(Lit(nodes#0), i#20)): DatatypeType)))
       ==> (Seq#Length(Lit(nodes#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KMBtreeModel.Node(), Lit(nodes#0))
             && KMBtreeModel.__default.ToSeqChildren#canCall(Lit(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), Lit(nodes#0))))
             && (var kv1#4 := Lit(KMBtreeModel.__default.ToSeqChildren($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), Lit(nodes#0))))); 
              Sequences.__default.Last#canCall(Tclass.KMBtreeModel.Node(), Lit(nodes#0))
                 && KMBtreeModel.__default.ToSeq#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(nodes#0))): DatatypeType))
                 && (var kv2#4 := KMBtreeModel.__default.ToSeq($LS($ly), 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(nodes#0))): DatatypeType)); 
                  _System.Tuple2.___hMake2_q(kv1#4)
                     && _System.Tuple2.___hMake2_q(kv2#4)
                     && 
                    _System.Tuple2.___hMake2_q(kv1#4)
                     && _System.Tuple2.___hMake2_q(kv2#4))))
         && KMBtreeModel.__default.ToSeqChildren($LS($ly), Lit(nodes#0))
           == (if Seq#Length(Lit(nodes#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var kv1#4 := Lit(KMBtreeModel.__default.ToSeqChildren($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.KMBtreeModel.Node(), Lit(nodes#0))))); 
              (var kv2#4 := KMBtreeModel.__default.ToSeq($LS($ly), 
                    Lit($Unbox(Sequences.__default.Last(Tclass.KMBtreeModel.Node(), Lit(nodes#0))): DatatypeType)); 
                #_System._tuple#2._#Make2($Box(Seq#Append($Unbox(_System.Tuple2._0(kv1#4)): Seq Box, 
                      Seq#Build(Seq#Empty(): Seq Box, _System.Tuple2._0(kv2#4)))), 
                  $Box(Seq#Append($Unbox(_System.Tuple2._1(kv1#4)): Seq Box, 
                      Seq#Build(Seq#Empty(): Seq Box, _System.Tuple2._1(kv2#4)))))))));

// function declaration for KMBtreeModel._default.ToSeq
function KMBtreeModel.__default.ToSeq($ly: LayerType, node#0: DatatypeType) : DatatypeType;

function KMBtreeModel.__default.ToSeq#canCall(node#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.ToSeq($LS($ly), node#0) } 
  KMBtreeModel.__default.ToSeq($LS($ly), node#0)
     == KMBtreeModel.__default.ToSeq($ly, node#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.ToSeq(AsFuelBottom($ly), node#0) } 
  KMBtreeModel.__default.ToSeq($ly, node#0)
     == KMBtreeModel.__default.ToSeq($LZ, node#0));

// consequence axiom for KMBtreeModel.__default.ToSeq
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.ToSeq($ly, node#0) } 
    KMBtreeModel.__default.ToSeq#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && KMBtreeModel.__default.WF($LS($LZ), node#0))
       ==> Seq#Length($Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeq($ly, node#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeq($ly, node#0))): Seq Box)
         && $Is(KMBtreeModel.__default.ToSeq($ly, node#0), 
          Tclass._System.Tuple2(TSeq(TSeq(Tclass.NativeTypes.byte())), TSeq(Tclass.ValueMessage.Message()))));

function KMBtreeModel.__default.ToSeq#requires(LayerType, DatatypeType) : bool;

// #requires axiom for KMBtreeModel.__default.ToSeq
axiom (forall $ly: LayerType, node#0: DatatypeType :: 
  { KMBtreeModel.__default.ToSeq#requires($ly, node#0) } 
  $Is(node#0, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.__default.ToSeq#requires($ly, node#0)
       == KMBtreeModel.__default.WF($LS($LZ), node#0));

// definition axiom for KMBtreeModel.__default.ToSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    { KMBtreeModel.__default.ToSeq($LS($ly), node#0) } 
    KMBtreeModel.__default.ToSeq#canCall(node#0)
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && KMBtreeModel.__default.WF($LS($LZ), node#0))
       ==> (!KMBtreeModel.Node.Leaf_q(node#0)
           ==> KMBtreeModel.__default.ToSeqChildren#canCall(KMBtreeModel.Node.children(node#0))
             && (var keylists#3, valuelists#3 := $Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeqChildren($ly, KMBtreeModel.Node.children(node#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, KMBtreeModel.Node.children(node#0)))): Seq Box; 
              Sequences.__default.Flatten#canCall(TSeq(Tclass.NativeTypes.byte()), keylists#3)
                 && Sequences.__default.Flatten#canCall(Tclass.ValueMessage.Message(), valuelists#3)))
         && KMBtreeModel.__default.ToSeq($LS($ly), node#0)
           == (if KMBtreeModel.Node.Leaf_q(node#0)
             then #_System._tuple#2._#Make2($Box(KMBtreeModel.Node.keys(node#0)), $Box(KMBtreeModel.Node.values(node#0)))
             else (var keylists#3, valuelists#3 := $Unbox(_System.Tuple2._0(KMBtreeModel.__default.ToSeqChildren($ly, KMBtreeModel.Node.children(node#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(KMBtreeModel.__default.ToSeqChildren($ly, KMBtreeModel.Node.children(node#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Sequences.__default.Flatten(TSeq(Tclass.NativeTypes.byte()), 
                    StartFuel_Sequences._default.Flatten, 
                    keylists#3)), 
                $Box(Sequences.__default.Flatten(Tclass.ValueMessage.Message(), 
                    StartFuel_Sequences._default.Flatten, 
                    valuelists#3))))));

// definition axiom for KMBtreeModel.__default.ToSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType :: 
    {:weight 3} { KMBtreeModel.__default.ToSeq($LS($ly), Lit(node#0)) } 
    KMBtreeModel.__default.ToSeq#canCall(Lit(node#0))
         || ($Is(node#0, Tclass.KMBtreeModel.Node())
           && Lit(KMBtreeModel.__default.WF($LS($LZ), Lit(node#0))))
       ==> (!Lit(KMBtreeModel.Node.Leaf_q(Lit(node#0)))
           ==> KMBtreeModel.__default.ToSeqChildren#canCall(Lit(KMBtreeModel.Node.children(Lit(node#0))))
             && (var keylists#4, valuelists#4 := $Unbox(_System.Tuple2._0(Lit(KMBtreeModel.__default.ToSeqChildren($LS($ly), Lit(KMBtreeModel.Node.children(Lit(node#0))))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Lit(KMBtreeModel.__default.ToSeqChildren($LS($ly), Lit(KMBtreeModel.Node.children(Lit(node#0))))))): Seq Box; 
              Sequences.__default.Flatten#canCall(TSeq(Tclass.NativeTypes.byte()), keylists#4)
                 && Sequences.__default.Flatten#canCall(Tclass.ValueMessage.Message(), valuelists#4)))
         && KMBtreeModel.__default.ToSeq($LS($ly), Lit(node#0))
           == (if KMBtreeModel.Node.Leaf_q(Lit(node#0))
             then #_System._tuple#2._#Make2($Box(Lit(KMBtreeModel.Node.keys(Lit(node#0)))), 
              $Box(Lit(KMBtreeModel.Node.values(Lit(node#0)))))
             else (var keylists#4, valuelists#4 := $Unbox(_System.Tuple2._0(Lit(KMBtreeModel.__default.ToSeqChildren($LS($ly), Lit(KMBtreeModel.Node.children(Lit(node#0))))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Lit(KMBtreeModel.__default.ToSeqChildren($LS($ly), Lit(KMBtreeModel.Node.children(Lit(node#0))))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Sequences.__default.Flatten(TSeq(Tclass.NativeTypes.byte()), 
                    StartFuel_Sequences._default.Flatten, 
                    keylists#4)), 
                $Box(Sequences.__default.Flatten(Tclass.ValueMessage.Message(), 
                    StartFuel_Sequences._default.Flatten, 
                    valuelists#4))))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$KMBtreeModel.__default.reveal__AllKeys();
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_KMBtreeModel._default.AllKeys1: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$KMBtreeModel.__default.reveal__AllKeys();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_KMBtreeModel._default.AllKeys
     == $LS(MoreFuel_KMBtreeModel._default.AllKeys1);
  free ensures StartFuelAssert_KMBtreeModel._default.AllKeys
     == $LS($LS(MoreFuel_KMBtreeModel._default.AllKeys1));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_KMBtreeModel._default.AllKeys1)
     == MoreFuel_KMBtreeModel._default.AllKeys1;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$KMBtreeModel.__default.reveal__Interpretation();
  free requires 9 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_KMBtreeModel._default.Interpretation1: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$KMBtreeModel.__default.reveal__Interpretation();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_KMBtreeModel._default.Interpretation
     == $LS(MoreFuel_KMBtreeModel._default.Interpretation1);
  free ensures StartFuelAssert_KMBtreeModel._default.Interpretation
     == $LS($LS(MoreFuel_KMBtreeModel._default.Interpretation1));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_KMBtreeModel._default.Interpretation1)
     == MoreFuel_KMBtreeModel._default.Interpretation1;



// Constructor function declaration
function #KMBtreeModel.Node.Leaf(Seq Box, Seq Box) : DatatypeType;

const unique ##KMBtreeModel.Node.Leaf: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Leaf(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#KMBtreeModel.Node.Leaf(a#0#0#0, a#0#1#0))
     == ##KMBtreeModel.Node.Leaf);

function KMBtreeModel.Node.Leaf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { KMBtreeModel.Node.Leaf_q(d) } 
  KMBtreeModel.Node.Leaf_q(d) <==> DatatypeCtorId(d) == ##KMBtreeModel.Node.Leaf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { KMBtreeModel.Node.Leaf_q(d) } 
  KMBtreeModel.Node.Leaf_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: Seq Box :: 
      d == #KMBtreeModel.Node.Leaf(a#1#0#0, a#1#1#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: Seq Box :: 
  { $Is(#KMBtreeModel.Node.Leaf(a#2#0#0, a#2#1#0), Tclass.KMBtreeModel.Node()) } 
  $Is(#KMBtreeModel.Node.Leaf(a#2#0#0, a#2#1#0), Tclass.KMBtreeModel.Node())
     <==> $Is(a#2#0#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(a#2#1#0, TSeq(Tclass.ValueMessage.Message())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#KMBtreeModel.Node.Leaf(a#3#0#0, a#3#1#0), Tclass.KMBtreeModel.Node(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#KMBtreeModel.Node.Leaf(a#3#0#0, a#3#1#0), Tclass.KMBtreeModel.Node(), $h)
       <==> $IsAlloc(a#3#0#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.ValueMessage.Message()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtreeModel.Node.keys(d), TSeq(TSeq(Tclass.NativeTypes.byte())), $h) } 
  $IsGoodHeap($h)
       && 
      KMBtreeModel.Node.Leaf_q(d)
       && $IsAlloc(d, Tclass.KMBtreeModel.Node(), $h)
     ==> $IsAlloc(KMBtreeModel.Node.keys(d), TSeq(TSeq(Tclass.NativeTypes.byte())), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtreeModel.Node.values(d), TSeq(Tclass.ValueMessage.Message()), $h) } 
  $IsGoodHeap($h)
       && 
      KMBtreeModel.Node.Leaf_q(d)
       && $IsAlloc(d, Tclass.KMBtreeModel.Node(), $h)
     ==> $IsAlloc(KMBtreeModel.Node.values(d), TSeq(Tclass.ValueMessage.Message()), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Leaf(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #KMBtreeModel.Node.Leaf(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#KMBtreeModel.Node.Leaf(a#4#0#0, a#4#1#0)));

function KMBtreeModel.Node.keys(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Leaf(a#5#0#0, a#5#1#0) } 
  KMBtreeModel.Node.keys(#KMBtreeModel.Node.Leaf(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive seq element rank
axiom (forall a#6#0#0: Seq Box, a#6#1#0: Seq Box, i: int :: 
  { Seq#Index(a#6#0#0, i), #KMBtreeModel.Node.Leaf(a#6#0#0, a#6#1#0) } 
  0 <= i && i < Seq#Length(a#6#0#0)
     ==> DtRank($Unbox(Seq#Index(a#6#0#0, i)): DatatypeType)
       < DtRank(#KMBtreeModel.Node.Leaf(a#6#0#0, a#6#1#0)));

// Inductive seq rank
axiom (forall a#7#0#0: Seq Box, a#7#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Leaf(a#7#0#0, a#7#1#0) } 
  Seq#Rank(a#7#0#0) < DtRank(#KMBtreeModel.Node.Leaf(a#7#0#0, a#7#1#0)));

function KMBtreeModel.Node.values(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Seq Box, a#8#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Leaf(a#8#0#0, a#8#1#0) } 
  KMBtreeModel.Node.values(#KMBtreeModel.Node.Leaf(a#8#0#0, a#8#1#0)) == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Seq Box, a#9#1#0: Seq Box, i: int :: 
  { Seq#Index(a#9#1#0, i), #KMBtreeModel.Node.Leaf(a#9#0#0, a#9#1#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#KMBtreeModel.Node.Leaf(a#9#0#0, a#9#1#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Seq Box, a#10#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Leaf(a#10#0#0, a#10#1#0) } 
  Seq#Rank(a#10#1#0) < DtRank(#KMBtreeModel.Node.Leaf(a#10#0#0, a#10#1#0)));

// Constructor function declaration
function #KMBtreeModel.Node.Index(Seq Box, Seq Box) : DatatypeType;

const unique ##KMBtreeModel.Node.Index: DtCtorId;

// Constructor identifier
axiom (forall a#11#0#0: Seq Box, a#11#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Index(a#11#0#0, a#11#1#0) } 
  DatatypeCtorId(#KMBtreeModel.Node.Index(a#11#0#0, a#11#1#0))
     == ##KMBtreeModel.Node.Index);

function KMBtreeModel.Node.Index_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { KMBtreeModel.Node.Index_q(d) } 
  KMBtreeModel.Node.Index_q(d) <==> DatatypeCtorId(d) == ##KMBtreeModel.Node.Index);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { KMBtreeModel.Node.Index_q(d) } 
  KMBtreeModel.Node.Index_q(d)
     ==> (exists a#12#0#0: Seq Box, a#12#1#0: Seq Box :: 
      d == #KMBtreeModel.Node.Index(a#12#0#0, a#12#1#0)));

// Constructor $Is
axiom (forall a#13#0#0: Seq Box, a#13#1#0: Seq Box :: 
  { $Is(#KMBtreeModel.Node.Index(a#13#0#0, a#13#1#0), Tclass.KMBtreeModel.Node()) } 
  $Is(#KMBtreeModel.Node.Index(a#13#0#0, a#13#1#0), Tclass.KMBtreeModel.Node())
     <==> $Is(a#13#0#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(a#13#1#0, TSeq(Tclass.KMBtreeModel.Node())));

// Constructor $IsAlloc
axiom (forall a#14#0#0: Seq Box, a#14#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#KMBtreeModel.Node.Index(a#14#0#0, a#14#1#0), Tclass.KMBtreeModel.Node(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#KMBtreeModel.Node.Index(a#14#0#0, a#14#1#0), Tclass.KMBtreeModel.Node(), $h)
       <==> $IsAlloc(a#14#0#0, TSeq(TSeq(Tclass.NativeTypes.byte())), $h)
         && $IsAlloc(a#14#1#0, TSeq(Tclass.KMBtreeModel.Node()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtreeModel.Node.pivots(d), TSeq(TSeq(Tclass.NativeTypes.byte())), $h) } 
  $IsGoodHeap($h)
       && 
      KMBtreeModel.Node.Index_q(d)
       && $IsAlloc(d, Tclass.KMBtreeModel.Node(), $h)
     ==> $IsAlloc(KMBtreeModel.Node.pivots(d), TSeq(TSeq(Tclass.NativeTypes.byte())), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(KMBtreeModel.Node.children(d), TSeq(Tclass.KMBtreeModel.Node()), $h) } 
  $IsGoodHeap($h)
       && 
      KMBtreeModel.Node.Index_q(d)
       && $IsAlloc(d, Tclass.KMBtreeModel.Node(), $h)
     ==> $IsAlloc(KMBtreeModel.Node.children(d), TSeq(Tclass.KMBtreeModel.Node()), $h));

// Constructor literal
axiom (forall a#15#0#0: Seq Box, a#15#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Index(Lit(a#15#0#0), Lit(a#15#1#0)) } 
  #KMBtreeModel.Node.Index(Lit(a#15#0#0), Lit(a#15#1#0))
     == Lit(#KMBtreeModel.Node.Index(a#15#0#0, a#15#1#0)));

function KMBtreeModel.Node.pivots(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#16#0#0: Seq Box, a#16#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Index(a#16#0#0, a#16#1#0) } 
  KMBtreeModel.Node.pivots(#KMBtreeModel.Node.Index(a#16#0#0, a#16#1#0))
     == a#16#0#0);

// Inductive seq element rank
axiom (forall a#17#0#0: Seq Box, a#17#1#0: Seq Box, i: int :: 
  { Seq#Index(a#17#0#0, i), #KMBtreeModel.Node.Index(a#17#0#0, a#17#1#0) } 
  0 <= i && i < Seq#Length(a#17#0#0)
     ==> DtRank($Unbox(Seq#Index(a#17#0#0, i)): DatatypeType)
       < DtRank(#KMBtreeModel.Node.Index(a#17#0#0, a#17#1#0)));

// Inductive seq rank
axiom (forall a#18#0#0: Seq Box, a#18#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Index(a#18#0#0, a#18#1#0) } 
  Seq#Rank(a#18#0#0) < DtRank(#KMBtreeModel.Node.Index(a#18#0#0, a#18#1#0)));

function KMBtreeModel.Node.children(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#19#0#0: Seq Box, a#19#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Index(a#19#0#0, a#19#1#0) } 
  KMBtreeModel.Node.children(#KMBtreeModel.Node.Index(a#19#0#0, a#19#1#0))
     == a#19#1#0);

// Inductive seq element rank
axiom (forall a#20#0#0: Seq Box, a#20#1#0: Seq Box, i: int :: 
  { Seq#Index(a#20#1#0, i), #KMBtreeModel.Node.Index(a#20#0#0, a#20#1#0) } 
  0 <= i && i < Seq#Length(a#20#1#0)
     ==> DtRank($Unbox(Seq#Index(a#20#1#0, i)): DatatypeType)
       < DtRank(#KMBtreeModel.Node.Index(a#20#0#0, a#20#1#0)));

// Inductive seq rank
axiom (forall a#21#0#0: Seq Box, a#21#1#0: Seq Box :: 
  { #KMBtreeModel.Node.Index(a#21#0#0, a#21#1#0) } 
  Seq#Rank(a#21#1#0) < DtRank(#KMBtreeModel.Node.Index(a#21#0#0, a#21#1#0)));

// Depth-one case-split function
function $IsA#KMBtreeModel.Node(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#KMBtreeModel.Node(d) } 
  $IsA#KMBtreeModel.Node(d)
     ==> KMBtreeModel.Node.Leaf_q(d) || KMBtreeModel.Node.Index_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { KMBtreeModel.Node.Index_q(d), $Is(d, Tclass.KMBtreeModel.Node()) } 
    { KMBtreeModel.Node.Leaf_q(d), $Is(d, Tclass.KMBtreeModel.Node()) } 
  $Is(d, Tclass.KMBtreeModel.Node())
     ==> KMBtreeModel.Node.Leaf_q(d) || KMBtreeModel.Node.Index_q(d));

// Datatype extensional equality declaration
function KMBtreeModel.Node#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #KMBtreeModel.Node.Leaf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { KMBtreeModel.Node#Equal(a, b), KMBtreeModel.Node.Leaf_q(a) } 
    { KMBtreeModel.Node#Equal(a, b), KMBtreeModel.Node.Leaf_q(b) } 
  KMBtreeModel.Node.Leaf_q(a) && KMBtreeModel.Node.Leaf_q(b)
     ==> (KMBtreeModel.Node#Equal(a, b)
       <==> Seq#Equal(KMBtreeModel.Node.keys(a), KMBtreeModel.Node.keys(b))
         && Seq#Equal(KMBtreeModel.Node.values(a), KMBtreeModel.Node.values(b))));

// Datatype extensional equality definition: #KMBtreeModel.Node.Index
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { KMBtreeModel.Node#Equal(a, b), KMBtreeModel.Node.Index_q(a) } 
    { KMBtreeModel.Node#Equal(a, b), KMBtreeModel.Node.Index_q(b) } 
  KMBtreeModel.Node.Index_q(a) && KMBtreeModel.Node.Index_q(b)
     ==> (KMBtreeModel.Node#Equal(a, b)
       <==> Seq#Equal(KMBtreeModel.Node.pivots(a), KMBtreeModel.Node.pivots(b))
         && Seq#Equal(KMBtreeModel.Node.children(a), KMBtreeModel.Node.children(b))));

// Datatype extensionality axiom: KMBtreeModel.Node
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { KMBtreeModel.Node#Equal(a, b) } 
  KMBtreeModel.Node#Equal(a, b) <==> a == b);

const unique class.KMBtreeModel.Node: ClassName;

const unique class.Arrays.__default: ClassName;

function Tclass.Arrays.__default() : Ty;

// Tclass.Arrays.__default Tag
axiom Tag(Tclass.Arrays.__default()) == Tagclass.Arrays.__default;

const unique Tagclass.Arrays.__default: TyTag;

// Box/unbox axiom for Tclass.Arrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Arrays.__default()) } 
  $IsBox(bx, Tclass.Arrays.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Arrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Arrays.__default()) } 
  $Is($o, Tclass.Arrays.__default())
     <==> $o == null || dtype($o) == Tclass.Arrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Arrays.__default(), $h) } 
  $IsAlloc($o, Tclass.Arrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Arrays._default.Aliases
function Arrays.__default.Aliases(Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref, 
    a2#0: ref)
   : bool;

function Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref, 
    a2#0: ref)
   : bool;

// consequence axiom for Arrays.__default.Aliases
axiom true
   ==> (forall Arrays._default.Aliases$T: Ty, 
      Arrays._default.Aliases$U: Ty, 
      a1#0: ref, 
      a2#0: ref :: 
    { Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0) } 
    Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
         || ($Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
           && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)))
       ==> true);

function Arrays.__default.Aliases#requires(Ty, Ty, ref, ref) : bool;

// #requires axiom for Arrays.__default.Aliases
axiom (forall Arrays._default.Aliases$T: Ty, 
    Arrays._default.Aliases$U: Ty, 
    a1#0: ref, 
    a2#0: ref :: 
  { Arrays.__default.Aliases#requires(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0) } 
  $Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
       && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U))
     ==> Arrays.__default.Aliases#requires(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
       == true);

// definition axiom for Arrays.__default.Aliases(revealed)
axiom true
   ==> (forall Arrays._default.Aliases$T: Ty, 
      Arrays._default.Aliases$U: Ty, 
      a1#0: ref, 
      a2#0: ref :: 
    { Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0) } 
    Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
         || ($Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
           && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)))
       ==> Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, a1#0, a2#0)
         == 
        (a1#0
         == a2#0));

// definition axiom for Arrays.__default.Aliases for all literals(revealed)
axiom true
   ==> (forall Arrays._default.Aliases$T: Ty, 
      Arrays._default.Aliases$U: Ty, 
      a1#0: ref, 
      a2#0: ref :: 
    {:weight 3} { Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, Lit(a1#0), Lit(a2#0)) } 
    Arrays.__default.Aliases#canCall(Arrays._default.Aliases$T, Arrays._default.Aliases$U, Lit(a1#0), Lit(a2#0))
         || ($Is(a1#0, Tclass._System.array(Arrays._default.Aliases$T))
           && $Is(a2#0, Tclass._System.array(Arrays._default.Aliases$U)))
       ==> Arrays.__default.Aliases(Arrays._default.Aliases$T, Arrays._default.Aliases$U, Lit(a1#0), Lit(a2#0))
         == 
        (Lit(a1#0)
         == Lit(a2#0)));

procedure CheckWellformed$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.Insert$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.Insert$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element#0: Box
       where $IsBox(element#0, Arrays._default.Insert$T)
         && $IsAllocBox(element#0, Arrays._default.Insert$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$Arrays.__default.Insert(Arrays._default.Insert$T: Ty, 
    arr#0: ref
       where $Is(arr#0, Tclass._System.array(Arrays._default.Insert$T))
         && $IsAlloc(arr#0, Tclass._System.array(Arrays._default.Insert$T), $Heap), 
    length#0: int where LitInt(0) <= length#0 && length#0 < 18446744073709551616, 
    element#0: Box
       where $IsBox(element#0, Arrays._default.Insert$T)
         && $IsAllocBox(element#0, Arrays._default.Insert$T, $Heap), 
    pos#0: int where LitInt(0) <= pos#0 && pos#0 < 18446744073709551616);
  // user-defined preconditions
  requires LitInt(0) <= length#0;
  requires length#0 < _System.array.Length(arr#0);
  requires _System.array.Length(arr#0) < NativeTypes.__default.Uint64UpperBound();
  requires LitInt(0) <= pos#0;
  requires pos#0 <= length#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Sequences.__default.insert#canCall(Arrays._default.Insert$T, 
    Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
    element#0, 
    pos#0);
  ensures Seq#Equal(Seq#Take(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Sequences.__default.insert(Arrays._default.Insert$T, 
      StartFuelAssert_Sequences._default.insert, 
      Seq#Take(Seq#FromArray(old($Heap), arr#0), length#0), 
      element#0, 
      pos#0));
  free ensures true;
  ensures Seq#Equal(Seq#Drop(Seq#FromArray($Heap, arr#0), length#0 + 1), 
    Seq#Drop(Seq#FromArray(old($Heap), arr#0), length#0 + 1));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o] || $o == arr#0);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



const unique field$height: NameFamily;

const unique field$repr: NameFamily;

const unique field$contents: NameFamily;
